#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 2365
#define LARGE_STATE_COUNT 350
#define SYMBOL_COUNT 433
#define ALIAS_COUNT 1
#define TOKEN_COUNT 141
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 82

enum {
  sym_identifier = 1,
  anon_sym_POUND = 2,
  sym_decimal_integer_literal = 3,
  sym_hex_integer_literal = 4,
  sym_decimal_floating_point_literal = 5,
  anon_sym_true = 6,
  anon_sym_false = 7,
  anon_sym_DQUOTE = 8,
  anon_sym_SQUOTE = 9,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 10,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 11,
  anon_sym_r_DQUOTE = 12,
  anon_sym_DOLLAR = 13,
  anon_sym_r_SQUOTE = 14,
  anon_sym_r_DQUOTE_DQUOTE_DQUOTE = 15,
  anon_sym_r_SQUOTE_SQUOTE_SQUOTE = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  aux_sym__sub_string_test_token1 = 19,
  sym__unused_escape_sequence = 20,
  anon_sym_LBRACK = 21,
  anon_sym_COMMA = 22,
  anon_sym_RBRACK = 23,
  anon_sym_COLON = 24,
  anon_sym_null = 25,
  anon_sym_throw = 26,
  anon_sym_EQ = 27,
  anon_sym_QMARK_QMARK = 28,
  anon_sym_LPAREN = 29,
  anon_sym_RPAREN = 30,
  anon_sym_QMARK = 31,
  anon_sym_PIPE_PIPE = 32,
  anon_sym_AMP_AMP = 33,
  sym_equality_operator = 34,
  anon_sym_LT = 35,
  anon_sym_GT = 36,
  anon_sym_LT_EQ = 37,
  anon_sym_GT_EQ = 38,
  anon_sym_PIPE = 39,
  anon_sym_CARET = 40,
  anon_sym_AMP = 41,
  anon_sym_LT_LT = 42,
  anon_sym_GT_GT = 43,
  anon_sym_GT_GT_GT = 44,
  sym__additive_operator = 45,
  anon_sym_STAR = 46,
  anon_sym_SLASH = 47,
  anon_sym_PERCENT = 48,
  anon_sym_TILDE_SLASH = 49,
  sym_increment_operator = 50,
  anon_sym_DOT_DOT_DOT = 51,
  sym_minus_operator = 52,
  sym__exclamation_operator = 53,
  anon_sym_TILDE = 54,
  anon_sym_await = 55,
  anon_sym_is = 56,
  anon_sym_as = 57,
  anon_sym_DOT = 58,
  anon_sym_QMARK_DOT = 59,
  anon_sym_DOT_DOT = 60,
  anon_sym_extends = 61,
  anon_sym_SEMI = 62,
  anon_sym_switch = 63,
  anon_sym_default = 64,
  anon_sym_do = 65,
  anon_sym_while = 66,
  anon_sym_continue = 67,
  anon_sym_yield = 68,
  anon_sym_return = 69,
  anon_sym_on = 70,
  anon_sym_try = 71,
  anon_sym_catch = 72,
  anon_sym_finally = 73,
  anon_sym_if = 74,
  anon_sym_else = 75,
  anon_sym_for = 76,
  anon_sym_in = 77,
  anon_sym_AT = 78,
  anon_sym_transitive = 79,
  anon_sym_part = 80,
  anon_sym_of = 81,
  anon_sym_EQ_EQ = 82,
  anon_sym_show = 83,
  anon_sym_hide = 84,
  anon_sym_enum = 85,
  anon_sym_abstract = 86,
  anon_sym_class = 87,
  anon_sym_extension = 88,
  anon_sym_with = 89,
  anon_sym_LBRACK_RBRACK = 90,
  anon_sym_LBRACK_RBRACK_EQ = 91,
  anon_sym_super = 92,
  sym_floating_point_type = 93,
  anon_sym_bool = 94,
  sym_void_type = 95,
  anon_sym_var = 96,
  anon_sym_async = 97,
  anon_sym_EQ_GT = 98,
  anon_sym_async_STAR = 99,
  anon_sym_sync_STAR = 100,
  anon_sym_required = 101,
  anon_sym_throws = 102,
  anon_sym_POUND_BANG = 103,
  aux_sym_script_tag_token1 = 104,
  anon_sym_LF = 105,
  anon_sym_library = 106,
  sym__break_builtin = 107,
  sym__assert_builtin = 108,
  sym_case_builtin = 109,
  anon_sym_covariant = 110,
  anon_sym_deferred = 111,
  anon_sym_dynamic = 112,
  anon_sym_export = 113,
  anon_sym_factory = 114,
  anon_sym_Function = 115,
  anon_sym_get = 116,
  anon_sym_native = 117,
  anon_sym_implements = 118,
  anon_sym_import = 119,
  anon_sym_interface = 120,
  anon_sym_operator = 121,
  anon_sym_mixin = 122,
  anon_sym_set = 123,
  anon_sym_static = 124,
  anon_sym_typedef = 125,
  anon_sym_new = 126,
  sym_const_builtin = 127,
  sym_final_builtin = 128,
  anon_sym_late = 129,
  anon_sym_external = 130,
  anon_sym_this = 131,
  sym_identifier_dollar_escaped = 132,
  sym_comment = 133,
  sym_documentation_comment = 134,
  sym__automatic_semicolon = 135,
  sym__template_chars_double = 136,
  sym__template_chars_single = 137,
  sym__template_chars_double_single = 138,
  sym__template_chars_single_single = 139,
  sym__template_chars_raw_slash = 140,
  sym_program = 141,
  sym__top_level_definition = 142,
  sym__literal = 143,
  sym_symbol_literal = 144,
  sym_true = 145,
  sym_false = 146,
  sym_string_literal = 147,
  sym__string_literal_double_quotes = 148,
  sym__string_literal_single_quotes = 149,
  sym__string_literal_double_quotes_multiple = 150,
  sym__string_literal_single_quotes_multiple = 151,
  sym__raw_string_literal_double_quotes = 152,
  sym__raw_string_literal_single_quotes = 153,
  sym__raw_string_literal_double_quotes_multiple = 154,
  sym__raw_string_literal_single_quotes_multiple = 155,
  sym_template_substitution = 156,
  sym__sub_string_test = 157,
  sym_escape_sequence = 158,
  sym_list_literal = 159,
  sym_set_or_map_literal = 160,
  sym_pair = 161,
  sym__element = 162,
  sym_null_literal = 163,
  sym__expression = 164,
  sym__expression_without_cascade = 165,
  sym__real_expression = 166,
  sym_throw_expression = 167,
  sym_throw_expression_without_cascade = 168,
  sym_assignment_expression = 169,
  sym_assignment_expression_without_cascade = 170,
  sym_assignable_expression = 171,
  sym__assignable_selector_part = 172,
  sym__assignment_operator = 173,
  sym_lambda_expression = 174,
  sym_function_expression = 175,
  sym_if_null_expression = 176,
  aux_sym__if_null_expression = 177,
  sym_conditional_expression = 178,
  sym_logical_or_expression = 179,
  sym_logical_and_expression = 180,
  sym_equality_expression = 181,
  sym_type_cast_expression = 182,
  sym_type_test_expression = 183,
  sym_relational_expression = 184,
  sym_relational_operator = 185,
  sym_bitwise_or_expression = 186,
  sym_bitwise_xor_expression = 187,
  sym_bitwise_and_expression = 188,
  sym_shift_expression = 189,
  sym_additive_expression = 190,
  sym_multiplicative_expression = 191,
  sym_bitwise_operator = 192,
  sym__bitwise_operator = 193,
  sym_shift_operator = 194,
  sym__shift_operator = 195,
  sym_additive_operator = 196,
  sym_multiplicative_operator = 197,
  sym__multiplicative_operator = 198,
  sym__unary_expression = 199,
  sym_unary_expression = 200,
  sym__postfix_expression = 201,
  sym_postfix_expression = 202,
  sym_postfix_operator = 203,
  sym_spread_element = 204,
  sym_selector = 205,
  sym_prefix_operator = 206,
  sym_negation_operator = 207,
  sym_tilde_operator = 208,
  sym_await_expression = 209,
  sym_type_test = 210,
  sym_is_operator = 211,
  sym_type_cast = 212,
  sym_as_operator = 213,
  sym_new_expression = 214,
  sym__dot_identifier = 215,
  sym_const_object_expression = 216,
  sym__primary = 217,
  sym_parenthesized_expression = 218,
  sym_constructor_invocation = 219,
  sym_arguments = 220,
  sym__argument_list = 221,
  sym_argument = 222,
  sym_named_argument = 223,
  sym_cascade_section = 224,
  sym__cascade_subsection = 225,
  sym__cascade_assignment_section = 226,
  sym_cascade_selector = 227,
  sym_argument_part = 228,
  sym_unconditional_assignable_selector = 229,
  sym_conditional_assignable_selector = 230,
  sym__assignable_selector = 231,
  sym_type_arguments = 232,
  sym__statement = 233,
  sym_block = 234,
  sym_expression_statement = 235,
  sym_labeled_statement = 236,
  sym_assert_statement = 237,
  sym_assertion = 238,
  sym_switch_statement = 239,
  sym_switch_block = 240,
  sym_switch_label = 241,
  sym_do_statement = 242,
  sym_break_statement = 243,
  sym_continue_statement = 244,
  sym_yield_statement = 245,
  sym_yield_each_statement = 246,
  sym_return_statement = 247,
  sym_try_statement = 248,
  sym__on_part = 249,
  sym__try_head = 250,
  sym_catch_clause = 251,
  sym_finally_clause = 252,
  sym_if_element = 253,
  sym_if_statement = 254,
  sym_while_statement = 255,
  sym_for_statement = 256,
  sym__for_loop_parts = 257,
  sym_for_element = 258,
  sym__annotation = 259,
  sym_marker_annotation = 260,
  sym_annotation = 261,
  sym_import_or_export = 262,
  sym_library_import = 263,
  sym_library_export = 264,
  sym_import_specification = 265,
  sym_part_directive = 266,
  sym_part_of_directive = 267,
  sym_uri = 268,
  sym_configurable_uri = 269,
  sym_configuration_uri = 270,
  sym_uri_test = 271,
  sym_combinator = 272,
  sym__identifier_list = 273,
  sym_enum_declaration = 274,
  sym_enum_body = 275,
  sym_enum_constant = 276,
  sym_type_alias = 277,
  sym_class_definition = 278,
  sym_extension_declaration = 279,
  sym__metadata = 280,
  sym_type_parameters = 281,
  sym_type_parameter = 282,
  sym_type_bound = 283,
  sym_superclass = 284,
  sym_mixins = 285,
  sym_mixin_application_class = 286,
  sym_mixin_application = 287,
  sym_mixin_declaration = 288,
  sym_interfaces = 289,
  sym_class_body = 290,
  sym_extension_body = 291,
  sym_getter_signature = 292,
  sym_setter_signature = 293,
  sym_method_signature = 294,
  sym_declaration = 295,
  sym_initialized_identifier_list = 296,
  sym_initialized_identifier = 297,
  sym_static_final_declaration_list = 298,
  sym_binary_operator = 299,
  sym_operator_signature = 300,
  sym_static_final_declaration = 301,
  sym__external_and_static = 302,
  sym__static_or_covariant = 303,
  sym__final_or_const = 304,
  sym_initializers = 305,
  sym_initializer_list_entry = 306,
  sym_field_initializer = 307,
  sym_factory_constructor_signature = 308,
  sym_redirecting_factory_constructor_signature = 309,
  sym_redirection = 310,
  sym_constructor_signature = 311,
  sym_constant_constructor_signature = 312,
  sym_scoped_identifier = 313,
  sym_initialized_variable_definition = 314,
  sym__declared_identifier = 315,
  sym__final_const_var_or_type = 316,
  sym__type = 317,
  sym__type_not_function = 318,
  sym__type_not_void_not_function = 319,
  sym_function_type = 320,
  aux_sym__function_type_tails = 321,
  sym__function_type_tail = 322,
  sym_parameter_type_list = 323,
  sym_normal_parameter_type = 324,
  sym_optional_parameter_types = 325,
  sym_optional_positional_parameter_types = 326,
  sym_named_parameter_types = 327,
  sym__type_not_void = 328,
  sym__type_not_void_list = 329,
  sym__type_name = 330,
  sym__type_dot_identifier = 331,
  sym_typed_identifier = 332,
  sym__nullable_type = 333,
  sym_inferred_type = 334,
  sym_function_body = 335,
  sym_function_expression_body = 336,
  sym_function_signature = 337,
  sym__formal_parameter_part = 338,
  sym_formal_parameter_list = 339,
  sym__strict_formal_parameter_list = 340,
  sym__normal_formal_parameters = 341,
  sym_optional_formal_parameters = 342,
  sym__optional_postional_formal_parameters = 343,
  sym__named_formal_parameters = 344,
  sym_formal_parameter = 345,
  sym__default_formal_parameter = 346,
  sym__default_named_parameter = 347,
  sym__normal_formal_parameter = 348,
  sym__function_formal_parameter = 349,
  sym__simple_formal_parameter = 350,
  sym_constructor_param = 351,
  sym_local_variable_declaration = 352,
  sym_script_tag = 353,
  sym_library_name = 354,
  sym_dotted_identifier_list = 355,
  sym_qualified = 356,
  sym__as = 357,
  sym__covariant = 358,
  sym__deferred = 359,
  sym__export = 360,
  sym__external = 361,
  sym__factory = 362,
  sym__function_builtin_identifier = 363,
  sym__get = 364,
  sym__native = 365,
  sym__implements = 366,
  sym__import = 367,
  sym__operator = 368,
  sym__mixin = 369,
  sym__set = 370,
  sym__static = 371,
  sym__typedef = 372,
  sym__new_builtin = 373,
  sym__late_builtin = 374,
  sym__external_builtin = 375,
  sym_this = 376,
  sym_super = 377,
  sym_label = 378,
  sym__semicolon = 379,
  aux_sym_program_repeat1 = 380,
  aux_sym_program_repeat2 = 381,
  aux_sym_program_repeat3 = 382,
  aux_sym_program_repeat4 = 383,
  aux_sym_program_repeat5 = 384,
  aux_sym_string_literal_repeat1 = 385,
  aux_sym__string_literal_double_quotes_repeat1 = 386,
  aux_sym__string_literal_single_quotes_repeat1 = 387,
  aux_sym__string_literal_double_quotes_multiple_repeat1 = 388,
  aux_sym__string_literal_single_quotes_multiple_repeat1 = 389,
  aux_sym__raw_string_literal_double_quotes_repeat1 = 390,
  aux_sym__raw_string_literal_single_quotes_repeat1 = 391,
  aux_sym__raw_string_literal_double_quotes_multiple_repeat1 = 392,
  aux_sym__raw_string_literal_single_quotes_multiple_repeat1 = 393,
  aux_sym_list_literal_repeat1 = 394,
  aux_sym__expression_repeat1 = 395,
  aux_sym__assignable_selector_part_repeat1 = 396,
  aux_sym_inferred_parameters_repeat1 = 397,
  aux_sym_logical_or_expression_repeat1 = 398,
  aux_sym_logical_and_expression_repeat1 = 399,
  aux_sym_bitwise_or_expression_repeat1 = 400,
  aux_sym_bitwise_xor_expression_repeat1 = 401,
  aux_sym_bitwise_and_expression_repeat1 = 402,
  aux_sym_shift_expression_repeat1 = 403,
  aux_sym_additive_expression_repeat1 = 404,
  aux_sym_multiplicative_expression_repeat1 = 405,
  aux_sym__argument_list_repeat1 = 406,
  aux_sym__argument_list_repeat2 = 407,
  aux_sym__argument_list_repeat3 = 408,
  aux_sym_cascade_section_repeat1 = 409,
  aux_sym_cascade_section_repeat2 = 410,
  aux_sym_type_arguments_repeat1 = 411,
  aux_sym_switch_block_repeat1 = 412,
  aux_sym_try_statement_repeat1 = 413,
  aux_sym__for_loop_parts_repeat1 = 414,
  aux_sym__for_loop_parts_repeat2 = 415,
  aux_sym_library_export_repeat1 = 416,
  aux_sym_configurable_uri_repeat1 = 417,
  aux_sym_enum_body_repeat1 = 418,
  aux_sym__metadata_repeat1 = 419,
  aux_sym_type_parameters_repeat1 = 420,
  aux_sym_class_body_repeat1 = 421,
  aux_sym_extension_body_repeat1 = 422,
  aux_sym_initialized_identifier_list_repeat1 = 423,
  aux_sym_static_final_declaration_list_repeat1 = 424,
  aux_sym_initializers_repeat1 = 425,
  aux_sym_factory_constructor_signature_repeat1 = 426,
  aux_sym_parameter_type_list_repeat1 = 427,
  aux_sym_named_parameter_types_repeat1 = 428,
  aux_sym__type_not_void_list_repeat1 = 429,
  aux_sym__normal_formal_parameters_repeat1 = 430,
  aux_sym_positional_parameters_repeat1 = 431,
  aux_sym__named_formal_parameters_repeat1 = 432,
  alias_sym_type_identifier = 433,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_POUND] = "#",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [anon_sym_r_DQUOTE] = "r\"",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_r_SQUOTE] = "r'",
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = "r\"\"\"",
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = "r'''",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym__sub_string_test_token1] = "_sub_string_test_token1",
  [sym__unused_escape_sequence] = "_unused_escape_sequence",
  [anon_sym_LBRACK] = "[",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_null] = "null",
  [anon_sym_throw] = "throw",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [sym_equality_operator] = "equality_operator",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [sym__additive_operator] = "_additive_operator",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_TILDE_SLASH] = "~/",
  [sym_increment_operator] = "increment_operator",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_minus_operator] = "minus_operator",
  [sym__exclamation_operator] = "_exclamation_operator",
  [anon_sym_TILDE] = "~",
  [anon_sym_await] = "await",
  [anon_sym_is] = "is",
  [anon_sym_as] = "as",
  [anon_sym_DOT] = ".",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_extends] = "extends",
  [anon_sym_SEMI] = ";",
  [anon_sym_switch] = "switch",
  [anon_sym_default] = "default",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_continue] = "continue",
  [anon_sym_yield] = "yield",
  [anon_sym_return] = "return",
  [anon_sym_on] = "on",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_AT] = "@",
  [anon_sym_transitive] = "transitive",
  [anon_sym_part] = "part",
  [anon_sym_of] = "of",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_show] = "show",
  [anon_sym_hide] = "hide",
  [anon_sym_enum] = "enum",
  [anon_sym_abstract] = "abstract",
  [anon_sym_class] = "class",
  [anon_sym_extension] = "extension",
  [anon_sym_with] = "with",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_super] = "super",
  [sym_floating_point_type] = "floating_point_type",
  [anon_sym_bool] = "bool",
  [sym_void_type] = "void_type",
  [anon_sym_var] = "var",
  [anon_sym_async] = "async",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_async_STAR] = "async*",
  [anon_sym_sync_STAR] = "sync*",
  [anon_sym_required] = "required",
  [anon_sym_throws] = "throws",
  [anon_sym_POUND_BANG] = "#!",
  [aux_sym_script_tag_token1] = "script_tag_token1",
  [anon_sym_LF] = "\n",
  [anon_sym_library] = "library",
  [sym__break_builtin] = "_break_builtin",
  [sym__assert_builtin] = "_assert_builtin",
  [sym_case_builtin] = "case_builtin",
  [anon_sym_covariant] = "covariant",
  [anon_sym_deferred] = "deferred",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_export] = "export",
  [anon_sym_factory] = "factory",
  [anon_sym_Function] = "Function",
  [anon_sym_get] = "get",
  [anon_sym_native] = "native",
  [anon_sym_implements] = "implements",
  [anon_sym_import] = "import",
  [anon_sym_interface] = "interface",
  [anon_sym_operator] = "operator",
  [anon_sym_mixin] = "mixin",
  [anon_sym_set] = "set",
  [anon_sym_static] = "static",
  [anon_sym_typedef] = "typedef",
  [anon_sym_new] = "new",
  [sym_const_builtin] = "const_builtin",
  [sym_final_builtin] = "final_builtin",
  [anon_sym_late] = "late",
  [anon_sym_external] = "external",
  [anon_sym_this] = "this",
  [sym_identifier_dollar_escaped] = "identifier_dollar_escaped",
  [sym_comment] = "comment",
  [sym_documentation_comment] = "documentation_comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars_double] = "_template_chars_double",
  [sym__template_chars_single] = "_template_chars_single",
  [sym__template_chars_double_single] = "_template_chars_double_single",
  [sym__template_chars_single_single] = "_template_chars_single_single",
  [sym__template_chars_raw_slash] = "_template_chars_raw_slash",
  [sym_program] = "program",
  [sym__top_level_definition] = "_top_level_definition",
  [sym__literal] = "_literal",
  [sym_symbol_literal] = "symbol_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_string_literal] = "string_literal",
  [sym__string_literal_double_quotes] = "_string_literal_double_quotes",
  [sym__string_literal_single_quotes] = "_string_literal_single_quotes",
  [sym__string_literal_double_quotes_multiple] = "_string_literal_double_quotes_multiple",
  [sym__string_literal_single_quotes_multiple] = "_string_literal_single_quotes_multiple",
  [sym__raw_string_literal_double_quotes] = "_raw_string_literal_double_quotes",
  [sym__raw_string_literal_single_quotes] = "_raw_string_literal_single_quotes",
  [sym__raw_string_literal_double_quotes_multiple] = "_raw_string_literal_double_quotes_multiple",
  [sym__raw_string_literal_single_quotes_multiple] = "_raw_string_literal_single_quotes_multiple",
  [sym_template_substitution] = "template_substitution",
  [sym__sub_string_test] = "_sub_string_test",
  [sym_escape_sequence] = "escape_sequence",
  [sym_list_literal] = "list_literal",
  [sym_set_or_map_literal] = "set_or_map_literal",
  [sym_pair] = "pair",
  [sym__element] = "_element",
  [sym_null_literal] = "null_literal",
  [sym__expression] = "_expression",
  [sym__expression_without_cascade] = "_expression_without_cascade",
  [sym__real_expression] = "_real_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_throw_expression_without_cascade] = "throw_expression_without_cascade",
  [sym_assignment_expression] = "assignment_expression",
  [sym_assignment_expression_without_cascade] = "assignment_expression_without_cascade",
  [sym_assignable_expression] = "assignable_expression",
  [sym__assignable_selector_part] = "_assignable_selector_part",
  [sym__assignment_operator] = "_assignment_operator",
  [sym_lambda_expression] = "lambda_expression",
  [sym_function_expression] = "function_expression",
  [sym_if_null_expression] = "if_null_expression",
  [aux_sym__if_null_expression] = "_if_null_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_logical_or_expression] = "logical_or_expression",
  [sym_logical_and_expression] = "logical_and_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_type_test_expression] = "type_test_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_relational_operator] = "relational_operator",
  [sym_bitwise_or_expression] = "bitwise_or_expression",
  [sym_bitwise_xor_expression] = "bitwise_xor_expression",
  [sym_bitwise_and_expression] = "bitwise_and_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_additive_expression] = "additive_expression",
  [sym_multiplicative_expression] = "multiplicative_expression",
  [sym_bitwise_operator] = "bitwise_operator",
  [sym__bitwise_operator] = "_bitwise_operator",
  [sym_shift_operator] = "shift_operator",
  [sym__shift_operator] = "_shift_operator",
  [sym_additive_operator] = "additive_operator",
  [sym_multiplicative_operator] = "multiplicative_operator",
  [sym__multiplicative_operator] = "_multiplicative_operator",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__postfix_expression] = "_postfix_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_postfix_operator] = "postfix_operator",
  [sym_spread_element] = "spread_element",
  [sym_selector] = "selector",
  [sym_prefix_operator] = "prefix_operator",
  [sym_negation_operator] = "negation_operator",
  [sym_tilde_operator] = "tilde_operator",
  [sym_await_expression] = "await_expression",
  [sym_type_test] = "type_test",
  [sym_is_operator] = "is_operator",
  [sym_type_cast] = "type_cast",
  [sym_as_operator] = "as_operator",
  [sym_new_expression] = "new_expression",
  [sym__dot_identifier] = "_dot_identifier",
  [sym_const_object_expression] = "const_object_expression",
  [sym__primary] = "_primary",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_constructor_invocation] = "constructor_invocation",
  [sym_arguments] = "arguments",
  [sym__argument_list] = "_argument_list",
  [sym_argument] = "argument",
  [sym_named_argument] = "named_argument",
  [sym_cascade_section] = "cascade_section",
  [sym__cascade_subsection] = "_cascade_subsection",
  [sym__cascade_assignment_section] = "_cascade_assignment_section",
  [sym_cascade_selector] = "cascade_selector",
  [sym_argument_part] = "argument_part",
  [sym_unconditional_assignable_selector] = "unconditional_assignable_selector",
  [sym_conditional_assignable_selector] = "conditional_assignable_selector",
  [sym__assignable_selector] = "_assignable_selector",
  [sym_type_arguments] = "type_arguments",
  [sym__statement] = "_statement",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_assertion] = "assertion",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_switch_label] = "switch_label",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_yield_each_statement] = "yield_each_statement",
  [sym_return_statement] = "return_statement",
  [sym_try_statement] = "try_statement",
  [sym__on_part] = "_on_part",
  [sym__try_head] = "_try_head",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_if_element] = "if_element",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_loop_parts] = "_for_loop_parts",
  [sym_for_element] = "for_element",
  [sym__annotation] = "_annotation",
  [sym_marker_annotation] = "marker_annotation",
  [sym_annotation] = "annotation",
  [sym_import_or_export] = "import_or_export",
  [sym_library_import] = "library_import",
  [sym_library_export] = "library_export",
  [sym_import_specification] = "import_specification",
  [sym_part_directive] = "part_directive",
  [sym_part_of_directive] = "part_of_directive",
  [sym_uri] = "uri",
  [sym_configurable_uri] = "configurable_uri",
  [sym_configuration_uri] = "configuration_uri",
  [sym_uri_test] = "uri_test",
  [sym_combinator] = "combinator",
  [sym__identifier_list] = "_identifier_list",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_constant] = "enum_constant",
  [sym_type_alias] = "type_alias",
  [sym_class_definition] = "class_definition",
  [sym_extension_declaration] = "extension_declaration",
  [sym__metadata] = "_metadata",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_mixins] = "mixins",
  [sym_mixin_application_class] = "mixin_application_class",
  [sym_mixin_application] = "mixin_application",
  [sym_mixin_declaration] = "mixin_declaration",
  [sym_interfaces] = "interfaces",
  [sym_class_body] = "class_body",
  [sym_extension_body] = "extension_body",
  [sym_getter_signature] = "getter_signature",
  [sym_setter_signature] = "setter_signature",
  [sym_method_signature] = "method_signature",
  [sym_declaration] = "declaration",
  [sym_initialized_identifier_list] = "initialized_identifier_list",
  [sym_initialized_identifier] = "initialized_identifier",
  [sym_static_final_declaration_list] = "static_final_declaration_list",
  [sym_binary_operator] = "binary_operator",
  [sym_operator_signature] = "operator_signature",
  [sym_static_final_declaration] = "static_final_declaration",
  [sym__external_and_static] = "_external_and_static",
  [sym__static_or_covariant] = "_static_or_covariant",
  [sym__final_or_const] = "_final_or_const",
  [sym_initializers] = "initializers",
  [sym_initializer_list_entry] = "initializer_list_entry",
  [sym_field_initializer] = "field_initializer",
  [sym_factory_constructor_signature] = "factory_constructor_signature",
  [sym_redirecting_factory_constructor_signature] = "redirecting_factory_constructor_signature",
  [sym_redirection] = "redirection",
  [sym_constructor_signature] = "constructor_signature",
  [sym_constant_constructor_signature] = "constant_constructor_signature",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_initialized_variable_definition] = "initialized_variable_definition",
  [sym__declared_identifier] = "_declared_identifier",
  [sym__final_const_var_or_type] = "_final_const_var_or_type",
  [sym__type] = "_type",
  [sym__type_not_function] = "_type_not_function",
  [sym__type_not_void_not_function] = "_type_not_void_not_function",
  [sym_function_type] = "function_type",
  [aux_sym__function_type_tails] = "_function_type_tails",
  [sym__function_type_tail] = "_function_type_tail",
  [sym_parameter_type_list] = "parameter_type_list",
  [sym_normal_parameter_type] = "normal_parameter_type",
  [sym_optional_parameter_types] = "optional_parameter_types",
  [sym_optional_positional_parameter_types] = "optional_positional_parameter_types",
  [sym_named_parameter_types] = "named_parameter_types",
  [sym__type_not_void] = "_type_not_void",
  [sym__type_not_void_list] = "_type_not_void_list",
  [sym__type_name] = "_type_name",
  [sym__type_dot_identifier] = "_type_dot_identifier",
  [sym_typed_identifier] = "typed_identifier",
  [sym__nullable_type] = "_nullable_type",
  [sym_inferred_type] = "inferred_type",
  [sym_function_body] = "function_body",
  [sym_function_expression_body] = "function_expression_body",
  [sym_function_signature] = "function_signature",
  [sym__formal_parameter_part] = "_formal_parameter_part",
  [sym_formal_parameter_list] = "formal_parameter_list",
  [sym__strict_formal_parameter_list] = "_strict_formal_parameter_list",
  [sym__normal_formal_parameters] = "_normal_formal_parameters",
  [sym_optional_formal_parameters] = "optional_formal_parameters",
  [sym__optional_postional_formal_parameters] = "_optional_postional_formal_parameters",
  [sym__named_formal_parameters] = "_named_formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym__default_formal_parameter] = "_default_formal_parameter",
  [sym__default_named_parameter] = "_default_named_parameter",
  [sym__normal_formal_parameter] = "_normal_formal_parameter",
  [sym__function_formal_parameter] = "_function_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_constructor_param] = "constructor_param",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_script_tag] = "script_tag",
  [sym_library_name] = "library_name",
  [sym_dotted_identifier_list] = "dotted_identifier_list",
  [sym_qualified] = "qualified",
  [sym__as] = "_as",
  [sym__covariant] = "_covariant",
  [sym__deferred] = "_deferred",
  [sym__export] = "_export",
  [sym__external] = "_external",
  [sym__factory] = "_factory",
  [sym__function_builtin_identifier] = "_function_builtin_identifier",
  [sym__get] = "_get",
  [sym__native] = "_native",
  [sym__implements] = "_implements",
  [sym__import] = "_import",
  [sym__operator] = "_operator",
  [sym__mixin] = "_mixin",
  [sym__set] = "_set",
  [sym__static] = "_static",
  [sym__typedef] = "_typedef",
  [sym__new_builtin] = "_new_builtin",
  [sym__late_builtin] = "_late_builtin",
  [sym__external_builtin] = "_external_builtin",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_label] = "label",
  [sym__semicolon] = "_semicolon",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_program_repeat2] = "program_repeat2",
  [aux_sym_program_repeat3] = "program_repeat3",
  [aux_sym_program_repeat4] = "program_repeat4",
  [aux_sym_program_repeat5] = "program_repeat5",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__string_literal_double_quotes_repeat1] = "_string_literal_double_quotes_repeat1",
  [aux_sym__string_literal_single_quotes_repeat1] = "_string_literal_single_quotes_repeat1",
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = "_string_literal_double_quotes_multiple_repeat1",
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = "_string_literal_single_quotes_multiple_repeat1",
  [aux_sym__raw_string_literal_double_quotes_repeat1] = "_raw_string_literal_double_quotes_repeat1",
  [aux_sym__raw_string_literal_single_quotes_repeat1] = "_raw_string_literal_single_quotes_repeat1",
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = "_raw_string_literal_double_quotes_multiple_repeat1",
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = "_raw_string_literal_single_quotes_multiple_repeat1",
  [aux_sym_list_literal_repeat1] = "list_literal_repeat1",
  [aux_sym__expression_repeat1] = "_expression_repeat1",
  [aux_sym__assignable_selector_part_repeat1] = "_assignable_selector_part_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_logical_or_expression_repeat1] = "logical_or_expression_repeat1",
  [aux_sym_logical_and_expression_repeat1] = "logical_and_expression_repeat1",
  [aux_sym_bitwise_or_expression_repeat1] = "bitwise_or_expression_repeat1",
  [aux_sym_bitwise_xor_expression_repeat1] = "bitwise_xor_expression_repeat1",
  [aux_sym_bitwise_and_expression_repeat1] = "bitwise_and_expression_repeat1",
  [aux_sym_shift_expression_repeat1] = "shift_expression_repeat1",
  [aux_sym_additive_expression_repeat1] = "additive_expression_repeat1",
  [aux_sym_multiplicative_expression_repeat1] = "multiplicative_expression_repeat1",
  [aux_sym__argument_list_repeat1] = "_argument_list_repeat1",
  [aux_sym__argument_list_repeat2] = "_argument_list_repeat2",
  [aux_sym__argument_list_repeat3] = "_argument_list_repeat3",
  [aux_sym_cascade_section_repeat1] = "cascade_section_repeat1",
  [aux_sym_cascade_section_repeat2] = "cascade_section_repeat2",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym__for_loop_parts_repeat1] = "_for_loop_parts_repeat1",
  [aux_sym__for_loop_parts_repeat2] = "_for_loop_parts_repeat2",
  [aux_sym_library_export_repeat1] = "library_export_repeat1",
  [aux_sym_configurable_uri_repeat1] = "configurable_uri_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym__metadata_repeat1] = "_metadata_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_extension_body_repeat1] = "extension_body_repeat1",
  [aux_sym_initialized_identifier_list_repeat1] = "initialized_identifier_list_repeat1",
  [aux_sym_static_final_declaration_list_repeat1] = "static_final_declaration_list_repeat1",
  [aux_sym_initializers_repeat1] = "initializers_repeat1",
  [aux_sym_factory_constructor_signature_repeat1] = "factory_constructor_signature_repeat1",
  [aux_sym_parameter_type_list_repeat1] = "parameter_type_list_repeat1",
  [aux_sym_named_parameter_types_repeat1] = "named_parameter_types_repeat1",
  [aux_sym__type_not_void_list_repeat1] = "_type_not_void_list_repeat1",
  [aux_sym__normal_formal_parameters_repeat1] = "_normal_formal_parameters_repeat1",
  [aux_sym_positional_parameters_repeat1] = "positional_parameters_repeat1",
  [aux_sym__named_formal_parameters_repeat1] = "_named_formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_r_DQUOTE] = anon_sym_r_DQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_r_SQUOTE] = anon_sym_r_SQUOTE,
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym__sub_string_test_token1] = aux_sym__sub_string_test_token1,
  [sym__unused_escape_sequence] = sym__unused_escape_sequence,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [sym_equality_operator] = sym_equality_operator,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [sym__additive_operator] = sym__additive_operator,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_TILDE_SLASH] = anon_sym_TILDE_SLASH,
  [sym_increment_operator] = sym_increment_operator,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_minus_operator] = sym_minus_operator,
  [sym__exclamation_operator] = sym__exclamation_operator,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_transitive] = anon_sym_transitive,
  [anon_sym_part] = anon_sym_part,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_show] = anon_sym_show,
  [anon_sym_hide] = anon_sym_hide,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extension] = anon_sym_extension,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_super] = anon_sym_super,
  [sym_floating_point_type] = sym_floating_point_type,
  [anon_sym_bool] = anon_sym_bool,
  [sym_void_type] = sym_void_type,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_async_STAR] = anon_sym_async_STAR,
  [anon_sym_sync_STAR] = anon_sym_sync_STAR,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_throws] = anon_sym_throws,
  [anon_sym_POUND_BANG] = anon_sym_POUND_BANG,
  [aux_sym_script_tag_token1] = aux_sym_script_tag_token1,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_library] = anon_sym_library,
  [sym__break_builtin] = sym__break_builtin,
  [sym__assert_builtin] = sym__assert_builtin,
  [sym_case_builtin] = sym_case_builtin,
  [anon_sym_covariant] = anon_sym_covariant,
  [anon_sym_deferred] = anon_sym_deferred,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_factory] = anon_sym_factory,
  [anon_sym_Function] = anon_sym_Function,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_mixin] = anon_sym_mixin,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_new] = anon_sym_new,
  [sym_const_builtin] = sym_const_builtin,
  [sym_final_builtin] = sym_final_builtin,
  [anon_sym_late] = anon_sym_late,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_this] = anon_sym_this,
  [sym_identifier_dollar_escaped] = sym_identifier_dollar_escaped,
  [sym_comment] = sym_comment,
  [sym_documentation_comment] = sym_documentation_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars_double] = sym__template_chars_double,
  [sym__template_chars_single] = sym__template_chars_single,
  [sym__template_chars_double_single] = sym__template_chars_double_single,
  [sym__template_chars_single_single] = sym__template_chars_single_single,
  [sym__template_chars_raw_slash] = sym__template_chars_raw_slash,
  [sym_program] = sym_program,
  [sym__top_level_definition] = sym__top_level_definition,
  [sym__literal] = sym__literal,
  [sym_symbol_literal] = sym_symbol_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_string_literal] = sym_string_literal,
  [sym__string_literal_double_quotes] = sym__string_literal_double_quotes,
  [sym__string_literal_single_quotes] = sym__string_literal_single_quotes,
  [sym__string_literal_double_quotes_multiple] = sym__string_literal_double_quotes_multiple,
  [sym__string_literal_single_quotes_multiple] = sym__string_literal_single_quotes_multiple,
  [sym__raw_string_literal_double_quotes] = sym__raw_string_literal_double_quotes,
  [sym__raw_string_literal_single_quotes] = sym__raw_string_literal_single_quotes,
  [sym__raw_string_literal_double_quotes_multiple] = sym__raw_string_literal_double_quotes_multiple,
  [sym__raw_string_literal_single_quotes_multiple] = sym__raw_string_literal_single_quotes_multiple,
  [sym_template_substitution] = sym_template_substitution,
  [sym__sub_string_test] = sym__sub_string_test,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_list_literal] = sym_list_literal,
  [sym_set_or_map_literal] = sym_set_or_map_literal,
  [sym_pair] = sym_pair,
  [sym__element] = sym__element,
  [sym_null_literal] = sym_null_literal,
  [sym__expression] = sym__expression,
  [sym__expression_without_cascade] = sym__expression_without_cascade,
  [sym__real_expression] = sym__real_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_throw_expression_without_cascade] = sym_throw_expression_without_cascade,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_assignment_expression_without_cascade] = sym_assignment_expression_without_cascade,
  [sym_assignable_expression] = sym_assignable_expression,
  [sym__assignable_selector_part] = sym__assignable_selector_part,
  [sym__assignment_operator] = sym__assignment_operator,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_if_null_expression] = sym_if_null_expression,
  [aux_sym__if_null_expression] = aux_sym__if_null_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_logical_or_expression] = sym_logical_or_expression,
  [sym_logical_and_expression] = sym_logical_and_expression,
  [sym_equality_expression] = sym_equality_expression,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_type_test_expression] = sym_type_test_expression,
  [sym_relational_expression] = sym_relational_expression,
  [sym_relational_operator] = sym_relational_operator,
  [sym_bitwise_or_expression] = sym_bitwise_or_expression,
  [sym_bitwise_xor_expression] = sym_bitwise_xor_expression,
  [sym_bitwise_and_expression] = sym_bitwise_and_expression,
  [sym_shift_expression] = sym_shift_expression,
  [sym_additive_expression] = sym_additive_expression,
  [sym_multiplicative_expression] = sym_multiplicative_expression,
  [sym_bitwise_operator] = sym_bitwise_operator,
  [sym__bitwise_operator] = sym__bitwise_operator,
  [sym_shift_operator] = sym_shift_operator,
  [sym__shift_operator] = sym__shift_operator,
  [sym_additive_operator] = sym_additive_operator,
  [sym_multiplicative_operator] = sym_multiplicative_operator,
  [sym__multiplicative_operator] = sym__multiplicative_operator,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym__postfix_expression] = sym__postfix_expression,
  [sym_postfix_expression] = sym_postfix_expression,
  [sym_postfix_operator] = sym_postfix_operator,
  [sym_spread_element] = sym_spread_element,
  [sym_selector] = sym_selector,
  [sym_prefix_operator] = sym_prefix_operator,
  [sym_negation_operator] = sym_negation_operator,
  [sym_tilde_operator] = sym_tilde_operator,
  [sym_await_expression] = sym_await_expression,
  [sym_type_test] = sym_type_test,
  [sym_is_operator] = sym_is_operator,
  [sym_type_cast] = sym_type_cast,
  [sym_as_operator] = sym_as_operator,
  [sym_new_expression] = sym_new_expression,
  [sym__dot_identifier] = sym__dot_identifier,
  [sym_const_object_expression] = sym_const_object_expression,
  [sym__primary] = sym__primary,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_constructor_invocation] = sym_constructor_invocation,
  [sym_arguments] = sym_arguments,
  [sym__argument_list] = sym__argument_list,
  [sym_argument] = sym_argument,
  [sym_named_argument] = sym_named_argument,
  [sym_cascade_section] = sym_cascade_section,
  [sym__cascade_subsection] = sym__cascade_subsection,
  [sym__cascade_assignment_section] = sym__cascade_assignment_section,
  [sym_cascade_selector] = sym_cascade_selector,
  [sym_argument_part] = sym_argument_part,
  [sym_unconditional_assignable_selector] = sym_unconditional_assignable_selector,
  [sym_conditional_assignable_selector] = sym_conditional_assignable_selector,
  [sym__assignable_selector] = sym__assignable_selector,
  [sym_type_arguments] = sym_type_arguments,
  [sym__statement] = sym__statement,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_assertion] = sym_assertion,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_label] = sym_switch_label,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_yield_each_statement] = sym_yield_each_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_try_statement] = sym_try_statement,
  [sym__on_part] = sym__on_part,
  [sym__try_head] = sym__try_head,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_if_element] = sym_if_element,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_loop_parts] = sym__for_loop_parts,
  [sym_for_element] = sym_for_element,
  [sym__annotation] = sym__annotation,
  [sym_marker_annotation] = sym_marker_annotation,
  [sym_annotation] = sym_annotation,
  [sym_import_or_export] = sym_import_or_export,
  [sym_library_import] = sym_library_import,
  [sym_library_export] = sym_library_export,
  [sym_import_specification] = sym_import_specification,
  [sym_part_directive] = sym_part_directive,
  [sym_part_of_directive] = sym_part_of_directive,
  [sym_uri] = sym_uri,
  [sym_configurable_uri] = sym_configurable_uri,
  [sym_configuration_uri] = sym_configuration_uri,
  [sym_uri_test] = sym_uri_test,
  [sym_combinator] = sym_combinator,
  [sym__identifier_list] = sym__identifier_list,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_constant] = sym_enum_constant,
  [sym_type_alias] = sym_type_alias,
  [sym_class_definition] = sym_class_definition,
  [sym_extension_declaration] = sym_extension_declaration,
  [sym__metadata] = sym__metadata,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_mixins] = sym_mixins,
  [sym_mixin_application_class] = sym_mixin_application_class,
  [sym_mixin_application] = sym_mixin_application,
  [sym_mixin_declaration] = sym_mixin_declaration,
  [sym_interfaces] = sym_interfaces,
  [sym_class_body] = sym_class_body,
  [sym_extension_body] = sym_extension_body,
  [sym_getter_signature] = sym_getter_signature,
  [sym_setter_signature] = sym_setter_signature,
  [sym_method_signature] = sym_method_signature,
  [sym_declaration] = sym_declaration,
  [sym_initialized_identifier_list] = sym_initialized_identifier_list,
  [sym_initialized_identifier] = sym_initialized_identifier,
  [sym_static_final_declaration_list] = sym_static_final_declaration_list,
  [sym_binary_operator] = sym_binary_operator,
  [sym_operator_signature] = sym_operator_signature,
  [sym_static_final_declaration] = sym_static_final_declaration,
  [sym__external_and_static] = sym__external_and_static,
  [sym__static_or_covariant] = sym__static_or_covariant,
  [sym__final_or_const] = sym__final_or_const,
  [sym_initializers] = sym_initializers,
  [sym_initializer_list_entry] = sym_initializer_list_entry,
  [sym_field_initializer] = sym_field_initializer,
  [sym_factory_constructor_signature] = sym_factory_constructor_signature,
  [sym_redirecting_factory_constructor_signature] = sym_redirecting_factory_constructor_signature,
  [sym_redirection] = sym_redirection,
  [sym_constructor_signature] = sym_constructor_signature,
  [sym_constant_constructor_signature] = sym_constant_constructor_signature,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_initialized_variable_definition] = sym_initialized_variable_definition,
  [sym__declared_identifier] = sym__declared_identifier,
  [sym__final_const_var_or_type] = sym__final_const_var_or_type,
  [sym__type] = sym__type,
  [sym__type_not_function] = sym__type_not_function,
  [sym__type_not_void_not_function] = sym__type_not_void_not_function,
  [sym_function_type] = sym_function_type,
  [aux_sym__function_type_tails] = aux_sym__function_type_tails,
  [sym__function_type_tail] = sym__function_type_tail,
  [sym_parameter_type_list] = sym_parameter_type_list,
  [sym_normal_parameter_type] = sym_normal_parameter_type,
  [sym_optional_parameter_types] = sym_optional_parameter_types,
  [sym_optional_positional_parameter_types] = sym_optional_positional_parameter_types,
  [sym_named_parameter_types] = sym_named_parameter_types,
  [sym__type_not_void] = sym__type_not_void,
  [sym__type_not_void_list] = sym__type_not_void_list,
  [sym__type_name] = sym__type_name,
  [sym__type_dot_identifier] = sym__type_dot_identifier,
  [sym_typed_identifier] = sym_typed_identifier,
  [sym__nullable_type] = sym__nullable_type,
  [sym_inferred_type] = sym_inferred_type,
  [sym_function_body] = sym_function_body,
  [sym_function_expression_body] = sym_function_expression_body,
  [sym_function_signature] = sym_function_signature,
  [sym__formal_parameter_part] = sym__formal_parameter_part,
  [sym_formal_parameter_list] = sym_formal_parameter_list,
  [sym__strict_formal_parameter_list] = sym__strict_formal_parameter_list,
  [sym__normal_formal_parameters] = sym__normal_formal_parameters,
  [sym_optional_formal_parameters] = sym_optional_formal_parameters,
  [sym__optional_postional_formal_parameters] = sym__optional_postional_formal_parameters,
  [sym__named_formal_parameters] = sym__named_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym__default_formal_parameter] = sym__default_formal_parameter,
  [sym__default_named_parameter] = sym__default_named_parameter,
  [sym__normal_formal_parameter] = sym__normal_formal_parameter,
  [sym__function_formal_parameter] = sym__function_formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_constructor_param] = sym_constructor_param,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_script_tag] = sym_script_tag,
  [sym_library_name] = sym_library_name,
  [sym_dotted_identifier_list] = sym_dotted_identifier_list,
  [sym_qualified] = sym_qualified,
  [sym__as] = sym__as,
  [sym__covariant] = sym__covariant,
  [sym__deferred] = sym__deferred,
  [sym__export] = sym__export,
  [sym__external] = sym__external,
  [sym__factory] = sym__factory,
  [sym__function_builtin_identifier] = sym__function_builtin_identifier,
  [sym__get] = sym__get,
  [sym__native] = sym__native,
  [sym__implements] = sym__implements,
  [sym__import] = sym__import,
  [sym__operator] = sym__operator,
  [sym__mixin] = sym__mixin,
  [sym__set] = sym__set,
  [sym__static] = sym__static,
  [sym__typedef] = sym__typedef,
  [sym__new_builtin] = sym__new_builtin,
  [sym__late_builtin] = sym__late_builtin,
  [sym__external_builtin] = sym__external_builtin,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_label] = sym_label,
  [sym__semicolon] = sym__semicolon,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_program_repeat2] = aux_sym_program_repeat2,
  [aux_sym_program_repeat3] = aux_sym_program_repeat3,
  [aux_sym_program_repeat4] = aux_sym_program_repeat4,
  [aux_sym_program_repeat5] = aux_sym_program_repeat5,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__string_literal_double_quotes_repeat1] = aux_sym__string_literal_double_quotes_repeat1,
  [aux_sym__string_literal_single_quotes_repeat1] = aux_sym__string_literal_single_quotes_repeat1,
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = aux_sym__string_literal_double_quotes_multiple_repeat1,
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = aux_sym__string_literal_single_quotes_multiple_repeat1,
  [aux_sym__raw_string_literal_double_quotes_repeat1] = aux_sym__raw_string_literal_double_quotes_repeat1,
  [aux_sym__raw_string_literal_single_quotes_repeat1] = aux_sym__raw_string_literal_single_quotes_repeat1,
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
  [aux_sym_list_literal_repeat1] = aux_sym_list_literal_repeat1,
  [aux_sym__expression_repeat1] = aux_sym__expression_repeat1,
  [aux_sym__assignable_selector_part_repeat1] = aux_sym__assignable_selector_part_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_logical_or_expression_repeat1] = aux_sym_logical_or_expression_repeat1,
  [aux_sym_logical_and_expression_repeat1] = aux_sym_logical_and_expression_repeat1,
  [aux_sym_bitwise_or_expression_repeat1] = aux_sym_bitwise_or_expression_repeat1,
  [aux_sym_bitwise_xor_expression_repeat1] = aux_sym_bitwise_xor_expression_repeat1,
  [aux_sym_bitwise_and_expression_repeat1] = aux_sym_bitwise_and_expression_repeat1,
  [aux_sym_shift_expression_repeat1] = aux_sym_shift_expression_repeat1,
  [aux_sym_additive_expression_repeat1] = aux_sym_additive_expression_repeat1,
  [aux_sym_multiplicative_expression_repeat1] = aux_sym_multiplicative_expression_repeat1,
  [aux_sym__argument_list_repeat1] = aux_sym__argument_list_repeat1,
  [aux_sym__argument_list_repeat2] = aux_sym__argument_list_repeat2,
  [aux_sym__argument_list_repeat3] = aux_sym__argument_list_repeat3,
  [aux_sym_cascade_section_repeat1] = aux_sym_cascade_section_repeat1,
  [aux_sym_cascade_section_repeat2] = aux_sym_cascade_section_repeat2,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym__for_loop_parts_repeat1] = aux_sym__for_loop_parts_repeat1,
  [aux_sym__for_loop_parts_repeat2] = aux_sym__for_loop_parts_repeat2,
  [aux_sym_library_export_repeat1] = aux_sym_library_export_repeat1,
  [aux_sym_configurable_uri_repeat1] = aux_sym_configurable_uri_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym__metadata_repeat1] = aux_sym__metadata_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_extension_body_repeat1] = aux_sym_extension_body_repeat1,
  [aux_sym_initialized_identifier_list_repeat1] = aux_sym_initialized_identifier_list_repeat1,
  [aux_sym_static_final_declaration_list_repeat1] = aux_sym_static_final_declaration_list_repeat1,
  [aux_sym_initializers_repeat1] = aux_sym_initializers_repeat1,
  [aux_sym_factory_constructor_signature_repeat1] = aux_sym_factory_constructor_signature_repeat1,
  [aux_sym_parameter_type_list_repeat1] = aux_sym_parameter_type_list_repeat1,
  [aux_sym_named_parameter_types_repeat1] = aux_sym_named_parameter_types_repeat1,
  [aux_sym__type_not_void_list_repeat1] = aux_sym__type_not_void_list_repeat1,
  [aux_sym__normal_formal_parameters_repeat1] = aux_sym__normal_formal_parameters_repeat1,
  [aux_sym_positional_parameters_repeat1] = aux_sym_positional_parameters_repeat1,
  [aux_sym__named_formal_parameters_repeat1] = aux_sym__named_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__sub_string_test_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__unused_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_equality_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__additive_operator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_increment_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_minus_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__exclamation_operator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_part] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_show] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hide] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_super] = {
    .visible = true,
    .named = false,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sync_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throws] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_script_tag_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_library] = {
    .visible = true,
    .named = false,
  },
  [sym__break_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym__assert_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym_case_builtin] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_covariant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deferred] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_factory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mixin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [sym_const_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_final_builtin] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_late] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier_dollar_escaped] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_documentation_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_double] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_double_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_single_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_raw_slash] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_symbol_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal_double_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_single_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_double_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_single_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_double_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_single_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_double_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_single_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym__sub_string_test] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_set_or_map_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element] = {
    .visible = false,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_without_cascade] = {
    .visible = false,
    .named = true,
  },
  [sym__real_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression_without_cascade] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression_without_cascade] = {
    .visible = true,
    .named = true,
  },
  [sym_assignable_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__assignable_selector_part] = {
    .visible = false,
    .named = true,
  },
  [sym__assignment_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_null_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__if_null_expression] = {
    .visible = false,
    .named = false,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_test_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_xor_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_additive_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__bitwise_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_shift_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__shift_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_additive_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__multiplicative_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__postfix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_negation_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_tilde_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_test] = {
    .visible = true,
    .named = true,
  },
  [sym_is_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_as_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dot_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_const_object_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_cascade_section] = {
    .visible = true,
    .named = true,
  },
  [sym__cascade_subsection] = {
    .visible = false,
    .named = true,
  },
  [sym__cascade_assignment_section] = {
    .visible = false,
    .named = true,
  },
  [sym_cascade_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_part] = {
    .visible = true,
    .named = true,
  },
  [sym_unconditional_assignable_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_assignable_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__assignable_selector] = {
    .visible = false,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__on_part] = {
    .visible = false,
    .named = true,
  },
  [sym__try_head] = {
    .visible = false,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_element] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_loop_parts] = {
    .visible = false,
    .named = true,
  },
  [sym_for_element] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_marker_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_import_or_export] = {
    .visible = true,
    .named = true,
  },
  [sym_library_import] = {
    .visible = true,
    .named = true,
  },
  [sym_library_export] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_part_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_part_of_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_configurable_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_configuration_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_uri_test] = {
    .visible = true,
    .named = true,
  },
  [sym_combinator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_list] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__metadata] = {
    .visible = false,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_mixins] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_application_class] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_application] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_body] = {
    .visible = true,
    .named = true,
  },
  [sym_getter_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_setter_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_static_final_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_static_final_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__external_and_static] = {
    .visible = false,
    .named = true,
  },
  [sym__static_or_covariant] = {
    .visible = false,
    .named = true,
  },
  [sym__final_or_const] = {
    .visible = false,
    .named = true,
  },
  [sym_initializers] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_factory_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_redirecting_factory_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_redirection] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_variable_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declared_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__final_const_var_or_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_function] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_void_not_function] = {
    .visible = false,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__function_type_tails] = {
    .visible = false,
    .named = false,
  },
  [sym__function_type_tail] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_normal_parameter_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_positional_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_named_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym__type_not_void] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_void_list] = {
    .visible = false,
    .named = true,
  },
  [sym__type_name] = {
    .visible = false,
    .named = true,
  },
  [sym__type_dot_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_typed_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__nullable_type] = {
    .visible = false,
    .named = true,
  },
  [sym_inferred_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter_part] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__strict_formal_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__normal_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__optional_postional_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__named_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__default_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__default_named_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__normal_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__function_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_param] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_script_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_library_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified] = {
    .visible = true,
    .named = true,
  },
  [sym__as] = {
    .visible = false,
    .named = true,
  },
  [sym__covariant] = {
    .visible = false,
    .named = true,
  },
  [sym__deferred] = {
    .visible = false,
    .named = true,
  },
  [sym__export] = {
    .visible = false,
    .named = true,
  },
  [sym__external] = {
    .visible = false,
    .named = true,
  },
  [sym__factory] = {
    .visible = false,
    .named = true,
  },
  [sym__function_builtin_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__get] = {
    .visible = false,
    .named = true,
  },
  [sym__native] = {
    .visible = false,
    .named = true,
  },
  [sym__implements] = {
    .visible = false,
    .named = true,
  },
  [sym__import] = {
    .visible = false,
    .named = true,
  },
  [sym__operator] = {
    .visible = false,
    .named = true,
  },
  [sym__mixin] = {
    .visible = false,
    .named = true,
  },
  [sym__set] = {
    .visible = false,
    .named = true,
  },
  [sym__static] = {
    .visible = false,
    .named = true,
  },
  [sym__typedef] = {
    .visible = false,
    .named = true,
  },
  [sym__new_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym__late_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym__external_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_double_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_single_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_double_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_single_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__assignable_selector_part_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_logical_or_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_logical_and_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_or_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_xor_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_and_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_shift_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_additive_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiplicative_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_list_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cascade_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cascade_section_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_loop_parts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_loop_parts_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_library_export_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_configurable_uri_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__metadata_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initialized_identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_static_final_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_factory_constructor_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_parameter_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_not_void_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__normal_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__named_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_class = 4,
  field_condition = 5,
  field_consequence = 6,
  field_first = 7,
  field_init = 8,
  field_interfaces = 9,
  field_key = 10,
  field_left = 11,
  field_name = 12,
  field_operator = 13,
  field_parameters = 14,
  field_right = 15,
  field_scope = 16,
  field_second = 17,
  field_superclass = 18,
  field_type_parameters = 19,
  field_update = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_class] = "class",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_first] = "first",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_second] = "second",
  [field_superclass] = "superclass",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 2},
  [13] = {.index = 12, .length = 2},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 2},
  [16] = {.index = 18, .length = 1},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 3},
  [19] = {.index = 24, .length = 1},
  [20] = {.index = 25, .length = 2},
  [21] = {.index = 2, .length = 1},
  [22] = {.index = 27, .length = 2},
  [23] = {.index = 29, .length = 1},
  [24] = {.index = 30, .length = 1},
  [25] = {.index = 31, .length = 1},
  [26] = {.index = 32, .length = 2},
  [27] = {.index = 34, .length = 2},
  [28] = {.index = 36, .length = 3},
  [29] = {.index = 39, .length = 3},
  [30] = {.index = 42, .length = 3},
  [31] = {.index = 45, .length = 2},
  [32] = {.index = 47, .length = 1},
  [33] = {.index = 48, .length = 2},
  [34] = {.index = 50, .length = 3},
  [35] = {.index = 53, .length = 1},
  [36] = {.index = 54, .length = 1},
  [37] = {.index = 55, .length = 2},
  [38] = {.index = 57, .length = 2},
  [39] = {.index = 59, .length = 6},
  [40] = {.index = 65, .length = 2},
  [41] = {.index = 67, .length = 2},
  [42] = {.index = 69, .length = 1},
  [43] = {.index = 70, .length = 2},
  [44] = {.index = 72, .length = 1},
  [45] = {.index = 73, .length = 3},
  [46] = {.index = 76, .length = 3},
  [47] = {.index = 79, .length = 3},
  [48] = {.index = 82, .length = 2},
  [49] = {.index = 84, .length = 4},
  [50] = {.index = 88, .length = 4},
  [51] = {.index = 92, .length = 4},
  [52] = {.index = 96, .length = 3},
  [53] = {.index = 99, .length = 3},
  [54] = {.index = 102, .length = 2},
  [55] = {.index = 104, .length = 6},
  [56] = {.index = 110, .length = 2},
  [57] = {.index = 112, .length = 3},
  [58] = {.index = 115, .length = 2},
  [59] = {.index = 117, .length = 2},
  [60] = {.index = 119, .length = 3},
  [61] = {.index = 122, .length = 3},
  [62] = {.index = 125, .length = 2},
  [63] = {.index = 127, .length = 2},
  [64] = {.index = 129, .length = 2},
  [65] = {.index = 131, .length = 4},
  [66] = {.index = 135, .length = 4},
  [67] = {.index = 139, .length = 4},
  [68] = {.index = 143, .length = 5},
  [69] = {.index = 148, .length = 4},
  [70] = {.index = 152, .length = 3},
  [71] = {.index = 155, .length = 3},
  [72] = {.index = 158, .length = 3},
  [73] = {.index = 161, .length = 3},
  [74] = {.index = 164, .length = 4},
  [75] = {.index = 168, .length = 3},
  [76] = {.index = 171, .length = 5},
  [77] = {.index = 176, .length = 4},
  [78] = {.index = 180, .length = 4},
  [79] = {.index = 184, .length = 4},
  [80] = {.index = 188, .length = 4},
  [81] = {.index = 192, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0, .inherited = true},
  [1] =
    {field_body, 1},
  [2] =
    {field_name, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_first, 0},
    {field_second, 1, .inherited = true},
  [6] =
    {field_body, 0, .inherited = true},
  [7] =
    {field_body, 1},
    {field_parameters, 0},
  [9] =
    {field_name, 1, .inherited = true},
  [10] =
    {field_body, 2},
    {field_condition, 1},
  [12] =
    {field_condition, 1},
    {field_consequence, 2},
  [14] =
    {field_arguments, 2},
    {field_name, 1},
  [16] =
    {field_body, 2},
    {field_name, 1},
  [18] =
    {field_second, 1},
  [19] =
    {field_second, 0, .inherited = true},
    {field_second, 1, .inherited = true},
  [21] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [24] =
    {field_name, 2},
  [25] =
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [27] =
    {field_key, 0},
    {field_value, 2},
  [29] =
    {field_condition, 0},
  [30] =
    {field_init, 0},
  [31] =
    {field_update, 1},
  [32] =
    {field_name, 2},
    {field_scope, 0},
  [34] =
    {field_body, 3},
    {field_name, 2},
  [36] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [39] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [42] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [45] =
    {field_body, 3},
    {field_class, 2},
  [47] =
    {field_name, 3},
  [48] =
    {field_body, 1},
    {field_condition, 3},
  [50] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [53] =
    {field_value, 2},
  [54] =
    {field_init, 1},
  [55] =
    {field_condition, 0},
    {field_update, 2},
  [57] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [59] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_init, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_update, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [65] =
    {field_condition, 1},
    {field_init, 0},
  [67] =
    {field_init, 0},
    {field_update, 2},
  [69] =
    {field_condition, 1},
  [70] =
    {field_update, 1},
    {field_update, 2, .inherited = true},
  [72] =
    {field_update, 2},
  [73] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [76] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [79] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [82] =
    {field_name, 0},
    {field_parameters, 1},
  [84] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [88] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [92] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [96] =
    {field_body, 4},
    {field_class, 3},
    {field_name, 1},
  [99] =
    {field_body, 4},
    {field_class, 3},
    {field_type_parameters, 1},
  [102] =
    {field_alternative, 4},
    {field_consequence, 2},
  [104] =
    {field_body, 5},
    {field_condition, 3, .inherited = true},
    {field_init, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_update, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [110] =
    {field_condition, 2},
    {field_init, 0},
  [112] =
    {field_condition, 0},
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [115] =
    {field_init, 0},
    {field_update, 3},
  [117] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
  [119] =
    {field_condition, 1},
    {field_init, 0},
    {field_update, 3},
  [122] =
    {field_init, 0},
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [125] =
    {field_condition, 1},
    {field_update, 3},
  [127] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [129] =
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [131] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [135] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [139] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [143] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [148] =
    {field_body, 5},
    {field_class, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [152] =
    {field_condition, 2},
    {field_init, 0},
    {field_update, 4},
  [155] =
    {field_init, 0},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [158] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
  [161] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 4},
  [164] =
    {field_condition, 1},
    {field_init, 0},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [168] =
    {field_condition, 1},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [171] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [176] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_parameters, 3},
  [180] =
    {field_condition, 2},
    {field_init, 0},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [184] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 5},
  [188] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [192] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 5},
    {field_update, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = sym_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [21] = {
    [1] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__get, 2,
    sym__get,
    sym_identifier,
  sym__set, 2,
    sym__set,
    sym_identifier,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(73);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(156);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(179);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(2)
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(177);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(187);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(148);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '>') ADVANCE(43);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(55);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(148);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(55);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(148);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(43);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(39);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(187);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(39);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(39);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(188);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(94);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(85);
      if (lookahead == '\'') ADVANCE(88);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(83);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(89);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '[') ADVANCE(44);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(138);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '[') ADVANCE(44);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(95);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(96);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 25:
      if (lookahead == '$') ADVANCE(192);
      END_STATE();
    case 26:
      if (lookahead == '\'') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == '\'') ADVANCE(90);
      END_STATE();
    case 28:
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 29:
      if (lookahead == '*') ADVANCE(31);
      if (lookahead == '/') ADVANCE(37);
      END_STATE();
    case 30:
      if (lookahead == '*') ADVANCE(30);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead != 0) ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == '*') ADVANCE(30);
      if (lookahead != 0) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '*') ADVANCE(171);
      END_STATE();
    case 33:
      if (lookahead == '+') ADVANCE(145);
      END_STATE();
    case 34:
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 35:
      if (lookahead == '.') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 36:
      if (lookahead == '/') ADVANCE(144);
      END_STATE();
    case 37:
      if (lookahead == '/') ADVANCE(195);
      if (lookahead != 0) ADVANCE(194);
      END_STATE();
    case 38:
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(97);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(99);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(93);
      END_STATE();
    case 39:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 41:
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 43:
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 44:
      if (lookahead == ']') ADVANCE(165);
      END_STATE();
    case 45:
      if (lookahead == '_') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 46:
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 47:
      if (lookahead == '_') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 48:
      if (lookahead == 'c') ADVANCE(32);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(167);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(48);
      END_STATE();
    case 51:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 52:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 54:
      if (lookahead == 'u') ADVANCE(57);
      if (lookahead == 'x') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      if (lookahead != 0) ADVANCE(101);
      END_STATE();
    case 55:
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 56:
      if (lookahead == 'y') ADVANCE(51);
      END_STATE();
    case 57:
      if (lookahead == '{') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 58:
      if (lookahead == '}') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 59:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(101);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 67:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(73);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(156);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == 's') ADVANCE(189);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 68:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(149);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == '^') ADVANCE(132);
      if (lookahead == 'a') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 69:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(148);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(73);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '+') ADVANCE(33);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(116);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 70:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(148);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '#') ADVANCE(72);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '+') ADVANCE(33);
      if (lookahead == ',') ADVANCE(105);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '/') ADVANCE(29);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(107);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(117);
      if (lookahead == '@') ADVANCE(163);
      if (lookahead == '[') ADVANCE(104);
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == 'r') ADVANCE(180);
      if (lookahead == '{') ADVANCE(91);
      if (lookahead == '}') ADVANCE(92);
      if (lookahead == '~') ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(70)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(172);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(63);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '_') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(17);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(26);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE);
      if (lookahead == '"') ADVANCE(18);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_r_SQUOTE);
      if (lookahead == '\'') ADVANCE(27);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_r_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(80);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(94);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(82);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(95);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(79);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\'') ADVANCE(81);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(96);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '$') ADVANCE(192);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '*') ADVANCE(31);
      if (lookahead == '/') ADVANCE(37);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(99);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(93);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == 'u') ADVANCE(57);
      if (lookahead == 'x') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      if (lookahead != 0) ADVANCE(101);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(101);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(102);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(164);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(159);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(159);
      if (lookahead == '?') ADVANCE(113);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(113);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_equality_operator);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(135);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(135);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(129);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(120);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(121);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym__additive_operator);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '+') ADVANCE(145);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '-') ADVANCE(145);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(31);
      if (lookahead == '/') ADVANCE(37);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_TILDE_SLASH);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_increment_operator);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_minus_operator);
      if (lookahead == '-') ADVANCE(145);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__exclamation_operator);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym__exclamation_operator);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '/') ADVANCE(144);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(185);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(160);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(77);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '*') ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_async_STAR);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_sync_STAR);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_POUND_BANG);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '\n') ADVANCE(31);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '\n') ADVANCE(31);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(85);
      if (lookahead == '\'') ADVANCE(88);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(181);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(168);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(182);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(183);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(153);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(154);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(190);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(184);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(185);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier_dollar_escaped);
      if (lookahead == '\\') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_documentation_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'b') ADVANCE(3);
      if (lookahead == 'c') ADVANCE(4);
      if (lookahead == 'd') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'g') ADVANCE(8);
      if (lookahead == 'h') ADVANCE(9);
      if (lookahead == 'i') ADVANCE(10);
      if (lookahead == 'l') ADVANCE(11);
      if (lookahead == 'm') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      if (lookahead == 'p') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'u') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'b') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      if (lookahead == 'y') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(40);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(41);
      END_STATE();
    case 10:
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(53);
      if (lookahead == 'p') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 't') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      if (lookahead == 'w') ADVANCE(61);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(79);
      if (lookahead == 'v') ADVANCE(80);
      END_STATE();
    case 31:
      if (lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 34:
      if (lookahead == 's') ADVANCE(84);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(86);
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(88);
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(93);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 47:
      if (lookahead == 'b') ADVANCE(97);
      END_STATE();
    case 48:
      if (lookahead == 'x') ADVANCE(98);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 50:
      if (lookahead == 'w') ADVANCE(100);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(104);
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 58:
      if (lookahead == 'o') ADVANCE(107);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(109);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(113);
      if (lookahead == 'u') ADVANCE(114);
      if (lookahead == 'y') ADVANCE(115);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 70:
      if (lookahead == 'c') ADVANCE(122);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 75:
      if (lookahead == 'a') ADVANCE(127);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 77:
      if (lookahead == 'c') ADVANCE(129);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 79:
      if (lookahead == 's') ADVANCE(131);
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(133);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(134);
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 82:
      if (lookahead == 'b') ADVANCE(136);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 85:
      if (lookahead == 'm') ADVANCE(139);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 89:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(146);
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 104:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 105:
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 107:
      if (lookahead == 'w') ADVANCE(158);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(159);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 111:
      if (lookahead == 's') ADVANCE(162);
      END_STATE();
    case 112:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(164);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 118:
      if (lookahead == 'd') ADVANCE(167);
      END_STATE();
    case 119:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 120:
      if (lookahead == 'h') ADVANCE(169);
      END_STATE();
    case 121:
      if (lookahead == 'l') ADVANCE(170);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 123:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 124:
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 127:
      if (lookahead == 'k') ADVANCE(175);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_case_builtin);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(176);
      END_STATE();
    case 130:
      if (lookahead == 's') ADVANCE(177);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 132:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 134:
      if (lookahead == 'u') ADVANCE(181);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 137:
      if (lookahead == 'm') ADVANCE(184);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(186);
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 142:
      if (lookahead == 'o') ADVANCE(188);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_hide);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_late);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 152:
      if (lookahead == 'v') ADVANCE(196);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(197);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_part);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_show);
      END_STATE();
    case 159:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 160:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 161:
      if (lookahead == 'c') ADVANCE(202);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 163:
      if (lookahead == 'w') ADVANCE(203);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(204);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 166:
      if (lookahead == 'd') ADVANCE(205);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 170:
      if (lookahead == 'd') ADVANCE(207);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(208);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym__break_builtin);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_const_builtin);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 182:
      if (lookahead == 'r') ADVANCE(214);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 184:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 186:
      if (lookahead == 'd') ADVANCE(218);
      if (lookahead == 's') ADVANCE(219);
      END_STATE();
    case 187:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_final_builtin);
      if (lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 191:
      if (lookahead == 'm') ADVANCE(223);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 193:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_mixin);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 200:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_super);
      END_STATE();
    case 202:
      if (lookahead == 'h') ADVANCE(232);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_throw);
      if (lookahead == 's') ADVANCE(233);
      END_STATE();
    case 204:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 208:
      if (lookahead == 'o') ADVANCE(236);
      END_STATE();
    case 209:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym__assert_builtin);
      END_STATE();
    case 211:
      if (lookahead == 'u') ADVANCE(238);
      END_STATE();
    case 212:
      if (lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_floating_point_type);
      END_STATE();
    case 216:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 218:
      if (lookahead == 's') ADVANCE(243);
      END_STATE();
    case 219:
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 220:
      if (lookahead == 'a') ADVANCE(245);
      END_STATE();
    case 221:
      if (lookahead == 'y') ADVANCE(246);
      END_STATE();
    case 222:
      if (lookahead == 'y') ADVANCE(247);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(248);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 225:
      if (lookahead == 'a') ADVANCE(249);
      END_STATE();
    case 226:
      if (lookahead == 'y') ADVANCE(250);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 228:
      if (lookahead == 'o') ADVANCE(251);
      END_STATE();
    case 229:
      if (lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_throws);
      END_STATE();
    case 234:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 235:
      if (lookahead == 'f') ADVANCE(254);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(255);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 239:
      if (lookahead == 'n') ADVANCE(258);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 241:
      if (lookahead == 'd') ADVANCE(259);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 244:
      if (lookahead == 'o') ADVANCE(260);
      END_STATE();
    case 245:
      if (lookahead == 'l') ADVANCE(261);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_factory);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 248:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 249:
      if (lookahead == 'c') ADVANCE(263);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_library);
      END_STATE();
    case 251:
      if (lookahead == 'r') ADVANCE(264);
      END_STATE();
    case 252:
      if (lookahead == 'd') ADVANCE(265);
      END_STATE();
    case 253:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_Function);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_deferred);
      END_STATE();
    case 260:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 262:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 266:
      if (lookahead == 'v') ADVANCE(271);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_covariant);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_extension);
      END_STATE();
    case 269:
      if (lookahead == 's') ADVANCE(272);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_transitive);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 69},
  [2] = {.lex_state = 69},
  [3] = {.lex_state = 69},
  [4] = {.lex_state = 69},
  [5] = {.lex_state = 69},
  [6] = {.lex_state = 69},
  [7] = {.lex_state = 69},
  [8] = {.lex_state = 69},
  [9] = {.lex_state = 69},
  [10] = {.lex_state = 69},
  [11] = {.lex_state = 69},
  [12] = {.lex_state = 69},
  [13] = {.lex_state = 69},
  [14] = {.lex_state = 69},
  [15] = {.lex_state = 69},
  [16] = {.lex_state = 69},
  [17] = {.lex_state = 69},
  [18] = {.lex_state = 69},
  [19] = {.lex_state = 69},
  [20] = {.lex_state = 69},
  [21] = {.lex_state = 69},
  [22] = {.lex_state = 69},
  [23] = {.lex_state = 69},
  [24] = {.lex_state = 69},
  [25] = {.lex_state = 69},
  [26] = {.lex_state = 69},
  [27] = {.lex_state = 69},
  [28] = {.lex_state = 69},
  [29] = {.lex_state = 69},
  [30] = {.lex_state = 69},
  [31] = {.lex_state = 69},
  [32] = {.lex_state = 69},
  [33] = {.lex_state = 69},
  [34] = {.lex_state = 69},
  [35] = {.lex_state = 69},
  [36] = {.lex_state = 69},
  [37] = {.lex_state = 69},
  [38] = {.lex_state = 69},
  [39] = {.lex_state = 69},
  [40] = {.lex_state = 69},
  [41] = {.lex_state = 69},
  [42] = {.lex_state = 69},
  [43] = {.lex_state = 69},
  [44] = {.lex_state = 69},
  [45] = {.lex_state = 69},
  [46] = {.lex_state = 69},
  [47] = {.lex_state = 69},
  [48] = {.lex_state = 69},
  [49] = {.lex_state = 69},
  [50] = {.lex_state = 69},
  [51] = {.lex_state = 69},
  [52] = {.lex_state = 69},
  [53] = {.lex_state = 69},
  [54] = {.lex_state = 69},
  [55] = {.lex_state = 69},
  [56] = {.lex_state = 69},
  [57] = {.lex_state = 69},
  [58] = {.lex_state = 69},
  [59] = {.lex_state = 69},
  [60] = {.lex_state = 69},
  [61] = {.lex_state = 69},
  [62] = {.lex_state = 69},
  [63] = {.lex_state = 69},
  [64] = {.lex_state = 69},
  [65] = {.lex_state = 69},
  [66] = {.lex_state = 69},
  [67] = {.lex_state = 69},
  [68] = {.lex_state = 69},
  [69] = {.lex_state = 69},
  [70] = {.lex_state = 69},
  [71] = {.lex_state = 69},
  [72] = {.lex_state = 69},
  [73] = {.lex_state = 69},
  [74] = {.lex_state = 69},
  [75] = {.lex_state = 69},
  [76] = {.lex_state = 69},
  [77] = {.lex_state = 69},
  [78] = {.lex_state = 69},
  [79] = {.lex_state = 69},
  [80] = {.lex_state = 69},
  [81] = {.lex_state = 69},
  [82] = {.lex_state = 69},
  [83] = {.lex_state = 69},
  [84] = {.lex_state = 69},
  [85] = {.lex_state = 69},
  [86] = {.lex_state = 69},
  [87] = {.lex_state = 69},
  [88] = {.lex_state = 69},
  [89] = {.lex_state = 69},
  [90] = {.lex_state = 69},
  [91] = {.lex_state = 69},
  [92] = {.lex_state = 69},
  [93] = {.lex_state = 69},
  [94] = {.lex_state = 69},
  [95] = {.lex_state = 69},
  [96] = {.lex_state = 69},
  [97] = {.lex_state = 69},
  [98] = {.lex_state = 69},
  [99] = {.lex_state = 69},
  [100] = {.lex_state = 69},
  [101] = {.lex_state = 69},
  [102] = {.lex_state = 69},
  [103] = {.lex_state = 69},
  [104] = {.lex_state = 69},
  [105] = {.lex_state = 69},
  [106] = {.lex_state = 69},
  [107] = {.lex_state = 69},
  [108] = {.lex_state = 69},
  [109] = {.lex_state = 69},
  [110] = {.lex_state = 69},
  [111] = {.lex_state = 69},
  [112] = {.lex_state = 69},
  [113] = {.lex_state = 69},
  [114] = {.lex_state = 69},
  [115] = {.lex_state = 69},
  [116] = {.lex_state = 69},
  [117] = {.lex_state = 69},
  [118] = {.lex_state = 69},
  [119] = {.lex_state = 69},
  [120] = {.lex_state = 69},
  [121] = {.lex_state = 69},
  [122] = {.lex_state = 69},
  [123] = {.lex_state = 69},
  [124] = {.lex_state = 69},
  [125] = {.lex_state = 69},
  [126] = {.lex_state = 69},
  [127] = {.lex_state = 69},
  [128] = {.lex_state = 69},
  [129] = {.lex_state = 69},
  [130] = {.lex_state = 69},
  [131] = {.lex_state = 69},
  [132] = {.lex_state = 69},
  [133] = {.lex_state = 69},
  [134] = {.lex_state = 69},
  [135] = {.lex_state = 69},
  [136] = {.lex_state = 69},
  [137] = {.lex_state = 69},
  [138] = {.lex_state = 69},
  [139] = {.lex_state = 69},
  [140] = {.lex_state = 69},
  [141] = {.lex_state = 69},
  [142] = {.lex_state = 69},
  [143] = {.lex_state = 69},
  [144] = {.lex_state = 69},
  [145] = {.lex_state = 69},
  [146] = {.lex_state = 69},
  [147] = {.lex_state = 69},
  [148] = {.lex_state = 69},
  [149] = {.lex_state = 69},
  [150] = {.lex_state = 69},
  [151] = {.lex_state = 69},
  [152] = {.lex_state = 69},
  [153] = {.lex_state = 69},
  [154] = {.lex_state = 69},
  [155] = {.lex_state = 69},
  [156] = {.lex_state = 69},
  [157] = {.lex_state = 69},
  [158] = {.lex_state = 69},
  [159] = {.lex_state = 69},
  [160] = {.lex_state = 69},
  [161] = {.lex_state = 69},
  [162] = {.lex_state = 69},
  [163] = {.lex_state = 69},
  [164] = {.lex_state = 69},
  [165] = {.lex_state = 69},
  [166] = {.lex_state = 69},
  [167] = {.lex_state = 69},
  [168] = {.lex_state = 69},
  [169] = {.lex_state = 69},
  [170] = {.lex_state = 69},
  [171] = {.lex_state = 69},
  [172] = {.lex_state = 69},
  [173] = {.lex_state = 69},
  [174] = {.lex_state = 69},
  [175] = {.lex_state = 69},
  [176] = {.lex_state = 69},
  [177] = {.lex_state = 69},
  [178] = {.lex_state = 69},
  [179] = {.lex_state = 69},
  [180] = {.lex_state = 69},
  [181] = {.lex_state = 69},
  [182] = {.lex_state = 69},
  [183] = {.lex_state = 69},
  [184] = {.lex_state = 69},
  [185] = {.lex_state = 69},
  [186] = {.lex_state = 69},
  [187] = {.lex_state = 69},
  [188] = {.lex_state = 69},
  [189] = {.lex_state = 69},
  [190] = {.lex_state = 69},
  [191] = {.lex_state = 69},
  [192] = {.lex_state = 69},
  [193] = {.lex_state = 69},
  [194] = {.lex_state = 69},
  [195] = {.lex_state = 69},
  [196] = {.lex_state = 69},
  [197] = {.lex_state = 69},
  [198] = {.lex_state = 69},
  [199] = {.lex_state = 69},
  [200] = {.lex_state = 69},
  [201] = {.lex_state = 69},
  [202] = {.lex_state = 69},
  [203] = {.lex_state = 69},
  [204] = {.lex_state = 69},
  [205] = {.lex_state = 69},
  [206] = {.lex_state = 69},
  [207] = {.lex_state = 69},
  [208] = {.lex_state = 69},
  [209] = {.lex_state = 69},
  [210] = {.lex_state = 69},
  [211] = {.lex_state = 69},
  [212] = {.lex_state = 69},
  [213] = {.lex_state = 69},
  [214] = {.lex_state = 69},
  [215] = {.lex_state = 69},
  [216] = {.lex_state = 69},
  [217] = {.lex_state = 69},
  [218] = {.lex_state = 69},
  [219] = {.lex_state = 69},
  [220] = {.lex_state = 69},
  [221] = {.lex_state = 69},
  [222] = {.lex_state = 69},
  [223] = {.lex_state = 69},
  [224] = {.lex_state = 69},
  [225] = {.lex_state = 69},
  [226] = {.lex_state = 69},
  [227] = {.lex_state = 69},
  [228] = {.lex_state = 69},
  [229] = {.lex_state = 69},
  [230] = {.lex_state = 69},
  [231] = {.lex_state = 69},
  [232] = {.lex_state = 69},
  [233] = {.lex_state = 69},
  [234] = {.lex_state = 69},
  [235] = {.lex_state = 69},
  [236] = {.lex_state = 69},
  [237] = {.lex_state = 69},
  [238] = {.lex_state = 69},
  [239] = {.lex_state = 69},
  [240] = {.lex_state = 69},
  [241] = {.lex_state = 69},
  [242] = {.lex_state = 69},
  [243] = {.lex_state = 69},
  [244] = {.lex_state = 69},
  [245] = {.lex_state = 69},
  [246] = {.lex_state = 69},
  [247] = {.lex_state = 69},
  [248] = {.lex_state = 69},
  [249] = {.lex_state = 69},
  [250] = {.lex_state = 69},
  [251] = {.lex_state = 69},
  [252] = {.lex_state = 69},
  [253] = {.lex_state = 69},
  [254] = {.lex_state = 69},
  [255] = {.lex_state = 69},
  [256] = {.lex_state = 69},
  [257] = {.lex_state = 69},
  [258] = {.lex_state = 69},
  [259] = {.lex_state = 69},
  [260] = {.lex_state = 69},
  [261] = {.lex_state = 69},
  [262] = {.lex_state = 69},
  [263] = {.lex_state = 69},
  [264] = {.lex_state = 69},
  [265] = {.lex_state = 69},
  [266] = {.lex_state = 69},
  [267] = {.lex_state = 69},
  [268] = {.lex_state = 69},
  [269] = {.lex_state = 69},
  [270] = {.lex_state = 69},
  [271] = {.lex_state = 69},
  [272] = {.lex_state = 69},
  [273] = {.lex_state = 69},
  [274] = {.lex_state = 69},
  [275] = {.lex_state = 69},
  [276] = {.lex_state = 69},
  [277] = {.lex_state = 69},
  [278] = {.lex_state = 69},
  [279] = {.lex_state = 69},
  [280] = {.lex_state = 69},
  [281] = {.lex_state = 69},
  [282] = {.lex_state = 69},
  [283] = {.lex_state = 69},
  [284] = {.lex_state = 69},
  [285] = {.lex_state = 69},
  [286] = {.lex_state = 69},
  [287] = {.lex_state = 69},
  [288] = {.lex_state = 69},
  [289] = {.lex_state = 69},
  [290] = {.lex_state = 69},
  [291] = {.lex_state = 69},
  [292] = {.lex_state = 69},
  [293] = {.lex_state = 69},
  [294] = {.lex_state = 69},
  [295] = {.lex_state = 69},
  [296] = {.lex_state = 69},
  [297] = {.lex_state = 69},
  [298] = {.lex_state = 69},
  [299] = {.lex_state = 69},
  [300] = {.lex_state = 69},
  [301] = {.lex_state = 69},
  [302] = {.lex_state = 69},
  [303] = {.lex_state = 69},
  [304] = {.lex_state = 69},
  [305] = {.lex_state = 69},
  [306] = {.lex_state = 69},
  [307] = {.lex_state = 69},
  [308] = {.lex_state = 69},
  [309] = {.lex_state = 69},
  [310] = {.lex_state = 69},
  [311] = {.lex_state = 69},
  [312] = {.lex_state = 69},
  [313] = {.lex_state = 69},
  [314] = {.lex_state = 69},
  [315] = {.lex_state = 68},
  [316] = {.lex_state = 68},
  [317] = {.lex_state = 68},
  [318] = {.lex_state = 69},
  [319] = {.lex_state = 69, .external_lex_state = 2},
  [320] = {.lex_state = 69},
  [321] = {.lex_state = 69},
  [322] = {.lex_state = 69},
  [323] = {.lex_state = 69},
  [324] = {.lex_state = 69},
  [325] = {.lex_state = 69},
  [326] = {.lex_state = 69},
  [327] = {.lex_state = 69},
  [328] = {.lex_state = 69},
  [329] = {.lex_state = 69},
  [330] = {.lex_state = 69},
  [331] = {.lex_state = 69},
  [332] = {.lex_state = 69},
  [333] = {.lex_state = 69},
  [334] = {.lex_state = 69},
  [335] = {.lex_state = 69},
  [336] = {.lex_state = 69},
  [337] = {.lex_state = 69},
  [338] = {.lex_state = 69},
  [339] = {.lex_state = 69},
  [340] = {.lex_state = 69},
  [341] = {.lex_state = 69},
  [342] = {.lex_state = 70},
  [343] = {.lex_state = 70},
  [344] = {.lex_state = 69},
  [345] = {.lex_state = 69},
  [346] = {.lex_state = 69},
  [347] = {.lex_state = 69},
  [348] = {.lex_state = 69},
  [349] = {.lex_state = 69},
  [350] = {.lex_state = 69},
  [351] = {.lex_state = 69},
  [352] = {.lex_state = 69},
  [353] = {.lex_state = 69},
  [354] = {.lex_state = 69},
  [355] = {.lex_state = 69},
  [356] = {.lex_state = 69},
  [357] = {.lex_state = 69},
  [358] = {.lex_state = 69},
  [359] = {.lex_state = 69},
  [360] = {.lex_state = 69},
  [361] = {.lex_state = 69},
  [362] = {.lex_state = 69},
  [363] = {.lex_state = 69},
  [364] = {.lex_state = 69},
  [365] = {.lex_state = 69},
  [366] = {.lex_state = 69},
  [367] = {.lex_state = 69},
  [368] = {.lex_state = 69},
  [369] = {.lex_state = 69},
  [370] = {.lex_state = 69},
  [371] = {.lex_state = 69},
  [372] = {.lex_state = 69},
  [373] = {.lex_state = 69},
  [374] = {.lex_state = 69},
  [375] = {.lex_state = 69},
  [376] = {.lex_state = 69},
  [377] = {.lex_state = 69},
  [378] = {.lex_state = 69},
  [379] = {.lex_state = 69},
  [380] = {.lex_state = 69},
  [381] = {.lex_state = 69},
  [382] = {.lex_state = 69},
  [383] = {.lex_state = 69},
  [384] = {.lex_state = 69},
  [385] = {.lex_state = 69},
  [386] = {.lex_state = 69},
  [387] = {.lex_state = 69},
  [388] = {.lex_state = 69},
  [389] = {.lex_state = 69},
  [390] = {.lex_state = 69},
  [391] = {.lex_state = 69},
  [392] = {.lex_state = 69},
  [393] = {.lex_state = 69},
  [394] = {.lex_state = 69},
  [395] = {.lex_state = 69},
  [396] = {.lex_state = 69},
  [397] = {.lex_state = 69},
  [398] = {.lex_state = 69},
  [399] = {.lex_state = 69},
  [400] = {.lex_state = 69},
  [401] = {.lex_state = 69},
  [402] = {.lex_state = 69},
  [403] = {.lex_state = 69},
  [404] = {.lex_state = 69},
  [405] = {.lex_state = 69},
  [406] = {.lex_state = 69},
  [407] = {.lex_state = 69},
  [408] = {.lex_state = 69},
  [409] = {.lex_state = 69},
  [410] = {.lex_state = 69},
  [411] = {.lex_state = 69},
  [412] = {.lex_state = 69},
  [413] = {.lex_state = 69},
  [414] = {.lex_state = 69},
  [415] = {.lex_state = 69},
  [416] = {.lex_state = 69},
  [417] = {.lex_state = 69},
  [418] = {.lex_state = 69},
  [419] = {.lex_state = 69},
  [420] = {.lex_state = 69},
  [421] = {.lex_state = 69},
  [422] = {.lex_state = 69},
  [423] = {.lex_state = 69},
  [424] = {.lex_state = 69},
  [425] = {.lex_state = 69},
  [426] = {.lex_state = 69},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 69},
  [429] = {.lex_state = 69},
  [430] = {.lex_state = 69},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 69},
  [433] = {.lex_state = 69},
  [434] = {.lex_state = 69},
  [435] = {.lex_state = 69},
  [436] = {.lex_state = 69},
  [437] = {.lex_state = 69},
  [438] = {.lex_state = 69},
  [439] = {.lex_state = 69},
  [440] = {.lex_state = 69},
  [441] = {.lex_state = 69},
  [442] = {.lex_state = 69},
  [443] = {.lex_state = 69},
  [444] = {.lex_state = 69},
  [445] = {.lex_state = 69},
  [446] = {.lex_state = 69},
  [447] = {.lex_state = 69},
  [448] = {.lex_state = 69},
  [449] = {.lex_state = 69},
  [450] = {.lex_state = 69},
  [451] = {.lex_state = 69},
  [452] = {.lex_state = 69},
  [453] = {.lex_state = 69},
  [454] = {.lex_state = 69},
  [455] = {.lex_state = 69},
  [456] = {.lex_state = 69},
  [457] = {.lex_state = 69},
  [458] = {.lex_state = 4},
  [459] = {.lex_state = 69},
  [460] = {.lex_state = 69},
  [461] = {.lex_state = 3},
  [462] = {.lex_state = 69},
  [463] = {.lex_state = 4},
  [464] = {.lex_state = 69},
  [465] = {.lex_state = 69},
  [466] = {.lex_state = 69},
  [467] = {.lex_state = 4},
  [468] = {.lex_state = 69},
  [469] = {.lex_state = 69},
  [470] = {.lex_state = 69},
  [471] = {.lex_state = 69},
  [472] = {.lex_state = 4},
  [473] = {.lex_state = 4},
  [474] = {.lex_state = 3},
  [475] = {.lex_state = 3},
  [476] = {.lex_state = 3},
  [477] = {.lex_state = 3},
  [478] = {.lex_state = 3},
  [479] = {.lex_state = 3},
  [480] = {.lex_state = 3},
  [481] = {.lex_state = 3},
  [482] = {.lex_state = 3},
  [483] = {.lex_state = 3},
  [484] = {.lex_state = 3},
  [485] = {.lex_state = 4},
  [486] = {.lex_state = 4},
  [487] = {.lex_state = 4},
  [488] = {.lex_state = 3},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 4},
  [491] = {.lex_state = 4},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 4},
  [494] = {.lex_state = 4},
  [495] = {.lex_state = 4},
  [496] = {.lex_state = 4},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 69},
  [499] = {.lex_state = 69},
  [500] = {.lex_state = 69},
  [501] = {.lex_state = 3},
  [502] = {.lex_state = 3},
  [503] = {.lex_state = 3},
  [504] = {.lex_state = 3},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 4},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 4},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 3},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 3},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 69},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 4},
  [525] = {.lex_state = 4},
  [526] = {.lex_state = 4},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 4},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 4},
  [532] = {.lex_state = 4},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 4},
  [535] = {.lex_state = 4},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 69},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 4},
  [544] = {.lex_state = 4},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 3},
  [547] = {.lex_state = 69},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 3},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 4},
  [552] = {.lex_state = 4},
  [553] = {.lex_state = 4},
  [554] = {.lex_state = 4},
  [555] = {.lex_state = 4},
  [556] = {.lex_state = 5},
  [557] = {.lex_state = 4},
  [558] = {.lex_state = 10},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 4},
  [561] = {.lex_state = 11},
  [562] = {.lex_state = 11},
  [563] = {.lex_state = 4},
  [564] = {.lex_state = 4},
  [565] = {.lex_state = 4},
  [566] = {.lex_state = 4},
  [567] = {.lex_state = 4},
  [568] = {.lex_state = 4},
  [569] = {.lex_state = 4},
  [570] = {.lex_state = 4},
  [571] = {.lex_state = 4},
  [572] = {.lex_state = 4},
  [573] = {.lex_state = 4},
  [574] = {.lex_state = 4},
  [575] = {.lex_state = 4},
  [576] = {.lex_state = 4},
  [577] = {.lex_state = 4},
  [578] = {.lex_state = 4},
  [579] = {.lex_state = 11},
  [580] = {.lex_state = 3},
  [581] = {.lex_state = 10},
  [582] = {.lex_state = 10},
  [583] = {.lex_state = 10},
  [584] = {.lex_state = 10},
  [585] = {.lex_state = 10},
  [586] = {.lex_state = 10},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 11},
  [589] = {.lex_state = 11},
  [590] = {.lex_state = 10},
  [591] = {.lex_state = 10},
  [592] = {.lex_state = 11},
  [593] = {.lex_state = 11},
  [594] = {.lex_state = 10},
  [595] = {.lex_state = 11},
  [596] = {.lex_state = 11},
  [597] = {.lex_state = 9},
  [598] = {.lex_state = 9},
  [599] = {.lex_state = 10},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 10},
  [602] = {.lex_state = 11},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 11},
  [605] = {.lex_state = 11},
  [606] = {.lex_state = 11},
  [607] = {.lex_state = 7},
  [608] = {.lex_state = 3},
  [609] = {.lex_state = 7},
  [610] = {.lex_state = 4},
  [611] = {.lex_state = 5},
  [612] = {.lex_state = 69},
  [613] = {.lex_state = 5},
  [614] = {.lex_state = 5},
  [615] = {.lex_state = 5},
  [616] = {.lex_state = 5},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 3},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 3},
  [623] = {.lex_state = 3},
  [624] = {.lex_state = 3},
  [625] = {.lex_state = 4},
  [626] = {.lex_state = 3},
  [627] = {.lex_state = 4},
  [628] = {.lex_state = 4},
  [629] = {.lex_state = 5},
  [630] = {.lex_state = 3},
  [631] = {.lex_state = 3},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 3},
  [634] = {.lex_state = 3},
  [635] = {.lex_state = 4},
  [636] = {.lex_state = 10},
  [637] = {.lex_state = 4},
  [638] = {.lex_state = 3},
  [639] = {.lex_state = 3},
  [640] = {.lex_state = 3},
  [641] = {.lex_state = 10},
  [642] = {.lex_state = 4},
  [643] = {.lex_state = 3},
  [644] = {.lex_state = 3},
  [645] = {.lex_state = 3},
  [646] = {.lex_state = 4},
  [647] = {.lex_state = 4},
  [648] = {.lex_state = 3},
  [649] = {.lex_state = 5},
  [650] = {.lex_state = 4},
  [651] = {.lex_state = 4},
  [652] = {.lex_state = 4},
  [653] = {.lex_state = 4},
  [654] = {.lex_state = 3},
  [655] = {.lex_state = 4},
  [656] = {.lex_state = 3},
  [657] = {.lex_state = 4},
  [658] = {.lex_state = 4},
  [659] = {.lex_state = 4},
  [660] = {.lex_state = 3},
  [661] = {.lex_state = 3},
  [662] = {.lex_state = 3},
  [663] = {.lex_state = 3},
  [664] = {.lex_state = 6},
  [665] = {.lex_state = 4},
  [666] = {.lex_state = 3},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 3},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 4},
  [671] = {.lex_state = 3},
  [672] = {.lex_state = 5},
  [673] = {.lex_state = 3},
  [674] = {.lex_state = 5},
  [675] = {.lex_state = 5},
  [676] = {.lex_state = 4},
  [677] = {.lex_state = 69},
  [678] = {.lex_state = 4},
  [679] = {.lex_state = 5},
  [680] = {.lex_state = 4},
  [681] = {.lex_state = 4},
  [682] = {.lex_state = 3},
  [683] = {.lex_state = 3},
  [684] = {.lex_state = 5},
  [685] = {.lex_state = 3},
  [686] = {.lex_state = 5},
  [687] = {.lex_state = 6},
  [688] = {.lex_state = 4},
  [689] = {.lex_state = 6},
  [690] = {.lex_state = 6},
  [691] = {.lex_state = 6},
  [692] = {.lex_state = 3},
  [693] = {.lex_state = 69},
  [694] = {.lex_state = 4},
  [695] = {.lex_state = 3},
  [696] = {.lex_state = 5},
  [697] = {.lex_state = 5},
  [698] = {.lex_state = 4},
  [699] = {.lex_state = 6},
  [700] = {.lex_state = 6},
  [701] = {.lex_state = 4},
  [702] = {.lex_state = 3},
  [703] = {.lex_state = 3},
  [704] = {.lex_state = 6},
  [705] = {.lex_state = 6},
  [706] = {.lex_state = 4},
  [707] = {.lex_state = 4},
  [708] = {.lex_state = 4},
  [709] = {.lex_state = 6},
  [710] = {.lex_state = 4},
  [711] = {.lex_state = 4},
  [712] = {.lex_state = 4},
  [713] = {.lex_state = 4},
  [714] = {.lex_state = 6},
  [715] = {.lex_state = 4},
  [716] = {.lex_state = 6},
  [717] = {.lex_state = 4},
  [718] = {.lex_state = 4},
  [719] = {.lex_state = 4},
  [720] = {.lex_state = 3},
  [721] = {.lex_state = 4},
  [722] = {.lex_state = 4},
  [723] = {.lex_state = 4},
  [724] = {.lex_state = 4},
  [725] = {.lex_state = 4},
  [726] = {.lex_state = 69},
  [727] = {.lex_state = 4},
  [728] = {.lex_state = 4},
  [729] = {.lex_state = 4},
  [730] = {.lex_state = 4},
  [731] = {.lex_state = 4},
  [732] = {.lex_state = 4},
  [733] = {.lex_state = 4},
  [734] = {.lex_state = 4},
  [735] = {.lex_state = 4},
  [736] = {.lex_state = 4},
  [737] = {.lex_state = 4},
  [738] = {.lex_state = 4},
  [739] = {.lex_state = 4},
  [740] = {.lex_state = 4},
  [741] = {.lex_state = 4},
  [742] = {.lex_state = 4},
  [743] = {.lex_state = 4},
  [744] = {.lex_state = 9},
  [745] = {.lex_state = 4},
  [746] = {.lex_state = 3},
  [747] = {.lex_state = 4},
  [748] = {.lex_state = 3},
  [749] = {.lex_state = 4},
  [750] = {.lex_state = 69},
  [751] = {.lex_state = 4},
  [752] = {.lex_state = 4},
  [753] = {.lex_state = 4},
  [754] = {.lex_state = 3},
  [755] = {.lex_state = 3},
  [756] = {.lex_state = 4},
  [757] = {.lex_state = 4},
  [758] = {.lex_state = 4},
  [759] = {.lex_state = 3},
  [760] = {.lex_state = 3},
  [761] = {.lex_state = 3},
  [762] = {.lex_state = 3},
  [763] = {.lex_state = 3},
  [764] = {.lex_state = 3},
  [765] = {.lex_state = 3},
  [766] = {.lex_state = 5},
  [767] = {.lex_state = 3},
  [768] = {.lex_state = 3},
  [769] = {.lex_state = 4},
  [770] = {.lex_state = 3},
  [771] = {.lex_state = 3},
  [772] = {.lex_state = 7},
  [773] = {.lex_state = 7},
  [774] = {.lex_state = 4},
  [775] = {.lex_state = 3},
  [776] = {.lex_state = 3},
  [777] = {.lex_state = 9},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 3},
  [781] = {.lex_state = 3},
  [782] = {.lex_state = 9},
  [783] = {.lex_state = 3},
  [784] = {.lex_state = 3},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 3},
  [787] = {.lex_state = 3},
  [788] = {.lex_state = 3},
  [789] = {.lex_state = 3},
  [790] = {.lex_state = 3},
  [791] = {.lex_state = 3},
  [792] = {.lex_state = 69},
  [793] = {.lex_state = 5},
  [794] = {.lex_state = 9},
  [795] = {.lex_state = 4},
  [796] = {.lex_state = 3},
  [797] = {.lex_state = 3},
  [798] = {.lex_state = 69},
  [799] = {.lex_state = 3},
  [800] = {.lex_state = 3},
  [801] = {.lex_state = 3},
  [802] = {.lex_state = 4},
  [803] = {.lex_state = 3},
  [804] = {.lex_state = 3},
  [805] = {.lex_state = 3},
  [806] = {.lex_state = 3},
  [807] = {.lex_state = 5},
  [808] = {.lex_state = 3},
  [809] = {.lex_state = 3},
  [810] = {.lex_state = 5},
  [811] = {.lex_state = 4},
  [812] = {.lex_state = 3},
  [813] = {.lex_state = 3},
  [814] = {.lex_state = 3},
  [815] = {.lex_state = 3},
  [816] = {.lex_state = 3},
  [817] = {.lex_state = 4},
  [818] = {.lex_state = 4},
  [819] = {.lex_state = 4},
  [820] = {.lex_state = 3},
  [821] = {.lex_state = 4},
  [822] = {.lex_state = 3},
  [823] = {.lex_state = 4},
  [824] = {.lex_state = 10},
  [825] = {.lex_state = 4},
  [826] = {.lex_state = 3},
  [827] = {.lex_state = 3},
  [828] = {.lex_state = 69},
  [829] = {.lex_state = 3},
  [830] = {.lex_state = 4},
  [831] = {.lex_state = 3},
  [832] = {.lex_state = 4},
  [833] = {.lex_state = 3},
  [834] = {.lex_state = 3},
  [835] = {.lex_state = 4},
  [836] = {.lex_state = 3},
  [837] = {.lex_state = 4},
  [838] = {.lex_state = 3},
  [839] = {.lex_state = 3},
  [840] = {.lex_state = 4},
  [841] = {.lex_state = 4},
  [842] = {.lex_state = 69},
  [843] = {.lex_state = 4},
  [844] = {.lex_state = 3},
  [845] = {.lex_state = 3},
  [846] = {.lex_state = 4},
  [847] = {.lex_state = 3},
  [848] = {.lex_state = 3},
  [849] = {.lex_state = 4},
  [850] = {.lex_state = 3},
  [851] = {.lex_state = 3},
  [852] = {.lex_state = 3},
  [853] = {.lex_state = 4},
  [854] = {.lex_state = 4},
  [855] = {.lex_state = 4},
  [856] = {.lex_state = 3},
  [857] = {.lex_state = 3},
  [858] = {.lex_state = 3},
  [859] = {.lex_state = 3},
  [860] = {.lex_state = 4},
  [861] = {.lex_state = 3},
  [862] = {.lex_state = 4},
  [863] = {.lex_state = 3},
  [864] = {.lex_state = 3},
  [865] = {.lex_state = 3},
  [866] = {.lex_state = 4},
  [867] = {.lex_state = 3},
  [868] = {.lex_state = 3},
  [869] = {.lex_state = 4},
  [870] = {.lex_state = 4},
  [871] = {.lex_state = 4},
  [872] = {.lex_state = 3},
  [873] = {.lex_state = 4},
  [874] = {.lex_state = 4},
  [875] = {.lex_state = 3},
  [876] = {.lex_state = 4},
  [877] = {.lex_state = 4},
  [878] = {.lex_state = 4},
  [879] = {.lex_state = 3},
  [880] = {.lex_state = 4},
  [881] = {.lex_state = 4},
  [882] = {.lex_state = 4},
  [883] = {.lex_state = 4},
  [884] = {.lex_state = 4},
  [885] = {.lex_state = 4},
  [886] = {.lex_state = 4},
  [887] = {.lex_state = 4},
  [888] = {.lex_state = 3},
  [889] = {.lex_state = 10},
  [890] = {.lex_state = 4},
  [891] = {.lex_state = 3},
  [892] = {.lex_state = 10},
  [893] = {.lex_state = 10},
  [894] = {.lex_state = 3},
  [895] = {.lex_state = 4},
  [896] = {.lex_state = 4},
  [897] = {.lex_state = 10},
  [898] = {.lex_state = 3},
  [899] = {.lex_state = 10},
  [900] = {.lex_state = 10},
  [901] = {.lex_state = 4},
  [902] = {.lex_state = 10},
  [903] = {.lex_state = 10},
  [904] = {.lex_state = 10},
  [905] = {.lex_state = 4},
  [906] = {.lex_state = 10},
  [907] = {.lex_state = 4},
  [908] = {.lex_state = 4},
  [909] = {.lex_state = 4},
  [910] = {.lex_state = 3},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 4},
  [915] = {.lex_state = 4},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 3},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 4},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 3},
  [922] = {.lex_state = 4},
  [923] = {.lex_state = 4},
  [924] = {.lex_state = 4},
  [925] = {.lex_state = 4},
  [926] = {.lex_state = 4},
  [927] = {.lex_state = 3},
  [928] = {.lex_state = 4},
  [929] = {.lex_state = 3},
  [930] = {.lex_state = 3},
  [931] = {.lex_state = 4},
  [932] = {.lex_state = 4},
  [933] = {.lex_state = 3},
  [934] = {.lex_state = 4},
  [935] = {.lex_state = 3},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 4},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 69},
  [941] = {.lex_state = 5},
  [942] = {.lex_state = 69},
  [943] = {.lex_state = 10},
  [944] = {.lex_state = 12},
  [945] = {.lex_state = 10},
  [946] = {.lex_state = 12},
  [947] = {.lex_state = 11},
  [948] = {.lex_state = 12},
  [949] = {.lex_state = 12},
  [950] = {.lex_state = 70},
  [951] = {.lex_state = 12},
  [952] = {.lex_state = 12},
  [953] = {.lex_state = 12},
  [954] = {.lex_state = 3},
  [955] = {.lex_state = 12},
  [956] = {.lex_state = 12},
  [957] = {.lex_state = 70},
  [958] = {.lex_state = 10},
  [959] = {.lex_state = 70},
  [960] = {.lex_state = 11},
  [961] = {.lex_state = 11},
  [962] = {.lex_state = 12},
  [963] = {.lex_state = 12},
  [964] = {.lex_state = 12},
  [965] = {.lex_state = 7},
  [966] = {.lex_state = 9},
  [967] = {.lex_state = 9},
  [968] = {.lex_state = 69},
  [969] = {.lex_state = 10},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 7},
  [972] = {.lex_state = 7},
  [973] = {.lex_state = 3},
  [974] = {.lex_state = 9},
  [975] = {.lex_state = 11},
  [976] = {.lex_state = 11},
  [977] = {.lex_state = 9},
  [978] = {.lex_state = 9},
  [979] = {.lex_state = 3},
  [980] = {.lex_state = 7},
  [981] = {.lex_state = 10},
  [982] = {.lex_state = 3},
  [983] = {.lex_state = 10},
  [984] = {.lex_state = 11},
  [985] = {.lex_state = 10},
  [986] = {.lex_state = 11},
  [987] = {.lex_state = 69},
  [988] = {.lex_state = 69},
  [989] = {.lex_state = 11},
  [990] = {.lex_state = 69},
  [991] = {.lex_state = 69},
  [992] = {.lex_state = 11},
  [993] = {.lex_state = 11},
  [994] = {.lex_state = 69},
  [995] = {.lex_state = 10},
  [996] = {.lex_state = 11},
  [997] = {.lex_state = 11},
  [998] = {.lex_state = 10},
  [999] = {.lex_state = 8},
  [1000] = {.lex_state = 10},
  [1001] = {.lex_state = 11},
  [1002] = {.lex_state = 10},
  [1003] = {.lex_state = 69},
  [1004] = {.lex_state = 10},
  [1005] = {.lex_state = 11},
  [1006] = {.lex_state = 10},
  [1007] = {.lex_state = 10},
  [1008] = {.lex_state = 11},
  [1009] = {.lex_state = 10},
  [1010] = {.lex_state = 10},
  [1011] = {.lex_state = 69},
  [1012] = {.lex_state = 11},
  [1013] = {.lex_state = 11},
  [1014] = {.lex_state = 10},
  [1015] = {.lex_state = 69},
  [1016] = {.lex_state = 11},
  [1017] = {.lex_state = 10},
  [1018] = {.lex_state = 11},
  [1019] = {.lex_state = 10},
  [1020] = {.lex_state = 10},
  [1021] = {.lex_state = 8},
  [1022] = {.lex_state = 11},
  [1023] = {.lex_state = 10},
  [1024] = {.lex_state = 69},
  [1025] = {.lex_state = 10},
  [1026] = {.lex_state = 10},
  [1027] = {.lex_state = 11},
  [1028] = {.lex_state = 70},
  [1029] = {.lex_state = 11},
  [1030] = {.lex_state = 11},
  [1031] = {.lex_state = 69},
  [1032] = {.lex_state = 69},
  [1033] = {.lex_state = 69},
  [1034] = {.lex_state = 11},
  [1035] = {.lex_state = 10},
  [1036] = {.lex_state = 69},
  [1037] = {.lex_state = 69},
  [1038] = {.lex_state = 10},
  [1039] = {.lex_state = 69},
  [1040] = {.lex_state = 7},
  [1041] = {.lex_state = 7},
  [1042] = {.lex_state = 10},
  [1043] = {.lex_state = 11},
  [1044] = {.lex_state = 10},
  [1045] = {.lex_state = 11},
  [1046] = {.lex_state = 7},
  [1047] = {.lex_state = 10},
  [1048] = {.lex_state = 7},
  [1049] = {.lex_state = 7},
  [1050] = {.lex_state = 11},
  [1051] = {.lex_state = 10},
  [1052] = {.lex_state = 7},
  [1053] = {.lex_state = 11},
  [1054] = {.lex_state = 19},
  [1055] = {.lex_state = 11},
  [1056] = {.lex_state = 7},
  [1057] = {.lex_state = 10},
  [1058] = {.lex_state = 7},
  [1059] = {.lex_state = 19},
  [1060] = {.lex_state = 10},
  [1061] = {.lex_state = 10},
  [1062] = {.lex_state = 7},
  [1063] = {.lex_state = 7},
  [1064] = {.lex_state = 19},
  [1065] = {.lex_state = 11},
  [1066] = {.lex_state = 70},
  [1067] = {.lex_state = 19},
  [1068] = {.lex_state = 7},
  [1069] = {.lex_state = 11},
  [1070] = {.lex_state = 11},
  [1071] = {.lex_state = 7},
  [1072] = {.lex_state = 10},
  [1073] = {.lex_state = 11},
  [1074] = {.lex_state = 11},
  [1075] = {.lex_state = 10},
  [1076] = {.lex_state = 10},
  [1077] = {.lex_state = 11},
  [1078] = {.lex_state = 11},
  [1079] = {.lex_state = 10},
  [1080] = {.lex_state = 10},
  [1081] = {.lex_state = 10},
  [1082] = {.lex_state = 10},
  [1083] = {.lex_state = 10},
  [1084] = {.lex_state = 3},
  [1085] = {.lex_state = 10},
  [1086] = {.lex_state = 10},
  [1087] = {.lex_state = 10},
  [1088] = {.lex_state = 10},
  [1089] = {.lex_state = 10},
  [1090] = {.lex_state = 10},
  [1091] = {.lex_state = 10},
  [1092] = {.lex_state = 10},
  [1093] = {.lex_state = 10},
  [1094] = {.lex_state = 11},
  [1095] = {.lex_state = 11},
  [1096] = {.lex_state = 11},
  [1097] = {.lex_state = 10},
  [1098] = {.lex_state = 10},
  [1099] = {.lex_state = 10},
  [1100] = {.lex_state = 11},
  [1101] = {.lex_state = 11},
  [1102] = {.lex_state = 10},
  [1103] = {.lex_state = 3},
  [1104] = {.lex_state = 10},
  [1105] = {.lex_state = 11},
  [1106] = {.lex_state = 10},
  [1107] = {.lex_state = 11},
  [1108] = {.lex_state = 11},
  [1109] = {.lex_state = 11},
  [1110] = {.lex_state = 10},
  [1111] = {.lex_state = 11},
  [1112] = {.lex_state = 10},
  [1113] = {.lex_state = 11},
  [1114] = {.lex_state = 11},
  [1115] = {.lex_state = 11},
  [1116] = {.lex_state = 10},
  [1117] = {.lex_state = 10},
  [1118] = {.lex_state = 11},
  [1119] = {.lex_state = 11},
  [1120] = {.lex_state = 11},
  [1121] = {.lex_state = 11},
  [1122] = {.lex_state = 11},
  [1123] = {.lex_state = 11},
  [1124] = {.lex_state = 11},
  [1125] = {.lex_state = 9},
  [1126] = {.lex_state = 10},
  [1127] = {.lex_state = 11},
  [1128] = {.lex_state = 11},
  [1129] = {.lex_state = 11},
  [1130] = {.lex_state = 11},
  [1131] = {.lex_state = 11},
  [1132] = {.lex_state = 10},
  [1133] = {.lex_state = 10},
  [1134] = {.lex_state = 10},
  [1135] = {.lex_state = 10},
  [1136] = {.lex_state = 11},
  [1137] = {.lex_state = 11},
  [1138] = {.lex_state = 11},
  [1139] = {.lex_state = 11},
  [1140] = {.lex_state = 11},
  [1141] = {.lex_state = 10},
  [1142] = {.lex_state = 10},
  [1143] = {.lex_state = 10},
  [1144] = {.lex_state = 3},
  [1145] = {.lex_state = 69},
  [1146] = {.lex_state = 11},
  [1147] = {.lex_state = 10},
  [1148] = {.lex_state = 10},
  [1149] = {.lex_state = 3},
  [1150] = {.lex_state = 10},
  [1151] = {.lex_state = 11},
  [1152] = {.lex_state = 10},
  [1153] = {.lex_state = 10},
  [1154] = {.lex_state = 11},
  [1155] = {.lex_state = 69},
  [1156] = {.lex_state = 3},
  [1157] = {.lex_state = 69},
  [1158] = {.lex_state = 69},
  [1159] = {.lex_state = 9},
  [1160] = {.lex_state = 69},
  [1161] = {.lex_state = 9},
  [1162] = {.lex_state = 3},
  [1163] = {.lex_state = 69},
  [1164] = {.lex_state = 3},
  [1165] = {.lex_state = 69},
  [1166] = {.lex_state = 3},
  [1167] = {.lex_state = 3},
  [1168] = {.lex_state = 3},
  [1169] = {.lex_state = 3},
  [1170] = {.lex_state = 69},
  [1171] = {.lex_state = 3},
  [1172] = {.lex_state = 69},
  [1173] = {.lex_state = 69},
  [1174] = {.lex_state = 3},
  [1175] = {.lex_state = 69},
  [1176] = {.lex_state = 69},
  [1177] = {.lex_state = 69},
  [1178] = {.lex_state = 69},
  [1179] = {.lex_state = 3},
  [1180] = {.lex_state = 3},
  [1181] = {.lex_state = 69},
  [1182] = {.lex_state = 69},
  [1183] = {.lex_state = 3},
  [1184] = {.lex_state = 7},
  [1185] = {.lex_state = 69},
  [1186] = {.lex_state = 69},
  [1187] = {.lex_state = 10},
  [1188] = {.lex_state = 28},
  [1189] = {.lex_state = 28},
  [1190] = {.lex_state = 10},
  [1191] = {.lex_state = 8},
  [1192] = {.lex_state = 8},
  [1193] = {.lex_state = 28},
  [1194] = {.lex_state = 8},
  [1195] = {.lex_state = 10},
  [1196] = {.lex_state = 8},
  [1197] = {.lex_state = 69},
  [1198] = {.lex_state = 8},
  [1199] = {.lex_state = 8},
  [1200] = {.lex_state = 10},
  [1201] = {.lex_state = 8},
  [1202] = {.lex_state = 8},
  [1203] = {.lex_state = 28},
  [1204] = {.lex_state = 8},
  [1205] = {.lex_state = 8},
  [1206] = {.lex_state = 8},
  [1207] = {.lex_state = 8},
  [1208] = {.lex_state = 28},
  [1209] = {.lex_state = 8},
  [1210] = {.lex_state = 8},
  [1211] = {.lex_state = 69},
  [1212] = {.lex_state = 8},
  [1213] = {.lex_state = 8},
  [1214] = {.lex_state = 28},
  [1215] = {.lex_state = 10},
  [1216] = {.lex_state = 10},
  [1217] = {.lex_state = 10},
  [1218] = {.lex_state = 10},
  [1219] = {.lex_state = 10},
  [1220] = {.lex_state = 69},
  [1221] = {.lex_state = 10},
  [1222] = {.lex_state = 10},
  [1223] = {.lex_state = 10},
  [1224] = {.lex_state = 28},
  [1225] = {.lex_state = 69},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 69},
  [1228] = {.lex_state = 28},
  [1229] = {.lex_state = 10},
  [1230] = {.lex_state = 69},
  [1231] = {.lex_state = 28},
  [1232] = {.lex_state = 28},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 28},
  [1235] = {.lex_state = 69},
  [1236] = {.lex_state = 28},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 69},
  [1239] = {.lex_state = 28},
  [1240] = {.lex_state = 10},
  [1241] = {.lex_state = 10},
  [1242] = {.lex_state = 10},
  [1243] = {.lex_state = 28},
  [1244] = {.lex_state = 5},
  [1245] = {.lex_state = 5},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 5},
  [1248] = {.lex_state = 5},
  [1249] = {.lex_state = 28},
  [1250] = {.lex_state = 69},
  [1251] = {.lex_state = 5},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 69},
  [1254] = {.lex_state = 69},
  [1255] = {.lex_state = 5},
  [1256] = {.lex_state = 69},
  [1257] = {.lex_state = 28},
  [1258] = {.lex_state = 5},
  [1259] = {.lex_state = 12},
  [1260] = {.lex_state = 5},
  [1261] = {.lex_state = 28},
  [1262] = {.lex_state = 5},
  [1263] = {.lex_state = 69},
  [1264] = {.lex_state = 28},
  [1265] = {.lex_state = 5},
  [1266] = {.lex_state = 5},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 28},
  [1269] = {.lex_state = 5},
  [1270] = {.lex_state = 28},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 28},
  [1273] = {.lex_state = 5},
  [1274] = {.lex_state = 28},
  [1275] = {.lex_state = 69},
  [1276] = {.lex_state = 69},
  [1277] = {.lex_state = 69},
  [1278] = {.lex_state = 28},
  [1279] = {.lex_state = 69},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 69},
  [1282] = {.lex_state = 28},
  [1283] = {.lex_state = 69},
  [1284] = {.lex_state = 28},
  [1285] = {.lex_state = 28},
  [1286] = {.lex_state = 28},
  [1287] = {.lex_state = 28},
  [1288] = {.lex_state = 28},
  [1289] = {.lex_state = 28},
  [1290] = {.lex_state = 69},
  [1291] = {.lex_state = 69},
  [1292] = {.lex_state = 28},
  [1293] = {.lex_state = 28},
  [1294] = {.lex_state = 69},
  [1295] = {.lex_state = 69},
  [1296] = {.lex_state = 70},
  [1297] = {.lex_state = 70},
  [1298] = {.lex_state = 70},
  [1299] = {.lex_state = 70},
  [1300] = {.lex_state = 70},
  [1301] = {.lex_state = 70},
  [1302] = {.lex_state = 69},
  [1303] = {.lex_state = 69},
  [1304] = {.lex_state = 69},
  [1305] = {.lex_state = 70},
  [1306] = {.lex_state = 70},
  [1307] = {.lex_state = 70},
  [1308] = {.lex_state = 70},
  [1309] = {.lex_state = 70},
  [1310] = {.lex_state = 69},
  [1311] = {.lex_state = 69},
  [1312] = {.lex_state = 8},
  [1313] = {.lex_state = 69},
  [1314] = {.lex_state = 8},
  [1315] = {.lex_state = 8},
  [1316] = {.lex_state = 8},
  [1317] = {.lex_state = 8},
  [1318] = {.lex_state = 8},
  [1319] = {.lex_state = 69},
  [1320] = {.lex_state = 69},
  [1321] = {.lex_state = 12},
  [1322] = {.lex_state = 5},
  [1323] = {.lex_state = 12},
  [1324] = {.lex_state = 69},
  [1325] = {.lex_state = 69},
  [1326] = {.lex_state = 12},
  [1327] = {.lex_state = 12},
  [1328] = {.lex_state = 69},
  [1329] = {.lex_state = 12},
  [1330] = {.lex_state = 69},
  [1331] = {.lex_state = 69},
  [1332] = {.lex_state = 69},
  [1333] = {.lex_state = 28},
  [1334] = {.lex_state = 12},
  [1335] = {.lex_state = 69},
  [1336] = {.lex_state = 69},
  [1337] = {.lex_state = 28},
  [1338] = {.lex_state = 69},
  [1339] = {.lex_state = 69},
  [1340] = {.lex_state = 69},
  [1341] = {.lex_state = 69},
  [1342] = {.lex_state = 69},
  [1343] = {.lex_state = 28},
  [1344] = {.lex_state = 69},
  [1345] = {.lex_state = 69},
  [1346] = {.lex_state = 69},
  [1347] = {.lex_state = 69},
  [1348] = {.lex_state = 69},
  [1349] = {.lex_state = 69},
  [1350] = {.lex_state = 69},
  [1351] = {.lex_state = 69},
  [1352] = {.lex_state = 69},
  [1353] = {.lex_state = 69},
  [1354] = {.lex_state = 69},
  [1355] = {.lex_state = 69},
  [1356] = {.lex_state = 70},
  [1357] = {.lex_state = 69},
  [1358] = {.lex_state = 69},
  [1359] = {.lex_state = 69},
  [1360] = {.lex_state = 69},
  [1361] = {.lex_state = 69},
  [1362] = {.lex_state = 69},
  [1363] = {.lex_state = 69},
  [1364] = {.lex_state = 69},
  [1365] = {.lex_state = 69},
  [1366] = {.lex_state = 69},
  [1367] = {.lex_state = 69},
  [1368] = {.lex_state = 69},
  [1369] = {.lex_state = 69},
  [1370] = {.lex_state = 69},
  [1371] = {.lex_state = 69},
  [1372] = {.lex_state = 69},
  [1373] = {.lex_state = 69},
  [1374] = {.lex_state = 69},
  [1375] = {.lex_state = 69},
  [1376] = {.lex_state = 69},
  [1377] = {.lex_state = 69},
  [1378] = {.lex_state = 69},
  [1379] = {.lex_state = 69},
  [1380] = {.lex_state = 69},
  [1381] = {.lex_state = 69},
  [1382] = {.lex_state = 69},
  [1383] = {.lex_state = 69},
  [1384] = {.lex_state = 69},
  [1385] = {.lex_state = 69},
  [1386] = {.lex_state = 69},
  [1387] = {.lex_state = 69},
  [1388] = {.lex_state = 69},
  [1389] = {.lex_state = 69},
  [1390] = {.lex_state = 69},
  [1391] = {.lex_state = 28},
  [1392] = {.lex_state = 19, .external_lex_state = 3},
  [1393] = {.lex_state = 7},
  [1394] = {.lex_state = 69},
  [1395] = {.lex_state = 28},
  [1396] = {.lex_state = 13, .external_lex_state = 4},
  [1397] = {.lex_state = 19, .external_lex_state = 3},
  [1398] = {.lex_state = 13, .external_lex_state = 4},
  [1399] = {.lex_state = 19, .external_lex_state = 3},
  [1400] = {.lex_state = 70},
  [1401] = {.lex_state = 70},
  [1402] = {.lex_state = 70},
  [1403] = {.lex_state = 19, .external_lex_state = 3},
  [1404] = {.lex_state = 13, .external_lex_state = 4},
  [1405] = {.lex_state = 19, .external_lex_state = 3},
  [1406] = {.lex_state = 28},
  [1407] = {.lex_state = 13, .external_lex_state = 4},
  [1408] = {.lex_state = 69},
  [1409] = {.lex_state = 13, .external_lex_state = 4},
  [1410] = {.lex_state = 13, .external_lex_state = 4},
  [1411] = {.lex_state = 69},
  [1412] = {.lex_state = 69},
  [1413] = {.lex_state = 69},
  [1414] = {.lex_state = 28},
  [1415] = {.lex_state = 13, .external_lex_state = 4},
  [1416] = {.lex_state = 19, .external_lex_state = 3},
  [1417] = {.lex_state = 7},
  [1418] = {.lex_state = 7},
  [1419] = {.lex_state = 69},
  [1420] = {.lex_state = 69},
  [1421] = {.lex_state = 70},
  [1422] = {.lex_state = 69},
  [1423] = {.lex_state = 19, .external_lex_state = 3},
  [1424] = {.lex_state = 22, .external_lex_state = 5},
  [1425] = {.lex_state = 69},
  [1426] = {.lex_state = 13, .external_lex_state = 6},
  [1427] = {.lex_state = 19, .external_lex_state = 7},
  [1428] = {.lex_state = 13, .external_lex_state = 6},
  [1429] = {.lex_state = 70},
  [1430] = {.lex_state = 28},
  [1431] = {.lex_state = 22, .external_lex_state = 5},
  [1432] = {.lex_state = 13, .external_lex_state = 6},
  [1433] = {.lex_state = 19, .external_lex_state = 7},
  [1434] = {.lex_state = 22, .external_lex_state = 8},
  [1435] = {.lex_state = 28},
  [1436] = {.lex_state = 19, .external_lex_state = 7},
  [1437] = {.lex_state = 28},
  [1438] = {.lex_state = 7},
  [1439] = {.lex_state = 22, .external_lex_state = 8},
  [1440] = {.lex_state = 22, .external_lex_state = 5},
  [1441] = {.lex_state = 69},
  [1442] = {.lex_state = 69},
  [1443] = {.lex_state = 19, .external_lex_state = 7},
  [1444] = {.lex_state = 69},
  [1445] = {.lex_state = 19, .external_lex_state = 7},
  [1446] = {.lex_state = 13, .external_lex_state = 6},
  [1447] = {.lex_state = 22, .external_lex_state = 5},
  [1448] = {.lex_state = 13, .external_lex_state = 6},
  [1449] = {.lex_state = 19, .external_lex_state = 7},
  [1450] = {.lex_state = 28},
  [1451] = {.lex_state = 22, .external_lex_state = 8},
  [1452] = {.lex_state = 22, .external_lex_state = 5},
  [1453] = {.lex_state = 22, .external_lex_state = 8},
  [1454] = {.lex_state = 22, .external_lex_state = 8},
  [1455] = {.lex_state = 7},
  [1456] = {.lex_state = 68},
  [1457] = {.lex_state = 19, .external_lex_state = 7},
  [1458] = {.lex_state = 13, .external_lex_state = 6},
  [1459] = {.lex_state = 69},
  [1460] = {.lex_state = 28},
  [1461] = {.lex_state = 28},
  [1462] = {.lex_state = 7},
  [1463] = {.lex_state = 22, .external_lex_state = 5},
  [1464] = {.lex_state = 22, .external_lex_state = 8},
  [1465] = {.lex_state = 22, .external_lex_state = 5},
  [1466] = {.lex_state = 22, .external_lex_state = 8},
  [1467] = {.lex_state = 69},
  [1468] = {.lex_state = 13, .external_lex_state = 6},
  [1469] = {.lex_state = 12},
  [1470] = {.lex_state = 22, .external_lex_state = 9},
  [1471] = {.lex_state = 12},
  [1472] = {.lex_state = 69},
  [1473] = {.lex_state = 69},
  [1474] = {.lex_state = 12},
  [1475] = {.lex_state = 69},
  [1476] = {.lex_state = 28},
  [1477] = {.lex_state = 28},
  [1478] = {.lex_state = 69},
  [1479] = {.lex_state = 12},
  [1480] = {.lex_state = 28},
  [1481] = {.lex_state = 7},
  [1482] = {.lex_state = 12},
  [1483] = {.lex_state = 69},
  [1484] = {.lex_state = 69},
  [1485] = {.lex_state = 69},
  [1486] = {.lex_state = 22, .external_lex_state = 9},
  [1487] = {.lex_state = 22, .external_lex_state = 10},
  [1488] = {.lex_state = 22, .external_lex_state = 9},
  [1489] = {.lex_state = 22, .external_lex_state = 10},
  [1490] = {.lex_state = 69},
  [1491] = {.lex_state = 68},
  [1492] = {.lex_state = 7},
  [1493] = {.lex_state = 12},
  [1494] = {.lex_state = 69},
  [1495] = {.lex_state = 69},
  [1496] = {.lex_state = 22, .external_lex_state = 10},
  [1497] = {.lex_state = 69},
  [1498] = {.lex_state = 22, .external_lex_state = 9},
  [1499] = {.lex_state = 69},
  [1500] = {.lex_state = 28},
  [1501] = {.lex_state = 22, .external_lex_state = 9},
  [1502] = {.lex_state = 22, .external_lex_state = 10},
  [1503] = {.lex_state = 69},
  [1504] = {.lex_state = 69},
  [1505] = {.lex_state = 12},
  [1506] = {.lex_state = 69},
  [1507] = {.lex_state = 12},
  [1508] = {.lex_state = 69},
  [1509] = {.lex_state = 69},
  [1510] = {.lex_state = 69},
  [1511] = {.lex_state = 69},
  [1512] = {.lex_state = 69},
  [1513] = {.lex_state = 7},
  [1514] = {.lex_state = 22, .external_lex_state = 10},
  [1515] = {.lex_state = 69},
  [1516] = {.lex_state = 12},
  [1517] = {.lex_state = 69},
  [1518] = {.lex_state = 22, .external_lex_state = 9},
  [1519] = {.lex_state = 22, .external_lex_state = 9},
  [1520] = {.lex_state = 15, .external_lex_state = 6},
  [1521] = {.lex_state = 12},
  [1522] = {.lex_state = 21, .external_lex_state = 7},
  [1523] = {.lex_state = 22, .external_lex_state = 10},
  [1524] = {.lex_state = 12},
  [1525] = {.lex_state = 28},
  [1526] = {.lex_state = 22, .external_lex_state = 10},
  [1527] = {.lex_state = 28},
  [1528] = {.lex_state = 70},
  [1529] = {.lex_state = 69},
  [1530] = {.lex_state = 70},
  [1531] = {.lex_state = 70},
  [1532] = {.lex_state = 70},
  [1533] = {.lex_state = 70},
  [1534] = {.lex_state = 70},
  [1535] = {.lex_state = 70},
  [1536] = {.lex_state = 70},
  [1537] = {.lex_state = 24, .external_lex_state = 9},
  [1538] = {.lex_state = 7},
  [1539] = {.lex_state = 70},
  [1540] = {.lex_state = 70},
  [1541] = {.lex_state = 70},
  [1542] = {.lex_state = 70},
  [1543] = {.lex_state = 7},
  [1544] = {.lex_state = 70},
  [1545] = {.lex_state = 70},
  [1546] = {.lex_state = 19, .external_lex_state = 7},
  [1547] = {.lex_state = 70},
  [1548] = {.lex_state = 69},
  [1549] = {.lex_state = 70},
  [1550] = {.lex_state = 12},
  [1551] = {.lex_state = 70},
  [1552] = {.lex_state = 7},
  [1553] = {.lex_state = 7},
  [1554] = {.lex_state = 13, .external_lex_state = 6},
  [1555] = {.lex_state = 70},
  [1556] = {.lex_state = 7},
  [1557] = {.lex_state = 69},
  [1558] = {.lex_state = 7},
  [1559] = {.lex_state = 69},
  [1560] = {.lex_state = 69},
  [1561] = {.lex_state = 28},
  [1562] = {.lex_state = 12},
  [1563] = {.lex_state = 70},
  [1564] = {.lex_state = 70},
  [1565] = {.lex_state = 69},
  [1566] = {.lex_state = 69},
  [1567] = {.lex_state = 70},
  [1568] = {.lex_state = 69},
  [1569] = {.lex_state = 70},
  [1570] = {.lex_state = 70},
  [1571] = {.lex_state = 70},
  [1572] = {.lex_state = 24, .external_lex_state = 10},
  [1573] = {.lex_state = 68},
  [1574] = {.lex_state = 70},
  [1575] = {.lex_state = 70},
  [1576] = {.lex_state = 70},
  [1577] = {.lex_state = 70},
  [1578] = {.lex_state = 70},
  [1579] = {.lex_state = 70},
  [1580] = {.lex_state = 7},
  [1581] = {.lex_state = 7},
  [1582] = {.lex_state = 7},
  [1583] = {.lex_state = 7},
  [1584] = {.lex_state = 68},
  [1585] = {.lex_state = 70},
  [1586] = {.lex_state = 70},
  [1587] = {.lex_state = 70},
  [1588] = {.lex_state = 70},
  [1589] = {.lex_state = 69},
  [1590] = {.lex_state = 70},
  [1591] = {.lex_state = 69},
  [1592] = {.lex_state = 7},
  [1593] = {.lex_state = 70},
  [1594] = {.lex_state = 7},
  [1595] = {.lex_state = 70},
  [1596] = {.lex_state = 12},
  [1597] = {.lex_state = 69},
  [1598] = {.lex_state = 7},
  [1599] = {.lex_state = 7},
  [1600] = {.lex_state = 7},
  [1601] = {.lex_state = 7},
  [1602] = {.lex_state = 7},
  [1603] = {.lex_state = 69},
  [1604] = {.lex_state = 7},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 69},
  [1607] = {.lex_state = 69},
  [1608] = {.lex_state = 69},
  [1609] = {.lex_state = 69},
  [1610] = {.lex_state = 69},
  [1611] = {.lex_state = 69},
  [1612] = {.lex_state = 69},
  [1613] = {.lex_state = 69},
  [1614] = {.lex_state = 69},
  [1615] = {.lex_state = 7},
  [1616] = {.lex_state = 69},
  [1617] = {.lex_state = 69},
  [1618] = {.lex_state = 69},
  [1619] = {.lex_state = 19, .external_lex_state = 3},
  [1620] = {.lex_state = 69},
  [1621] = {.lex_state = 69},
  [1622] = {.lex_state = 7},
  [1623] = {.lex_state = 7},
  [1624] = {.lex_state = 19, .external_lex_state = 3},
  [1625] = {.lex_state = 19, .external_lex_state = 3},
  [1626] = {.lex_state = 69},
  [1627] = {.lex_state = 22, .external_lex_state = 10},
  [1628] = {.lex_state = 7},
  [1629] = {.lex_state = 7},
  [1630] = {.lex_state = 69},
  [1631] = {.lex_state = 7},
  [1632] = {.lex_state = 69},
  [1633] = {.lex_state = 70},
  [1634] = {.lex_state = 69},
  [1635] = {.lex_state = 69},
  [1636] = {.lex_state = 7},
  [1637] = {.lex_state = 69},
  [1638] = {.lex_state = 22, .external_lex_state = 9},
  [1639] = {.lex_state = 69},
  [1640] = {.lex_state = 69},
  [1641] = {.lex_state = 69},
  [1642] = {.lex_state = 69},
  [1643] = {.lex_state = 68},
  [1644] = {.lex_state = 69},
  [1645] = {.lex_state = 69},
  [1646] = {.lex_state = 69},
  [1647] = {.lex_state = 7},
  [1648] = {.lex_state = 69},
  [1649] = {.lex_state = 13, .external_lex_state = 4},
  [1650] = {.lex_state = 7},
  [1651] = {.lex_state = 7},
  [1652] = {.lex_state = 69},
  [1653] = {.lex_state = 13, .external_lex_state = 4},
  [1654] = {.lex_state = 7},
  [1655] = {.lex_state = 7},
  [1656] = {.lex_state = 13, .external_lex_state = 4},
  [1657] = {.lex_state = 13, .external_lex_state = 4},
  [1658] = {.lex_state = 69},
  [1659] = {.lex_state = 69},
  [1660] = {.lex_state = 69},
  [1661] = {.lex_state = 69},
  [1662] = {.lex_state = 69},
  [1663] = {.lex_state = 69},
  [1664] = {.lex_state = 69},
  [1665] = {.lex_state = 69},
  [1666] = {.lex_state = 69},
  [1667] = {.lex_state = 69},
  [1668] = {.lex_state = 69},
  [1669] = {.lex_state = 69},
  [1670] = {.lex_state = 19, .external_lex_state = 3},
  [1671] = {.lex_state = 69},
  [1672] = {.lex_state = 28},
  [1673] = {.lex_state = 69},
  [1674] = {.lex_state = 7},
  [1675] = {.lex_state = 69},
  [1676] = {.lex_state = 69},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 12},
  [1679] = {.lex_state = 22, .external_lex_state = 5},
  [1680] = {.lex_state = 69},
  [1681] = {.lex_state = 68},
  [1682] = {.lex_state = 70},
  [1683] = {.lex_state = 69},
  [1684] = {.lex_state = 69},
  [1685] = {.lex_state = 68},
  [1686] = {.lex_state = 68},
  [1687] = {.lex_state = 69},
  [1688] = {.lex_state = 22, .external_lex_state = 5},
  [1689] = {.lex_state = 69},
  [1690] = {.lex_state = 12},
  [1691] = {.lex_state = 69},
  [1692] = {.lex_state = 69},
  [1693] = {.lex_state = 69},
  [1694] = {.lex_state = 69},
  [1695] = {.lex_state = 68},
  [1696] = {.lex_state = 68},
  [1697] = {.lex_state = 69},
  [1698] = {.lex_state = 68},
  [1699] = {.lex_state = 69},
  [1700] = {.lex_state = 68},
  [1701] = {.lex_state = 69},
  [1702] = {.lex_state = 12},
  [1703] = {.lex_state = 69},
  [1704] = {.lex_state = 69},
  [1705] = {.lex_state = 22, .external_lex_state = 8},
  [1706] = {.lex_state = 22, .external_lex_state = 8},
  [1707] = {.lex_state = 69},
  [1708] = {.lex_state = 69},
  [1709] = {.lex_state = 68},
  [1710] = {.lex_state = 22, .external_lex_state = 5},
  [1711] = {.lex_state = 68},
  [1712] = {.lex_state = 69},
  [1713] = {.lex_state = 12},
  [1714] = {.lex_state = 7},
  [1715] = {.lex_state = 70},
  [1716] = {.lex_state = 69},
  [1717] = {.lex_state = 69},
  [1718] = {.lex_state = 12},
  [1719] = {.lex_state = 69},
  [1720] = {.lex_state = 22, .external_lex_state = 5},
  [1721] = {.lex_state = 69},
  [1722] = {.lex_state = 69},
  [1723] = {.lex_state = 22, .external_lex_state = 8},
  [1724] = {.lex_state = 69},
  [1725] = {.lex_state = 69},
  [1726] = {.lex_state = 69},
  [1727] = {.lex_state = 22, .external_lex_state = 8},
  [1728] = {.lex_state = 69},
  [1729] = {.lex_state = 69},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 70},
  [1732] = {.lex_state = 69},
  [1733] = {.lex_state = 69},
  [1734] = {.lex_state = 12},
  [1735] = {.lex_state = 69},
  [1736] = {.lex_state = 69},
  [1737] = {.lex_state = 68},
  [1738] = {.lex_state = 70},
  [1739] = {.lex_state = 69},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 69},
  [1742] = {.lex_state = 69},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 69},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 68},
  [1747] = {.lex_state = 69},
  [1748] = {.lex_state = 69},
  [1749] = {.lex_state = 69},
  [1750] = {.lex_state = 69},
  [1751] = {.lex_state = 68},
  [1752] = {.lex_state = 69},
  [1753] = {.lex_state = 69},
  [1754] = {.lex_state = 69},
  [1755] = {.lex_state = 69},
  [1756] = {.lex_state = 69},
  [1757] = {.lex_state = 0},
  [1758] = {.lex_state = 68},
  [1759] = {.lex_state = 69},
  [1760] = {.lex_state = 69},
  [1761] = {.lex_state = 69},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 69},
  [1764] = {.lex_state = 69},
  [1765] = {.lex_state = 69},
  [1766] = {.lex_state = 69},
  [1767] = {.lex_state = 69},
  [1768] = {.lex_state = 68},
  [1769] = {.lex_state = 69},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 69},
  [1773] = {.lex_state = 69},
  [1774] = {.lex_state = 69},
  [1775] = {.lex_state = 69},
  [1776] = {.lex_state = 69},
  [1777] = {.lex_state = 69},
  [1778] = {.lex_state = 0},
  [1779] = {.lex_state = 69},
  [1780] = {.lex_state = 69},
  [1781] = {.lex_state = 68},
  [1782] = {.lex_state = 69},
  [1783] = {.lex_state = 69},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 69},
  [1786] = {.lex_state = 69},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 0},
  [1791] = {.lex_state = 0},
  [1792] = {.lex_state = 0},
  [1793] = {.lex_state = 69},
  [1794] = {.lex_state = 69},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 69},
  [1797] = {.lex_state = 68},
  [1798] = {.lex_state = 69},
  [1799] = {.lex_state = 38},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 69},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 68},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 0},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 0},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 0},
  [1814] = {.lex_state = 69},
  [1815] = {.lex_state = 69},
  [1816] = {.lex_state = 0},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 69},
  [1819] = {.lex_state = 69},
  [1820] = {.lex_state = 69},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 69},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 0},
  [1825] = {.lex_state = 69},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 69},
  [1828] = {.lex_state = 0},
  [1829] = {.lex_state = 0},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 0},
  [1832] = {.lex_state = 69},
  [1833] = {.lex_state = 69},
  [1834] = {.lex_state = 0},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 69},
  [1838] = {.lex_state = 69},
  [1839] = {.lex_state = 0},
  [1840] = {.lex_state = 38},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 0},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 69},
  [1845] = {.lex_state = 69},
  [1846] = {.lex_state = 38},
  [1847] = {.lex_state = 69},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 0},
  [1851] = {.lex_state = 0},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 0},
  [1856] = {.lex_state = 0},
  [1857] = {.lex_state = 68},
  [1858] = {.lex_state = 69},
  [1859] = {.lex_state = 0},
  [1860] = {.lex_state = 0},
  [1861] = {.lex_state = 69},
  [1862] = {.lex_state = 0},
  [1863] = {.lex_state = 0},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 0},
  [1866] = {.lex_state = 69},
  [1867] = {.lex_state = 69},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 0},
  [1871] = {.lex_state = 0},
  [1872] = {.lex_state = 69},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 0},
  [1875] = {.lex_state = 69},
  [1876] = {.lex_state = 0},
  [1877] = {.lex_state = 69},
  [1878] = {.lex_state = 0},
  [1879] = {.lex_state = 69},
  [1880] = {.lex_state = 69},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 69},
  [1884] = {.lex_state = 69},
  [1885] = {.lex_state = 69},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 69},
  [1890] = {.lex_state = 69},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 0},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 69},
  [1901] = {.lex_state = 69},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 69},
  [1908] = {.lex_state = 69},
  [1909] = {.lex_state = 69},
  [1910] = {.lex_state = 69},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 0},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 69},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 0},
  [1926] = {.lex_state = 69},
  [1927] = {.lex_state = 68},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 69},
  [1930] = {.lex_state = 69},
  [1931] = {.lex_state = 0},
  [1932] = {.lex_state = 69},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 69},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 0},
  [1938] = {.lex_state = 69},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 69},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 69},
  [1943] = {.lex_state = 69},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 69},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 69},
  [1948] = {.lex_state = 69},
  [1949] = {.lex_state = 69},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 69},
  [1952] = {.lex_state = 0},
  [1953] = {.lex_state = 69},
  [1954] = {.lex_state = 69},
  [1955] = {.lex_state = 0},
  [1956] = {.lex_state = 0},
  [1957] = {.lex_state = 69},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 69},
  [1961] = {.lex_state = 0},
  [1962] = {.lex_state = 69},
  [1963] = {.lex_state = 0},
  [1964] = {.lex_state = 38},
  [1965] = {.lex_state = 69},
  [1966] = {.lex_state = 69},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 0},
  [1969] = {.lex_state = 0},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 0},
  [1972] = {.lex_state = 0},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 69},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 69},
  [1979] = {.lex_state = 69},
  [1980] = {.lex_state = 69},
  [1981] = {.lex_state = 69},
  [1982] = {.lex_state = 0},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 69},
  [1986] = {.lex_state = 68},
  [1987] = {.lex_state = 0},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 69},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 69},
  [1992] = {.lex_state = 0},
  [1993] = {.lex_state = 69},
  [1994] = {.lex_state = 0},
  [1995] = {.lex_state = 69},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 70},
  [1998] = {.lex_state = 0},
  [1999] = {.lex_state = 68},
  [2000] = {.lex_state = 69},
  [2001] = {.lex_state = 68},
  [2002] = {.lex_state = 0},
  [2003] = {.lex_state = 69},
  [2004] = {.lex_state = 0},
  [2005] = {.lex_state = 0},
  [2006] = {.lex_state = 0},
  [2007] = {.lex_state = 0},
  [2008] = {.lex_state = 0},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 0},
  [2011] = {.lex_state = 0},
  [2012] = {.lex_state = 0},
  [2013] = {.lex_state = 0},
  [2014] = {.lex_state = 0},
  [2015] = {.lex_state = 0},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 0},
  [2018] = {.lex_state = 69},
  [2019] = {.lex_state = 69},
  [2020] = {.lex_state = 68},
  [2021] = {.lex_state = 69},
  [2022] = {.lex_state = 0},
  [2023] = {.lex_state = 0},
  [2024] = {.lex_state = 0},
  [2025] = {.lex_state = 0},
  [2026] = {.lex_state = 69},
  [2027] = {.lex_state = 0},
  [2028] = {.lex_state = 69},
  [2029] = {.lex_state = 0},
  [2030] = {.lex_state = 0},
  [2031] = {.lex_state = 69},
  [2032] = {.lex_state = 0},
  [2033] = {.lex_state = 0},
  [2034] = {.lex_state = 0},
  [2035] = {.lex_state = 0},
  [2036] = {.lex_state = 0},
  [2037] = {.lex_state = 0},
  [2038] = {.lex_state = 0},
  [2039] = {.lex_state = 0},
  [2040] = {.lex_state = 0},
  [2041] = {.lex_state = 0},
  [2042] = {.lex_state = 0},
  [2043] = {.lex_state = 0},
  [2044] = {.lex_state = 0},
  [2045] = {.lex_state = 0},
  [2046] = {.lex_state = 69},
  [2047] = {.lex_state = 0},
  [2048] = {.lex_state = 0},
  [2049] = {.lex_state = 0},
  [2050] = {.lex_state = 0},
  [2051] = {.lex_state = 0},
  [2052] = {.lex_state = 0},
  [2053] = {.lex_state = 0},
  [2054] = {.lex_state = 0},
  [2055] = {.lex_state = 0},
  [2056] = {.lex_state = 69},
  [2057] = {.lex_state = 0},
  [2058] = {.lex_state = 0},
  [2059] = {.lex_state = 0},
  [2060] = {.lex_state = 0},
  [2061] = {.lex_state = 0},
  [2062] = {.lex_state = 0},
  [2063] = {.lex_state = 69},
  [2064] = {.lex_state = 0},
  [2065] = {.lex_state = 0},
  [2066] = {.lex_state = 0},
  [2067] = {.lex_state = 0},
  [2068] = {.lex_state = 69},
  [2069] = {.lex_state = 0},
  [2070] = {.lex_state = 0},
  [2071] = {.lex_state = 0},
  [2072] = {.lex_state = 0},
  [2073] = {.lex_state = 0},
  [2074] = {.lex_state = 0},
  [2075] = {.lex_state = 0},
  [2076] = {.lex_state = 69},
  [2077] = {.lex_state = 0},
  [2078] = {.lex_state = 0},
  [2079] = {.lex_state = 0},
  [2080] = {.lex_state = 0},
  [2081] = {.lex_state = 0},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 0},
  [2084] = {.lex_state = 0},
  [2085] = {.lex_state = 69},
  [2086] = {.lex_state = 69},
  [2087] = {.lex_state = 0},
  [2088] = {.lex_state = 0},
  [2089] = {.lex_state = 69},
  [2090] = {.lex_state = 0},
  [2091] = {.lex_state = 0},
  [2092] = {.lex_state = 0},
  [2093] = {.lex_state = 0},
  [2094] = {.lex_state = 0},
  [2095] = {.lex_state = 0},
  [2096] = {.lex_state = 0},
  [2097] = {.lex_state = 19},
  [2098] = {.lex_state = 0},
  [2099] = {.lex_state = 0},
  [2100] = {.lex_state = 0},
  [2101] = {.lex_state = 0},
  [2102] = {.lex_state = 0},
  [2103] = {.lex_state = 0},
  [2104] = {.lex_state = 69},
  [2105] = {.lex_state = 0},
  [2106] = {.lex_state = 0},
  [2107] = {.lex_state = 0},
  [2108] = {.lex_state = 0},
  [2109] = {.lex_state = 0},
  [2110] = {.lex_state = 0},
  [2111] = {.lex_state = 69},
  [2112] = {.lex_state = 0},
  [2113] = {.lex_state = 0},
  [2114] = {.lex_state = 69},
  [2115] = {.lex_state = 69},
  [2116] = {.lex_state = 0},
  [2117] = {.lex_state = 0},
  [2118] = {.lex_state = 0},
  [2119] = {.lex_state = 69},
  [2120] = {.lex_state = 0},
  [2121] = {.lex_state = 0},
  [2122] = {.lex_state = 0},
  [2123] = {.lex_state = 0},
  [2124] = {.lex_state = 0},
  [2125] = {.lex_state = 69},
  [2126] = {.lex_state = 0},
  [2127] = {.lex_state = 0},
  [2128] = {.lex_state = 0},
  [2129] = {.lex_state = 69},
  [2130] = {.lex_state = 0},
  [2131] = {.lex_state = 69},
  [2132] = {.lex_state = 0},
  [2133] = {.lex_state = 0},
  [2134] = {.lex_state = 69},
  [2135] = {.lex_state = 0},
  [2136] = {.lex_state = 69},
  [2137] = {.lex_state = 69},
  [2138] = {.lex_state = 69},
  [2139] = {.lex_state = 0},
  [2140] = {.lex_state = 0},
  [2141] = {.lex_state = 69},
  [2142] = {.lex_state = 69},
  [2143] = {.lex_state = 69},
  [2144] = {.lex_state = 0},
  [2145] = {.lex_state = 0},
  [2146] = {.lex_state = 69},
  [2147] = {.lex_state = 69},
  [2148] = {.lex_state = 69},
  [2149] = {.lex_state = 0},
  [2150] = {.lex_state = 0},
  [2151] = {.lex_state = 0},
  [2152] = {.lex_state = 0},
  [2153] = {.lex_state = 69},
  [2154] = {.lex_state = 0},
  [2155] = {.lex_state = 0},
  [2156] = {.lex_state = 69},
  [2157] = {.lex_state = 0},
  [2158] = {.lex_state = 0},
  [2159] = {.lex_state = 0},
  [2160] = {.lex_state = 0},
  [2161] = {.lex_state = 0},
  [2162] = {.lex_state = 69},
  [2163] = {.lex_state = 69},
  [2164] = {.lex_state = 69},
  [2165] = {.lex_state = 0},
  [2166] = {.lex_state = 0},
  [2167] = {.lex_state = 0},
  [2168] = {.lex_state = 69},
  [2169] = {.lex_state = 69},
  [2170] = {.lex_state = 0},
  [2171] = {.lex_state = 0},
  [2172] = {.lex_state = 69},
  [2173] = {.lex_state = 0},
  [2174] = {.lex_state = 0},
  [2175] = {.lex_state = 0},
  [2176] = {.lex_state = 0},
  [2177] = {.lex_state = 0},
  [2178] = {.lex_state = 0},
  [2179] = {.lex_state = 69},
  [2180] = {.lex_state = 69},
  [2181] = {.lex_state = 0},
  [2182] = {.lex_state = 0},
  [2183] = {.lex_state = 0},
  [2184] = {.lex_state = 0},
  [2185] = {.lex_state = 0},
  [2186] = {.lex_state = 0},
  [2187] = {.lex_state = 69},
  [2188] = {.lex_state = 69},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 69},
  [2191] = {.lex_state = 0},
  [2192] = {.lex_state = 0},
  [2193] = {.lex_state = 69},
  [2194] = {.lex_state = 69},
  [2195] = {.lex_state = 0},
  [2196] = {.lex_state = 0},
  [2197] = {.lex_state = 0},
  [2198] = {.lex_state = 0},
  [2199] = {.lex_state = 0},
  [2200] = {.lex_state = 69},
  [2201] = {.lex_state = 69},
  [2202] = {.lex_state = 0},
  [2203] = {.lex_state = 69},
  [2204] = {.lex_state = 69},
  [2205] = {.lex_state = 69},
  [2206] = {.lex_state = 0},
  [2207] = {.lex_state = 0},
  [2208] = {.lex_state = 69},
  [2209] = {.lex_state = 69},
  [2210] = {.lex_state = 69},
  [2211] = {.lex_state = 0},
  [2212] = {.lex_state = 69},
  [2213] = {.lex_state = 0},
  [2214] = {.lex_state = 69},
  [2215] = {.lex_state = 69},
  [2216] = {.lex_state = 0},
  [2217] = {.lex_state = 0},
  [2218] = {.lex_state = 0},
  [2219] = {.lex_state = 0},
  [2220] = {.lex_state = 0},
  [2221] = {.lex_state = 1},
  [2222] = {.lex_state = 0},
  [2223] = {.lex_state = 0},
  [2224] = {.lex_state = 0},
  [2225] = {.lex_state = 0},
  [2226] = {.lex_state = 69},
  [2227] = {.lex_state = 0},
  [2228] = {.lex_state = 0},
  [2229] = {.lex_state = 0},
  [2230] = {.lex_state = 0},
  [2231] = {.lex_state = 0},
  [2232] = {.lex_state = 0},
  [2233] = {.lex_state = 0},
  [2234] = {.lex_state = 69},
  [2235] = {.lex_state = 0},
  [2236] = {.lex_state = 0},
  [2237] = {.lex_state = 0},
  [2238] = {.lex_state = 0},
  [2239] = {.lex_state = 0},
  [2240] = {.lex_state = 0},
  [2241] = {.lex_state = 69},
  [2242] = {.lex_state = 69},
  [2243] = {.lex_state = 69},
  [2244] = {.lex_state = 0},
  [2245] = {.lex_state = 0},
  [2246] = {.lex_state = 69},
  [2247] = {.lex_state = 69},
  [2248] = {.lex_state = 0},
  [2249] = {.lex_state = 0},
  [2250] = {.lex_state = 69},
  [2251] = {.lex_state = 0},
  [2252] = {.lex_state = 0},
  [2253] = {.lex_state = 0},
  [2254] = {.lex_state = 69},
  [2255] = {.lex_state = 69},
  [2256] = {.lex_state = 68},
  [2257] = {.lex_state = 69},
  [2258] = {.lex_state = 0},
  [2259] = {.lex_state = 69},
  [2260] = {.lex_state = 69},
  [2261] = {.lex_state = 69},
  [2262] = {.lex_state = 0},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 69},
  [2265] = {.lex_state = 0},
  [2266] = {.lex_state = 0},
  [2267] = {.lex_state = 0},
  [2268] = {.lex_state = 0},
  [2269] = {.lex_state = 2},
  [2270] = {.lex_state = 0},
  [2271] = {.lex_state = 69},
  [2272] = {.lex_state = 0},
  [2273] = {.lex_state = 0},
  [2274] = {.lex_state = 0},
  [2275] = {.lex_state = 0},
  [2276] = {.lex_state = 0},
  [2277] = {.lex_state = 0},
  [2278] = {.lex_state = 0},
  [2279] = {.lex_state = 0},
  [2280] = {.lex_state = 0},
  [2281] = {.lex_state = 0},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 69},
  [2284] = {.lex_state = 0},
  [2285] = {.lex_state = 68},
  [2286] = {.lex_state = 0},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 68},
  [2289] = {.lex_state = 68},
  [2290] = {.lex_state = 69},
  [2291] = {.lex_state = 69},
  [2292] = {.lex_state = 0},
  [2293] = {.lex_state = 0},
  [2294] = {.lex_state = 0},
  [2295] = {.lex_state = 0},
  [2296] = {.lex_state = 69},
  [2297] = {.lex_state = 0},
  [2298] = {.lex_state = 69},
  [2299] = {.lex_state = 0},
  [2300] = {.lex_state = 69},
  [2301] = {.lex_state = 0},
  [2302] = {.lex_state = 68},
  [2303] = {.lex_state = 0},
  [2304] = {.lex_state = 69},
  [2305] = {.lex_state = 0},
  [2306] = {.lex_state = 69},
  [2307] = {.lex_state = 69},
  [2308] = {.lex_state = 0},
  [2309] = {.lex_state = 0},
  [2310] = {.lex_state = 0},
  [2311] = {.lex_state = 0},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 69},
  [2314] = {.lex_state = 0},
  [2315] = {.lex_state = 69},
  [2316] = {.lex_state = 0},
  [2317] = {.lex_state = 69},
  [2318] = {.lex_state = 0},
  [2319] = {.lex_state = 69},
  [2320] = {.lex_state = 69},
  [2321] = {.lex_state = 0},
  [2322] = {.lex_state = 69},
  [2323] = {.lex_state = 69},
  [2324] = {.lex_state = 0},
  [2325] = {.lex_state = 0},
  [2326] = {.lex_state = 0},
  [2327] = {.lex_state = 69},
  [2328] = {.lex_state = 0},
  [2329] = {.lex_state = 68},
  [2330] = {.lex_state = 0},
  [2331] = {.lex_state = 0},
  [2332] = {.lex_state = 69},
  [2333] = {.lex_state = 0},
  [2334] = {.lex_state = 69},
  [2335] = {.lex_state = 69},
  [2336] = {.lex_state = 69},
  [2337] = {.lex_state = 69},
  [2338] = {.lex_state = 69},
  [2339] = {.lex_state = 0},
  [2340] = {.lex_state = 69},
  [2341] = {.lex_state = 69},
  [2342] = {.lex_state = 69},
  [2343] = {.lex_state = 0},
  [2344] = {.lex_state = 0},
  [2345] = {.lex_state = 0},
  [2346] = {.lex_state = 0},
  [2347] = {.lex_state = 68},
  [2348] = {.lex_state = 0},
  [2349] = {.lex_state = 0},
  [2350] = {.lex_state = 0},
  [2351] = {.lex_state = 0},
  [2352] = {.lex_state = 0},
  [2353] = {.lex_state = 0},
  [2354] = {.lex_state = 0},
  [2355] = {.lex_state = 0},
  [2356] = {.lex_state = 0},
  [2357] = {.lex_state = 69},
  [2358] = {.lex_state = 0},
  [2359] = {.lex_state = 0},
  [2360] = {.lex_state = 0},
  [2361] = {.lex_state = 0},
  [2362] = {.lex_state = 69},
  [2363] = {.lex_state = 69},
  [2364] = {.lex_state = 69},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars_double = 1,
  ts_external_token__template_chars_single = 2,
  ts_external_token__template_chars_double_single = 3,
  ts_external_token__template_chars_single_single = 4,
  ts_external_token__template_chars_raw_slash = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars_double] = sym__template_chars_double,
  [ts_external_token__template_chars_single] = sym__template_chars_single,
  [ts_external_token__template_chars_double_single] = sym__template_chars_double_single,
  [ts_external_token__template_chars_single_single] = sym__template_chars_single_single,
  [ts_external_token__template_chars_raw_slash] = sym__template_chars_raw_slash,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars_double] = true,
    [ts_external_token__template_chars_single] = true,
    [ts_external_token__template_chars_double_single] = true,
    [ts_external_token__template_chars_single_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars_single] = true,
  },
  [4] = {
    [ts_external_token__template_chars_double] = true,
  },
  [5] = {
    [ts_external_token__template_chars_single_single] = true,
  },
  [6] = {
    [ts_external_token__template_chars_double] = true,
    [ts_external_token__template_chars_raw_slash] = true,
  },
  [7] = {
    [ts_external_token__template_chars_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
  },
  [8] = {
    [ts_external_token__template_chars_double_single] = true,
  },
  [9] = {
    [ts_external_token__template_chars_single_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
  },
  [10] = {
    [ts_external_token__template_chars_double_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_r_SQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym__unused_escape_sequence] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym_equality_operator] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [sym__additive_operator] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_TILDE_SLASH] = ACTIONS(1),
    [sym_increment_operator] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [sym_minus_operator] = ACTIONS(1),
    [sym__exclamation_operator] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_transitive] = ACTIONS(1),
    [anon_sym_part] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_show] = ACTIONS(1),
    [anon_sym_hide] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extension] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_super] = ACTIONS(1),
    [sym_floating_point_type] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_async_STAR] = ACTIONS(1),
    [anon_sym_sync_STAR] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_throws] = ACTIONS(1),
    [anon_sym_POUND_BANG] = ACTIONS(1),
    [anon_sym_library] = ACTIONS(1),
    [sym__break_builtin] = ACTIONS(1),
    [sym__assert_builtin] = ACTIONS(1),
    [sym_case_builtin] = ACTIONS(1),
    [anon_sym_covariant] = ACTIONS(1),
    [anon_sym_deferred] = ACTIONS(1),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_factory] = ACTIONS(1),
    [anon_sym_Function] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_mixin] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [sym_const_builtin] = ACTIONS(1),
    [sym_final_builtin] = ACTIONS(1),
    [anon_sym_late] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars_double] = ACTIONS(1),
    [sym__template_chars_single] = ACTIONS(1),
    [sym__template_chars_double_single] = ACTIONS(1),
    [sym__template_chars_single_single] = ACTIONS(1),
    [sym__template_chars_raw_slash] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2248),
    [sym__top_level_definition] = STATE(19),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(43),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(6),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(10),
    [sym_part_of_directive] = STATE(13),
    [sym_enum_declaration] = STATE(19),
    [sym_type_alias] = STATE(19),
    [sym_class_definition] = STATE(19),
    [sym_extension_declaration] = STATE(19),
    [sym__metadata] = STATE(424),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(19),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym_script_tag] = STATE(2),
    [sym_library_name] = STATE(5),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_program_repeat2] = STATE(10),
    [aux_sym_program_repeat3] = STATE(13),
    [aux_sym_program_repeat4] = STATE(19),
    [aux_sym_program_repeat5] = STATE(43),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_POUND_BANG] = ACTIONS(93),
    [anon_sym_library] = ACTIONS(95),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__top_level_definition] = STATE(22),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(7),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(9),
    [sym_part_of_directive] = STATE(14),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias] = STATE(22),
    [sym_class_definition] = STATE(22),
    [sym_extension_declaration] = STATE(22),
    [sym__metadata] = STATE(424),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(22),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym_library_name] = STATE(3),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_program_repeat2] = STATE(9),
    [aux_sym_program_repeat3] = STATE(14),
    [aux_sym_program_repeat4] = STATE(22),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_library] = ACTIONS(95),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__top_level_definition] = STATE(18),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(37),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(4),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(8),
    [sym_part_of_directive] = STATE(12),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias] = STATE(18),
    [sym_class_definition] = STATE(18),
    [sym_extension_declaration] = STATE(18),
    [sym__metadata] = STATE(456),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(18),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_program_repeat2] = STATE(8),
    [aux_sym_program_repeat3] = STATE(12),
    [aux_sym_program_repeat4] = STATE(18),
    [aux_sym_program_repeat5] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__top_level_definition] = STATE(17),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(45),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(318),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(11),
    [sym_part_of_directive] = STATE(16),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias] = STATE(17),
    [sym_class_definition] = STATE(17),
    [sym_extension_declaration] = STATE(17),
    [sym__metadata] = STATE(456),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(17),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(318),
    [aux_sym_program_repeat2] = STATE(11),
    [aux_sym_program_repeat3] = STATE(16),
    [aux_sym_program_repeat4] = STATE(17),
    [aux_sym_program_repeat5] = STATE(45),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__top_level_definition] = STATE(22),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(7),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(9),
    [sym_part_of_directive] = STATE(14),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias] = STATE(22),
    [sym_class_definition] = STATE(22),
    [sym_extension_declaration] = STATE(22),
    [sym__metadata] = STATE(456),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(22),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_program_repeat2] = STATE(9),
    [aux_sym_program_repeat3] = STATE(14),
    [aux_sym_program_repeat4] = STATE(22),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__top_level_definition] = STATE(22),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(318),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(9),
    [sym_part_of_directive] = STATE(14),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias] = STATE(22),
    [sym_class_definition] = STATE(22),
    [sym_extension_declaration] = STATE(22),
    [sym__metadata] = STATE(456),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(22),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(318),
    [aux_sym_program_repeat2] = STATE(9),
    [aux_sym_program_repeat3] = STATE(14),
    [aux_sym_program_repeat4] = STATE(22),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__top_level_definition] = STATE(18),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(37),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_import_or_export] = STATE(318),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym_part_directive] = STATE(8),
    [sym_part_of_directive] = STATE(12),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias] = STATE(18),
    [sym_class_definition] = STATE(18),
    [sym_extension_declaration] = STATE(18),
    [sym__metadata] = STATE(456),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(18),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__export] = STATE(1226),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__import] = STATE(1233),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat1] = STATE(318),
    [aux_sym_program_repeat2] = STATE(8),
    [aux_sym_program_repeat3] = STATE(12),
    [aux_sym_program_repeat4] = STATE(18),
    [aux_sym_program_repeat5] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(103),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_import] = ACTIONS(109),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__top_level_definition] = STATE(17),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(45),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_directive] = STATE(345),
    [sym_part_of_directive] = STATE(16),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias] = STATE(17),
    [sym_class_definition] = STATE(17),
    [sym_extension_declaration] = STATE(17),
    [sym__metadata] = STATE(498),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(17),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat2] = STATE(345),
    [aux_sym_program_repeat3] = STATE(16),
    [aux_sym_program_repeat4] = STATE(17),
    [aux_sym_program_repeat5] = STATE(45),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__top_level_definition] = STATE(18),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(37),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_directive] = STATE(345),
    [sym_part_of_directive] = STATE(12),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias] = STATE(18),
    [sym_class_definition] = STATE(18),
    [sym_extension_declaration] = STATE(18),
    [sym__metadata] = STATE(498),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(18),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat2] = STATE(345),
    [aux_sym_program_repeat3] = STATE(12),
    [aux_sym_program_repeat4] = STATE(18),
    [aux_sym_program_repeat5] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__top_level_definition] = STATE(22),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_directive] = STATE(345),
    [sym_part_of_directive] = STATE(14),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias] = STATE(22),
    [sym_class_definition] = STATE(22),
    [sym_extension_declaration] = STATE(22),
    [sym__metadata] = STATE(498),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(22),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat2] = STATE(345),
    [aux_sym_program_repeat3] = STATE(14),
    [aux_sym_program_repeat4] = STATE(22),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__top_level_definition] = STATE(21),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(44),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_directive] = STATE(345),
    [sym_part_of_directive] = STATE(15),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias] = STATE(21),
    [sym_class_definition] = STATE(21),
    [sym_extension_declaration] = STATE(21),
    [sym__metadata] = STATE(498),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(21),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat2] = STATE(345),
    [aux_sym_program_repeat3] = STATE(15),
    [aux_sym_program_repeat4] = STATE(21),
    [aux_sym_program_repeat5] = STATE(44),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(77),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__top_level_definition] = STATE(17),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(45),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_of_directive] = STATE(344),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias] = STATE(17),
    [sym_class_definition] = STATE(17),
    [sym_extension_declaration] = STATE(17),
    [sym__metadata] = STATE(499),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(17),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym_program_repeat4] = STATE(17),
    [aux_sym_program_repeat5] = STATE(45),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__top_level_definition] = STATE(22),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_of_directive] = STATE(344),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias] = STATE(22),
    [sym_class_definition] = STATE(22),
    [sym_extension_declaration] = STATE(22),
    [sym__metadata] = STATE(499),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(22),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym_program_repeat4] = STATE(22),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__top_level_definition] = STATE(18),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(37),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_of_directive] = STATE(344),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias] = STATE(18),
    [sym_class_definition] = STATE(18),
    [sym_extension_declaration] = STATE(18),
    [sym__metadata] = STATE(499),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(18),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym_program_repeat4] = STATE(18),
    [aux_sym_program_repeat5] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__top_level_definition] = STATE(20),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(35),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_of_directive] = STATE(344),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias] = STATE(20),
    [sym_class_definition] = STATE(20),
    [sym_extension_declaration] = STATE(20),
    [sym__metadata] = STATE(499),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(20),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym_program_repeat4] = STATE(20),
    [aux_sym_program_repeat5] = STATE(35),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__top_level_definition] = STATE(21),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(44),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_part_of_directive] = STATE(344),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias] = STATE(21),
    [sym_class_definition] = STATE(21),
    [sym_extension_declaration] = STATE(21),
    [sym__metadata] = STATE(499),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(21),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym_program_repeat4] = STATE(21),
    [aux_sym_program_repeat5] = STATE(44),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_part] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(44),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(44),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(45),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(45),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(42),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(51),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(51),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(143),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(35),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(35),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__top_level_definition] = STATE(204),
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(37),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(500),
    [sym_type_parameters] = STATE(1971),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1597),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1921),
    [sym_function_signature] = STATE(1438),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1324),
    [sym__external_builtin] = STATE(1291),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym_program_repeat5] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_enum] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_extension] = ACTIONS(85),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_mixin] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_typedef] = ACTIONS(115),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(119),
    [sym_final_builtin] = ACTIONS(121),
    [anon_sym_late] = ACTIONS(123),
    [anon_sym_external] = ACTIONS(125),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1915),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1915),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1915),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1915),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1915),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1915),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1915),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1915),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1741),
    [sym__element] = STATE(1741),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1741),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(448),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1741),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1741),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(175),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1741),
    [sym__element] = STATE(1741),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1741),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(448),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1741),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1741),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1774),
    [sym__element] = STATE(1774),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1774),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(450),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1774),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1774),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(175),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1775),
    [sym__element] = STATE(1775),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1775),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(457),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1775),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1775),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(175),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1774),
    [sym__element] = STATE(1774),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1637),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(1637),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1774),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(450),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_element] = STATE(1774),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym_for_element] = STATE(1774),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(151),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(33),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_switch_label] = STATE(33),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym_switch_block_repeat1] = STATE(33),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_default] = ACTIONS(185),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [sym_case_builtin] = ACTIONS(191),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(33),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_switch_label] = STATE(33),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym_switch_block_repeat1] = STATE(33),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_POUND] = ACTIONS(196),
    [sym_decimal_integer_literal] = ACTIONS(199),
    [sym_hex_integer_literal] = ACTIONS(202),
    [sym_decimal_floating_point_literal] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(220),
    [anon_sym_r_DQUOTE] = ACTIONS(223),
    [anon_sym_r_SQUOTE] = ACTIONS(226),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(229),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(232),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_RBRACE] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_null] = ACTIONS(243),
    [anon_sym_throw] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(252),
    [sym_increment_operator] = ACTIONS(255),
    [sym_minus_operator] = ACTIONS(258),
    [sym__exclamation_operator] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(264),
    [anon_sym_await] = ACTIONS(267),
    [anon_sym_switch] = ACTIONS(270),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(279),
    [anon_sym_continue] = ACTIONS(282),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(288),
    [anon_sym_try] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_for] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_super] = ACTIONS(303),
    [sym_void_type] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(309),
    [sym__break_builtin] = ACTIONS(312),
    [sym__assert_builtin] = ACTIONS(315),
    [sym_case_builtin] = ACTIONS(318),
    [anon_sym_covariant] = ACTIONS(321),
    [anon_sym_Function] = ACTIONS(324),
    [anon_sym_get] = ACTIONS(327),
    [anon_sym_set] = ACTIONS(330),
    [anon_sym_new] = ACTIONS(333),
    [sym_const_builtin] = ACTIONS(336),
    [sym_final_builtin] = ACTIONS(339),
    [anon_sym_late] = ACTIONS(342),
    [anon_sym_this] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(32),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_switch_label] = STATE(32),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym_switch_block_repeat1] = STATE(32),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(348),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_default] = ACTIONS(185),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [sym_case_builtin] = ACTIONS(191),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(143),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(46),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(46),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(39),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(39),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(352),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(52),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(50),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(50),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(358),
    [sym_identifier] = ACTIONS(360),
    [anon_sym_POUND] = ACTIONS(363),
    [sym_decimal_integer_literal] = ACTIONS(366),
    [sym_hex_integer_literal] = ACTIONS(369),
    [sym_decimal_floating_point_literal] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_SQUOTE] = ACTIONS(381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(384),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(387),
    [anon_sym_r_DQUOTE] = ACTIONS(390),
    [anon_sym_r_SQUOTE] = ACTIONS(393),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(396),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(402),
    [anon_sym_LBRACK] = ACTIONS(405),
    [anon_sym_null] = ACTIONS(408),
    [anon_sym_throw] = ACTIONS(411),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(417),
    [sym_increment_operator] = ACTIONS(420),
    [sym_minus_operator] = ACTIONS(423),
    [sym__exclamation_operator] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(438),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_continue] = ACTIONS(444),
    [anon_sym_yield] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(450),
    [anon_sym_try] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(456),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_super] = ACTIONS(465),
    [sym_void_type] = ACTIONS(468),
    [anon_sym_var] = ACTIONS(471),
    [sym__break_builtin] = ACTIONS(474),
    [sym__assert_builtin] = ACTIONS(477),
    [anon_sym_covariant] = ACTIONS(480),
    [anon_sym_Function] = ACTIONS(483),
    [anon_sym_get] = ACTIONS(486),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_new] = ACTIONS(492),
    [sym_const_builtin] = ACTIONS(495),
    [sym_final_builtin] = ACTIONS(498),
    [anon_sym_late] = ACTIONS(501),
    [anon_sym_this] = ACTIONS(504),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(52),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(52),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(47),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(52),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(41),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(515),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(52),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_program_repeat5] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(363),
    [sym_decimal_integer_literal] = ACTIONS(366),
    [sym_hex_integer_literal] = ACTIONS(369),
    [sym_decimal_floating_point_literal] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_SQUOTE] = ACTIONS(381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(384),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(387),
    [anon_sym_r_DQUOTE] = ACTIONS(390),
    [anon_sym_r_SQUOTE] = ACTIONS(393),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(396),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(405),
    [anon_sym_null] = ACTIONS(408),
    [anon_sym_throw] = ACTIONS(411),
    [anon_sym_LPAREN] = ACTIONS(414),
    [anon_sym_LT] = ACTIONS(417),
    [sym_increment_operator] = ACTIONS(420),
    [sym_minus_operator] = ACTIONS(423),
    [sym__exclamation_operator] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_await] = ACTIONS(523),
    [anon_sym_switch] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(438),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_continue] = ACTIONS(444),
    [anon_sym_yield] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(450),
    [anon_sym_try] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_super] = ACTIONS(465),
    [sym_void_type] = ACTIONS(468),
    [anon_sym_var] = ACTIONS(471),
    [sym__break_builtin] = ACTIONS(474),
    [sym__assert_builtin] = ACTIONS(477),
    [anon_sym_covariant] = ACTIONS(480),
    [anon_sym_Function] = ACTIONS(483),
    [anon_sym_get] = ACTIONS(486),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_new] = ACTIONS(492),
    [sym_const_builtin] = ACTIONS(495),
    [sym_final_builtin] = ACTIONS(498),
    [anon_sym_late] = ACTIONS(501),
    [anon_sym_this] = ACTIONS(504),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(1978),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(436),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(445),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(436),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(448),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(450),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(2209),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(436),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(450),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(462),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(449),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(450),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(448),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(448),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(449),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(445),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(457),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(449),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1548),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1582),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(183),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_for] = ACTIONS(189),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2112),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2112),
    [sym_assignable_expression] = STATE(1273),
    [sym_lambda_expression] = STATE(440),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__statement] = STATE(445),
    [sym_block] = STATE(440),
    [sym_expression_statement] = STATE(440),
    [sym_labeled_statement] = STATE(440),
    [sym_assert_statement] = STATE(440),
    [sym_assertion] = STATE(2216),
    [sym_switch_statement] = STATE(440),
    [sym_do_statement] = STATE(440),
    [sym_break_statement] = STATE(440),
    [sym_continue_statement] = STATE(440),
    [sym_yield_statement] = STATE(440),
    [sym_yield_each_statement] = STATE(440),
    [sym_return_statement] = STATE(440),
    [sym_try_statement] = STATE(440),
    [sym__try_head] = STATE(1603),
    [sym_if_statement] = STATE(440),
    [sym_while_statement] = STATE(440),
    [sym_for_statement] = STATE(440),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1736),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(1719),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym_function_signature] = STATE(1598),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(440),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1616),
    [sym__set] = STATE(1616),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(63),
    [anon_sym_yield] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_try] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(545),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [sym__break_builtin] = ACTIONS(97),
    [sym__assert_builtin] = ACTIONS(99),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(113),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1915),
    [sym_for_element] = STATE(1915),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(968),
    [sym_type_parameters] = STATE(1971),
    [sym__declared_identifier] = STATE(1610),
    [sym__final_const_var_or_type] = STATE(1957),
    [sym__type] = STATE(2003),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1957),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_formal_parameter] = STATE(1773),
    [sym__default_named_parameter] = STATE(1939),
    [sym__normal_formal_parameter] = STATE(1634),
    [sym__function_formal_parameter] = STATE(1634),
    [sym__simple_formal_parameter] = STATE(1635),
    [sym_constructor_param] = STATE(1634),
    [sym__covariant] = STATE(1277),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(954),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_required] = ACTIONS(559),
    [anon_sym_covariant] = ACTIONS(561),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1936),
    [sym__element] = STATE(1936),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1936),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1936),
    [sym_for_element] = STATE(1936),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(968),
    [sym_type_parameters] = STATE(1971),
    [sym__declared_identifier] = STATE(1610),
    [sym__final_const_var_or_type] = STATE(1957),
    [sym__type] = STATE(2003),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1957),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_formal_parameter] = STATE(1940),
    [sym__default_formal_parameter] = STATE(1941),
    [sym__normal_formal_parameter] = STATE(1634),
    [sym__function_formal_parameter] = STATE(1634),
    [sym__simple_formal_parameter] = STATE(1635),
    [sym_constructor_param] = STATE(1634),
    [sym__covariant] = STATE(1277),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(954),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(563),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(561),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2196),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2196),
    [sym_assignment_expression] = STATE(2196),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(968),
    [sym_type_parameters] = STATE(1971),
    [sym__declared_identifier] = STATE(1610),
    [sym__final_const_var_or_type] = STATE(1957),
    [sym__type] = STATE(2003),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1957),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__normal_formal_parameters] = STATE(1987),
    [sym_optional_formal_parameters] = STATE(2198),
    [sym__optional_postional_formal_parameters] = STATE(2199),
    [sym__named_formal_parameters] = STATE(2199),
    [sym_formal_parameter] = STATE(1855),
    [sym__normal_formal_parameter] = STATE(1634),
    [sym__function_formal_parameter] = STATE(1634),
    [sym__simple_formal_parameter] = STATE(1635),
    [sym_constructor_param] = STATE(1634),
    [sym__covariant] = STATE(1277),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(954),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(561),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2252),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2252),
    [sym_assignment_expression] = STATE(2252),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(968),
    [sym_type_parameters] = STATE(1971),
    [sym__declared_identifier] = STATE(1610),
    [sym__final_const_var_or_type] = STATE(1957),
    [sym__type] = STATE(2003),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1957),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__normal_formal_parameters] = STATE(1987),
    [sym_optional_formal_parameters] = STATE(2198),
    [sym__optional_postional_formal_parameters] = STATE(2199),
    [sym__named_formal_parameters] = STATE(2199),
    [sym_formal_parameter] = STATE(1855),
    [sym__normal_formal_parameter] = STATE(1634),
    [sym__function_formal_parameter] = STATE(1634),
    [sym__simple_formal_parameter] = STATE(1635),
    [sym_constructor_param] = STATE(1634),
    [sym__covariant] = STATE(1277),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(954),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(561),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2195),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2195),
    [sym_assignment_expression] = STATE(2195),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(968),
    [sym_type_parameters] = STATE(1971),
    [sym__declared_identifier] = STATE(1610),
    [sym__final_const_var_or_type] = STATE(1957),
    [sym__type] = STATE(2003),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(1957),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__normal_formal_parameters] = STATE(1987),
    [sym_optional_formal_parameters] = STATE(2198),
    [sym__optional_postional_formal_parameters] = STATE(2199),
    [sym__named_formal_parameters] = STATE(2199),
    [sym_formal_parameter] = STATE(1855),
    [sym__normal_formal_parameter] = STATE(1634),
    [sym__function_formal_parameter] = STATE(1634),
    [sym__simple_formal_parameter] = STATE(1635),
    [sym_constructor_param] = STATE(1634),
    [sym__covariant] = STATE(1277),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(954),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(561),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2325),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [78] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2328),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [79] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2301),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2299),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [81] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2217),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [82] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2276),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2244),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2316),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2245),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2249),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2281),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1743),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1743),
    [sym_assignment_expression] = STATE(1743),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym__for_loop_parts] = STATE(2294),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym__metadata] = STATE(1227),
    [sym_type_parameters] = STATE(1971),
    [sym_initialized_variable_definition] = STATE(2006),
    [sym__declared_identifier] = STATE(1722),
    [sym__final_const_var_or_type] = STATE(2193),
    [sym__type] = STATE(2193),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1441),
    [sym_inferred_type] = STATE(2193),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym_local_variable_declaration] = STATE(144),
    [sym__covariant] = STATE(1283),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__new_builtin] = STATE(1378),
    [sym__late_builtin] = STATE(1325),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [aux_sym__metadata_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_super] = ACTIONS(87),
    [sym_void_type] = ACTIONS(89),
    [anon_sym_var] = ACTIONS(91),
    [anon_sym_covariant] = ACTIONS(101),
    [anon_sym_Function] = ACTIONS(105),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(159),
    [sym_final_builtin] = ACTIONS(161),
    [anon_sym_late] = ACTIONS(163),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [89] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [90] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1936),
    [sym__element] = STATE(1936),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1936),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1936),
    [sym_for_element] = STATE(1936),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [91] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [92] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1869),
    [sym__element] = STATE(1869),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1869),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1869),
    [sym_for_element] = STATE(1869),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1870),
    [sym__element] = STATE(1870),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1870),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1870),
    [sym_for_element] = STATE(1870),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1906),
    [sym__element] = STATE(1906),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1906),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1906),
    [sym_for_element] = STATE(1906),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [95] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1915),
    [sym__element] = STATE(1915),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1915),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1915),
    [sym_for_element] = STATE(1915),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1898),
    [sym__element] = STATE(1898),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1898),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1898),
    [sym_for_element] = STATE(1898),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1975),
    [sym__element] = STATE(1975),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1975),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1975),
    [sym_for_element] = STATE(1975),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [101] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1899),
    [sym__element] = STATE(1899),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1899),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1899),
    [sym_for_element] = STATE(1899),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [102] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [103] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1905),
    [sym__element] = STATE(1905),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1905),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1905),
    [sym_for_element] = STATE(1905),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [104] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(605),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [105] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [106] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1852),
    [sym__element] = STATE(1852),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1852),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1852),
    [sym_for_element] = STATE(1852),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(609),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [107] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [108] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1856),
    [sym__element] = STATE(1856),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1856),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1856),
    [sym_for_element] = STATE(1856),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [109] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [110] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [111] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [112] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [113] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [114] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1808),
    [sym__element] = STATE(1808),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1808),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1808),
    [sym_for_element] = STATE(1808),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [115] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1828),
    [sym__element] = STATE(1828),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1828),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1828),
    [sym_for_element] = STATE(1828),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [116] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [117] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [118] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1956),
    [sym__element] = STATE(1956),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1956),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1956),
    [sym_for_element] = STATE(1956),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [119] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [120] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [121] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [122] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1811),
    [sym__element] = STATE(1811),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1811),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1811),
    [sym_for_element] = STATE(1811),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(645),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [126] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1860),
    [sym__element] = STATE(1860),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1860),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1860),
    [sym_for_element] = STATE(1860),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1958),
    [sym__element] = STATE(1958),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1958),
    [sym_for_element] = STATE(1958),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [129] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [130] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1868),
    [sym__element] = STATE(1868),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1868),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1868),
    [sym_for_element] = STATE(1868),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [131] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1774),
    [sym__element] = STATE(1774),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1774),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1774),
    [sym_for_element] = STATE(1774),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [132] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1744),
    [sym__element] = STATE(1744),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1744),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1744),
    [sym_for_element] = STATE(1744),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [133] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1775),
    [sym__element] = STATE(1775),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1775),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1775),
    [sym_for_element] = STATE(1775),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [134] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1741),
    [sym__element] = STATE(1741),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1741),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1741),
    [sym_for_element] = STATE(1741),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [135] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_pair] = STATE(1892),
    [sym__element] = STATE(1892),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1733),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1733),
    [sym_assignment_expression] = STATE(1733),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_spread_element] = STATE(1892),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_if_element] = STATE(1892),
    [sym_for_element] = STATE(1892),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(149),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [136] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym__argument_list] = STATE(2062),
    [sym_argument] = STATE(1757),
    [sym_named_argument] = STATE(1795),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym_label] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym__argument_list] = STATE(2121),
    [sym_argument] = STATE(1757),
    [sym_named_argument] = STATE(1795),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym_label] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym__argument_list] = STATE(2067),
    [sym_argument] = STATE(1757),
    [sym_named_argument] = STATE(1795),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym_label] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [139] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym__argument_list] = STATE(2123),
    [sym_argument] = STATE(1757),
    [sym_named_argument] = STATE(1795),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym_label] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [140] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1730),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1730),
    [sym_assignment_expression] = STATE(1730),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(155),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [141] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1677),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1677),
    [sym_assignment_expression] = STATE(1677),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(151),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [142] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_argument] = STATE(2016),
    [sym_named_argument] = STATE(1950),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym_label] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [143] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2108),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2108),
    [sym_assignment_expression] = STATE(2108),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(148),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [144] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2094),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2094),
    [sym_assignment_expression] = STATE(2094),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(156),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [145] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2009),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2009),
    [sym_assignment_expression] = STATE(2009),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [sym__semicolon] = STATE(447),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [146] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1830),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1830),
    [sym_assignment_expression] = STATE(1830),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [147] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1764),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1764),
    [sym_assignment_expression] = STATE(1764),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_QMARK] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [148] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1893),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1893),
    [sym_assignment_expression] = STATE(1893),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [149] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1826),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1826),
    [sym_assignment_expression] = STATE(1826),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [150] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1970),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1970),
    [sym_assignment_expression] = STATE(1970),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [151] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1891),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1891),
    [sym_assignment_expression] = STATE(1891),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [152] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1882),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1882),
    [sym_assignment_expression] = STATE(1882),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [153] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2120),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_argument] = STATE(2016),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [154] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2008),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2008),
    [sym_assignment_expression] = STATE(2008),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [anon_sym_STAR] = ACTIONS(681),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [155] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1834),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [156] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1876),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1876),
    [sym_assignment_expression] = STATE(1876),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [157] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(820),
    [sym__real_expression] = STATE(501),
    [sym_throw_expression] = STATE(820),
    [sym_assignment_expression] = STATE(820),
    [sym_assignable_expression] = STATE(1248),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(501),
    [sym_conditional_expression] = STATE(501),
    [sym_logical_or_expression] = STATE(501),
    [sym_logical_and_expression] = STATE(501),
    [sym_equality_expression] = STATE(501),
    [sym_type_cast_expression] = STATE(501),
    [sym_type_test_expression] = STATE(501),
    [sym_relational_expression] = STATE(501),
    [sym_bitwise_or_expression] = STATE(501),
    [sym_bitwise_xor_expression] = STATE(501),
    [sym_bitwise_and_expression] = STATE(501),
    [sym_shift_expression] = STATE(501),
    [sym_additive_expression] = STATE(501),
    [sym_multiplicative_expression] = STATE(501),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [158] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(879),
    [sym__real_expression] = STATE(501),
    [sym_throw_expression] = STATE(879),
    [sym_assignment_expression] = STATE(879),
    [sym_assignable_expression] = STATE(1248),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(501),
    [sym_conditional_expression] = STATE(501),
    [sym_logical_or_expression] = STATE(501),
    [sym_logical_and_expression] = STATE(501),
    [sym_equality_expression] = STATE(501),
    [sym_type_cast_expression] = STATE(501),
    [sym_type_test_expression] = STATE(501),
    [sym_relational_expression] = STATE(501),
    [sym_bitwise_or_expression] = STATE(501),
    [sym_bitwise_xor_expression] = STATE(501),
    [sym_bitwise_and_expression] = STATE(501),
    [sym_shift_expression] = STATE(501),
    [sym_additive_expression] = STATE(501),
    [sym_multiplicative_expression] = STATE(501),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [159] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1148),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(1148),
    [sym_assignment_expression_without_cascade] = STATE(1148),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [160] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1789),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1789),
    [sym_assignment_expression] = STATE(1789),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [161] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2330),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2330),
    [sym_assignment_expression] = STATE(2330),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [162] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2331),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2331),
    [sym_assignment_expression_without_cascade] = STATE(2331),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [163] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2098),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2098),
    [sym_assignment_expression] = STATE(2098),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [164] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2139),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2139),
    [sym_assignment_expression] = STATE(2139),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [165] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2235),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2235),
    [sym_assignment_expression] = STATE(2235),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [166] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2113),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2113),
    [sym_assignment_expression] = STATE(2113),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [167] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2295),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2295),
    [sym_assignment_expression_without_cascade] = STATE(2295),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [168] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2220),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2220),
    [sym_assignment_expression_without_cascade] = STATE(2220),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [169] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1317),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1317),
    [sym_assignment_expression_without_cascade] = STATE(1317),
    [sym_assignable_expression] = STATE(1244),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [170] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1563),
    [sym__real_expression] = STATE(587),
    [sym_throw_expression] = STATE(1563),
    [sym_assignment_expression] = STATE(1563),
    [sym_assignable_expression] = STATE(1255),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(587),
    [sym_conditional_expression] = STATE(587),
    [sym_logical_or_expression] = STATE(587),
    [sym_logical_and_expression] = STATE(587),
    [sym_equality_expression] = STATE(587),
    [sym_type_cast_expression] = STATE(587),
    [sym_type_test_expression] = STATE(587),
    [sym_relational_expression] = STATE(587),
    [sym_bitwise_or_expression] = STATE(587),
    [sym_bitwise_xor_expression] = STATE(587),
    [sym_bitwise_and_expression] = STATE(587),
    [sym_shift_expression] = STATE(587),
    [sym_additive_expression] = STATE(587),
    [sym_multiplicative_expression] = STATE(587),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [171] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1137),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1137),
    [sym_assignment_expression_without_cascade] = STATE(1137),
    [sym_assignable_expression] = STATE(1251),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2229),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2229),
    [sym_assignment_expression] = STATE(2229),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [173] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1151),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1151),
    [sym_assignment_expression_without_cascade] = STATE(1151),
    [sym_assignable_expression] = STATE(1251),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [174] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2192),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2192),
    [sym_assignment_expression] = STATE(2192),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [175] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression] = STATE(849),
    [sym__real_expression] = STATE(458),
    [sym_throw_expression] = STATE(849),
    [sym_assignment_expression] = STATE(849),
    [sym_assignable_expression] = STATE(1266),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(458),
    [sym_conditional_expression] = STATE(458),
    [sym_logical_or_expression] = STATE(458),
    [sym_logical_and_expression] = STATE(458),
    [sym_equality_expression] = STATE(458),
    [sym_type_cast_expression] = STATE(458),
    [sym_type_test_expression] = STATE(458),
    [sym_relational_expression] = STATE(458),
    [sym_bitwise_or_expression] = STATE(458),
    [sym_bitwise_xor_expression] = STATE(458),
    [sym_bitwise_and_expression] = STATE(458),
    [sym_shift_expression] = STATE(458),
    [sym_additive_expression] = STATE(458),
    [sym_multiplicative_expression] = STATE(458),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [176] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2185),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2185),
    [sym_assignment_expression_without_cascade] = STATE(2185),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [177] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2176),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2176),
    [sym_assignment_expression] = STATE(2176),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [178] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1136),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1136),
    [sym_assignment_expression_without_cascade] = STATE(1136),
    [sym_assignable_expression] = STATE(1251),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [179] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(860),
    [sym__real_expression] = STATE(486),
    [sym_throw_expression_without_cascade] = STATE(860),
    [sym_assignment_expression_without_cascade] = STATE(860),
    [sym_assignable_expression] = STATE(1262),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(486),
    [sym_conditional_expression] = STATE(486),
    [sym_logical_or_expression] = STATE(486),
    [sym_logical_and_expression] = STATE(486),
    [sym_equality_expression] = STATE(486),
    [sym_type_cast_expression] = STATE(486),
    [sym_type_test_expression] = STATE(486),
    [sym_relational_expression] = STATE(486),
    [sym_bitwise_or_expression] = STATE(486),
    [sym_bitwise_xor_expression] = STATE(486),
    [sym_bitwise_and_expression] = STATE(486),
    [sym_shift_expression] = STATE(486),
    [sym_additive_expression] = STATE(486),
    [sym_multiplicative_expression] = STATE(486),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [180] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1315),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1315),
    [sym_assignment_expression_without_cascade] = STATE(1315),
    [sym_assignable_expression] = STATE(1244),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [181] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(919),
    [sym__real_expression] = STATE(486),
    [sym_throw_expression_without_cascade] = STATE(919),
    [sym_assignment_expression_without_cascade] = STATE(919),
    [sym_assignable_expression] = STATE(1262),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(486),
    [sym_conditional_expression] = STATE(486),
    [sym_logical_or_expression] = STATE(486),
    [sym_logical_and_expression] = STATE(486),
    [sym_equality_expression] = STATE(486),
    [sym_type_cast_expression] = STATE(486),
    [sym_type_test_expression] = STATE(486),
    [sym_relational_expression] = STATE(486),
    [sym_bitwise_or_expression] = STATE(486),
    [sym_bitwise_xor_expression] = STATE(486),
    [sym_bitwise_and_expression] = STATE(486),
    [sym_shift_expression] = STATE(486),
    [sym_additive_expression] = STATE(486),
    [sym_multiplicative_expression] = STATE(486),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [182] = {
    [sym__literal] = STATE(535),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(1316),
    [sym__real_expression] = STATE(592),
    [sym_throw_expression_without_cascade] = STATE(1316),
    [sym_assignment_expression_without_cascade] = STATE(1316),
    [sym_assignable_expression] = STATE(1244),
    [sym_function_expression] = STATE(535),
    [sym_if_null_expression] = STATE(592),
    [sym_conditional_expression] = STATE(592),
    [sym_logical_or_expression] = STATE(592),
    [sym_logical_and_expression] = STATE(592),
    [sym_equality_expression] = STATE(592),
    [sym_type_cast_expression] = STATE(592),
    [sym_type_test_expression] = STATE(592),
    [sym_relational_expression] = STATE(592),
    [sym_bitwise_or_expression] = STATE(592),
    [sym_bitwise_xor_expression] = STATE(592),
    [sym_bitwise_and_expression] = STATE(592),
    [sym_shift_expression] = STATE(592),
    [sym_additive_expression] = STATE(592),
    [sym_multiplicative_expression] = STATE(592),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(535),
    [sym_const_object_expression] = STATE(535),
    [sym__primary] = STATE(535),
    [sym_constructor_invocation] = STATE(532),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(535),
    [sym_super] = STATE(952),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [183] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1150),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(1150),
    [sym_assignment_expression_without_cascade] = STATE(1150),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [184] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1148),
    [sym__real_expression] = STATE(590),
    [sym_throw_expression_without_cascade] = STATE(1148),
    [sym_assignment_expression_without_cascade] = STATE(1148),
    [sym_assignable_expression] = STATE(1260),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(590),
    [sym_conditional_expression] = STATE(590),
    [sym_logical_or_expression] = STATE(590),
    [sym_logical_and_expression] = STATE(590),
    [sym_equality_expression] = STATE(590),
    [sym_type_cast_expression] = STATE(590),
    [sym_type_test_expression] = STATE(590),
    [sym_relational_expression] = STATE(590),
    [sym_bitwise_or_expression] = STATE(590),
    [sym_bitwise_xor_expression] = STATE(590),
    [sym_bitwise_and_expression] = STATE(590),
    [sym_shift_expression] = STATE(590),
    [sym_additive_expression] = STATE(590),
    [sym_multiplicative_expression] = STATE(590),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [185] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2171),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2171),
    [sym_assignment_expression] = STATE(2171),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [186] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2310),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2310),
    [sym_assignment_expression] = STATE(2310),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [187] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2239),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2239),
    [sym_assignment_expression] = STATE(2239),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [188] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2165),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2165),
    [sym_assignment_expression] = STATE(2165),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [189] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2227),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2227),
    [sym_assignment_expression] = STATE(2227),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [190] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1776),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1776),
    [sym_assignment_expression] = STATE(1776),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [191] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(859),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(859),
    [sym_assignment_expression_without_cascade] = STATE(859),
    [sym_assignable_expression] = STATE(1265),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [192] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2030),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2030),
    [sym_assignment_expression] = STATE(2030),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [193] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(833),
    [sym__real_expression] = STATE(461),
    [sym_throw_expression] = STATE(833),
    [sym_assignment_expression] = STATE(833),
    [sym_assignable_expression] = STATE(1245),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(461),
    [sym_conditional_expression] = STATE(461),
    [sym_logical_or_expression] = STATE(461),
    [sym_logical_and_expression] = STATE(461),
    [sym_equality_expression] = STATE(461),
    [sym_type_cast_expression] = STATE(461),
    [sym_type_test_expression] = STATE(461),
    [sym_relational_expression] = STATE(461),
    [sym_bitwise_or_expression] = STATE(461),
    [sym_bitwise_xor_expression] = STATE(461),
    [sym_bitwise_and_expression] = STATE(461),
    [sym_shift_expression] = STATE(461),
    [sym_additive_expression] = STATE(461),
    [sym_multiplicative_expression] = STATE(461),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [194] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression] = STATE(835),
    [sym__real_expression] = STATE(458),
    [sym_throw_expression] = STATE(835),
    [sym_assignment_expression] = STATE(835),
    [sym_assignable_expression] = STATE(1266),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(458),
    [sym_conditional_expression] = STATE(458),
    [sym_logical_or_expression] = STATE(458),
    [sym_logical_and_expression] = STATE(458),
    [sym_equality_expression] = STATE(458),
    [sym_type_cast_expression] = STATE(458),
    [sym_type_test_expression] = STATE(458),
    [sym_relational_expression] = STATE(458),
    [sym_bitwise_or_expression] = STATE(458),
    [sym_bitwise_xor_expression] = STATE(458),
    [sym_bitwise_and_expression] = STATE(458),
    [sym_shift_expression] = STATE(458),
    [sym_additive_expression] = STATE(458),
    [sym_multiplicative_expression] = STATE(458),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [195] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression] = STATE(832),
    [sym__real_expression] = STATE(458),
    [sym_throw_expression] = STATE(832),
    [sym_assignment_expression] = STATE(832),
    [sym_assignable_expression] = STATE(1266),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(458),
    [sym_conditional_expression] = STATE(458),
    [sym_logical_or_expression] = STATE(458),
    [sym_logical_and_expression] = STATE(458),
    [sym_equality_expression] = STATE(458),
    [sym_type_cast_expression] = STATE(458),
    [sym_type_test_expression] = STATE(458),
    [sym_relational_expression] = STATE(458),
    [sym_bitwise_or_expression] = STATE(458),
    [sym_bitwise_xor_expression] = STATE(458),
    [sym_bitwise_and_expression] = STATE(458),
    [sym_shift_expression] = STATE(458),
    [sym_additive_expression] = STATE(458),
    [sym_multiplicative_expression] = STATE(458),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [196] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2152),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2152),
    [sym_assignment_expression] = STATE(2152),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [197] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2099),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2099),
    [sym_assignment_expression] = STATE(2099),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [198] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2155),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2155),
    [sym_assignment_expression] = STATE(2155),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [199] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1769),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1769),
    [sym_assignment_expression] = STATE(1769),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [200] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(833),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(833),
    [sym_assignment_expression] = STATE(833),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [201] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(820),
    [sym__real_expression] = STATE(461),
    [sym_throw_expression] = STATE(820),
    [sym_assignment_expression] = STATE(820),
    [sym_assignable_expression] = STATE(1245),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(461),
    [sym_conditional_expression] = STATE(461),
    [sym_logical_or_expression] = STATE(461),
    [sym_logical_and_expression] = STATE(461),
    [sym_equality_expression] = STATE(461),
    [sym_type_cast_expression] = STATE(461),
    [sym_type_test_expression] = STATE(461),
    [sym_relational_expression] = STATE(461),
    [sym_bitwise_or_expression] = STATE(461),
    [sym_bitwise_xor_expression] = STATE(461),
    [sym_bitwise_and_expression] = STATE(461),
    [sym_shift_expression] = STATE(461),
    [sym_additive_expression] = STATE(461),
    [sym_multiplicative_expression] = STATE(461),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [202] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1134),
    [sym__real_expression] = STATE(590),
    [sym_throw_expression_without_cascade] = STATE(1134),
    [sym_assignment_expression_without_cascade] = STATE(1134),
    [sym_assignable_expression] = STATE(1260),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(590),
    [sym_conditional_expression] = STATE(590),
    [sym_logical_or_expression] = STATE(590),
    [sym_logical_and_expression] = STATE(590),
    [sym_equality_expression] = STATE(590),
    [sym_type_cast_expression] = STATE(590),
    [sym_type_test_expression] = STATE(590),
    [sym_relational_expression] = STATE(590),
    [sym_bitwise_or_expression] = STATE(590),
    [sym_bitwise_xor_expression] = STATE(590),
    [sym_bitwise_and_expression] = STATE(590),
    [sym_shift_expression] = STATE(590),
    [sym_additive_expression] = STATE(590),
    [sym_multiplicative_expression] = STATE(590),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(865),
    [sym__real_expression] = STATE(590),
    [sym_throw_expression_without_cascade] = STATE(865),
    [sym_assignment_expression_without_cascade] = STATE(865),
    [sym_assignable_expression] = STATE(1260),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(590),
    [sym_conditional_expression] = STATE(590),
    [sym_logical_or_expression] = STATE(590),
    [sym_logical_and_expression] = STATE(590),
    [sym_equality_expression] = STATE(590),
    [sym_type_cast_expression] = STATE(590),
    [sym_type_test_expression] = STATE(590),
    [sym_relational_expression] = STATE(590),
    [sym_bitwise_or_expression] = STATE(590),
    [sym_bitwise_xor_expression] = STATE(590),
    [sym_bitwise_and_expression] = STATE(590),
    [sym_shift_expression] = STATE(590),
    [sym_additive_expression] = STATE(590),
    [sym_multiplicative_expression] = STATE(590),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [204] = {
    [sym__top_level_definition] = STATE(204),
    [sym__annotation] = STATE(987),
    [sym_marker_annotation] = STATE(987),
    [sym_annotation] = STATE(987),
    [sym_enum_declaration] = STATE(204),
    [sym_type_alias] = STATE(204),
    [sym_class_definition] = STATE(204),
    [sym_extension_declaration] = STATE(204),
    [sym__metadata] = STATE(522),
    [sym_mixin_declaration] = STATE(204),
    [sym_getter_signature] = STATE(1455),
    [sym_setter_signature] = STATE(1455),
    [sym__type] = STATE(1566),
    [sym__type_not_function] = STATE(1330),
    [sym__type_not_void_not_function] = STATE(1330),
    [sym_function_type] = STATE(1349),
    [aux_sym__function_type_tails] = STATE(1228),
    [sym__function_type_tail] = STATE(1228),
    [sym__type_name] = STATE(1193),
    [sym_inferred_type] = STATE(1879),
    [sym_function_signature] = STATE(1455),
    [sym__function_builtin_identifier] = STATE(1188),
    [sym__get] = STATE(1560),
    [sym__mixin] = STATE(2169),
    [sym__set] = STATE(1568),
    [sym__typedef] = STATE(1381),
    [sym__late_builtin] = STATE(1328),
    [sym__external_builtin] = STATE(1291),
    [aux_sym_program_repeat4] = STATE(204),
    [aux_sym__metadata_repeat1] = STATE(987),
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_POUND] = ACTIONS(769),
    [sym_decimal_integer_literal] = ACTIONS(774),
    [sym_hex_integer_literal] = ACTIONS(769),
    [sym_decimal_floating_point_literal] = ACTIONS(774),
    [anon_sym_true] = ACTIONS(774),
    [anon_sym_false] = ACTIONS(774),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [anon_sym_SQUOTE] = ACTIONS(774),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(769),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(769),
    [anon_sym_r_DQUOTE] = ACTIONS(774),
    [anon_sym_r_SQUOTE] = ACTIONS(774),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(769),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_null] = ACTIONS(774),
    [anon_sym_throw] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(769),
    [sym_increment_operator] = ACTIONS(769),
    [sym_minus_operator] = ACTIONS(774),
    [sym__exclamation_operator] = ACTIONS(769),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_await] = ACTIONS(774),
    [anon_sym_switch] = ACTIONS(774),
    [anon_sym_do] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(774),
    [anon_sym_continue] = ACTIONS(774),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_try] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_enum] = ACTIONS(779),
    [anon_sym_abstract] = ACTIONS(782),
    [anon_sym_class] = ACTIONS(785),
    [anon_sym_extension] = ACTIONS(788),
    [anon_sym_super] = ACTIONS(774),
    [sym_void_type] = ACTIONS(791),
    [anon_sym_var] = ACTIONS(794),
    [sym__break_builtin] = ACTIONS(774),
    [sym__assert_builtin] = ACTIONS(774),
    [anon_sym_covariant] = ACTIONS(774),
    [anon_sym_Function] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(800),
    [anon_sym_mixin] = ACTIONS(803),
    [anon_sym_set] = ACTIONS(806),
    [anon_sym_typedef] = ACTIONS(809),
    [anon_sym_new] = ACTIONS(774),
    [sym_const_builtin] = ACTIONS(812),
    [sym_final_builtin] = ACTIONS(812),
    [anon_sym_late] = ACTIONS(815),
    [anon_sym_external] = ACTIONS(818),
    [anon_sym_this] = ACTIONS(774),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2150),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2150),
    [sym_assignment_expression] = STATE(2150),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [206] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(929),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(929),
    [sym_assignment_expression_without_cascade] = STATE(929),
    [sym_assignable_expression] = STATE(1265),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [207] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2184),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2184),
    [sym_assignment_expression] = STATE(2184),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [208] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(930),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(930),
    [sym_assignment_expression_without_cascade] = STATE(930),
    [sym_assignable_expression] = STATE(1265),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [209] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2045),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2045),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [210] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2110),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2110),
    [sym_assignment_expression] = STATE(2110),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [211] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1317),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(1317),
    [sym_assignment_expression_without_cascade] = STATE(1317),
    [sym_assignable_expression] = STATE(1247),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [212] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1977),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(1977),
    [sym_assignment_expression] = STATE(1977),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [213] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2080),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2080),
    [sym_assignment_expression] = STATE(2080),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [214] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1134),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(1134),
    [sym_assignment_expression_without_cascade] = STATE(1134),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [215] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2182),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2182),
    [sym_assignment_expression] = STATE(2182),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2225),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2225),
    [sym_assignment_expression] = STATE(2225),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2230),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2230),
    [sym_assignment_expression] = STATE(2230),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(934),
    [sym__real_expression] = STATE(486),
    [sym_throw_expression_without_cascade] = STATE(934),
    [sym_assignment_expression_without_cascade] = STATE(934),
    [sym_assignable_expression] = STATE(1262),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(486),
    [sym_conditional_expression] = STATE(486),
    [sym_logical_or_expression] = STATE(486),
    [sym_logical_and_expression] = STATE(486),
    [sym_equality_expression] = STATE(486),
    [sym_type_cast_expression] = STATE(486),
    [sym_type_test_expression] = STATE(486),
    [sym_relational_expression] = STATE(486),
    [sym_bitwise_or_expression] = STATE(486),
    [sym_bitwise_xor_expression] = STATE(486),
    [sym_bitwise_and_expression] = STATE(486),
    [sym_shift_expression] = STATE(486),
    [sym_additive_expression] = STATE(486),
    [sym_multiplicative_expression] = STATE(486),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(865),
    [sym__real_expression] = STATE(482),
    [sym_throw_expression_without_cascade] = STATE(865),
    [sym_assignment_expression_without_cascade] = STATE(865),
    [sym_assignable_expression] = STATE(1258),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(482),
    [sym_conditional_expression] = STATE(482),
    [sym_logical_or_expression] = STATE(482),
    [sym_logical_and_expression] = STATE(482),
    [sym_equality_expression] = STATE(482),
    [sym_type_cast_expression] = STATE(482),
    [sym_type_test_expression] = STATE(482),
    [sym_relational_expression] = STATE(482),
    [sym_bitwise_or_expression] = STATE(482),
    [sym_bitwise_xor_expression] = STATE(482),
    [sym_bitwise_and_expression] = STATE(482),
    [sym_shift_expression] = STATE(482),
    [sym_additive_expression] = STATE(482),
    [sym_multiplicative_expression] = STATE(482),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(930),
    [sym__real_expression] = STATE(482),
    [sym_throw_expression_without_cascade] = STATE(930),
    [sym_assignment_expression_without_cascade] = STATE(930),
    [sym_assignable_expression] = STATE(1258),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(482),
    [sym_conditional_expression] = STATE(482),
    [sym_logical_or_expression] = STATE(482),
    [sym_logical_and_expression] = STATE(482),
    [sym_equality_expression] = STATE(482),
    [sym_type_cast_expression] = STATE(482),
    [sym_type_test_expression] = STATE(482),
    [sym_relational_expression] = STATE(482),
    [sym_bitwise_or_expression] = STATE(482),
    [sym_bitwise_xor_expression] = STATE(482),
    [sym_bitwise_and_expression] = STATE(482),
    [sym_shift_expression] = STATE(482),
    [sym_additive_expression] = STATE(482),
    [sym_multiplicative_expression] = STATE(482),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(929),
    [sym__real_expression] = STATE(482),
    [sym_throw_expression_without_cascade] = STATE(929),
    [sym_assignment_expression_without_cascade] = STATE(929),
    [sym_assignable_expression] = STATE(1258),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(482),
    [sym_conditional_expression] = STATE(482),
    [sym_logical_or_expression] = STATE(482),
    [sym_logical_and_expression] = STATE(482),
    [sym_equality_expression] = STATE(482),
    [sym_type_cast_expression] = STATE(482),
    [sym_type_test_expression] = STATE(482),
    [sym_relational_expression] = STATE(482),
    [sym_bitwise_or_expression] = STATE(482),
    [sym_bitwise_xor_expression] = STATE(482),
    [sym_bitwise_and_expression] = STATE(482),
    [sym_shift_expression] = STATE(482),
    [sym_additive_expression] = STATE(482),
    [sym_multiplicative_expression] = STATE(482),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2223),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2223),
    [sym_assignment_expression] = STATE(2223),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2275),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2275),
    [sym_assignment_expression] = STATE(2275),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression_without_cascade] = STATE(937),
    [sym__real_expression] = STATE(486),
    [sym_throw_expression_without_cascade] = STATE(937),
    [sym_assignment_expression_without_cascade] = STATE(937),
    [sym_assignable_expression] = STATE(1262),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(486),
    [sym_conditional_expression] = STATE(486),
    [sym_logical_or_expression] = STATE(486),
    [sym_logical_and_expression] = STATE(486),
    [sym_equality_expression] = STATE(486),
    [sym_type_cast_expression] = STATE(486),
    [sym_type_test_expression] = STATE(486),
    [sym_relational_expression] = STATE(486),
    [sym_bitwise_or_expression] = STATE(486),
    [sym_bitwise_xor_expression] = STATE(486),
    [sym_bitwise_and_expression] = STATE(486),
    [sym_shift_expression] = STATE(486),
    [sym_additive_expression] = STATE(486),
    [sym_multiplicative_expression] = STATE(486),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(833),
    [sym__real_expression] = STATE(501),
    [sym_throw_expression] = STATE(833),
    [sym_assignment_expression] = STATE(833),
    [sym_assignable_expression] = STATE(1248),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(501),
    [sym_conditional_expression] = STATE(501),
    [sym_logical_or_expression] = STATE(501),
    [sym_logical_and_expression] = STATE(501),
    [sym_equality_expression] = STATE(501),
    [sym_type_cast_expression] = STATE(501),
    [sym_type_test_expression] = STATE(501),
    [sym_relational_expression] = STATE(501),
    [sym_bitwise_or_expression] = STATE(501),
    [sym_bitwise_xor_expression] = STATE(501),
    [sym_bitwise_and_expression] = STATE(501),
    [sym_shift_expression] = STATE(501),
    [sym_additive_expression] = STATE(501),
    [sym_multiplicative_expression] = STATE(501),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1575),
    [sym__real_expression] = STATE(587),
    [sym_throw_expression] = STATE(1575),
    [sym_assignment_expression] = STATE(1575),
    [sym_assignable_expression] = STATE(1255),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(587),
    [sym_conditional_expression] = STATE(587),
    [sym_logical_or_expression] = STATE(587),
    [sym_logical_and_expression] = STATE(587),
    [sym_equality_expression] = STATE(587),
    [sym_type_cast_expression] = STATE(587),
    [sym_type_test_expression] = STATE(587),
    [sym_relational_expression] = STATE(587),
    [sym_bitwise_or_expression] = STATE(587),
    [sym_bitwise_xor_expression] = STATE(587),
    [sym_bitwise_and_expression] = STATE(587),
    [sym_shift_expression] = STATE(587),
    [sym_additive_expression] = STATE(587),
    [sym_multiplicative_expression] = STATE(587),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [227] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2166),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2166),
    [sym_assignment_expression] = STATE(2166),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [228] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2348),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2348),
    [sym_assignment_expression_without_cascade] = STATE(2348),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [229] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(859),
    [sym__real_expression] = STATE(482),
    [sym_throw_expression_without_cascade] = STATE(859),
    [sym_assignment_expression_without_cascade] = STATE(859),
    [sym_assignable_expression] = STATE(1258),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(482),
    [sym_conditional_expression] = STATE(482),
    [sym_logical_or_expression] = STATE(482),
    [sym_logical_and_expression] = STATE(482),
    [sym_equality_expression] = STATE(482),
    [sym_type_cast_expression] = STATE(482),
    [sym_type_test_expression] = STATE(482),
    [sym_relational_expression] = STATE(482),
    [sym_bitwise_or_expression] = STATE(482),
    [sym_bitwise_xor_expression] = STATE(482),
    [sym_bitwise_and_expression] = STATE(482),
    [sym_shift_expression] = STATE(482),
    [sym_additive_expression] = STATE(482),
    [sym_multiplicative_expression] = STATE(482),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2084),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2084),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [231] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(868),
    [sym__real_expression] = STATE(501),
    [sym_throw_expression] = STATE(868),
    [sym_assignment_expression] = STATE(868),
    [sym_assignable_expression] = STATE(1248),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(501),
    [sym_conditional_expression] = STATE(501),
    [sym_logical_or_expression] = STATE(501),
    [sym_logical_and_expression] = STATE(501),
    [sym_equality_expression] = STATE(501),
    [sym_type_cast_expression] = STATE(501),
    [sym_type_test_expression] = STATE(501),
    [sym_relational_expression] = STATE(501),
    [sym_bitwise_or_expression] = STATE(501),
    [sym_bitwise_xor_expression] = STATE(501),
    [sym_bitwise_and_expression] = STATE(501),
    [sym_shift_expression] = STATE(501),
    [sym_additive_expression] = STATE(501),
    [sym_multiplicative_expression] = STATE(501),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1316),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(1316),
    [sym_assignment_expression_without_cascade] = STATE(1316),
    [sym_assignable_expression] = STATE(1247),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [233] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1315),
    [sym__real_expression] = STATE(624),
    [sym_throw_expression_without_cascade] = STATE(1315),
    [sym_assignment_expression_without_cascade] = STATE(1315),
    [sym_assignable_expression] = STATE(1247),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(624),
    [sym_conditional_expression] = STATE(624),
    [sym_logical_or_expression] = STATE(624),
    [sym_logical_and_expression] = STATE(624),
    [sym_equality_expression] = STATE(624),
    [sym_type_cast_expression] = STATE(624),
    [sym_type_test_expression] = STATE(624),
    [sym_relational_expression] = STATE(624),
    [sym_bitwise_or_expression] = STATE(624),
    [sym_bitwise_xor_expression] = STATE(624),
    [sym_bitwise_and_expression] = STATE(624),
    [sym_shift_expression] = STATE(624),
    [sym_additive_expression] = STATE(624),
    [sym_multiplicative_expression] = STATE(624),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(821),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2167),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2167),
    [sym_assignment_expression] = STATE(2167),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [235] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1541),
    [sym__real_expression] = STATE(587),
    [sym_throw_expression] = STATE(1541),
    [sym_assignment_expression] = STATE(1541),
    [sym_assignable_expression] = STATE(1255),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(587),
    [sym_conditional_expression] = STATE(587),
    [sym_logical_or_expression] = STATE(587),
    [sym_logical_and_expression] = STATE(587),
    [sym_equality_expression] = STATE(587),
    [sym_type_cast_expression] = STATE(587),
    [sym_type_test_expression] = STATE(587),
    [sym_relational_expression] = STATE(587),
    [sym_bitwise_or_expression] = STATE(587),
    [sym_bitwise_xor_expression] = STATE(587),
    [sym_bitwise_and_expression] = STATE(587),
    [sym_shift_expression] = STATE(587),
    [sym_additive_expression] = STATE(587),
    [sym_multiplicative_expression] = STATE(587),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2231),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2231),
    [sym_assignment_expression] = STATE(2231),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2173),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2173),
    [sym_assignment_expression] = STATE(2173),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2048),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2048),
    [sym_assignment_expression] = STATE(2048),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [239] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(868),
    [sym__real_expression] = STATE(461),
    [sym_throw_expression] = STATE(868),
    [sym_assignment_expression] = STATE(868),
    [sym_assignable_expression] = STATE(1245),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(461),
    [sym_conditional_expression] = STATE(461),
    [sym_logical_or_expression] = STATE(461),
    [sym_logical_and_expression] = STATE(461),
    [sym_equality_expression] = STATE(461),
    [sym_type_cast_expression] = STATE(461),
    [sym_type_test_expression] = STATE(461),
    [sym_relational_expression] = STATE(461),
    [sym_bitwise_or_expression] = STATE(461),
    [sym_bitwise_xor_expression] = STATE(461),
    [sym_bitwise_and_expression] = STATE(461),
    [sym_shift_expression] = STATE(461),
    [sym_additive_expression] = STATE(461),
    [sym_multiplicative_expression] = STATE(461),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(868),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(868),
    [sym_assignment_expression] = STATE(868),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(1150),
    [sym__real_expression] = STATE(590),
    [sym_throw_expression_without_cascade] = STATE(1150),
    [sym_assignment_expression_without_cascade] = STATE(1150),
    [sym_assignable_expression] = STATE(1260),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(590),
    [sym_conditional_expression] = STATE(590),
    [sym_logical_or_expression] = STATE(590),
    [sym_logical_and_expression] = STATE(590),
    [sym_equality_expression] = STATE(590),
    [sym_type_cast_expression] = STATE(590),
    [sym_type_test_expression] = STATE(590),
    [sym_relational_expression] = STATE(590),
    [sym_bitwise_or_expression] = STATE(590),
    [sym_bitwise_xor_expression] = STATE(590),
    [sym_bitwise_and_expression] = STATE(590),
    [sym_shift_expression] = STATE(590),
    [sym_additive_expression] = STATE(590),
    [sym_multiplicative_expression] = STATE(590),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2360),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2360),
    [sym_assignment_expression] = STATE(2360),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [243] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression_without_cascade] = STATE(2232),
    [sym__real_expression] = STATE(824),
    [sym_throw_expression_without_cascade] = STATE(2232),
    [sym_assignment_expression_without_cascade] = STATE(2232),
    [sym_assignable_expression] = STATE(1269),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_logical_or_expression] = STATE(824),
    [sym_logical_and_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_type_cast_expression] = STATE(824),
    [sym_type_test_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_bitwise_or_expression] = STATE(824),
    [sym_bitwise_xor_expression] = STATE(824),
    [sym_bitwise_and_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_additive_expression] = STATE(824),
    [sym_multiplicative_expression] = STATE(824),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(944),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [244] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2177),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2177),
    [sym_assignment_expression] = STATE(2177),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [245] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(879),
    [sym__real_expression] = STATE(461),
    [sym_throw_expression] = STATE(879),
    [sym_assignment_expression] = STATE(879),
    [sym_assignable_expression] = STATE(1245),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(461),
    [sym_conditional_expression] = STATE(461),
    [sym_logical_or_expression] = STATE(461),
    [sym_logical_and_expression] = STATE(461),
    [sym_equality_expression] = STATE(461),
    [sym_type_cast_expression] = STATE(461),
    [sym_type_test_expression] = STATE(461),
    [sym_relational_expression] = STATE(461),
    [sym_bitwise_or_expression] = STATE(461),
    [sym_bitwise_xor_expression] = STATE(461),
    [sym_bitwise_and_expression] = STATE(461),
    [sym_shift_expression] = STATE(461),
    [sym_additive_expression] = STATE(461),
    [sym_multiplicative_expression] = STATE(461),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(949),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2219),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2219),
    [sym_assignment_expression] = STATE(2219),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [247] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2073),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2073),
    [sym_assignment_expression] = STATE(2073),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__literal] = STATE(524),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__expression] = STATE(922),
    [sym__real_expression] = STATE(458),
    [sym_throw_expression] = STATE(922),
    [sym_assignment_expression] = STATE(922),
    [sym_assignable_expression] = STATE(1266),
    [sym_function_expression] = STATE(524),
    [sym_if_null_expression] = STATE(458),
    [sym_conditional_expression] = STATE(458),
    [sym_logical_or_expression] = STATE(458),
    [sym_logical_and_expression] = STATE(458),
    [sym_equality_expression] = STATE(458),
    [sym_type_cast_expression] = STATE(458),
    [sym_type_test_expression] = STATE(458),
    [sym_relational_expression] = STATE(458),
    [sym_bitwise_or_expression] = STATE(458),
    [sym_bitwise_xor_expression] = STATE(458),
    [sym_bitwise_and_expression] = STATE(458),
    [sym_shift_expression] = STATE(458),
    [sym_additive_expression] = STATE(458),
    [sym_multiplicative_expression] = STATE(458),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(524),
    [sym_const_object_expression] = STATE(524),
    [sym__primary] = STATE(524),
    [sym_constructor_invocation] = STATE(534),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(524),
    [sym_super] = STATE(963),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [249] = {
    [sym__literal] = STATE(533),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(2047),
    [sym__real_expression] = STATE(558),
    [sym_throw_expression] = STATE(2047),
    [sym_assignment_expression] = STATE(2047),
    [sym_assignable_expression] = STATE(1273),
    [sym_function_expression] = STATE(533),
    [sym_if_null_expression] = STATE(558),
    [sym_conditional_expression] = STATE(558),
    [sym_logical_or_expression] = STATE(558),
    [sym_logical_and_expression] = STATE(558),
    [sym_equality_expression] = STATE(558),
    [sym_type_cast_expression] = STATE(558),
    [sym_type_test_expression] = STATE(558),
    [sym_relational_expression] = STATE(558),
    [sym_bitwise_or_expression] = STATE(558),
    [sym_bitwise_xor_expression] = STATE(558),
    [sym_bitwise_and_expression] = STATE(558),
    [sym_shift_expression] = STATE(558),
    [sym_additive_expression] = STATE(558),
    [sym_multiplicative_expression] = STATE(558),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(533),
    [sym_const_object_expression] = STATE(533),
    [sym__primary] = STATE(533),
    [sym_constructor_invocation] = STATE(527),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(533),
    [sym_super] = STATE(951),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [250] = {
    [sym__literal] = STATE(529),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__expression] = STATE(1555),
    [sym__real_expression] = STATE(587),
    [sym_throw_expression] = STATE(1555),
    [sym_assignment_expression] = STATE(1555),
    [sym_assignable_expression] = STATE(1255),
    [sym_function_expression] = STATE(529),
    [sym_if_null_expression] = STATE(587),
    [sym_conditional_expression] = STATE(587),
    [sym_logical_or_expression] = STATE(587),
    [sym_logical_and_expression] = STATE(587),
    [sym_equality_expression] = STATE(587),
    [sym_type_cast_expression] = STATE(587),
    [sym_type_test_expression] = STATE(587),
    [sym_relational_expression] = STATE(587),
    [sym_bitwise_or_expression] = STATE(587),
    [sym_bitwise_xor_expression] = STATE(587),
    [sym_bitwise_and_expression] = STATE(587),
    [sym_shift_expression] = STATE(587),
    [sym_additive_expression] = STATE(587),
    [sym_multiplicative_expression] = STATE(587),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(529),
    [sym_const_object_expression] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_constructor_invocation] = STATE(530),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(529),
    [sym_super] = STATE(946),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [251] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(626),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(626),
    [sym_conditional_expression] = STATE(626),
    [sym_logical_or_expression] = STATE(626),
    [sym_logical_and_expression] = STATE(626),
    [sym_equality_expression] = STATE(626),
    [sym_type_cast_expression] = STATE(626),
    [sym_type_test_expression] = STATE(626),
    [sym_relational_expression] = STATE(626),
    [sym_bitwise_or_expression] = STATE(626),
    [sym_bitwise_xor_expression] = STATE(626),
    [sym_bitwise_and_expression] = STATE(626),
    [sym_shift_expression] = STATE(626),
    [sym_additive_expression] = STATE(626),
    [sym_multiplicative_expression] = STATE(626),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [252] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(489),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(489),
    [sym_conditional_expression] = STATE(489),
    [sym_logical_or_expression] = STATE(489),
    [sym_logical_and_expression] = STATE(489),
    [sym_equality_expression] = STATE(489),
    [sym_type_cast_expression] = STATE(489),
    [sym_type_test_expression] = STATE(489),
    [sym_relational_expression] = STATE(489),
    [sym_bitwise_or_expression] = STATE(489),
    [sym_bitwise_xor_expression] = STATE(489),
    [sym_bitwise_and_expression] = STATE(489),
    [sym_shift_expression] = STATE(489),
    [sym_additive_expression] = STATE(489),
    [sym_multiplicative_expression] = STATE(489),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [253] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(595),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(595),
    [sym_conditional_expression] = STATE(595),
    [sym_logical_or_expression] = STATE(595),
    [sym_logical_and_expression] = STATE(595),
    [sym_equality_expression] = STATE(595),
    [sym_type_cast_expression] = STATE(595),
    [sym_type_test_expression] = STATE(595),
    [sym_relational_expression] = STATE(595),
    [sym_bitwise_or_expression] = STATE(595),
    [sym_bitwise_xor_expression] = STATE(595),
    [sym_bitwise_and_expression] = STATE(595),
    [sym_shift_expression] = STATE(595),
    [sym_additive_expression] = STATE(595),
    [sym_multiplicative_expression] = STATE(595),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [254] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(599),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(599),
    [sym_conditional_expression] = STATE(599),
    [sym_logical_or_expression] = STATE(599),
    [sym_logical_and_expression] = STATE(599),
    [sym_equality_expression] = STATE(599),
    [sym_type_cast_expression] = STATE(599),
    [sym_type_test_expression] = STATE(599),
    [sym_relational_expression] = STATE(599),
    [sym_bitwise_or_expression] = STATE(599),
    [sym_bitwise_xor_expression] = STATE(599),
    [sym_bitwise_and_expression] = STATE(599),
    [sym_shift_expression] = STATE(599),
    [sym_additive_expression] = STATE(599),
    [sym_multiplicative_expression] = STATE(599),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [255] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(596),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(596),
    [sym_conditional_expression] = STATE(596),
    [sym_logical_or_expression] = STATE(596),
    [sym_logical_and_expression] = STATE(596),
    [sym_equality_expression] = STATE(596),
    [sym_type_cast_expression] = STATE(596),
    [sym_type_test_expression] = STATE(596),
    [sym_relational_expression] = STATE(596),
    [sym_bitwise_or_expression] = STATE(596),
    [sym_bitwise_xor_expression] = STATE(596),
    [sym_bitwise_and_expression] = STATE(596),
    [sym_shift_expression] = STATE(596),
    [sym_additive_expression] = STATE(596),
    [sym_multiplicative_expression] = STATE(596),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [256] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(594),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(594),
    [sym_conditional_expression] = STATE(594),
    [sym_logical_or_expression] = STATE(594),
    [sym_logical_and_expression] = STATE(594),
    [sym_equality_expression] = STATE(594),
    [sym_type_cast_expression] = STATE(594),
    [sym_type_test_expression] = STATE(594),
    [sym_relational_expression] = STATE(594),
    [sym_bitwise_or_expression] = STATE(594),
    [sym_bitwise_xor_expression] = STATE(594),
    [sym_bitwise_and_expression] = STATE(594),
    [sym_shift_expression] = STATE(594),
    [sym_additive_expression] = STATE(594),
    [sym_multiplicative_expression] = STATE(594),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(481),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(481),
    [sym_conditional_expression] = STATE(481),
    [sym_logical_or_expression] = STATE(481),
    [sym_logical_and_expression] = STATE(481),
    [sym_equality_expression] = STATE(481),
    [sym_type_cast_expression] = STATE(481),
    [sym_type_test_expression] = STATE(481),
    [sym_relational_expression] = STATE(481),
    [sym_bitwise_or_expression] = STATE(481),
    [sym_bitwise_xor_expression] = STATE(481),
    [sym_bitwise_and_expression] = STATE(481),
    [sym_shift_expression] = STATE(481),
    [sym_additive_expression] = STATE(481),
    [sym_multiplicative_expression] = STATE(481),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [258] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(480),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(480),
    [sym_conditional_expression] = STATE(480),
    [sym_logical_or_expression] = STATE(480),
    [sym_logical_and_expression] = STATE(480),
    [sym_equality_expression] = STATE(480),
    [sym_type_cast_expression] = STATE(480),
    [sym_type_test_expression] = STATE(480),
    [sym_relational_expression] = STATE(480),
    [sym_bitwise_or_expression] = STATE(480),
    [sym_bitwise_xor_expression] = STATE(480),
    [sym_bitwise_and_expression] = STATE(480),
    [sym_shift_expression] = STATE(480),
    [sym_additive_expression] = STATE(480),
    [sym_multiplicative_expression] = STATE(480),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [259] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(479),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(479),
    [sym_conditional_expression] = STATE(479),
    [sym_logical_or_expression] = STATE(479),
    [sym_logical_and_expression] = STATE(479),
    [sym_equality_expression] = STATE(479),
    [sym_type_cast_expression] = STATE(479),
    [sym_type_test_expression] = STATE(479),
    [sym_relational_expression] = STATE(479),
    [sym_bitwise_or_expression] = STATE(479),
    [sym_bitwise_xor_expression] = STATE(479),
    [sym_bitwise_and_expression] = STATE(479),
    [sym_shift_expression] = STATE(479),
    [sym_additive_expression] = STATE(479),
    [sym_multiplicative_expression] = STATE(479),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(476),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_logical_or_expression] = STATE(476),
    [sym_logical_and_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_type_cast_expression] = STATE(476),
    [sym_type_test_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_bitwise_or_expression] = STATE(476),
    [sym_bitwise_xor_expression] = STATE(476),
    [sym_bitwise_and_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_additive_expression] = STATE(476),
    [sym_multiplicative_expression] = STATE(476),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(475),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_logical_or_expression] = STATE(475),
    [sym_logical_and_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_type_cast_expression] = STATE(475),
    [sym_type_test_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_bitwise_or_expression] = STATE(475),
    [sym_bitwise_xor_expression] = STATE(475),
    [sym_bitwise_and_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_additive_expression] = STATE(475),
    [sym_multiplicative_expression] = STATE(475),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(474),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(474),
    [sym_conditional_expression] = STATE(474),
    [sym_logical_or_expression] = STATE(474),
    [sym_logical_and_expression] = STATE(474),
    [sym_equality_expression] = STATE(474),
    [sym_type_cast_expression] = STATE(474),
    [sym_type_test_expression] = STATE(474),
    [sym_relational_expression] = STATE(474),
    [sym_bitwise_or_expression] = STATE(474),
    [sym_bitwise_xor_expression] = STATE(474),
    [sym_bitwise_and_expression] = STATE(474),
    [sym_shift_expression] = STATE(474),
    [sym_additive_expression] = STATE(474),
    [sym_multiplicative_expression] = STATE(474),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(484),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(484),
    [sym_conditional_expression] = STATE(484),
    [sym_logical_or_expression] = STATE(484),
    [sym_logical_and_expression] = STATE(484),
    [sym_equality_expression] = STATE(484),
    [sym_type_cast_expression] = STATE(484),
    [sym_type_test_expression] = STATE(484),
    [sym_relational_expression] = STATE(484),
    [sym_bitwise_or_expression] = STATE(484),
    [sym_bitwise_xor_expression] = STATE(484),
    [sym_bitwise_and_expression] = STATE(484),
    [sym_shift_expression] = STATE(484),
    [sym_additive_expression] = STATE(484),
    [sym_multiplicative_expression] = STATE(484),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [264] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(478),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(478),
    [sym_conditional_expression] = STATE(478),
    [sym_logical_or_expression] = STATE(478),
    [sym_logical_and_expression] = STATE(478),
    [sym_equality_expression] = STATE(478),
    [sym_type_cast_expression] = STATE(478),
    [sym_type_test_expression] = STATE(478),
    [sym_relational_expression] = STATE(478),
    [sym_bitwise_or_expression] = STATE(478),
    [sym_bitwise_xor_expression] = STATE(478),
    [sym_bitwise_and_expression] = STATE(478),
    [sym_shift_expression] = STATE(478),
    [sym_additive_expression] = STATE(478),
    [sym_multiplicative_expression] = STATE(478),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [265] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(591),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(591),
    [sym_conditional_expression] = STATE(591),
    [sym_logical_or_expression] = STATE(591),
    [sym_logical_and_expression] = STATE(591),
    [sym_equality_expression] = STATE(591),
    [sym_type_cast_expression] = STATE(591),
    [sym_type_test_expression] = STATE(591),
    [sym_relational_expression] = STATE(591),
    [sym_bitwise_or_expression] = STATE(591),
    [sym_bitwise_xor_expression] = STATE(591),
    [sym_bitwise_and_expression] = STATE(591),
    [sym_shift_expression] = STATE(591),
    [sym_additive_expression] = STATE(591),
    [sym_multiplicative_expression] = STATE(591),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(497),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(497),
    [sym_conditional_expression] = STATE(497),
    [sym_logical_or_expression] = STATE(497),
    [sym_logical_and_expression] = STATE(497),
    [sym_equality_expression] = STATE(497),
    [sym_type_cast_expression] = STATE(497),
    [sym_type_test_expression] = STATE(497),
    [sym_relational_expression] = STATE(497),
    [sym_bitwise_or_expression] = STATE(497),
    [sym_bitwise_xor_expression] = STATE(497),
    [sym_bitwise_and_expression] = STATE(497),
    [sym_shift_expression] = STATE(497),
    [sym_additive_expression] = STATE(497),
    [sym_multiplicative_expression] = STATE(497),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [267] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(593),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(593),
    [sym_conditional_expression] = STATE(593),
    [sym_logical_or_expression] = STATE(593),
    [sym_logical_and_expression] = STATE(593),
    [sym_equality_expression] = STATE(593),
    [sym_type_cast_expression] = STATE(593),
    [sym_type_test_expression] = STATE(593),
    [sym_relational_expression] = STATE(593),
    [sym_bitwise_or_expression] = STATE(593),
    [sym_bitwise_xor_expression] = STATE(593),
    [sym_bitwise_and_expression] = STATE(593),
    [sym_shift_expression] = STATE(593),
    [sym_additive_expression] = STATE(593),
    [sym_multiplicative_expression] = STATE(593),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(483),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(483),
    [sym_conditional_expression] = STATE(483),
    [sym_logical_or_expression] = STATE(483),
    [sym_logical_and_expression] = STATE(483),
    [sym_equality_expression] = STATE(483),
    [sym_type_cast_expression] = STATE(483),
    [sym_type_test_expression] = STATE(483),
    [sym_relational_expression] = STATE(483),
    [sym_bitwise_or_expression] = STATE(483),
    [sym_bitwise_xor_expression] = STATE(483),
    [sym_bitwise_and_expression] = STATE(483),
    [sym_shift_expression] = STATE(483),
    [sym_additive_expression] = STATE(483),
    [sym_multiplicative_expression] = STATE(483),
    [sym__unary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__postfix_expression] = STATE(667),
    [sym_postfix_expression] = STATE(667),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(955),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(585),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(585),
    [sym_conditional_expression] = STATE(585),
    [sym_logical_or_expression] = STATE(585),
    [sym_logical_and_expression] = STATE(585),
    [sym_equality_expression] = STATE(585),
    [sym_type_cast_expression] = STATE(585),
    [sym_type_test_expression] = STATE(585),
    [sym_relational_expression] = STATE(585),
    [sym_bitwise_or_expression] = STATE(585),
    [sym_bitwise_xor_expression] = STATE(585),
    [sym_bitwise_and_expression] = STATE(585),
    [sym_shift_expression] = STATE(585),
    [sym_additive_expression] = STATE(585),
    [sym_multiplicative_expression] = STATE(585),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(602),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(602),
    [sym_conditional_expression] = STATE(602),
    [sym_logical_or_expression] = STATE(602),
    [sym_logical_and_expression] = STATE(602),
    [sym_equality_expression] = STATE(602),
    [sym_type_cast_expression] = STATE(602),
    [sym_type_test_expression] = STATE(602),
    [sym_relational_expression] = STATE(602),
    [sym_bitwise_or_expression] = STATE(602),
    [sym_bitwise_xor_expression] = STATE(602),
    [sym_bitwise_and_expression] = STATE(602),
    [sym_shift_expression] = STATE(602),
    [sym_additive_expression] = STATE(602),
    [sym_multiplicative_expression] = STATE(602),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(604),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(604),
    [sym_conditional_expression] = STATE(604),
    [sym_logical_or_expression] = STATE(604),
    [sym_logical_and_expression] = STATE(604),
    [sym_equality_expression] = STATE(604),
    [sym_type_cast_expression] = STATE(604),
    [sym_type_test_expression] = STATE(604),
    [sym_relational_expression] = STATE(604),
    [sym_bitwise_or_expression] = STATE(604),
    [sym_bitwise_xor_expression] = STATE(604),
    [sym_bitwise_and_expression] = STATE(604),
    [sym_shift_expression] = STATE(604),
    [sym_additive_expression] = STATE(604),
    [sym_multiplicative_expression] = STATE(604),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [272] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(589),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(589),
    [sym_conditional_expression] = STATE(589),
    [sym_logical_or_expression] = STATE(589),
    [sym_logical_and_expression] = STATE(589),
    [sym_equality_expression] = STATE(589),
    [sym_type_cast_expression] = STATE(589),
    [sym_type_test_expression] = STATE(589),
    [sym_relational_expression] = STATE(589),
    [sym_bitwise_or_expression] = STATE(589),
    [sym_bitwise_xor_expression] = STATE(589),
    [sym_bitwise_and_expression] = STATE(589),
    [sym_shift_expression] = STATE(589),
    [sym_additive_expression] = STATE(589),
    [sym_multiplicative_expression] = STATE(589),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [273] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(579),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(579),
    [sym_conditional_expression] = STATE(579),
    [sym_logical_or_expression] = STATE(579),
    [sym_logical_and_expression] = STATE(579),
    [sym_equality_expression] = STATE(579),
    [sym_type_cast_expression] = STATE(579),
    [sym_type_test_expression] = STATE(579),
    [sym_relational_expression] = STATE(579),
    [sym_bitwise_or_expression] = STATE(579),
    [sym_bitwise_xor_expression] = STATE(579),
    [sym_bitwise_and_expression] = STATE(579),
    [sym_shift_expression] = STATE(579),
    [sym_additive_expression] = STATE(579),
    [sym_multiplicative_expression] = STATE(579),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [274] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(584),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(584),
    [sym_conditional_expression] = STATE(584),
    [sym_logical_or_expression] = STATE(584),
    [sym_logical_and_expression] = STATE(584),
    [sym_equality_expression] = STATE(584),
    [sym_type_cast_expression] = STATE(584),
    [sym_type_test_expression] = STATE(584),
    [sym_relational_expression] = STATE(584),
    [sym_bitwise_or_expression] = STATE(584),
    [sym_bitwise_xor_expression] = STATE(584),
    [sym_bitwise_and_expression] = STATE(584),
    [sym_shift_expression] = STATE(584),
    [sym_additive_expression] = STATE(584),
    [sym_multiplicative_expression] = STATE(584),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [275] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(588),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(588),
    [sym_conditional_expression] = STATE(588),
    [sym_logical_or_expression] = STATE(588),
    [sym_logical_and_expression] = STATE(588),
    [sym_equality_expression] = STATE(588),
    [sym_type_cast_expression] = STATE(588),
    [sym_type_test_expression] = STATE(588),
    [sym_relational_expression] = STATE(588),
    [sym_bitwise_or_expression] = STATE(588),
    [sym_bitwise_xor_expression] = STATE(588),
    [sym_bitwise_and_expression] = STATE(588),
    [sym_shift_expression] = STATE(588),
    [sym_additive_expression] = STATE(588),
    [sym_multiplicative_expression] = STATE(588),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [276] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(601),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(601),
    [sym_conditional_expression] = STATE(601),
    [sym_logical_or_expression] = STATE(601),
    [sym_logical_and_expression] = STATE(601),
    [sym_equality_expression] = STATE(601),
    [sym_type_cast_expression] = STATE(601),
    [sym_type_test_expression] = STATE(601),
    [sym_relational_expression] = STATE(601),
    [sym_bitwise_or_expression] = STATE(601),
    [sym_bitwise_xor_expression] = STATE(601),
    [sym_bitwise_and_expression] = STATE(601),
    [sym_shift_expression] = STATE(601),
    [sym_additive_expression] = STATE(601),
    [sym_multiplicative_expression] = STATE(601),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(899),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(899),
    [sym_conditional_expression] = STATE(899),
    [sym_logical_or_expression] = STATE(899),
    [sym_logical_and_expression] = STATE(899),
    [sym_equality_expression] = STATE(899),
    [sym_type_cast_expression] = STATE(899),
    [sym_type_test_expression] = STATE(899),
    [sym_relational_expression] = STATE(899),
    [sym_bitwise_or_expression] = STATE(899),
    [sym_bitwise_xor_expression] = STATE(899),
    [sym_bitwise_and_expression] = STATE(899),
    [sym_shift_expression] = STATE(899),
    [sym_additive_expression] = STATE(899),
    [sym_multiplicative_expression] = STATE(899),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [278] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(581),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(581),
    [sym_conditional_expression] = STATE(581),
    [sym_logical_or_expression] = STATE(581),
    [sym_logical_and_expression] = STATE(581),
    [sym_equality_expression] = STATE(581),
    [sym_type_cast_expression] = STATE(581),
    [sym_type_test_expression] = STATE(581),
    [sym_relational_expression] = STATE(581),
    [sym_bitwise_or_expression] = STATE(581),
    [sym_bitwise_xor_expression] = STATE(581),
    [sym_bitwise_and_expression] = STATE(581),
    [sym_shift_expression] = STATE(581),
    [sym_additive_expression] = STATE(581),
    [sym_multiplicative_expression] = STATE(581),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(561),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(561),
    [sym_conditional_expression] = STATE(561),
    [sym_logical_or_expression] = STATE(561),
    [sym_logical_and_expression] = STATE(561),
    [sym_equality_expression] = STATE(561),
    [sym_type_cast_expression] = STATE(561),
    [sym_type_test_expression] = STATE(561),
    [sym_relational_expression] = STATE(561),
    [sym_bitwise_or_expression] = STATE(561),
    [sym_bitwise_xor_expression] = STATE(561),
    [sym_bitwise_and_expression] = STATE(561),
    [sym_shift_expression] = STATE(561),
    [sym_additive_expression] = STATE(561),
    [sym_multiplicative_expression] = STATE(561),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [280] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(562),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(562),
    [sym_conditional_expression] = STATE(562),
    [sym_logical_or_expression] = STATE(562),
    [sym_logical_and_expression] = STATE(562),
    [sym_equality_expression] = STATE(562),
    [sym_type_cast_expression] = STATE(562),
    [sym_type_test_expression] = STATE(562),
    [sym_relational_expression] = STATE(562),
    [sym_bitwise_or_expression] = STATE(562),
    [sym_bitwise_xor_expression] = STATE(562),
    [sym_bitwise_and_expression] = STATE(562),
    [sym_shift_expression] = STATE(562),
    [sym_additive_expression] = STATE(562),
    [sym_multiplicative_expression] = STATE(562),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [281] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(606),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(606),
    [sym_conditional_expression] = STATE(606),
    [sym_logical_or_expression] = STATE(606),
    [sym_logical_and_expression] = STATE(606),
    [sym_equality_expression] = STATE(606),
    [sym_type_cast_expression] = STATE(606),
    [sym_type_test_expression] = STATE(606),
    [sym_relational_expression] = STATE(606),
    [sym_bitwise_or_expression] = STATE(606),
    [sym_bitwise_xor_expression] = STATE(606),
    [sym_bitwise_and_expression] = STATE(606),
    [sym_shift_expression] = STATE(606),
    [sym_additive_expression] = STATE(606),
    [sym_multiplicative_expression] = STATE(606),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [282] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(586),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(586),
    [sym_conditional_expression] = STATE(586),
    [sym_logical_or_expression] = STATE(586),
    [sym_logical_and_expression] = STATE(586),
    [sym_equality_expression] = STATE(586),
    [sym_type_cast_expression] = STATE(586),
    [sym_type_test_expression] = STATE(586),
    [sym_relational_expression] = STATE(586),
    [sym_bitwise_or_expression] = STATE(586),
    [sym_bitwise_xor_expression] = STATE(586),
    [sym_bitwise_and_expression] = STATE(586),
    [sym_shift_expression] = STATE(586),
    [sym_additive_expression] = STATE(586),
    [sym_multiplicative_expression] = STATE(586),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [283] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(582),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(582),
    [sym_conditional_expression] = STATE(582),
    [sym_logical_or_expression] = STATE(582),
    [sym_logical_and_expression] = STATE(582),
    [sym_equality_expression] = STATE(582),
    [sym_type_cast_expression] = STATE(582),
    [sym_type_test_expression] = STATE(582),
    [sym_relational_expression] = STATE(582),
    [sym_bitwise_or_expression] = STATE(582),
    [sym_bitwise_xor_expression] = STATE(582),
    [sym_bitwise_and_expression] = STATE(582),
    [sym_shift_expression] = STATE(582),
    [sym_additive_expression] = STATE(582),
    [sym_multiplicative_expression] = STATE(582),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [284] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(900),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(900),
    [sym_conditional_expression] = STATE(900),
    [sym_logical_or_expression] = STATE(900),
    [sym_logical_and_expression] = STATE(900),
    [sym_equality_expression] = STATE(900),
    [sym_type_cast_expression] = STATE(900),
    [sym_type_test_expression] = STATE(900),
    [sym_relational_expression] = STATE(900),
    [sym_bitwise_or_expression] = STATE(900),
    [sym_bitwise_xor_expression] = STATE(900),
    [sym_bitwise_and_expression] = STATE(900),
    [sym_shift_expression] = STATE(900),
    [sym_additive_expression] = STATE(900),
    [sym_multiplicative_expression] = STATE(900),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [285] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(605),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym_if_null_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_logical_or_expression] = STATE(605),
    [sym_logical_and_expression] = STATE(605),
    [sym_equality_expression] = STATE(605),
    [sym_type_cast_expression] = STATE(605),
    [sym_type_test_expression] = STATE(605),
    [sym_relational_expression] = STATE(605),
    [sym_bitwise_or_expression] = STATE(605),
    [sym_bitwise_xor_expression] = STATE(605),
    [sym_bitwise_and_expression] = STATE(605),
    [sym_shift_expression] = STATE(605),
    [sym_additive_expression] = STATE(605),
    [sym_multiplicative_expression] = STATE(605),
    [sym__unary_expression] = STATE(947),
    [sym_unary_expression] = STATE(947),
    [sym__postfix_expression] = STATE(947),
    [sym_postfix_expression] = STATE(947),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(948),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [286] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(485),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(485),
    [sym_conditional_expression] = STATE(485),
    [sym_logical_or_expression] = STATE(485),
    [sym_logical_and_expression] = STATE(485),
    [sym_equality_expression] = STATE(485),
    [sym_type_cast_expression] = STATE(485),
    [sym_type_test_expression] = STATE(485),
    [sym_relational_expression] = STATE(485),
    [sym_bitwise_or_expression] = STATE(485),
    [sym_bitwise_xor_expression] = STATE(485),
    [sym_bitwise_and_expression] = STATE(485),
    [sym_shift_expression] = STATE(485),
    [sym_additive_expression] = STATE(485),
    [sym_multiplicative_expression] = STATE(485),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [287] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(487),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(487),
    [sym_conditional_expression] = STATE(487),
    [sym_logical_or_expression] = STATE(487),
    [sym_logical_and_expression] = STATE(487),
    [sym_equality_expression] = STATE(487),
    [sym_type_cast_expression] = STATE(487),
    [sym_type_test_expression] = STATE(487),
    [sym_relational_expression] = STATE(487),
    [sym_bitwise_or_expression] = STATE(487),
    [sym_bitwise_xor_expression] = STATE(487),
    [sym_bitwise_and_expression] = STATE(487),
    [sym_shift_expression] = STATE(487),
    [sym_additive_expression] = STATE(487),
    [sym_multiplicative_expression] = STATE(487),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(583),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(583),
    [sym_conditional_expression] = STATE(583),
    [sym_logical_or_expression] = STATE(583),
    [sym_logical_and_expression] = STATE(583),
    [sym_equality_expression] = STATE(583),
    [sym_type_cast_expression] = STATE(583),
    [sym_type_test_expression] = STATE(583),
    [sym_relational_expression] = STATE(583),
    [sym_bitwise_or_expression] = STATE(583),
    [sym_bitwise_xor_expression] = STATE(583),
    [sym_bitwise_and_expression] = STATE(583),
    [sym_shift_expression] = STATE(583),
    [sym_additive_expression] = STATE(583),
    [sym_multiplicative_expression] = STATE(583),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [289] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(490),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(490),
    [sym_conditional_expression] = STATE(490),
    [sym_logical_or_expression] = STATE(490),
    [sym_logical_and_expression] = STATE(490),
    [sym_equality_expression] = STATE(490),
    [sym_type_cast_expression] = STATE(490),
    [sym_type_test_expression] = STATE(490),
    [sym_relational_expression] = STATE(490),
    [sym_bitwise_or_expression] = STATE(490),
    [sym_bitwise_xor_expression] = STATE(490),
    [sym_bitwise_and_expression] = STATE(490),
    [sym_shift_expression] = STATE(490),
    [sym_additive_expression] = STATE(490),
    [sym_multiplicative_expression] = STATE(490),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [290] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(491),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(491),
    [sym_conditional_expression] = STATE(491),
    [sym_logical_or_expression] = STATE(491),
    [sym_logical_and_expression] = STATE(491),
    [sym_equality_expression] = STATE(491),
    [sym_type_cast_expression] = STATE(491),
    [sym_type_test_expression] = STATE(491),
    [sym_relational_expression] = STATE(491),
    [sym_bitwise_or_expression] = STATE(491),
    [sym_bitwise_xor_expression] = STATE(491),
    [sym_bitwise_and_expression] = STATE(491),
    [sym_shift_expression] = STATE(491),
    [sym_additive_expression] = STATE(491),
    [sym_multiplicative_expression] = STATE(491),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(472),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(472),
    [sym_conditional_expression] = STATE(472),
    [sym_logical_or_expression] = STATE(472),
    [sym_logical_and_expression] = STATE(472),
    [sym_equality_expression] = STATE(472),
    [sym_type_cast_expression] = STATE(472),
    [sym_type_test_expression] = STATE(472),
    [sym_relational_expression] = STATE(472),
    [sym_bitwise_or_expression] = STATE(472),
    [sym_bitwise_xor_expression] = STATE(472),
    [sym_bitwise_and_expression] = STATE(472),
    [sym_shift_expression] = STATE(472),
    [sym_additive_expression] = STATE(472),
    [sym_multiplicative_expression] = STATE(472),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(492),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_logical_or_expression] = STATE(492),
    [sym_logical_and_expression] = STATE(492),
    [sym_equality_expression] = STATE(492),
    [sym_type_cast_expression] = STATE(492),
    [sym_type_test_expression] = STATE(492),
    [sym_relational_expression] = STATE(492),
    [sym_bitwise_or_expression] = STATE(492),
    [sym_bitwise_xor_expression] = STATE(492),
    [sym_bitwise_and_expression] = STATE(492),
    [sym_shift_expression] = STATE(492),
    [sym_additive_expression] = STATE(492),
    [sym_multiplicative_expression] = STATE(492),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [293] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(902),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(902),
    [sym_conditional_expression] = STATE(902),
    [sym_logical_or_expression] = STATE(902),
    [sym_logical_and_expression] = STATE(902),
    [sym_equality_expression] = STATE(902),
    [sym_type_cast_expression] = STATE(902),
    [sym_type_test_expression] = STATE(902),
    [sym_relational_expression] = STATE(902),
    [sym_bitwise_or_expression] = STATE(902),
    [sym_bitwise_xor_expression] = STATE(902),
    [sym_bitwise_and_expression] = STATE(902),
    [sym_shift_expression] = STATE(902),
    [sym_additive_expression] = STATE(902),
    [sym_multiplicative_expression] = STATE(902),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [294] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(903),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(903),
    [sym_conditional_expression] = STATE(903),
    [sym_logical_or_expression] = STATE(903),
    [sym_logical_and_expression] = STATE(903),
    [sym_equality_expression] = STATE(903),
    [sym_type_cast_expression] = STATE(903),
    [sym_type_test_expression] = STATE(903),
    [sym_relational_expression] = STATE(903),
    [sym_bitwise_or_expression] = STATE(903),
    [sym_bitwise_xor_expression] = STATE(903),
    [sym_bitwise_and_expression] = STATE(903),
    [sym_shift_expression] = STATE(903),
    [sym_additive_expression] = STATE(903),
    [sym_multiplicative_expression] = STATE(903),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [295] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(494),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(494),
    [sym_conditional_expression] = STATE(494),
    [sym_logical_or_expression] = STATE(494),
    [sym_logical_and_expression] = STATE(494),
    [sym_equality_expression] = STATE(494),
    [sym_type_cast_expression] = STATE(494),
    [sym_type_test_expression] = STATE(494),
    [sym_relational_expression] = STATE(494),
    [sym_bitwise_or_expression] = STATE(494),
    [sym_bitwise_xor_expression] = STATE(494),
    [sym_bitwise_and_expression] = STATE(494),
    [sym_shift_expression] = STATE(494),
    [sym_additive_expression] = STATE(494),
    [sym_multiplicative_expression] = STATE(494),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [296] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(495),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(495),
    [sym_conditional_expression] = STATE(495),
    [sym_logical_or_expression] = STATE(495),
    [sym_logical_and_expression] = STATE(495),
    [sym_equality_expression] = STATE(495),
    [sym_type_cast_expression] = STATE(495),
    [sym_type_test_expression] = STATE(495),
    [sym_relational_expression] = STATE(495),
    [sym_bitwise_or_expression] = STATE(495),
    [sym_bitwise_xor_expression] = STATE(495),
    [sym_bitwise_and_expression] = STATE(495),
    [sym_shift_expression] = STATE(495),
    [sym_additive_expression] = STATE(495),
    [sym_multiplicative_expression] = STATE(495),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [297] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym__real_expression] = STATE(496),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym_if_null_expression] = STATE(496),
    [sym_conditional_expression] = STATE(496),
    [sym_logical_or_expression] = STATE(496),
    [sym_logical_and_expression] = STATE(496),
    [sym_equality_expression] = STATE(496),
    [sym_type_cast_expression] = STATE(496),
    [sym_type_test_expression] = STATE(496),
    [sym_relational_expression] = STATE(496),
    [sym_bitwise_or_expression] = STATE(496),
    [sym_bitwise_xor_expression] = STATE(496),
    [sym_bitwise_and_expression] = STATE(496),
    [sym_shift_expression] = STATE(496),
    [sym_additive_expression] = STATE(496),
    [sym_multiplicative_expression] = STATE(496),
    [sym__unary_expression] = STATE(665),
    [sym_unary_expression] = STATE(665),
    [sym__postfix_expression] = STATE(665),
    [sym_postfix_expression] = STATE(665),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(953),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [298] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(904),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(904),
    [sym_conditional_expression] = STATE(904),
    [sym_logical_or_expression] = STATE(904),
    [sym_logical_and_expression] = STATE(904),
    [sym_equality_expression] = STATE(904),
    [sym_type_cast_expression] = STATE(904),
    [sym_type_test_expression] = STATE(904),
    [sym_relational_expression] = STATE(904),
    [sym_bitwise_or_expression] = STATE(904),
    [sym_bitwise_xor_expression] = STATE(904),
    [sym_bitwise_and_expression] = STATE(904),
    [sym_shift_expression] = STATE(904),
    [sym_additive_expression] = STATE(904),
    [sym_multiplicative_expression] = STATE(904),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [299] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(906),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(906),
    [sym_conditional_expression] = STATE(906),
    [sym_logical_or_expression] = STATE(906),
    [sym_logical_and_expression] = STATE(906),
    [sym_equality_expression] = STATE(906),
    [sym_type_cast_expression] = STATE(906),
    [sym_type_test_expression] = STATE(906),
    [sym_relational_expression] = STATE(906),
    [sym_bitwise_or_expression] = STATE(906),
    [sym_bitwise_xor_expression] = STATE(906),
    [sym_bitwise_and_expression] = STATE(906),
    [sym_shift_expression] = STATE(906),
    [sym_additive_expression] = STATE(906),
    [sym_multiplicative_expression] = STATE(906),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [300] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(641),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(641),
    [sym_conditional_expression] = STATE(641),
    [sym_logical_or_expression] = STATE(641),
    [sym_logical_and_expression] = STATE(641),
    [sym_equality_expression] = STATE(641),
    [sym_type_cast_expression] = STATE(641),
    [sym_type_test_expression] = STATE(641),
    [sym_relational_expression] = STATE(641),
    [sym_bitwise_or_expression] = STATE(641),
    [sym_bitwise_xor_expression] = STATE(641),
    [sym_bitwise_and_expression] = STATE(641),
    [sym_shift_expression] = STATE(641),
    [sym_additive_expression] = STATE(641),
    [sym_multiplicative_expression] = STATE(641),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [301] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(889),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(889),
    [sym_conditional_expression] = STATE(889),
    [sym_logical_or_expression] = STATE(889),
    [sym_logical_and_expression] = STATE(889),
    [sym_equality_expression] = STATE(889),
    [sym_type_cast_expression] = STATE(889),
    [sym_type_test_expression] = STATE(889),
    [sym_relational_expression] = STATE(889),
    [sym_bitwise_or_expression] = STATE(889),
    [sym_bitwise_xor_expression] = STATE(889),
    [sym_bitwise_and_expression] = STATE(889),
    [sym_shift_expression] = STATE(889),
    [sym_additive_expression] = STATE(889),
    [sym_multiplicative_expression] = STATE(889),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [302] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(892),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(892),
    [sym_conditional_expression] = STATE(892),
    [sym_logical_or_expression] = STATE(892),
    [sym_logical_and_expression] = STATE(892),
    [sym_equality_expression] = STATE(892),
    [sym_type_cast_expression] = STATE(892),
    [sym_type_test_expression] = STATE(892),
    [sym_relational_expression] = STATE(892),
    [sym_bitwise_or_expression] = STATE(892),
    [sym_bitwise_xor_expression] = STATE(892),
    [sym_bitwise_and_expression] = STATE(892),
    [sym_shift_expression] = STATE(892),
    [sym_additive_expression] = STATE(892),
    [sym_multiplicative_expression] = STATE(892),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [303] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(893),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(893),
    [sym_conditional_expression] = STATE(893),
    [sym_logical_or_expression] = STATE(893),
    [sym_logical_and_expression] = STATE(893),
    [sym_equality_expression] = STATE(893),
    [sym_type_cast_expression] = STATE(893),
    [sym_type_test_expression] = STATE(893),
    [sym_relational_expression] = STATE(893),
    [sym_bitwise_or_expression] = STATE(893),
    [sym_bitwise_xor_expression] = STATE(893),
    [sym_bitwise_and_expression] = STATE(893),
    [sym_shift_expression] = STATE(893),
    [sym_additive_expression] = STATE(893),
    [sym_multiplicative_expression] = STATE(893),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [304] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(897),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(897),
    [sym_conditional_expression] = STATE(897),
    [sym_logical_or_expression] = STATE(897),
    [sym_logical_and_expression] = STATE(897),
    [sym_equality_expression] = STATE(897),
    [sym_type_cast_expression] = STATE(897),
    [sym_type_test_expression] = STATE(897),
    [sym_relational_expression] = STATE(897),
    [sym_bitwise_or_expression] = STATE(897),
    [sym_bitwise_xor_expression] = STATE(897),
    [sym_bitwise_and_expression] = STATE(897),
    [sym_shift_expression] = STATE(897),
    [sym_additive_expression] = STATE(897),
    [sym_multiplicative_expression] = STATE(897),
    [sym__unary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym__postfix_expression] = STATE(1147),
    [sym_postfix_expression] = STATE(1147),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(962),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [305] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(620),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(620),
    [sym_conditional_expression] = STATE(620),
    [sym_logical_or_expression] = STATE(620),
    [sym_logical_and_expression] = STATE(620),
    [sym_equality_expression] = STATE(620),
    [sym_type_cast_expression] = STATE(620),
    [sym_type_test_expression] = STATE(620),
    [sym_relational_expression] = STATE(620),
    [sym_bitwise_or_expression] = STATE(620),
    [sym_bitwise_xor_expression] = STATE(620),
    [sym_bitwise_and_expression] = STATE(620),
    [sym_shift_expression] = STATE(620),
    [sym_additive_expression] = STATE(620),
    [sym_multiplicative_expression] = STATE(620),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [306] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(619),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(619),
    [sym_conditional_expression] = STATE(619),
    [sym_logical_or_expression] = STATE(619),
    [sym_logical_and_expression] = STATE(619),
    [sym_equality_expression] = STATE(619),
    [sym_type_cast_expression] = STATE(619),
    [sym_type_test_expression] = STATE(619),
    [sym_relational_expression] = STATE(619),
    [sym_bitwise_or_expression] = STATE(619),
    [sym_bitwise_xor_expression] = STATE(619),
    [sym_bitwise_and_expression] = STATE(619),
    [sym_shift_expression] = STATE(619),
    [sym_additive_expression] = STATE(619),
    [sym_multiplicative_expression] = STATE(619),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [307] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(621),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(621),
    [sym_conditional_expression] = STATE(621),
    [sym_logical_or_expression] = STATE(621),
    [sym_logical_and_expression] = STATE(621),
    [sym_equality_expression] = STATE(621),
    [sym_type_cast_expression] = STATE(621),
    [sym_type_test_expression] = STATE(621),
    [sym_relational_expression] = STATE(621),
    [sym_bitwise_or_expression] = STATE(621),
    [sym_bitwise_xor_expression] = STATE(621),
    [sym_bitwise_and_expression] = STATE(621),
    [sym_shift_expression] = STATE(621),
    [sym_additive_expression] = STATE(621),
    [sym_multiplicative_expression] = STATE(621),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [308] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(636),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym_if_null_expression] = STATE(636),
    [sym_conditional_expression] = STATE(636),
    [sym_logical_or_expression] = STATE(636),
    [sym_logical_and_expression] = STATE(636),
    [sym_equality_expression] = STATE(636),
    [sym_type_cast_expression] = STATE(636),
    [sym_type_test_expression] = STATE(636),
    [sym_relational_expression] = STATE(636),
    [sym_bitwise_or_expression] = STATE(636),
    [sym_bitwise_xor_expression] = STATE(636),
    [sym_bitwise_and_expression] = STATE(636),
    [sym_shift_expression] = STATE(636),
    [sym_additive_expression] = STATE(636),
    [sym_multiplicative_expression] = STATE(636),
    [sym__unary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym__postfix_expression] = STATE(958),
    [sym_postfix_expression] = STATE(958),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(956),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [309] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(622),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(622),
    [sym_conditional_expression] = STATE(622),
    [sym_logical_or_expression] = STATE(622),
    [sym_logical_and_expression] = STATE(622),
    [sym_equality_expression] = STATE(622),
    [sym_type_cast_expression] = STATE(622),
    [sym_type_test_expression] = STATE(622),
    [sym_relational_expression] = STATE(622),
    [sym_bitwise_or_expression] = STATE(622),
    [sym_bitwise_xor_expression] = STATE(622),
    [sym_bitwise_and_expression] = STATE(622),
    [sym_shift_expression] = STATE(622),
    [sym_additive_expression] = STATE(622),
    [sym_multiplicative_expression] = STATE(622),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [310] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(634),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(634),
    [sym_conditional_expression] = STATE(634),
    [sym_logical_or_expression] = STATE(634),
    [sym_logical_and_expression] = STATE(634),
    [sym_equality_expression] = STATE(634),
    [sym_type_cast_expression] = STATE(634),
    [sym_type_test_expression] = STATE(634),
    [sym_relational_expression] = STATE(634),
    [sym_bitwise_or_expression] = STATE(634),
    [sym_bitwise_xor_expression] = STATE(634),
    [sym_bitwise_and_expression] = STATE(634),
    [sym_shift_expression] = STATE(634),
    [sym_additive_expression] = STATE(634),
    [sym_multiplicative_expression] = STATE(634),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [311] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(632),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(632),
    [sym_conditional_expression] = STATE(632),
    [sym_logical_or_expression] = STATE(632),
    [sym_logical_and_expression] = STATE(632),
    [sym_equality_expression] = STATE(632),
    [sym_type_cast_expression] = STATE(632),
    [sym_type_test_expression] = STATE(632),
    [sym_relational_expression] = STATE(632),
    [sym_bitwise_or_expression] = STATE(632),
    [sym_bitwise_xor_expression] = STATE(632),
    [sym_bitwise_and_expression] = STATE(632),
    [sym_shift_expression] = STATE(632),
    [sym_additive_expression] = STATE(632),
    [sym_multiplicative_expression] = STATE(632),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [312] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(633),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(633),
    [sym_conditional_expression] = STATE(633),
    [sym_logical_or_expression] = STATE(633),
    [sym_logical_and_expression] = STATE(633),
    [sym_equality_expression] = STATE(633),
    [sym_type_cast_expression] = STATE(633),
    [sym_type_test_expression] = STATE(633),
    [sym_relational_expression] = STATE(633),
    [sym_bitwise_or_expression] = STATE(633),
    [sym_bitwise_xor_expression] = STATE(633),
    [sym_bitwise_and_expression] = STATE(633),
    [sym_shift_expression] = STATE(633),
    [sym_additive_expression] = STATE(633),
    [sym_multiplicative_expression] = STATE(633),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [313] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(623),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(623),
    [sym_conditional_expression] = STATE(623),
    [sym_logical_or_expression] = STATE(623),
    [sym_logical_and_expression] = STATE(623),
    [sym_equality_expression] = STATE(623),
    [sym_type_cast_expression] = STATE(623),
    [sym_type_test_expression] = STATE(623),
    [sym_relational_expression] = STATE(623),
    [sym_bitwise_or_expression] = STATE(623),
    [sym_bitwise_xor_expression] = STATE(623),
    [sym_bitwise_and_expression] = STATE(623),
    [sym_shift_expression] = STATE(623),
    [sym_additive_expression] = STATE(623),
    [sym_multiplicative_expression] = STATE(623),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [314] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym__real_expression] = STATE(618),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym_if_null_expression] = STATE(618),
    [sym_conditional_expression] = STATE(618),
    [sym_logical_or_expression] = STATE(618),
    [sym_logical_and_expression] = STATE(618),
    [sym_equality_expression] = STATE(618),
    [sym_type_cast_expression] = STATE(618),
    [sym_type_test_expression] = STATE(618),
    [sym_relational_expression] = STATE(618),
    [sym_bitwise_or_expression] = STATE(618),
    [sym_bitwise_xor_expression] = STATE(618),
    [sym_bitwise_and_expression] = STATE(618),
    [sym_shift_expression] = STATE(618),
    [sym_additive_expression] = STATE(618),
    [sym_multiplicative_expression] = STATE(618),
    [sym__unary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__postfix_expression] = STATE(979),
    [sym_postfix_expression] = STATE(979),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(964),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_decimal_integer_literal] = ACTIONS(831),
    [sym_hex_integer_literal] = ACTIONS(829),
    [sym_decimal_floating_point_literal] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_r_DQUOTE] = ACTIONS(831),
    [anon_sym_r_SQUOTE] = ACTIONS(831),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(836),
    [anon_sym_COLON] = ACTIONS(836),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_QMARK_QMARK] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [sym_equality_operator] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_EQ] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_GT_GT_GT] = ACTIONS(836),
    [sym__additive_operator] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_SLASH] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(836),
    [anon_sym_TILDE_SLASH] = ACTIONS(836),
    [sym_increment_operator] = ACTIONS(829),
    [sym_minus_operator] = ACTIONS(831),
    [sym__exclamation_operator] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_QMARK_DOT] = ACTIONS(836),
    [anon_sym_DOT_DOT] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_super] = ACTIONS(831),
    [sym_void_type] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [sym__break_builtin] = ACTIONS(831),
    [sym__assert_builtin] = ACTIONS(831),
    [anon_sym_covariant] = ACTIONS(831),
    [anon_sym_Function] = ACTIONS(831),
    [anon_sym_get] = ACTIONS(831),
    [anon_sym_set] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [sym_const_builtin] = ACTIONS(831),
    [sym_final_builtin] = ACTIONS(831),
    [anon_sym_late] = ACTIONS(831),
    [anon_sym_this] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_identifier] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_decimal_integer_literal] = ACTIONS(831),
    [sym_hex_integer_literal] = ACTIONS(829),
    [sym_decimal_floating_point_literal] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_r_DQUOTE] = ACTIONS(831),
    [anon_sym_r_SQUOTE] = ACTIONS(831),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_QMARK_QMARK] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [sym_equality_operator] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_EQ] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_GT_GT_GT] = ACTIONS(836),
    [sym__additive_operator] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_SLASH] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(836),
    [anon_sym_TILDE_SLASH] = ACTIONS(836),
    [sym_increment_operator] = ACTIONS(829),
    [sym_minus_operator] = ACTIONS(831),
    [sym__exclamation_operator] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_QMARK_DOT] = ACTIONS(836),
    [anon_sym_DOT_DOT] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_super] = ACTIONS(831),
    [sym_void_type] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [sym__break_builtin] = ACTIONS(831),
    [sym__assert_builtin] = ACTIONS(831),
    [sym_case_builtin] = ACTIONS(831),
    [anon_sym_covariant] = ACTIONS(831),
    [anon_sym_Function] = ACTIONS(831),
    [anon_sym_get] = ACTIONS(831),
    [anon_sym_set] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [sym_const_builtin] = ACTIONS(831),
    [sym_final_builtin] = ACTIONS(831),
    [anon_sym_late] = ACTIONS(831),
    [anon_sym_this] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_identifier] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_decimal_integer_literal] = ACTIONS(831),
    [sym_hex_integer_literal] = ACTIONS(829),
    [sym_decimal_floating_point_literal] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_r_DQUOTE] = ACTIONS(831),
    [anon_sym_r_SQUOTE] = ACTIONS(831),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(836),
    [anon_sym_COLON] = ACTIONS(836),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_QMARK_QMARK] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [sym_equality_operator] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_EQ] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(836),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_GT_GT_GT] = ACTIONS(836),
    [sym__additive_operator] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_SLASH] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(836),
    [anon_sym_TILDE_SLASH] = ACTIONS(836),
    [sym_increment_operator] = ACTIONS(829),
    [sym_minus_operator] = ACTIONS(831),
    [sym__exclamation_operator] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_QMARK_DOT] = ACTIONS(836),
    [anon_sym_DOT_DOT] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_super] = ACTIONS(831),
    [sym_void_type] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [sym__break_builtin] = ACTIONS(831),
    [sym__assert_builtin] = ACTIONS(831),
    [anon_sym_covariant] = ACTIONS(831),
    [anon_sym_Function] = ACTIONS(831),
    [anon_sym_get] = ACTIONS(831),
    [anon_sym_set] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [sym_const_builtin] = ACTIONS(831),
    [sym_final_builtin] = ACTIONS(831),
    [anon_sym_late] = ACTIONS(831),
    [anon_sym_this] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [318] = {
    [sym__annotation] = STATE(1420),
    [sym_marker_annotation] = STATE(1420),
    [sym_annotation] = STATE(1420),
    [sym_import_or_export] = STATE(318),
    [sym_library_import] = STATE(360),
    [sym_library_export] = STATE(360),
    [sym_import_specification] = STATE(356),
    [sym__metadata] = STATE(1689),
    [sym__export] = STATE(1226),
    [sym__import] = STATE(1233),
    [aux_sym_program_repeat1] = STATE(318),
    [aux_sym__metadata_repeat1] = STATE(1420),
    [ts_builtin_sym_end] = ACTIONS(843),
    [sym_identifier] = ACTIONS(845),
    [anon_sym_POUND] = ACTIONS(843),
    [sym_decimal_integer_literal] = ACTIONS(845),
    [sym_hex_integer_literal] = ACTIONS(843),
    [sym_decimal_floating_point_literal] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(843),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(843),
    [anon_sym_r_DQUOTE] = ACTIONS(845),
    [anon_sym_r_SQUOTE] = ACTIONS(845),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(843),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_null] = ACTIONS(845),
    [anon_sym_throw] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [sym_increment_operator] = ACTIONS(843),
    [sym_minus_operator] = ACTIONS(845),
    [sym__exclamation_operator] = ACTIONS(843),
    [anon_sym_TILDE] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_yield] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_AT] = ACTIONS(847),
    [anon_sym_part] = ACTIONS(845),
    [anon_sym_enum] = ACTIONS(845),
    [anon_sym_abstract] = ACTIONS(845),
    [anon_sym_class] = ACTIONS(845),
    [anon_sym_extension] = ACTIONS(845),
    [anon_sym_super] = ACTIONS(845),
    [sym_void_type] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [sym__break_builtin] = ACTIONS(845),
    [sym__assert_builtin] = ACTIONS(845),
    [anon_sym_covariant] = ACTIONS(845),
    [anon_sym_export] = ACTIONS(850),
    [anon_sym_Function] = ACTIONS(845),
    [anon_sym_get] = ACTIONS(845),
    [anon_sym_import] = ACTIONS(853),
    [anon_sym_mixin] = ACTIONS(845),
    [anon_sym_set] = ACTIONS(845),
    [anon_sym_typedef] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(845),
    [sym_const_builtin] = ACTIONS(845),
    [sym_final_builtin] = ACTIONS(845),
    [anon_sym_late] = ACTIONS(845),
    [anon_sym_external] = ACTIONS(845),
    [anon_sym_this] = ACTIONS(845),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(856),
    [sym_identifier] = ACTIONS(858),
    [anon_sym_POUND] = ACTIONS(856),
    [sym_decimal_integer_literal] = ACTIONS(858),
    [sym_hex_integer_literal] = ACTIONS(856),
    [sym_decimal_floating_point_literal] = ACTIONS(858),
    [anon_sym_true] = ACTIONS(858),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(858),
    [anon_sym_SQUOTE] = ACTIONS(858),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(856),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(856),
    [anon_sym_r_DQUOTE] = ACTIONS(858),
    [anon_sym_r_SQUOTE] = ACTIONS(858),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(856),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(856),
    [anon_sym_LBRACE] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_LBRACK] = ACTIONS(856),
    [anon_sym_null] = ACTIONS(858),
    [anon_sym_throw] = ACTIONS(858),
    [anon_sym_LPAREN] = ACTIONS(856),
    [anon_sym_RPAREN] = ACTIONS(856),
    [anon_sym_LT] = ACTIONS(856),
    [sym_increment_operator] = ACTIONS(856),
    [sym_minus_operator] = ACTIONS(858),
    [sym__exclamation_operator] = ACTIONS(856),
    [anon_sym_TILDE] = ACTIONS(856),
    [anon_sym_await] = ACTIONS(858),
    [anon_sym_SEMI] = ACTIONS(856),
    [anon_sym_switch] = ACTIONS(858),
    [anon_sym_default] = ACTIONS(858),
    [anon_sym_do] = ACTIONS(858),
    [anon_sym_while] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(858),
    [anon_sym_yield] = ACTIONS(858),
    [anon_sym_return] = ACTIONS(858),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_if] = ACTIONS(858),
    [anon_sym_else] = ACTIONS(858),
    [anon_sym_for] = ACTIONS(858),
    [anon_sym_AT] = ACTIONS(856),
    [anon_sym_part] = ACTIONS(858),
    [anon_sym_enum] = ACTIONS(858),
    [anon_sym_abstract] = ACTIONS(858),
    [anon_sym_class] = ACTIONS(858),
    [anon_sym_extension] = ACTIONS(858),
    [anon_sym_super] = ACTIONS(858),
    [sym_void_type] = ACTIONS(858),
    [anon_sym_var] = ACTIONS(858),
    [sym__break_builtin] = ACTIONS(858),
    [sym__assert_builtin] = ACTIONS(858),
    [sym_case_builtin] = ACTIONS(858),
    [anon_sym_covariant] = ACTIONS(858),
    [anon_sym_export] = ACTIONS(858),
    [anon_sym_factory] = ACTIONS(858),
    [anon_sym_Function] = ACTIONS(858),
    [anon_sym_get] = ACTIONS(858),
    [anon_sym_import] = ACTIONS(858),
    [anon_sym_operator] = ACTIONS(858),
    [anon_sym_mixin] = ACTIONS(858),
    [anon_sym_set] = ACTIONS(858),
    [anon_sym_static] = ACTIONS(858),
    [anon_sym_typedef] = ACTIONS(858),
    [anon_sym_new] = ACTIONS(858),
    [sym_const_builtin] = ACTIONS(858),
    [sym_final_builtin] = ACTIONS(858),
    [anon_sym_late] = ACTIONS(858),
    [anon_sym_external] = ACTIONS(858),
    [anon_sym_this] = ACTIONS(858),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(860),
  },
  [320] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(862),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [321] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(864),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [322] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(866),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(868),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(870),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [325] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(874),
    [sym_identifier] = ACTIONS(876),
    [anon_sym_POUND] = ACTIONS(874),
    [sym_decimal_integer_literal] = ACTIONS(876),
    [sym_hex_integer_literal] = ACTIONS(874),
    [sym_decimal_floating_point_literal] = ACTIONS(876),
    [anon_sym_true] = ACTIONS(876),
    [anon_sym_false] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(876),
    [anon_sym_SQUOTE] = ACTIONS(876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(874),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_r_DQUOTE] = ACTIONS(876),
    [anon_sym_r_SQUOTE] = ACTIONS(876),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(874),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(874),
    [anon_sym_RBRACE] = ACTIONS(874),
    [anon_sym_LBRACK] = ACTIONS(874),
    [anon_sym_null] = ACTIONS(876),
    [anon_sym_throw] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_RPAREN] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(874),
    [sym_increment_operator] = ACTIONS(874),
    [sym_minus_operator] = ACTIONS(876),
    [sym__exclamation_operator] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(874),
    [anon_sym_await] = ACTIONS(876),
    [anon_sym_SEMI] = ACTIONS(874),
    [anon_sym_switch] = ACTIONS(876),
    [anon_sym_default] = ACTIONS(876),
    [anon_sym_do] = ACTIONS(876),
    [anon_sym_while] = ACTIONS(876),
    [anon_sym_continue] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_return] = ACTIONS(876),
    [anon_sym_try] = ACTIONS(876),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_else] = ACTIONS(876),
    [anon_sym_for] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(874),
    [anon_sym_part] = ACTIONS(876),
    [anon_sym_enum] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(876),
    [anon_sym_class] = ACTIONS(876),
    [anon_sym_extension] = ACTIONS(876),
    [anon_sym_super] = ACTIONS(876),
    [sym_void_type] = ACTIONS(876),
    [anon_sym_var] = ACTIONS(876),
    [sym__break_builtin] = ACTIONS(876),
    [sym__assert_builtin] = ACTIONS(876),
    [sym_case_builtin] = ACTIONS(876),
    [anon_sym_covariant] = ACTIONS(876),
    [anon_sym_export] = ACTIONS(876),
    [anon_sym_factory] = ACTIONS(876),
    [anon_sym_Function] = ACTIONS(876),
    [anon_sym_get] = ACTIONS(876),
    [anon_sym_import] = ACTIONS(876),
    [anon_sym_operator] = ACTIONS(876),
    [anon_sym_mixin] = ACTIONS(876),
    [anon_sym_set] = ACTIONS(876),
    [anon_sym_static] = ACTIONS(876),
    [anon_sym_typedef] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(876),
    [sym_const_builtin] = ACTIONS(876),
    [sym_final_builtin] = ACTIONS(876),
    [anon_sym_late] = ACTIONS(876),
    [anon_sym_external] = ACTIONS(876),
    [anon_sym_this] = ACTIONS(876),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [327] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym__unary_expression] = STATE(1001),
    [sym_unary_expression] = STATE(1001),
    [sym__postfix_expression] = STATE(1001),
    [sym_postfix_expression] = STATE(1001),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [328] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym__unary_expression] = STATE(997),
    [sym_unary_expression] = STATE(997),
    [sym__postfix_expression] = STATE(997),
    [sym_postfix_expression] = STATE(997),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [329] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym__unary_expression] = STATE(864),
    [sym_unary_expression] = STATE(864),
    [sym__postfix_expression] = STATE(864),
    [sym_postfix_expression] = STATE(864),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [330] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym__unary_expression] = STATE(863),
    [sym_unary_expression] = STATE(863),
    [sym__postfix_expression] = STATE(863),
    [sym_postfix_expression] = STATE(863),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [331] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [332] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym__postfix_expression] = STATE(1000),
    [sym_postfix_expression] = STATE(1000),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [333] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym__postfix_expression] = STATE(1000),
    [sym_postfix_expression] = STATE(1000),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [334] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym__unary_expression] = STATE(914),
    [sym_unary_expression] = STATE(914),
    [sym__postfix_expression] = STATE(914),
    [sym_postfix_expression] = STATE(914),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [335] = {
    [sym__literal] = STATE(538),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2118),
    [sym_function_expression] = STATE(538),
    [sym__unary_expression] = STATE(822),
    [sym_unary_expression] = STATE(822),
    [sym__postfix_expression] = STATE(822),
    [sym_postfix_expression] = STATE(822),
    [sym_prefix_operator] = STATE(329),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(991),
    [sym_await_expression] = STATE(872),
    [sym_new_expression] = STATE(538),
    [sym_const_object_expression] = STATE(538),
    [sym__primary] = STATE(538),
    [sym_constructor_invocation] = STATE(523),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(538),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(689),
    [sym_minus_operator] = ACTIONS(691),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [336] = {
    [sym__literal] = STATE(525),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2011),
    [sym_function_expression] = STATE(525),
    [sym__unary_expression] = STATE(996),
    [sym_unary_expression] = STATE(996),
    [sym__postfix_expression] = STATE(996),
    [sym_postfix_expression] = STATE(996),
    [sym_prefix_operator] = STATE(327),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1003),
    [sym_await_expression] = STATE(992),
    [sym_new_expression] = STATE(525),
    [sym_const_object_expression] = STATE(525),
    [sym__primary] = STATE(525),
    [sym_constructor_invocation] = STATE(526),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(525),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(737),
    [sym_minus_operator] = ACTIONS(739),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [337] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__postfix_expression] = STATE(1017),
    [sym_postfix_expression] = STATE(1017),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [338] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym__unary_expression] = STATE(878),
    [sym_unary_expression] = STATE(878),
    [sym__postfix_expression] = STATE(878),
    [sym_postfix_expression] = STATE(878),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [339] = {
    [sym__literal] = STATE(531),
    [sym_symbol_literal] = STATE(882),
    [sym_true] = STATE(882),
    [sym_false] = STATE(882),
    [sym_string_literal] = STATE(882),
    [sym__string_literal_double_quotes] = STATE(467),
    [sym__string_literal_single_quotes] = STATE(467),
    [sym__string_literal_double_quotes_multiple] = STATE(467),
    [sym__string_literal_single_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_double_quotes] = STATE(467),
    [sym__raw_string_literal_single_quotes] = STATE(467),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(467),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(467),
    [sym_list_literal] = STATE(882),
    [sym_set_or_map_literal] = STATE(882),
    [sym_null_literal] = STATE(882),
    [sym_assignable_expression] = STATE(2109),
    [sym_function_expression] = STATE(531),
    [sym__unary_expression] = STATE(877),
    [sym_unary_expression] = STATE(877),
    [sym__postfix_expression] = STATE(877),
    [sym_postfix_expression] = STATE(877),
    [sym_prefix_operator] = STATE(339),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(990),
    [sym_await_expression] = STATE(876),
    [sym_new_expression] = STATE(531),
    [sym_const_object_expression] = STATE(531),
    [sym__primary] = STATE(531),
    [sym_constructor_invocation] = STATE(528),
    [sym_type_arguments] = STATE(2013),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2129),
    [sym__formal_parameter_part] = STATE(1583),
    [sym_formal_parameter_list] = STATE(1583),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1367),
    [sym_this] = STATE(531),
    [sym_super] = STATE(1702),
    [aux_sym_string_literal_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_POUND] = ACTIONS(701),
    [sym_decimal_integer_literal] = ACTIONS(703),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(707),
    [anon_sym_false] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(713),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(717),
    [anon_sym_r_DQUOTE] = ACTIONS(719),
    [anon_sym_r_SQUOTE] = ACTIONS(721),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(755),
    [sym_minus_operator] = ACTIONS(757),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(759),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(743),
    [sym_const_builtin] = ACTIONS(745),
    [anon_sym_this] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [340] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym__postfix_expression] = STATE(1014),
    [sym_postfix_expression] = STATE(1014),
    [sym_prefix_operator] = STATE(340),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1601),
    [sym_formal_parameter_list] = STATE(1601),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(697),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [341] = {
    [sym__literal] = STATE(536),
    [sym_symbol_literal] = STATE(813),
    [sym_true] = STATE(813),
    [sym_false] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym__string_literal_double_quotes] = STATE(427),
    [sym__string_literal_single_quotes] = STATE(427),
    [sym__string_literal_double_quotes_multiple] = STATE(427),
    [sym__string_literal_single_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_double_quotes] = STATE(427),
    [sym__raw_string_literal_single_quotes] = STATE(427),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(427),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(427),
    [sym_list_literal] = STATE(813),
    [sym_set_or_map_literal] = STATE(813),
    [sym_null_literal] = STATE(813),
    [sym_assignable_expression] = STATE(2002),
    [sym_function_expression] = STATE(536),
    [sym__unary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym__postfix_expression] = STATE(1014),
    [sym_postfix_expression] = STATE(1014),
    [sym_prefix_operator] = STATE(341),
    [sym_negation_operator] = STATE(1024),
    [sym_tilde_operator] = STATE(1011),
    [sym_await_expression] = STATE(1002),
    [sym_new_expression] = STATE(536),
    [sym_const_object_expression] = STATE(536),
    [sym__primary] = STATE(536),
    [sym_constructor_invocation] = STATE(537),
    [sym_type_arguments] = STATE(2033),
    [sym_type_parameters] = STATE(1971),
    [sym__type_name] = STATE(2019),
    [sym__formal_parameter_part] = STATE(1552),
    [sym_formal_parameter_list] = STATE(1552),
    [sym__strict_formal_parameter_list] = STATE(1326),
    [sym__new_builtin] = STATE(1378),
    [sym_this] = STATE(536),
    [sym_super] = STATE(1718),
    [aux_sym_string_literal_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(825),
    [anon_sym_POUND] = ACTIONS(131),
    [sym_decimal_integer_literal] = ACTIONS(11),
    [sym_hex_integer_literal] = ACTIONS(13),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [anon_sym_true] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_r_DQUOTE] = ACTIONS(27),
    [anon_sym_r_SQUOTE] = ACTIONS(29),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_null] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(45),
    [sym_increment_operator] = ACTIONS(47),
    [sym_minus_operator] = ACTIONS(49),
    [sym__exclamation_operator] = ACTIONS(51),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_await] = ACTIONS(575),
    [anon_sym_super] = ACTIONS(87),
    [anon_sym_new] = ACTIONS(117),
    [sym_const_builtin] = ACTIONS(585),
    [anon_sym_this] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_decimal_integer_literal] = ACTIONS(831),
    [sym_hex_integer_literal] = ACTIONS(829),
    [sym_decimal_floating_point_literal] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_r_DQUOTE] = ACTIONS(831),
    [anon_sym_r_SQUOTE] = ACTIONS(831),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(829),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_QMARK] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(829),
    [sym_increment_operator] = ACTIONS(829),
    [sym_minus_operator] = ACTIONS(831),
    [sym__exclamation_operator] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_await] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(831),
    [anon_sym_QMARK_DOT] = ACTIONS(829),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_enum] = ACTIONS(831),
    [anon_sym_abstract] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_extension] = ACTIONS(831),
    [anon_sym_super] = ACTIONS(831),
    [sym_void_type] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [sym__break_builtin] = ACTIONS(831),
    [sym__assert_builtin] = ACTIONS(831),
    [sym_case_builtin] = ACTIONS(831),
    [anon_sym_covariant] = ACTIONS(831),
    [anon_sym_factory] = ACTIONS(831),
    [anon_sym_Function] = ACTIONS(831),
    [anon_sym_get] = ACTIONS(831),
    [anon_sym_operator] = ACTIONS(831),
    [anon_sym_mixin] = ACTIONS(831),
    [anon_sym_set] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_typedef] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [sym_const_builtin] = ACTIONS(831),
    [sym_final_builtin] = ACTIONS(831),
    [anon_sym_late] = ACTIONS(831),
    [anon_sym_external] = ACTIONS(831),
    [anon_sym_this] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(878),
    [sym_identifier] = ACTIONS(880),
    [anon_sym_POUND] = ACTIONS(878),
    [sym_decimal_integer_literal] = ACTIONS(880),
    [sym_hex_integer_literal] = ACTIONS(878),
    [sym_decimal_floating_point_literal] = ACTIONS(880),
    [anon_sym_true] = ACTIONS(880),
    [anon_sym_false] = ACTIONS(880),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [anon_sym_SQUOTE] = ACTIONS(880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(878),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(878),
    [anon_sym_r_DQUOTE] = ACTIONS(880),
    [anon_sym_r_SQUOTE] = ACTIONS(880),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(878),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(878),
    [anon_sym_LBRACE] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_null] = ACTIONS(880),
    [anon_sym_throw] = ACTIONS(880),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_QMARK] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(878),
    [sym_increment_operator] = ACTIONS(878),
    [sym_minus_operator] = ACTIONS(880),
    [sym__exclamation_operator] = ACTIONS(878),
    [anon_sym_TILDE] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(880),
    [anon_sym_DOT] = ACTIONS(880),
    [anon_sym_QMARK_DOT] = ACTIONS(878),
    [anon_sym_switch] = ACTIONS(880),
    [anon_sym_default] = ACTIONS(880),
    [anon_sym_do] = ACTIONS(880),
    [anon_sym_while] = ACTIONS(880),
    [anon_sym_continue] = ACTIONS(880),
    [anon_sym_yield] = ACTIONS(880),
    [anon_sym_return] = ACTIONS(880),
    [anon_sym_try] = ACTIONS(880),
    [anon_sym_if] = ACTIONS(880),
    [anon_sym_else] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(880),
    [anon_sym_AT] = ACTIONS(878),
    [anon_sym_enum] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(880),
    [anon_sym_extension] = ACTIONS(880),
    [anon_sym_super] = ACTIONS(880),
    [sym_void_type] = ACTIONS(880),
    [anon_sym_var] = ACTIONS(880),
    [sym__break_builtin] = ACTIONS(880),
    [sym__assert_builtin] = ACTIONS(880),
    [sym_case_builtin] = ACTIONS(880),
    [anon_sym_covariant] = ACTIONS(880),
    [anon_sym_factory] = ACTIONS(880),
    [anon_sym_Function] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_operator] = ACTIONS(880),
    [anon_sym_mixin] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_typedef] = ACTIONS(880),
    [anon_sym_new] = ACTIONS(880),
    [sym_const_builtin] = ACTIONS(880),
    [sym_final_builtin] = ACTIONS(880),
    [anon_sym_late] = ACTIONS(880),
    [anon_sym_external] = ACTIONS(880),
    [anon_sym_this] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [344] = {
    [sym__annotation] = STATE(1420),
    [sym_marker_annotation] = STATE(1420),
    [sym_annotation] = STATE(1420),
    [sym_part_of_directive] = STATE(344),
    [sym__metadata] = STATE(2332),
    [aux_sym_program_repeat3] = STATE(344),
    [aux_sym__metadata_repeat1] = STATE(1420),
    [ts_builtin_sym_end] = ACTIONS(882),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_POUND] = ACTIONS(882),
    [sym_decimal_integer_literal] = ACTIONS(884),
    [sym_hex_integer_literal] = ACTIONS(882),
    [sym_decimal_floating_point_literal] = ACTIONS(884),
    [anon_sym_true] = ACTIONS(884),
    [anon_sym_false] = ACTIONS(884),
    [anon_sym_DQUOTE] = ACTIONS(884),
    [anon_sym_SQUOTE] = ACTIONS(884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(882),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(882),
    [anon_sym_r_DQUOTE] = ACTIONS(884),
    [anon_sym_r_SQUOTE] = ACTIONS(884),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(882),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_null] = ACTIONS(884),
    [anon_sym_throw] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(882),
    [sym_increment_operator] = ACTIONS(882),
    [sym_minus_operator] = ACTIONS(884),
    [sym__exclamation_operator] = ACTIONS(882),
    [anon_sym_TILDE] = ACTIONS(882),
    [anon_sym_await] = ACTIONS(884),
    [anon_sym_switch] = ACTIONS(884),
    [anon_sym_do] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_part] = ACTIONS(889),
    [anon_sym_enum] = ACTIONS(884),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_class] = ACTIONS(884),
    [anon_sym_extension] = ACTIONS(884),
    [anon_sym_super] = ACTIONS(884),
    [sym_void_type] = ACTIONS(884),
    [anon_sym_var] = ACTIONS(884),
    [sym__break_builtin] = ACTIONS(884),
    [sym__assert_builtin] = ACTIONS(884),
    [anon_sym_covariant] = ACTIONS(884),
    [anon_sym_Function] = ACTIONS(884),
    [anon_sym_get] = ACTIONS(884),
    [anon_sym_mixin] = ACTIONS(884),
    [anon_sym_set] = ACTIONS(884),
    [anon_sym_typedef] = ACTIONS(884),
    [anon_sym_new] = ACTIONS(884),
    [sym_const_builtin] = ACTIONS(884),
    [sym_final_builtin] = ACTIONS(884),
    [anon_sym_late] = ACTIONS(884),
    [anon_sym_external] = ACTIONS(884),
    [anon_sym_this] = ACTIONS(884),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [345] = {
    [sym__annotation] = STATE(1420),
    [sym_marker_annotation] = STATE(1420),
    [sym_annotation] = STATE(1420),
    [sym_part_directive] = STATE(345),
    [sym__metadata] = STATE(2335),
    [aux_sym_program_repeat2] = STATE(345),
    [aux_sym__metadata_repeat1] = STATE(1420),
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_POUND] = ACTIONS(892),
    [sym_decimal_integer_literal] = ACTIONS(894),
    [sym_hex_integer_literal] = ACTIONS(892),
    [sym_decimal_floating_point_literal] = ACTIONS(894),
    [anon_sym_true] = ACTIONS(894),
    [anon_sym_false] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(894),
    [anon_sym_SQUOTE] = ACTIONS(894),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(892),
    [anon_sym_r_DQUOTE] = ACTIONS(894),
    [anon_sym_r_SQUOTE] = ACTIONS(894),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_null] = ACTIONS(894),
    [anon_sym_throw] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_LT] = ACTIONS(892),
    [sym_increment_operator] = ACTIONS(892),
    [sym_minus_operator] = ACTIONS(894),
    [sym__exclamation_operator] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(896),
    [anon_sym_part] = ACTIONS(899),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_abstract] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_extension] = ACTIONS(894),
    [anon_sym_super] = ACTIONS(894),
    [sym_void_type] = ACTIONS(894),
    [anon_sym_var] = ACTIONS(894),
    [sym__break_builtin] = ACTIONS(894),
    [sym__assert_builtin] = ACTIONS(894),
    [anon_sym_covariant] = ACTIONS(894),
    [anon_sym_Function] = ACTIONS(894),
    [anon_sym_get] = ACTIONS(894),
    [anon_sym_mixin] = ACTIONS(894),
    [anon_sym_set] = ACTIONS(894),
    [anon_sym_typedef] = ACTIONS(894),
    [anon_sym_new] = ACTIONS(894),
    [sym_const_builtin] = ACTIONS(894),
    [sym_final_builtin] = ACTIONS(894),
    [anon_sym_late] = ACTIONS(894),
    [anon_sym_external] = ACTIONS(894),
    [anon_sym_this] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(902),
    [sym_identifier] = ACTIONS(904),
    [anon_sym_POUND] = ACTIONS(902),
    [sym_decimal_integer_literal] = ACTIONS(904),
    [sym_hex_integer_literal] = ACTIONS(902),
    [sym_decimal_floating_point_literal] = ACTIONS(904),
    [anon_sym_true] = ACTIONS(904),
    [anon_sym_false] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(904),
    [anon_sym_SQUOTE] = ACTIONS(904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(902),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(902),
    [anon_sym_r_DQUOTE] = ACTIONS(904),
    [anon_sym_r_SQUOTE] = ACTIONS(904),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(902),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(902),
    [anon_sym_null] = ACTIONS(904),
    [anon_sym_throw] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_LT] = ACTIONS(902),
    [sym_increment_operator] = ACTIONS(902),
    [sym_minus_operator] = ACTIONS(904),
    [sym__exclamation_operator] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(904),
    [anon_sym_switch] = ACTIONS(904),
    [anon_sym_default] = ACTIONS(904),
    [anon_sym_do] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(904),
    [anon_sym_try] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_else] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(904),
    [anon_sym_abstract] = ACTIONS(904),
    [anon_sym_class] = ACTIONS(904),
    [anon_sym_extension] = ACTIONS(904),
    [anon_sym_super] = ACTIONS(904),
    [sym_void_type] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(904),
    [sym__break_builtin] = ACTIONS(904),
    [sym__assert_builtin] = ACTIONS(904),
    [sym_case_builtin] = ACTIONS(904),
    [anon_sym_covariant] = ACTIONS(904),
    [anon_sym_factory] = ACTIONS(904),
    [anon_sym_Function] = ACTIONS(904),
    [anon_sym_get] = ACTIONS(904),
    [anon_sym_operator] = ACTIONS(904),
    [anon_sym_mixin] = ACTIONS(904),
    [anon_sym_set] = ACTIONS(904),
    [anon_sym_static] = ACTIONS(904),
    [anon_sym_typedef] = ACTIONS(904),
    [anon_sym_new] = ACTIONS(904),
    [sym_const_builtin] = ACTIONS(904),
    [sym_final_builtin] = ACTIONS(904),
    [anon_sym_late] = ACTIONS(904),
    [anon_sym_external] = ACTIONS(904),
    [anon_sym_this] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(906),
    [sym_identifier] = ACTIONS(908),
    [anon_sym_POUND] = ACTIONS(906),
    [sym_decimal_integer_literal] = ACTIONS(908),
    [sym_hex_integer_literal] = ACTIONS(906),
    [sym_decimal_floating_point_literal] = ACTIONS(908),
    [anon_sym_true] = ACTIONS(908),
    [anon_sym_false] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_SQUOTE] = ACTIONS(908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(906),
    [anon_sym_r_DQUOTE] = ACTIONS(908),
    [anon_sym_r_SQUOTE] = ACTIONS(908),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(906),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(906),
    [anon_sym_RBRACE] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_null] = ACTIONS(908),
    [anon_sym_throw] = ACTIONS(908),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_LT] = ACTIONS(906),
    [sym_increment_operator] = ACTIONS(906),
    [sym_minus_operator] = ACTIONS(908),
    [sym__exclamation_operator] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_switch] = ACTIONS(908),
    [anon_sym_default] = ACTIONS(908),
    [anon_sym_do] = ACTIONS(908),
    [anon_sym_while] = ACTIONS(908),
    [anon_sym_continue] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(908),
    [anon_sym_return] = ACTIONS(908),
    [anon_sym_try] = ACTIONS(908),
    [anon_sym_if] = ACTIONS(908),
    [anon_sym_else] = ACTIONS(908),
    [anon_sym_for] = ACTIONS(908),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(908),
    [anon_sym_abstract] = ACTIONS(908),
    [anon_sym_class] = ACTIONS(908),
    [anon_sym_extension] = ACTIONS(908),
    [anon_sym_super] = ACTIONS(908),
    [sym_void_type] = ACTIONS(908),
    [anon_sym_var] = ACTIONS(908),
    [sym__break_builtin] = ACTIONS(908),
    [sym__assert_builtin] = ACTIONS(908),
    [sym_case_builtin] = ACTIONS(908),
    [anon_sym_covariant] = ACTIONS(908),
    [anon_sym_factory] = ACTIONS(908),
    [anon_sym_Function] = ACTIONS(908),
    [anon_sym_get] = ACTIONS(908),
    [anon_sym_operator] = ACTIONS(908),
    [anon_sym_mixin] = ACTIONS(908),
    [anon_sym_set] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_typedef] = ACTIONS(908),
    [anon_sym_new] = ACTIONS(908),
    [sym_const_builtin] = ACTIONS(908),
    [sym_final_builtin] = ACTIONS(908),
    [anon_sym_late] = ACTIONS(908),
    [anon_sym_external] = ACTIONS(908),
    [anon_sym_this] = ACTIONS(908),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(910),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_POUND] = ACTIONS(910),
    [sym_decimal_integer_literal] = ACTIONS(912),
    [sym_hex_integer_literal] = ACTIONS(910),
    [sym_decimal_floating_point_literal] = ACTIONS(912),
    [anon_sym_true] = ACTIONS(912),
    [anon_sym_false] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(910),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(910),
    [anon_sym_r_DQUOTE] = ACTIONS(912),
    [anon_sym_r_SQUOTE] = ACTIONS(912),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(910),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_null] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_LT] = ACTIONS(910),
    [sym_increment_operator] = ACTIONS(910),
    [sym_minus_operator] = ACTIONS(912),
    [sym__exclamation_operator] = ACTIONS(910),
    [anon_sym_TILDE] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_else] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_extension] = ACTIONS(912),
    [anon_sym_super] = ACTIONS(912),
    [sym_void_type] = ACTIONS(912),
    [anon_sym_var] = ACTIONS(912),
    [sym__break_builtin] = ACTIONS(912),
    [sym__assert_builtin] = ACTIONS(912),
    [sym_case_builtin] = ACTIONS(912),
    [anon_sym_covariant] = ACTIONS(912),
    [anon_sym_factory] = ACTIONS(912),
    [anon_sym_Function] = ACTIONS(912),
    [anon_sym_get] = ACTIONS(912),
    [anon_sym_operator] = ACTIONS(912),
    [anon_sym_mixin] = ACTIONS(912),
    [anon_sym_set] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(912),
    [anon_sym_new] = ACTIONS(912),
    [sym_const_builtin] = ACTIONS(912),
    [sym_final_builtin] = ACTIONS(912),
    [anon_sym_late] = ACTIONS(912),
    [anon_sym_external] = ACTIONS(912),
    [anon_sym_this] = ACTIONS(912),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(914),
    [sym_identifier] = ACTIONS(916),
    [anon_sym_POUND] = ACTIONS(914),
    [sym_decimal_integer_literal] = ACTIONS(916),
    [sym_hex_integer_literal] = ACTIONS(914),
    [sym_decimal_floating_point_literal] = ACTIONS(916),
    [anon_sym_true] = ACTIONS(916),
    [anon_sym_false] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(914),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(914),
    [anon_sym_r_DQUOTE] = ACTIONS(916),
    [anon_sym_r_SQUOTE] = ACTIONS(916),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(914),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(914),
    [anon_sym_RBRACE] = ACTIONS(914),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_null] = ACTIONS(916),
    [anon_sym_throw] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_LT] = ACTIONS(914),
    [sym_increment_operator] = ACTIONS(914),
    [sym_minus_operator] = ACTIONS(916),
    [sym__exclamation_operator] = ACTIONS(914),
    [anon_sym_TILDE] = ACTIONS(914),
    [anon_sym_await] = ACTIONS(916),
    [anon_sym_switch] = ACTIONS(916),
    [anon_sym_default] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(916),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(916),
    [anon_sym_return] = ACTIONS(916),
    [anon_sym_try] = ACTIONS(916),
    [anon_sym_if] = ACTIONS(916),
    [anon_sym_else] = ACTIONS(916),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_AT] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(916),
    [anon_sym_abstract] = ACTIONS(916),
    [anon_sym_class] = ACTIONS(916),
    [anon_sym_extension] = ACTIONS(916),
    [anon_sym_super] = ACTIONS(916),
    [sym_void_type] = ACTIONS(916),
    [anon_sym_var] = ACTIONS(916),
    [sym__break_builtin] = ACTIONS(916),
    [sym__assert_builtin] = ACTIONS(916),
    [sym_case_builtin] = ACTIONS(916),
    [anon_sym_covariant] = ACTIONS(916),
    [anon_sym_factory] = ACTIONS(916),
    [anon_sym_Function] = ACTIONS(916),
    [anon_sym_get] = ACTIONS(916),
    [anon_sym_operator] = ACTIONS(916),
    [anon_sym_mixin] = ACTIONS(916),
    [anon_sym_set] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(916),
    [sym_const_builtin] = ACTIONS(916),
    [sym_final_builtin] = ACTIONS(916),
    [anon_sym_late] = ACTIONS(916),
    [anon_sym_external] = ACTIONS(916),
    [anon_sym_this] = ACTIONS(916),
    [sym_comment] = ACTIONS(3),
    [sym_documentation_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(918), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(920), 47,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [71] = 9,
    ACTIONS(926), 1,
      anon_sym_on,
    ACTIONS(928), 1,
      anon_sym_catch,
    ACTIONS(930), 1,
      anon_sym_finally,
    STATE(435), 1,
      sym_finally_clause,
    STATE(2133), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(362), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
    ACTIONS(922), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(924), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [154] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(932), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(934), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(936), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(938), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [294] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(940), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(942), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [364] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(944), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(946), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [434] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(948), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(950), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(952), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(954), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(956), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(958), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(960), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(962), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(964), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(966), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [784] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(968), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(970), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [854] = 7,
    ACTIONS(976), 1,
      anon_sym_on,
    ACTIONS(979), 1,
      anon_sym_catch,
    STATE(2133), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(362), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
    ACTIONS(972), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(974), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(982), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(984), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(986), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(988), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1072] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(990), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(992), 46,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(994), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(996), 44,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(998), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1000), 44,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1002), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1004), 44,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1006), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1008), 44,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1010), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1012), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1481] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1014), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1016), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1548] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1018), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1020), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1022), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1024), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1026), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1028), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1749] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1030), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1032), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1034), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1036), 42,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_on,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [1883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1038), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1040), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [1950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(878), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(880), 42,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_on,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [2017] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1042), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1044), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2084] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1046), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1048), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2151] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1032), 7,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_mixin,
      anon_sym_typedef,
      anon_sym_external,
    ACTIONS(1050), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1053), 36,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [2220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1056), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1058), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1060), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1063), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1066), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1068), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2421] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1070), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1072), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1074), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1076), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2555] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(829), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(831), 42,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_on,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [2622] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1078), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1080), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1082), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1084), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2756] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1086), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1088), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2823] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1090), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1092), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1094), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1096), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [2957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1098), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1100), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3024] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1102), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1104), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1106), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1108), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1110), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1112), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3225] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1114), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1116), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3292] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1118), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1120), 42,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_on,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [3359] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1122), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1124), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1126), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1128), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3493] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1130), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1132), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3560] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1134), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1136), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1138), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1140), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3694] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1142), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1144), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1146), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1148), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1150), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1152), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1154), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1156), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [3962] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1158), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1160), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1162), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1164), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1166), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1168), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4163] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1170), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1172), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1174), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1176), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1178), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1180), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4364] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1182), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1184), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4431] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1186), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1189), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1192), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1194), 42,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_on,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [4565] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1196), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1198), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1200), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1202), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1204), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1206), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4766] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1208), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1210), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4833] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1212), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1214), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1216), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1218), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [4967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1220), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1222), 43,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [5034] = 44,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(109), 1,
      anon_sym_import,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(123), 1,
      anon_sym_late,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1228), 1,
      anon_sym_part,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1234), 1,
      anon_sym_library,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    ACTIONS(1238), 1,
      anon_sym_export,
    STATE(363), 1,
      sym_import_specification,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1233), 1,
      sym__import,
    STATE(1237), 1,
      sym__export,
    STATE(1281), 1,
      sym__covariant,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1324), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1597), 1,
      sym__type,
    STATE(1921), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    STATE(2260), 1,
      sym__final_const_var_or_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(121), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [5181] = 35,
    ACTIONS(45), 1,
      anon_sym_LT,
    ACTIONS(87), 1,
      anon_sym_super,
    ACTIONS(1240), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_POUND,
    ACTIONS(1246), 1,
      sym_hex_integer_literal,
    ACTIONS(1248), 1,
      anon_sym_true,
    ACTIONS(1250), 1,
      anon_sym_false,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1268), 1,
      anon_sym_LBRACE,
    ACTIONS(1270), 1,
      anon_sym_LBRACK,
    ACTIONS(1272), 1,
      anon_sym_null,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_new,
    ACTIONS(1278), 1,
      sym_const_builtin,
    ACTIONS(1280), 1,
      anon_sym_this,
    STATE(877), 1,
      sym_assignable_expression,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1376), 1,
      sym__new_builtin,
    STATE(1690), 1,
      sym_super,
    STATE(1971), 1,
      sym_type_parameters,
    STATE(2090), 1,
      sym_type_arguments,
    STATE(2115), 1,
      sym__type_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1244), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(1553), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    STATE(1298), 7,
      sym__literal,
      sym_function_expression,
      sym_new_expression,
      sym_const_object_expression,
      sym__primary,
      sym_constructor_invocation,
      sym_this,
    STATE(1590), 7,
      sym_symbol_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_list_literal,
      sym_set_or_map_literal,
      sym_null_literal,
    STATE(1021), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [5310] = 35,
    ACTIONS(45), 1,
      anon_sym_LT,
    ACTIONS(87), 1,
      anon_sym_super,
    ACTIONS(1242), 1,
      anon_sym_POUND,
    ACTIONS(1246), 1,
      sym_hex_integer_literal,
    ACTIONS(1248), 1,
      anon_sym_true,
    ACTIONS(1250), 1,
      anon_sym_false,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1268), 1,
      anon_sym_LBRACE,
    ACTIONS(1270), 1,
      anon_sym_LBRACK,
    ACTIONS(1272), 1,
      anon_sym_null,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_new,
    ACTIONS(1278), 1,
      sym_const_builtin,
    ACTIONS(1280), 1,
      anon_sym_this,
    ACTIONS(1282), 1,
      sym_identifier,
    STATE(1001), 1,
      sym_assignable_expression,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1376), 1,
      sym__new_builtin,
    STATE(1678), 1,
      sym_super,
    STATE(1971), 1,
      sym_type_parameters,
    STATE(2090), 1,
      sym_type_arguments,
    STATE(2115), 1,
      sym__type_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1244), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(1553), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    STATE(1297), 7,
      sym__literal,
      sym_function_expression,
      sym_new_expression,
      sym_const_object_expression,
      sym__primary,
      sym_constructor_invocation,
      sym_this,
    STATE(1590), 7,
      sym_symbol_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_list_literal,
      sym_set_or_map_literal,
      sym_null_literal,
    STATE(1021), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [5439] = 12,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1286), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    STATE(431), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1284), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [5522] = 35,
    ACTIONS(45), 1,
      anon_sym_LT,
    ACTIONS(87), 1,
      anon_sym_super,
    ACTIONS(1242), 1,
      anon_sym_POUND,
    ACTIONS(1246), 1,
      sym_hex_integer_literal,
    ACTIONS(1248), 1,
      anon_sym_true,
    ACTIONS(1250), 1,
      anon_sym_false,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1268), 1,
      anon_sym_LBRACE,
    ACTIONS(1270), 1,
      anon_sym_LBRACK,
    ACTIONS(1272), 1,
      anon_sym_null,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_new,
    ACTIONS(1278), 1,
      sym_const_builtin,
    ACTIONS(1280), 1,
      anon_sym_this,
    ACTIONS(1288), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_assignable_expression,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1376), 1,
      sym__new_builtin,
    STATE(1713), 1,
      sym_super,
    STATE(1971), 1,
      sym_type_parameters,
    STATE(2090), 1,
      sym_type_arguments,
    STATE(2115), 1,
      sym__type_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1244), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(1553), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    STATE(1300), 7,
      sym__literal,
      sym_function_expression,
      sym_new_expression,
      sym_const_object_expression,
      sym__primary,
      sym_constructor_invocation,
      sym_this,
    STATE(1590), 7,
      sym_symbol_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_list_literal,
      sym_set_or_map_literal,
      sym_null_literal,
    STATE(1021), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [5651] = 35,
    ACTIONS(45), 1,
      anon_sym_LT,
    ACTIONS(87), 1,
      anon_sym_super,
    ACTIONS(1242), 1,
      anon_sym_POUND,
    ACTIONS(1246), 1,
      sym_hex_integer_literal,
    ACTIONS(1248), 1,
      anon_sym_true,
    ACTIONS(1250), 1,
      anon_sym_false,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1268), 1,
      anon_sym_LBRACE,
    ACTIONS(1270), 1,
      anon_sym_LBRACK,
    ACTIONS(1272), 1,
      anon_sym_null,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_new,
    ACTIONS(1278), 1,
      sym_const_builtin,
    ACTIONS(1280), 1,
      anon_sym_this,
    ACTIONS(1290), 1,
      sym_identifier,
    STATE(864), 1,
      sym_assignable_expression,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1376), 1,
      sym__new_builtin,
    STATE(1734), 1,
      sym_super,
    STATE(1971), 1,
      sym_type_parameters,
    STATE(2090), 1,
      sym_type_arguments,
    STATE(2115), 1,
      sym__type_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1244), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(1553), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    STATE(1296), 7,
      sym__literal,
      sym_function_expression,
      sym_new_expression,
      sym_const_object_expression,
      sym__primary,
      sym_constructor_invocation,
      sym_this,
    STATE(1590), 7,
      sym_symbol_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_list_literal,
      sym_set_or_map_literal,
      sym_null_literal,
    STATE(1021), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [5780] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1292), 17,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1294), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [5845] = 12,
    ACTIONS(1296), 1,
      anon_sym_DQUOTE,
    ACTIONS(1299), 1,
      anon_sym_SQUOTE,
    ACTIONS(1302), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1311), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1314), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1317), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    STATE(431), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1320), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [5928] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1324), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1326), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [5992] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1328), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1330), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1334), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6120] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1336), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1338), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6184] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1340), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1342), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6248] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1344), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1346), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1348), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1350), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1352), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1354), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6440] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1356), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1358), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1360), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1362), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6568] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1364), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1366), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1368), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1370), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1372), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1374), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6760] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1376), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1378), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1380), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1382), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1384), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1386), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [6952] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1388), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1390), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1392), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1394), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1396), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1398), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7144] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1400), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1402), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1404), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1406), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7272] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1408), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1410), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7336] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1414), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(922), 16,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(924), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7464] = 43,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(109), 1,
      anon_sym_import,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(123), 1,
      anon_sym_late,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1228), 1,
      anon_sym_part,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    ACTIONS(1238), 1,
      anon_sym_export,
    STATE(363), 1,
      sym_import_specification,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1233), 1,
      sym__import,
    STATE(1237), 1,
      sym__export,
    STATE(1281), 1,
      sym__covariant,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1324), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1597), 1,
      sym__type,
    STATE(1921), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    STATE(2260), 1,
      sym__final_const_var_or_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(121), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [7608] = 4,
    ACTIONS(1420), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1418), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1416), 38,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7673] = 36,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1456), 1,
      anon_sym_DOT_DOT,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(701), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(1450), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1422), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [7801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1461), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1459), 38,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1465), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1463), 38,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      sym_case_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [7925] = 36,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1485), 1,
      anon_sym_DOT_DOT,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(692), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(1450), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1422), 13,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [8053] = 4,
    ACTIONS(1488), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1418), 15,
      ts_builtin_sym_end,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1416), 36,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [8116] = 12,
    ACTIONS(1490), 1,
      anon_sym_DQUOTE,
    ACTIONS(1493), 1,
      anon_sym_SQUOTE,
    ACTIONS(1496), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1499), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1502), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1505), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1508), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1511), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(463), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1322), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1320), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [8195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1516), 16,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_DOT_DOT_DOT,
      sym__exclamation_operator,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1514), 36,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_super,
      sym_void_type,
      anon_sym_var,
      sym__break_builtin,
      sym__assert_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_this,
      sym_identifier,
  [8256] = 44,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1520), 1,
      anon_sym_RBRACE,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    STATE(471), 1,
      aux_sym_extension_body_repeat1,
    STATE(539), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1600), 1,
      sym_method_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2083), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [8399] = 44,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    ACTIONS(1538), 1,
      anon_sym_RBRACE,
    STATE(470), 1,
      aux_sym_class_body_repeat1,
    STATE(547), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1594), 1,
      sym_method_signature,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2105), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [8542] = 12,
    ACTIONS(711), 1,
      anon_sym_DQUOTE,
    ACTIONS(713), 1,
      anon_sym_SQUOTE,
    ACTIONS(715), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(717), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(719), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(721), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(723), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(725), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(463), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1286), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1284), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [8621] = 44,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    ACTIONS(1540), 1,
      anon_sym_RBRACE,
    STATE(465), 1,
      aux_sym_extension_body_repeat1,
    STATE(539), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1600), 1,
      sym_method_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2083), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [8764] = 44,
    ACTIONS(1542), 1,
      sym_identifier,
    ACTIONS(1545), 1,
      anon_sym_RBRACE,
    ACTIONS(1547), 1,
      anon_sym_AT,
    ACTIONS(1550), 1,
      sym_void_type,
    ACTIONS(1553), 1,
      anon_sym_var,
    ACTIONS(1556), 1,
      anon_sym_covariant,
    ACTIONS(1559), 1,
      anon_sym_factory,
    ACTIONS(1562), 1,
      anon_sym_Function,
    ACTIONS(1565), 1,
      anon_sym_get,
    ACTIONS(1568), 1,
      anon_sym_operator,
    ACTIONS(1571), 1,
      anon_sym_set,
    ACTIONS(1574), 1,
      anon_sym_static,
    ACTIONS(1577), 1,
      sym_const_builtin,
    ACTIONS(1580), 1,
      sym_final_builtin,
    ACTIONS(1583), 1,
      anon_sym_late,
    ACTIONS(1586), 1,
      anon_sym_external,
    STATE(469), 1,
      aux_sym_class_body_repeat1,
    STATE(547), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1594), 1,
      sym_method_signature,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2105), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [8907] = 44,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    STATE(469), 1,
      aux_sym_class_body_repeat1,
    STATE(547), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1594), 1,
      sym_method_signature,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2105), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [9050] = 44,
    ACTIONS(1591), 1,
      sym_identifier,
    ACTIONS(1594), 1,
      anon_sym_RBRACE,
    ACTIONS(1596), 1,
      anon_sym_AT,
    ACTIONS(1599), 1,
      sym_void_type,
    ACTIONS(1602), 1,
      anon_sym_var,
    ACTIONS(1605), 1,
      anon_sym_covariant,
    ACTIONS(1608), 1,
      anon_sym_factory,
    ACTIONS(1611), 1,
      anon_sym_Function,
    ACTIONS(1614), 1,
      anon_sym_get,
    ACTIONS(1617), 1,
      anon_sym_operator,
    ACTIONS(1620), 1,
      anon_sym_set,
    ACTIONS(1623), 1,
      anon_sym_static,
    ACTIONS(1626), 1,
      sym_const_builtin,
    ACTIONS(1629), 1,
      sym_final_builtin,
    ACTIONS(1632), 1,
      anon_sym_late,
    ACTIONS(1635), 1,
      anon_sym_external,
    STATE(471), 1,
      aux_sym_extension_body_repeat1,
    STATE(539), 1,
      sym__metadata,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1600), 1,
      sym_method_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2083), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [9193] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1640), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1638), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [9315] = 13,
    ACTIONS(1644), 1,
      anon_sym_EQ,
    STATE(179), 1,
      sym__assignment_operator,
    STATE(751), 1,
      sym_arguments,
    STATE(862), 1,
      sym__cascade_assignment_section,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(509), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(625), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(627), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1646), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1642), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [9395] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1650), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1648), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [9517] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1640), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1638), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [9639] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1654), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1652), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [9761] = 13,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(219), 1,
      sym__assignment_operator,
    STATE(765), 1,
      sym_arguments,
    STATE(891), 1,
      sym__cascade_assignment_section,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(488), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(502), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(631), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1660), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1656), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [9841] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1662), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [9963] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1668), 4,
      anon_sym_QMARK,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1666), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10075] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1676), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10197] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1682), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1680), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10319] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1686), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1684), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10441] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1690), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1688), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10563] = 30,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1696), 1,
      sym_equality_operator,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1694), 4,
      anon_sym_QMARK,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1692), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [10677] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1690), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1688), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [10799] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1686), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1684), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [10921] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1701), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1699), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11043] = 13,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(219), 1,
      sym__assignment_operator,
    STATE(765), 1,
      sym_arguments,
    STATE(858), 1,
      sym__cascade_assignment_section,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(504), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(617), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(631), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1646), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1642), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [11123] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1662), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11245] = 30,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1703), 1,
      sym_equality_operator,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1694), 5,
      anon_sym_QMARK,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1692), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11359] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1650), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1648), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11481] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1654), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1652), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11603] = 13,
    ACTIONS(1644), 1,
      anon_sym_EQ,
    STATE(179), 1,
      sym__assignment_operator,
    STATE(751), 1,
      sym_arguments,
    STATE(846), 1,
      sym__cascade_assignment_section,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(473), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(507), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(627), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1660), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1656), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11683] = 29,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1668), 5,
      anon_sym_QMARK,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1666), 17,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11795] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1676), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [11917] = 34,
    ACTIONS(1424), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1426), 1,
      anon_sym_QMARK,
    ACTIONS(1428), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1430), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1438), 1,
      anon_sym_PIPE,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1442), 1,
      anon_sym_AMP,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(756), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(757), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(758), 1,
      aux_sym__if_null_expression,
    STATE(880), 1,
      sym_type_test,
    STATE(881), 1,
      sym_type_cast,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1377), 1,
      sym_as_operator,
    STATE(1379), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1682), 4,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1680), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [12039] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1701), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1699), 14,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [12161] = 38,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(123), 1,
      anon_sym_late,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1228), 1,
      anon_sym_part,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1281), 1,
      sym__covariant,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1324), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1597), 1,
      sym__type,
    STATE(1921), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    STATE(2260), 1,
      sym__final_const_var_or_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(121), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [12290] = 38,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(123), 1,
      anon_sym_late,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    ACTIONS(1706), 1,
      anon_sym_part,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1281), 1,
      sym__covariant,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1324), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1597), 1,
      sym__type,
    STATE(1921), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    STATE(2260), 1,
      sym__final_const_var_or_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(121), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [12419] = 37,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(123), 1,
      anon_sym_late,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1281), 1,
      sym__covariant,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1324), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1597), 1,
      sym__type,
    STATE(1921), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    STATE(2260), 1,
      sym__final_const_var_or_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(121), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [12545] = 36,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1467), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1469), 1,
      anon_sym_QMARK,
    ACTIONS(1471), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1481), 1,
      anon_sym_AMP,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1708), 1,
      anon_sym_DOT_DOT,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(755), 1,
      aux_sym__if_null_expression,
    STATE(760), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(761), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(970), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(1450), 3,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1422), 7,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
  [12667] = 10,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(219), 1,
      sym__assignment_operator,
    STATE(858), 1,
      sym__cascade_assignment_section,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(608), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(631), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1646), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1642), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [12737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1710), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1712), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [12793] = 10,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(219), 1,
      sym__assignment_operator,
    STATE(933), 1,
      sym__cascade_assignment_section,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(608), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(631), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1716), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1714), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [12863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1718), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1720), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [12919] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1722), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1724), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [12975] = 10,
    ACTIONS(1644), 1,
      anon_sym_EQ,
    STATE(179), 1,
      sym__assignment_operator,
    STATE(862), 1,
      sym__cascade_assignment_section,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(610), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(627), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1646), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1642), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [13045] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1726), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1728), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13101] = 10,
    ACTIONS(1644), 1,
      anon_sym_EQ,
    STATE(179), 1,
      sym__assignment_operator,
    STATE(871), 1,
      sym__cascade_assignment_section,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(610), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(627), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1716), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1714), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [13171] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1730), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1732), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13227] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1734), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1736), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1738), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1740), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13339] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1742), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1744), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1746), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1748), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13451] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1750), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1752), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13507] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1754), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1756), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1758), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1760), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13619] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1762), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1764), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13675] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1766), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1768), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1770), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1772), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1774), 13,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1776), 34,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [13843] = 34,
    ACTIONS(79), 1,
      anon_sym_enum,
    ACTIONS(85), 1,
      anon_sym_extension,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(111), 1,
      anon_sym_mixin,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(115), 1,
      anon_sym_typedef,
    ACTIONS(125), 1,
      anon_sym_external,
    ACTIONS(1224), 1,
      sym_identifier,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(1230), 1,
      anon_sym_abstract,
    ACTIONS(1232), 1,
      anon_sym_class,
    ACTIONS(1780), 1,
      anon_sym_late,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1291), 1,
      sym__external_builtin,
    STATE(1328), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1381), 1,
      sym__typedef,
    STATE(1560), 1,
      sym__get,
    STATE(1566), 1,
      sym__type,
    STATE(1568), 1,
      sym__set,
    STATE(1879), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym__metadata,
    STATE(2169), 1,
      sym__mixin,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1778), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1455), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
    STATE(1420), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    STATE(392), 6,
      sym__top_level_definition,
      sym_enum_declaration,
      sym_type_alias,
      sym_class_definition,
      sym_extension_declaration,
      sym_mixin_declaration,
  [13960] = 17,
    ACTIONS(1784), 1,
      anon_sym_LBRACK,
    ACTIONS(1787), 1,
      anon_sym_LPAREN,
    ACTIONS(1790), 1,
      anon_sym_QMARK,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1798), 1,
      sym__exclamation_operator,
    ACTIONS(1801), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(549), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(807), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1782), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [14042] = 17,
    ACTIONS(1809), 1,
      anon_sym_LBRACK,
    ACTIONS(1812), 1,
      anon_sym_LPAREN,
    ACTIONS(1815), 1,
      anon_sym_QMARK,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1823), 1,
      sym__exclamation_operator,
    ACTIONS(1826), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(554), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(687), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1807), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14124] = 17,
    ACTIONS(1815), 1,
      anon_sym_QMARK,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(544), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(714), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1807), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14206] = 17,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1842), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(543), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(714), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1782), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14288] = 17,
    ACTIONS(1790), 1,
      anon_sym_QMARK,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(540), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(697), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1782), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [14370] = 17,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1842), 1,
      anon_sym_QMARK,
    ACTIONS(1855), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      anon_sym_LPAREN,
    ACTIONS(1861), 1,
      sym__exclamation_operator,
    ACTIONS(1864), 1,
      anon_sym_DOT,
    ACTIONS(1867), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(551), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(714), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1782), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14452] = 17,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1870), 1,
      anon_sym_LBRACK,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1876), 1,
      anon_sym_QMARK,
    ACTIONS(1879), 1,
      sym__exclamation_operator,
    ACTIONS(1882), 1,
      anon_sym_DOT,
    ACTIONS(1885), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(541), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(697), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [14534] = 17,
    ACTIONS(1784), 1,
      anon_sym_LBRACK,
    ACTIONS(1787), 1,
      anon_sym_LPAREN,
    ACTIONS(1790), 1,
      anon_sym_QMARK,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1798), 1,
      sym__exclamation_operator,
    ACTIONS(1801), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(542), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(697), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1782), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [14616] = 17,
    ACTIONS(1809), 1,
      anon_sym_LBRACK,
    ACTIONS(1812), 1,
      anon_sym_LPAREN,
    ACTIONS(1815), 1,
      anon_sym_QMARK,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1823), 1,
      sym__exclamation_operator,
    ACTIONS(1826), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(557), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(714), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1807), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14698] = 17,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1842), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(553), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(687), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1782), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14780] = 17,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1876), 1,
      anon_sym_QMARK,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(550), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(697), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [14862] = 17,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1842), 1,
      anon_sym_QMARK,
    ACTIONS(1855), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      anon_sym_LPAREN,
    ACTIONS(1861), 1,
      sym__exclamation_operator,
    ACTIONS(1864), 1,
      anon_sym_DOT,
    ACTIONS(1867), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(555), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(687), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1782), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [14944] = 17,
    ACTIONS(1815), 1,
      anon_sym_QMARK,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(552), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(687), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1807), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [15026] = 17,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1876), 1,
      anon_sym_QMARK,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(545), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(807), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15108] = 17,
    ACTIONS(1790), 1,
      anon_sym_QMARK,
    ACTIONS(1793), 1,
      anon_sym_LT,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(546), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(807), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1796), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1782), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15190] = 17,
    ACTIONS(1818), 1,
      anon_sym_LT,
    ACTIONS(1870), 1,
      anon_sym_LBRACK,
    ACTIONS(1873), 1,
      anon_sym_LPAREN,
    ACTIONS(1876), 1,
      anon_sym_QMARK,
    ACTIONS(1879), 1,
      sym__exclamation_operator,
    ACTIONS(1882), 1,
      anon_sym_DOT,
    ACTIONS(1885), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(1322), 1,
      sym__assignable_selector_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(548), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(807), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1821), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15272] = 39,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1581), 1,
      sym_method_signature,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2106), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [15397] = 16,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1890), 1,
      anon_sym_QMARK,
    ACTIONS(1893), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(675), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1888), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15476] = 16,
    ACTIONS(1900), 1,
      anon_sym_LBRACK,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1906), 1,
      anon_sym_QMARK,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1914), 1,
      sym__exclamation_operator,
    ACTIONS(1917), 1,
      anon_sym_DOT,
    ACTIONS(1920), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(675), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1898), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15555] = 16,
    ACTIONS(1890), 1,
      anon_sym_QMARK,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1923), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 1,
      anon_sym_LPAREN,
    ACTIONS(1929), 1,
      sym__exclamation_operator,
    ACTIONS(1932), 1,
      anon_sym_DOT,
    ACTIONS(1935), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(675), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1888), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15634] = 16,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1938), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(716), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1888), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [15713] = 16,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1941), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(716), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1898), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [15792] = 16,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1906), 1,
      anon_sym_QMARK,
    ACTIONS(1909), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(793), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1898), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15871] = 16,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1890), 1,
      anon_sym_QMARK,
    ACTIONS(1893), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(793), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1888), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [15950] = 39,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_covariant,
    ACTIONS(1524), 1,
      anon_sym_factory,
    ACTIONS(1526), 1,
      anon_sym_operator,
    ACTIONS(1528), 1,
      anon_sym_static,
    ACTIONS(1530), 1,
      sym_const_builtin,
    ACTIONS(1532), 1,
      sym_final_builtin,
    ACTIONS(1534), 1,
      anon_sym_late,
    ACTIONS(1536), 1,
      anon_sym_external,
    STATE(1054), 1,
      sym__operator,
    STATE(1185), 1,
      sym__external,
    STATE(1186), 1,
      sym__static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1235), 1,
      sym__external_builtin,
    STATE(1295), 1,
      sym__external_and_static,
    STATE(1332), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1462), 1,
      sym_constructor_signature,
    STATE(1467), 1,
      sym__type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1596), 1,
      sym_factory_constructor_signature,
    STATE(1599), 1,
      sym_method_signature,
    STATE(1762), 1,
      sym_constant_constructor_signature,
    STATE(1900), 1,
      sym_inferred_type,
    STATE(2144), 1,
      sym_declaration,
    STATE(2205), 1,
      sym__factory,
    STATE(2262), 1,
      sym_redirecting_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1319), 2,
      sym__static_or_covariant,
      sym__covariant,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1622), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [16075] = 16,
    ACTIONS(1900), 1,
      anon_sym_LBRACK,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1906), 1,
      anon_sym_QMARK,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1914), 1,
      sym__exclamation_operator,
    ACTIONS(1917), 1,
      anon_sym_DOT,
    ACTIONS(1920), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(793), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1898), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [16154] = 16,
    ACTIONS(1890), 1,
      anon_sym_QMARK,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1923), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 1,
      anon_sym_LPAREN,
    ACTIONS(1929), 1,
      sym__exclamation_operator,
    ACTIONS(1932), 1,
      anon_sym_DOT,
    ACTIONS(1935), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(793), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1888), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [16233] = 16,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 1,
      sym__exclamation_operator,
    ACTIONS(1851), 1,
      anon_sym_DOT,
    ACTIONS(1853), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1906), 1,
      anon_sym_QMARK,
    ACTIONS(1909), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(898), 1,
      sym_argument_part,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(675), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1898), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [16312] = 16,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1938), 1,
      anon_sym_QMARK,
    ACTIONS(1944), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_LPAREN,
    ACTIONS(1950), 1,
      sym__exclamation_operator,
    ACTIONS(1953), 1,
      anon_sym_DOT,
    ACTIONS(1956), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(716), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1888), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16391] = 16,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1941), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(691), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1898), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16470] = 16,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym__exclamation_operator,
    ACTIONS(1838), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1938), 1,
      anon_sym_QMARK,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(691), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1888), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16549] = 16,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1941), 1,
      anon_sym_QMARK,
    ACTIONS(1959), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_LPAREN,
    ACTIONS(1965), 1,
      sym__exclamation_operator,
    ACTIONS(1968), 1,
      anon_sym_DOT,
    ACTIONS(1971), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(691), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1898), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16628] = 16,
    ACTIONS(1893), 1,
      anon_sym_LT,
    ACTIONS(1938), 1,
      anon_sym_QMARK,
    ACTIONS(1944), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_LPAREN,
    ACTIONS(1950), 1,
      sym__exclamation_operator,
    ACTIONS(1953), 1,
      anon_sym_DOT,
    ACTIONS(1956), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(691), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1896), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1888), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16707] = 17,
    ACTIONS(1978), 1,
      anon_sym_COLON,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1474), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
    ACTIONS(1996), 5,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_else,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 11,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [16788] = 16,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1941), 1,
      anon_sym_QMARK,
    ACTIONS(1959), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_LPAREN,
    ACTIONS(1965), 1,
      sym__exclamation_operator,
    ACTIONS(1968), 1,
      anon_sym_DOT,
    ACTIONS(1971), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(819), 1,
      sym_argument_part,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(716), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(1912), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1898), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [16867] = 35,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1400), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(1422), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_else,
  [16984] = 15,
    ACTIONS(2026), 1,
      anon_sym_LBRACK,
    ACTIONS(2029), 1,
      anon_sym_LPAREN,
    ACTIONS(2032), 1,
      anon_sym_QMARK,
    ACTIONS(2035), 1,
      anon_sym_LT,
    ACTIONS(2040), 1,
      sym__exclamation_operator,
    ACTIONS(2043), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_QMARK_DOT,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(559), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(898), 4,
      sym_argument_part,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2038), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2024), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [17061] = 15,
    ACTIONS(2035), 1,
      anon_sym_LT,
    ACTIONS(2049), 1,
      anon_sym_LBRACK,
    ACTIONS(2052), 1,
      anon_sym_LPAREN,
    ACTIONS(2055), 1,
      anon_sym_QMARK,
    ACTIONS(2058), 1,
      sym__exclamation_operator,
    ACTIONS(2061), 1,
      anon_sym_DOT,
    ACTIONS(2064), 1,
      anon_sym_QMARK_DOT,
    STATE(751), 1,
      sym_arguments,
    STATE(2116), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(560), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(819), 4,
      sym_argument_part,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2038), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2024), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17138] = 36,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2087), 1,
      anon_sym_async,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1393), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2067), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17257] = 36,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2091), 1,
      anon_sym_async,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1418), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2089), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1726), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1728), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1754), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1756), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17480] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1734), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1736), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1738), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1740), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1742), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1744), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17636] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1766), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1768), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17688] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1762), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1764), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17740] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1758), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1760), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1750), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1752), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17844] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1774), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1776), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1770), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1772), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [17948] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1746), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1748), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18000] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1710), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1712), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1718), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1720), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1722), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1724), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18156] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1730), 15,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1732), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18208] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1650), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1648), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [18321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2095), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2093), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_AT,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [18372] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1676), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [18483] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1699), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [18594] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1662), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [18705] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1688), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [18816] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1652), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [18927] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1680), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [19038] = 36,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    ACTIONS(2113), 1,
      anon_sym_DOT_DOT,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1450), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    STATE(1401), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(1422), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
  [19155] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1690), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1688), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [19268] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1652), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [19381] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1684), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [19492] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1638), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [19603] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1686), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1684), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [19716] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1701), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1699), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [19829] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1648), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [19940] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1664), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1662), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20053] = 30,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    ACTIONS(2115), 1,
      sym_equality_operator,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1694), 2,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1692), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20158] = 20,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2120), 1,
      anon_sym_EQ,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2130), 1,
      anon_sym_DOT,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    STATE(203), 1,
      sym__assignment_operator,
    STATE(765), 1,
      sym_arguments,
    STATE(891), 1,
      sym__cascade_assignment_section,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(598), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(782), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(978), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1656), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [20243] = 20,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2120), 1,
      anon_sym_EQ,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2130), 1,
      anon_sym_DOT,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    STATE(203), 1,
      sym__assignment_operator,
    STATE(765), 1,
      sym_arguments,
    STATE(858), 1,
      sym__cascade_assignment_section,
    STATE(2117), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(617), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(744), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(978), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [20328] = 30,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1694), 1,
      anon_sym_QMARK,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    ACTIONS(2134), 1,
      sym_equality_operator,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1692), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [20433] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2139), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2137), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_AT,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [20484] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1668), 1,
      anon_sym_QMARK,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1666), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [20587] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1668), 2,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1666), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20690] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2143), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2141), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_AT,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [20741] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1678), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1676), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20854] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1682), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1680), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20967] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1454), 1,
      anon_sym_as,
    ACTIONS(1640), 1,
      anon_sym_async,
    ACTIONS(2069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2071), 1,
      anon_sym_QMARK,
    ACTIONS(2073), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2075), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2079), 1,
      anon_sym_PIPE,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2083), 1,
      anon_sym_AMP,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1078), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1105), 1,
      aux_sym__if_null_expression,
    STATE(1115), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1146), 1,
      sym_type_cast,
    STATE(1154), 1,
      sym_type_test,
    STATE(1383), 1,
      sym_as_operator,
    STATE(1385), 1,
      sym_is_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1638), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [21080] = 21,
    ACTIONS(1660), 1,
      anon_sym_async,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2147), 1,
      anon_sym_EQ,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    ACTIONS(2151), 1,
      anon_sym_QMARK,
    ACTIONS(2153), 1,
      anon_sym_DOT,
    ACTIONS(2155), 1,
      anon_sym_QMARK_DOT,
    STATE(169), 1,
      sym__assignment_operator,
    STATE(1062), 1,
      sym_arguments,
    STATE(1312), 1,
      sym__cascade_assignment_section,
    STATE(2038), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(609), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(772), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(980), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1656), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [21167] = 10,
    ACTIONS(2159), 1,
      anon_sym_LBRACK,
    ACTIONS(2164), 1,
      anon_sym_QMARK,
    ACTIONS(2167), 1,
      anon_sym_DOT,
    ACTIONS(2170), 1,
      anon_sym_QMARK_DOT,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(608), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(631), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2162), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
    ACTIONS(2157), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [21232] = 21,
    ACTIONS(1646), 1,
      anon_sym_async,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2147), 1,
      anon_sym_EQ,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    ACTIONS(2151), 1,
      anon_sym_QMARK,
    ACTIONS(2153), 1,
      anon_sym_DOT,
    ACTIONS(2155), 1,
      anon_sym_QMARK_DOT,
    STATE(169), 1,
      sym__assignment_operator,
    STATE(1062), 1,
      sym_arguments,
    STATE(1314), 1,
      sym__cascade_assignment_section,
    STATE(2038), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(773), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(965), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(980), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [21319] = 10,
    ACTIONS(2173), 1,
      anon_sym_LBRACK,
    ACTIONS(2176), 1,
      anon_sym_QMARK,
    ACTIONS(2179), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_QMARK_DOT,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(610), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(627), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2162), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2157), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [21384] = 17,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2185), 1,
      anon_sym_COLON,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1474), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 9,
      anon_sym_LBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [21462] = 32,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(573), 1,
      anon_sym_RPAREN,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_LBRACE,
    ACTIONS(2191), 1,
      anon_sym_LBRACK,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1855), 1,
      sym_formal_parameter,
    STATE(1987), 1,
      sym__normal_formal_parameters,
    STATE(2003), 1,
      sym__type,
    STATE(2198), 1,
      sym_optional_formal_parameters,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(2199), 2,
      sym__optional_postional_formal_parameters,
      sym__named_formal_parameters,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [21570] = 17,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2193), 1,
      anon_sym_COLON,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1474), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 9,
      anon_sym_LBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [21648] = 17,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_EQ,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2195), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(1484), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 9,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [21726] = 17,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2198), 1,
      anon_sym_EQ,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1484), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2195), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 8,
      anon_sym_LBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [21804] = 17,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2201), 1,
      anon_sym_COLON,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1474), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 9,
      anon_sym_LBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [21882] = 8,
    ACTIONS(2207), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(617), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2205), 9,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2203), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [21941] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1676), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22052] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1662), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22163] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1701), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1699), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22274] = 30,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      sym_equality_operator,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1694), 3,
      anon_sym_QMARK,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1692), 7,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22377] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1650), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1648), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22488] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1682), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1680), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22599] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1686), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1684), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22710] = 8,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2216), 1,
      anon_sym_LPAREN,
    STATE(751), 1,
      sym_arguments,
    STATE(2116), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(625), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2205), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2203), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [22769] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1690), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1688), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [22880] = 8,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2226), 1,
      anon_sym_LT,
    STATE(751), 1,
      sym_arguments,
    STATE(2116), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(628), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2221), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2219), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [22939] = 8,
    ACTIONS(2233), 1,
      anon_sym_LPAREN,
    ACTIONS(2236), 1,
      anon_sym_LT,
    STATE(751), 1,
      sym_arguments,
    STATE(2116), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(625), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2231), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2229), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [22998] = 18,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2195), 1,
      anon_sym_RPAREN,
    ACTIONS(2239), 1,
      anon_sym_COMMA,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1484), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 8,
      anon_sym_LBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [23077] = 8,
    ACTIONS(2236), 1,
      anon_sym_LT,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(617), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2231), 9,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2229), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [23136] = 8,
    ACTIONS(2226), 1,
      anon_sym_LT,
    ACTIONS(2244), 1,
      anon_sym_LPAREN,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(630), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2221), 9,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2219), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [23195] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1654), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1652), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [23306] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1668), 3,
      anon_sym_QMARK,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1666), 8,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [23407] = 34,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2099), 1,
      anon_sym_QMARK,
    ACTIONS(2101), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2107), 1,
      anon_sym_PIPE,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2111), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(850), 1,
      sym_type_cast,
    STATE(851), 1,
      sym_type_test,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1179), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1180), 1,
      aux_sym__if_null_expression,
    STATE(1183), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1386), 1,
      sym_is_operator,
    STATE(1387), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1640), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1638), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [23518] = 6,
    ACTIONS(2251), 1,
      anon_sym_Function,
    STATE(646), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(642), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2249), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2247), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23572] = 35,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2089), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1695), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
  [23684] = 9,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2260), 1,
      anon_sym_QMARK,
    ACTIONS(2264), 1,
      anon_sym_LT,
    STATE(650), 1,
      sym__nullable_type,
    STATE(655), 1,
      sym_type_parameters,
    STATE(680), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2268), 9,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2253), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [23744] = 6,
    ACTIONS(2275), 1,
      anon_sym_Function,
    STATE(645), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(640), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2273), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2271), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [23798] = 6,
    ACTIONS(2275), 1,
      anon_sym_Function,
    STATE(645), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(640), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2249), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2247), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [23852] = 6,
    ACTIONS(2281), 1,
      anon_sym_Function,
    STATE(645), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(640), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2279), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2277), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [23906] = 35,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(2006), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2008), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2016), 1,
      anon_sym_PIPE,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2020), 1,
      anon_sym_AMP,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1102), 1,
      aux_sym__if_null_expression,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1117), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1126), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2067), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1696), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
  [24018] = 6,
    ACTIONS(2284), 1,
      anon_sym_Function,
    STATE(646), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(642), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2279), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2277), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24072] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(880), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(878), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_while,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
  [24120] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(831), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(829), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_while,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
  [24168] = 9,
    ACTIONS(2289), 1,
      anon_sym_LPAREN,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym__nullable_type,
    STATE(669), 1,
      sym_type_parameters,
    STATE(682), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2298), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2287), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [24228] = 9,
    ACTIONS(2300), 1,
      anon_sym_LPAREN,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2306), 1,
      anon_sym_LT,
    STATE(655), 1,
      sym_type_parameters,
    STATE(659), 1,
      sym__nullable_type,
    STATE(680), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2298), 9,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2287), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [24288] = 6,
    ACTIONS(2251), 1,
      anon_sym_Function,
    STATE(646), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(642), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2273), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2271), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24342] = 9,
    ACTIONS(2309), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_QMARK,
    ACTIONS(2317), 1,
      anon_sym_LT,
    STATE(660), 1,
      sym__nullable_type,
    STATE(669), 1,
      sym_type_parameters,
    STATE(682), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2268), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2253), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [24402] = 10,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 3,
      anon_sym_QMARK,
      anon_sym_GT,
      sym__exclamation_operator,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [24463] = 7,
    ACTIONS(2324), 1,
      anon_sym_LPAREN,
    ACTIONS(2328), 1,
      anon_sym_QMARK,
    STATE(678), 1,
      sym_parameter_type_list,
    STATE(721), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2332), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2321), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [24518] = 7,
    ACTIONS(2337), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_QMARK,
    STATE(676), 1,
      sym_parameter_type_list,
    STATE(728), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2335), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [24573] = 7,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2350), 1,
      anon_sym_LT,
    STATE(698), 1,
      sym_type_arguments,
    STATE(725), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 9,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2345), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [24628] = 6,
    STATE(334), 1,
      sym_multiplicative_operator,
    STATE(658), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2357), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2355), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24681] = 6,
    STATE(258), 1,
      sym_shift_operator,
    STATE(661), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2359), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [24734] = 7,
    ACTIONS(2365), 1,
      anon_sym_LPAREN,
    ACTIONS(2368), 1,
      anon_sym_QMARK,
    STATE(651), 1,
      sym__nullable_type,
    STATE(678), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2363), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [24789] = 7,
    ACTIONS(2373), 1,
      anon_sym_QMARK,
    ACTIONS(2376), 1,
      anon_sym_LT,
    STATE(673), 1,
      sym_type_arguments,
    STATE(808), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2345), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [24844] = 6,
    STATE(296), 1,
      sym_shift_operator,
    STATE(670), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2359), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24897] = 8,
    ACTIONS(2386), 1,
      anon_sym_SLASH,
    STATE(334), 1,
      sym_multiplicative_operator,
    STATE(658), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2383), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2381), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2379), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24954] = 7,
    ACTIONS(2365), 1,
      anon_sym_LPAREN,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    STATE(678), 1,
      sym_parameter_type_list,
    STATE(721), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2363), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [25009] = 7,
    ACTIONS(2392), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_QMARK,
    STATE(683), 1,
      sym_parameter_type_list,
    STATE(781), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2332), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2321), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25064] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(258), 1,
      sym_shift_operator,
    STATE(661), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1676), 24,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25121] = 7,
    ACTIONS(2406), 1,
      anon_sym_LPAREN,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    STATE(683), 1,
      sym_parameter_type_list,
    STATE(781), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2363), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25176] = 6,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(666), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2357), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2355), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25229] = 10,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 5,
      anon_sym_QMARK,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [25290] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(334), 1,
      sym_multiplicative_operator,
    STATE(653), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2412), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [25347] = 8,
    ACTIONS(2386), 1,
      anon_sym_SLASH,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(666), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2383), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2381), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2379), 23,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25404] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(663), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2412), 23,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25461] = 7,
    ACTIONS(2420), 1,
      anon_sym_LPAREN,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    STATE(685), 1,
      sym_parameter_type_list,
    STATE(775), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2335), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25516] = 7,
    ACTIONS(2406), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    STATE(668), 1,
      sym__nullable_type,
    STATE(683), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2363), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25571] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(296), 1,
      sym_shift_operator,
    STATE(670), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1676), 22,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [25628] = 5,
    ACTIONS(2431), 1,
      anon_sym_DOT,
    STATE(806), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
    ACTIONS(2429), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25678] = 7,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 8,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
    ACTIONS(1976), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25732] = 5,
    ACTIONS(2436), 1,
      anon_sym_QMARK,
    STATE(784), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2434), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [25782] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2443), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2441), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25828] = 7,
    ACTIONS(2447), 1,
      anon_sym_EQ,
    ACTIONS(2457), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2454), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2449), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2445), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [25882] = 5,
    ACTIONS(2461), 1,
      anon_sym_QMARK,
    STATE(731), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2459), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [25932] = 29,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(559), 1,
      anon_sym_required,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2466), 1,
      anon_sym_RBRACE,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1773), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2070), 1,
      sym__default_named_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [26030] = 5,
    ACTIONS(2340), 1,
      anon_sym_QMARK,
    STATE(728), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2335), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [26080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2470), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2468), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [26126] = 5,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    STATE(721), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2363), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [26176] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(681), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1680), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26228] = 5,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    STATE(781), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2363), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [26278] = 5,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    STATE(775), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2335), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [26328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2477), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2475), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [26374] = 5,
    ACTIONS(2479), 1,
      anon_sym_QMARK,
    STATE(770), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2459), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [26424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2484), 11,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2482), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [26470] = 7,
    ACTIONS(2486), 1,
      anon_sym_EQ,
    ACTIONS(2494), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2491), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2452), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2488), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2445), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26524] = 5,
    STATE(297), 1,
      sym_additive_operator,
    STATE(681), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2496), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26574] = 7,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 10,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1976), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26628] = 7,
    ACTIONS(2502), 1,
      anon_sym_EQ,
    ACTIONS(2512), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2509), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2504), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2507), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2500), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26682] = 7,
    ACTIONS(2447), 1,
      anon_sym_EQ,
    ACTIONS(2457), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2454), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2449), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2452), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2445), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26736] = 5,
    ACTIONS(2518), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(702), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2516), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2514), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [26786] = 29,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(559), 1,
      anon_sym_required,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2521), 1,
      anon_sym_RBRACE,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1773), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2070), 1,
      sym__default_named_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [26884] = 5,
    ACTIONS(2527), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(694), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2525), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2523), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [26934] = 5,
    STATE(257), 1,
      sym_additive_operator,
    STATE(703), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2496), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [26984] = 7,
    ACTIONS(2502), 1,
      anon_sym_EQ,
    ACTIONS(2512), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2507), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2509), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2504), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2500), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [27038] = 7,
    ACTIONS(2486), 1,
      anon_sym_EQ,
    ACTIONS(2494), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2491), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2488), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2445), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [27092] = 5,
    ACTIONS(2530), 1,
      anon_sym_QMARK,
    STATE(718), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2434), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [27142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2470), 13,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2468), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2477), 13,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2475), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27234] = 5,
    ACTIONS(2533), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(694), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2516), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2514), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27284] = 5,
    ACTIONS(2536), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(702), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2525), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2523), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [27334] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(257), 1,
      sym_additive_operator,
    STATE(703), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1680), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [27386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2484), 13,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2482), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27432] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2443), 13,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2441), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27478] = 5,
    ACTIONS(2539), 1,
      anon_sym_DOT,
    STATE(736), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2429), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [27528] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2095), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2093), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27573] = 5,
    ACTIONS(2544), 1,
      anon_sym_QMARK,
    STATE(931), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2542), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27622] = 4,
    ACTIONS(2512), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2507), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2500), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2551), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2549), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [27714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2553), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [27759] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2139), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2137), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2557), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [27849] = 4,
    ACTIONS(2494), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2445), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27896] = 8,
    ACTIONS(2561), 1,
      anon_sym_LT,
    ACTIONS(2565), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1998), 2,
      anon_sym_QMARK,
      sym__exclamation_operator,
    ACTIONS(1983), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(1981), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2001), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27951] = 4,
    ACTIONS(2457), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2445), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [27998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2571), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2569), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [28043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2575), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2573), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2579), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2577), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2583), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2581), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [28178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2335), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2587), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2585), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28268] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2591), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2589), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2595), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2593), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2434), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28403] = 28,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(559), 1,
      anon_sym_required,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1773), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2070), 1,
      sym__default_named_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [28498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2599), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2597), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2459), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28588] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2143), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2141), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [28633] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2603), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2601), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28678] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2607), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2605), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28723] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2611), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2609), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28768] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2615), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2613), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28813] = 9,
    ACTIONS(1996), 1,
      sym__exclamation_operator,
    ACTIONS(1998), 1,
      anon_sym_QMARK,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2561), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1976), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(1981), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2001), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [28870] = 4,
    ACTIONS(2617), 1,
      anon_sym_Function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2542), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [28917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2621), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2619), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [28962] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2470), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2468), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2477), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2475), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29052] = 4,
    STATE(743), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2623), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2484), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2482), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29144] = 5,
    ACTIONS(2627), 1,
      anon_sym_AMP,
    STATE(741), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1652), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29193] = 5,
    ACTIONS(2630), 1,
      anon_sym_CARET,
    STATE(742), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1638), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29242] = 5,
    ACTIONS(2633), 1,
      anon_sym_PIPE,
    STATE(743), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1648), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29291] = 15,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2120), 1,
      anon_sym_EQ,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2130), 1,
      anon_sym_DOT,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    STATE(203), 1,
      sym__assignment_operator,
    STATE(933), 1,
      sym__cascade_assignment_section,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(977), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(978), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1714), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [29360] = 5,
    ACTIONS(2636), 1,
      anon_sym_AMP_AMP,
    STATE(745), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1662), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2641), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2639), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [29454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2443), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2441), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29499] = 9,
    ACTIONS(1996), 1,
      sym__exclamation_operator,
    ACTIONS(1998), 1,
      anon_sym_QMARK,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2561), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1976), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(1981), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2001), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [29556] = 5,
    ACTIONS(2643), 1,
      anon_sym_PIPE_PIPE,
    STATE(749), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1699), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29605] = 28,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2646), 1,
      anon_sym_RBRACK,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1940), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2074), 1,
      sym__default_formal_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [29700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2650), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2648), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29745] = 4,
    STATE(741), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2652), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29792] = 4,
    STATE(742), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2656), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29839] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2662), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2660), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [29884] = 4,
    STATE(780), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2664), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [29931] = 4,
    STATE(745), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2668), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [29978] = 4,
    STATE(749), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2672), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [30025] = 4,
    STATE(802), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2664), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [30072] = 8,
    ACTIONS(2561), 1,
      anon_sym_LT,
    ACTIONS(2565), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1998), 2,
      anon_sym_QMARK,
      sym__exclamation_operator,
    ACTIONS(1983), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(1981), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2001), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30127] = 4,
    STATE(785), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2672), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30174] = 4,
    STATE(786), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2668), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30221] = 4,
    STATE(787), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2623), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30268] = 4,
    STATE(788), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2656), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30315] = 4,
    STATE(789), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2652), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30362] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2650), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2648), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [30407] = 12,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2676), 1,
      anon_sym_in,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1989), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1996), 4,
      anon_sym_GT,
      sym__exclamation_operator,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 11,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [30470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2615), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2613), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2611), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2609), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30560] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2583), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2581), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [30605] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2607), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2605), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2603), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2601), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30695] = 16,
    ACTIONS(1646), 1,
      anon_sym_async,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2147), 1,
      anon_sym_EQ,
    ACTIONS(2151), 1,
      anon_sym_QMARK,
    ACTIONS(2153), 1,
      anon_sym_DOT,
    ACTIONS(2155), 1,
      anon_sym_QMARK_DOT,
    STATE(169), 1,
      sym__assignment_operator,
    STATE(1314), 1,
      sym__cascade_assignment_section,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(971), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(980), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [30766] = 16,
    ACTIONS(1716), 1,
      anon_sym_async,
    ACTIONS(2145), 1,
      anon_sym_LBRACK,
    ACTIONS(2147), 1,
      anon_sym_EQ,
    ACTIONS(2151), 1,
      anon_sym_QMARK,
    ACTIONS(2153), 1,
      anon_sym_DOT,
    ACTIONS(2155), 1,
      anon_sym_QMARK_DOT,
    STATE(169), 1,
      sym__assignment_operator,
    STATE(1318), 1,
      sym__cascade_assignment_section,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(971), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(980), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1714), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [30837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2641), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2639), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [30882] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2459), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30927] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2599), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2597), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [30972] = 15,
    ACTIONS(2678), 1,
      anon_sym_EQ,
    STATE(211), 1,
      sym__assignment_operator,
    STATE(1062), 1,
      sym_arguments,
    STATE(1314), 1,
      sym__cascade_assignment_section,
    STATE(2038), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(965), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(966), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1646), 3,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
    STATE(1159), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [31041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2595), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2593), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [31086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2591), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2589), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [31131] = 5,
    ACTIONS(2682), 1,
      anon_sym_QMARK_QMARK,
    STATE(780), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2680), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31180] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2335), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [31225] = 15,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2120), 1,
      anon_sym_EQ,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2130), 1,
      anon_sym_DOT,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    STATE(203), 1,
      sym__assignment_operator,
    STATE(858), 1,
      sym__cascade_assignment_section,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(977), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(978), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [31294] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2579), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2577), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [31339] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2575), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2573), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [31384] = 5,
    ACTIONS(2687), 1,
      anon_sym_PIPE_PIPE,
    STATE(785), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1699), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31433] = 5,
    ACTIONS(2690), 1,
      anon_sym_AMP_AMP,
    STATE(786), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1662), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31482] = 5,
    ACTIONS(2693), 1,
      anon_sym_PIPE,
    STATE(787), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1648), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31531] = 5,
    ACTIONS(2696), 1,
      anon_sym_CARET,
    STATE(788), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1638), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31580] = 5,
    ACTIONS(2699), 1,
      anon_sym_AMP,
    STATE(789), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1652), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31629] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2470), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2468), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31674] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2477), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2475), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31719] = 28,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1940), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2074), 1,
      sym__default_formal_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [31814] = 4,
    ACTIONS(2457), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2445), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [31861] = 15,
    ACTIONS(2678), 1,
      anon_sym_EQ,
    STATE(211), 1,
      sym__assignment_operator,
    STATE(1062), 1,
      sym_arguments,
    STATE(1312), 1,
      sym__cascade_assignment_section,
    STATE(2038), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(777), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    STATE(967), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1660), 3,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
    STATE(1159), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1656), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [31930] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2662), 12,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2660), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [31975] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2484), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2482), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2443), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2441), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32065] = 28,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(559), 1,
      anon_sym_required,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1773), 1,
      sym_formal_parameter,
    STATE(1939), 1,
      sym__default_named_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [32160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2557), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32205] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2553), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2551), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2549), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32295] = 5,
    ACTIONS(2704), 1,
      anon_sym_QMARK_QMARK,
    STATE(802), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2680), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [32344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2571), 10,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2569), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32389] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2587), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2585), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32434] = 4,
    ACTIONS(2617), 1,
      anon_sym_Function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2542), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32481] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2621), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2619), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32526] = 4,
    ACTIONS(2494), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2445), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32573] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2434), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [32618] = 5,
    ACTIONS(2707), 1,
      anon_sym_QMARK,
    STATE(836), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2542), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32667] = 4,
    ACTIONS(2512), 1,
      sym_increment_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2507), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2500), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32714] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2488), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2491), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2486), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2494), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [32762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2712), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2710), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2716), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2714), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2720), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2718), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2724), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2722), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32938] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2454), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2445), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2447), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2457), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [32988] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2726), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(838), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(836), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33076] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2445), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33120] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2732), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2730), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33164] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2736), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2734), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2381), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2379), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33252] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2740), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2738), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33296] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1684), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [33400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2760), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2758), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2762), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2768), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2766), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33532] = 27,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1940), 1,
      sym_formal_parameter,
    STATE(1941), 1,
      sym__default_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [33624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2760), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2758), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33668] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2449), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2454), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2447), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2457), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2772), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2770), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33760] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2776), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2774), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2780), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2778), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33848] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2507), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2509), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2500), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2502), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2512), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33898] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2784), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2782), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [33942] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2788), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2786), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [33986] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2772), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2770), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34030] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2491), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2445), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2486), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2494), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2792), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2790), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2796), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2794), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2800), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2798), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34212] = 27,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1940), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2074), 1,
      sym__default_formal_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [34304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2712), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2710), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1896), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1888), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34392] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2804), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2802), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1646), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1642), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34480] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2808), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2806), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2810), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34568] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2732), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2730), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34612] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2814), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34656] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2818), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2796), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2794), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2808), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2806), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2824), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2822), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2828), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2826), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [34876] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2800), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2798), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34920] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2824), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2822), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [34964] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1716), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1714), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2830), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2836), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2834), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2828), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2826), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1716), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1714), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35184] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2840), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2838), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35228] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2844), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2842), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35272] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2836), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2834), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2810), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2848), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2846), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35404] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2776), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2774), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2852), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2850), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2856), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2854), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35536] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2860), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2858), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35580] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2862), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2868), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2866), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35668] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2872), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2870), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35712] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2876), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2874), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35756] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2862), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2844), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2842), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35844] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2840), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2838), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2784), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2782), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [35932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2818), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [35976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2814), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2716), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2714), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2720), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2718), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2880), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2878), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36152] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2804), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2802), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36196] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1896), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1888), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2724), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2722), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36284] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2488), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2491), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2486), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2494), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [36332] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1680), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [36436] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2504), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2509), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2502), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2512), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36484] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1646), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1642), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [36528] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1676), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [36632] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1668), 1,
      anon_sym_QMARK,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1670), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1666), 5,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
  [36728] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2504), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2509), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2502), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2512), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [36776] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(880), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(878), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36820] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2884), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2882), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36864] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1652), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [36968] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2445), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [37012] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1638), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [37116] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1648), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [37220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2888), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2886), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [37264] = 30,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1694), 1,
      anon_sym_QMARK,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      sym_equality_operator,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1692), 4,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [37362] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1662), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [37466] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1699), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [37570] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(831), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(829), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [37614] = 33,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1452), 1,
      anon_sym_is,
    ACTIONS(1483), 1,
      anon_sym_as,
    ACTIONS(1688), 1,
      anon_sym_COLON,
    ACTIONS(2742), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2744), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2748), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2752), 1,
      anon_sym_PIPE,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2756), 1,
      anon_sym_AMP,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1141), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1217), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1218), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1223), 1,
      aux_sym__if_null_expression,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1365), 1,
      sym_is_operator,
    STATE(1390), 1,
      sym_as_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [37718] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2792), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2790), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [37762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2768), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2766), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [37806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2762), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [37850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2872), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2870), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [37894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2868), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2866), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [37938] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2740), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2738), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [37982] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2895), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2893), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38026] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2381), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2379), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38070] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2876), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2874), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38114] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2449), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2454), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2447), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2457), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38162] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2736), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2734), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(838), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(836), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2899), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2897), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38294] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2888), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2886), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38338] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2726), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38382] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2780), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2778), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2895), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2893), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2848), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2846), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38514] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2454), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2445), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2447), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2457), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38564] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2507), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2509), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2500), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2502), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2512), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2502), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2512), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2502), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2512), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38702] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2899), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2897), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38746] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2903), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2901), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2788), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2786), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38834] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2452), 2,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2491), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2445), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(2486), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2494), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38884] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2860), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2858), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [38928] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2830), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [38972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2856), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2854), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2852), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2850), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39060] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2903), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2901), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [39104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2880), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2878), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39148] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2884), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2882), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39192] = 26,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(1765), 1,
      sym_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [39281] = 11,
    ACTIONS(1981), 1,
      anon_sym_EQ,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(2001), 1,
      sym_increment_operator,
    ACTIONS(2003), 1,
      anon_sym_DOT,
    ACTIONS(2905), 1,
      anon_sym_COLON,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 3,
      anon_sym_QMARK,
      anon_sym_GT,
      sym__exclamation_operator,
    ACTIONS(1998), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(1983), 7,
      anon_sym_QMARK_QMARK,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(1976), 13,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [39340] = 26,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(561), 1,
      anon_sym_covariant,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(968), 1,
      sym__metadata,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1277), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1635), 1,
      sym__simple_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2035), 1,
      sym_formal_parameter,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1957), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(1634), 3,
      sym__normal_formal_parameter,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [39429] = 8,
    ACTIONS(2386), 1,
      anon_sym_SLASH,
    STATE(333), 1,
      sym_multiplicative_operator,
    STATE(943), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2383), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2381), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2379), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39481] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(2911), 1,
      anon_sym_AMP,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(332), 1,
      sym_multiplicative_operator,
    STATE(696), 1,
      sym_unconditional_assignable_selector,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1135), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [39575] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(333), 1,
      sym_multiplicative_operator,
    STATE(943), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2357), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2355), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [39627] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2915), 1,
      anon_sym_PIPE,
    ACTIONS(2917), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(696), 1,
      sym_unconditional_assignable_selector,
    STATE(982), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [39721] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(336), 1,
      sym_multiplicative_operator,
    STATE(961), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2412), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [39773] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_PIPE,
    ACTIONS(2923), 1,
      anon_sym_AMP,
    ACTIONS(2925), 1,
      anon_sym_DOT,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(336), 1,
      sym_multiplicative_operator,
    STATE(709), 1,
      sym_unconditional_assignable_selector,
    STATE(961), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [39867] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2927), 1,
      anon_sym_PIPE,
    ACTIONS(2929), 1,
      anon_sym_AMP,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(663), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(696), 1,
      sym_unconditional_assignable_selector,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [39961] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2137), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AT,
    ACTIONS(2139), 26,
      anon_sym_QMARK,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [40003] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2931), 1,
      anon_sym_PIPE,
    ACTIONS(2933), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(333), 1,
      sym_multiplicative_operator,
    STATE(696), 1,
      sym_unconditional_assignable_selector,
    STATE(945), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40097] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      sym_equality_operator,
    ACTIONS(2081), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_PIPE,
    ACTIONS(2923), 1,
      anon_sym_AMP,
    ACTIONS(2925), 1,
      anon_sym_DOT,
    STATE(270), 1,
      sym_relational_operator,
    STATE(271), 1,
      sym_shift_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(336), 1,
      sym_multiplicative_operator,
    STATE(690), 1,
      sym_unconditional_assignable_selector,
    STATE(961), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1027), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1050), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1094), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1096), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1100), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40191] = 29,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2925), 1,
      anon_sym_DOT,
    ACTIONS(2935), 1,
      anon_sym_PIPE,
    ACTIONS(2937), 1,
      anon_sym_AMP,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_multiplicative_operator,
    STATE(653), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(709), 1,
      sym_unconditional_assignable_selector,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40285] = 4,
    ACTIONS(2939), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1996), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
    ACTIONS(1976), 24,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [40329] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1475), 1,
      sym_equality_operator,
    ACTIONS(1479), 1,
      anon_sym_CARET,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2927), 1,
      anon_sym_PIPE,
    ACTIONS(2929), 1,
      anon_sym_AMP,
    STATE(257), 1,
      sym_additive_operator,
    STATE(258), 1,
      sym_shift_operator,
    STATE(259), 1,
      sym_relational_operator,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(654), 1,
      aux_sym_shift_expression_repeat1,
    STATE(663), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(695), 1,
      aux_sym_additive_expression_repeat1,
    STATE(762), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(763), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(764), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(810), 1,
      sym_unconditional_assignable_selector,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40423] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2014), 1,
      sym_equality_operator,
    ACTIONS(2018), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2931), 1,
      anon_sym_PIPE,
    ACTIONS(2933), 1,
      anon_sym_AMP,
    STATE(276), 1,
      sym_relational_operator,
    STATE(278), 1,
      sym_shift_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(333), 1,
      sym_multiplicative_operator,
    STATE(810), 1,
      sym_unconditional_assignable_selector,
    STATE(945), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1038), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1051), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1091), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1097), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1106), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2093), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AT,
    ACTIONS(2095), 26,
      anon_sym_QMARK,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [40559] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(333), 1,
      sym_multiplicative_operator,
    STATE(945), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2412), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [40611] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2141), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AT,
    ACTIONS(2143), 26,
      anon_sym_QMARK,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [40653] = 8,
    ACTIONS(2386), 1,
      anon_sym_SLASH,
    STATE(336), 1,
      sym_multiplicative_operator,
    STATE(960), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2383), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2381), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2379), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [40705] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(336), 1,
      sym_multiplicative_operator,
    STATE(960), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2357), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2355), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [40757] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2750), 1,
      sym_equality_operator,
    ACTIONS(2754), 1,
      anon_sym_CARET,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(2911), 1,
      anon_sym_AMP,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    STATE(301), 1,
      sym_additive_operator,
    STATE(302), 1,
      sym_shift_operator,
    STATE(303), 1,
      sym_relational_operator,
    STATE(332), 1,
      sym_multiplicative_operator,
    STATE(810), 1,
      sym_unconditional_assignable_selector,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1135), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1187), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1200), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1215), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1240), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1241), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40851] = 29,
    ACTIONS(1432), 1,
      sym_equality_operator,
    ACTIONS(1440), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2925), 1,
      anon_sym_DOT,
    ACTIONS(2935), 1,
      anon_sym_PIPE,
    ACTIONS(2937), 1,
      anon_sym_AMP,
    STATE(295), 1,
      sym_relational_operator,
    STATE(296), 1,
      sym_shift_operator,
    STATE(297), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_multiplicative_operator,
    STATE(653), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(657), 1,
      aux_sym_shift_expression_repeat1,
    STATE(688), 1,
      aux_sym_additive_expression_repeat1,
    STATE(690), 1,
      sym_unconditional_assignable_selector,
    STATE(739), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(752), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(753), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [40945] = 29,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2105), 1,
      sym_equality_operator,
    ACTIONS(2109), 1,
      anon_sym_CARET,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    ACTIONS(2915), 1,
      anon_sym_PIPE,
    ACTIONS(2917), 1,
      anon_sym_AMP,
    STATE(312), 1,
      sym_relational_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(314), 1,
      sym_shift_operator,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(810), 1,
      sym_unconditional_assignable_selector,
    STATE(982), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1103), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1144), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1156), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1164), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1168), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [41039] = 8,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2942), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_arguments,
    STATE(2038), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(965), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2205), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2203), 20,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [41090] = 12,
    ACTIONS(2678), 1,
      anon_sym_EQ,
    STATE(211), 1,
      sym__assignment_operator,
    STATE(1318), 1,
      sym__cascade_assignment_section,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(1125), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1716), 3,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
    STATE(1159), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1714), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [41149] = 12,
    ACTIONS(2678), 1,
      anon_sym_EQ,
    STATE(211), 1,
      sym__assignment_operator,
    STATE(1314), 1,
      sym__cascade_assignment_section,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(1125), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1646), 3,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
    STATE(1159), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(1642), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(2122), 10,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [41208] = 25,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2945), 1,
      anon_sym_covariant,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1227), 1,
      sym__metadata,
    STATE(1290), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(1610), 1,
      sym__declared_identifier,
    STATE(1644), 1,
      sym__simple_formal_parameter,
    STATE(2003), 1,
      sym__type,
    STATE(2288), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1645), 2,
      sym__function_formal_parameter,
      sym_constructor_param,
    STATE(1948), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [41293] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2788), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2786), 25,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_catch,
      anon_sym_else,
      anon_sym_with,
      anon_sym_implements,
  [41334] = 5,
    ACTIONS(1708), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(702), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2516), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2514), 19,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [41378] = 10,
    ACTIONS(2947), 1,
      anon_sym_LBRACK,
    ACTIONS(2950), 1,
      anon_sym_QMARK,
    ACTIONS(2953), 1,
      anon_sym_DOT,
    ACTIONS(2956), 1,
      anon_sym_QMARK_DOT,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(971), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(980), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2162), 4,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_async,
    ACTIONS(2157), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [41432] = 8,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_arguments,
    STATE(2038), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(965), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2231), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2229), 19,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [41482] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(829), 2,
      anon_sym_while,
      anon_sym_else,
    ACTIONS(838), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(836), 20,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
  [41524] = 8,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(617), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2231), 4,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(2229), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [41574] = 9,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(2961), 1,
      anon_sym_QMARK,
    ACTIONS(2965), 1,
      anon_sym_LT,
    STATE(984), 1,
      sym__nullable_type,
    STATE(989), 1,
      sym_type_parameters,
    STATE(1065), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2268), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2253), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [41626] = 9,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(2969), 1,
      anon_sym_QMARK,
    ACTIONS(2972), 1,
      anon_sym_LT,
    STATE(989), 1,
      sym_type_parameters,
    STATE(993), 1,
      sym__nullable_type,
    STATE(1065), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2298), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2287), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [41678] = 10,
    ACTIONS(2159), 1,
      anon_sym_LBRACK,
    ACTIONS(2164), 1,
      anon_sym_QMARK,
    ACTIONS(2167), 1,
      anon_sym_DOT,
    ACTIONS(2170), 1,
      anon_sym_QMARK_DOT,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2162), 2,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(977), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    STATE(978), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2157), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [41732] = 8,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_arguments,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(974), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2221), 4,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(2219), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [41782] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(982), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2412), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [41832] = 8,
    ACTIONS(2126), 1,
      anon_sym_LT,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_arguments,
    STATE(2038), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(972), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2221), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2219), 19,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [41882] = 9,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_QMARK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    STATE(1020), 1,
      sym_type_parameters,
    STATE(1023), 1,
      sym__nullable_type,
    STATE(1044), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2268), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2253), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [41934] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(335), 1,
      sym_multiplicative_operator,
    STATE(666), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1037), 1,
      sym__multiplicative_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2357), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2355), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [41984] = 9,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2985), 1,
      anon_sym_QMARK,
    ACTIONS(2988), 1,
      anon_sym_LT,
    STATE(1004), 1,
      sym__nullable_type,
    STATE(1020), 1,
      sym_type_parameters,
    STATE(1044), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2298), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2287), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [42036] = 7,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(2991), 1,
      anon_sym_QMARK,
    STATE(1070), 1,
      sym_parameter_type_list,
    STATE(1114), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2332), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2321), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [42083] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2895), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2893), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [42122] = 7,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_QMARK,
    STATE(1069), 1,
      sym_parameter_type_list,
    STATE(1129), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2335), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [42169] = 4,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(988), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    ACTIONS(2998), 25,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [42210] = 4,
    ACTIONS(3002), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(988), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    ACTIONS(3000), 25,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [42251] = 7,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(3005), 1,
      anon_sym_QMARK,
    STATE(986), 1,
      sym__nullable_type,
    STATE(1070), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2363), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [42298] = 5,
    ACTIONS(3012), 1,
      anon_sym_super,
    STATE(877), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3008), 15,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [42341] = 5,
    ACTIONS(3014), 1,
      anon_sym_super,
    STATE(864), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3008), 15,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [42384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2862), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42423] = 7,
    ACTIONS(2959), 1,
      anon_sym_LPAREN,
    ACTIONS(3016), 1,
      anon_sym_QMARK,
    STATE(1070), 1,
      sym_parameter_type_list,
    STATE(1114), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2363), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [42470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3021), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3019), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [42509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1896), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1888), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [42548] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2381), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2379), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2840), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2838), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42626] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2804), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2802), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [42665] = 12,
    ACTIONS(3023), 1,
      anon_sym_DQUOTE,
    ACTIONS(3026), 1,
      anon_sym_SQUOTE,
    ACTIONS(3029), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3032), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3035), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(3038), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(3041), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3044), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 2,
      anon_sym_QMARK,
      anon_sym_async,
    STATE(999), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1320), 11,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2381), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2379), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [42761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2844), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2842), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2862), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [42839] = 5,
    ACTIONS(3047), 1,
      anon_sym_super,
    STATE(1001), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3008), 15,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [42882] = 7,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    STATE(1072), 1,
      sym_parameter_type_list,
    STATE(1076), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2363), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [42929] = 6,
    ACTIONS(3052), 1,
      anon_sym_Function,
    STATE(976), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1005), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2279), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2277), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [42974] = 7,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(3055), 1,
      anon_sym_QMARK,
    STATE(1042), 1,
      sym_parameter_type_list,
    STATE(1112), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2335), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [43021] = 6,
    ACTIONS(3058), 1,
      anon_sym_Function,
    STATE(983), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1007), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2279), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2277), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43066] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1896), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1888), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43105] = 6,
    ACTIONS(3061), 1,
      anon_sym_Function,
    STATE(983), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1007), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2273), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2271), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43150] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2502), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2512), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43189] = 5,
    ACTIONS(3063), 1,
      anon_sym_super,
    STATE(1014), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3008), 15,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [43232] = 6,
    ACTIONS(3065), 1,
      anon_sym_Function,
    STATE(976), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1005), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2273), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2271), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43277] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2502), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2512), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2844), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2842), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43355] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3069), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3067), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [43394] = 6,
    ACTIONS(3065), 1,
      anon_sym_Function,
    STATE(976), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1005), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2249), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2247), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2840), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2838), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2895), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2893), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43517] = 6,
    ACTIONS(3061), 1,
      anon_sym_Function,
    STATE(983), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1007), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2249), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2247), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43562] = 7,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(3071), 1,
      anon_sym_QMARK,
    STATE(1006), 1,
      sym__nullable_type,
    STATE(1072), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2363), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [43609] = 12,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1286), 2,
      anon_sym_QMARK,
      anon_sym_async,
    STATE(999), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
    ACTIONS(1284), 11,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2804), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2802), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43705] = 7,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      anon_sym_QMARK,
    STATE(1072), 1,
      sym_parameter_type_list,
    STATE(1076), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2332), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2321), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [43752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3008), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [43790] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(278), 1,
      sym_shift_operator,
    STATE(1025), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1676), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [43838] = 7,
    ACTIONS(3078), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_LT,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2345), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [43884] = 6,
    STATE(271), 1,
      sym_shift_operator,
    STATE(1030), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2359), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43928] = 6,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3088), 1,
      anon_sym_DOT,
    ACTIONS(3090), 1,
      anon_sym_AT,
    STATE(1145), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3084), 25,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [43972] = 5,
    ACTIONS(3092), 1,
      anon_sym_DOT,
    STATE(1109), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2429), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [44014] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(271), 1,
      sym_shift_operator,
    STATE(1030), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1676), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44062] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3096), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3094), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3100), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3098), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3104), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3102), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44176] = 7,
    ACTIONS(3106), 1,
      anon_sym_QMARK,
    ACTIONS(3109), 1,
      anon_sym_LT,
    STATE(1045), 1,
      sym_type_arguments,
    STATE(1118), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2345), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [44222] = 5,
    ACTIONS(3112), 1,
      anon_sym_DOT,
    STATE(1086), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2429), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [44264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3116), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3114), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3120), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3118), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44340] = 6,
    STATE(278), 1,
      sym_shift_operator,
    STATE(1025), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1036), 1,
      sym__shift_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2359), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [44384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3124), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      sym__exclamation_operator,
      anon_sym_TILDE,
    ACTIONS(3122), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_super,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [44422] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2470), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2468), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2139), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2137), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44496] = 5,
    ACTIONS(3126), 1,
      anon_sym_QMARK,
    STATE(1116), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2459), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [44537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2551), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2549), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [44574] = 5,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    STATE(1076), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2363), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [44615] = 5,
    ACTIONS(3129), 1,
      anon_sym_QMARK,
    STATE(1107), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2434), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [44656] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2571), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2569), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44693] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1047), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1680), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [44736] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2143), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2141), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2477), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2475), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44810] = 5,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1053), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2496), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44851] = 5,
    STATE(282), 1,
      sym_additive_operator,
    STATE(1047), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2496), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [44892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2095), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2093), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44929] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(285), 1,
      sym_additive_operator,
    STATE(1053), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1680), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44972] = 17,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(3136), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3138), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1803), 1,
      sym_binary_operator,
    STATE(2151), 1,
      sym__bitwise_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3134), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3132), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(2159), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [45037] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2591), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2589), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2484), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2482), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45111] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2591), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2589), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [45148] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2443), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2441), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45185] = 17,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(3136), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3142), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1807), 1,
      sym_binary_operator,
    STATE(2151), 1,
      sym__bitwise_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3140), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3132), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(2159), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [45250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2551), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2549), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [45287] = 5,
    ACTIONS(3144), 1,
      anon_sym_QMARK,
    STATE(1085), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2434), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [45328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2650), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2648), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2662), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2660), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45402] = 17,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(3136), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3149), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1813), 1,
      sym_binary_operator,
    STATE(2151), 1,
      sym__bitwise_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3147), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3132), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(2159), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [45467] = 5,
    ACTIONS(3016), 1,
      anon_sym_QMARK,
    STATE(1114), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2363), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45508] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3153), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3151), 25,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [45545] = 17,
    ACTIONS(1446), 1,
      anon_sym_GT_GT,
    ACTIONS(1448), 1,
      sym__additive_operator,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    ACTIONS(3136), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3157), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1792), 1,
      sym_binary_operator,
    STATE(2151), 1,
      sym__bitwise_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1436), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1444), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3155), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3132), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(2159), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [45610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2583), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2581), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45647] = 5,
    ACTIONS(3159), 1,
      anon_sym_QMARK,
    STATE(1123), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2459), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45688] = 5,
    ACTIONS(2995), 1,
      anon_sym_QMARK,
    STATE(1129), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2335), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2641), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2639), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45766] = 5,
    ACTIONS(3055), 1,
      anon_sym_QMARK,
    STATE(1112), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2335), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [45807] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2553), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45843] = 5,
    ACTIONS(3162), 1,
      anon_sym_CARET,
    STATE(1074), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1638), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45883] = 5,
    ACTIONS(3165), 1,
      anon_sym_PIPE_PIPE,
    STATE(1075), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1699), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [45923] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2335), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [45959] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2557), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [45995] = 4,
    STATE(1119), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2672), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [46033] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2579), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2577), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46069] = 5,
    ACTIONS(3168), 1,
      anon_sym_QMARK,
    STATE(969), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2542), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46109] = 5,
    ACTIONS(3171), 1,
      anon_sym_PIPE,
    STATE(1081), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1648), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46149] = 5,
    ACTIONS(3174), 1,
      anon_sym_CARET,
    STATE(1082), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1638), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46189] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2603), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2601), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46225] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(314), 1,
      sym_shift_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1084), 1,
      aux_sym_shift_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1676), 14,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [46271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2575), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2573), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2621), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2619), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46343] = 5,
    ACTIONS(3177), 1,
      anon_sym_AMP_AMP,
    STATE(1087), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1662), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46383] = 5,
    ACTIONS(3180), 1,
      anon_sym_QMARK_QMARK,
    STATE(1088), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2680), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46423] = 4,
    ACTIONS(2617), 1,
      anon_sym_Function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2542), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46461] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2587), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2585), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46497] = 4,
    STATE(1082), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2656), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46535] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2611), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2609), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46571] = 5,
    ACTIONS(3183), 1,
      anon_sym_AMP,
    STATE(1093), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1652), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46611] = 4,
    STATE(1128), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2623), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [46649] = 5,
    ACTIONS(3186), 1,
      anon_sym_AMP,
    STATE(1095), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1652), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [46689] = 4,
    STATE(1074), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2656), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [46727] = 4,
    STATE(1093), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2652), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46765] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2595), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2593), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2553), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [46837] = 4,
    STATE(1095), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2652), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [46875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2587), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2585), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [46911] = 4,
    STATE(1088), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2664), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [46949] = 6,
    STATE(314), 1,
      sym_shift_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1084), 1,
      aux_sym_shift_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2359), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [46991] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2434), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [47027] = 4,
    STATE(1111), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2664), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47065] = 4,
    STATE(1081), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2623), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [47103] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2575), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2573), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47139] = 4,
    ACTIONS(2617), 1,
      anon_sym_Function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2542), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47177] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2621), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2619), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47213] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2599), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2597), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [47249] = 5,
    ACTIONS(3189), 1,
      anon_sym_QMARK_QMARK,
    STATE(1111), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2680), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47289] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2459), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [47325] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2579), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2577), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47361] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2335), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47397] = 4,
    STATE(1121), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2668), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47435] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2607), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2605), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [47471] = 4,
    STATE(1075), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2672), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [47509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2434), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47545] = 5,
    ACTIONS(3192), 1,
      anon_sym_PIPE_PIPE,
    STATE(1119), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1699), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2615), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2613), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47621] = 5,
    ACTIONS(3195), 1,
      anon_sym_AMP_AMP,
    STATE(1121), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1662), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2611), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2609), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47697] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2607), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2605), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47733] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2603), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2601), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47769] = 10,
    ACTIONS(2947), 1,
      anon_sym_LBRACK,
    ACTIONS(2950), 1,
      anon_sym_QMARK,
    ACTIONS(2953), 1,
      anon_sym_DOT,
    ACTIONS(2956), 1,
      anon_sym_QMARK_DOT,
    STATE(2350), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1125), 2,
      sym__cascade_subsection,
      aux_sym_cascade_section_repeat2,
    ACTIONS(2162), 3,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    STATE(1159), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
    ACTIONS(2157), 14,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_DOT_DOT,
  [47819] = 4,
    STATE(1087), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2668), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [47857] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2595), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2593), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47893] = 5,
    ACTIONS(3198), 1,
      anon_sym_PIPE,
    STATE(1128), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1648), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [47933] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2464), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2459), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [47969] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2599), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2597), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
  [48005] = 5,
    ACTIONS(3201), 1,
      anon_sym_QMARK,
    STATE(1139), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2542), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48045] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2557), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [48081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2615), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2613), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_Function,
  [48117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2830), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48152] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(332), 1,
      sym_multiplicative_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1142), 1,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2357), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2355), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [48197] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2830), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2903), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2901), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48267] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2762), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2788), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2786), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48337] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2768), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2766), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2814), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48407] = 8,
    ACTIONS(2386), 1,
      anon_sym_SLASH,
    STATE(332), 1,
      sym_multiplicative_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1142), 1,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2383), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2381), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2379), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [48452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2818), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48487] = 5,
    STATE(313), 1,
      sym_additive_operator,
    STATE(1149), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2496), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [48526] = 3,
    ACTIONS(3206), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3204), 25,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_covariant,
      anon_sym_export,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      sym_identifier,
  [48561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2814), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48596] = 8,
    ACTIONS(2418), 1,
      anon_sym_SLASH,
    STATE(332), 1,
      sym_multiplicative_operator,
    STATE(1037), 1,
      sym__multiplicative_operator,
    STATE(1135), 1,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2416), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2414), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2412), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [48641] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2899), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2897), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48676] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(313), 1,
      sym_additive_operator,
    STATE(1149), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1680), 15,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [48717] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2903), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2901), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2899), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2897), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2768), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2766), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48822] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2762), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_else,
  [48857] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2818), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [48892] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3214), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2158), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [48960] = 4,
    STATE(1167), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2623), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [48996] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2161), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49064] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3218), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2174), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49132] = 8,
    ACTIONS(2226), 1,
      anon_sym_LT,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_arguments,
    STATE(2038), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1161), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2221), 4,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(2219), 15,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49176] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1881), 1,
      sym_normal_parameter_type,
    STATE(2183), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49244] = 8,
    ACTIONS(2236), 1,
      anon_sym_LT,
    ACTIONS(3225), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_arguments,
    STATE(2038), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(965), 2,
      sym_argument_part,
      aux_sym_cascade_section_repeat1,
    ACTIONS(2231), 4,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(2229), 15,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49288] = 5,
    ACTIONS(3228), 1,
      anon_sym_AMP,
    STATE(1162), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1652), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49326] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3231), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2175), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49394] = 4,
    STATE(1162), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2652), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49430] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3233), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1835), 1,
      sym_normal_parameter_type,
    STATE(2344), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49498] = 5,
    ACTIONS(3235), 1,
      anon_sym_CARET,
    STATE(1166), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1638), 15,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49536] = 5,
    ACTIONS(3238), 1,
      anon_sym_PIPE,
    STATE(1167), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1648), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49574] = 4,
    STATE(1166), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2656), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49610] = 5,
    ACTIONS(3241), 1,
      anon_sym_AMP_AMP,
    STATE(1169), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1662), 15,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49648] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3244), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2213), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49716] = 5,
    ACTIONS(3246), 1,
      anon_sym_PIPE_PIPE,
    STATE(1171), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(1699), 15,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49754] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2157), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49822] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3251), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2222), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49890] = 5,
    ACTIONS(3253), 1,
      anon_sym_QMARK_QMARK,
    STATE(1174), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2680), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [49928] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1812), 1,
      sym_normal_parameter_type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(2170), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [49996] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3258), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2218), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [50064] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2160), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [50132] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    STATE(2274), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [50200] = 4,
    STATE(1169), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2668), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [50236] = 4,
    STATE(1174), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2664), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [50272] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3264), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1887), 1,
      sym_normal_parameter_type,
    STATE(2228), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [50340] = 20,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(3212), 1,
      anon_sym_LBRACK,
    ACTIONS(3266), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1791), 1,
      sym_normal_parameter_type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(2154), 1,
      sym_optional_parameter_types,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2343), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [50408] = 4,
    STATE(1171), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__exclamation_operator,
      anon_sym_DOT,
    ACTIONS(2672), 16,
      anon_sym_LBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_LPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
  [50444] = 13,
    ACTIONS(1252), 1,
      anon_sym_DQUOTE,
    ACTIONS(1254), 1,
      anon_sym_SQUOTE,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1260), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1262), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1266), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3270), 1,
      anon_sym_async,
    STATE(1654), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3268), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(1021), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [50497] = 19,
    ACTIONS(3272), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_void_type,
    ACTIONS(3278), 1,
      anon_sym_factory,
    ACTIONS(3280), 1,
      anon_sym_Function,
    ACTIONS(3285), 1,
      anon_sym_operator,
    ACTIONS(3287), 1,
      anon_sym_static,
    ACTIONS(3289), 1,
      sym_const_builtin,
    STATE(1064), 1,
      sym__operator,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1693), 1,
      sym__static,
    STATE(2137), 1,
      sym__type,
    STATE(2156), 1,
      sym__factory,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3283), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2189), 4,
      sym_operator_signature,
      sym_factory_constructor_signature,
      sym_constructor_signature,
      sym_constant_constructor_signature,
  [50562] = 19,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(3291), 1,
      sym_identifier,
    ACTIONS(3294), 1,
      sym_void_type,
    ACTIONS(3299), 1,
      anon_sym_Function,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1341), 1,
      sym__final_or_const,
    STATE(1349), 1,
      sym_function_type,
    STATE(1560), 1,
      sym__get,
    STATE(1568), 1,
      sym__set,
    STATE(1680), 1,
      sym__type,
    STATE(1714), 1,
      sym_setter_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3297), 2,
      anon_sym_var,
      anon_sym_late,
    ACTIONS(3302), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1674), 2,
      sym_getter_signature,
      sym_function_signature,
  [50626] = 6,
    STATE(302), 1,
      sym_shift_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1190), 1,
      aux_sym_shift_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2361), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2359), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [50663] = 9,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3306), 1,
      anon_sym_QMARK,
    ACTIONS(3309), 1,
      anon_sym_LT,
    STATE(1214), 1,
      sym_type_parameters,
    STATE(1239), 1,
      sym__nullable_type,
    STATE(1261), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2253), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2268), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [50706] = 9,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3311), 1,
      anon_sym_QMARK,
    STATE(1214), 1,
      sym_type_parameters,
    STATE(1224), 1,
      sym__nullable_type,
    STATE(1261), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2287), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2298), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [50749] = 8,
    ACTIONS(2403), 1,
      anon_sym_GT_GT,
    STATE(302), 1,
      sym_shift_operator,
    STATE(1036), 1,
      sym__shift_operator,
    STATE(1190), 1,
      aux_sym_shift_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1678), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1676), 11,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [50790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1726), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1728), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [50820] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1774), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1776), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [50850] = 7,
    ACTIONS(3314), 1,
      anon_sym_QMARK,
    ACTIONS(3316), 1,
      anon_sym_LT,
    STATE(1274), 1,
      sym_type_arguments,
    STATE(1299), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2345), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2353), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [50888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1750), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1752), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [50918] = 6,
    ACTIONS(2472), 1,
      sym__additive_operator,
    STATE(301), 1,
      sym_additive_operator,
    STATE(1195), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1680), 12,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
  [50954] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1754), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1756), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [50984] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3318), 1,
      sym_identifier,
    STATE(1643), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2039), 2,
      sym_uri,
      sym_dotted_identifier_list,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [51034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1758), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1760), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1762), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1764), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51094] = 5,
    STATE(301), 1,
      sym_additive_operator,
    STATE(1195), 1,
      aux_sym_additive_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2498), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2496), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51128] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1766), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1768), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1734), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1736), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2589), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2591), 11,
      anon_sym_extends,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [51218] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1710), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1712), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51248] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1742), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1744), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1718), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1720), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1722), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1724), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51338] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2549), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2551), 11,
      anon_sym_extends,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [51368] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1738), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1740), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51398] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1730), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1732), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51428] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3318), 1,
      sym_identifier,
    STATE(1643), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2004), 2,
      sym_uri,
      sym_dotted_identifier_list,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [51478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1770), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1772), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51508] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1746), 6,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1748), 15,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51538] = 7,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3320), 1,
      anon_sym_QMARK,
    STATE(1232), 1,
      sym__nullable_type,
    STATE(1270), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2371), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [51575] = 4,
    STATE(1221), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2625), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2623), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51606] = 5,
    ACTIONS(3323), 1,
      anon_sym_QMARK_QMARK,
    STATE(1216), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2685), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2680), 12,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51639] = 4,
    STATE(1219), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2670), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2668), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51670] = 4,
    STATE(1229), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2674), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2672), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51701] = 5,
    ACTIONS(3326), 1,
      anon_sym_AMP_AMP,
    STATE(1219), 1,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1664), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1662), 12,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51734] = 16,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3329), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [51789] = 5,
    ACTIONS(3331), 1,
      anon_sym_PIPE,
    STATE(1221), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1650), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1648), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51822] = 5,
    ACTIONS(3334), 1,
      anon_sym_CARET,
    STATE(1222), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1640), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1638), 12,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51855] = 4,
    STATE(1216), 1,
      aux_sym__if_null_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2666), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2664), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [51886] = 7,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3337), 1,
      anon_sym_QMARK,
    STATE(1270), 1,
      sym_parameter_type_list,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2371), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [51923] = 16,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3340), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [51978] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1612), 1,
      sym_uri,
    STATE(1641), 1,
      sym_configurable_uri,
    STATE(1643), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52027] = 16,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(1236), 1,
      anon_sym_covariant,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1281), 1,
      sym__covariant,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2260), 3,
      sym__final_const_var_or_type,
      sym__type,
      sym_inferred_type,
  [52082] = 6,
    ACTIONS(3342), 1,
      anon_sym_Function,
    STATE(1189), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1234), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2247), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2249), 8,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [52117] = 5,
    ACTIONS(3344), 1,
      anon_sym_PIPE_PIPE,
    STATE(1229), 1,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1699), 12,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [52150] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3347), 1,
      anon_sym_of,
    STATE(1643), 1,
      sym_string_literal,
    STATE(2130), 1,
      sym_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52199] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2621), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2619), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [52228] = 7,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    STATE(1264), 1,
      sym_parameter_type_list,
    STATE(1285), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2335), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2343), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [52265] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1456), 1,
      sym_uri,
    STATE(1491), 1,
      sym_configurable_uri,
    STATE(1643), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52314] = 6,
    ACTIONS(3352), 1,
      anon_sym_Function,
    STATE(1189), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1234), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2277), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2279), 8,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [52349] = 16,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      sym_void_type,
    ACTIONS(3363), 1,
      anon_sym_Function,
    ACTIONS(3366), 1,
      anon_sym_get,
    ACTIONS(3369), 1,
      anon_sym_static,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1331), 1,
      sym__static,
    STATE(1349), 1,
      sym_function_type,
    STATE(2119), 1,
      sym__type,
    STATE(2168), 1,
      sym__get,
    STATE(2189), 1,
      sym_getter_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    ACTIONS(3361), 4,
      anon_sym_factory,
      anon_sym_operator,
      anon_sym_set,
      sym_const_builtin,
  [52404] = 6,
    ACTIONS(3342), 1,
      anon_sym_Function,
    STATE(1189), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1234), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2271), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2273), 8,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [52439] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1612), 1,
      sym_uri,
    STATE(1643), 1,
      sym_string_literal,
    STATE(1664), 1,
      sym_configurable_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52488] = 13,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3372), 1,
      anon_sym_of,
    STATE(1643), 1,
      sym_string_literal,
    STATE(2014), 1,
      sym_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52537] = 7,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3337), 1,
      anon_sym_QMARK,
    STATE(1270), 1,
      sym_parameter_type_list,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2321), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2332), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [52574] = 4,
    STATE(1242), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2654), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2652), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [52605] = 4,
    STATE(1222), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2658), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2656), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [52636] = 5,
    ACTIONS(3374), 1,
      anon_sym_AMP,
    STATE(1242), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1654), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1652), 13,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
  [52669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2587), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2585), 10,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [52697] = 8,
    ACTIONS(3377), 1,
      anon_sym_EQ,
    ACTIONS(3379), 1,
      sym_increment_operator,
    STATE(180), 1,
      sym__assignment_operator,
    STATE(1008), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [52735] = 8,
    ACTIONS(3381), 1,
      anon_sym_EQ,
    ACTIONS(3383), 1,
      sym_increment_operator,
    STATE(239), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [52773] = 12,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1643), 1,
      sym_string_literal,
    STATE(1700), 1,
      sym_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [52819] = 8,
    ACTIONS(3383), 1,
      sym_increment_operator,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    STATE(233), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [52857] = 8,
    ACTIONS(3383), 1,
      sym_increment_operator,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    STATE(231), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [52895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 8,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2557), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [52923] = 15,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1878), 1,
      sym_normal_parameter_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [52975] = 8,
    ACTIONS(3379), 1,
      sym_increment_operator,
    ACTIONS(3389), 1,
      anon_sym_EQ,
    STATE(171), 1,
      sym__assignment_operator,
    STATE(1008), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53013] = 12,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1643), 1,
      sym_string_literal,
    STATE(2130), 1,
      sym_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [53059] = 15,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3391), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(2075), 1,
      sym_typed_identifier,
    STATE(2336), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [53111] = 15,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3393), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(2075), 1,
      sym_typed_identifier,
    STATE(2336), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [53163] = 8,
    ACTIONS(3383), 1,
      sym_increment_operator,
    ACTIONS(3395), 1,
      anon_sym_EQ,
    STATE(250), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53201] = 15,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1752), 1,
      sym__type,
    STATE(1823), 1,
      sym_typed_identifier,
    STATE(1920), 1,
      sym_normal_parameter_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [53253] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2595), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2593), 10,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [53281] = 8,
    ACTIONS(3383), 1,
      sym_increment_operator,
    ACTIONS(3397), 1,
      anon_sym_EQ,
    STATE(220), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53319] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2895), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2893), 15,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT,
  [53347] = 8,
    ACTIONS(3399), 1,
      anon_sym_EQ,
    ACTIONS(3401), 1,
      sym_increment_operator,
    STATE(241), 1,
      sym__assignment_operator,
    STATE(995), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53385] = 5,
    ACTIONS(3337), 1,
      anon_sym_QMARK,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2371), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [53417] = 8,
    ACTIONS(3403), 1,
      anon_sym_EQ,
    ACTIONS(3405), 1,
      sym_increment_operator,
    STATE(224), 1,
      sym__assignment_operator,
    STATE(886), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53455] = 15,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1965), 1,
      sym__type,
    STATE(1966), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [53507] = 5,
    ACTIONS(3411), 1,
      anon_sym_QMARK,
    STATE(1282), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2459), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2464), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [53539] = 8,
    ACTIONS(3383), 1,
      sym_increment_operator,
    ACTIONS(3414), 1,
      anon_sym_EQ,
    STATE(208), 1,
      sym__assignment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53577] = 8,
    ACTIONS(3405), 1,
      sym_increment_operator,
    ACTIONS(3416), 1,
      anon_sym_EQ,
    STATE(195), 1,
      sym__assignment_operator,
    STATE(886), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53615] = 12,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1643), 1,
      sym_string_literal,
    STATE(2014), 1,
      sym_uri,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [53661] = 5,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 7,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2429), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SEMI,
  [53693] = 8,
    ACTIONS(3401), 1,
      sym_increment_operator,
    ACTIONS(3420), 1,
      anon_sym_EQ,
    STATE(183), 1,
      sym__assignment_operator,
    STATE(995), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53731] = 5,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    STATE(1285), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2335), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2343), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [53763] = 12,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3268), 1,
      anon_sym_SEMI,
    STATE(1654), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [53809] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2553), 10,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [53837] = 8,
    ACTIONS(3401), 1,
      sym_increment_operator,
    ACTIONS(3422), 1,
      anon_sym_EQ,
    STATE(240), 1,
      sym__assignment_operator,
    STATE(995), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2128), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    STATE(2242), 3,
      sym__bitwise_operator,
      sym__shift_operator,
      sym__multiplicative_operator,
    ACTIONS(2122), 9,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [53875] = 5,
    ACTIONS(3424), 1,
      anon_sym_QMARK,
    STATE(1301), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2434), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2439), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [53907] = 14,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(2075), 1,
      sym_typed_identifier,
    STATE(2336), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [53956] = 18,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3426), 1,
      sym_identifier,
    ACTIONS(3429), 1,
      anon_sym_LBRACE,
    ACTIONS(3431), 1,
      anon_sym_LBRACK,
    ACTIONS(3433), 1,
      sym_void_type,
    ACTIONS(3435), 1,
      anon_sym_Function,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1667), 1,
      sym__type_not_function,
    STATE(1672), 1,
      sym_function_type,
    STATE(1781), 1,
      sym__type_not_void,
    STATE(1901), 1,
      sym__type,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2054), 1,
      sym_type_arguments,
    STATE(2055), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [54013] = 15,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(3437), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(2296), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2260), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
  [54064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2601), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2603), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54091] = 14,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1369), 1,
      sym__metadata,
    STATE(1859), 1,
      sym_typed_identifier,
    STATE(2336), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [54140] = 11,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_SQUOTE,
    ACTIONS(23), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(31), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(33), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(2287), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(427), 9,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
      aux_sym_string_literal_repeat1,
  [54183] = 14,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2364), 3,
      sym__final_const_var_or_type,
      sym__type,
      sym_inferred_type,
  [54232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2605), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2607), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54259] = 14,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2260), 3,
      sym__final_const_var_or_type,
      sym__type,
      sym_inferred_type,
  [54308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2335), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2343), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54335] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2459), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2464), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54362] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2597), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2599), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54389] = 11,
    ACTIONS(2429), 1,
      anon_sym_QMARK,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1484), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2239), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [54432] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2609), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2611), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2613), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2615), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54486] = 15,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(163), 1,
      anon_sym_late,
    ACTIONS(3437), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1325), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    STATE(2296), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(161), 2,
      sym_const_builtin,
      sym_final_builtin,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2320), 2,
      sym__final_const_var_or_type,
      sym_inferred_type,
  [54537] = 15,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(3444), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1589), 1,
      sym__set,
    STATE(1591), 1,
      sym__get,
    STATE(1712), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2055), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [54588] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2577), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2579), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54615] = 11,
    ACTIONS(2429), 1,
      anon_sym_QMARK,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(1510), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(3446), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [54657] = 17,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3429), 1,
      anon_sym_LBRACE,
    ACTIONS(3431), 1,
      anon_sym_LBRACK,
    ACTIONS(3433), 1,
      sym_void_type,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3448), 1,
      sym_identifier,
    ACTIONS(3451), 1,
      anon_sym_this,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1667), 1,
      sym__type_not_function,
    STATE(1672), 1,
      sym_function_type,
    STATE(1781), 1,
      sym__type_not_void,
    STATE(2054), 1,
      sym_type_arguments,
    STATE(2068), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [54711] = 15,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(3444), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1589), 1,
      sym__set,
    STATE(1632), 1,
      sym__get,
    STATE(1683), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2189), 2,
      sym_setter_signature,
      sym_function_signature,
  [54761] = 15,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    STATE(927), 1,
      sym__assignable_selector_part,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1307), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(888), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [54811] = 15,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3459), 1,
      anon_sym_QMARK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(3463), 1,
      anon_sym_QMARK_DOT,
    STATE(1013), 1,
      sym__assignable_selector_part,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1309), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(932), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [54861] = 15,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3459), 1,
      anon_sym_QMARK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(3463), 1,
      anon_sym_QMARK_DOT,
    STATE(928), 1,
      sym__assignable_selector_part,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1308), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(811), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [54911] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2434), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2439), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [54937] = 15,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    STATE(1010), 1,
      sym__assignable_selector_part,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1306), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(838), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [54987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2573), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
    ACTIONS(2575), 9,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [55013] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1594), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3465), 14,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [55038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1545), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3467), 14,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [55063] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3471), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3469), 14,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [55088] = 13,
    ACTIONS(3473), 1,
      anon_sym_LBRACK,
    ACTIONS(3476), 1,
      anon_sym_LPAREN,
    ACTIONS(3479), 1,
      anon_sym_QMARK,
    ACTIONS(3482), 1,
      anon_sym_LT,
    ACTIONS(3485), 1,
      sym__exclamation_operator,
    ACTIONS(3488), 1,
      anon_sym_DOT,
    ACTIONS(3491), 1,
      anon_sym_QMARK_DOT,
    STATE(1542), 1,
      sym_arguments,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2346), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1305), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1544), 4,
      sym_argument_part,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [55133] = 14,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1305), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(816), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [55180] = 14,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(2124), 1,
      anon_sym_QMARK,
    ACTIONS(2132), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1305), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(916), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [55227] = 14,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3459), 1,
      anon_sym_QMARK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(3463), 1,
      anon_sym_QMARK_DOT,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1305), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(830), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [55274] = 14,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      sym__exclamation_operator,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3459), 1,
      anon_sym_QMARK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(3463), 1,
      anon_sym_QMARK_DOT,
    STATE(1542), 1,
      sym_arguments,
    STATE(1544), 1,
      sym_argument_part,
    STATE(2091), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1305), 2,
      sym_selector,
      aux_sym__assignable_selector_part_repeat1,
    STATE(925), 3,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
      sym__assignable_selector,
  [55321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3496), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3494), 14,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      sym_final_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [55346] = 15,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3429), 1,
      anon_sym_LBRACE,
    ACTIONS(3431), 1,
      anon_sym_LBRACK,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(1781), 1,
      sym__type_not_void,
    STATE(2054), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [55394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1646), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1642), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55418] = 15,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    ACTIONS(3502), 1,
      anon_sym_LBRACE,
    ACTIONS(3504), 1,
      anon_sym_LBRACK,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1746), 1,
      sym__type_not_void,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(2061), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [55466] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1716), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(1714), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55490] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2903), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2901), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55514] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2830), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2836), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2834), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55562] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2860), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_async,
    ACTIONS(2858), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
      anon_sym_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55586] = 13,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3506), 1,
      anon_sym_late,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1336), 1,
      sym__late_builtin,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1880), 2,
      sym__type,
      sym_inferred_type,
  [55630] = 15,
    ACTIONS(3316), 1,
      anon_sym_LT,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    ACTIONS(3508), 1,
      anon_sym_LBRACE,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1737), 1,
      sym__type_not_void,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(1998), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [55678] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3514), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3512), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [55701] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2502), 3,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
    ACTIONS(2512), 11,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
  [55724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3518), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3516), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [55747] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3520), 1,
      sym_final_builtin,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1858), 2,
      sym__type,
      sym_inferred_type,
  [55788] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3522), 1,
      sym_final_builtin,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(2068), 2,
      sym__type,
      sym_inferred_type,
  [55829] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3526), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3524), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [55852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3530), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3528), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [55875] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3532), 1,
      sym_final_builtin,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1943), 2,
      sym__type,
      sym_inferred_type,
  [55916] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3536), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3534), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [55939] = 6,
    ACTIONS(3342), 1,
      anon_sym_Function,
    STATE(1189), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1236), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(3538), 5,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(3540), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
  [55968] = 13,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2119), 1,
      sym__type,
    STATE(2168), 1,
      sym__get,
    STATE(2258), 1,
      sym_getter_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56011] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3542), 1,
      sym_final_builtin,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1880), 2,
      sym__type,
      sym_inferred_type,
  [56052] = 11,
    ACTIONS(2429), 1,
      anon_sym_QMARK,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_LT,
    ACTIONS(3544), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1474), 1,
      sym__formal_parameter_part,
    STATE(1505), 1,
      sym_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      sym_identifier,
  [56091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3548), 2,
      anon_sym_EQ,
      anon_sym_async,
    ACTIONS(3546), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [56114] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3550), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1901), 1,
      sym__type,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2055), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56154] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(91), 1,
      anon_sym_var,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
    STATE(1796), 2,
      sym__type,
      sym_inferred_type,
  [56192] = 10,
    ACTIONS(2429), 1,
      anon_sym_QMARK,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1890), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [56228] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3553), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(1877), 1,
      sym__type,
    STATE(2093), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56268] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3556), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1796), 1,
      sym__type,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2258), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56308] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3558), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(1932), 1,
      sym__type,
    STATE(2055), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56348] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3558), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1819), 1,
      sym__type,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2258), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56388] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3556), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(1880), 1,
      sym__type,
    STATE(2189), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56428] = 10,
    ACTIONS(2429), 1,
      anon_sym_QMARK,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3441), 1,
      anon_sym_LT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1474), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(1974), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [56464] = 12,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3556), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(1861), 1,
      sym__type,
    STATE(2093), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56504] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3560), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1798), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56541] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3562), 1,
      sym_identifier,
    ACTIONS(3565), 1,
      anon_sym_this,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2056), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56578] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1697), 1,
      sym__type_not_void_list,
    STATE(1735), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [56617] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1608), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(3569), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [56646] = 5,
    ACTIONS(3571), 1,
      anon_sym_QMARK,
    STATE(1394), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3538), 5,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(3540), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
  [56671] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3573), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1953), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56708] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3451), 1,
      anon_sym_this,
    ACTIONS(3575), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2068), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56745] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1981), 1,
      sym__type_not_void,
    STATE(2101), 1,
      sym_mixin_application,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [56784] = 13,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3580), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_extends,
    ACTIONS(3584), 1,
      anon_sym_with,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(380), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1408), 1,
      sym_type_parameters,
    STATE(1691), 1,
      sym_superclass,
    STATE(2063), 1,
      sym_mixins,
    STATE(2065), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [56825] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1965), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [56862] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1735), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(2049), 1,
      sym__type_not_void_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [56901] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2547), 3,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
    ACTIONS(3588), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2542), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [56924] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1735), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1926), 1,
      sym__type_not_void_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [56963] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3590), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1815), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57000] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1707), 1,
      sym__type_not_void_list,
    STATE(1735), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57039] = 12,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1981), 1,
      sym__type_not_void,
    STATE(1983), 1,
      sym_mixin_application,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57078] = 13,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3580), 1,
      anon_sym_EQ,
    ACTIONS(3582), 1,
      anon_sym_extends,
    ACTIONS(3584), 1,
      anon_sym_with,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(421), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1412), 1,
      sym_type_parameters,
    STATE(1726), 1,
      sym_superclass,
    STATE(2063), 1,
      sym_mixins,
    STATE(2135), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [57119] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1668), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
    ACTIONS(3592), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [57148] = 11,
    ACTIONS(45), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_QMARK,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3594), 1,
      anon_sym_EQ,
    STATE(1274), 1,
      sym_type_arguments,
    STATE(1299), 1,
      sym__nullable_type,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1742), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2339), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [57185] = 11,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3596), 1,
      anon_sym_GT,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(1837), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57222] = 11,
    ACTIONS(3598), 1,
      sym_identifier,
    ACTIONS(3600), 1,
      sym_void_type,
    ACTIONS(3602), 1,
      anon_sym_Function,
    STATE(981), 1,
      sym__function_builtin_identifier,
    STATE(1026), 1,
      sym__type_name,
    STATE(1080), 1,
      sym_function_type,
    STATE(1089), 1,
      sym__type_not_void_not_function,
    STATE(1152), 1,
      sym__type_not_void,
    STATE(1783), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1019), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57258] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1753), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57294] = 11,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(1768), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57330] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2134), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57364] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2327), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57398] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(2020), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57434] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1756), 1,
      sym_function_type,
    STATE(1991), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57470] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(2001), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57506] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1999), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57542] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2053), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57576] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1777), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57612] = 11,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(1758), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57648] = 11,
    ACTIONS(3604), 1,
      sym_identifier,
    ACTIONS(3606), 1,
      sym_void_type,
    ACTIONS(3608), 1,
      anon_sym_Function,
    STATE(637), 1,
      sym__function_builtin_identifier,
    STATE(652), 1,
      sym__type_name,
    STATE(708), 1,
      sym_function_type,
    STATE(735), 1,
      sym__type_not_void_not_function,
    STATE(909), 1,
      sym__type_not_void,
    STATE(1754), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(635), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57684] = 11,
    ACTIONS(3435), 1,
      anon_sym_Function,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      sym_void_type,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1406), 1,
      sym__function_builtin_identifier,
    STATE(1414), 1,
      sym_function_type,
    STATE(1750), 1,
      sym__type_not_function,
    STATE(1751), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1435), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57720] = 11,
    ACTIONS(3604), 1,
      sym_identifier,
    ACTIONS(3606), 1,
      sym_void_type,
    ACTIONS(3608), 1,
      anon_sym_Function,
    STATE(637), 1,
      sym__function_builtin_identifier,
    STATE(652), 1,
      sym__type_name,
    STATE(708), 1,
      sym_function_type,
    STATE(735), 1,
      sym__type_not_void_not_function,
    STATE(908), 1,
      sym__type_not_void,
    STATE(1754), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(635), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57756] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1747), 1,
      sym__type_not_void,
    STATE(1755), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57792] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1349), 1,
      sym_function_type,
    STATE(1363), 1,
      sym__type_name,
    STATE(2085), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57826] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2092), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [57860] = 11,
    ACTIONS(3610), 1,
      sym_identifier,
    ACTIONS(3612), 1,
      sym_void_type,
    ACTIONS(3614), 1,
      anon_sym_Function,
    STATE(975), 1,
      sym__function_builtin_identifier,
    STATE(1034), 1,
      sym__type_name,
    STATE(1108), 1,
      sym__type_not_void_not_function,
    STATE(1131), 1,
      sym_function_type,
    STATE(1138), 1,
      sym__type_not_void,
    STATE(1748), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1016), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57896] = 11,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      sym_void_type,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1356), 1,
      sym__type_not_void_not_function,
    STATE(1414), 1,
      sym_function_type,
    STATE(1755), 1,
      sym__type_not_function,
    STATE(1759), 1,
      sym__type_not_void,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57932] = 11,
    ACTIONS(3610), 1,
      sym_identifier,
    ACTIONS(3612), 1,
      sym_void_type,
    ACTIONS(3614), 1,
      anon_sym_Function,
    STATE(975), 1,
      sym__function_builtin_identifier,
    STATE(1034), 1,
      sym__type_name,
    STATE(1108), 1,
      sym__type_not_void_not_function,
    STATE(1131), 1,
      sym_function_type,
    STATE(1140), 1,
      sym__type_not_void,
    STATE(1748), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1016), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [57968] = 11,
    ACTIONS(3616), 1,
      sym_identifier,
    ACTIONS(3618), 1,
      sym_void_type,
    ACTIONS(3620), 1,
      anon_sym_Function,
    STATE(648), 1,
      sym__function_builtin_identifier,
    STATE(656), 1,
      sym__type_name,
    STATE(805), 1,
      sym__type_not_void_not_function,
    STATE(809), 1,
      sym_function_type,
    STATE(827), 1,
      sym__type_not_void,
    STATE(1761), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(639), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [58004] = 11,
    ACTIONS(3616), 1,
      sym_identifier,
    ACTIONS(3618), 1,
      sym_void_type,
    ACTIONS(3620), 1,
      anon_sym_Function,
    STATE(648), 1,
      sym__function_builtin_identifier,
    STATE(656), 1,
      sym__type_name,
    STATE(805), 1,
      sym__type_not_void_not_function,
    STATE(809), 1,
      sym_function_type,
    STATE(826), 1,
      sym__type_not_void,
    STATE(1761), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(639), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [58040] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2057), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [58074] = 10,
    ACTIONS(89), 1,
      sym_void_type,
    ACTIONS(105), 1,
      anon_sym_Function,
    ACTIONS(3208), 1,
      sym_identifier,
    STATE(1188), 1,
      sym__function_builtin_identifier,
    STATE(1193), 1,
      sym__type_name,
    STATE(1349), 1,
      sym_function_type,
    STATE(2071), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1228), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1330), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [58108] = 11,
    ACTIONS(3598), 1,
      sym_identifier,
    ACTIONS(3600), 1,
      sym_void_type,
    ACTIONS(3602), 1,
      anon_sym_Function,
    STATE(981), 1,
      sym__function_builtin_identifier,
    STATE(1026), 1,
      sym__type_name,
    STATE(1080), 1,
      sym_function_type,
    STATE(1089), 1,
      sym__type_not_void_not_function,
    STATE(1153), 1,
      sym__type_not_void,
    STATE(1783), 1,
      sym__type_not_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1019), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [58144] = 9,
    ACTIONS(2287), 1,
      anon_sym_DOT,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3622), 1,
      anon_sym_LPAREN,
    ACTIONS(3625), 1,
      anon_sym_QMARK,
    STATE(1261), 1,
      sym_parameter_type_list,
    STATE(1480), 1,
      sym__nullable_type,
    STATE(1527), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2298), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [58175] = 7,
    ACTIONS(3630), 1,
      anon_sym_SQUOTE,
    ACTIONS(3632), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3628), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1403), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58202] = 5,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3640), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1417), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(3638), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [58225] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3642), 5,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
    ACTIONS(3644), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_GT,
  [58244] = 9,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3649), 1,
      anon_sym_QMARK,
    ACTIONS(3652), 1,
      anon_sym_extends,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1739), 1,
      sym__nullable_type,
    STATE(1995), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2429), 2,
      anon_sym_LT,
      anon_sym_Function,
    ACTIONS(3646), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [58275] = 7,
    ACTIONS(3654), 1,
      anon_sym_DQUOTE,
    ACTIONS(3658), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3656), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1398), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58302] = 7,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3666), 1,
      anon_sym_SQUOTE,
    ACTIONS(3668), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3664), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1399), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58329] = 7,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3670), 1,
      anon_sym_DQUOTE,
    ACTIONS(3674), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3672), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1415), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58356] = 7,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3678), 1,
      anon_sym_SQUOTE,
    ACTIONS(3680), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3676), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1416), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58383] = 4,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1421), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2514), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_else,
  [58404] = 5,
    ACTIONS(2113), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2516), 2,
      anon_sym_QMARK,
      anon_sym_DOT,
    STATE(1402), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2514), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
  [58427] = 5,
    ACTIONS(3682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2525), 2,
      anon_sym_QMARK,
      anon_sym_DOT,
    STATE(1402), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2523), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_QMARK_DOT,
  [58450] = 7,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3678), 1,
      anon_sym_SQUOTE,
    ACTIONS(3685), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3676), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1416), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58477] = 7,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3670), 1,
      anon_sym_DQUOTE,
    ACTIONS(3687), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3672), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1415), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58504] = 7,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3678), 1,
      anon_sym_SQUOTE,
    ACTIONS(3689), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3676), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1416), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58531] = 9,
    ACTIONS(2253), 1,
      anon_sym_DOT,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3691), 1,
      anon_sym_LPAREN,
    ACTIONS(3695), 1,
      anon_sym_QMARK,
    STATE(1261), 1,
      sym_parameter_type_list,
    STATE(1525), 1,
      sym__nullable_type,
    STATE(1527), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2268), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [58562] = 7,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3670), 1,
      anon_sym_DQUOTE,
    ACTIONS(3698), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3672), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1415), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58589] = 11,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3582), 1,
      anon_sym_extends,
    ACTIONS(3584), 1,
      anon_sym_with,
    ACTIONS(3586), 1,
      anon_sym_implements,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1676), 1,
      sym_superclass,
    STATE(2034), 1,
      sym_interfaces,
    STATE(2063), 1,
      sym_mixins,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [58624] = 7,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3702), 1,
      anon_sym_DQUOTE,
    ACTIONS(3706), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3704), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1407), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58651] = 7,
    ACTIONS(3660), 1,
      anon_sym_DOLLAR,
    ACTIONS(3662), 1,
      sym__unused_escape_sequence,
    ACTIONS(3708), 1,
      anon_sym_DQUOTE,
    ACTIONS(3712), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3710), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1404), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58678] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1538), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2557), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2559), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      sym_identifier,
  [58703] = 11,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3582), 1,
      anon_sym_extends,
    ACTIONS(3584), 1,
      anon_sym_with,
    ACTIONS(3586), 1,
      anon_sym_implements,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    STATE(420), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1732), 1,
      sym_superclass,
    STATE(2042), 1,
      sym_interfaces,
    STATE(2063), 1,
      sym_mixins,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [58738] = 9,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3714), 1,
      sym_void_type,
    ACTIONS(3716), 1,
      anon_sym_Function,
    STATE(1193), 1,
      sym__type_name,
    STATE(1509), 1,
      sym__function_builtin_identifier,
    STATE(2312), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1721), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1767), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [58769] = 4,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    STATE(969), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2542), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
  [58790] = 7,
    ACTIONS(3720), 1,
      anon_sym_DQUOTE,
    ACTIONS(3726), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3731), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3723), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(1415), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
  [58817] = 7,
    ACTIONS(3737), 1,
      anon_sym_SQUOTE,
    ACTIONS(3740), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3742), 1,
      anon_sym_DOLLAR,
    ACTIONS(3745), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3734), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1416), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [58844] = 5,
    ACTIONS(2525), 1,
      anon_sym_async,
    ACTIONS(3748), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1417), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2523), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [58867] = 5,
    ACTIONS(2085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3753), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1417), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(3751), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [58890] = 9,
    ACTIONS(3208), 1,
      sym_identifier,
    ACTIONS(3714), 1,
      sym_void_type,
    ACTIONS(3716), 1,
      anon_sym_Function,
    STATE(1193), 1,
      sym__type_name,
    STATE(1509), 1,
      sym__function_builtin_identifier,
    STATE(2233), 1,
      sym_function_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1721), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    STATE(1767), 2,
      sym__type_not_function,
      sym__type_not_void_not_function,
  [58921] = 4,
    ACTIONS(1226), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1422), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    ACTIONS(3755), 5,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [58942] = 4,
    ACTIONS(3757), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1421), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
    ACTIONS(2523), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_else,
  [58963] = 4,
    ACTIONS(3760), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1422), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
    ACTIONS(3763), 5,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [58984] = 7,
    ACTIONS(3634), 1,
      anon_sym_DOLLAR,
    ACTIONS(3636), 1,
      sym__unused_escape_sequence,
    ACTIONS(3767), 1,
      anon_sym_SQUOTE,
    ACTIONS(3769), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3765), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(1405), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
  [59011] = 6,
    ACTIONS(3773), 1,
      anon_sym_SQUOTE,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3771), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1452), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59035] = 7,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3781), 1,
      anon_sym_RBRACE,
    STATE(2122), 1,
      sym_enum_constant,
    STATE(2179), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [59061] = 6,
    ACTIONS(3783), 1,
      anon_sym_DQUOTE,
    ACTIONS(3787), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1448), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3785), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59085] = 6,
    ACTIONS(3793), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1443), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3791), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59109] = 6,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3799), 1,
      anon_sym_DQUOTE,
    ACTIONS(3803), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1432), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3801), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59133] = 5,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(3088), 1,
      anon_sym_DOT,
    STATE(1145), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3090), 6,
      anon_sym_AT,
      anon_sym_part,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_export,
      anon_sym_import,
  [59155] = 7,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3807), 1,
      anon_sym_EQ,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2429), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(3805), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [59181] = 6,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3811), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3809), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1440), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59205] = 6,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3813), 1,
      anon_sym_DQUOTE,
    ACTIONS(3817), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1468), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3815), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59229] = 6,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3821), 1,
      anon_sym_SQUOTE,
    ACTIONS(3823), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1449), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3819), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59253] = 6,
    ACTIONS(3825), 1,
      anon_sym_DQUOTE,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3827), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1439), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [59277] = 6,
    ACTIONS(3833), 1,
      anon_sym_Function,
    STATE(1391), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2249), 2,
      anon_sym_this,
      sym_identifier,
    STATE(1461), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2247), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
  [59301] = 6,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3837), 1,
      anon_sym_SQUOTE,
    ACTIONS(3839), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1427), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3835), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59325] = 7,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3544), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(2263), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2429), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_Function,
      anon_sym_operator,
  [59351] = 9,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(375), 1,
      sym__semicolon,
    STATE(381), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [59381] = 6,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3849), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3851), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1464), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [59405] = 6,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3855), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3853), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1465), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59429] = 6,
    ACTIONS(3314), 1,
      anon_sym_QMARK,
    ACTIONS(3316), 1,
      anon_sym_LT,
    STATE(1299), 1,
      sym__nullable_type,
    STATE(1500), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2353), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [59453] = 7,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3857), 1,
      anon_sym_RBRACE,
    STATE(2122), 1,
      sym_enum_constant,
    STATE(2179), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [59479] = 6,
    ACTIONS(3862), 1,
      anon_sym_SQUOTE,
    ACTIONS(3865), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3867), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1443), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3859), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59503] = 8,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(3807), 1,
      anon_sym_EQ,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3805), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1516), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [59531] = 6,
    ACTIONS(3793), 1,
      anon_sym_SQUOTE,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3870), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1443), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3791), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59555] = 6,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3813), 1,
      anon_sym_DQUOTE,
    ACTIONS(3872), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1468), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3815), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59579] = 6,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3874), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3853), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1465), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59603] = 6,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3813), 1,
      anon_sym_DQUOTE,
    ACTIONS(3876), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1468), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3815), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59627] = 6,
    ACTIONS(3793), 1,
      anon_sym_SQUOTE,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3878), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1443), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3791), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59651] = 5,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
    ACTIONS(2429), 4,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_SEMI,
  [59673] = 6,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3883), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3851), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1464), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [59697] = 6,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3885), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3853), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1465), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59721] = 6,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3887), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3889), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1451), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [59745] = 6,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3891), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3851), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1464), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [59769] = 8,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(375), 2,
      sym_function_body,
      sym__semicolon,
  [59797] = 6,
    ACTIONS(3895), 1,
      anon_sym_if,
    ACTIONS(3897), 1,
      anon_sym_deferred,
    STATE(2097), 1,
      sym__deferred,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1573), 2,
      sym_configuration_uri,
      aux_sym_configurable_uri_repeat1,
    ACTIONS(3893), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [59821] = 6,
    ACTIONS(3797), 1,
      anon_sym_DOLLAR,
    ACTIONS(3901), 1,
      anon_sym_SQUOTE,
    ACTIONS(3903), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1445), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(3899), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [59845] = 6,
    ACTIONS(3789), 1,
      anon_sym_DOLLAR,
    ACTIONS(3905), 1,
      anon_sym_DQUOTE,
    ACTIONS(3909), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1446), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3907), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [59869] = 8,
    ACTIONS(3911), 1,
      anon_sym_on,
    ACTIONS(3913), 1,
      anon_sym_catch,
    ACTIONS(3915), 1,
      anon_sym_finally,
    STATE(435), 1,
      sym_finally_clause,
    STATE(2088), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(922), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(1472), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
  [59897] = 6,
    ACTIONS(3833), 1,
      anon_sym_Function,
    STATE(1391), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2273), 2,
      anon_sym_this,
      sym_identifier,
    STATE(1461), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2271), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
  [59921] = 6,
    ACTIONS(3917), 1,
      anon_sym_Function,
    STATE(1391), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2279), 2,
      anon_sym_this,
      sym_identifier,
    STATE(1461), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
    ACTIONS(2277), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
  [59945] = 7,
    ACTIONS(3922), 1,
      anon_sym_COLON,
    ACTIONS(3924), 1,
      anon_sym_SEMI,
    ACTIONS(3926), 1,
      anon_sym_async,
    STATE(1674), 1,
      sym_initializers,
    STATE(2189), 1,
      sym_redirection,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3920), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [59971] = 6,
    ACTIONS(3775), 1,
      anon_sym_DOLLAR,
    ACTIONS(3777), 1,
      sym__unused_escape_sequence,
    ACTIONS(3930), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3928), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1447), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [59995] = 6,
    ACTIONS(3932), 1,
      anon_sym_DQUOTE,
    ACTIONS(3937), 1,
      anon_sym_DOLLAR,
    ACTIONS(3940), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3934), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1464), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [60019] = 6,
    ACTIONS(3946), 1,
      anon_sym_SQUOTE,
    ACTIONS(3948), 1,
      anon_sym_DOLLAR,
    ACTIONS(3951), 1,
      sym__unused_escape_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3943), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(1465), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_single_quotes_repeat1,
  [60043] = 6,
    ACTIONS(3829), 1,
      anon_sym_DOLLAR,
    ACTIONS(3831), 1,
      sym__unused_escape_sequence,
    ACTIONS(3954), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3956), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(1454), 4,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
      aux_sym__string_literal_double_quotes_repeat1,
  [60067] = 10,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(3958), 1,
      sym_identifier,
    ACTIONS(3960), 1,
      anon_sym_operator,
    STATE(1059), 1,
      sym__operator,
    STATE(1557), 1,
      sym__get,
    STATE(1559), 1,
      sym__set,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2189), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [60099] = 6,
    ACTIONS(3962), 1,
      anon_sym_DQUOTE,
    ACTIONS(3968), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3970), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1468), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(3965), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [60123] = 5,
    ACTIONS(3975), 1,
      anon_sym_async,
    ACTIONS(3977), 1,
      anon_sym_native,
    STATE(1655), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3973), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60144] = 5,
    ACTIONS(3981), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1498), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(3979), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [60165] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(3987), 1,
      anon_sym_async,
    STATE(1628), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3985), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60186] = 6,
    ACTIONS(3989), 1,
      anon_sym_on,
    ACTIONS(3992), 1,
      anon_sym_catch,
    STATE(2088), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1472), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
    ACTIONS(972), 3,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_else,
  [60209] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(1838), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60232] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(3999), 1,
      anon_sym_async,
    STATE(1631), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3997), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60253] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(2122), 1,
      sym_enum_constant,
    STATE(2179), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60276] = 6,
    ACTIONS(3880), 1,
      anon_sym_DOT,
    ACTIONS(4001), 1,
      anon_sym_EQ,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2429), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [60299] = 7,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(3349), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_LPAREN,
    STATE(1264), 1,
      sym_parameter_type_list,
    STATE(1285), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2343), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [60324] = 8,
    ACTIONS(99), 1,
      sym__assert_builtin,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4006), 1,
      sym_identifier,
    ACTIONS(4008), 1,
      anon_sym_super,
    STATE(1580), 1,
      sym_initializer_list_entry,
    STATE(2302), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1592), 2,
      sym_assertion,
      sym_field_initializer,
  [60351] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4012), 1,
      anon_sym_async,
    STATE(1636), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4010), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60372] = 7,
    ACTIONS(2363), 1,
      anon_sym_DOT,
    ACTIONS(3337), 1,
      anon_sym_QMARK,
    ACTIONS(4014), 1,
      anon_sym_LPAREN,
    STATE(1270), 1,
      sym_parameter_type_list,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [60397] = 5,
    ACTIONS(4019), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_async,
    STATE(1492), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4017), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60418] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4025), 1,
      anon_sym_async,
    STATE(1615), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4023), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60439] = 8,
    ACTIONS(99), 1,
      sym__assert_builtin,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4027), 1,
      sym_identifier,
    ACTIONS(4029), 1,
      anon_sym_super,
    STATE(1580), 1,
      sym_initializer_list_entry,
    STATE(2256), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1592), 2,
      sym_assertion,
      sym_field_initializer,
  [60466] = 4,
    ACTIONS(4033), 1,
      anon_sym_QMARK,
    STATE(1640), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4031), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60485] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(1966), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60508] = 5,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(4037), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1501), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(4035), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [60529] = 5,
    ACTIONS(4039), 1,
      anon_sym_DQUOTE,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1496), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4041), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [60550] = 5,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(4047), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1470), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(4045), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [60571] = 5,
    ACTIONS(4049), 1,
      anon_sym_DQUOTE,
    ACTIONS(4054), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1489), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4051), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [60592] = 9,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    ACTIONS(4057), 1,
      anon_sym_on,
    STATE(382), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1607), 1,
      sym_type_parameters,
    STATE(2079), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [60621] = 7,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4059), 1,
      anon_sym_as,
    STATE(365), 1,
      sym__semicolon,
    STATE(2342), 1,
      sym__as,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1617), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [60646] = 5,
    ACTIONS(4065), 1,
      anon_sym_COMMA,
    ACTIONS(4068), 1,
      anon_sym_async,
    STATE(1492), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4063), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60667] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4072), 1,
      anon_sym_async,
    STATE(1629), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4070), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60688] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(1814), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60711] = 8,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(4074), 1,
      anon_sym_QMARK,
    STATE(1618), 1,
      sym_type_parameters,
    STATE(1660), 1,
      sym__nullable_type,
    STATE(1760), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2287), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [60738] = 5,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(4076), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1489), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4078), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [60759] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(2026), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60782] = 5,
    ACTIONS(4083), 1,
      anon_sym_SQUOTE,
    ACTIONS(4085), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1498), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(4080), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [60803] = 8,
    ACTIONS(99), 1,
      sym__assert_builtin,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4027), 1,
      sym_identifier,
    ACTIONS(4029), 1,
      anon_sym_super,
    STATE(1810), 1,
      sym_initializer_list_entry,
    STATE(1857), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1592), 2,
      sym_assertion,
      sym_field_initializer,
  [60830] = 5,
    ACTIONS(3424), 1,
      anon_sym_QMARK,
    ACTIONS(4088), 1,
      anon_sym_DOT,
    STATE(1301), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2439), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_this,
      sym_identifier,
  [60851] = 5,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(4090), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1498), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(3979), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [60872] = 5,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(4092), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1489), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4078), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [60893] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(1954), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60916] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3995), 1,
      sym_identifier,
    STATE(1801), 1,
      sym_type_parameter,
    STATE(2204), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [60939] = 5,
    ACTIONS(4097), 1,
      anon_sym_COLON,
    ACTIONS(4099), 1,
      anon_sym_async,
    ACTIONS(4102), 1,
      anon_sym_native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4094), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60960] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4104), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_in,
  [60975] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4108), 1,
      anon_sym_async,
    STATE(1623), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4106), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [60996] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4110), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_in,
  [61011] = 9,
    ACTIONS(2253), 1,
      anon_sym_Function,
    ACTIONS(2287), 1,
      anon_sym_SEMI,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(4112), 1,
      anon_sym_QMARK,
    STATE(1618), 1,
      sym_type_parameters,
    STATE(1620), 1,
      sym__nullable_type,
    STATE(1760), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [61040] = 4,
    ACTIONS(4116), 1,
      anon_sym_QMARK,
    STATE(1661), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4114), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [61059] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4118), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_in,
  [61074] = 6,
    ACTIONS(75), 1,
      anon_sym_AT,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(1839), 1,
      sym_enum_constant,
    STATE(2179), 1,
      sym__metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(987), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym__metadata_repeat1,
  [61097] = 5,
    ACTIONS(4019), 1,
      anon_sym_COMMA,
    ACTIONS(4122), 1,
      anon_sym_async,
    STATE(1481), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4120), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61118] = 5,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(4124), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1523), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4126), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [61139] = 4,
    ACTIONS(4130), 1,
      anon_sym_QMARK,
    STATE(1609), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4128), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [61158] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4134), 1,
      anon_sym_async,
    STATE(1651), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4132), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61179] = 8,
    ACTIONS(99), 1,
      sym__assert_builtin,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4006), 1,
      sym_identifier,
    ACTIONS(4008), 1,
      anon_sym_super,
    STATE(1513), 1,
      sym_initializer_list_entry,
    STATE(1806), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1592), 2,
      sym_assertion,
      sym_field_initializer,
  [61206] = 5,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(4136), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1498), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(3979), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [61227] = 5,
    ACTIONS(3983), 1,
      anon_sym_DOLLAR,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1518), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(4138), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [61248] = 4,
    ACTIONS(4144), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4146), 3,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
    ACTIONS(4142), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
  [61267] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4152), 1,
      anon_sym_async,
    STATE(1650), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4150), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61288] = 4,
    ACTIONS(4156), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4158), 3,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
    ACTIONS(4154), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
  [61307] = 5,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(4160), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1489), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4078), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [61328] = 5,
    ACTIONS(3977), 1,
      anon_sym_native,
    ACTIONS(4164), 1,
      anon_sym_async,
    STATE(1647), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4162), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61349] = 7,
    ACTIONS(2321), 1,
      anon_sym_DOT,
    ACTIONS(3337), 1,
      anon_sym_QMARK,
    ACTIONS(4166), 1,
      anon_sym_LPAREN,
    STATE(1270), 1,
      sym_parameter_type_list,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2332), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [61374] = 5,
    ACTIONS(4043), 1,
      anon_sym_DOLLAR,
    ACTIONS(4170), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1502), 2,
      sym__sub_string_test,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(4172), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [61395] = 7,
    ACTIONS(2363), 1,
      anon_sym_DOT,
    ACTIONS(4014), 1,
      anon_sym_LPAREN,
    ACTIONS(4174), 1,
      anon_sym_QMARK,
    STATE(1270), 1,
      sym_parameter_type_list,
    STATE(1477), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2371), 3,
      anon_sym_Function,
      anon_sym_this,
      sym_identifier,
  [61420] = 3,
    ACTIONS(2736), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2734), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61436] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4177), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1885), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [61460] = 3,
    ACTIONS(838), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(836), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61476] = 3,
    ACTIONS(2728), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2726), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61492] = 3,
    ACTIONS(2868), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2866), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61508] = 3,
    ACTIONS(2470), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2468), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61524] = 3,
    ACTIONS(2477), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61540] = 3,
    ACTIONS(2872), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2870), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61556] = 3,
    ACTIONS(2772), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61572] = 4,
    ACTIONS(4181), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4179), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(4183), 3,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
  [61590] = 3,
    ACTIONS(4187), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4185), 6,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61606] = 3,
    ACTIONS(2880), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2878), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61622] = 3,
    ACTIONS(2884), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2882), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61638] = 3,
    ACTIONS(2784), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61654] = 3,
    ACTIONS(2650), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2648), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61670] = 3,
    ACTIONS(4191), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4189), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61686] = 3,
    ACTIONS(2452), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2445), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61702] = 3,
    ACTIONS(2484), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2482), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61718] = 3,
    ACTIONS(4195), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 6,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [61734] = 3,
    ACTIONS(2571), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2569), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61750] = 7,
    ACTIONS(3913), 1,
      anon_sym_catch,
    ACTIONS(4197), 1,
      anon_sym_on,
    ACTIONS(4199), 1,
      anon_sym_finally,
    STATE(455), 1,
      sym_finally_clause,
    STATE(2133), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(351), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
  [61774] = 3,
    ACTIONS(2856), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2854), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61790] = 4,
    ACTIONS(4203), 1,
      anon_sym_EQ,
    ACTIONS(4205), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4201), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [61808] = 3,
    ACTIONS(2800), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2798), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61824] = 7,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    ACTIONS(4209), 1,
      anon_sym_async,
    ACTIONS(4211), 1,
      anon_sym_EQ_GT,
    STATE(938), 1,
      sym_function_expression_body,
    STATE(939), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4213), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61848] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(4215), 1,
      anon_sym_async,
    ACTIONS(4217), 1,
      anon_sym_EQ_GT,
    STATE(1539), 1,
      sym_function_expression_body,
    STATE(1540), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4219), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61872] = 3,
    ACTIONS(4195), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 6,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [61888] = 3,
    ACTIONS(2776), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [61904] = 3,
    ACTIONS(4223), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4221), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61920] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4225), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1524), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [61944] = 3,
    ACTIONS(4229), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4227), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [61960] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4231), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1524), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [61984] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4233), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1471), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62008] = 6,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(4001), 1,
      anon_sym_EQ,
    STATE(1231), 1,
      sym__type_dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1974), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2429), 2,
      anon_sym_QMARK,
      anon_sym_LT,
  [62030] = 4,
    ACTIONS(4237), 1,
      anon_sym_EQ,
    ACTIONS(4239), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4235), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [62048] = 3,
    ACTIONS(2780), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62064] = 3,
    ACTIONS(2443), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2441), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62080] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4241), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1885), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62104] = 8,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(3958), 1,
      sym_identifier,
    STATE(1557), 1,
      sym__get,
    STATE(1559), 1,
      sym__set,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2055), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [62130] = 3,
    ACTIONS(2848), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2846), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62146] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4243), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1471), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62170] = 3,
    ACTIONS(2888), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2886), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62186] = 3,
    ACTIONS(2796), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2794), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62202] = 3,
    ACTIONS(2760), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2758), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62218] = 4,
    ACTIONS(4247), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4245), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(4249), 3,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
  [62236] = 4,
    ACTIONS(3895), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1584), 2,
      sym_configuration_uri,
      aux_sym_configurable_uri_repeat1,
    ACTIONS(4251), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [62254] = 3,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62270] = 3,
    ACTIONS(2732), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2730), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62286] = 3,
    ACTIONS(2852), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2850), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62302] = 3,
    ACTIONS(2720), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62318] = 3,
    ACTIONS(2808), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2806), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62334] = 3,
    ACTIONS(2876), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2874), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62350] = 3,
    ACTIONS(4068), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4063), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62366] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(1304), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62390] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(454), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62414] = 7,
    ACTIONS(4253), 1,
      anon_sym_LBRACE,
    ACTIONS(4255), 1,
      anon_sym_async,
    ACTIONS(4257), 1,
      anon_sym_EQ_GT,
    STATE(884), 1,
      sym_function_expression_body,
    STATE(896), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4259), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62438] = 4,
    ACTIONS(4263), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1584), 2,
      sym_configuration_uri,
      aux_sym_configurable_uri_repeat1,
    ACTIONS(4261), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [62456] = 3,
    ACTIONS(2824), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2822), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62472] = 3,
    ACTIONS(2828), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2826), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62488] = 3,
    ACTIONS(2792), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2790), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62504] = 3,
    ACTIONS(2724), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62520] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4266), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1942), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62544] = 3,
    ACTIONS(2716), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62560] = 7,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4268), 1,
      sym_identifier,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1942), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62584] = 3,
    ACTIONS(4272), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4270), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62600] = 3,
    ACTIONS(2740), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2738), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62616] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(1303), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62640] = 3,
    ACTIONS(2812), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2810), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym__exclamation_operator,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [62656] = 5,
    ACTIONS(3926), 1,
      anon_sym_async,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(2189), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3920), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62676] = 8,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(4276), 1,
      sym_identifier,
    STATE(1557), 1,
      sym__get,
    STATE(1559), 1,
      sym__set,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2055), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [62702] = 7,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    ACTIONS(4279), 1,
      anon_sym_LBRACE,
    ACTIONS(4281), 1,
      anon_sym_async,
    STATE(349), 1,
      sym_block,
    STATE(454), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4283), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62726] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(1310), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62750] = 7,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(3843), 1,
      anon_sym_async,
    ACTIONS(3845), 1,
      anon_sym_EQ_GT,
    STATE(349), 1,
      sym_block,
    STATE(1302), 1,
      sym_function_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3847), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62774] = 7,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    ACTIONS(4285), 1,
      anon_sym_async,
    ACTIONS(4287), 1,
      anon_sym_EQ_GT,
    STATE(938), 1,
      sym_function_expression_body,
    STATE(939), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4213), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62798] = 3,
    ACTIONS(4291), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4289), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62814] = 7,
    ACTIONS(3911), 1,
      anon_sym_on,
    ACTIONS(3913), 1,
      anon_sym_catch,
    ACTIONS(3915), 1,
      anon_sym_finally,
    STATE(455), 1,
      sym_finally_clause,
    STATE(2088), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1459), 2,
      sym__on_part,
      aux_sym_try_statement_repeat1,
  [62838] = 3,
    ACTIONS(4295), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4293), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [62854] = 6,
    ACTIONS(2189), 1,
      anon_sym_LBRACE,
    ACTIONS(2191), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
    STATE(2318), 1,
      sym_optional_formal_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2199), 2,
      sym__optional_postional_formal_parameters,
      sym__named_formal_parameters,
  [62875] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1516), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [62896] = 7,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    ACTIONS(4299), 1,
      anon_sym_on,
    STATE(371), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2037), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [62919] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4301), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [62932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4303), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [62945] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4305), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [62958] = 6,
    ACTIONS(3652), 1,
      anon_sym_extends,
    ACTIONS(4309), 1,
      anon_sym_QMARK,
    STATE(1763), 1,
      sym__nullable_type,
    STATE(1979), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4307), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [62979] = 4,
    ACTIONS(3895), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1573), 2,
      sym_configuration_uri,
      aux_sym_configurable_uri_repeat1,
    ACTIONS(3893), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [62996] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2312), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63017] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4311), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63030] = 3,
    ACTIONS(4316), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4314), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63045] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1471), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63066] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(354), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63085] = 6,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      anon_sym_QMARK,
    STATE(1663), 1,
      sym__nullable_type,
    STATE(1779), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [63106] = 3,
    ACTIONS(4322), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4320), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63121] = 7,
    ACTIONS(2321), 1,
      anon_sym_Function,
    ACTIONS(2363), 1,
      anon_sym_SEMI,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    STATE(1284), 1,
      sym__nullable_type,
    STATE(1779), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [63144] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1507), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63165] = 4,
    ACTIONS(3924), 1,
      anon_sym_SEMI,
    ACTIONS(3926), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3920), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63182] = 3,
    ACTIONS(4328), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4326), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63197] = 3,
    ACTIONS(4195), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63212] = 3,
    ACTIONS(4332), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4330), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63227] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1910), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63248] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 6,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63261] = 3,
    ACTIONS(4336), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4334), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63276] = 3,
    ACTIONS(4340), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4338), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63291] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(353), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63310] = 3,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4342), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63325] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1942), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63346] = 4,
    ACTIONS(4348), 1,
      anon_sym_DOT,
    STATE(1633), 1,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4346), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [63363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4351), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63376] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4353), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63389] = 3,
    ACTIONS(4357), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4355), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63404] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4361), 1,
      anon_sym_COLON,
    STATE(437), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4359), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
  [63423] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 6,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63436] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1515), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63457] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4114), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63470] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(361), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1646), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63489] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(358), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63508] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4363), 6,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [63521] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4365), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63534] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4367), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63547] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(357), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63566] = 3,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4369), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63581] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(355), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1675), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63600] = 3,
    ACTIONS(4195), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63615] = 3,
    ACTIONS(4375), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4373), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63630] = 3,
    ACTIONS(4379), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4377), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63645] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1889), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63666] = 3,
    ACTIONS(4332), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4330), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63681] = 3,
    ACTIONS(4383), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4381), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63696] = 3,
    ACTIONS(4025), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4023), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [63711] = 3,
    ACTIONS(4385), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4387), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63726] = 3,
    ACTIONS(4322), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4320), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63741] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4389), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63754] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1479), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63775] = 6,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    STATE(1284), 1,
      sym__nullable_type,
    STATE(1779), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [63796] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4128), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63809] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1883), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63830] = 6,
    ACTIONS(3304), 1,
      anon_sym_LPAREN,
    ACTIONS(4392), 1,
      anon_sym_QMARK,
    STATE(1285), 1,
      sym__nullable_type,
    STATE(1772), 1,
      sym_parameter_type_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2335), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [63851] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(357), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1630), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63870] = 6,
    ACTIONS(3652), 1,
      anon_sym_extends,
    ACTIONS(4396), 1,
      anon_sym_QMARK,
    STATE(1739), 1,
      sym__nullable_type,
    STATE(1995), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4394), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [63891] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1885), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63912] = 5,
    ACTIONS(3833), 1,
      anon_sym_Function,
    STATE(1391), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3538), 2,
      anon_sym_this,
      sym_identifier,
    STATE(1460), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [63931] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3569), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [63944] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1524), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [63965] = 3,
    ACTIONS(4385), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4387), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [63980] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(364), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1642), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [63999] = 5,
    ACTIONS(4398), 1,
      anon_sym_QMARK,
    STATE(1738), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2542), 2,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(3538), 2,
      anon_sym_this,
      sym_identifier,
  [64018] = 6,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1971), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1510), 2,
      sym__formal_parameter_part,
      sym_formal_parameter_list,
  [64039] = 4,
    ACTIONS(4402), 1,
      anon_sym_SEMI,
    ACTIONS(4404), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4400), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [64056] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(364), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4061), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [64075] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(412), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2100), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64095] = 6,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4408), 1,
      anon_sym_RPAREN,
    STATE(149), 1,
      sym__semicolon,
    STATE(1888), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64115] = 6,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(4410), 1,
      anon_sym_QMARK,
    STATE(926), 1,
      sym_unconditional_assignable_selector,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64135] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64147] = 6,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(4412), 1,
      sym_identifier,
    STATE(1557), 1,
      sym__get,
    STATE(1559), 1,
      sym__set,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64167] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1633), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2303), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64187] = 4,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1731), 1,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4416), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [64203] = 6,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(4418), 1,
      sym_identifier,
    STATE(1565), 1,
      sym__set,
    STATE(1666), 1,
      sym__get,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64223] = 6,
    ACTIONS(4420), 1,
      sym_identifier,
    ACTIONS(4422), 1,
      anon_sym_factory,
    STATE(1933), 1,
      sym_qualified,
    STATE(1989), 1,
      sym_factory_constructor_signature,
    STATE(2190), 1,
      sym__factory,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64243] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1686), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2046), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64263] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1633), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(1985), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64283] = 6,
    ACTIONS(3278), 1,
      anon_sym_factory,
    ACTIONS(4420), 1,
      sym_identifier,
    STATE(1933), 1,
      sym_qualified,
    STATE(2156), 1,
      sym__factory,
    STATE(2258), 1,
      sym_factory_constructor_signature,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4330), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64315] = 6,
    ACTIONS(4424), 1,
      anon_sym_export,
    ACTIONS(4426), 1,
      anon_sym_import,
    STATE(363), 1,
      sym_import_specification,
    STATE(1233), 1,
      sym__import,
    STATE(1237), 1,
      sym__export,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64335] = 6,
    ACTIONS(3457), 1,
      anon_sym_LBRACK,
    ACTIONS(3461), 1,
      anon_sym_DOT,
    ACTIONS(4410), 1,
      anon_sym_QMARK,
    STATE(890), 1,
      sym_unconditional_assignable_selector,
    STATE(2352), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64355] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(373), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2044), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64375] = 4,
    ACTIONS(4430), 1,
      anon_sym_COMMA,
    STATE(1724), 1,
      aux_sym__type_not_void_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4428), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [64391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4432), 5,
      sym_void_type,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [64403] = 6,
    ACTIONS(4434), 1,
      sym_identifier,
    ACTIONS(4436), 1,
      anon_sym_LBRACK,
    ACTIONS(4438), 1,
      anon_sym_QMARK,
    STATE(493), 1,
      sym_cascade_selector,
    STATE(2349), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64423] = 4,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3751), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1421), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
  [64439] = 4,
    ACTIONS(2022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3638), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1421), 2,
      sym_cascade_section,
      aux_sym__expression_repeat1,
  [64455] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(395), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2064), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64475] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1562), 1,
      sym_formal_parameter_list,
    STATE(1711), 1,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64495] = 6,
    ACTIONS(4440), 1,
      sym_identifier,
    ACTIONS(4442), 1,
      anon_sym_LBRACK,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    STATE(607), 1,
      sym_cascade_selector,
    STATE(2333), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64515] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4446), 5,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_show,
      anon_sym_hide,
  [64527] = 6,
    ACTIONS(4448), 1,
      sym_identifier,
    ACTIONS(4450), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_QMARK,
    STATE(597), 1,
      sym_cascade_selector,
    STATE(2345), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64547] = 6,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2925), 1,
      anon_sym_DOT,
    STATE(709), 1,
      sym_unconditional_assignable_selector,
    STATE(2351), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64567] = 5,
    ACTIONS(2277), 1,
      anon_sym_SEMI,
    ACTIONS(4454), 1,
      anon_sym_Function,
    STATE(1495), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1703), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [64585] = 4,
    ACTIONS(4457), 1,
      anon_sym_COMMA,
    STATE(1717), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4459), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [64601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4330), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64613] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4193), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64625] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(389), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2069), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64645] = 5,
    ACTIONS(2271), 1,
      anon_sym_SEMI,
    ACTIONS(4461), 1,
      anon_sym_Function,
    STATE(1495), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1703), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [64663] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1681), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2145), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64683] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4320), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64695] = 6,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1550), 1,
      sym_formal_parameter_list,
    STATE(1633), 1,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64715] = 6,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(4418), 1,
      sym_identifier,
    STATE(1529), 1,
      sym__get,
    STATE(1565), 1,
      sym__set,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64735] = 6,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    ACTIONS(4463), 1,
      anon_sym_QMARK,
    STATE(834), 1,
      sym_unconditional_assignable_selector,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64755] = 3,
    ACTIONS(4404), 1,
      anon_sym_async,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4400), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [64769] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4346), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [64781] = 4,
    ACTIONS(4465), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4467), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(1716), 2,
      sym_combinator,
      aux_sym_library_export_repeat1,
  [64797] = 4,
    ACTIONS(4470), 1,
      anon_sym_COMMA,
    STATE(1717), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4473), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [64813] = 6,
    ACTIONS(1845), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_QMARK,
    ACTIONS(2913), 1,
      anon_sym_DOT,
    STATE(810), 1,
      sym_unconditional_assignable_selector,
    STATE(2237), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64833] = 5,
    ACTIONS(107), 1,
      anon_sym_get,
    ACTIONS(113), 1,
      anon_sym_set,
    ACTIONS(4475), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1669), 2,
      sym__get,
      sym__set,
  [64851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4387), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64863] = 5,
    ACTIONS(2247), 1,
      anon_sym_SEMI,
    ACTIONS(4461), 1,
      anon_sym_Function,
    STATE(1495), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1703), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [64881] = 6,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4480), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_SEMI,
    ACTIONS(4484), 1,
      anon_sym_in,
    STATE(1804), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64901] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4320), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64913] = 4,
    ACTIONS(4488), 1,
      anon_sym_COMMA,
    STATE(1724), 1,
      aux_sym__type_not_void_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4486), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [64929] = 4,
    ACTIONS(4457), 1,
      anon_sym_COMMA,
    STATE(1704), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4491), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [64945] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(370), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(1992), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64965] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4387), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [64977] = 6,
    ACTIONS(4440), 1,
      sym_identifier,
    ACTIONS(4442), 1,
      anon_sym_LBRACK,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    STATE(794), 1,
      sym_cascade_selector,
    STATE(2333), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [64997] = 6,
    ACTIONS(4448), 1,
      sym_identifier,
    ACTIONS(4450), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_QMARK,
    STATE(477), 1,
      sym_cascade_selector,
    STATE(2345), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65017] = 6,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4493), 1,
      anon_sym_RPAREN,
    STATE(152), 1,
      sym__semicolon,
    STATE(1836), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65037] = 4,
    ACTIONS(4414), 1,
      anon_sym_DOT,
    STATE(1633), 1,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4495), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [65053] = 6,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(3586), 1,
      anon_sym_implements,
    STATE(408), 1,
      sym_class_body,
    STATE(1355), 1,
      sym__implements,
    STATE(2127), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65073] = 3,
    ACTIONS(4361), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4359), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65087] = 6,
    ACTIONS(2118), 1,
      anon_sym_LBRACK,
    ACTIONS(3455), 1,
      anon_sym_DOT,
    ACTIONS(4463), 1,
      anon_sym_QMARK,
    STATE(894), 1,
      sym_unconditional_assignable_selector,
    STATE(2326), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65107] = 4,
    ACTIONS(4430), 1,
      anon_sym_COMMA,
    STATE(1692), 1,
      aux_sym__type_not_void_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4497), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [65123] = 5,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4480), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_SEMI,
    STATE(1804), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65140] = 5,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(825), 1,
      sym_arguments,
    STATE(2058), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2786), 2,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(3642), 2,
      anon_sym_this,
      sym_identifier,
  [65170] = 4,
    ACTIONS(3652), 1,
      anon_sym_extends,
    STATE(1976), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4501), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [65185] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4503), 1,
      anon_sym_COMMA,
    STATE(143), 1,
      sym__semicolon,
    STATE(1864), 1,
      aux_sym__for_loop_parts_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65202] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4505), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65213] = 5,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    ACTIONS(4507), 1,
      anon_sym_EQ,
    STATE(1321), 1,
      sym_formal_parameter_list,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65230] = 5,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4503), 1,
      anon_sym_COMMA,
    STATE(140), 1,
      sym__semicolon,
    STATE(1740), 1,
      aux_sym__for_loop_parts_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65247] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4509), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65258] = 5,
    ACTIONS(4511), 1,
      anon_sym_COMMA,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    STATE(1952), 1,
      aux_sym__argument_list_repeat2,
    STATE(1961), 1,
      aux_sym__argument_list_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65275] = 5,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(1571), 1,
      sym_arguments,
    STATE(2072), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65292] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4486), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_implements,
  [65303] = 4,
    ACTIONS(3065), 1,
      anon_sym_Function,
    STATE(976), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1012), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65318] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4473), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [65329] = 4,
    ACTIONS(4516), 1,
      anon_sym_Function,
    STATE(1391), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1460), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65344] = 5,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(831), 1,
      sym_arguments,
    STATE(2078), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65361] = 3,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4520), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65374] = 4,
    ACTIONS(3584), 1,
      anon_sym_with,
    STATE(2104), 1,
      sym_mixins,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4522), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [65389] = 4,
    ACTIONS(2251), 1,
      anon_sym_Function,
    STATE(646), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(647), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65404] = 4,
    ACTIONS(4524), 1,
      anon_sym_Function,
    STATE(1189), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1236), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65419] = 4,
    ACTIONS(4526), 1,
      anon_sym_QMARK,
    STATE(2111), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2542), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [65434] = 5,
    ACTIONS(4528), 1,
      anon_sym_COMMA,
    ACTIONS(4531), 1,
      anon_sym_RPAREN,
    STATE(1745), 1,
      aux_sym__argument_list_repeat2,
    STATE(1841), 1,
      aux_sym__argument_list_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65451] = 5,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(1536), 1,
      sym_arguments,
    STATE(2060), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65468] = 5,
    ACTIONS(3913), 1,
      anon_sym_catch,
    ACTIONS(4533), 1,
      anon_sym_LBRACE,
    STATE(398), 1,
      sym_block,
    STATE(2036), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65485] = 4,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    STATE(1284), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2363), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [65500] = 4,
    ACTIONS(2275), 1,
      anon_sym_Function,
    STATE(645), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(638), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65515] = 4,
    ACTIONS(3924), 1,
      anon_sym_SEMI,
    ACTIONS(4535), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2189), 2,
      sym_initializers,
      sym_redirection,
  [65530] = 4,
    ACTIONS(3652), 1,
      anon_sym_extends,
    STATE(2143), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4537), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [65545] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4539), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4541), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(4543), 2,
      anon_sym_COLON,
      anon_sym_EQ,
  [65569] = 3,
    ACTIONS(4547), 1,
      sym__exclamation_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4545), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [65582] = 4,
    ACTIONS(4461), 1,
      anon_sym_Function,
    STATE(1495), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1708), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65597] = 5,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(837), 1,
      sym_arguments,
    STATE(2066), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65614] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4549), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65625] = 4,
    ACTIONS(4553), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4551), 2,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [65640] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4556), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65651] = 4,
    ACTIONS(4558), 1,
      anon_sym_QMARK,
    STATE(1282), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2459), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [65666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4560), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(4562), 2,
      anon_sym_COLON,
      anon_sym_EQ,
  [65679] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4564), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65690] = 3,
    ACTIONS(4568), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4566), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [65703] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4570), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [65714] = 5,
    ACTIONS(3913), 1,
      anon_sym_catch,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    STATE(398), 1,
      sym_block,
    STATE(2051), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65731] = 4,
    ACTIONS(4572), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4575), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65746] = 4,
    ACTIONS(4392), 1,
      anon_sym_QMARK,
    STATE(1285), 1,
      sym__nullable_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2335), 2,
      anon_sym_SEMI,
      anon_sym_Function,
  [65761] = 5,
    ACTIONS(3586), 1,
      anon_sym_implements,
    ACTIONS(4577), 1,
      anon_sym_SEMI,
    STATE(1355), 1,
      sym__implements,
    STATE(2266), 1,
      sym_interfaces,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65778] = 5,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      anon_sym_DOT,
    STATE(829), 1,
      sym_arguments,
    STATE(2096), 1,
      sym__dot_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65795] = 5,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(4579), 1,
      sym_identifier,
    ACTIONS(4581), 1,
      anon_sym_on,
    STATE(2215), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65812] = 4,
    ACTIONS(3061), 1,
      anon_sym_Function,
    STATE(983), 1,
      sym__function_builtin_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1009), 2,
      aux_sym__function_type_tails,
      sym__function_type_tail,
  [65827] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4583), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [65838] = 4,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4585), 1,
      sym_identifier,
    STATE(446), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65852] = 4,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(3580), 1,
      anon_sym_EQ,
    STATE(2203), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65866] = 4,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4587), 1,
      anon_sym_SEMI,
    STATE(1788), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65880] = 4,
    ACTIONS(4589), 1,
      anon_sym_COMMA,
    ACTIONS(4592), 1,
      anon_sym_SEMI,
    STATE(1788), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65894] = 4,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4594), 1,
      anon_sym_SEMI,
    STATE(1842), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65908] = 4,
    ACTIONS(3214), 1,
      anon_sym_RPAREN,
    ACTIONS(4596), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65922] = 4,
    ACTIONS(4598), 1,
      anon_sym_COMMA,
    ACTIONS(4600), 1,
      anon_sym_RPAREN,
    STATE(1790), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65936] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1935), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65950] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4604), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65964] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4608), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65978] = 4,
    ACTIONS(4531), 1,
      anon_sym_RPAREN,
    ACTIONS(4610), 1,
      anon_sym_COMMA,
    STATE(1824), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [65992] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2282), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66006] = 4,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    ACTIONS(4615), 1,
      anon_sym_DOT,
    STATE(1543), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66020] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4617), 1,
      anon_sym_GT,
    STATE(1793), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66034] = 4,
    ACTIONS(4619), 1,
      anon_sym_LBRACE,
    ACTIONS(4621), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4623), 1,
      sym_identifier_dollar_escaped,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [66048] = 4,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(4625), 1,
      anon_sym_EQ_GT,
    STATE(347), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66062] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_GT,
    STATE(1794), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66076] = 4,
    ACTIONS(4629), 1,
      anon_sym_RBRACE,
    ACTIONS(4631), 1,
      anon_sym_COMMA,
    STATE(1802), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66090] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1469), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66104] = 4,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4634), 1,
      anon_sym_SEMI,
    STATE(1788), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66118] = 4,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4636), 1,
      anon_sym_SEMI,
    STATE(1787), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66132] = 4,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4638), 1,
      anon_sym_DOT,
    STATE(2284), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66146] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1482), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66160] = 4,
    ACTIONS(589), 1,
      anon_sym_RBRACE,
    ACTIONS(4640), 1,
      anon_sym_COMMA,
    STATE(1863), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66174] = 4,
    ACTIONS(3249), 1,
      anon_sym_RPAREN,
    ACTIONS(4642), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66188] = 4,
    ACTIONS(4120), 1,
      anon_sym_SEMI,
    ACTIONS(4644), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66202] = 4,
    ACTIONS(591), 1,
      anon_sym_RBRACK,
    ACTIONS(4646), 1,
      anon_sym_COMMA,
    STATE(1865), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66216] = 4,
    ACTIONS(4648), 1,
      anon_sym_COMMA,
    ACTIONS(4650), 1,
      anon_sym_RPAREN,
    STATE(1809), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66230] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(1929), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66244] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4652), 1,
      anon_sym_GT,
    STATE(1866), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66258] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4654), 1,
      anon_sym_GT,
    STATE(1867), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66272] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4656), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66286] = 4,
    ACTIONS(4658), 1,
      anon_sym_COMMA,
    ACTIONS(4661), 1,
      anon_sym_RBRACK,
    STATE(1817), 1,
      aux_sym_positional_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66300] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4663), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66314] = 4,
    ACTIONS(4665), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2282), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66328] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4667), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66342] = 4,
    ACTIONS(4669), 1,
      anon_sym_COMMA,
    ACTIONS(4672), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66356] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4674), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_identifier,
  [66366] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4520), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [66376] = 4,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    ACTIONS(4676), 1,
      anon_sym_COMMA,
    STATE(1974), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66390] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4679), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_identifier,
  [66400] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4681), 1,
      anon_sym_RPAREN,
    STATE(1904), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66414] = 3,
    ACTIONS(3807), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3805), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [66426] = 4,
    ACTIONS(607), 1,
      anon_sym_RBRACE,
    ACTIONS(4683), 1,
      anon_sym_COMMA,
    STATE(1922), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66440] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4685), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66454] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4687), 1,
      anon_sym_RPAREN,
    STATE(1894), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66468] = 4,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    ACTIONS(4689), 1,
      anon_sym_EQ_GT,
    STATE(879), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66482] = 4,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(230), 1,
      sym_label,
    STATE(2077), 1,
      sym_named_argument,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66496] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4693), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [66506] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4695), 1,
      anon_sym_RPAREN,
    STATE(1886), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66520] = 4,
    ACTIONS(4697), 1,
      anon_sym_COMMA,
    ACTIONS(4699), 1,
      anon_sym_RPAREN,
    STATE(1914), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66534] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4701), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66548] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4703), 1,
      anon_sym_GT,
    STATE(1818), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66562] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4705), 1,
      anon_sym_GT,
    STATE(1820), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66576] = 4,
    ACTIONS(4707), 1,
      anon_sym_RBRACE,
    ACTIONS(4709), 1,
      anon_sym_COMMA,
    STATE(1902), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66590] = 4,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4715), 1,
      sym_identifier_dollar_escaped,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [66604] = 4,
    ACTIONS(4514), 1,
      anon_sym_RPAREN,
    ACTIONS(4717), 1,
      anon_sym_COMMA,
    STATE(1967), 1,
      aux_sym__argument_list_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66618] = 4,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    ACTIONS(4720), 1,
      anon_sym_SEMI,
    STATE(1788), 1,
      aux_sym_initialized_identifier_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66632] = 4,
    ACTIONS(607), 1,
      anon_sym_RBRACE,
    ACTIONS(4683), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66646] = 4,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    ACTIONS(4722), 1,
      sym_identifier,
    STATE(442), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66660] = 4,
    ACTIONS(4724), 1,
      sym_identifier,
    STATE(1997), 1,
      sym_dotted_identifier_list,
    STATE(2206), 1,
      sym_uri_test,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66674] = 4,
    ACTIONS(4726), 1,
      anon_sym_LBRACE,
    ACTIONS(4728), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4730), 1,
      sym_identifier_dollar_escaped,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [66688] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4732), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [66698] = 4,
    ACTIONS(4734), 1,
      anon_sym_COMMA,
    ACTIONS(4737), 1,
      anon_sym_RPAREN,
    STATE(1974), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66712] = 4,
    ACTIONS(617), 1,
      anon_sym_RBRACK,
    ACTIONS(4739), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66726] = 4,
    ACTIONS(619), 1,
      anon_sym_RBRACE,
    ACTIONS(4741), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66740] = 4,
    ACTIONS(4743), 1,
      anon_sym_COMMA,
    ACTIONS(4745), 1,
      anon_sym_SEMI,
    STATE(1923), 1,
      aux_sym_static_final_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66754] = 4,
    ACTIONS(587), 1,
      anon_sym_RBRACK,
    ACTIONS(4747), 1,
      anon_sym_COMMA,
    STATE(1968), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66768] = 4,
    ACTIONS(3231), 1,
      anon_sym_RPAREN,
    ACTIONS(4749), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66782] = 4,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    ACTIONS(4751), 1,
      anon_sym_EQ_GT,
    STATE(1541), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66796] = 4,
    ACTIONS(4753), 1,
      anon_sym_COMMA,
    ACTIONS(4756), 1,
      anon_sym_RPAREN,
    STATE(1973), 1,
      aux_sym__normal_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66810] = 4,
    ACTIONS(627), 1,
      anon_sym_RBRACE,
    ACTIONS(4758), 1,
      anon_sym_COMMA,
    STATE(1843), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66824] = 4,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4760), 1,
      anon_sym_DOT,
    STATE(2284), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66838] = 4,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2093), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66852] = 4,
    ACTIONS(4765), 1,
      anon_sym_RBRACE,
    ACTIONS(4767), 1,
      anon_sym_COMMA,
    STATE(1944), 1,
      aux_sym_named_parameter_types_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66866] = 4,
    ACTIONS(637), 1,
      anon_sym_RBRACK,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66880] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2027), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66894] = 4,
    ACTIONS(4771), 1,
      anon_sym_RBRACE,
    ACTIONS(4773), 1,
      anon_sym_COMMA,
    STATE(1862), 1,
      aux_sym_named_parameter_types_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66908] = 4,
    ACTIONS(597), 1,
      anon_sym_RBRACE,
    ACTIONS(4776), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66922] = 4,
    ACTIONS(4778), 1,
      anon_sym_COMMA,
    ACTIONS(4781), 1,
      anon_sym_SEMI,
    STATE(1864), 1,
      aux_sym__for_loop_parts_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66936] = 4,
    ACTIONS(599), 1,
      anon_sym_RBRACK,
    ACTIONS(4783), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66950] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4785), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66964] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4787), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66978] = 4,
    ACTIONS(639), 1,
      anon_sym_RBRACE,
    ACTIONS(4789), 1,
      anon_sym_COMMA,
    STATE(1850), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [66992] = 4,
    ACTIONS(597), 1,
      anon_sym_RBRACE,
    ACTIONS(4776), 1,
      anon_sym_COMMA,
    STATE(1896), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67006] = 4,
    ACTIONS(599), 1,
      anon_sym_RBRACK,
    ACTIONS(4783), 1,
      anon_sym_COMMA,
    STATE(1897), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67020] = 4,
    ACTIONS(637), 1,
      anon_sym_RBRACK,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67034] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4791), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [67044] = 4,
    ACTIONS(639), 1,
      anon_sym_RBRACE,
    ACTIONS(4789), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67058] = 4,
    ACTIONS(4793), 1,
      anon_sym_RBRACE,
    ACTIONS(4795), 1,
      anon_sym_COMMA,
    STATE(1874), 1,
      aux_sym__named_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67072] = 4,
    ACTIONS(4798), 1,
      anon_sym_COMMA,
    ACTIONS(4801), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67086] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(1829), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67100] = 4,
    ACTIONS(4805), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2027), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67114] = 4,
    ACTIONS(4808), 1,
      anon_sym_COMMA,
    ACTIONS(4810), 1,
      anon_sym_RBRACK,
    STATE(1931), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67128] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2055), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67142] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2258), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67156] = 4,
    ACTIONS(4812), 1,
      anon_sym_COMMA,
    ACTIONS(4814), 1,
      anon_sym_RPAREN,
    STATE(1853), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67170] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4816), 1,
      anon_sym_RPAREN,
    STATE(1972), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67184] = 4,
    ACTIONS(4132), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1651), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67198] = 4,
    ACTIONS(4150), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1650), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67212] = 4,
    ACTIONS(4162), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1647), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67226] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4818), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67240] = 4,
    ACTIONS(4820), 1,
      anon_sym_COMMA,
    ACTIONS(4822), 1,
      anon_sym_RPAREN,
    STATE(1913), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67254] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4824), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67268] = 4,
    ACTIONS(4106), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1623), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67282] = 4,
    ACTIONS(3997), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1631), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67296] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4826), 1,
      anon_sym_RPAREN,
    STATE(1816), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67310] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4551), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67320] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4828), 1,
      anon_sym_RPAREN,
    STATE(1969), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67334] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4830), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67348] = 4,
    ACTIONS(627), 1,
      anon_sym_RBRACE,
    ACTIONS(4758), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67362] = 4,
    ACTIONS(601), 1,
      anon_sym_RBRACE,
    ACTIONS(4832), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67376] = 4,
    ACTIONS(605), 1,
      anon_sym_RBRACK,
    ACTIONS(4834), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67390] = 4,
    ACTIONS(601), 1,
      anon_sym_RBRACE,
    ACTIONS(4832), 1,
      anon_sym_COMMA,
    STATE(1918), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67404] = 4,
    ACTIONS(605), 1,
      anon_sym_RBRACK,
    ACTIONS(4834), 1,
      anon_sym_COMMA,
    STATE(1919), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67418] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2189), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67432] = 4,
    ACTIONS(4836), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2093), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67446] = 4,
    ACTIONS(3781), 1,
      anon_sym_RBRACE,
    ACTIONS(4839), 1,
      anon_sym_COMMA,
    STATE(1802), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67460] = 4,
    ACTIONS(4743), 1,
      anon_sym_COMMA,
    ACTIONS(4841), 1,
      anon_sym_SEMI,
    STATE(1851), 1,
      aux_sym_static_final_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67474] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4843), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67488] = 4,
    ACTIONS(583), 1,
      anon_sym_RBRACK,
    ACTIONS(4845), 1,
      anon_sym_COMMA,
    STATE(1871), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67502] = 4,
    ACTIONS(649), 1,
      anon_sym_RBRACE,
    ACTIONS(4847), 1,
      anon_sym_COMMA,
    STATE(1873), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67516] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4849), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67530] = 4,
    ACTIONS(4851), 1,
      anon_sym_COMMA,
    ACTIONS(4854), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67544] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4856), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67558] = 4,
    ACTIONS(4010), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1636), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67572] = 4,
    ACTIONS(583), 1,
      anon_sym_RBRACK,
    ACTIONS(4845), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67586] = 4,
    ACTIONS(649), 1,
      anon_sym_RBRACE,
    ACTIONS(4847), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67600] = 4,
    ACTIONS(3258), 1,
      anon_sym_RPAREN,
    ACTIONS(4858), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67614] = 4,
    ACTIONS(3251), 1,
      anon_sym_RPAREN,
    ACTIONS(4860), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67628] = 4,
    ACTIONS(613), 1,
      anon_sym_RBRACE,
    ACTIONS(4862), 1,
      anon_sym_COMMA,
    STATE(1895), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67642] = 4,
    ACTIONS(4253), 1,
      anon_sym_LBRACE,
    ACTIONS(4864), 1,
      anon_sym_EQ_GT,
    STATE(835), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67656] = 4,
    ACTIONS(2646), 1,
      anon_sym_RBRACK,
    ACTIONS(4866), 1,
      anon_sym_COMMA,
    STATE(1817), 1,
      aux_sym_positional_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67670] = 4,
    ACTIONS(621), 1,
      anon_sym_RBRACE,
    ACTIONS(4868), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67684] = 4,
    ACTIONS(623), 1,
      anon_sym_RBRACK,
    ACTIONS(4870), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67698] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4575), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [67708] = 4,
    ACTIONS(4872), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2055), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67722] = 4,
    ACTIONS(635), 1,
      anon_sym_RBRACE,
    ACTIONS(4875), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67736] = 4,
    ACTIONS(4877), 1,
      anon_sym_COMMA,
    ACTIONS(4880), 1,
      anon_sym_SEMI,
    STATE(1923), 1,
      aux_sym_static_final_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67750] = 4,
    ACTIONS(643), 1,
      anon_sym_RBRACK,
    ACTIONS(4882), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67764] = 4,
    ACTIONS(4884), 1,
      anon_sym_COMMA,
    ACTIONS(4887), 1,
      anon_sym_RPAREN,
    STATE(1925), 1,
      aux_sym__normal_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67778] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4889), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [67788] = 4,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4891), 1,
      anon_sym_DOT,
    STATE(1543), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67802] = 4,
    ACTIONS(587), 1,
      anon_sym_RBRACK,
    ACTIONS(4747), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67816] = 4,
    ACTIONS(3973), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1655), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67830] = 4,
    ACTIONS(3309), 1,
      anon_sym_LT,
    ACTIONS(4893), 1,
      anon_sym_on,
    STATE(2337), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67844] = 4,
    ACTIONS(3340), 1,
      anon_sym_RBRACK,
    ACTIONS(4895), 1,
      anon_sym_COMMA,
    STATE(1778), 1,
      aux_sym_parameter_type_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67858] = 4,
    ACTIONS(4665), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_static_final_declaration,
    STATE(2093), 1,
      sym_static_final_declaration_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67872] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    STATE(2128), 1,
      sym_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67886] = 4,
    ACTIONS(4017), 1,
      anon_sym_SEMI,
    ACTIONS(4644), 1,
      anon_sym_COMMA,
    STATE(1937), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67900] = 4,
    ACTIONS(4023), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1615), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67914] = 4,
    ACTIONS(609), 1,
      anon_sym_RBRACK,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    STATE(1928), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67928] = 4,
    ACTIONS(4063), 1,
      anon_sym_SEMI,
    ACTIONS(4899), 1,
      anon_sym_COMMA,
    STATE(1937), 1,
      aux_sym_initializers_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67942] = 4,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4902), 1,
      anon_sym_EQ,
    STATE(2305), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67956] = 4,
    ACTIONS(4904), 1,
      anon_sym_RBRACE,
    ACTIONS(4906), 1,
      anon_sym_COMMA,
    STATE(1946), 1,
      aux_sym__named_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67970] = 3,
    ACTIONS(4910), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4908), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67982] = 4,
    ACTIONS(4912), 1,
      anon_sym_COMMA,
    ACTIONS(4914), 1,
      anon_sym_RBRACK,
    STATE(1917), 1,
      aux_sym_positional_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [67996] = 4,
    ACTIONS(3985), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1628), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68010] = 4,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(1805), 1,
      sym_initialized_identifier,
    STATE(2093), 1,
      sym_initialized_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68024] = 4,
    ACTIONS(3391), 1,
      anon_sym_RBRACE,
    ACTIONS(4916), 1,
      anon_sym_COMMA,
    STATE(1862), 1,
      aux_sym_named_parameter_types_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68038] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4918), 1,
      anon_sym_GT,
    STATE(1875), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68052] = 4,
    ACTIONS(2466), 1,
      anon_sym_RBRACE,
    ACTIONS(4920), 1,
      anon_sym_COMMA,
    STATE(1874), 1,
      aux_sym__named_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68066] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4922), 1,
      anon_sym_GT,
    STATE(1908), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68080] = 4,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4924), 1,
      sym_identifier,
    STATE(2289), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68094] = 4,
    ACTIONS(4070), 1,
      anon_sym_SEMI,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(1629), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68108] = 4,
    ACTIONS(4926), 1,
      anon_sym_COMMA,
    ACTIONS(4929), 1,
      anon_sym_RPAREN,
    STATE(1848), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68122] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4931), 3,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_finally,
  [68132] = 4,
    ACTIONS(4933), 1,
      anon_sym_COMMA,
    ACTIONS(4936), 1,
      anon_sym_RPAREN,
    STATE(1952), 1,
      aux_sym__argument_list_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68146] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4938), 1,
      anon_sym_GT,
    STATE(1907), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68160] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4940), 1,
      anon_sym_GT,
    STATE(1909), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68174] = 4,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    ACTIONS(4942), 1,
      anon_sym_EQ_GT,
    STATE(879), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68188] = 4,
    ACTIONS(603), 1,
      anon_sym_RBRACK,
    ACTIONS(4944), 1,
      anon_sym_COMMA,
    STATE(1911), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68202] = 4,
    ACTIONS(127), 1,
      anon_sym_this,
    ACTIONS(4946), 1,
      sym_identifier,
    STATE(2289), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68216] = 4,
    ACTIONS(593), 1,
      anon_sym_RBRACE,
    ACTIONS(4948), 1,
      anon_sym_COMMA,
    STATE(1912), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68230] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4950), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68244] = 4,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(4952), 1,
      anon_sym_EQ,
    STATE(2305), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68258] = 4,
    ACTIONS(4954), 1,
      anon_sym_COMMA,
    ACTIONS(4957), 1,
      anon_sym_RPAREN,
    STATE(1967), 1,
      aux_sym__argument_list_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68272] = 4,
    ACTIONS(4691), 1,
      sym_identifier,
    STATE(230), 1,
      sym_label,
    STATE(1950), 1,
      sym_named_argument,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68286] = 4,
    ACTIONS(4279), 1,
      anon_sym_LBRACE,
    ACTIONS(4625), 1,
      anon_sym_EQ_GT,
    STATE(347), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68300] = 4,
    ACTIONS(4959), 1,
      anon_sym_LBRACE,
    ACTIONS(4961), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(4963), 1,
      sym_identifier_dollar_escaped,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [68314] = 4,
    ACTIONS(4602), 1,
      anon_sym_COMMA,
    ACTIONS(4965), 1,
      anon_sym_GT,
    STATE(1945), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68328] = 4,
    ACTIONS(4606), 1,
      anon_sym_COMMA,
    ACTIONS(4967), 1,
      anon_sym_GT,
    STATE(1947), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68342] = 4,
    ACTIONS(4929), 1,
      anon_sym_RPAREN,
    ACTIONS(4969), 1,
      anon_sym_COMMA,
    STATE(1967), 1,
      aux_sym__argument_list_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68356] = 4,
    ACTIONS(595), 1,
      anon_sym_RBRACK,
    ACTIONS(4972), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68370] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4974), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68384] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4976), 1,
      anon_sym_RPAREN,
    STATE(1959), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68398] = 4,
    ACTIONS(3439), 1,
      anon_sym_LPAREN,
    STATE(1321), 1,
      sym_formal_parameter_list,
    STATE(1326), 1,
      sym__strict_formal_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68412] = 4,
    ACTIONS(4406), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_RPAREN,
    STATE(1821), 1,
      aux_sym__for_loop_parts_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68426] = 4,
    ACTIONS(4980), 1,
      anon_sym_COMMA,
    ACTIONS(4983), 1,
      anon_sym_RPAREN,
    STATE(1925), 1,
      aux_sym__normal_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68440] = 4,
    ACTIONS(4985), 1,
      anon_sym_COMMA,
    ACTIONS(4988), 1,
      anon_sym_RPAREN,
    STATE(1974), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68454] = 4,
    ACTIONS(595), 1,
      anon_sym_RBRACK,
    ACTIONS(4972), 1,
      anon_sym_COMMA,
    STATE(1924), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68468] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4990), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [68477] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(346), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68488] = 3,
    ACTIONS(1418), 1,
      anon_sym_while,
    ACTIONS(4992), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68499] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4537), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [68508] = 3,
    ACTIONS(4994), 1,
      sym_identifier,
    STATE(1028), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68519] = 3,
    ACTIONS(3584), 1,
      anon_sym_with,
    STATE(1780), 1,
      sym_mixins,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68530] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4880), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [68539] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(417), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68550] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68561] = 3,
    ACTIONS(4201), 1,
      anon_sym_native,
    ACTIONS(4998), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68572] = 3,
    ACTIONS(5000), 1,
      anon_sym_LPAREN,
    ACTIONS(5002), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68583] = 3,
    ACTIONS(5004), 1,
      anon_sym_COMMA,
    ACTIONS(5006), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68594] = 3,
    ACTIONS(4279), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68605] = 3,
    ACTIONS(4274), 1,
      anon_sym_native,
    STATE(2258), 1,
      sym__native,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68616] = 3,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1602), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68627] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5008), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [68636] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(374), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68647] = 3,
    ACTIONS(5010), 1,
      anon_sym_abstract,
    ACTIONS(5012), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68658] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(62), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68669] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4501), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [68678] = 3,
    ACTIONS(4279), 1,
      anon_sym_LBRACE,
    STATE(347), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68689] = 3,
    ACTIONS(5014), 1,
      anon_sym_RPAREN,
    ACTIONS(5016), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68700] = 3,
    ACTIONS(5018), 1,
      anon_sym_LBRACE,
    ACTIONS(5020), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68711] = 3,
    ACTIONS(5022), 1,
      anon_sym_DOT,
    ACTIONS(5024), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68722] = 3,
    ACTIONS(5026), 1,
      sym_identifier,
    STATE(423), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68733] = 3,
    ACTIONS(5028), 1,
      anon_sym_DOT,
    ACTIONS(5030), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68744] = 3,
    ACTIONS(3401), 1,
      sym_increment_operator,
    STATE(995), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68755] = 3,
    ACTIONS(3451), 1,
      anon_sym_this,
    ACTIONS(5032), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68766] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(368), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68777] = 3,
    ACTIONS(5035), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_switch_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68788] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(430), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68799] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68810] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(452), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68821] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(453), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68832] = 3,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    STATE(1951), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68843] = 3,
    ACTIONS(3379), 1,
      sym_increment_operator,
    STATE(1008), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68854] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(70), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68865] = 3,
    ACTIONS(3508), 1,
      anon_sym_LBRACE,
    ACTIONS(3510), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68876] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(367), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68887] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(63), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68898] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4936), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68907] = 3,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68918] = 3,
    ACTIONS(5039), 1,
      sym_identifier,
    STATE(385), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68929] = 3,
    ACTIONS(3316), 1,
      anon_sym_LT,
    STATE(2285), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68940] = 3,
    ACTIONS(5041), 1,
      anon_sym_DOT,
    ACTIONS(5043), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68951] = 3,
    ACTIONS(5045), 1,
      sym_identifier,
    STATE(402), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68962] = 3,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    STATE(1602), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68973] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(69), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68984] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(67), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [68995] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(133), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69006] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4854), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [69015] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(394), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69026] = 3,
    ACTIONS(5047), 1,
      sym_identifier,
    STATE(1429), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69037] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(2087), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69048] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(438), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69059] = 3,
    ACTIONS(5049), 1,
      sym_identifier,
    STATE(1990), 1,
      sym_qualified,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69070] = 3,
    ACTIONS(5051), 1,
      anon_sym_COMMA,
    ACTIONS(5053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69081] = 3,
    ACTIONS(3429), 1,
      anon_sym_LBRACE,
    ACTIONS(3431), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69092] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(405), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4887), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69112] = 3,
    ACTIONS(4533), 1,
      anon_sym_LBRACE,
    STATE(416), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69123] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69134] = 3,
    ACTIONS(2149), 1,
      anon_sym_LPAREN,
    STATE(1046), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69145] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(366), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69156] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(359), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69167] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(451), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69178] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(372), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69189] = 3,
    ACTIONS(4253), 1,
      anon_sym_LBRACE,
    STATE(835), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69200] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(404), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69211] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5055), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [69220] = 3,
    ACTIONS(4235), 1,
      anon_sym_native,
    ACTIONS(5057), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69231] = 3,
    ACTIONS(5059), 1,
      anon_sym_COMMA,
    ACTIONS(5061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69242] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5063), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69251] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5065), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [69260] = 3,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    STATE(1595), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69271] = 3,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    STATE(416), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69282] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5067), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69291] = 3,
    ACTIONS(5069), 1,
      anon_sym_LBRACE,
    STATE(418), 1,
      sym_extension_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69302] = 3,
    ACTIONS(5071), 1,
      anon_sym_LBRACE,
    ACTIONS(5073), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69313] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(419), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69324] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5075), 2,
      anon_sym_this,
      sym_identifier,
  [69333] = 3,
    ACTIONS(5069), 1,
      anon_sym_LBRACE,
    STATE(379), 1,
      sym_extension_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69344] = 3,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    STATE(843), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69355] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(2005), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69366] = 3,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    STATE(1578), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69377] = 3,
    ACTIONS(5077), 1,
      anon_sym_LBRACE,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69388] = 3,
    ACTIONS(5081), 1,
      anon_sym_COMMA,
    ACTIONS(5083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69399] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5085), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [69408] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(411), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69419] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(377), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69430] = 3,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    STATE(853), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69441] = 3,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    ACTIONS(5089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69452] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3565), 2,
      anon_sym_this,
      sym_identifier,
  [69461] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(395), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69472] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4793), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69481] = 3,
    ACTIONS(5069), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym_extension_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69492] = 3,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    STATE(1574), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69503] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5091), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [69512] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4661), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [69521] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4771), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69530] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5093), 2,
      anon_sym_this,
      sym_identifier,
  [69539] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4988), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69548] = 3,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    STATE(847), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69559] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(371), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69570] = 3,
    ACTIONS(5095), 1,
      anon_sym_COMMA,
    ACTIONS(5097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69581] = 3,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    STATE(1541), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69592] = 3,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    STATE(866), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69603] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(1302), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69614] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5099), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69623] = 3,
    ACTIONS(5101), 1,
      sym_identifier,
    STATE(1613), 1,
      sym__type_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69634] = 3,
    ACTIONS(4665), 1,
      sym_identifier,
    STATE(1982), 1,
      sym_static_final_declaration,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69645] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(434), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69656] = 3,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69667] = 3,
    ACTIONS(4724), 1,
      sym_identifier,
    STATE(2040), 1,
      sym_dotted_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69678] = 3,
    ACTIONS(3502), 1,
      anon_sym_LBRACE,
    ACTIONS(3504), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69689] = 3,
    ACTIONS(3086), 1,
      anon_sym_LPAREN,
    STATE(1547), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69700] = 3,
    ACTIONS(5069), 1,
      anon_sym_LBRACE,
    STATE(399), 1,
      sym_extension_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69711] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(410), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69722] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(146), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69733] = 3,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69744] = 3,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    STATE(812), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69755] = 3,
    ACTIONS(5103), 1,
      anon_sym_as,
    STATE(2323), 1,
      sym__as,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69766] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5105), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [69775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5107), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69784] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(409), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69795] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(393), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69806] = 3,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    STATE(848), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69817] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5109), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69826] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5111), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [69835] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(1303), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69846] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(1304), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69857] = 3,
    ACTIONS(4207), 1,
      anon_sym_LBRACE,
    STATE(879), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69868] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(150), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69879] = 3,
    ACTIONS(3405), 1,
      sym_increment_operator,
    STATE(886), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69890] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5113), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2786), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [69908] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(437), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69919] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5115), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [69928] = 3,
    ACTIONS(5117), 1,
      sym_identifier,
    STATE(1847), 1,
      sym__identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69939] = 3,
    ACTIONS(3316), 1,
      anon_sym_LT,
    STATE(2329), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69950] = 3,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69961] = 3,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    STATE(803), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69972] = 3,
    ACTIONS(3383), 1,
      sym_increment_operator,
    STATE(844), 1,
      sym_postfix_operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69983] = 3,
    ACTIONS(5119), 1,
      anon_sym_get,
    STATE(2264), 1,
      sym__get,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [69994] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70003] = 3,
    ACTIONS(5123), 1,
      anon_sym_COMMA,
    ACTIONS(5125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70014] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4629), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [70023] = 3,
    ACTIONS(5127), 1,
      anon_sym_COMMA,
    ACTIONS(5129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70034] = 3,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70045] = 3,
    ACTIONS(4613), 1,
      sym_identifier,
    STATE(2140), 1,
      sym_initialized_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70056] = 3,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
    STATE(347), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70067] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(407), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70078] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5131), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
  [70087] = 3,
    ACTIONS(3316), 1,
      anon_sym_LT,
    STATE(2347), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70098] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(369), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70109] = 3,
    ACTIONS(5039), 1,
      sym_identifier,
    STATE(415), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70120] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(352), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70131] = 3,
    ACTIONS(4533), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70142] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4801), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [70151] = 3,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    STATE(422), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70162] = 3,
    ACTIONS(5049), 1,
      sym_identifier,
    STATE(2022), 1,
      sym_qualified,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70173] = 3,
    ACTIONS(5133), 1,
      anon_sym_operator,
    STATE(1067), 1,
      sym__operator,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70184] = 3,
    ACTIONS(5026), 1,
      sym_identifier,
    STATE(385), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70195] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(348), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70206] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4592), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [70215] = 3,
    ACTIONS(5045), 1,
      sym_identifier,
    STATE(383), 1,
      sym_mixin_application_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70226] = 3,
    ACTIONS(4724), 1,
      sym_identifier,
    STATE(2132), 1,
      sym_dotted_identifier_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70237] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5135), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [70246] = 3,
    ACTIONS(579), 1,
      anon_sym_SEMI,
    STATE(1310), 1,
      sym__semicolon,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70257] = 2,
    ACTIONS(4235), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70265] = 2,
    ACTIONS(5137), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70273] = 2,
    ACTIONS(5139), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70281] = 2,
    ACTIONS(5141), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70289] = 2,
    ACTIONS(5143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70297] = 2,
    ACTIONS(5145), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70305] = 2,
    ACTIONS(5147), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70313] = 2,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70321] = 2,
    ACTIONS(5151), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70329] = 2,
    ACTIONS(4600), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70337] = 2,
    ACTIONS(5153), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70345] = 2,
    ACTIONS(5155), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70353] = 2,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70361] = 2,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70369] = 2,
    ACTIONS(5157), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70377] = 2,
    ACTIONS(5159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70385] = 2,
    ACTIONS(5161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70393] = 2,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70401] = 2,
    ACTIONS(5165), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70409] = 2,
    ACTIONS(5167), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70417] = 2,
    ACTIONS(5169), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70425] = 2,
    ACTIONS(5171), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70433] = 2,
    ACTIONS(5173), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70441] = 2,
    ACTIONS(4268), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70449] = 2,
    ACTIONS(5175), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70457] = 2,
    ACTIONS(4650), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70465] = 2,
    ACTIONS(5177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70473] = 2,
    ACTIONS(5179), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70481] = 2,
    ACTIONS(5181), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70489] = 2,
    ACTIONS(5183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70497] = 2,
    ACTIONS(3218), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70505] = 2,
    ACTIONS(5185), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70513] = 2,
    ACTIONS(5187), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70521] = 2,
    ACTIONS(5189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70529] = 2,
    ACTIONS(5191), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70537] = 2,
    ACTIONS(5193), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70545] = 2,
    ACTIONS(5195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70553] = 2,
    ACTIONS(5197), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70561] = 2,
    ACTIONS(4814), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70569] = 2,
    ACTIONS(5199), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70577] = 2,
    ACTIONS(5201), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70585] = 2,
    ACTIONS(5203), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70593] = 2,
    ACTIONS(5205), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70601] = 2,
    ACTIONS(5207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70609] = 2,
    ACTIONS(4402), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70617] = 2,
    ACTIONS(5209), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70625] = 2,
    ACTIONS(5211), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70633] = 2,
    ACTIONS(5213), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70641] = 2,
    ACTIONS(5215), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70649] = 2,
    ACTIONS(5217), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70657] = 2,
    ACTIONS(5219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70665] = 2,
    ACTIONS(5221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70673] = 2,
    ACTIONS(2905), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70681] = 2,
    ACTIONS(5006), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70689] = 2,
    ACTIONS(5223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70697] = 2,
    ACTIONS(5225), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70705] = 2,
    ACTIONS(5227), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70713] = 2,
    ACTIONS(5229), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70721] = 2,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70729] = 2,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70737] = 2,
    ACTIONS(5233), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70745] = 2,
    ACTIONS(5235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70753] = 2,
    ACTIONS(5237), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70761] = 2,
    ACTIONS(5239), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70769] = 2,
    ACTIONS(5241), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70777] = 2,
    ACTIONS(5243), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70785] = 2,
    ACTIONS(5245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70793] = 2,
    ACTIONS(5247), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70801] = 2,
    ACTIONS(5249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70809] = 2,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70817] = 2,
    ACTIONS(5253), 1,
      anon_sym_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70825] = 2,
    ACTIONS(5255), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70833] = 2,
    ACTIONS(5257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70841] = 2,
    ACTIONS(3244), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70849] = 2,
    ACTIONS(5259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70857] = 2,
    ACTIONS(5261), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70865] = 2,
    ACTIONS(5263), 1,
      anon_sym_LF,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [70873] = 2,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70881] = 2,
    ACTIONS(5265), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70889] = 2,
    ACTIONS(5267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70897] = 2,
    ACTIONS(5269), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70905] = 2,
    ACTIONS(5271), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70913] = 2,
    ACTIONS(5273), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70921] = 2,
    ACTIONS(4822), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70929] = 2,
    ACTIONS(5275), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70937] = 2,
    ACTIONS(5277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70945] = 2,
    ACTIONS(5279), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70953] = 2,
    ACTIONS(5281), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70961] = 2,
    ACTIONS(5283), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70969] = 2,
    ACTIONS(5285), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70977] = 2,
    ACTIONS(5287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70985] = 2,
    ACTIONS(5289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [70993] = 2,
    ACTIONS(5291), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71001] = 2,
    ACTIONS(5293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71009] = 2,
    ACTIONS(5295), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71017] = 2,
    ACTIONS(5297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71025] = 2,
    ACTIONS(5299), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71033] = 2,
    ACTIONS(5301), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71041] = 2,
    ACTIONS(5303), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71049] = 2,
    ACTIONS(5305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71057] = 2,
    ACTIONS(5307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71065] = 2,
    ACTIONS(5309), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71073] = 2,
    ACTIONS(5311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71081] = 2,
    ACTIONS(5313), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71089] = 2,
    ACTIONS(5315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71097] = 2,
    ACTIONS(5317), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71105] = 2,
    ACTIONS(5319), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71113] = 2,
    ACTIONS(5321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71121] = 2,
    ACTIONS(5323), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71129] = 2,
    ACTIONS(5325), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71137] = 2,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71145] = 2,
    ACTIONS(5329), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71153] = 2,
    ACTIONS(5331), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71161] = 2,
    ACTIONS(5333), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71169] = 2,
    ACTIONS(5335), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71177] = 2,
    ACTIONS(5337), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71185] = 2,
    ACTIONS(5339), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71193] = 2,
    ACTIONS(3924), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71201] = 2,
    ACTIONS(4097), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71209] = 2,
    ACTIONS(4177), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71217] = 2,
    ACTIONS(5341), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71225] = 2,
    ACTIONS(5343), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71233] = 2,
    ACTIONS(5345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71241] = 2,
    ACTIONS(5347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71249] = 2,
    ACTIONS(5349), 1,
      aux_sym_script_tag_token1,
    ACTIONS(4148), 2,
      sym_comment,
      sym_documentation_comment,
  [71257] = 2,
    ACTIONS(5351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71265] = 2,
    ACTIONS(3372), 1,
      anon_sym_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71273] = 2,
    ACTIONS(5353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71281] = 2,
    ACTIONS(5355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71289] = 2,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71297] = 2,
    ACTIONS(5359), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71305] = 2,
    ACTIONS(5361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71313] = 2,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71321] = 2,
    ACTIONS(5365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71329] = 2,
    ACTIONS(5367), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71337] = 2,
    ACTIONS(5369), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71345] = 2,
    ACTIONS(5371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71353] = 2,
    ACTIONS(5373), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71361] = 2,
    ACTIONS(5375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71369] = 2,
    ACTIONS(5377), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71377] = 2,
    ACTIONS(4088), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71385] = 2,
    ACTIONS(5379), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71393] = 2,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71401] = 2,
    ACTIONS(5383), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71409] = 2,
    ACTIONS(5385), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71417] = 2,
    ACTIONS(5387), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71425] = 2,
    ACTIONS(5389), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71433] = 2,
    ACTIONS(5391), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71441] = 2,
    ACTIONS(5393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71449] = 2,
    ACTIONS(5395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71457] = 2,
    ACTIONS(5397), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71465] = 2,
    ACTIONS(5399), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71473] = 2,
    ACTIONS(5402), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71481] = 2,
    ACTIONS(5404), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71489] = 2,
    ACTIONS(5406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71497] = 2,
    ACTIONS(5408), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71505] = 2,
    ACTIONS(5410), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71513] = 2,
    ACTIONS(5412), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71521] = 2,
    ACTIONS(4201), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71529] = 2,
    ACTIONS(5414), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71537] = 2,
    ACTIONS(5416), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71545] = 2,
    ACTIONS(5418), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71553] = 2,
    ACTIONS(5420), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71561] = 2,
    ACTIONS(5422), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71569] = 2,
    ACTIONS(5043), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71577] = 2,
    ACTIONS(5424), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71585] = 2,
    ACTIONS(5426), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71593] = 2,
    ACTIONS(5428), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71601] = 2,
    ACTIONS(5430), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71609] = 2,
    ACTIONS(5432), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71617] = 2,
    ACTIONS(4952), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71625] = 2,
    ACTIONS(5434), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71633] = 2,
    ACTIONS(5436), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71641] = 2,
    ACTIONS(5438), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71649] = 2,
    ACTIONS(5440), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71657] = 2,
    ACTIONS(5442), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71665] = 2,
    ACTIONS(5444), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71673] = 2,
    ACTIONS(4902), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71681] = 2,
    ACTIONS(5446), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71689] = 2,
    ACTIONS(5448), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71697] = 2,
    ACTIONS(5450), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71705] = 2,
    ACTIONS(5452), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71713] = 2,
    ACTIONS(5454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71721] = 2,
    ACTIONS(5456), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71729] = 2,
    ACTIONS(5458), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71737] = 2,
    ACTIONS(5460), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71745] = 2,
    ACTIONS(5462), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71753] = 2,
    ACTIONS(5464), 1,
      anon_sym_part,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71761] = 2,
    ACTIONS(5466), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71769] = 2,
    ACTIONS(3347), 1,
      anon_sym_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71777] = 2,
    ACTIONS(5468), 1,
      anon_sym_part,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71785] = 2,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71793] = 2,
    ACTIONS(5470), 1,
      anon_sym_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71801] = 2,
    ACTIONS(5472), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71809] = 2,
    ACTIONS(5474), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71817] = 2,
    ACTIONS(4001), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71825] = 2,
    ACTIONS(5476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71833] = 2,
    ACTIONS(5478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71841] = 2,
    ACTIONS(5480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71849] = 2,
    ACTIONS(4699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71857] = 2,
    ACTIONS(5482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71865] = 2,
    ACTIONS(5484), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71873] = 2,
    ACTIONS(5486), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71881] = 2,
    ACTIONS(5488), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71889] = 2,
    ACTIONS(5490), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71897] = 2,
    ACTIONS(5492), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71905] = 2,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71913] = 2,
    ACTIONS(5496), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71921] = 2,
    ACTIONS(5498), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71929] = 2,
    ACTIONS(5500), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71937] = 2,
    ACTIONS(5502), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71945] = 2,
    ACTIONS(5504), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71953] = 2,
    ACTIONS(5506), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71961] = 2,
    ACTIONS(5508), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71969] = 2,
    ACTIONS(5510), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71977] = 2,
    ACTIONS(5512), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71985] = 2,
    ACTIONS(5514), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [71993] = 2,
    ACTIONS(5516), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [72001] = 2,
    ACTIONS(5518), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
  [72009] = 2,
    ACTIONS(5520), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_documentation_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(350)] = 0,
  [SMALL_STATE(351)] = 71,
  [SMALL_STATE(352)] = 154,
  [SMALL_STATE(353)] = 224,
  [SMALL_STATE(354)] = 294,
  [SMALL_STATE(355)] = 364,
  [SMALL_STATE(356)] = 434,
  [SMALL_STATE(357)] = 504,
  [SMALL_STATE(358)] = 574,
  [SMALL_STATE(359)] = 644,
  [SMALL_STATE(360)] = 714,
  [SMALL_STATE(361)] = 784,
  [SMALL_STATE(362)] = 854,
  [SMALL_STATE(363)] = 932,
  [SMALL_STATE(364)] = 1002,
  [SMALL_STATE(365)] = 1072,
  [SMALL_STATE(366)] = 1142,
  [SMALL_STATE(367)] = 1210,
  [SMALL_STATE(368)] = 1278,
  [SMALL_STATE(369)] = 1346,
  [SMALL_STATE(370)] = 1414,
  [SMALL_STATE(371)] = 1481,
  [SMALL_STATE(372)] = 1548,
  [SMALL_STATE(373)] = 1615,
  [SMALL_STATE(374)] = 1682,
  [SMALL_STATE(375)] = 1749,
  [SMALL_STATE(376)] = 1816,
  [SMALL_STATE(377)] = 1883,
  [SMALL_STATE(378)] = 1950,
  [SMALL_STATE(379)] = 2017,
  [SMALL_STATE(380)] = 2084,
  [SMALL_STATE(381)] = 2151,
  [SMALL_STATE(382)] = 2220,
  [SMALL_STATE(383)] = 2287,
  [SMALL_STATE(384)] = 2354,
  [SMALL_STATE(385)] = 2421,
  [SMALL_STATE(386)] = 2488,
  [SMALL_STATE(387)] = 2555,
  [SMALL_STATE(388)] = 2622,
  [SMALL_STATE(389)] = 2689,
  [SMALL_STATE(390)] = 2756,
  [SMALL_STATE(391)] = 2823,
  [SMALL_STATE(392)] = 2890,
  [SMALL_STATE(393)] = 2957,
  [SMALL_STATE(394)] = 3024,
  [SMALL_STATE(395)] = 3091,
  [SMALL_STATE(396)] = 3158,
  [SMALL_STATE(397)] = 3225,
  [SMALL_STATE(398)] = 3292,
  [SMALL_STATE(399)] = 3359,
  [SMALL_STATE(400)] = 3426,
  [SMALL_STATE(401)] = 3493,
  [SMALL_STATE(402)] = 3560,
  [SMALL_STATE(403)] = 3627,
  [SMALL_STATE(404)] = 3694,
  [SMALL_STATE(405)] = 3761,
  [SMALL_STATE(406)] = 3828,
  [SMALL_STATE(407)] = 3895,
  [SMALL_STATE(408)] = 3962,
  [SMALL_STATE(409)] = 4029,
  [SMALL_STATE(410)] = 4096,
  [SMALL_STATE(411)] = 4163,
  [SMALL_STATE(412)] = 4230,
  [SMALL_STATE(413)] = 4297,
  [SMALL_STATE(414)] = 4364,
  [SMALL_STATE(415)] = 4431,
  [SMALL_STATE(416)] = 4498,
  [SMALL_STATE(417)] = 4565,
  [SMALL_STATE(418)] = 4632,
  [SMALL_STATE(419)] = 4699,
  [SMALL_STATE(420)] = 4766,
  [SMALL_STATE(421)] = 4833,
  [SMALL_STATE(422)] = 4900,
  [SMALL_STATE(423)] = 4967,
  [SMALL_STATE(424)] = 5034,
  [SMALL_STATE(425)] = 5181,
  [SMALL_STATE(426)] = 5310,
  [SMALL_STATE(427)] = 5439,
  [SMALL_STATE(428)] = 5522,
  [SMALL_STATE(429)] = 5651,
  [SMALL_STATE(430)] = 5780,
  [SMALL_STATE(431)] = 5845,
  [SMALL_STATE(432)] = 5928,
  [SMALL_STATE(433)] = 5992,
  [SMALL_STATE(434)] = 6056,
  [SMALL_STATE(435)] = 6120,
  [SMALL_STATE(436)] = 6184,
  [SMALL_STATE(437)] = 6248,
  [SMALL_STATE(438)] = 6312,
  [SMALL_STATE(439)] = 6376,
  [SMALL_STATE(440)] = 6440,
  [SMALL_STATE(441)] = 6504,
  [SMALL_STATE(442)] = 6568,
  [SMALL_STATE(443)] = 6632,
  [SMALL_STATE(444)] = 6696,
  [SMALL_STATE(445)] = 6760,
  [SMALL_STATE(446)] = 6824,
  [SMALL_STATE(447)] = 6888,
  [SMALL_STATE(448)] = 6952,
  [SMALL_STATE(449)] = 7016,
  [SMALL_STATE(450)] = 7080,
  [SMALL_STATE(451)] = 7144,
  [SMALL_STATE(452)] = 7208,
  [SMALL_STATE(453)] = 7272,
  [SMALL_STATE(454)] = 7336,
  [SMALL_STATE(455)] = 7400,
  [SMALL_STATE(456)] = 7464,
  [SMALL_STATE(457)] = 7608,
  [SMALL_STATE(458)] = 7673,
  [SMALL_STATE(459)] = 7801,
  [SMALL_STATE(460)] = 7863,
  [SMALL_STATE(461)] = 7925,
  [SMALL_STATE(462)] = 8053,
  [SMALL_STATE(463)] = 8116,
  [SMALL_STATE(464)] = 8195,
  [SMALL_STATE(465)] = 8256,
  [SMALL_STATE(466)] = 8399,
  [SMALL_STATE(467)] = 8542,
  [SMALL_STATE(468)] = 8621,
  [SMALL_STATE(469)] = 8764,
  [SMALL_STATE(470)] = 8907,
  [SMALL_STATE(471)] = 9050,
  [SMALL_STATE(472)] = 9193,
  [SMALL_STATE(473)] = 9315,
  [SMALL_STATE(474)] = 9395,
  [SMALL_STATE(475)] = 9517,
  [SMALL_STATE(476)] = 9639,
  [SMALL_STATE(477)] = 9761,
  [SMALL_STATE(478)] = 9841,
  [SMALL_STATE(479)] = 9963,
  [SMALL_STATE(480)] = 10075,
  [SMALL_STATE(481)] = 10197,
  [SMALL_STATE(482)] = 10319,
  [SMALL_STATE(483)] = 10441,
  [SMALL_STATE(484)] = 10563,
  [SMALL_STATE(485)] = 10677,
  [SMALL_STATE(486)] = 10799,
  [SMALL_STATE(487)] = 10921,
  [SMALL_STATE(488)] = 11043,
  [SMALL_STATE(489)] = 11123,
  [SMALL_STATE(490)] = 11245,
  [SMALL_STATE(491)] = 11359,
  [SMALL_STATE(492)] = 11481,
  [SMALL_STATE(493)] = 11603,
  [SMALL_STATE(494)] = 11683,
  [SMALL_STATE(495)] = 11795,
  [SMALL_STATE(496)] = 11917,
  [SMALL_STATE(497)] = 12039,
  [SMALL_STATE(498)] = 12161,
  [SMALL_STATE(499)] = 12290,
  [SMALL_STATE(500)] = 12419,
  [SMALL_STATE(501)] = 12545,
  [SMALL_STATE(502)] = 12667,
  [SMALL_STATE(503)] = 12737,
  [SMALL_STATE(504)] = 12793,
  [SMALL_STATE(505)] = 12863,
  [SMALL_STATE(506)] = 12919,
  [SMALL_STATE(507)] = 12975,
  [SMALL_STATE(508)] = 13045,
  [SMALL_STATE(509)] = 13101,
  [SMALL_STATE(510)] = 13171,
  [SMALL_STATE(511)] = 13227,
  [SMALL_STATE(512)] = 13283,
  [SMALL_STATE(513)] = 13339,
  [SMALL_STATE(514)] = 13395,
  [SMALL_STATE(515)] = 13451,
  [SMALL_STATE(516)] = 13507,
  [SMALL_STATE(517)] = 13563,
  [SMALL_STATE(518)] = 13619,
  [SMALL_STATE(519)] = 13675,
  [SMALL_STATE(520)] = 13731,
  [SMALL_STATE(521)] = 13787,
  [SMALL_STATE(522)] = 13843,
  [SMALL_STATE(523)] = 13960,
  [SMALL_STATE(524)] = 14042,
  [SMALL_STATE(525)] = 14124,
  [SMALL_STATE(526)] = 14206,
  [SMALL_STATE(527)] = 14288,
  [SMALL_STATE(528)] = 14370,
  [SMALL_STATE(529)] = 14452,
  [SMALL_STATE(530)] = 14534,
  [SMALL_STATE(531)] = 14616,
  [SMALL_STATE(532)] = 14698,
  [SMALL_STATE(533)] = 14780,
  [SMALL_STATE(534)] = 14862,
  [SMALL_STATE(535)] = 14944,
  [SMALL_STATE(536)] = 15026,
  [SMALL_STATE(537)] = 15108,
  [SMALL_STATE(538)] = 15190,
  [SMALL_STATE(539)] = 15272,
  [SMALL_STATE(540)] = 15397,
  [SMALL_STATE(541)] = 15476,
  [SMALL_STATE(542)] = 15555,
  [SMALL_STATE(543)] = 15634,
  [SMALL_STATE(544)] = 15713,
  [SMALL_STATE(545)] = 15792,
  [SMALL_STATE(546)] = 15871,
  [SMALL_STATE(547)] = 15950,
  [SMALL_STATE(548)] = 16075,
  [SMALL_STATE(549)] = 16154,
  [SMALL_STATE(550)] = 16233,
  [SMALL_STATE(551)] = 16312,
  [SMALL_STATE(552)] = 16391,
  [SMALL_STATE(553)] = 16470,
  [SMALL_STATE(554)] = 16549,
  [SMALL_STATE(555)] = 16628,
  [SMALL_STATE(556)] = 16707,
  [SMALL_STATE(557)] = 16788,
  [SMALL_STATE(558)] = 16867,
  [SMALL_STATE(559)] = 16984,
  [SMALL_STATE(560)] = 17061,
  [SMALL_STATE(561)] = 17138,
  [SMALL_STATE(562)] = 17257,
  [SMALL_STATE(563)] = 17376,
  [SMALL_STATE(564)] = 17428,
  [SMALL_STATE(565)] = 17480,
  [SMALL_STATE(566)] = 17532,
  [SMALL_STATE(567)] = 17584,
  [SMALL_STATE(568)] = 17636,
  [SMALL_STATE(569)] = 17688,
  [SMALL_STATE(570)] = 17740,
  [SMALL_STATE(571)] = 17792,
  [SMALL_STATE(572)] = 17844,
  [SMALL_STATE(573)] = 17896,
  [SMALL_STATE(574)] = 17948,
  [SMALL_STATE(575)] = 18000,
  [SMALL_STATE(576)] = 18052,
  [SMALL_STATE(577)] = 18104,
  [SMALL_STATE(578)] = 18156,
  [SMALL_STATE(579)] = 18208,
  [SMALL_STATE(580)] = 18321,
  [SMALL_STATE(581)] = 18372,
  [SMALL_STATE(582)] = 18483,
  [SMALL_STATE(583)] = 18594,
  [SMALL_STATE(584)] = 18705,
  [SMALL_STATE(585)] = 18816,
  [SMALL_STATE(586)] = 18927,
  [SMALL_STATE(587)] = 19038,
  [SMALL_STATE(588)] = 19155,
  [SMALL_STATE(589)] = 19268,
  [SMALL_STATE(590)] = 19381,
  [SMALL_STATE(591)] = 19492,
  [SMALL_STATE(592)] = 19603,
  [SMALL_STATE(593)] = 19716,
  [SMALL_STATE(594)] = 19829,
  [SMALL_STATE(595)] = 19940,
  [SMALL_STATE(596)] = 20053,
  [SMALL_STATE(597)] = 20158,
  [SMALL_STATE(598)] = 20243,
  [SMALL_STATE(599)] = 20328,
  [SMALL_STATE(600)] = 20433,
  [SMALL_STATE(601)] = 20484,
  [SMALL_STATE(602)] = 20587,
  [SMALL_STATE(603)] = 20690,
  [SMALL_STATE(604)] = 20741,
  [SMALL_STATE(605)] = 20854,
  [SMALL_STATE(606)] = 20967,
  [SMALL_STATE(607)] = 21080,
  [SMALL_STATE(608)] = 21167,
  [SMALL_STATE(609)] = 21232,
  [SMALL_STATE(610)] = 21319,
  [SMALL_STATE(611)] = 21384,
  [SMALL_STATE(612)] = 21462,
  [SMALL_STATE(613)] = 21570,
  [SMALL_STATE(614)] = 21648,
  [SMALL_STATE(615)] = 21726,
  [SMALL_STATE(616)] = 21804,
  [SMALL_STATE(617)] = 21882,
  [SMALL_STATE(618)] = 21941,
  [SMALL_STATE(619)] = 22052,
  [SMALL_STATE(620)] = 22163,
  [SMALL_STATE(621)] = 22274,
  [SMALL_STATE(622)] = 22377,
  [SMALL_STATE(623)] = 22488,
  [SMALL_STATE(624)] = 22599,
  [SMALL_STATE(625)] = 22710,
  [SMALL_STATE(626)] = 22769,
  [SMALL_STATE(627)] = 22880,
  [SMALL_STATE(628)] = 22939,
  [SMALL_STATE(629)] = 22998,
  [SMALL_STATE(630)] = 23077,
  [SMALL_STATE(631)] = 23136,
  [SMALL_STATE(632)] = 23195,
  [SMALL_STATE(633)] = 23306,
  [SMALL_STATE(634)] = 23407,
  [SMALL_STATE(635)] = 23518,
  [SMALL_STATE(636)] = 23572,
  [SMALL_STATE(637)] = 23684,
  [SMALL_STATE(638)] = 23744,
  [SMALL_STATE(639)] = 23798,
  [SMALL_STATE(640)] = 23852,
  [SMALL_STATE(641)] = 23906,
  [SMALL_STATE(642)] = 24018,
  [SMALL_STATE(643)] = 24072,
  [SMALL_STATE(644)] = 24120,
  [SMALL_STATE(645)] = 24168,
  [SMALL_STATE(646)] = 24228,
  [SMALL_STATE(647)] = 24288,
  [SMALL_STATE(648)] = 24342,
  [SMALL_STATE(649)] = 24402,
  [SMALL_STATE(650)] = 24463,
  [SMALL_STATE(651)] = 24518,
  [SMALL_STATE(652)] = 24573,
  [SMALL_STATE(653)] = 24628,
  [SMALL_STATE(654)] = 24681,
  [SMALL_STATE(655)] = 24734,
  [SMALL_STATE(656)] = 24789,
  [SMALL_STATE(657)] = 24844,
  [SMALL_STATE(658)] = 24897,
  [SMALL_STATE(659)] = 24954,
  [SMALL_STATE(660)] = 25009,
  [SMALL_STATE(661)] = 25064,
  [SMALL_STATE(662)] = 25121,
  [SMALL_STATE(663)] = 25176,
  [SMALL_STATE(664)] = 25229,
  [SMALL_STATE(665)] = 25290,
  [SMALL_STATE(666)] = 25347,
  [SMALL_STATE(667)] = 25404,
  [SMALL_STATE(668)] = 25461,
  [SMALL_STATE(669)] = 25516,
  [SMALL_STATE(670)] = 25571,
  [SMALL_STATE(671)] = 25628,
  [SMALL_STATE(672)] = 25678,
  [SMALL_STATE(673)] = 25732,
  [SMALL_STATE(674)] = 25782,
  [SMALL_STATE(675)] = 25828,
  [SMALL_STATE(676)] = 25882,
  [SMALL_STATE(677)] = 25932,
  [SMALL_STATE(678)] = 26030,
  [SMALL_STATE(679)] = 26080,
  [SMALL_STATE(680)] = 26126,
  [SMALL_STATE(681)] = 26176,
  [SMALL_STATE(682)] = 26228,
  [SMALL_STATE(683)] = 26278,
  [SMALL_STATE(684)] = 26328,
  [SMALL_STATE(685)] = 26374,
  [SMALL_STATE(686)] = 26424,
  [SMALL_STATE(687)] = 26470,
  [SMALL_STATE(688)] = 26524,
  [SMALL_STATE(689)] = 26574,
  [SMALL_STATE(690)] = 26628,
  [SMALL_STATE(691)] = 26682,
  [SMALL_STATE(692)] = 26736,
  [SMALL_STATE(693)] = 26786,
  [SMALL_STATE(694)] = 26884,
  [SMALL_STATE(695)] = 26934,
  [SMALL_STATE(696)] = 26984,
  [SMALL_STATE(697)] = 27038,
  [SMALL_STATE(698)] = 27092,
  [SMALL_STATE(699)] = 27142,
  [SMALL_STATE(700)] = 27188,
  [SMALL_STATE(701)] = 27234,
  [SMALL_STATE(702)] = 27284,
  [SMALL_STATE(703)] = 27334,
  [SMALL_STATE(704)] = 27386,
  [SMALL_STATE(705)] = 27432,
  [SMALL_STATE(706)] = 27478,
  [SMALL_STATE(707)] = 27528,
  [SMALL_STATE(708)] = 27573,
  [SMALL_STATE(709)] = 27622,
  [SMALL_STATE(710)] = 27669,
  [SMALL_STATE(711)] = 27714,
  [SMALL_STATE(712)] = 27759,
  [SMALL_STATE(713)] = 27804,
  [SMALL_STATE(714)] = 27849,
  [SMALL_STATE(715)] = 27896,
  [SMALL_STATE(716)] = 27951,
  [SMALL_STATE(717)] = 27998,
  [SMALL_STATE(718)] = 28043,
  [SMALL_STATE(719)] = 28088,
  [SMALL_STATE(720)] = 28133,
  [SMALL_STATE(721)] = 28178,
  [SMALL_STATE(722)] = 28223,
  [SMALL_STATE(723)] = 28268,
  [SMALL_STATE(724)] = 28313,
  [SMALL_STATE(725)] = 28358,
  [SMALL_STATE(726)] = 28403,
  [SMALL_STATE(727)] = 28498,
  [SMALL_STATE(728)] = 28543,
  [SMALL_STATE(729)] = 28588,
  [SMALL_STATE(730)] = 28633,
  [SMALL_STATE(731)] = 28678,
  [SMALL_STATE(732)] = 28723,
  [SMALL_STATE(733)] = 28768,
  [SMALL_STATE(734)] = 28813,
  [SMALL_STATE(735)] = 28870,
  [SMALL_STATE(736)] = 28917,
  [SMALL_STATE(737)] = 28962,
  [SMALL_STATE(738)] = 29007,
  [SMALL_STATE(739)] = 29052,
  [SMALL_STATE(740)] = 29099,
  [SMALL_STATE(741)] = 29144,
  [SMALL_STATE(742)] = 29193,
  [SMALL_STATE(743)] = 29242,
  [SMALL_STATE(744)] = 29291,
  [SMALL_STATE(745)] = 29360,
  [SMALL_STATE(746)] = 29409,
  [SMALL_STATE(747)] = 29454,
  [SMALL_STATE(748)] = 29499,
  [SMALL_STATE(749)] = 29556,
  [SMALL_STATE(750)] = 29605,
  [SMALL_STATE(751)] = 29700,
  [SMALL_STATE(752)] = 29745,
  [SMALL_STATE(753)] = 29792,
  [SMALL_STATE(754)] = 29839,
  [SMALL_STATE(755)] = 29884,
  [SMALL_STATE(756)] = 29931,
  [SMALL_STATE(757)] = 29978,
  [SMALL_STATE(758)] = 30025,
  [SMALL_STATE(759)] = 30072,
  [SMALL_STATE(760)] = 30127,
  [SMALL_STATE(761)] = 30174,
  [SMALL_STATE(762)] = 30221,
  [SMALL_STATE(763)] = 30268,
  [SMALL_STATE(764)] = 30315,
  [SMALL_STATE(765)] = 30362,
  [SMALL_STATE(766)] = 30407,
  [SMALL_STATE(767)] = 30470,
  [SMALL_STATE(768)] = 30515,
  [SMALL_STATE(769)] = 30560,
  [SMALL_STATE(770)] = 30605,
  [SMALL_STATE(771)] = 30650,
  [SMALL_STATE(772)] = 30695,
  [SMALL_STATE(773)] = 30766,
  [SMALL_STATE(774)] = 30837,
  [SMALL_STATE(775)] = 30882,
  [SMALL_STATE(776)] = 30927,
  [SMALL_STATE(777)] = 30972,
  [SMALL_STATE(778)] = 31041,
  [SMALL_STATE(779)] = 31086,
  [SMALL_STATE(780)] = 31131,
  [SMALL_STATE(781)] = 31180,
  [SMALL_STATE(782)] = 31225,
  [SMALL_STATE(783)] = 31294,
  [SMALL_STATE(784)] = 31339,
  [SMALL_STATE(785)] = 31384,
  [SMALL_STATE(786)] = 31433,
  [SMALL_STATE(787)] = 31482,
  [SMALL_STATE(788)] = 31531,
  [SMALL_STATE(789)] = 31580,
  [SMALL_STATE(790)] = 31629,
  [SMALL_STATE(791)] = 31674,
  [SMALL_STATE(792)] = 31719,
  [SMALL_STATE(793)] = 31814,
  [SMALL_STATE(794)] = 31861,
  [SMALL_STATE(795)] = 31930,
  [SMALL_STATE(796)] = 31975,
  [SMALL_STATE(797)] = 32020,
  [SMALL_STATE(798)] = 32065,
  [SMALL_STATE(799)] = 32160,
  [SMALL_STATE(800)] = 32205,
  [SMALL_STATE(801)] = 32250,
  [SMALL_STATE(802)] = 32295,
  [SMALL_STATE(803)] = 32344,
  [SMALL_STATE(804)] = 32389,
  [SMALL_STATE(805)] = 32434,
  [SMALL_STATE(806)] = 32481,
  [SMALL_STATE(807)] = 32526,
  [SMALL_STATE(808)] = 32573,
  [SMALL_STATE(809)] = 32618,
  [SMALL_STATE(810)] = 32667,
  [SMALL_STATE(811)] = 32714,
  [SMALL_STATE(812)] = 32762,
  [SMALL_STATE(813)] = 32806,
  [SMALL_STATE(814)] = 32850,
  [SMALL_STATE(815)] = 32894,
  [SMALL_STATE(816)] = 32938,
  [SMALL_STATE(817)] = 32988,
  [SMALL_STATE(818)] = 33032,
  [SMALL_STATE(819)] = 33076,
  [SMALL_STATE(820)] = 33120,
  [SMALL_STATE(821)] = 33164,
  [SMALL_STATE(822)] = 33208,
  [SMALL_STATE(823)] = 33252,
  [SMALL_STATE(824)] = 33296,
  [SMALL_STATE(825)] = 33400,
  [SMALL_STATE(826)] = 33444,
  [SMALL_STATE(827)] = 33488,
  [SMALL_STATE(828)] = 33532,
  [SMALL_STATE(829)] = 33624,
  [SMALL_STATE(830)] = 33668,
  [SMALL_STATE(831)] = 33716,
  [SMALL_STATE(832)] = 33760,
  [SMALL_STATE(833)] = 33804,
  [SMALL_STATE(834)] = 33848,
  [SMALL_STATE(835)] = 33898,
  [SMALL_STATE(836)] = 33942,
  [SMALL_STATE(837)] = 33986,
  [SMALL_STATE(838)] = 34030,
  [SMALL_STATE(839)] = 34080,
  [SMALL_STATE(840)] = 34124,
  [SMALL_STATE(841)] = 34168,
  [SMALL_STATE(842)] = 34212,
  [SMALL_STATE(843)] = 34304,
  [SMALL_STATE(844)] = 34348,
  [SMALL_STATE(845)] = 34392,
  [SMALL_STATE(846)] = 34436,
  [SMALL_STATE(847)] = 34480,
  [SMALL_STATE(848)] = 34524,
  [SMALL_STATE(849)] = 34568,
  [SMALL_STATE(850)] = 34612,
  [SMALL_STATE(851)] = 34656,
  [SMALL_STATE(852)] = 34700,
  [SMALL_STATE(853)] = 34744,
  [SMALL_STATE(854)] = 34788,
  [SMALL_STATE(855)] = 34832,
  [SMALL_STATE(856)] = 34876,
  [SMALL_STATE(857)] = 34920,
  [SMALL_STATE(858)] = 34964,
  [SMALL_STATE(859)] = 35008,
  [SMALL_STATE(860)] = 35052,
  [SMALL_STATE(861)] = 35096,
  [SMALL_STATE(862)] = 35140,
  [SMALL_STATE(863)] = 35184,
  [SMALL_STATE(864)] = 35228,
  [SMALL_STATE(865)] = 35272,
  [SMALL_STATE(866)] = 35316,
  [SMALL_STATE(867)] = 35360,
  [SMALL_STATE(868)] = 35404,
  [SMALL_STATE(869)] = 35448,
  [SMALL_STATE(870)] = 35492,
  [SMALL_STATE(871)] = 35536,
  [SMALL_STATE(872)] = 35580,
  [SMALL_STATE(873)] = 35624,
  [SMALL_STATE(874)] = 35668,
  [SMALL_STATE(875)] = 35712,
  [SMALL_STATE(876)] = 35756,
  [SMALL_STATE(877)] = 35800,
  [SMALL_STATE(878)] = 35844,
  [SMALL_STATE(879)] = 35888,
  [SMALL_STATE(880)] = 35932,
  [SMALL_STATE(881)] = 35976,
  [SMALL_STATE(882)] = 36020,
  [SMALL_STATE(883)] = 36064,
  [SMALL_STATE(884)] = 36108,
  [SMALL_STATE(885)] = 36152,
  [SMALL_STATE(886)] = 36196,
  [SMALL_STATE(887)] = 36240,
  [SMALL_STATE(888)] = 36284,
  [SMALL_STATE(889)] = 36332,
  [SMALL_STATE(890)] = 36436,
  [SMALL_STATE(891)] = 36484,
  [SMALL_STATE(892)] = 36528,
  [SMALL_STATE(893)] = 36632,
  [SMALL_STATE(894)] = 36728,
  [SMALL_STATE(895)] = 36776,
  [SMALL_STATE(896)] = 36820,
  [SMALL_STATE(897)] = 36864,
  [SMALL_STATE(898)] = 36968,
  [SMALL_STATE(899)] = 37012,
  [SMALL_STATE(900)] = 37116,
  [SMALL_STATE(901)] = 37220,
  [SMALL_STATE(902)] = 37264,
  [SMALL_STATE(903)] = 37362,
  [SMALL_STATE(904)] = 37466,
  [SMALL_STATE(905)] = 37570,
  [SMALL_STATE(906)] = 37614,
  [SMALL_STATE(907)] = 37718,
  [SMALL_STATE(908)] = 37762,
  [SMALL_STATE(909)] = 37806,
  [SMALL_STATE(910)] = 37850,
  [SMALL_STATE(911)] = 37894,
  [SMALL_STATE(912)] = 37938,
  [SMALL_STATE(913)] = 37982,
  [SMALL_STATE(914)] = 38026,
  [SMALL_STATE(915)] = 38070,
  [SMALL_STATE(916)] = 38114,
  [SMALL_STATE(917)] = 38162,
  [SMALL_STATE(918)] = 38206,
  [SMALL_STATE(919)] = 38250,
  [SMALL_STATE(920)] = 38294,
  [SMALL_STATE(921)] = 38338,
  [SMALL_STATE(922)] = 38382,
  [SMALL_STATE(923)] = 38426,
  [SMALL_STATE(924)] = 38470,
  [SMALL_STATE(925)] = 38514,
  [SMALL_STATE(926)] = 38564,
  [SMALL_STATE(927)] = 38614,
  [SMALL_STATE(928)] = 38658,
  [SMALL_STATE(929)] = 38702,
  [SMALL_STATE(930)] = 38746,
  [SMALL_STATE(931)] = 38790,
  [SMALL_STATE(932)] = 38834,
  [SMALL_STATE(933)] = 38884,
  [SMALL_STATE(934)] = 38928,
  [SMALL_STATE(935)] = 38972,
  [SMALL_STATE(936)] = 39016,
  [SMALL_STATE(937)] = 39060,
  [SMALL_STATE(938)] = 39104,
  [SMALL_STATE(939)] = 39148,
  [SMALL_STATE(940)] = 39192,
  [SMALL_STATE(941)] = 39281,
  [SMALL_STATE(942)] = 39340,
  [SMALL_STATE(943)] = 39429,
  [SMALL_STATE(944)] = 39481,
  [SMALL_STATE(945)] = 39575,
  [SMALL_STATE(946)] = 39627,
  [SMALL_STATE(947)] = 39721,
  [SMALL_STATE(948)] = 39773,
  [SMALL_STATE(949)] = 39867,
  [SMALL_STATE(950)] = 39961,
  [SMALL_STATE(951)] = 40003,
  [SMALL_STATE(952)] = 40097,
  [SMALL_STATE(953)] = 40191,
  [SMALL_STATE(954)] = 40285,
  [SMALL_STATE(955)] = 40329,
  [SMALL_STATE(956)] = 40423,
  [SMALL_STATE(957)] = 40517,
  [SMALL_STATE(958)] = 40559,
  [SMALL_STATE(959)] = 40611,
  [SMALL_STATE(960)] = 40653,
  [SMALL_STATE(961)] = 40705,
  [SMALL_STATE(962)] = 40757,
  [SMALL_STATE(963)] = 40851,
  [SMALL_STATE(964)] = 40945,
  [SMALL_STATE(965)] = 41039,
  [SMALL_STATE(966)] = 41090,
  [SMALL_STATE(967)] = 41149,
  [SMALL_STATE(968)] = 41208,
  [SMALL_STATE(969)] = 41293,
  [SMALL_STATE(970)] = 41334,
  [SMALL_STATE(971)] = 41378,
  [SMALL_STATE(972)] = 41432,
  [SMALL_STATE(973)] = 41482,
  [SMALL_STATE(974)] = 41524,
  [SMALL_STATE(975)] = 41574,
  [SMALL_STATE(976)] = 41626,
  [SMALL_STATE(977)] = 41678,
  [SMALL_STATE(978)] = 41732,
  [SMALL_STATE(979)] = 41782,
  [SMALL_STATE(980)] = 41832,
  [SMALL_STATE(981)] = 41882,
  [SMALL_STATE(982)] = 41934,
  [SMALL_STATE(983)] = 41984,
  [SMALL_STATE(984)] = 42036,
  [SMALL_STATE(985)] = 42083,
  [SMALL_STATE(986)] = 42122,
  [SMALL_STATE(987)] = 42169,
  [SMALL_STATE(988)] = 42210,
  [SMALL_STATE(989)] = 42251,
  [SMALL_STATE(990)] = 42298,
  [SMALL_STATE(991)] = 42341,
  [SMALL_STATE(992)] = 42384,
  [SMALL_STATE(993)] = 42423,
  [SMALL_STATE(994)] = 42470,
  [SMALL_STATE(995)] = 42509,
  [SMALL_STATE(996)] = 42548,
  [SMALL_STATE(997)] = 42587,
  [SMALL_STATE(998)] = 42626,
  [SMALL_STATE(999)] = 42665,
  [SMALL_STATE(1000)] = 42722,
  [SMALL_STATE(1001)] = 42761,
  [SMALL_STATE(1002)] = 42800,
  [SMALL_STATE(1003)] = 42839,
  [SMALL_STATE(1004)] = 42882,
  [SMALL_STATE(1005)] = 42929,
  [SMALL_STATE(1006)] = 42974,
  [SMALL_STATE(1007)] = 43021,
  [SMALL_STATE(1008)] = 43066,
  [SMALL_STATE(1009)] = 43105,
  [SMALL_STATE(1010)] = 43150,
  [SMALL_STATE(1011)] = 43189,
  [SMALL_STATE(1012)] = 43232,
  [SMALL_STATE(1013)] = 43277,
  [SMALL_STATE(1014)] = 43316,
  [SMALL_STATE(1015)] = 43355,
  [SMALL_STATE(1016)] = 43394,
  [SMALL_STATE(1017)] = 43439,
  [SMALL_STATE(1018)] = 43478,
  [SMALL_STATE(1019)] = 43517,
  [SMALL_STATE(1020)] = 43562,
  [SMALL_STATE(1021)] = 43609,
  [SMALL_STATE(1022)] = 43666,
  [SMALL_STATE(1023)] = 43705,
  [SMALL_STATE(1024)] = 43752,
  [SMALL_STATE(1025)] = 43790,
  [SMALL_STATE(1026)] = 43838,
  [SMALL_STATE(1027)] = 43884,
  [SMALL_STATE(1028)] = 43928,
  [SMALL_STATE(1029)] = 43972,
  [SMALL_STATE(1030)] = 44014,
  [SMALL_STATE(1031)] = 44062,
  [SMALL_STATE(1032)] = 44100,
  [SMALL_STATE(1033)] = 44138,
  [SMALL_STATE(1034)] = 44176,
  [SMALL_STATE(1035)] = 44222,
  [SMALL_STATE(1036)] = 44264,
  [SMALL_STATE(1037)] = 44302,
  [SMALL_STATE(1038)] = 44340,
  [SMALL_STATE(1039)] = 44384,
  [SMALL_STATE(1040)] = 44422,
  [SMALL_STATE(1041)] = 44459,
  [SMALL_STATE(1042)] = 44496,
  [SMALL_STATE(1043)] = 44537,
  [SMALL_STATE(1044)] = 44574,
  [SMALL_STATE(1045)] = 44615,
  [SMALL_STATE(1046)] = 44656,
  [SMALL_STATE(1047)] = 44693,
  [SMALL_STATE(1048)] = 44736,
  [SMALL_STATE(1049)] = 44773,
  [SMALL_STATE(1050)] = 44810,
  [SMALL_STATE(1051)] = 44851,
  [SMALL_STATE(1052)] = 44892,
  [SMALL_STATE(1053)] = 44929,
  [SMALL_STATE(1054)] = 44972,
  [SMALL_STATE(1055)] = 45037,
  [SMALL_STATE(1056)] = 45074,
  [SMALL_STATE(1057)] = 45111,
  [SMALL_STATE(1058)] = 45148,
  [SMALL_STATE(1059)] = 45185,
  [SMALL_STATE(1060)] = 45250,
  [SMALL_STATE(1061)] = 45287,
  [SMALL_STATE(1062)] = 45328,
  [SMALL_STATE(1063)] = 45365,
  [SMALL_STATE(1064)] = 45402,
  [SMALL_STATE(1065)] = 45467,
  [SMALL_STATE(1066)] = 45508,
  [SMALL_STATE(1067)] = 45545,
  [SMALL_STATE(1068)] = 45610,
  [SMALL_STATE(1069)] = 45647,
  [SMALL_STATE(1070)] = 45688,
  [SMALL_STATE(1071)] = 45729,
  [SMALL_STATE(1072)] = 45766,
  [SMALL_STATE(1073)] = 45807,
  [SMALL_STATE(1074)] = 45843,
  [SMALL_STATE(1075)] = 45883,
  [SMALL_STATE(1076)] = 45923,
  [SMALL_STATE(1077)] = 45959,
  [SMALL_STATE(1078)] = 45995,
  [SMALL_STATE(1079)] = 46033,
  [SMALL_STATE(1080)] = 46069,
  [SMALL_STATE(1081)] = 46109,
  [SMALL_STATE(1082)] = 46149,
  [SMALL_STATE(1083)] = 46189,
  [SMALL_STATE(1084)] = 46225,
  [SMALL_STATE(1085)] = 46271,
  [SMALL_STATE(1086)] = 46307,
  [SMALL_STATE(1087)] = 46343,
  [SMALL_STATE(1088)] = 46383,
  [SMALL_STATE(1089)] = 46423,
  [SMALL_STATE(1090)] = 46461,
  [SMALL_STATE(1091)] = 46497,
  [SMALL_STATE(1092)] = 46535,
  [SMALL_STATE(1093)] = 46571,
  [SMALL_STATE(1094)] = 46611,
  [SMALL_STATE(1095)] = 46649,
  [SMALL_STATE(1096)] = 46689,
  [SMALL_STATE(1097)] = 46727,
  [SMALL_STATE(1098)] = 46765,
  [SMALL_STATE(1099)] = 46801,
  [SMALL_STATE(1100)] = 46837,
  [SMALL_STATE(1101)] = 46875,
  [SMALL_STATE(1102)] = 46911,
  [SMALL_STATE(1103)] = 46949,
  [SMALL_STATE(1104)] = 46991,
  [SMALL_STATE(1105)] = 47027,
  [SMALL_STATE(1106)] = 47065,
  [SMALL_STATE(1107)] = 47103,
  [SMALL_STATE(1108)] = 47139,
  [SMALL_STATE(1109)] = 47177,
  [SMALL_STATE(1110)] = 47213,
  [SMALL_STATE(1111)] = 47249,
  [SMALL_STATE(1112)] = 47289,
  [SMALL_STATE(1113)] = 47325,
  [SMALL_STATE(1114)] = 47361,
  [SMALL_STATE(1115)] = 47397,
  [SMALL_STATE(1116)] = 47435,
  [SMALL_STATE(1117)] = 47471,
  [SMALL_STATE(1118)] = 47509,
  [SMALL_STATE(1119)] = 47545,
  [SMALL_STATE(1120)] = 47585,
  [SMALL_STATE(1121)] = 47621,
  [SMALL_STATE(1122)] = 47661,
  [SMALL_STATE(1123)] = 47697,
  [SMALL_STATE(1124)] = 47733,
  [SMALL_STATE(1125)] = 47769,
  [SMALL_STATE(1126)] = 47819,
  [SMALL_STATE(1127)] = 47857,
  [SMALL_STATE(1128)] = 47893,
  [SMALL_STATE(1129)] = 47933,
  [SMALL_STATE(1130)] = 47969,
  [SMALL_STATE(1131)] = 48005,
  [SMALL_STATE(1132)] = 48045,
  [SMALL_STATE(1133)] = 48081,
  [SMALL_STATE(1134)] = 48117,
  [SMALL_STATE(1135)] = 48152,
  [SMALL_STATE(1136)] = 48197,
  [SMALL_STATE(1137)] = 48232,
  [SMALL_STATE(1138)] = 48267,
  [SMALL_STATE(1139)] = 48302,
  [SMALL_STATE(1140)] = 48337,
  [SMALL_STATE(1141)] = 48372,
  [SMALL_STATE(1142)] = 48407,
  [SMALL_STATE(1143)] = 48452,
  [SMALL_STATE(1144)] = 48487,
  [SMALL_STATE(1145)] = 48526,
  [SMALL_STATE(1146)] = 48561,
  [SMALL_STATE(1147)] = 48596,
  [SMALL_STATE(1148)] = 48641,
  [SMALL_STATE(1149)] = 48676,
  [SMALL_STATE(1150)] = 48717,
  [SMALL_STATE(1151)] = 48752,
  [SMALL_STATE(1152)] = 48787,
  [SMALL_STATE(1153)] = 48822,
  [SMALL_STATE(1154)] = 48857,
  [SMALL_STATE(1155)] = 48892,
  [SMALL_STATE(1156)] = 48960,
  [SMALL_STATE(1157)] = 48996,
  [SMALL_STATE(1158)] = 49064,
  [SMALL_STATE(1159)] = 49132,
  [SMALL_STATE(1160)] = 49176,
  [SMALL_STATE(1161)] = 49244,
  [SMALL_STATE(1162)] = 49288,
  [SMALL_STATE(1163)] = 49326,
  [SMALL_STATE(1164)] = 49394,
  [SMALL_STATE(1165)] = 49430,
  [SMALL_STATE(1166)] = 49498,
  [SMALL_STATE(1167)] = 49536,
  [SMALL_STATE(1168)] = 49574,
  [SMALL_STATE(1169)] = 49610,
  [SMALL_STATE(1170)] = 49648,
  [SMALL_STATE(1171)] = 49716,
  [SMALL_STATE(1172)] = 49754,
  [SMALL_STATE(1173)] = 49822,
  [SMALL_STATE(1174)] = 49890,
  [SMALL_STATE(1175)] = 49928,
  [SMALL_STATE(1176)] = 49996,
  [SMALL_STATE(1177)] = 50064,
  [SMALL_STATE(1178)] = 50132,
  [SMALL_STATE(1179)] = 50200,
  [SMALL_STATE(1180)] = 50236,
  [SMALL_STATE(1181)] = 50272,
  [SMALL_STATE(1182)] = 50340,
  [SMALL_STATE(1183)] = 50408,
  [SMALL_STATE(1184)] = 50444,
  [SMALL_STATE(1185)] = 50497,
  [SMALL_STATE(1186)] = 50562,
  [SMALL_STATE(1187)] = 50626,
  [SMALL_STATE(1188)] = 50663,
  [SMALL_STATE(1189)] = 50706,
  [SMALL_STATE(1190)] = 50749,
  [SMALL_STATE(1191)] = 50790,
  [SMALL_STATE(1192)] = 50820,
  [SMALL_STATE(1193)] = 50850,
  [SMALL_STATE(1194)] = 50888,
  [SMALL_STATE(1195)] = 50918,
  [SMALL_STATE(1196)] = 50954,
  [SMALL_STATE(1197)] = 50984,
  [SMALL_STATE(1198)] = 51034,
  [SMALL_STATE(1199)] = 51064,
  [SMALL_STATE(1200)] = 51094,
  [SMALL_STATE(1201)] = 51128,
  [SMALL_STATE(1202)] = 51158,
  [SMALL_STATE(1203)] = 51188,
  [SMALL_STATE(1204)] = 51218,
  [SMALL_STATE(1205)] = 51248,
  [SMALL_STATE(1206)] = 51278,
  [SMALL_STATE(1207)] = 51308,
  [SMALL_STATE(1208)] = 51338,
  [SMALL_STATE(1209)] = 51368,
  [SMALL_STATE(1210)] = 51398,
  [SMALL_STATE(1211)] = 51428,
  [SMALL_STATE(1212)] = 51478,
  [SMALL_STATE(1213)] = 51508,
  [SMALL_STATE(1214)] = 51538,
  [SMALL_STATE(1215)] = 51575,
  [SMALL_STATE(1216)] = 51606,
  [SMALL_STATE(1217)] = 51639,
  [SMALL_STATE(1218)] = 51670,
  [SMALL_STATE(1219)] = 51701,
  [SMALL_STATE(1220)] = 51734,
  [SMALL_STATE(1221)] = 51789,
  [SMALL_STATE(1222)] = 51822,
  [SMALL_STATE(1223)] = 51855,
  [SMALL_STATE(1224)] = 51886,
  [SMALL_STATE(1225)] = 51923,
  [SMALL_STATE(1226)] = 51978,
  [SMALL_STATE(1227)] = 52027,
  [SMALL_STATE(1228)] = 52082,
  [SMALL_STATE(1229)] = 52117,
  [SMALL_STATE(1230)] = 52150,
  [SMALL_STATE(1231)] = 52199,
  [SMALL_STATE(1232)] = 52228,
  [SMALL_STATE(1233)] = 52265,
  [SMALL_STATE(1234)] = 52314,
  [SMALL_STATE(1235)] = 52349,
  [SMALL_STATE(1236)] = 52404,
  [SMALL_STATE(1237)] = 52439,
  [SMALL_STATE(1238)] = 52488,
  [SMALL_STATE(1239)] = 52537,
  [SMALL_STATE(1240)] = 52574,
  [SMALL_STATE(1241)] = 52605,
  [SMALL_STATE(1242)] = 52636,
  [SMALL_STATE(1243)] = 52669,
  [SMALL_STATE(1244)] = 52697,
  [SMALL_STATE(1245)] = 52735,
  [SMALL_STATE(1246)] = 52773,
  [SMALL_STATE(1247)] = 52819,
  [SMALL_STATE(1248)] = 52857,
  [SMALL_STATE(1249)] = 52895,
  [SMALL_STATE(1250)] = 52923,
  [SMALL_STATE(1251)] = 52975,
  [SMALL_STATE(1252)] = 53013,
  [SMALL_STATE(1253)] = 53059,
  [SMALL_STATE(1254)] = 53111,
  [SMALL_STATE(1255)] = 53163,
  [SMALL_STATE(1256)] = 53201,
  [SMALL_STATE(1257)] = 53253,
  [SMALL_STATE(1258)] = 53281,
  [SMALL_STATE(1259)] = 53319,
  [SMALL_STATE(1260)] = 53347,
  [SMALL_STATE(1261)] = 53385,
  [SMALL_STATE(1262)] = 53417,
  [SMALL_STATE(1263)] = 53455,
  [SMALL_STATE(1264)] = 53507,
  [SMALL_STATE(1265)] = 53539,
  [SMALL_STATE(1266)] = 53577,
  [SMALL_STATE(1267)] = 53615,
  [SMALL_STATE(1268)] = 53661,
  [SMALL_STATE(1269)] = 53693,
  [SMALL_STATE(1270)] = 53731,
  [SMALL_STATE(1271)] = 53763,
  [SMALL_STATE(1272)] = 53809,
  [SMALL_STATE(1273)] = 53837,
  [SMALL_STATE(1274)] = 53875,
  [SMALL_STATE(1275)] = 53907,
  [SMALL_STATE(1276)] = 53956,
  [SMALL_STATE(1277)] = 54013,
  [SMALL_STATE(1278)] = 54064,
  [SMALL_STATE(1279)] = 54091,
  [SMALL_STATE(1280)] = 54140,
  [SMALL_STATE(1281)] = 54183,
  [SMALL_STATE(1282)] = 54232,
  [SMALL_STATE(1283)] = 54259,
  [SMALL_STATE(1284)] = 54308,
  [SMALL_STATE(1285)] = 54335,
  [SMALL_STATE(1286)] = 54362,
  [SMALL_STATE(1287)] = 54389,
  [SMALL_STATE(1288)] = 54432,
  [SMALL_STATE(1289)] = 54459,
  [SMALL_STATE(1290)] = 54486,
  [SMALL_STATE(1291)] = 54537,
  [SMALL_STATE(1292)] = 54588,
  [SMALL_STATE(1293)] = 54615,
  [SMALL_STATE(1294)] = 54657,
  [SMALL_STATE(1295)] = 54711,
  [SMALL_STATE(1296)] = 54761,
  [SMALL_STATE(1297)] = 54811,
  [SMALL_STATE(1298)] = 54861,
  [SMALL_STATE(1299)] = 54911,
  [SMALL_STATE(1300)] = 54937,
  [SMALL_STATE(1301)] = 54987,
  [SMALL_STATE(1302)] = 55013,
  [SMALL_STATE(1303)] = 55038,
  [SMALL_STATE(1304)] = 55063,
  [SMALL_STATE(1305)] = 55088,
  [SMALL_STATE(1306)] = 55133,
  [SMALL_STATE(1307)] = 55180,
  [SMALL_STATE(1308)] = 55227,
  [SMALL_STATE(1309)] = 55274,
  [SMALL_STATE(1310)] = 55321,
  [SMALL_STATE(1311)] = 55346,
  [SMALL_STATE(1312)] = 55394,
  [SMALL_STATE(1313)] = 55418,
  [SMALL_STATE(1314)] = 55466,
  [SMALL_STATE(1315)] = 55490,
  [SMALL_STATE(1316)] = 55514,
  [SMALL_STATE(1317)] = 55538,
  [SMALL_STATE(1318)] = 55562,
  [SMALL_STATE(1319)] = 55586,
  [SMALL_STATE(1320)] = 55630,
  [SMALL_STATE(1321)] = 55678,
  [SMALL_STATE(1322)] = 55701,
  [SMALL_STATE(1323)] = 55724,
  [SMALL_STATE(1324)] = 55747,
  [SMALL_STATE(1325)] = 55788,
  [SMALL_STATE(1326)] = 55829,
  [SMALL_STATE(1327)] = 55852,
  [SMALL_STATE(1328)] = 55875,
  [SMALL_STATE(1329)] = 55916,
  [SMALL_STATE(1330)] = 55939,
  [SMALL_STATE(1331)] = 55968,
  [SMALL_STATE(1332)] = 56011,
  [SMALL_STATE(1333)] = 56052,
  [SMALL_STATE(1334)] = 56091,
  [SMALL_STATE(1335)] = 56114,
  [SMALL_STATE(1336)] = 56154,
  [SMALL_STATE(1337)] = 56192,
  [SMALL_STATE(1338)] = 56228,
  [SMALL_STATE(1339)] = 56268,
  [SMALL_STATE(1340)] = 56308,
  [SMALL_STATE(1341)] = 56348,
  [SMALL_STATE(1342)] = 56388,
  [SMALL_STATE(1343)] = 56428,
  [SMALL_STATE(1344)] = 56464,
  [SMALL_STATE(1345)] = 56504,
  [SMALL_STATE(1346)] = 56541,
  [SMALL_STATE(1347)] = 56578,
  [SMALL_STATE(1348)] = 56617,
  [SMALL_STATE(1349)] = 56646,
  [SMALL_STATE(1350)] = 56671,
  [SMALL_STATE(1351)] = 56708,
  [SMALL_STATE(1352)] = 56745,
  [SMALL_STATE(1353)] = 56784,
  [SMALL_STATE(1354)] = 56825,
  [SMALL_STATE(1355)] = 56862,
  [SMALL_STATE(1356)] = 56901,
  [SMALL_STATE(1357)] = 56924,
  [SMALL_STATE(1358)] = 56963,
  [SMALL_STATE(1359)] = 57000,
  [SMALL_STATE(1360)] = 57039,
  [SMALL_STATE(1361)] = 57078,
  [SMALL_STATE(1362)] = 57119,
  [SMALL_STATE(1363)] = 57148,
  [SMALL_STATE(1364)] = 57185,
  [SMALL_STATE(1365)] = 57222,
  [SMALL_STATE(1366)] = 57258,
  [SMALL_STATE(1367)] = 57294,
  [SMALL_STATE(1368)] = 57330,
  [SMALL_STATE(1369)] = 57364,
  [SMALL_STATE(1370)] = 57398,
  [SMALL_STATE(1371)] = 57434,
  [SMALL_STATE(1372)] = 57470,
  [SMALL_STATE(1373)] = 57506,
  [SMALL_STATE(1374)] = 57542,
  [SMALL_STATE(1375)] = 57576,
  [SMALL_STATE(1376)] = 57612,
  [SMALL_STATE(1377)] = 57648,
  [SMALL_STATE(1378)] = 57684,
  [SMALL_STATE(1379)] = 57720,
  [SMALL_STATE(1380)] = 57756,
  [SMALL_STATE(1381)] = 57792,
  [SMALL_STATE(1382)] = 57826,
  [SMALL_STATE(1383)] = 57860,
  [SMALL_STATE(1384)] = 57896,
  [SMALL_STATE(1385)] = 57932,
  [SMALL_STATE(1386)] = 57968,
  [SMALL_STATE(1387)] = 58004,
  [SMALL_STATE(1388)] = 58040,
  [SMALL_STATE(1389)] = 58074,
  [SMALL_STATE(1390)] = 58108,
  [SMALL_STATE(1391)] = 58144,
  [SMALL_STATE(1392)] = 58175,
  [SMALL_STATE(1393)] = 58202,
  [SMALL_STATE(1394)] = 58225,
  [SMALL_STATE(1395)] = 58244,
  [SMALL_STATE(1396)] = 58275,
  [SMALL_STATE(1397)] = 58302,
  [SMALL_STATE(1398)] = 58329,
  [SMALL_STATE(1399)] = 58356,
  [SMALL_STATE(1400)] = 58383,
  [SMALL_STATE(1401)] = 58404,
  [SMALL_STATE(1402)] = 58427,
  [SMALL_STATE(1403)] = 58450,
  [SMALL_STATE(1404)] = 58477,
  [SMALL_STATE(1405)] = 58504,
  [SMALL_STATE(1406)] = 58531,
  [SMALL_STATE(1407)] = 58562,
  [SMALL_STATE(1408)] = 58589,
  [SMALL_STATE(1409)] = 58624,
  [SMALL_STATE(1410)] = 58651,
  [SMALL_STATE(1411)] = 58678,
  [SMALL_STATE(1412)] = 58703,
  [SMALL_STATE(1413)] = 58738,
  [SMALL_STATE(1414)] = 58769,
  [SMALL_STATE(1415)] = 58790,
  [SMALL_STATE(1416)] = 58817,
  [SMALL_STATE(1417)] = 58844,
  [SMALL_STATE(1418)] = 58867,
  [SMALL_STATE(1419)] = 58890,
  [SMALL_STATE(1420)] = 58921,
  [SMALL_STATE(1421)] = 58942,
  [SMALL_STATE(1422)] = 58963,
  [SMALL_STATE(1423)] = 58984,
  [SMALL_STATE(1424)] = 59011,
  [SMALL_STATE(1425)] = 59035,
  [SMALL_STATE(1426)] = 59061,
  [SMALL_STATE(1427)] = 59085,
  [SMALL_STATE(1428)] = 59109,
  [SMALL_STATE(1429)] = 59133,
  [SMALL_STATE(1430)] = 59155,
  [SMALL_STATE(1431)] = 59181,
  [SMALL_STATE(1432)] = 59205,
  [SMALL_STATE(1433)] = 59229,
  [SMALL_STATE(1434)] = 59253,
  [SMALL_STATE(1435)] = 59277,
  [SMALL_STATE(1436)] = 59301,
  [SMALL_STATE(1437)] = 59325,
  [SMALL_STATE(1438)] = 59351,
  [SMALL_STATE(1439)] = 59381,
  [SMALL_STATE(1440)] = 59405,
  [SMALL_STATE(1441)] = 59429,
  [SMALL_STATE(1442)] = 59453,
  [SMALL_STATE(1443)] = 59479,
  [SMALL_STATE(1444)] = 59503,
  [SMALL_STATE(1445)] = 59531,
  [SMALL_STATE(1446)] = 59555,
  [SMALL_STATE(1447)] = 59579,
  [SMALL_STATE(1448)] = 59603,
  [SMALL_STATE(1449)] = 59627,
  [SMALL_STATE(1450)] = 59651,
  [SMALL_STATE(1451)] = 59673,
  [SMALL_STATE(1452)] = 59697,
  [SMALL_STATE(1453)] = 59721,
  [SMALL_STATE(1454)] = 59745,
  [SMALL_STATE(1455)] = 59769,
  [SMALL_STATE(1456)] = 59797,
  [SMALL_STATE(1457)] = 59821,
  [SMALL_STATE(1458)] = 59845,
  [SMALL_STATE(1459)] = 59869,
  [SMALL_STATE(1460)] = 59897,
  [SMALL_STATE(1461)] = 59921,
  [SMALL_STATE(1462)] = 59945,
  [SMALL_STATE(1463)] = 59971,
  [SMALL_STATE(1464)] = 59995,
  [SMALL_STATE(1465)] = 60019,
  [SMALL_STATE(1466)] = 60043,
  [SMALL_STATE(1467)] = 60067,
  [SMALL_STATE(1468)] = 60099,
  [SMALL_STATE(1469)] = 60123,
  [SMALL_STATE(1470)] = 60144,
  [SMALL_STATE(1471)] = 60165,
  [SMALL_STATE(1472)] = 60186,
  [SMALL_STATE(1473)] = 60209,
  [SMALL_STATE(1474)] = 60232,
  [SMALL_STATE(1475)] = 60253,
  [SMALL_STATE(1476)] = 60276,
  [SMALL_STATE(1477)] = 60299,
  [SMALL_STATE(1478)] = 60324,
  [SMALL_STATE(1479)] = 60351,
  [SMALL_STATE(1480)] = 60372,
  [SMALL_STATE(1481)] = 60397,
  [SMALL_STATE(1482)] = 60418,
  [SMALL_STATE(1483)] = 60439,
  [SMALL_STATE(1484)] = 60466,
  [SMALL_STATE(1485)] = 60485,
  [SMALL_STATE(1486)] = 60508,
  [SMALL_STATE(1487)] = 60529,
  [SMALL_STATE(1488)] = 60550,
  [SMALL_STATE(1489)] = 60571,
  [SMALL_STATE(1490)] = 60592,
  [SMALL_STATE(1491)] = 60621,
  [SMALL_STATE(1492)] = 60646,
  [SMALL_STATE(1493)] = 60667,
  [SMALL_STATE(1494)] = 60688,
  [SMALL_STATE(1495)] = 60711,
  [SMALL_STATE(1496)] = 60738,
  [SMALL_STATE(1497)] = 60759,
  [SMALL_STATE(1498)] = 60782,
  [SMALL_STATE(1499)] = 60803,
  [SMALL_STATE(1500)] = 60830,
  [SMALL_STATE(1501)] = 60851,
  [SMALL_STATE(1502)] = 60872,
  [SMALL_STATE(1503)] = 60893,
  [SMALL_STATE(1504)] = 60916,
  [SMALL_STATE(1505)] = 60939,
  [SMALL_STATE(1506)] = 60960,
  [SMALL_STATE(1507)] = 60975,
  [SMALL_STATE(1508)] = 60996,
  [SMALL_STATE(1509)] = 61011,
  [SMALL_STATE(1510)] = 61040,
  [SMALL_STATE(1511)] = 61059,
  [SMALL_STATE(1512)] = 61074,
  [SMALL_STATE(1513)] = 61097,
  [SMALL_STATE(1514)] = 61118,
  [SMALL_STATE(1515)] = 61139,
  [SMALL_STATE(1516)] = 61158,
  [SMALL_STATE(1517)] = 61179,
  [SMALL_STATE(1518)] = 61206,
  [SMALL_STATE(1519)] = 61227,
  [SMALL_STATE(1520)] = 61248,
  [SMALL_STATE(1521)] = 61267,
  [SMALL_STATE(1522)] = 61288,
  [SMALL_STATE(1523)] = 61307,
  [SMALL_STATE(1524)] = 61328,
  [SMALL_STATE(1525)] = 61349,
  [SMALL_STATE(1526)] = 61374,
  [SMALL_STATE(1527)] = 61395,
  [SMALL_STATE(1528)] = 61420,
  [SMALL_STATE(1529)] = 61436,
  [SMALL_STATE(1530)] = 61460,
  [SMALL_STATE(1531)] = 61476,
  [SMALL_STATE(1532)] = 61492,
  [SMALL_STATE(1533)] = 61508,
  [SMALL_STATE(1534)] = 61524,
  [SMALL_STATE(1535)] = 61540,
  [SMALL_STATE(1536)] = 61556,
  [SMALL_STATE(1537)] = 61572,
  [SMALL_STATE(1538)] = 61590,
  [SMALL_STATE(1539)] = 61606,
  [SMALL_STATE(1540)] = 61622,
  [SMALL_STATE(1541)] = 61638,
  [SMALL_STATE(1542)] = 61654,
  [SMALL_STATE(1543)] = 61670,
  [SMALL_STATE(1544)] = 61686,
  [SMALL_STATE(1545)] = 61702,
  [SMALL_STATE(1546)] = 61718,
  [SMALL_STATE(1547)] = 61734,
  [SMALL_STATE(1548)] = 61750,
  [SMALL_STATE(1549)] = 61774,
  [SMALL_STATE(1550)] = 61790,
  [SMALL_STATE(1551)] = 61808,
  [SMALL_STATE(1552)] = 61824,
  [SMALL_STATE(1553)] = 61848,
  [SMALL_STATE(1554)] = 61872,
  [SMALL_STATE(1555)] = 61888,
  [SMALL_STATE(1556)] = 61904,
  [SMALL_STATE(1557)] = 61920,
  [SMALL_STATE(1558)] = 61944,
  [SMALL_STATE(1559)] = 61960,
  [SMALL_STATE(1560)] = 61984,
  [SMALL_STATE(1561)] = 62008,
  [SMALL_STATE(1562)] = 62030,
  [SMALL_STATE(1563)] = 62048,
  [SMALL_STATE(1564)] = 62064,
  [SMALL_STATE(1565)] = 62080,
  [SMALL_STATE(1566)] = 62104,
  [SMALL_STATE(1567)] = 62130,
  [SMALL_STATE(1568)] = 62146,
  [SMALL_STATE(1569)] = 62170,
  [SMALL_STATE(1570)] = 62186,
  [SMALL_STATE(1571)] = 62202,
  [SMALL_STATE(1572)] = 62218,
  [SMALL_STATE(1573)] = 62236,
  [SMALL_STATE(1574)] = 62254,
  [SMALL_STATE(1575)] = 62270,
  [SMALL_STATE(1576)] = 62286,
  [SMALL_STATE(1577)] = 62302,
  [SMALL_STATE(1578)] = 62318,
  [SMALL_STATE(1579)] = 62334,
  [SMALL_STATE(1580)] = 62350,
  [SMALL_STATE(1581)] = 62366,
  [SMALL_STATE(1582)] = 62390,
  [SMALL_STATE(1583)] = 62414,
  [SMALL_STATE(1584)] = 62438,
  [SMALL_STATE(1585)] = 62456,
  [SMALL_STATE(1586)] = 62472,
  [SMALL_STATE(1587)] = 62488,
  [SMALL_STATE(1588)] = 62504,
  [SMALL_STATE(1589)] = 62520,
  [SMALL_STATE(1590)] = 62544,
  [SMALL_STATE(1591)] = 62560,
  [SMALL_STATE(1592)] = 62584,
  [SMALL_STATE(1593)] = 62600,
  [SMALL_STATE(1594)] = 62616,
  [SMALL_STATE(1595)] = 62640,
  [SMALL_STATE(1596)] = 62656,
  [SMALL_STATE(1597)] = 62676,
  [SMALL_STATE(1598)] = 62702,
  [SMALL_STATE(1599)] = 62726,
  [SMALL_STATE(1600)] = 62750,
  [SMALL_STATE(1601)] = 62774,
  [SMALL_STATE(1602)] = 62798,
  [SMALL_STATE(1603)] = 62814,
  [SMALL_STATE(1604)] = 62838,
  [SMALL_STATE(1605)] = 62854,
  [SMALL_STATE(1606)] = 62875,
  [SMALL_STATE(1607)] = 62896,
  [SMALL_STATE(1608)] = 62919,
  [SMALL_STATE(1609)] = 62932,
  [SMALL_STATE(1610)] = 62945,
  [SMALL_STATE(1611)] = 62958,
  [SMALL_STATE(1612)] = 62979,
  [SMALL_STATE(1613)] = 62996,
  [SMALL_STATE(1614)] = 63017,
  [SMALL_STATE(1615)] = 63030,
  [SMALL_STATE(1616)] = 63045,
  [SMALL_STATE(1617)] = 63066,
  [SMALL_STATE(1618)] = 63085,
  [SMALL_STATE(1619)] = 63106,
  [SMALL_STATE(1620)] = 63121,
  [SMALL_STATE(1621)] = 63144,
  [SMALL_STATE(1622)] = 63165,
  [SMALL_STATE(1623)] = 63182,
  [SMALL_STATE(1624)] = 63197,
  [SMALL_STATE(1625)] = 63212,
  [SMALL_STATE(1626)] = 63227,
  [SMALL_STATE(1627)] = 63248,
  [SMALL_STATE(1628)] = 63261,
  [SMALL_STATE(1629)] = 63276,
  [SMALL_STATE(1630)] = 63291,
  [SMALL_STATE(1631)] = 63310,
  [SMALL_STATE(1632)] = 63325,
  [SMALL_STATE(1633)] = 63346,
  [SMALL_STATE(1634)] = 63363,
  [SMALL_STATE(1635)] = 63376,
  [SMALL_STATE(1636)] = 63389,
  [SMALL_STATE(1637)] = 63404,
  [SMALL_STATE(1638)] = 63423,
  [SMALL_STATE(1639)] = 63436,
  [SMALL_STATE(1640)] = 63457,
  [SMALL_STATE(1641)] = 63470,
  [SMALL_STATE(1642)] = 63489,
  [SMALL_STATE(1643)] = 63508,
  [SMALL_STATE(1644)] = 63521,
  [SMALL_STATE(1645)] = 63534,
  [SMALL_STATE(1646)] = 63547,
  [SMALL_STATE(1647)] = 63566,
  [SMALL_STATE(1648)] = 63581,
  [SMALL_STATE(1649)] = 63600,
  [SMALL_STATE(1650)] = 63615,
  [SMALL_STATE(1651)] = 63630,
  [SMALL_STATE(1652)] = 63645,
  [SMALL_STATE(1653)] = 63666,
  [SMALL_STATE(1654)] = 63681,
  [SMALL_STATE(1655)] = 63696,
  [SMALL_STATE(1656)] = 63711,
  [SMALL_STATE(1657)] = 63726,
  [SMALL_STATE(1658)] = 63741,
  [SMALL_STATE(1659)] = 63754,
  [SMALL_STATE(1660)] = 63775,
  [SMALL_STATE(1661)] = 63796,
  [SMALL_STATE(1662)] = 63809,
  [SMALL_STATE(1663)] = 63830,
  [SMALL_STATE(1664)] = 63851,
  [SMALL_STATE(1665)] = 63870,
  [SMALL_STATE(1666)] = 63891,
  [SMALL_STATE(1667)] = 63912,
  [SMALL_STATE(1668)] = 63931,
  [SMALL_STATE(1669)] = 63944,
  [SMALL_STATE(1670)] = 63965,
  [SMALL_STATE(1671)] = 63980,
  [SMALL_STATE(1672)] = 63999,
  [SMALL_STATE(1673)] = 64018,
  [SMALL_STATE(1674)] = 64039,
  [SMALL_STATE(1675)] = 64056,
  [SMALL_STATE(1676)] = 64075,
  [SMALL_STATE(1677)] = 64095,
  [SMALL_STATE(1678)] = 64115,
  [SMALL_STATE(1679)] = 64135,
  [SMALL_STATE(1680)] = 64147,
  [SMALL_STATE(1681)] = 64167,
  [SMALL_STATE(1682)] = 64187,
  [SMALL_STATE(1683)] = 64203,
  [SMALL_STATE(1684)] = 64223,
  [SMALL_STATE(1685)] = 64243,
  [SMALL_STATE(1686)] = 64263,
  [SMALL_STATE(1687)] = 64283,
  [SMALL_STATE(1688)] = 64303,
  [SMALL_STATE(1689)] = 64315,
  [SMALL_STATE(1690)] = 64335,
  [SMALL_STATE(1691)] = 64355,
  [SMALL_STATE(1692)] = 64375,
  [SMALL_STATE(1693)] = 64391,
  [SMALL_STATE(1694)] = 64403,
  [SMALL_STATE(1695)] = 64423,
  [SMALL_STATE(1696)] = 64439,
  [SMALL_STATE(1697)] = 64455,
  [SMALL_STATE(1698)] = 64475,
  [SMALL_STATE(1699)] = 64495,
  [SMALL_STATE(1700)] = 64515,
  [SMALL_STATE(1701)] = 64527,
  [SMALL_STATE(1702)] = 64547,
  [SMALL_STATE(1703)] = 64567,
  [SMALL_STATE(1704)] = 64585,
  [SMALL_STATE(1705)] = 64601,
  [SMALL_STATE(1706)] = 64613,
  [SMALL_STATE(1707)] = 64625,
  [SMALL_STATE(1708)] = 64645,
  [SMALL_STATE(1709)] = 64663,
  [SMALL_STATE(1710)] = 64683,
  [SMALL_STATE(1711)] = 64695,
  [SMALL_STATE(1712)] = 64715,
  [SMALL_STATE(1713)] = 64735,
  [SMALL_STATE(1714)] = 64755,
  [SMALL_STATE(1715)] = 64769,
  [SMALL_STATE(1716)] = 64781,
  [SMALL_STATE(1717)] = 64797,
  [SMALL_STATE(1718)] = 64813,
  [SMALL_STATE(1719)] = 64833,
  [SMALL_STATE(1720)] = 64851,
  [SMALL_STATE(1721)] = 64863,
  [SMALL_STATE(1722)] = 64881,
  [SMALL_STATE(1723)] = 64901,
  [SMALL_STATE(1724)] = 64913,
  [SMALL_STATE(1725)] = 64929,
  [SMALL_STATE(1726)] = 64945,
  [SMALL_STATE(1727)] = 64965,
  [SMALL_STATE(1728)] = 64977,
  [SMALL_STATE(1729)] = 64997,
  [SMALL_STATE(1730)] = 65017,
  [SMALL_STATE(1731)] = 65037,
  [SMALL_STATE(1732)] = 65053,
  [SMALL_STATE(1733)] = 65073,
  [SMALL_STATE(1734)] = 65087,
  [SMALL_STATE(1735)] = 65107,
  [SMALL_STATE(1736)] = 65123,
  [SMALL_STATE(1737)] = 65140,
  [SMALL_STATE(1738)] = 65157,
  [SMALL_STATE(1739)] = 65170,
  [SMALL_STATE(1740)] = 65185,
  [SMALL_STATE(1741)] = 65202,
  [SMALL_STATE(1742)] = 65213,
  [SMALL_STATE(1743)] = 65230,
  [SMALL_STATE(1744)] = 65247,
  [SMALL_STATE(1745)] = 65258,
  [SMALL_STATE(1746)] = 65275,
  [SMALL_STATE(1747)] = 65292,
  [SMALL_STATE(1748)] = 65303,
  [SMALL_STATE(1749)] = 65318,
  [SMALL_STATE(1750)] = 65329,
  [SMALL_STATE(1751)] = 65344,
  [SMALL_STATE(1752)] = 65361,
  [SMALL_STATE(1753)] = 65374,
  [SMALL_STATE(1754)] = 65389,
  [SMALL_STATE(1755)] = 65404,
  [SMALL_STATE(1756)] = 65419,
  [SMALL_STATE(1757)] = 65434,
  [SMALL_STATE(1758)] = 65451,
  [SMALL_STATE(1759)] = 65468,
  [SMALL_STATE(1760)] = 65485,
  [SMALL_STATE(1761)] = 65500,
  [SMALL_STATE(1762)] = 65515,
  [SMALL_STATE(1763)] = 65530,
  [SMALL_STATE(1764)] = 65545,
  [SMALL_STATE(1765)] = 65556,
  [SMALL_STATE(1766)] = 65569,
  [SMALL_STATE(1767)] = 65582,
  [SMALL_STATE(1768)] = 65597,
  [SMALL_STATE(1769)] = 65614,
  [SMALL_STATE(1770)] = 65625,
  [SMALL_STATE(1771)] = 65640,
  [SMALL_STATE(1772)] = 65651,
  [SMALL_STATE(1773)] = 65666,
  [SMALL_STATE(1774)] = 65679,
  [SMALL_STATE(1775)] = 65690,
  [SMALL_STATE(1776)] = 65703,
  [SMALL_STATE(1777)] = 65714,
  [SMALL_STATE(1778)] = 65731,
  [SMALL_STATE(1779)] = 65746,
  [SMALL_STATE(1780)] = 65761,
  [SMALL_STATE(1781)] = 65778,
  [SMALL_STATE(1782)] = 65795,
  [SMALL_STATE(1783)] = 65812,
  [SMALL_STATE(1784)] = 65827,
  [SMALL_STATE(1785)] = 65838,
  [SMALL_STATE(1786)] = 65852,
  [SMALL_STATE(1787)] = 65866,
  [SMALL_STATE(1788)] = 65880,
  [SMALL_STATE(1789)] = 65894,
  [SMALL_STATE(1790)] = 65908,
  [SMALL_STATE(1791)] = 65922,
  [SMALL_STATE(1792)] = 65936,
  [SMALL_STATE(1793)] = 65950,
  [SMALL_STATE(1794)] = 65964,
  [SMALL_STATE(1795)] = 65978,
  [SMALL_STATE(1796)] = 65992,
  [SMALL_STATE(1797)] = 66006,
  [SMALL_STATE(1798)] = 66020,
  [SMALL_STATE(1799)] = 66034,
  [SMALL_STATE(1800)] = 66048,
  [SMALL_STATE(1801)] = 66062,
  [SMALL_STATE(1802)] = 66076,
  [SMALL_STATE(1803)] = 66090,
  [SMALL_STATE(1804)] = 66104,
  [SMALL_STATE(1805)] = 66118,
  [SMALL_STATE(1806)] = 66132,
  [SMALL_STATE(1807)] = 66146,
  [SMALL_STATE(1808)] = 66160,
  [SMALL_STATE(1809)] = 66174,
  [SMALL_STATE(1810)] = 66188,
  [SMALL_STATE(1811)] = 66202,
  [SMALL_STATE(1812)] = 66216,
  [SMALL_STATE(1813)] = 66230,
  [SMALL_STATE(1814)] = 66244,
  [SMALL_STATE(1815)] = 66258,
  [SMALL_STATE(1816)] = 66272,
  [SMALL_STATE(1817)] = 66286,
  [SMALL_STATE(1818)] = 66300,
  [SMALL_STATE(1819)] = 66314,
  [SMALL_STATE(1820)] = 66328,
  [SMALL_STATE(1821)] = 66342,
  [SMALL_STATE(1822)] = 66356,
  [SMALL_STATE(1823)] = 66366,
  [SMALL_STATE(1824)] = 66376,
  [SMALL_STATE(1825)] = 66390,
  [SMALL_STATE(1826)] = 66400,
  [SMALL_STATE(1827)] = 66414,
  [SMALL_STATE(1828)] = 66426,
  [SMALL_STATE(1829)] = 66440,
  [SMALL_STATE(1830)] = 66454,
  [SMALL_STATE(1831)] = 66468,
  [SMALL_STATE(1832)] = 66482,
  [SMALL_STATE(1833)] = 66496,
  [SMALL_STATE(1834)] = 66506,
  [SMALL_STATE(1835)] = 66520,
  [SMALL_STATE(1836)] = 66534,
  [SMALL_STATE(1837)] = 66548,
  [SMALL_STATE(1838)] = 66562,
  [SMALL_STATE(1839)] = 66576,
  [SMALL_STATE(1840)] = 66590,
  [SMALL_STATE(1841)] = 66604,
  [SMALL_STATE(1842)] = 66618,
  [SMALL_STATE(1843)] = 66632,
  [SMALL_STATE(1844)] = 66646,
  [SMALL_STATE(1845)] = 66660,
  [SMALL_STATE(1846)] = 66674,
  [SMALL_STATE(1847)] = 66688,
  [SMALL_STATE(1848)] = 66698,
  [SMALL_STATE(1849)] = 66712,
  [SMALL_STATE(1850)] = 66726,
  [SMALL_STATE(1851)] = 66740,
  [SMALL_STATE(1852)] = 66754,
  [SMALL_STATE(1853)] = 66768,
  [SMALL_STATE(1854)] = 66782,
  [SMALL_STATE(1855)] = 66796,
  [SMALL_STATE(1856)] = 66810,
  [SMALL_STATE(1857)] = 66824,
  [SMALL_STATE(1858)] = 66838,
  [SMALL_STATE(1859)] = 66852,
  [SMALL_STATE(1860)] = 66866,
  [SMALL_STATE(1861)] = 66880,
  [SMALL_STATE(1862)] = 66894,
  [SMALL_STATE(1863)] = 66908,
  [SMALL_STATE(1864)] = 66922,
  [SMALL_STATE(1865)] = 66936,
  [SMALL_STATE(1866)] = 66950,
  [SMALL_STATE(1867)] = 66964,
  [SMALL_STATE(1868)] = 66978,
  [SMALL_STATE(1869)] = 66992,
  [SMALL_STATE(1870)] = 67006,
  [SMALL_STATE(1871)] = 67020,
  [SMALL_STATE(1872)] = 67034,
  [SMALL_STATE(1873)] = 67044,
  [SMALL_STATE(1874)] = 67058,
  [SMALL_STATE(1875)] = 67072,
  [SMALL_STATE(1876)] = 67086,
  [SMALL_STATE(1877)] = 67100,
  [SMALL_STATE(1878)] = 67114,
  [SMALL_STATE(1879)] = 67128,
  [SMALL_STATE(1880)] = 67142,
  [SMALL_STATE(1881)] = 67156,
  [SMALL_STATE(1882)] = 67170,
  [SMALL_STATE(1883)] = 67184,
  [SMALL_STATE(1884)] = 67198,
  [SMALL_STATE(1885)] = 67212,
  [SMALL_STATE(1886)] = 67226,
  [SMALL_STATE(1887)] = 67240,
  [SMALL_STATE(1888)] = 67254,
  [SMALL_STATE(1889)] = 67268,
  [SMALL_STATE(1890)] = 67282,
  [SMALL_STATE(1891)] = 67296,
  [SMALL_STATE(1892)] = 67310,
  [SMALL_STATE(1893)] = 67320,
  [SMALL_STATE(1894)] = 67334,
  [SMALL_STATE(1895)] = 67348,
  [SMALL_STATE(1896)] = 67362,
  [SMALL_STATE(1897)] = 67376,
  [SMALL_STATE(1898)] = 67390,
  [SMALL_STATE(1899)] = 67404,
  [SMALL_STATE(1900)] = 67418,
  [SMALL_STATE(1901)] = 67432,
  [SMALL_STATE(1902)] = 67446,
  [SMALL_STATE(1903)] = 67460,
  [SMALL_STATE(1904)] = 67474,
  [SMALL_STATE(1905)] = 67488,
  [SMALL_STATE(1906)] = 67502,
  [SMALL_STATE(1907)] = 67516,
  [SMALL_STATE(1908)] = 67530,
  [SMALL_STATE(1909)] = 67544,
  [SMALL_STATE(1910)] = 67558,
  [SMALL_STATE(1911)] = 67572,
  [SMALL_STATE(1912)] = 67586,
  [SMALL_STATE(1913)] = 67600,
  [SMALL_STATE(1914)] = 67614,
  [SMALL_STATE(1915)] = 67628,
  [SMALL_STATE(1916)] = 67642,
  [SMALL_STATE(1917)] = 67656,
  [SMALL_STATE(1918)] = 67670,
  [SMALL_STATE(1919)] = 67684,
  [SMALL_STATE(1920)] = 67698,
  [SMALL_STATE(1921)] = 67708,
  [SMALL_STATE(1922)] = 67722,
  [SMALL_STATE(1923)] = 67736,
  [SMALL_STATE(1924)] = 67750,
  [SMALL_STATE(1925)] = 67764,
  [SMALL_STATE(1926)] = 67778,
  [SMALL_STATE(1927)] = 67788,
  [SMALL_STATE(1928)] = 67802,
  [SMALL_STATE(1929)] = 67816,
  [SMALL_STATE(1930)] = 67830,
  [SMALL_STATE(1931)] = 67844,
  [SMALL_STATE(1932)] = 67858,
  [SMALL_STATE(1933)] = 67872,
  [SMALL_STATE(1934)] = 67886,
  [SMALL_STATE(1935)] = 67900,
  [SMALL_STATE(1936)] = 67914,
  [SMALL_STATE(1937)] = 67928,
  [SMALL_STATE(1938)] = 67942,
  [SMALL_STATE(1939)] = 67956,
  [SMALL_STATE(1940)] = 67970,
  [SMALL_STATE(1941)] = 67982,
  [SMALL_STATE(1942)] = 67996,
  [SMALL_STATE(1943)] = 68010,
  [SMALL_STATE(1944)] = 68024,
  [SMALL_STATE(1945)] = 68038,
  [SMALL_STATE(1946)] = 68052,
  [SMALL_STATE(1947)] = 68066,
  [SMALL_STATE(1948)] = 68080,
  [SMALL_STATE(1949)] = 68094,
  [SMALL_STATE(1950)] = 68108,
  [SMALL_STATE(1951)] = 68122,
  [SMALL_STATE(1952)] = 68132,
  [SMALL_STATE(1953)] = 68146,
  [SMALL_STATE(1954)] = 68160,
  [SMALL_STATE(1955)] = 68174,
  [SMALL_STATE(1956)] = 68188,
  [SMALL_STATE(1957)] = 68202,
  [SMALL_STATE(1958)] = 68216,
  [SMALL_STATE(1959)] = 68230,
  [SMALL_STATE(1960)] = 68244,
  [SMALL_STATE(1961)] = 68258,
  [SMALL_STATE(1962)] = 68272,
  [SMALL_STATE(1963)] = 68286,
  [SMALL_STATE(1964)] = 68300,
  [SMALL_STATE(1965)] = 68314,
  [SMALL_STATE(1966)] = 68328,
  [SMALL_STATE(1967)] = 68342,
  [SMALL_STATE(1968)] = 68356,
  [SMALL_STATE(1969)] = 68370,
  [SMALL_STATE(1970)] = 68384,
  [SMALL_STATE(1971)] = 68398,
  [SMALL_STATE(1972)] = 68412,
  [SMALL_STATE(1973)] = 68426,
  [SMALL_STATE(1974)] = 68440,
  [SMALL_STATE(1975)] = 68454,
  [SMALL_STATE(1976)] = 68468,
  [SMALL_STATE(1977)] = 68477,
  [SMALL_STATE(1978)] = 68488,
  [SMALL_STATE(1979)] = 68499,
  [SMALL_STATE(1980)] = 68508,
  [SMALL_STATE(1981)] = 68519,
  [SMALL_STATE(1982)] = 68530,
  [SMALL_STATE(1983)] = 68539,
  [SMALL_STATE(1984)] = 68550,
  [SMALL_STATE(1985)] = 68561,
  [SMALL_STATE(1986)] = 68572,
  [SMALL_STATE(1987)] = 68583,
  [SMALL_STATE(1988)] = 68594,
  [SMALL_STATE(1989)] = 68605,
  [SMALL_STATE(1990)] = 68616,
  [SMALL_STATE(1991)] = 68627,
  [SMALL_STATE(1992)] = 68636,
  [SMALL_STATE(1993)] = 68647,
  [SMALL_STATE(1994)] = 68658,
  [SMALL_STATE(1995)] = 68669,
  [SMALL_STATE(1996)] = 68678,
  [SMALL_STATE(1997)] = 68689,
  [SMALL_STATE(1998)] = 68700,
  [SMALL_STATE(1999)] = 68711,
  [SMALL_STATE(2000)] = 68722,
  [SMALL_STATE(2001)] = 68733,
  [SMALL_STATE(2002)] = 68744,
  [SMALL_STATE(2003)] = 68755,
  [SMALL_STATE(2004)] = 68766,
  [SMALL_STATE(2005)] = 68777,
  [SMALL_STATE(2006)] = 68788,
  [SMALL_STATE(2007)] = 68799,
  [SMALL_STATE(2008)] = 68810,
  [SMALL_STATE(2009)] = 68821,
  [SMALL_STATE(2010)] = 68832,
  [SMALL_STATE(2011)] = 68843,
  [SMALL_STATE(2012)] = 68854,
  [SMALL_STATE(2013)] = 68865,
  [SMALL_STATE(2014)] = 68876,
  [SMALL_STATE(2015)] = 68887,
  [SMALL_STATE(2016)] = 68898,
  [SMALL_STATE(2017)] = 68907,
  [SMALL_STATE(2018)] = 68918,
  [SMALL_STATE(2019)] = 68929,
  [SMALL_STATE(2020)] = 68940,
  [SMALL_STATE(2021)] = 68951,
  [SMALL_STATE(2022)] = 68962,
  [SMALL_STATE(2023)] = 68973,
  [SMALL_STATE(2024)] = 68984,
  [SMALL_STATE(2025)] = 68995,
  [SMALL_STATE(2026)] = 69006,
  [SMALL_STATE(2027)] = 69015,
  [SMALL_STATE(2028)] = 69026,
  [SMALL_STATE(2029)] = 69037,
  [SMALL_STATE(2030)] = 69048,
  [SMALL_STATE(2031)] = 69059,
  [SMALL_STATE(2032)] = 69070,
  [SMALL_STATE(2033)] = 69081,
  [SMALL_STATE(2034)] = 69092,
  [SMALL_STATE(2035)] = 69103,
  [SMALL_STATE(2036)] = 69112,
  [SMALL_STATE(2037)] = 69123,
  [SMALL_STATE(2038)] = 69134,
  [SMALL_STATE(2039)] = 69145,
  [SMALL_STATE(2040)] = 69156,
  [SMALL_STATE(2041)] = 69167,
  [SMALL_STATE(2042)] = 69178,
  [SMALL_STATE(2043)] = 69189,
  [SMALL_STATE(2044)] = 69200,
  [SMALL_STATE(2045)] = 69211,
  [SMALL_STATE(2046)] = 69220,
  [SMALL_STATE(2047)] = 69231,
  [SMALL_STATE(2048)] = 69242,
  [SMALL_STATE(2049)] = 69251,
  [SMALL_STATE(2050)] = 69260,
  [SMALL_STATE(2051)] = 69271,
  [SMALL_STATE(2052)] = 69282,
  [SMALL_STATE(2053)] = 69291,
  [SMALL_STATE(2054)] = 69302,
  [SMALL_STATE(2055)] = 69313,
  [SMALL_STATE(2056)] = 69324,
  [SMALL_STATE(2057)] = 69333,
  [SMALL_STATE(2058)] = 69344,
  [SMALL_STATE(2059)] = 69355,
  [SMALL_STATE(2060)] = 69366,
  [SMALL_STATE(2061)] = 69377,
  [SMALL_STATE(2062)] = 69388,
  [SMALL_STATE(2063)] = 69399,
  [SMALL_STATE(2064)] = 69408,
  [SMALL_STATE(2065)] = 69419,
  [SMALL_STATE(2066)] = 69430,
  [SMALL_STATE(2067)] = 69441,
  [SMALL_STATE(2068)] = 69452,
  [SMALL_STATE(2069)] = 69461,
  [SMALL_STATE(2070)] = 69472,
  [SMALL_STATE(2071)] = 69481,
  [SMALL_STATE(2072)] = 69492,
  [SMALL_STATE(2073)] = 69503,
  [SMALL_STATE(2074)] = 69512,
  [SMALL_STATE(2075)] = 69521,
  [SMALL_STATE(2076)] = 69530,
  [SMALL_STATE(2077)] = 69539,
  [SMALL_STATE(2078)] = 69548,
  [SMALL_STATE(2079)] = 69559,
  [SMALL_STATE(2080)] = 69570,
  [SMALL_STATE(2081)] = 69581,
  [SMALL_STATE(2082)] = 69592,
  [SMALL_STATE(2083)] = 69603,
  [SMALL_STATE(2084)] = 69614,
  [SMALL_STATE(2085)] = 69623,
  [SMALL_STATE(2086)] = 69634,
  [SMALL_STATE(2087)] = 69645,
  [SMALL_STATE(2088)] = 69656,
  [SMALL_STATE(2089)] = 69667,
  [SMALL_STATE(2090)] = 69678,
  [SMALL_STATE(2091)] = 69689,
  [SMALL_STATE(2092)] = 69700,
  [SMALL_STATE(2093)] = 69711,
  [SMALL_STATE(2094)] = 69722,
  [SMALL_STATE(2095)] = 69733,
  [SMALL_STATE(2096)] = 69744,
  [SMALL_STATE(2097)] = 69755,
  [SMALL_STATE(2098)] = 69766,
  [SMALL_STATE(2099)] = 69775,
  [SMALL_STATE(2100)] = 69784,
  [SMALL_STATE(2101)] = 69795,
  [SMALL_STATE(2102)] = 69806,
  [SMALL_STATE(2103)] = 69817,
  [SMALL_STATE(2104)] = 69826,
  [SMALL_STATE(2105)] = 69835,
  [SMALL_STATE(2106)] = 69846,
  [SMALL_STATE(2107)] = 69857,
  [SMALL_STATE(2108)] = 69868,
  [SMALL_STATE(2109)] = 69879,
  [SMALL_STATE(2110)] = 69890,
  [SMALL_STATE(2111)] = 69899,
  [SMALL_STATE(2112)] = 69908,
  [SMALL_STATE(2113)] = 69919,
  [SMALL_STATE(2114)] = 69928,
  [SMALL_STATE(2115)] = 69939,
  [SMALL_STATE(2116)] = 69950,
  [SMALL_STATE(2117)] = 69961,
  [SMALL_STATE(2118)] = 69972,
  [SMALL_STATE(2119)] = 69983,
  [SMALL_STATE(2120)] = 69994,
  [SMALL_STATE(2121)] = 70003,
  [SMALL_STATE(2122)] = 70014,
  [SMALL_STATE(2123)] = 70023,
  [SMALL_STATE(2124)] = 70034,
  [SMALL_STATE(2125)] = 70045,
  [SMALL_STATE(2126)] = 70056,
  [SMALL_STATE(2127)] = 70067,
  [SMALL_STATE(2128)] = 70078,
  [SMALL_STATE(2129)] = 70087,
  [SMALL_STATE(2130)] = 70098,
  [SMALL_STATE(2131)] = 70109,
  [SMALL_STATE(2132)] = 70120,
  [SMALL_STATE(2133)] = 70131,
  [SMALL_STATE(2134)] = 70142,
  [SMALL_STATE(2135)] = 70151,
  [SMALL_STATE(2136)] = 70162,
  [SMALL_STATE(2137)] = 70173,
  [SMALL_STATE(2138)] = 70184,
  [SMALL_STATE(2139)] = 70195,
  [SMALL_STATE(2140)] = 70206,
  [SMALL_STATE(2141)] = 70215,
  [SMALL_STATE(2142)] = 70226,
  [SMALL_STATE(2143)] = 70237,
  [SMALL_STATE(2144)] = 70246,
  [SMALL_STATE(2145)] = 70257,
  [SMALL_STATE(2146)] = 70265,
  [SMALL_STATE(2147)] = 70273,
  [SMALL_STATE(2148)] = 70281,
  [SMALL_STATE(2149)] = 70289,
  [SMALL_STATE(2150)] = 70297,
  [SMALL_STATE(2151)] = 70305,
  [SMALL_STATE(2152)] = 70313,
  [SMALL_STATE(2153)] = 70321,
  [SMALL_STATE(2154)] = 70329,
  [SMALL_STATE(2155)] = 70337,
  [SMALL_STATE(2156)] = 70345,
  [SMALL_STATE(2157)] = 70353,
  [SMALL_STATE(2158)] = 70361,
  [SMALL_STATE(2159)] = 70369,
  [SMALL_STATE(2160)] = 70377,
  [SMALL_STATE(2161)] = 70385,
  [SMALL_STATE(2162)] = 70393,
  [SMALL_STATE(2163)] = 70401,
  [SMALL_STATE(2164)] = 70409,
  [SMALL_STATE(2165)] = 70417,
  [SMALL_STATE(2166)] = 70425,
  [SMALL_STATE(2167)] = 70433,
  [SMALL_STATE(2168)] = 70441,
  [SMALL_STATE(2169)] = 70449,
  [SMALL_STATE(2170)] = 70457,
  [SMALL_STATE(2171)] = 70465,
  [SMALL_STATE(2172)] = 70473,
  [SMALL_STATE(2173)] = 70481,
  [SMALL_STATE(2174)] = 70489,
  [SMALL_STATE(2175)] = 70497,
  [SMALL_STATE(2176)] = 70505,
  [SMALL_STATE(2177)] = 70513,
  [SMALL_STATE(2178)] = 70521,
  [SMALL_STATE(2179)] = 70529,
  [SMALL_STATE(2180)] = 70537,
  [SMALL_STATE(2181)] = 70545,
  [SMALL_STATE(2182)] = 70553,
  [SMALL_STATE(2183)] = 70561,
  [SMALL_STATE(2184)] = 70569,
  [SMALL_STATE(2185)] = 70577,
  [SMALL_STATE(2186)] = 70585,
  [SMALL_STATE(2187)] = 70593,
  [SMALL_STATE(2188)] = 70601,
  [SMALL_STATE(2189)] = 70609,
  [SMALL_STATE(2190)] = 70617,
  [SMALL_STATE(2191)] = 70625,
  [SMALL_STATE(2192)] = 70633,
  [SMALL_STATE(2193)] = 70641,
  [SMALL_STATE(2194)] = 70649,
  [SMALL_STATE(2195)] = 70657,
  [SMALL_STATE(2196)] = 70665,
  [SMALL_STATE(2197)] = 70673,
  [SMALL_STATE(2198)] = 70681,
  [SMALL_STATE(2199)] = 70689,
  [SMALL_STATE(2200)] = 70697,
  [SMALL_STATE(2201)] = 70705,
  [SMALL_STATE(2202)] = 70713,
  [SMALL_STATE(2203)] = 70721,
  [SMALL_STATE(2204)] = 70729,
  [SMALL_STATE(2205)] = 70737,
  [SMALL_STATE(2206)] = 70745,
  [SMALL_STATE(2207)] = 70753,
  [SMALL_STATE(2208)] = 70761,
  [SMALL_STATE(2209)] = 70769,
  [SMALL_STATE(2210)] = 70777,
  [SMALL_STATE(2211)] = 70785,
  [SMALL_STATE(2212)] = 70793,
  [SMALL_STATE(2213)] = 70801,
  [SMALL_STATE(2214)] = 70809,
  [SMALL_STATE(2215)] = 70817,
  [SMALL_STATE(2216)] = 70825,
  [SMALL_STATE(2217)] = 70833,
  [SMALL_STATE(2218)] = 70841,
  [SMALL_STATE(2219)] = 70849,
  [SMALL_STATE(2220)] = 70857,
  [SMALL_STATE(2221)] = 70865,
  [SMALL_STATE(2222)] = 70873,
  [SMALL_STATE(2223)] = 70881,
  [SMALL_STATE(2224)] = 70889,
  [SMALL_STATE(2225)] = 70897,
  [SMALL_STATE(2226)] = 70905,
  [SMALL_STATE(2227)] = 70913,
  [SMALL_STATE(2228)] = 70921,
  [SMALL_STATE(2229)] = 70929,
  [SMALL_STATE(2230)] = 70937,
  [SMALL_STATE(2231)] = 70945,
  [SMALL_STATE(2232)] = 70953,
  [SMALL_STATE(2233)] = 70961,
  [SMALL_STATE(2234)] = 70969,
  [SMALL_STATE(2235)] = 70977,
  [SMALL_STATE(2236)] = 70985,
  [SMALL_STATE(2237)] = 70993,
  [SMALL_STATE(2238)] = 71001,
  [SMALL_STATE(2239)] = 71009,
  [SMALL_STATE(2240)] = 71017,
  [SMALL_STATE(2241)] = 71025,
  [SMALL_STATE(2242)] = 71033,
  [SMALL_STATE(2243)] = 71041,
  [SMALL_STATE(2244)] = 71049,
  [SMALL_STATE(2245)] = 71057,
  [SMALL_STATE(2246)] = 71065,
  [SMALL_STATE(2247)] = 71073,
  [SMALL_STATE(2248)] = 71081,
  [SMALL_STATE(2249)] = 71089,
  [SMALL_STATE(2250)] = 71097,
  [SMALL_STATE(2251)] = 71105,
  [SMALL_STATE(2252)] = 71113,
  [SMALL_STATE(2253)] = 71121,
  [SMALL_STATE(2254)] = 71129,
  [SMALL_STATE(2255)] = 71137,
  [SMALL_STATE(2256)] = 71145,
  [SMALL_STATE(2257)] = 71153,
  [SMALL_STATE(2258)] = 71161,
  [SMALL_STATE(2259)] = 71169,
  [SMALL_STATE(2260)] = 71177,
  [SMALL_STATE(2261)] = 71185,
  [SMALL_STATE(2262)] = 71193,
  [SMALL_STATE(2263)] = 71201,
  [SMALL_STATE(2264)] = 71209,
  [SMALL_STATE(2265)] = 71217,
  [SMALL_STATE(2266)] = 71225,
  [SMALL_STATE(2267)] = 71233,
  [SMALL_STATE(2268)] = 71241,
  [SMALL_STATE(2269)] = 71249,
  [SMALL_STATE(2270)] = 71257,
  [SMALL_STATE(2271)] = 71265,
  [SMALL_STATE(2272)] = 71273,
  [SMALL_STATE(2273)] = 71281,
  [SMALL_STATE(2274)] = 71289,
  [SMALL_STATE(2275)] = 71297,
  [SMALL_STATE(2276)] = 71305,
  [SMALL_STATE(2277)] = 71313,
  [SMALL_STATE(2278)] = 71321,
  [SMALL_STATE(2279)] = 71329,
  [SMALL_STATE(2280)] = 71337,
  [SMALL_STATE(2281)] = 71345,
  [SMALL_STATE(2282)] = 71353,
  [SMALL_STATE(2283)] = 71361,
  [SMALL_STATE(2284)] = 71369,
  [SMALL_STATE(2285)] = 71377,
  [SMALL_STATE(2286)] = 71385,
  [SMALL_STATE(2287)] = 71393,
  [SMALL_STATE(2288)] = 71401,
  [SMALL_STATE(2289)] = 71409,
  [SMALL_STATE(2290)] = 71417,
  [SMALL_STATE(2291)] = 71425,
  [SMALL_STATE(2292)] = 71433,
  [SMALL_STATE(2293)] = 71441,
  [SMALL_STATE(2294)] = 71449,
  [SMALL_STATE(2295)] = 71457,
  [SMALL_STATE(2296)] = 71465,
  [SMALL_STATE(2297)] = 71473,
  [SMALL_STATE(2298)] = 71481,
  [SMALL_STATE(2299)] = 71489,
  [SMALL_STATE(2300)] = 71497,
  [SMALL_STATE(2301)] = 71505,
  [SMALL_STATE(2302)] = 71513,
  [SMALL_STATE(2303)] = 71521,
  [SMALL_STATE(2304)] = 71529,
  [SMALL_STATE(2305)] = 71537,
  [SMALL_STATE(2306)] = 71545,
  [SMALL_STATE(2307)] = 71553,
  [SMALL_STATE(2308)] = 71561,
  [SMALL_STATE(2309)] = 71569,
  [SMALL_STATE(2310)] = 71577,
  [SMALL_STATE(2311)] = 71585,
  [SMALL_STATE(2312)] = 71593,
  [SMALL_STATE(2313)] = 71601,
  [SMALL_STATE(2314)] = 71609,
  [SMALL_STATE(2315)] = 71617,
  [SMALL_STATE(2316)] = 71625,
  [SMALL_STATE(2317)] = 71633,
  [SMALL_STATE(2318)] = 71641,
  [SMALL_STATE(2319)] = 71649,
  [SMALL_STATE(2320)] = 71657,
  [SMALL_STATE(2321)] = 71665,
  [SMALL_STATE(2322)] = 71673,
  [SMALL_STATE(2323)] = 71681,
  [SMALL_STATE(2324)] = 71689,
  [SMALL_STATE(2325)] = 71697,
  [SMALL_STATE(2326)] = 71705,
  [SMALL_STATE(2327)] = 71713,
  [SMALL_STATE(2328)] = 71721,
  [SMALL_STATE(2329)] = 71729,
  [SMALL_STATE(2330)] = 71737,
  [SMALL_STATE(2331)] = 71745,
  [SMALL_STATE(2332)] = 71753,
  [SMALL_STATE(2333)] = 71761,
  [SMALL_STATE(2334)] = 71769,
  [SMALL_STATE(2335)] = 71777,
  [SMALL_STATE(2336)] = 71785,
  [SMALL_STATE(2337)] = 71793,
  [SMALL_STATE(2338)] = 71801,
  [SMALL_STATE(2339)] = 71809,
  [SMALL_STATE(2340)] = 71817,
  [SMALL_STATE(2341)] = 71825,
  [SMALL_STATE(2342)] = 71833,
  [SMALL_STATE(2343)] = 71841,
  [SMALL_STATE(2344)] = 71849,
  [SMALL_STATE(2345)] = 71857,
  [SMALL_STATE(2346)] = 71865,
  [SMALL_STATE(2347)] = 71873,
  [SMALL_STATE(2348)] = 71881,
  [SMALL_STATE(2349)] = 71889,
  [SMALL_STATE(2350)] = 71897,
  [SMALL_STATE(2351)] = 71905,
  [SMALL_STATE(2352)] = 71913,
  [SMALL_STATE(2353)] = 71921,
  [SMALL_STATE(2354)] = 71929,
  [SMALL_STATE(2355)] = 71937,
  [SMALL_STATE(2356)] = 71945,
  [SMALL_STATE(2357)] = 71953,
  [SMALL_STATE(2358)] = 71961,
  [SMALL_STATE(2359)] = 71969,
  [SMALL_STATE(2360)] = 71977,
  [SMALL_STATE(2361)] = 71985,
  [SMALL_STATE(2362)] = 71993,
  [SMALL_STATE(2363)] = 72001,
  [SMALL_STATE(2364)] = 72009,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 4),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 5),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 6),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(611),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2241),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(813),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(813),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(814),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(815),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1453),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1463),
  [217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1409),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1423),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1514),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1519),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1428),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1436),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(24),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(90),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(839),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(200),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(76),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1263),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(428),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1011),
  [261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1039),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1033),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(324),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2059),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2308),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(59),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2012),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1785),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(154),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(145),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2010),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2023),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2359),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1980),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1259),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1330),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2076),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1844),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2265),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(187),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1283),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1188),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1825),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1822),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1378),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1294),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1351),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1325),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(875),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(616),
  [363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2241),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(813),
  [369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(813),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(814),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(815),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1453),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1463),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1409),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1423),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1514),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1519),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1428),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1436),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(23),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(90),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(839),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(200),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(76),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1263),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(428),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1011),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1039),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1033),
  [432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(325),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2059),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(59),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2015),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1785),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(154),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(145),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2010),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1994),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2297),
  [462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1980),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1259),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1330),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2076),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1844),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2265),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1283),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1188),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1825),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1822),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1378),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1294),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1351),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(1325),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(875),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 7),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(611),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(24),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(324),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2012),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2023),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat5, 2), SHIFT_REPEAT(2359),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, .production_id = 23),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 1),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 40),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 59),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 42),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 72),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 56),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 24),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, .production_id = 24),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1343),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2),
  [776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1980),
  [779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(2291),
  [782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(2290),
  [785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(2021),
  [788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1782),
  [791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1330),
  [794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(2076),
  [797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1188),
  [800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1825),
  [803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(2169),
  [806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1822),
  [809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1381),
  [812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1340),
  [815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1328),
  [818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2), SHIFT_REPEAT(1291),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 2), REDUCE(sym_block, 2),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 2),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 2),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 2), REDUCE(sym_block, 2),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2028),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1226),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1233),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__semicolon, 1),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__semicolon, 1),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__semicolon, 2),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__semicolon, 2),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 2),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat3, 2),
  [886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 2), SHIFT_REPEAT(2028),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat3, 2), SHIFT_REPEAT(2271),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2),
  [896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2), SHIFT_REPEAT(2028),
  [899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2), SHIFT_REPEAT(1267),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4),
  [904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 4),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2),
  [908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3),
  [912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3),
  [914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 1),
  [916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 1),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_tag, 3),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_tag, 3),
  [922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 7),
  [924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 7),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_name, 4),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_name, 4),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 5),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 5),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 4),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 4),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 5),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 5),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_import, 1),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_import, 1),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 4),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 4),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 7),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 7),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_name, 3),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_name, 3),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_or_export, 1),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_or_export, 1),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 3),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 3),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1384),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2253),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_import, 2),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_import, 2),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 6),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 6),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 3),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 3),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_of_directive, 4),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_of_directive, 4),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_directive, 3),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_directive, 3),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_of_directive, 5),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_of_directive, 5),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_directive, 4),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_directive, 4),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 46),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 46),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 4),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 4),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 66),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 66),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 29),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 29),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 67),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 67),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 2),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 2),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 2),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 2),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 30),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 30),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 5, .production_id = 52),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 5, .production_id = 52),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3, .production_id = 15),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 3, .production_id = 15),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_definition, 2), REDUCE(sym_lambda_expression, 2, .production_id = 8),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_definition, 2), REDUCE(sym_lambda_expression, 2, .production_id = 8),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 3),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 3),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class_definition, 2), REDUCE(sym_class_definition, 3),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class_definition, 2), REDUCE(sym_class_definition, 3),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 4, .production_id = 31),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 4, .production_id = 31),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 3),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 15),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 15),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_body, 2),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_body, 2),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 5),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 5),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 4),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 4),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 5),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2, .dynamic_precedence = 22),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, .dynamic_precedence = 22),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application_class, 5),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_application_class, 5),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 5),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 5),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 6),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 6),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 6),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 6),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 3),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 3),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 5, .production_id = 53),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 5, .production_id = 53),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 2),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 2),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 51),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 51),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 50),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 50),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 28),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 28),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, .production_id = 76),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, .production_id = 76),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 65),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 65),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 68),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 68),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 4),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 4),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 7),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 7),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 49),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 49),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_body, 3),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_body, 3),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class_definition, 3), REDUCE(sym_class_definition, 4),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class_definition, 3), REDUCE(sym_class_definition, 4),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 4),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 4),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application_class, 4),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_application_class, 4),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 6, .production_id = 69),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 6, .production_id = 69),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 3),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 3),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 45),
  [1210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 45),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 27),
  [1214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 27),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 47),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 47),
  [1220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4),
  [1222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 2),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 2),
  [1296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1453),
  [1299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1463),
  [1302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1409),
  [1305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1423),
  [1308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1514),
  [1311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1519),
  [1314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1428),
  [1317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1436),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 12),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 12),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 33),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 33),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 7),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 7),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 34),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 34),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_each_statement, 4),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_each_statement, 4),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 2),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 39),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 39),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 12),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 12),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 55),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 55),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, .production_id = 8),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, .production_id = 8),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 13),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 13),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [1456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1694),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_label, 3),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 3),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_label, 2),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 2),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [1485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1729),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1466),
  [1493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1424),
  [1496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1396),
  [1499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1397),
  [1502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1487),
  [1505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1488),
  [1508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1458),
  [1511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1457),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1333),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [1547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1980),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1330),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2076),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1319),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2205),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1188),
  [1565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1825),
  [1568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1054),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1822),
  [1574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1186),
  [1577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1684),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1342),
  [1583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1332),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1235),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1333),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 2),
  [1596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1980),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1330),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(2076),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1319),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(2205),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1188),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1825),
  [1617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1054),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1822),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1186),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1684),
  [1629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1342),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1332),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2), SHIFT_REPEAT(1235),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 3),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 3),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 2),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 2),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_expression, 3),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_expression, 3),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_relational_expression, 3), SHIFT(1031),
  [1673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_relational_expression, 3), SHIFT(1031),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_shift_expression_repeat1, 2),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_shift_expression_repeat1, 2),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_additive_expression_repeat1, 2),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_additive_expression_repeat1, 2),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_without_cascade, 1),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_without_cascade, 1),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 16),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 16),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equality_expression, 3),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equality_expression, 3),
  [1696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(263),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(289),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [1710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 2),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 2),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 4),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 4),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 2),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 2),
  [1722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes, 2),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes, 2),
  [1726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes, 2),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes, 2),
  [1730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes_multiple, 2),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes_multiple, 2),
  [1734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 3),
  [1736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 3),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 3),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 3),
  [1742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes, 3),
  [1744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes, 3),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes_multiple, 2),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes_multiple, 2),
  [1750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes, 3),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes, 3),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes_multiple, 3),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes_multiple, 3),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes_multiple, 3),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes_multiple, 3),
  [1762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes, 3),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes, 3),
  [1766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes, 3),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes, 3),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes, 2),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes, 2),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes, 2),
  [1776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes, 2),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 1),
  [1784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(242),
  [1787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(139),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(2237),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(1354),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_expression, 1),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(898),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(2247),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(2250),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 1),
  [1809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(196),
  [1812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(137),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(2351),
  [1818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(1354),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 1),
  [1823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(819),
  [1826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(2147),
  [1829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(2148),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(2351),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [1855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(196),
  [1858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(137),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(819),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 1), SHIFT(2147),
  [1867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 1), SHIFT(2148),
  [1870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(242),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(139),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(2237),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(898),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1), SHIFT(2247),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1), SHIFT(2250),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 2),
  [1890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(2237),
  [1893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(1354),
  [1896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_expression, 2),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 2),
  [1900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(242),
  [1903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(139),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(2237),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(1354),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 2),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(898),
  [1917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(2247),
  [1920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(2250),
  [1923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(242),
  [1926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(139),
  [1929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(898),
  [1932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(2247),
  [1935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(2250),
  [1938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(2351),
  [1941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(2351),
  [1944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(196),
  [1947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(137),
  [1950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(819),
  [1953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_postfix_expression, 2), SHIFT(2147),
  [1956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_postfix_expression, 2), SHIFT(2148),
  [1959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(196),
  [1962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(137),
  [1965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(819),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2), SHIFT(2147),
  [1971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2), SHIFT(2148),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_name, 1, .production_id = 1),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1),
  [1978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1), SHIFT(68),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignable_expression, 1),
  [1983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignable_expression, 1), REDUCE(sym__primary, 1),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1), SHIFT(612),
  [1989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1), REDUCE(sym__type_name, 1, .production_id = 1),
  [1992] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__primary, 1), REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(1485),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1),
  [1998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 1), REDUCE(sym__primary, 1),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignable_expression, 1),
  [2003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1), SHIFT(2226),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2),
  [2026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(172),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(139),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2326),
  [2035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(1354),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(898),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2210),
  [2046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2234),
  [2049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(188),
  [2052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(137),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2352),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(819),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2163),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2164),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 5),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 5),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 3),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [2115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(255),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [2134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(254),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(172),
  [2162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2),
  [2164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2326),
  [2167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2210),
  [2170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2234),
  [2173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(188),
  [2176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2352),
  [2179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2163),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2164),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1), REDUCE(sym__simple_formal_parameter, 1),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 1), REDUCE(sym__simple_formal_parameter, 1),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat1, 2),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2), SHIFT_REPEAT(139),
  [2210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat1, 2), SHIFT_REPEAT(1354),
  [2213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(307),
  [2216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2), SHIFT_REPEAT(137),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_subsection, 1),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_subsection, 1),
  [2223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1), SHIFT(137),
  [2226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cascade_subsection, 1), SHIFT(1354),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_subsection, 2),
  [2231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_subsection, 2),
  [2233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2), SHIFT(137),
  [2236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cascade_subsection, 2), SHIFT(1354),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1),
  [2241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2), SHIFT(139),
  [2244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1), SHIFT(139),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 1),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 1),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1),
  [2256] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1182),
  [2260] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(650),
  [2264] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1504),
  [2268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2),
  [2279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 2),
  [2281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(645),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(646),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 1),
  [2289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1160),
  [2292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(662),
  [2295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(1503),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 1),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1182),
  [2303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(659),
  [2306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(1504),
  [2309] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1160),
  [2313] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(660),
  [2317] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1503),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2),
  [2324] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(1182),
  [2328] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(721),
  [2332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 3),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3), SHIFT(1182),
  [2340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3), SHIFT(728),
  [2343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 3),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(725),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1345),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_expression, 2),
  [2357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_expression, 2),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shift_expression, 2),
  [2361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shift_expression, 2),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 2),
  [2365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1182),
  [2368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(651),
  [2371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 2),
  [2373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(808),
  [2376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1350),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2), SHIFT_REPEAT(1037),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2), SHIFT_REPEAT(1037),
  [2389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(721),
  [2392] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(1160),
  [2396] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(781),
  [2400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_shift_expression_repeat1, 2), SHIFT_REPEAT(1036),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_shift_expression_repeat1, 2), SHIFT_REPEAT(1036),
  [2406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1160),
  [2409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(781),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__real_expression, 1),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__real_expression, 1),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [2420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3), SHIFT(1160),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3), SHIFT(775),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(668),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_name, 1, .production_id = 1),
  [2431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(2194),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), SHIFT(784),
  [2439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 4),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 4),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 1),
  [2447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignable_selector_part, 2),
  [2449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_selector, 1), REDUCE(sym__assignable_selector_part, 2),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 1),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_selector, 1), REDUCE(sym__assignable_selector_part, 2),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignable_selector_part, 2),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 4),
  [2461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4), SHIFT(731),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 4),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 2),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 2),
  [2472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_additive_expression_repeat1, 2), SHIFT_REPEAT(1032),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_assignable_selector, 2),
  [2477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_assignable_selector, 2),
  [2479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4), SHIFT(770),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 3),
  [2484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 3),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignable_selector_part, 1),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__assignable_selector_part, 1), REDUCE(sym_selector, 1),
  [2491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__assignable_selector_part, 1), REDUCE(sym_selector, 1),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignable_selector_part, 1),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_expression, 2),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_expression, 2),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 2),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignable_expression, 2),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignable_expression, 2), REDUCE(sym__primary, 2),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 2),
  [2509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 2), REDUCE(sym__primary, 2),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignable_expression, 2),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 2),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 2),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 2), SHIFT(1729),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_repeat1, 2),
  [2527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2), SHIFT_REPEAT(1694),
  [2530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), SHIFT(718),
  [2533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 2), SHIFT(1694),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2), SHIFT_REPEAT(1729),
  [2539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(2172),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void, 1),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1), SHIFT(931),
  [2547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void, 1),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_dot_identifier, 2, .production_id = 11),
  [2559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_dot_identifier, 2, .production_id = 11),
  [2561] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_assignable_expression, 1), REDUCE(sym__primary, 1), REDUCE(sym__type_name, 1, .production_id = 1),
  [2565] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_assignable_expression, 1), REDUCE(sym__primary, 1), SHIFT(2226),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_part, 2),
  [2571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_part, 2),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 3),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 3),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 2),
  [2579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 2),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_selector, 4),
  [2583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_selector, 4),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [2587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [2591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 3),
  [2599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 3),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 4),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 4),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 5),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 5),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 5),
  [2611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 5),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 6),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 6),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_function, 1),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_name, 2, .production_id = 1),
  [2621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_name, 2, .production_id = 1),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_or_expression, 2),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_or_expression, 2),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(292),
  [2630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(291),
  [2633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(290),
  [2636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(252),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_selector, 3),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_selector, 3),
  [2643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(287),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_part, 1),
  [2650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_part, 1),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_and_expression, 2),
  [2654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_and_expression, 2),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_xor_expression, 2),
  [2658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_xor_expression, 2),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_selector, 1),
  [2662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_selector, 1),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_null_expression, 2, .production_id = 6),
  [2666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_null_expression, 2, .production_id = 6),
  [2668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_and_expression, 2),
  [2670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_and_expression, 2),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_or_expression, 2),
  [2674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_or_expression, 2),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17),
  [2682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(268),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17),
  [2687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(266),
  [2690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(264),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(262),
  [2696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(261),
  [2699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(260),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [2704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(286),
  [2707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1), SHIFT(836),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_object_expression, 4),
  [2712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_object_expression, 4),
  [2714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [2716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 3),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 3),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 3),
  [2732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 3),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 3),
  [2736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 3),
  [2738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 3),
  [2740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 3),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_object_expression, 3),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_object_expression, 3),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast, 2),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast, 2),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_test, 2),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_test, 2),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3),
  [2772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3),
  [2774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 18),
  [2776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 18),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 2),
  [2784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 2),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void, 2),
  [2788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void, 2),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_literal, 1),
  [2792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null_literal, 1),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 4),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 4),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 4),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 4),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_operator, 1),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_operator, 1),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4),
  [2808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_invocation, 5),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_invocation, 5),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 2),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 2),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_test_expression, 2),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_test_expression, 2),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 5),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 5),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 5),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 5),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression_without_cascade, 2),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression_without_cascade, 2),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_assignment_section, 2),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_assignment_section, 2),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [2840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [2844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [2846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 2),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 2),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 6),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 6),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 6),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 6),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 5),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 5),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 1),
  [2864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 1),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 7),
  [2868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 7),
  [2870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 7),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 7),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_this, 1),
  [2876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_this, 1),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 2, .production_id = 8),
  [2880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 2, .production_id = 8),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 1),
  [2884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 1),
  [2886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_literal, 2),
  [2888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_literal, 2),
  [2890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3), SHIFT(293),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super, 1),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super, 1),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 54),
  [2899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 54),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression_without_cascade, 3, .production_id = 18),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression_without_cascade, 3, .production_id = 18),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1), SHIFT(2300),
  [2942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2), SHIFT_REPEAT(136),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(234),
  [2950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2350),
  [2953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2146),
  [2956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2), SHIFT_REPEAT(2153),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2961] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(984),
  [2965] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1473),
  [2969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(993),
  [2972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(1473),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2977] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1023),
  [2981] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1494),
  [2985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(1004),
  [2988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1), SHIFT(1494),
  [2991] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(1114),
  [2995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3), SHIFT(1129),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata, 1),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__metadata_repeat1, 2),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2), SHIFT_REPEAT(1980),
  [3005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(986),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_operator, 1),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_operator, 1),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [3016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(1114),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment_operator, 2),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_operator, 2),
  [3023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1434),
  [3026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1431),
  [3029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1410),
  [3032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1392),
  [3035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1526),
  [3038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1486),
  [3041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1426),
  [3044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1433),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [3049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(1076),
  [3052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(976),
  [3055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3), SHIFT(1112),
  [3058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(983),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2),
  [3071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2), SHIFT(1006),
  [3074] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(1076),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1104),
  [3081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1358),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 4),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 4),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_operator, 1),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_operator, 1),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_operator, 1),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_operator, 1),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tilde_operator, 1),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tilde_operator, 1),
  [3106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1118),
  [3109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1), SHIFT(1364),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [3114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shift_operator, 1),
  [3116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shift_operator, 1),
  [3118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_operator, 1),
  [3120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_operator, 1),
  [3122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negation_operator, 1),
  [3124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negation_operator, 1),
  [3126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4), SHIFT(1116),
  [3129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), SHIFT(1107),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2), SHIFT(1085),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 26),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 26),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [3159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4), SHIFT(1123),
  [3162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(281),
  [3165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(283),
  [3168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1), SHIFT(969),
  [3171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(256),
  [3174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(265),
  [3177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(288),
  [3180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(274),
  [3183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(269),
  [3186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(272),
  [3189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(275),
  [3192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(267),
  [3195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(253),
  [3198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(273),
  [3201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1), SHIFT(1139),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 14),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 14),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1), SHIFT(136),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [3225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2), SHIFT(136),
  [3228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(311),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(310),
  [3238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(309),
  [3241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(306),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [3246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(305),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(251),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__native, 1),
  [3270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__native, 1),
  [3272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1), SHIFT(1437),
  [3275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1), SHIFT(1330),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [3280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1), SHIFT(1188),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_and_static, 1),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [3291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__static_or_covariant, 1), SHIFT(1343),
  [3294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__static_or_covariant, 1), SHIFT(1330),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static_or_covariant, 1),
  [3299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__static_or_covariant, 1), SHIFT(1188),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1239),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1224),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [3320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1232),
  [3323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, .production_id = 17), SHIFT_REPEAT(299),
  [3326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2), SHIFT_REPEAT(294),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [3331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2), SHIFT_REPEAT(284),
  [3334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2), SHIFT_REPEAT(277),
  [3337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1284),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [3344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2), SHIFT_REPEAT(298),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3), SHIFT(1285),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(1189),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1), SHIFT(1268),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1), SHIFT(1330),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external, 1),
  [3363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1), SHIFT(1188),
  [3366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1), SHIFT(1825),
  [3369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1), SHIFT(1331),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [3374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2), SHIFT_REPEAT(304),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 4), SHIFT(1282),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [3426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1476),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [3441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(1485),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 2),
  [3448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1450),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 3),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 3),
  [3473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(207),
  [3476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(138),
  [3479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2346),
  [3482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(1354),
  [3485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(1544),
  [3488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2188),
  [3491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2), SHIFT_REPEAT(2187),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 3),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 3),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_part, 2),
  [3514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__formal_parameter_part, 2),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 2),
  [3518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 2),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter_list, 1),
  [3526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameter_list, 1),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 4),
  [3530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 4),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 3),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 3),
  [3538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 5),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 5),
  [3550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1561),
  [3553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2), SHIFT(1430),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2), SHIFT(1268),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 4),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1268),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_function, 1),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [3592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 3),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [3622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1165),
  [3625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1480),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 6),
  [3640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 6),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 2),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 2),
  [3646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 1), REDUCE(sym__type_name, 1, .production_id = 1),
  [3649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(1739),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2), SHIFT_REPEAT(1728),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [3691] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1), REDUCE(sym__function_type_tail, 1), SHIFT(1165),
  [3695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1), SHIFT(1525),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1415),
  [3723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1415),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2),
  [3728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1964),
  [3731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1657),
  [3734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1416),
  [3737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1416),
  [3740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2),
  [3742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1840),
  [3745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1619),
  [3748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2), SHIFT_REPEAT(1699),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4),
  [3753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 4),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata, 1),
  [3757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2), SHIFT_REPEAT(1701),
  [3760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2), SHIFT_REPEAT(2028),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier, 1),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1443),
  [3862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1443),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2),
  [3867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1522),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [3880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, .production_id = 1), SHIFT(2226),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configurable_uri, 1),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [3917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(1391),
  [3920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 1),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_signature, 1),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2),
  [3934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2), SHIFT_REPEAT(1464),
  [3937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2), SHIFT_REPEAT(1846),
  [3940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2), SHIFT_REPEAT(1723),
  [3943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2), SHIFT_REPEAT(1465),
  [3946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2),
  [3948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2), SHIFT_REPEAT(1799),
  [3951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2), SHIFT_REPEAT(1710),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [3962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1468),
  [3965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1468),
  [3968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2),
  [3970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2), SHIFT_REPEAT(1520),
  [3973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 3),
  [3975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 3),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 2, .production_id = 9),
  [3987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 2, .production_id = 9),
  [3989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1375),
  [3992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2253),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 2, .production_id = 5),
  [3999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 2, .production_id = 5),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [4003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3), SHIFT(1165),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [4010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 4, .production_id = 19),
  [4012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 4, .production_id = 19),
  [4014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1165),
  [4017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializers, 3),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializers, 3),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 4),
  [4025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 4),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 2),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2),
  [4051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2), SHIFT_REPEAT(1489),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2), SHIFT_REPEAT(1572),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2),
  [4065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2), SHIFT_REPEAT(1478),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_initializers_repeat1, 2),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 2, .production_id = 4),
  [4072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 2, .production_id = 4),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2), SHIFT_REPEAT(1498),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2),
  [4085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2), SHIFT_REPEAT(1537),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [4094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__formal_parameter_part, 1), REDUCE(sym_constructor_signature, 2, .production_id = 48),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_signature, 2, .production_id = 48),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__formal_parameter_part, 1), REDUCE(sym_constructor_signature, 2, .production_id = 48),
  [4102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_part, 1),
  [4104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 2, .production_id = 4),
  [4106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 3, .production_id = 4),
  [4108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 3, .production_id = 4),
  [4110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 4, .production_id = 32),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 3),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [4118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 3, .production_id = 19),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializers, 2),
  [4122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializers, 2),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 4),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [4132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, .production_id = 4),
  [4134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, .production_id = 4),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 1),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 1),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 3, .production_id = 19),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 3, .production_id = 19),
  [4154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 1),
  [4156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 1),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, .production_id = 21),
  [4164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, .production_id = 21),
  [4166] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2), REDUCE(sym__function_type_tail, 2), SHIFT(1165),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2), SHIFT(1477),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [4179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 1),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 1),
  [4185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_signature, 4, .production_id = 77),
  [4187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_signature, 4, .production_id = 77),
  [4189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 2),
  [4191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 2),
  [4193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sub_string_test, 2),
  [4195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sub_string_test, 2),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [4201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_factory_constructor_signature, 4),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [4205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_factory_constructor_signature, 4),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion, 7),
  [4223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion, 7),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion, 4),
  [4229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion, 4),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_factory_constructor_signature, 3),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [4239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_factory_constructor_signature, 3),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [4245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 1),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [4249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 1),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configurable_uri, 2),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_configurable_uri_repeat1, 2),
  [4263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_configurable_uri_repeat1, 2), SHIFT_REPEAT(2355),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 1),
  [4272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 1),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [4276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1444),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 4),
  [4291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 4),
  [4293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion, 6),
  [4295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion, 6),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 5),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 5),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, .production_id = 2),
  [4307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 11),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [4311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declared_identifier, 2, .production_id = 4), REDUCE(sym__declared_identifier, 3, .production_id = 19),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 5),
  [4316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 5),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1),
  [4322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape_sequence, 1),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 4, .production_id = 4),
  [4328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 4, .production_id = 4),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 2),
  [4332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_substitution, 2),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, .production_id = 9),
  [4336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, .production_id = 9),
  [4338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 3, .production_id = 4),
  [4340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 3, .production_id = 4),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, .production_id = 5),
  [4344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, .production_id = 5),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_factory_constructor_signature_repeat1, 2),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_factory_constructor_signature_repeat1, 2), SHIFT_REPEAT(2338),
  [4351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 1, .production_id = 2),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 1, .production_id = 2),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 5, .production_id = 19),
  [4357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 5, .production_id = 19),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element, 1),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri, 1),
  [4365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 2, .production_id = 10),
  [4367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 2),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 21),
  [4371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 21),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 4, .production_id = 19),
  [4375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 4, .production_id = 19),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 4),
  [4379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 4),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__native, 2),
  [4383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__native, 2),
  [4385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_substitution, 4),
  [4387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 4),
  [4389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declared_identifier, 3, .production_id = 19), REDUCE(sym__declared_identifier, 4, .production_id = 32),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 1),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [4400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 2),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_signature, 2),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, .production_id = 25),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [4416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_identifier_list, 1),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_list, 2),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_and_static, 2),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configuration_uri, 5),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [4454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2), SHIFT_REPEAT(1495),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 2),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_library_export_repeat1, 2),
  [4467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_library_export_repeat1, 2), SHIFT_REPEAT(2114),
  [4470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2), SHIFT_REPEAT(2208),
  [4473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2),
  [4475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1606),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 1, .production_id = 2),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_not_void_list_repeat1, 2),
  [4488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_not_void_list_repeat1, 2), SHIFT_REPEAT(1380),
  [4491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 1),
  [4493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 37),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_identifier_list, 2),
  [4497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_list, 1),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 1),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [4505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_element, 5, .production_id = 39),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 5, .production_id = 34),
  [4511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 2), SHIFT(142),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 2),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_parameter_type, 1),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [4528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 1), SHIFT(142),
  [4531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 1),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 11),
  [4539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 2),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_operator, 1),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 22),
  [4551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2),
  [4553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2), SHIFT_REPEAT(135),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 2),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 1),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_element, 6, .production_id = 55),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 3, .production_id = 13),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 3),
  [4572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_type_list_repeat1, 2), SHIFT_REPEAT(1256),
  [4575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_type_list_repeat1, 2),
  [4577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application, 2),
  [4579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [4583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 3),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier_list, 2),
  [4589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initialized_identifier_list_repeat1, 2), SHIFT_REPEAT(2125),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initialized_identifier_list_repeat1, 2),
  [4594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 3, .production_id = 20),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 1), SHIFT(1832),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [4631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1475),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 2, .production_id = 2),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier_list, 1),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [4656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 64),
  [4658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_parameters_repeat1, 2), SHIFT_REPEAT(842),
  [4661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_parameters_repeat1, 2),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, .production_id = 63), SHIFT_REPEAT(210),
  [4672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, .production_id = 63),
  [4674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__set, 1),
  [4676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 2), SHIFT(1832),
  [4679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__get, 1),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 62),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 61),
  [4687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 60),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [4693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_operator, 2),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 58),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, .production_id = 57),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [4717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 2), SHIFT(1962),
  [4720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 4, .production_id = 20),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [4732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_combinator, 2),
  [4734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat3, 3), SHIFT(1832),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat3, 3),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration_list, 2),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 1), SHIFT(942),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 1),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [4762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_const_var_or_type, 2), SHIFT(1827),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_parameter_types_repeat1, 2),
  [4773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_parameter_types_repeat1, 2), SHIFT_REPEAT(1275),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, .production_id = 38), SHIFT_REPEAT(163),
  [4781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, .production_id = 38),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [4791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_operator, 1),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__named_formal_parameters_repeat1, 2),
  [4795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__named_formal_parameters_repeat1, 2), SHIFT_REPEAT(726),
  [4798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(1368),
  [4801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [4803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 41),
  [4805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_const_var_or_type, 3), SHIFT(1827),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 70),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 71),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 43),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 44),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 73),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 74),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [4836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_const_var_or_type, 2), SHIFT(2340),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration_list, 1),
  [4843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, .production_id = 75),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1497),
  [4854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1827),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_static_final_declaration_list_repeat1, 2), SHIFT_REPEAT(2086),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_static_final_declaration_list_repeat1, 2),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__normal_formal_parameters_repeat1, 2), SHIFT_REPEAT(942),
  [4887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__normal_formal_parameters_repeat1, 2),
  [4889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixins, 2),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [4899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2), SHIFT_REPEAT(1483),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_formal_parameter, 1),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [4926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat3, 2), SHIFT_REPEAT(1832),
  [4929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat3, 2),
  [4931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__try_head, 2, .production_id = 3),
  [4933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat2, 2), SHIFT_REPEAT(153),
  [4936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat2, 2),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 7, .production_id = 81),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__argument_list, 3), SHIFT(1962),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 3),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [4969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat3, 2), SHIFT_REPEAT(1962),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, .production_id = 80),
  [4976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, .production_id = 79),
  [4978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, .production_id = 78),
  [4980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 2), SHIFT(942),
  [4983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 2),
  [4985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2), SHIFT_REPEAT(1832),
  [4988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2),
  [4990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 1),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified, 1),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [5014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri_test, 1),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 5),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 6),
  [5032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1673),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 7),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier, 3),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 3),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interfaces, 2),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 4),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [5075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 3),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 1),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_formal_parameter, 3),
  [5093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inferred_type, 1),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 2),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, .production_id = 36),
  [5107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 4),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, .production_id = 5),
  [5111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 3),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, .production_id = 25),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration, 3),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_constructor_signature, 3),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, .production_id = 11),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_operator, 1),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 1),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [5195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 3),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_formal_parameters, 1),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [5229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 3),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 20),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, .production_id = 35),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 5),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [5297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 5),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5313] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [5343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application, 3),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [5349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 4),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 4),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 4),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 4),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 3),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified, 3),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 3),
  [5379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6),
  [5381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri_test, 3),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 5),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 5),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [5399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_const_var_or_type, 1), SHIFT(1639),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 5),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [5426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 8),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 9),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_identifier, 2, .dynamic_precedence = 19),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 3),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_types, 1),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_dart_external_scanner_create(void);
void tree_sitter_dart_external_scanner_destroy(void *);
bool tree_sitter_dart_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_dart_external_scanner_serialize(void *, char *);
void tree_sitter_dart_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_dart(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_dart_external_scanner_create,
      tree_sitter_dart_external_scanner_destroy,
      tree_sitter_dart_external_scanner_scan,
      tree_sitter_dart_external_scanner_serialize,
      tree_sitter_dart_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
