#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1182
#define LARGE_STATE_COUNT 22
#define SYMBOL_COUNT 196
#define ALIAS_COUNT 4
#define TOKEN_COUNT 90
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 33
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 97

enum {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_SEMI = 3,
  anon_sym_package = 4,
  anon_sym_import = 5,
  anon_sym_DOT = 6,
  sym_blank_identifier = 7,
  anon_sym_LPAREN = 8,
  anon_sym_RPAREN = 9,
  anon_sym_const = 10,
  anon_sym_COMMA = 11,
  anon_sym_EQ = 12,
  anon_sym_var = 13,
  anon_sym_func = 14,
  anon_sym_DOT_DOT_DOT = 15,
  anon_sym_type = 16,
  anon_sym_STAR = 17,
  anon_sym_LBRACK = 18,
  anon_sym_RBRACK = 19,
  anon_sym_struct = 20,
  anon_sym_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_interface = 23,
  anon_sym_map = 24,
  anon_sym_chan = 25,
  anon_sym_LT_DASH = 26,
  anon_sym_COLON_EQ = 27,
  anon_sym_PLUS_PLUS = 28,
  anon_sym_DASH_DASH = 29,
  anon_sym_STAR_EQ = 30,
  anon_sym_SLASH_EQ = 31,
  anon_sym_PERCENT_EQ = 32,
  anon_sym_LT_LT_EQ = 33,
  anon_sym_GT_GT_EQ = 34,
  anon_sym_AMP_EQ = 35,
  anon_sym_AMP_CARET_EQ = 36,
  anon_sym_PLUS_EQ = 37,
  anon_sym_DASH_EQ = 38,
  anon_sym_PIPE_EQ = 39,
  anon_sym_CARET_EQ = 40,
  anon_sym_COLON = 41,
  anon_sym_fallthrough = 42,
  anon_sym_break = 43,
  anon_sym_continue = 44,
  anon_sym_goto = 45,
  anon_sym_return = 46,
  anon_sym_go = 47,
  anon_sym_defer = 48,
  anon_sym_if = 49,
  anon_sym_else = 50,
  anon_sym_for = 51,
  anon_sym_range = 52,
  anon_sym_switch = 53,
  anon_sym_case = 54,
  anon_sym_default = 55,
  anon_sym_select = 56,
  anon_sym_new = 57,
  anon_sym_make = 58,
  anon_sym_PLUS = 59,
  anon_sym_DASH = 60,
  anon_sym_BANG = 61,
  anon_sym_CARET = 62,
  anon_sym_AMP = 63,
  anon_sym_SLASH = 64,
  anon_sym_PERCENT = 65,
  anon_sym_LT_LT = 66,
  anon_sym_GT_GT = 67,
  anon_sym_AMP_CARET = 68,
  anon_sym_PIPE = 69,
  anon_sym_EQ_EQ = 70,
  anon_sym_BANG_EQ = 71,
  anon_sym_LT = 72,
  anon_sym_LT_EQ = 73,
  anon_sym_GT = 74,
  anon_sym_GT_EQ = 75,
  anon_sym_AMP_AMP = 76,
  anon_sym_PIPE_PIPE = 77,
  sym_raw_string_literal = 78,
  anon_sym_DQUOTE = 79,
  aux_sym_interpreted_string_literal_token1 = 80,
  sym_escape_sequence = 81,
  sym_int_literal = 82,
  sym_float_literal = 83,
  sym_imaginary_literal = 84,
  sym_rune_literal = 85,
  sym_nil = 86,
  sym_true = 87,
  sym_false = 88,
  sym_comment = 89,
  sym_source_file = 90,
  sym_package_clause = 91,
  sym_import_declaration = 92,
  sym_import_spec = 93,
  sym_dot = 94,
  sym_import_spec_list = 95,
  sym__declaration = 96,
  sym_const_declaration = 97,
  sym_const_spec = 98,
  sym_var_declaration = 99,
  sym_var_spec = 100,
  sym_function_declaration = 101,
  sym_method_declaration = 102,
  sym_parameter_list = 103,
  sym_parameter_declaration = 104,
  sym_variadic_parameter_declaration = 105,
  sym_type_alias = 106,
  sym_type_declaration = 107,
  sym_type_spec = 108,
  sym_expression_list = 109,
  sym_parenthesized_type = 110,
  sym__simple_type = 111,
  sym_pointer_type = 112,
  sym_array_type = 113,
  sym_implicit_length_array_type = 114,
  sym_slice_type = 115,
  sym_struct_type = 116,
  sym_field_declaration_list = 117,
  sym_field_declaration = 118,
  sym_interface_type = 119,
  sym_method_spec_list = 120,
  sym_method_spec = 121,
  sym_map_type = 122,
  sym_channel_type = 123,
  sym_function_type = 124,
  sym_block = 125,
  sym__statement_list = 126,
  sym__statement = 127,
  sym_empty_statement = 128,
  sym__simple_statement = 129,
  sym_send_statement = 130,
  sym_receive_statement = 131,
  sym_inc_statement = 132,
  sym_dec_statement = 133,
  sym_assignment_statement = 134,
  sym_short_var_declaration = 135,
  sym_labeled_statement = 136,
  sym_empty_labeled_statement = 137,
  sym_fallthrough_statement = 138,
  sym_break_statement = 139,
  sym_continue_statement = 140,
  sym_goto_statement = 141,
  sym_return_statement = 142,
  sym_go_statement = 143,
  sym_defer_statement = 144,
  sym_if_statement = 145,
  sym_for_statement = 146,
  sym_for_clause = 147,
  sym_range_clause = 148,
  sym_expression_switch_statement = 149,
  sym_expression_case = 150,
  sym_default_case = 151,
  sym_type_switch_statement = 152,
  sym__type_switch_header = 153,
  sym_type_case = 154,
  sym_select_statement = 155,
  sym_communication_case = 156,
  sym__expression = 157,
  sym_parenthesized_expression = 158,
  sym_call_expression = 159,
  sym_variadic_argument = 160,
  sym_special_argument_list = 161,
  sym_argument_list = 162,
  sym_selector_expression = 163,
  sym_index_expression = 164,
  sym_slice_expression = 165,
  sym_type_assertion_expression = 166,
  sym_type_conversion_expression = 167,
  sym_composite_literal = 168,
  sym_literal_value = 169,
  sym_keyed_element = 170,
  sym_element = 171,
  sym_func_literal = 172,
  sym_unary_expression = 173,
  sym_binary_expression = 174,
  sym_qualified_type = 175,
  sym_interpreted_string_literal = 176,
  aux_sym_source_file_repeat1 = 177,
  aux_sym_import_spec_list_repeat1 = 178,
  aux_sym_const_declaration_repeat1 = 179,
  aux_sym_const_spec_repeat1 = 180,
  aux_sym_var_declaration_repeat1 = 181,
  aux_sym_parameter_list_repeat1 = 182,
  aux_sym_type_declaration_repeat1 = 183,
  aux_sym_field_name_list_repeat1 = 184,
  aux_sym_expression_list_repeat1 = 185,
  aux_sym_field_declaration_list_repeat1 = 186,
  aux_sym_method_spec_list_repeat1 = 187,
  aux_sym__statement_list_repeat1 = 188,
  aux_sym_expression_switch_statement_repeat1 = 189,
  aux_sym_type_switch_statement_repeat1 = 190,
  aux_sym_type_case_repeat1 = 191,
  aux_sym_select_statement_repeat1 = 192,
  aux_sym_argument_list_repeat1 = 193,
  aux_sym_literal_value_repeat1 = 194,
  aux_sym_interpreted_string_literal_repeat1 = 195,
  alias_sym_field_identifier = 196,
  alias_sym_label_name = 197,
  alias_sym_package_identifier = 198,
  alias_sym_type_identifier = 199,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_const] = "const",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_var] = "var",
  [anon_sym_func] = "func",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_type] = "type",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_struct] = "struct",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_map] = "map",
  [anon_sym_chan] = "chan",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON] = ":",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_go] = "go",
  [anon_sym_defer] = "defer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_range] = "range",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_select] = "select",
  [anon_sym_new] = "identifier",
  [anon_sym_make] = "identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_PIPE] = "|",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_interpreted_string_literal_token1] = "interpreted_string_literal_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_imaginary_literal] = "imaginary_literal",
  [sym_rune_literal] = "rune_literal",
  [sym_nil] = "nil",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_dot] = "dot",
  [sym_import_spec_list] = "import_spec_list",
  [sym__declaration] = "_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_spec] = "const_spec",
  [sym_var_declaration] = "var_declaration",
  [sym_var_spec] = "var_spec",
  [sym_function_declaration] = "function_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_type_alias] = "type_alias",
  [sym_type_declaration] = "type_declaration",
  [sym_type_spec] = "type_spec",
  [sym_expression_list] = "expression_list",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym__simple_type] = "_simple_type",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_implicit_length_array_type] = "implicit_length_array_type",
  [sym_slice_type] = "slice_type",
  [sym_struct_type] = "struct_type",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_interface_type] = "interface_type",
  [sym_method_spec_list] = "method_spec_list",
  [sym_method_spec] = "method_spec",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_function_type] = "function_type",
  [sym_block] = "block",
  [sym__statement_list] = "_statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym_send_statement] = "send_statement",
  [sym_receive_statement] = "receive_statement",
  [sym_inc_statement] = "inc_statement",
  [sym_dec_statement] = "dec_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_short_var_declaration] = "short_var_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_empty_labeled_statement] = "labeled_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_return_statement] = "return_statement",
  [sym_go_statement] = "go_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_clause] = "for_clause",
  [sym_range_clause] = "range_clause",
  [sym_expression_switch_statement] = "expression_switch_statement",
  [sym_expression_case] = "expression_case",
  [sym_default_case] = "default_case",
  [sym_type_switch_statement] = "type_switch_statement",
  [sym__type_switch_header] = "_type_switch_header",
  [sym_type_case] = "type_case",
  [sym_select_statement] = "select_statement",
  [sym_communication_case] = "communication_case",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_variadic_argument] = "variadic_argument",
  [sym_special_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym_selector_expression] = "selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_type_assertion_expression] = "type_assertion_expression",
  [sym_type_conversion_expression] = "type_conversion_expression",
  [sym_composite_literal] = "composite_literal",
  [sym_literal_value] = "literal_value",
  [sym_keyed_element] = "keyed_element",
  [sym_element] = "element",
  [sym_func_literal] = "func_literal",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_qualified_type] = "qualified_type",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_const_spec_repeat1] = "const_spec_repeat1",
  [aux_sym_var_declaration_repeat1] = "var_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_declaration_repeat1] = "type_declaration_repeat1",
  [aux_sym_field_name_list_repeat1] = "field_name_list_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_method_spec_list_repeat1] = "method_spec_list_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_expression_switch_statement_repeat1] = "expression_switch_statement_repeat1",
  [aux_sym_type_switch_statement_repeat1] = "type_switch_statement_repeat1",
  [aux_sym_type_case_repeat1] = "type_case_repeat1",
  [aux_sym_select_statement_repeat1] = "select_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_literal_value_repeat1] = "literal_value_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_label_name] = "label_name",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_new] = sym_identifier,
  [anon_sym_make] = sym_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_interpreted_string_literal_token1] = aux_sym_interpreted_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_imaginary_literal] = sym_imaginary_literal,
  [sym_rune_literal] = sym_rune_literal,
  [sym_nil] = sym_nil,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_dot] = sym_dot,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym__declaration] = sym__declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_spec] = sym_const_spec,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_spec] = sym_var_spec,
  [sym_function_declaration] = sym_function_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_type_alias] = sym_type_alias,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_spec] = sym_type_spec,
  [sym_expression_list] = sym_expression_list,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym__simple_type] = sym__simple_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_implicit_length_array_type] = sym_implicit_length_array_type,
  [sym_slice_type] = sym_slice_type,
  [sym_struct_type] = sym_struct_type,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_interface_type] = sym_interface_type,
  [sym_method_spec_list] = sym_method_spec_list,
  [sym_method_spec] = sym_method_spec,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_function_type] = sym_function_type,
  [sym_block] = sym_block,
  [sym__statement_list] = sym__statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_receive_statement] = sym_receive_statement,
  [sym_inc_statement] = sym_inc_statement,
  [sym_dec_statement] = sym_dec_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_short_var_declaration] = sym_short_var_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_empty_labeled_statement] = sym_labeled_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_go_statement] = sym_go_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_clause] = sym_for_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_expression_switch_statement] = sym_expression_switch_statement,
  [sym_expression_case] = sym_expression_case,
  [sym_default_case] = sym_default_case,
  [sym_type_switch_statement] = sym_type_switch_statement,
  [sym__type_switch_header] = sym__type_switch_header,
  [sym_type_case] = sym_type_case,
  [sym_select_statement] = sym_select_statement,
  [sym_communication_case] = sym_communication_case,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_variadic_argument] = sym_variadic_argument,
  [sym_special_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_selector_expression] = sym_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_type_assertion_expression] = sym_type_assertion_expression,
  [sym_type_conversion_expression] = sym_type_conversion_expression,
  [sym_composite_literal] = sym_composite_literal,
  [sym_literal_value] = sym_literal_value,
  [sym_keyed_element] = sym_keyed_element,
  [sym_element] = sym_element,
  [sym_func_literal] = sym_func_literal,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_qualified_type] = sym_qualified_type,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_const_spec_repeat1] = aux_sym_const_spec_repeat1,
  [aux_sym_var_declaration_repeat1] = aux_sym_var_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_type_declaration_repeat1] = aux_sym_type_declaration_repeat1,
  [aux_sym_field_name_list_repeat1] = aux_sym_field_name_list_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_method_spec_list_repeat1] = aux_sym_method_spec_list_repeat1,
  [aux_sym__statement_list_repeat1] = aux_sym__statement_list_repeat1,
  [aux_sym_expression_switch_statement_repeat1] = aux_sym_expression_switch_statement_repeat1,
  [aux_sym_type_switch_statement_repeat1] = aux_sym_type_switch_statement_repeat1,
  [aux_sym_type_case_repeat1] = aux_sym_type_case_repeat1,
  [aux_sym_select_statement_repeat1] = aux_sym_select_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_literal_value_repeat1] = aux_sym_literal_value_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_make] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_imaginary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_length_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type] = {
    .visible = true,
    .named = true,
  },
  [sym_method_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym_method_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_short_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_go_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_type_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_switch_header] = {
    .visible = false,
    .named = true,
  },
  [sym_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_communication_case] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_value] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_func_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_body = 4,
  field_capacity = 5,
  field_channel = 6,
  field_communication = 7,
  field_condition = 8,
  field_consequence = 9,
  field_element = 10,
  field_end = 11,
  field_field = 12,
  field_function = 13,
  field_index = 14,
  field_initializer = 15,
  field_key = 16,
  field_label = 17,
  field_left = 18,
  field_length = 19,
  field_name = 20,
  field_operand = 21,
  field_operator = 22,
  field_package = 23,
  field_parameters = 24,
  field_path = 25,
  field_receiver = 26,
  field_result = 27,
  field_right = 28,
  field_start = 29,
  field_tag = 30,
  field_type = 31,
  field_update = 32,
  field_value = 33,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_capacity] = "capacity",
  [field_channel] = "channel",
  [field_communication] = "communication",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_element] = "element",
  [field_end] = "end",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_start] = "start",
  [field_tag] = "tag",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 9, .length = 2},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 11, .length = 2},
  [15] = {.index = 13, .length = 2},
  [16] = {.index = 15, .length = 2},
  [17] = {.index = 17, .length = 1},
  [18] = {.index = 18, .length = 2},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 15, .length = 2},
  [22] = {.index = 24, .length = 1},
  [23] = {.index = 17, .length = 1},
  [24] = {.index = 25, .length = 1},
  [25] = {.index = 26, .length = 1},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 1},
  [28] = {.index = 30, .length = 1},
  [29] = {.index = 31, .length = 2},
  [30] = {.index = 33, .length = 3},
  [31] = {.index = 36, .length = 2},
  [32] = {.index = 38, .length = 2},
  [33] = {.index = 40, .length = 2},
  [34] = {.index = 42, .length = 2},
  [35] = {.index = 44, .length = 3},
  [36] = {.index = 47, .length = 1},
  [37] = {.index = 48, .length = 3},
  [38] = {.index = 51, .length = 3},
  [39] = {.index = 54, .length = 3},
  [40] = {.index = 57, .length = 3},
  [41] = {.index = 60, .length = 2},
  [42] = {.index = 62, .length = 1},
  [43] = {.index = 63, .length = 2},
  [44] = {.index = 47, .length = 1},
  [45] = {.index = 65, .length = 2},
  [46] = {.index = 15, .length = 2},
  [47] = {.index = 65, .length = 2},
  [49] = {.index = 67, .length = 2},
  [50] = {.index = 69, .length = 1},
  [51] = {.index = 70, .length = 1},
  [52] = {.index = 71, .length = 1},
  [53] = {.index = 72, .length = 3},
  [54] = {.index = 75, .length = 1},
  [55] = {.index = 76, .length = 2},
  [56] = {.index = 78, .length = 1},
  [57] = {.index = 79, .length = 2},
  [58] = {.index = 81, .length = 3},
  [59] = {.index = 84, .length = 3},
  [60] = {.index = 60, .length = 2},
  [61] = {.index = 87, .length = 4},
  [62] = {.index = 91, .length = 4},
  [63] = {.index = 95, .length = 4},
  [64] = {.index = 99, .length = 2},
  [65] = {.index = 99, .length = 2},
  [67] = {.index = 101, .length = 3},
  [68] = {.index = 44, .length = 3},
  [69] = {.index = 104, .length = 3},
  [70] = {.index = 107, .length = 2},
  [71] = {.index = 109, .length = 3},
  [72] = {.index = 112, .length = 3},
  [73] = {.index = 115, .length = 2},
  [74] = {.index = 117, .length = 2},
  [75] = {.index = 119, .length = 2},
  [76] = {.index = 121, .length = 2},
  [77] = {.index = 123, .length = 1},
  [78] = {.index = 124, .length = 1},
  [80] = {.index = 125, .length = 2},
  [81] = {.index = 127, .length = 2},
  [82] = {.index = 129, .length = 2},
  [83] = {.index = 131, .length = 4},
  [84] = {.index = 135, .length = 5},
  [85] = {.index = 140, .length = 4},
  [86] = {.index = 144, .length = 3},
  [87] = {.index = 147, .length = 2},
  [88] = {.index = 149, .length = 1},
  [89] = {.index = 150, .length = 3},
  [90] = {.index = 153, .length = 4},
  [91] = {.index = 157, .length = 2},
  [92] = {.index = 159, .length = 3},
  [93] = {.index = 162, .length = 2},
  [94] = {.index = 164, .length = 2},
  [95] = {.index = 166, .length = 4},
  [96] = {.index = 170, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_parameters, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_value, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_body, 1},
    {field_type, 0},
  [11] =
    {field_name, 0},
    {field_path, 1},
  [13] =
    {field_name, 0},
    {field_name, 1},
  [15] =
    {field_name, 0},
    {field_type, 1},
  [17] =
    {field_type, 0},
  [18] =
    {field_name, 1},
    {field_parameters, 2},
  [20] =
    {field_parameters, 1},
    {field_result, 2},
  [22] =
    {field_body, 2},
    {field_parameters, 1},
  [24] =
    {field_element, 2},
  [25] =
    {field_label, 0},
  [26] =
    {field_value, 2},
  [27] =
    {field_condition, 1},
    {field_consequence, 2},
  [29] =
    {field_right, 1},
  [30] =
    {field_body, 2},
  [31] =
    {field_name, 2},
    {field_package, 0},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_left, 0},
    {field_right, 2},
  [38] =
    {field_field, 2},
    {field_operand, 0},
  [40] =
    {field_channel, 0},
    {field_value, 2},
  [42] =
    {field_name, 0},
    {field_value, 2},
  [44] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
  [47] =
    {field_type, 1},
  [48] =
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [51] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [54] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [57] =
    {field_body, 3},
    {field_parameters, 1},
    {field_result, 2},
  [60] =
    {field_name, 0},
    {field_type, 2},
  [62] =
    {field_element, 3},
  [63] =
    {field_element, 3},
    {field_length, 1},
  [65] =
    {field_tag, 1},
    {field_type, 0},
  [67] =
    {field_name, 0},
    {field_parameters, 1},
  [69] =
    {field_update, 2},
  [70] =
    {field_condition, 1},
  [71] =
    {field_initializer, 0},
  [72] =
    {field_alias, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [75] =
    {field_right, 0},
  [76] =
    {field_operand, 2},
    {field_type, 0},
  [78] =
    {field_operand, 0},
  [79] =
    {field_index, 2},
    {field_operand, 0},
  [81] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 3},
  [84] =
    {field_name, 0},
    {field_name, 1},
    {field_value, 3},
  [87] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [91] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [95] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [99] =
    {field_tag, 2},
    {field_type, 1},
  [101] =
    {field_name, 0},
    {field_tag, 2},
    {field_type, 1},
  [104] =
    {field_name, 0},
    {field_parameters, 1},
    {field_result, 2},
  [107] =
    {field_key, 2},
    {field_value, 4},
  [109] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [112] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [115] =
    {field_condition, 1},
    {field_update, 3},
  [117] =
    {field_left, 0},
    {field_right, 3},
  [119] =
    {field_initializer, 0},
    {field_update, 3},
  [121] =
    {field_condition, 2},
    {field_initializer, 0},
  [123] =
    {field_initializer, 1},
  [124] =
    {field_communication, 1},
  [125] =
    {field_operand, 0},
    {field_type, 3},
  [127] =
    {field_end, 3},
    {field_operand, 0},
  [129] =
    {field_operand, 0},
    {field_start, 2},
  [131] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [135] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [140] =
    {field_name, 0},
    {field_name, 1},
    {field_tag, 3},
    {field_type, 2},
  [144] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [147] =
    {field_initializer, 1},
    {field_value, 3},
  [149] =
    {field_value, 0},
  [150] =
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [153] =
    {field_alternative, 6},
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [157] =
    {field_type, 1},
    {field_type, 2},
  [159] =
    {field_capacity, 5},
    {field_end, 3},
    {field_operand, 0},
  [162] =
    {field_alias, 0},
    {field_value, 2},
  [164] =
    {field_initializer, 0},
    {field_value, 2},
  [166] =
    {field_capacity, 6},
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [170] =
    {field_alias, 2},
    {field_initializer, 0},
    {field_value, 4},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_package_identifier,
  },
  [8] = {
    [1] = alias_sym_label_name,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [0] = alias_sym_package_identifier,
  },
  [21] = {
    [0] = alias_sym_type_identifier,
  },
  [23] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [0] = alias_sym_label_name,
  },
  [29] = {
    [0] = alias_sym_package_identifier,
    [2] = alias_sym_type_identifier,
  },
  [32] = {
    [2] = alias_sym_field_identifier,
  },
  [39] = {
    [2] = alias_sym_field_identifier,
  },
  [41] = {
    [0] = alias_sym_type_identifier,
  },
  [44] = {
    [1] = alias_sym_type_identifier,
  },
  [45] = {
    [0] = alias_sym_type_identifier,
  },
  [46] = {
    [0] = alias_sym_field_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [0] = alias_sym_field_identifier,
  },
  [62] = {
    [2] = alias_sym_field_identifier,
  },
  [63] = {
    [2] = alias_sym_field_identifier,
  },
  [64] = {
    [1] = alias_sym_type_identifier,
  },
  [66] = {
    [1] = alias_sym_field_identifier,
  },
  [67] = {
    [0] = alias_sym_field_identifier,
  },
  [68] = {
    [0] = alias_sym_field_identifier,
  },
  [69] = {
    [0] = alias_sym_field_identifier,
  },
  [79] = {
    [0] = alias_sym_field_identifier,
  },
  [84] = {
    [2] = alias_sym_field_identifier,
  },
  [85] = {
    [0] = alias_sym_field_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2208
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2228 || (c < 2308
                  ? (c >= 2230 && c <= 2247)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4186
        ? (c < 3450
          ? (c < 3242
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3205
                ? (c < 3168
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3169 || c == 3200))
                : (c <= 3212 || (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : c <= 3240)))))
            : (c <= 3251 || (c < 3342
              ? (c < 3296
                ? (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : (c <= 3261 || c == 3294))
                : (c <= 3297 || (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)))
              : (c <= 3344 || (c < 3406
                ? (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)
                : (c <= 3406 || (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : c <= 3425)))))))
          : (c <= 3455 || (c < 3751
            ? (c < 3634
              ? (c < 3517
                ? (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : c <= 3632)))
              : (c <= 3635 || (c < 3718
                ? (c < 3713
                  ? (c >= 3648 && c <= 3654)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))))
            : (c <= 3760 || (c < 3904
              ? (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))
              : (c <= 3911 || (c < 4096
                ? (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)
                : (c <= 4138 || (c < 4176
                  ? c == 4159
                  : c <= 4181)))))))))
        : (c <= 4189 || (c < 5024
          ? (c < 4698
            ? (c < 4295
              ? (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4256
                  ? c == 4238
                  : c <= 4293)))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))
            : (c <= 4701 || (c < 4802
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))
              : (c <= 4805 || (c < 4882
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))))))
          : (c <= 5109 || (c < 6103
            ? (c < 5888
              ? (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))
              : (c <= 5900 || (c < 5984
                ? (c < 5920
                  ? (c >= 5902 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43259
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6987)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11310 || (c < 12549
          ? (c < 11704
            ? (c < 11565
              ? (c < 11506
                ? (c < 11360
                  ? (c >= 11312 && c <= 11358)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))
                : (c <= 11507 || (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : c <= 11559)))
              : (c <= 11565 || (c < 11680
                ? (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))
                : (c <= 11686 || (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : c <= 11702)))))
            : (c <= 11710 || (c < 12337
              ? (c < 11736
                ? (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))
                : (c <= 11742 || (c < 12293
                  ? c == 11823
                  : c <= 12294)))
              : (c <= 12341 || (c < 12445
                ? (c < 12353
                  ? (c >= 12347 && c <= 12348)
                  : c <= 12438)
                : (c <= 12447 || (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : c <= 12543)))))))
          : (c <= 12591 || (c < 42623
            ? (c < 40956
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : c <= 19968)))
              : (c <= 40956 || (c < 42512
                ? (c < 42192
                  ? (c >= 40960 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42943 || (c < 42997
                  ? (c >= 42946 && c <= 42954)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67828
            ? (c < 67639
              ? (c < 67584
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))
                : (c <= 67589 || (c < 67594
                  ? c == 67592
                  : c <= 67637)))
              : (c <= 67640 || (c < 67680
                ? (c < 67647
                  ? c == 67644
                  : c <= 67669)
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(103);
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 170 ||
          lookahead == 181 ||
          lookahead == 186 ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 705) ||
          (710 <= lookahead && lookahead <= 721) ||
          (736 <= lookahead && lookahead <= 740) ||
          lookahead == 748 ||
          lookahead == 750 ||
          (880 <= lookahead && lookahead <= 884) ||
          lookahead == 886 ||
          lookahead == 887 ||
          (890 <= lookahead && lookahead <= 893) ||
          lookahead == 895 ||
          lookahead == 902 ||
          (904 <= lookahead && lookahead <= 906) ||
          lookahead == 908 ||
          (910 <= lookahead && lookahead <= 929) ||
          (931 <= lookahead && lookahead <= 1013) ||
          (1015 <= lookahead && lookahead <= 1153) ||
          (1162 <= lookahead && lookahead <= 1327) ||
          (1329 <= lookahead && lookahead <= 1366) ||
          lookahead == 1369 ||
          (1376 <= lookahead && lookahead <= 1416) ||
          (1488 <= lookahead && lookahead <= 1514) ||
          (1519 <= lookahead && lookahead <= 1522) ||
          (1568 <= lookahead && lookahead <= 1610) ||
          lookahead == 1646 ||
          lookahead == 1647 ||
          (1649 <= lookahead && lookahead <= 1747) ||
          lookahead == 1749 ||
          lookahead == 1765 ||
          lookahead == 1766 ||
          lookahead == 1774 ||
          lookahead == 1775 ||
          (1786 <= lookahead && lookahead <= 1788) ||
          lookahead == 1791 ||
          lookahead == 1808 ||
          (1810 <= lookahead && lookahead <= 1839) ||
          (1869 <= lookahead && lookahead <= 1957) ||
          lookahead == 1969 ||
          (1994 <= lookahead && lookahead <= 2026) ||
          lookahead == 2036 ||
          lookahead == 2037 ||
          lookahead == 2042 ||
          (2048 <= lookahead && lookahead <= 2069) ||
          lookahead == 2074 ||
          lookahead == 2084 ||
          lookahead == 2088 ||
          (2112 <= lookahead && lookahead <= 2136) ||
          (2144 <= lookahead && lookahead <= 2154) ||
          (2208 <= lookahead && lookahead <= 2228) ||
          (2230 <= lookahead && lookahead <= 2247) ||
          (2308 <= lookahead && lookahead <= 2361) ||
          lookahead == 2365 ||
          lookahead == 2384 ||
          (2392 <= lookahead && lookahead <= 2401) ||
          (2417 <= lookahead && lookahead <= 2432) ||
          (2437 <= lookahead && lookahead <= 2444) ||
          lookahead == 2447 ||
          lookahead == 2448 ||
          (2451 <= lookahead && lookahead <= 2472) ||
          (2474 <= lookahead && lookahead <= 2480) ||
          lookahead == 2482 ||
          (2486 <= lookahead && lookahead <= 2489) ||
          lookahead == 2493 ||
          lookahead == 2510 ||
          lookahead == 2524 ||
          lookahead == 2525 ||
          (2527 <= lookahead && lookahead <= 2529) ||
          lookahead == 2544 ||
          lookahead == 2545 ||
          lookahead == 2556 ||
          (2565 <= lookahead && lookahead <= 2570) ||
          lookahead == 2575 ||
          lookahead == 2576 ||
          (2579 <= lookahead && lookahead <= 2600) ||
          (2602 <= lookahead && lookahead <= 2608) ||
          lookahead == 2610 ||
          lookahead == 2611 ||
          lookahead == 2613 ||
          lookahead == 2614 ||
          lookahead == 2616 ||
          lookahead == 2617 ||
          (2649 <= lookahead && lookahead <= 2652) ||
          lookahead == 2654 ||
          (2674 <= lookahead && lookahead <= 2676) ||
          (2693 <= lookahead && lookahead <= 2701) ||
          (2703 <= lookahead && lookahead <= 2705) ||
          (2707 <= lookahead && lookahead <= 2728) ||
          (2730 <= lookahead && lookahead <= 2736) ||
          lookahead == 2738 ||
          lookahead == 2739 ||
          (2741 <= lookahead && lookahead <= 2745) ||
          lookahead == 2749 ||
          lookahead == 2768 ||
          lookahead == 2784 ||
          lookahead == 2785 ||
          lookahead == 2809 ||
          (2821 <= lookahead && lookahead <= 2828) ||
          lookahead == 2831 ||
          lookahead == 2832 ||
          (2835 <= lookahead && lookahead <= 2856) ||
          (2858 <= lookahead && lookahead <= 2864) ||
          lookahead == 2866 ||
          lookahead == 2867 ||
          (2869 <= lookahead && lookahead <= 2873) ||
          lookahead == 2877 ||
          lookahead == 2908 ||
          lookahead == 2909 ||
          (2911 <= lookahead && lookahead <= 2913) ||
          lookahead == 2929 ||
          lookahead == 2947 ||
          (2949 <= lookahead && lookahead <= 2954) ||
          (2958 <= lookahead && lookahead <= 2960) ||
          (2962 <= lookahead && lookahead <= 2965) ||
          lookahead == 2969 ||
          lookahead == 2970 ||
          lookahead == 2972 ||
          lookahead == 2974 ||
          lookahead == 2975 ||
          lookahead == 2979 ||
          lookahead == 2980 ||
          (2984 <= lookahead && lookahead <= 2986) ||
          (2990 <= lookahead && lookahead <= 3001) ||
          lookahead == 3024 ||
          (3077 <= lookahead && lookahead <= 3084) ||
          (3086 <= lookahead && lookahead <= 3088) ||
          (3090 <= lookahead && lookahead <= 3112) ||
          (3114 <= lookahead && lookahead <= 3129) ||
          lookahead == 3133 ||
          (3160 <= lookahead && lookahead <= 3162) ||
          lookahead == 3168 ||
          lookahead == 3169 ||
          lookahead == 3200 ||
          (3205 <= lookahead && lookahead <= 3212) ||
          (3214 <= lookahead && lookahead <= 3216) ||
          (3218 <= lookahead && lookahead <= 3240) ||
          (3242 <= lookahead && lookahead <= 3251) ||
          (3253 <= lookahead && lookahead <= 3257) ||
          lookahead == 3261 ||
          lookahead == 3294 ||
          lookahead == 3296 ||
          lookahead == 3297 ||
          lookahead == 3313 ||
          lookahead == 3314 ||
          (3332 <= lookahead && lookahead <= 3340) ||
          (3342 <= lookahead && lookahead <= 3344) ||
          (3346 <= lookahead && lookahead <= 3386) ||
          lookahead == 3389 ||
          lookahead == 3406 ||
          (3412 <= lookahead && lookahead <= 3414) ||
          (3423 <= lookahead && lookahead <= 3425) ||
          (3450 <= lookahead && lookahead <= 3455) ||
          (3461 <= lookahead && lookahead <= 3478) ||
          (3482 <= lookahead && lookahead <= 3505) ||
          (3507 <= lookahead && lookahead <= 3515) ||
          lookahead == 3517 ||
          (3520 <= lookahead && lookahead <= 3526) ||
          (3585 <= lookahead && lookahead <= 3632) ||
          lookahead == 3634 ||
          lookahead == 3635 ||
          (3648 <= lookahead && lookahead <= 3654) ||
          lookahead == 3713 ||
          lookahead == 3714 ||
          lookahead == 3716 ||
          (3718 <= lookahead && lookahead <= 3722) ||
          (3724 <= lookahead && lookahead <= 3747) ||
          lookahead == 3749 ||
          (3751 <= lookahead && lookahead <= 3760) ||
          lookahead == 3762 ||
          lookahead == 3763 ||
          lookahead == 3773 ||
          (3776 <= lookahead && lookahead <= 3780) ||
          lookahead == 3782 ||
          (3804 <= lookahead && lookahead <= 3807) ||
          lookahead == 3840 ||
          (3904 <= lookahead && lookahead <= 3911) ||
          (3913 <= lookahead && lookahead <= 3948) ||
          (3976 <= lookahead && lookahead <= 3980) ||
          (4096 <= lookahead && lookahead <= 4138) ||
          lookahead == 4159 ||
          (4176 <= lookahead && lookahead <= 4181) ||
          (4186 <= lookahead && lookahead <= 4189) ||
          lookahead == 4193 ||
          lookahead == 4197 ||
          lookahead == 4198 ||
          (4206 <= lookahead && lookahead <= 4208) ||
          (4213 <= lookahead && lookahead <= 4225) ||
          lookahead == 4238 ||
          (4256 <= lookahead && lookahead <= 4293) ||
          lookahead == 4295 ||
          lookahead == 4301 ||
          (4304 <= lookahead && lookahead <= 4346) ||
          (4348 <= lookahead && lookahead <= 4680) ||
          (4682 <= lookahead && lookahead <= 4685) ||
          (4688 <= lookahead && lookahead <= 4694) ||
          lookahead == 4696 ||
          (4698 <= lookahead && lookahead <= 4701) ||
          (4704 <= lookahead && lookahead <= 4744) ||
          (4746 <= lookahead && lookahead <= 4749) ||
          (4752 <= lookahead && lookahead <= 4784) ||
          (4786 <= lookahead && lookahead <= 4789) ||
          (4792 <= lookahead && lookahead <= 4798) ||
          lookahead == 4800 ||
          (4802 <= lookahead && lookahead <= 4805) ||
          (4808 <= lookahead && lookahead <= 4822) ||
          (4824 <= lookahead && lookahead <= 4880) ||
          (4882 <= lookahead && lookahead <= 4885) ||
          (4888 <= lookahead && lookahead <= 4954) ||
          (4992 <= lookahead && lookahead <= 5007) ||
          (5024 <= lookahead && lookahead <= 5109) ||
          (5112 <= lookahead && lookahead <= 5117) ||
          (5121 <= lookahead && lookahead <= 5740) ||
          (5743 <= lookahead && lookahead <= 5759) ||
          (5761 <= lookahead && lookahead <= 5786) ||
          (5792 <= lookahead && lookahead <= 5866) ||
          (5873 <= lookahead && lookahead <= 5880) ||
          (5888 <= lookahead && lookahead <= 5900) ||
          (5902 <= lookahead && lookahead <= 5905) ||
          (5920 <= lookahead && lookahead <= 5937) ||
          (5952 <= lookahead && lookahead <= 5969) ||
          (5984 <= lookahead && lookahead <= 5996) ||
          (5998 <= lookahead && lookahead <= 6000) ||
          (6016 <= lookahead && lookahead <= 6067) ||
          lookahead == 6103 ||
          lookahead == 6108 ||
          (6176 <= lookahead && lookahead <= 6264) ||
          (6272 <= lookahead && lookahead <= 6276) ||
          (6279 <= lookahead && lookahead <= 6312) ||
          lookahead == 6314 ||
          (6320 <= lookahead && lookahead <= 6389) ||
          (6400 <= lookahead && lookahead <= 6430) ||
          (6480 <= lookahead && lookahead <= 6509) ||
          (6512 <= lookahead && lookahead <= 6516) ||
          (6528 <= lookahead && lookahead <= 6571) ||
          (6576 <= lookahead && lookahead <= 6601) ||
          (6656 <= lookahead && lookahead <= 6678) ||
          (6688 <= lookahead && lookahead <= 6740) ||
          lookahead == 6823 ||
          (6917 <= lookahead && lookahead <= 6963) ||
          (6981 <= lookahead && lookahead <= 6987) ||
          (7043 <= lookahead && lookahead <= 7072) ||
          lookahead == 7086 ||
          lookahead == 7087 ||
          (7098 <= lookahead && lookahead <= 7141) ||
          (7168 <= lookahead && lookahead <= 7203) ||
          (7245 <= lookahead && lookahead <= 7247) ||
          (7258 <= lookahead && lookahead <= 7293) ||
          (7296 <= lookahead && lookahead <= 7304) ||
          (7312 <= lookahead && lookahead <= 7354) ||
          (7357 <= lookahead && lookahead <= 7359) ||
          (7401 <= lookahead && lookahead <= 7404) ||
          (7406 <= lookahead && lookahead <= 7411) ||
          lookahead == 7413 ||
          lookahead == 7414 ||
          lookahead == 7418 ||
          (7424 <= lookahead && lookahead <= 7615) ||
          (7680 <= lookahead && lookahead <= 7957) ||
          (7960 <= lookahead && lookahead <= 7965) ||
          (7968 <= lookahead && lookahead <= 8005) ||
          (8008 <= lookahead && lookahead <= 8013) ||
          (8016 <= lookahead && lookahead <= 8023) ||
          lookahead == 8025 ||
          lookahead == 8027 ||
          lookahead == 8029 ||
          (8031 <= lookahead && lookahead <= 8061) ||
          (8064 <= lookahead && lookahead <= 8116) ||
          (8118 <= lookahead && lookahead <= 8124) ||
          lookahead == 8126 ||
          (8130 <= lookahead && lookahead <= 8132) ||
          (8134 <= lookahead && lookahead <= 8140) ||
          (8144 <= lookahead && lookahead <= 8147) ||
          (8150 <= lookahead && lookahead <= 8155) ||
          (8160 <= lookahead && lookahead <= 8172) ||
          (8178 <= lookahead && lookahead <= 8180) ||
          (8182 <= lookahead && lookahead <= 8188) ||
          lookahead == 8305 ||
          lookahead == 8319 ||
          (8336 <= lookahead && lookahead <= 8348) ||
          lookahead == 8450 ||
          lookahead == 8455 ||
          (8458 <= lookahead && lookahead <= 8467) ||
          lookahead == 8469 ||
          (8473 <= lookahead && lookahead <= 8477) ||
          lookahead == 8484 ||
          lookahead == 8486 ||
          lookahead == 8488 ||
          (8490 <= lookahead && lookahead <= 8493) ||
          (8495 <= lookahead && lookahead <= 8505) ||
          (8508 <= lookahead && lookahead <= 8511) ||
          (8517 <= lookahead && lookahead <= 8521) ||
          lookahead == 8526 ||
          lookahead == 8579 ||
          lookahead == 8580 ||
          (11264 <= lookahead && lookahead <= 11310) ||
          (11312 <= lookahead && lookahead <= 11358) ||
          (11360 <= lookahead && lookahead <= 11492) ||
          (11499 <= lookahead && lookahead <= 11502) ||
          lookahead == 11506 ||
          lookahead == 11507 ||
          (11520 <= lookahead && lookahead <= 11557) ||
          lookahead == 11559 ||
          lookahead == 11565 ||
          (11568 <= lookahead && lookahead <= 11623) ||
          lookahead == 11631 ||
          (11648 <= lookahead && lookahead <= 11670) ||
          (11680 <= lookahead && lookahead <= 11686) ||
          (11688 <= lookahead && lookahead <= 11694) ||
          (11696 <= lookahead && lookahead <= 11702) ||
          (11704 <= lookahead && lookahead <= 11710) ||
          (11712 <= lookahead && lookahead <= 11718) ||
          (11720 <= lookahead && lookahead <= 11726) ||
          (11728 <= lookahead && lookahead <= 11734) ||
          (11736 <= lookahead && lookahead <= 11742) ||
          lookahead == 11823 ||
          lookahead == 12293 ||
          lookahead == 12294 ||
          (12337 <= lookahead && lookahead <= 12341) ||
          lookahead == 12347 ||
          lookahead == 12348 ||
          (12353 <= lookahead && lookahead <= 12438) ||
          (12445 <= lookahead && lookahead <= 12447) ||
          (12449 <= lookahead && lookahead <= 12538) ||
          (12540 <= lookahead && lookahead <= 12543) ||
          (12549 <= lookahead && lookahead <= 12591) ||
          (12593 <= lookahead && lookahead <= 12686) ||
          (12704 <= lookahead && lookahead <= 12735) ||
          (12784 <= lookahead && lookahead <= 12799) ||
          lookahead == 13312 ||
          lookahead == 19903 ||
          lookahead == 19968 ||
          lookahead == 40956 ||
          (40960 <= lookahead && lookahead <= 42124) ||
          (42192 <= lookahead && lookahead <= 42237) ||
          (42240 <= lookahead && lookahead <= 42508) ||
          (42512 <= lookahead && lookahead <= 42527) ||
          lookahead == 42538 ||
          lookahead == 42539 ||
          (42560 <= lookahead && lookahead <= 42606) ||
          (42623 <= lookahead && lookahead <= 42653) ||
          (42656 <= lookahead && lookahead <= 42725) ||
          (42775 <= lookahead && lookahead <= 42783) ||
          (42786 <= lookahead && lookahead <= 42888) ||
          (42891 <= lookahead && lookahead <= 42943) ||
          (42946 <= lookahead && lookahead <= 42954) ||
          (42997 <= lookahead && lookahead <= 43009) ||
          (43011 <= lookahead && lookahead <= 43013) ||
          (43015 <= lookahead && lookahead <= 43018) ||
          (43020 <= lookahead && lookahead <= 43042) ||
          (43072 <= lookahead && lookahead <= 43123) ||
          (43138 <= lookahead && lookahead <= 43187) ||
          (43250 <= lookahead && lookahead <= 43255) ||
          lookahead == 43259 ||
          lookahead == 43261 ||
          lookahead == 43262 ||
          (43274 <= lookahead && lookahead <= 43301) ||
          (43312 <= lookahead && lookahead <= 43334) ||
          (43360 <= lookahead && lookahead <= 43388) ||
          (43396 <= lookahead && lookahead <= 43442) ||
          lookahead == 43471 ||
          (43488 <= lookahead && lookahead <= 43492) ||
          (43494 <= lookahead && lookahead <= 43503) ||
          (43514 <= lookahead && lookahead <= 43518) ||
          (43520 <= lookahead && lookahead <= 43560) ||
          (43584 <= lookahead && lookahead <= 43586) ||
          (43588 <= lookahead && lookahead <= 43595) ||
          (43616 <= lookahead && lookahead <= 43638) ||
          lookahead == 43642 ||
          (43646 <= lookahead && lookahead <= 43695) ||
          lookahead == 43697 ||
          lookahead == 43701 ||
          lookahead == 43702 ||
          (43705 <= lookahead && lookahead <= 43709) ||
          lookahead == 43712 ||
          lookahead == 43714 ||
          (43739 <= lookahead && lookahead <= 43741) ||
          (43744 <= lookahead && lookahead <= 43754) ||
          (43762 <= lookahead && lookahead <= 43764) ||
          (43777 <= lookahead && lookahead <= 43782) ||
          (43785 <= lookahead && lookahead <= 43790) ||
          (43793 <= lookahead && lookahead <= 43798) ||
          (43808 <= lookahead && lookahead <= 43814) ||
          (43816 <= lookahead && lookahead <= 43822) ||
          (43824 <= lookahead && lookahead <= 43866) ||
          (43868 <= lookahead && lookahead <= 43881) ||
          (43888 <= lookahead && lookahead <= 44002) ||
          lookahead == 44032 ||
          lookahead == 55203 ||
          (55216 <= lookahead && lookahead <= 55238) ||
          (55243 <= lookahead && lookahead <= 55291) ||
          (63744 <= lookahead && lookahead <= 64109) ||
          (64112 <= lookahead && lookahead <= 64217) ||
          (64256 <= lookahead && lookahead <= 64262) ||
          (64275 <= lookahead && lookahead <= 64279) ||
          lookahead == 64285 ||
          (64287 <= lookahead && lookahead <= 64296) ||
          (64298 <= lookahead && lookahead <= 64310) ||
          (64312 <= lookahead && lookahead <= 64316) ||
          lookahead == 64318 ||
          lookahead == 64320 ||
          lookahead == 64321 ||
          lookahead == 64323 ||
          lookahead == 64324 ||
          (64326 <= lookahead && lookahead <= 64433) ||
          (64467 <= lookahead && lookahead <= 64829) ||
          (64848 <= lookahead && lookahead <= 64911) ||
          (64914 <= lookahead && lookahead <= 64967) ||
          (65008 <= lookahead && lookahead <= 65019) ||
          (65136 <= lookahead && lookahead <= 65140) ||
          (65142 <= lookahead && lookahead <= 65276) ||
          (65313 <= lookahead && lookahead <= 65338) ||
          (65345 <= lookahead && lookahead <= 65370) ||
          (65382 <= lookahead && lookahead <= 65470) ||
          (65474 <= lookahead && lookahead <= 65479) ||
          (65482 <= lookahead && lookahead <= 65487) ||
          (65490 <= lookahead && lookahead <= 65495) ||
          (65498 <= lookahead && lookahead <= 65500) ||
          (65536 <= lookahead && lookahead <= 65547) ||
          (65549 <= lookahead && lookahead <= 65574) ||
          (65576 <= lookahead && lookahead <= 65594) ||
          lookahead == 65596 ||
          lookahead == 65597 ||
          (65599 <= lookahead && lookahead <= 65613) ||
          (65616 <= lookahead && lookahead <= 65629) ||
          (65664 <= lookahead && lookahead <= 65786) ||
          (66176 <= lookahead && lookahead <= 66204) ||
          (66208 <= lookahead && lookahead <= 66256) ||
          (66304 <= lookahead && lookahead <= 66335) ||
          (66349 <= lookahead && lookahead <= 66368) ||
          (66370 <= lookahead && lookahead <= 66377) ||
          (66384 <= lookahead && lookahead <= 66421) ||
          (66432 <= lookahead && lookahead <= 66461) ||
          (66464 <= lookahead && lookahead <= 66499) ||
          (66504 <= lookahead && lookahead <= 66511) ||
          (66560 <= lookahead && lookahead <= 66717) ||
          (66736 <= lookahead && lookahead <= 66771) ||
          (66776 <= lookahead && lookahead <= 66811) ||
          (66816 <= lookahead && lookahead <= 66855) ||
          (66864 <= lookahead && lookahead <= 66915) ||
          (67072 <= lookahead && lookahead <= 67382) ||
          (67392 <= lookahead && lookahead <= 67413) ||
          (67424 <= lookahead && lookahead <= 67431) ||
          (67584 <= lookahead && lookahead <= 67589) ||
          lookahead == 67592 ||
          (67594 <= lookahead && lookahead <= 67637) ||
          lookahead == 67639 ||
          lookahead == 67640 ||
          lookahead == 67644 ||
          (67647 <= lookahead && lookahead <= 67669) ||
          (67680 <= lookahead && lookahead <= 67702) ||
          (67712 <= lookahead && lookahead <= 67742) ||
          (67808 <= lookahead && lookahead <= 67826) ||
          lookahead == 67828 ||
          lookahead == 67829 ||
          (67840 <= lookahead && lookahead <= 67861) ||
          (67872 <= lookahead && lookahead <= 67897) ||
          (67968 <= lookahead && lookahead <= 68023) ||
          lookahead == 68030 ||
          lookahead == 68031 ||
          lookahead == 68096 ||
          (68112 <= lookahead && lookahead <= 68115) ||
          (68117 <= lookahead && lookahead <= 68119) ||
          (68121 <= lookahead && lookahead <= 68149) ||
          (68192 <= lookahead && lookahead <= 68220) ||
          (68224 <= lookahead && lookahead <= 68252) ||
          (68288 <= lookahead && lookahead <= 68295) ||
          (68297 <= lookahead && lookahead <= 68309)) ADVANCE(133);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(105);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(133);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(111);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(104);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(133);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(8)
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '/') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(139);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(105);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(98);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(105);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(111);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(104);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(111);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(129);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(104);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(154);
      END_STATE();
    case 10:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(156);
      END_STATE();
    case 11:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '-') ADVANCE(79);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(72);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(147);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 21:
      if (lookahead == 'U') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (lookahead != 0) ADVANCE(141);
      END_STATE();
    case 22:
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(9);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(148);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(149);
      END_STATE();
    case 25:
      if (lookahead == '`') ADVANCE(134);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 27:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(148);
      END_STATE();
    case 30:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(9);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(149);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(31);
      END_STATE();
    case 34:
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v') ADVANCE(9);
      if (lookahead == 'U') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(141);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(147);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 57:
      if (eof) ADVANCE(60);
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(102);
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '&') ADVANCE(106);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(104);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(133);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 58:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(103);
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '%') ADVANCE(112);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(110);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(95);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(105);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(133);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(102);
      if (lookahead == '"') ADVANCE(135);
      if (lookahead == '&') ADVANCE(106);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(14);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(94);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(104);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(133);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '=') ADVANCE(88);
      if (lookahead == '^') ADVANCE(118);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '^') ADVANCE(117);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(156);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(86);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(89);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '|') ADVANCE(132);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(132);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '>') ADVANCE(116);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 170 ||
          lookahead == 181 ||
          lookahead == 186 ||
          (192 <= lookahead && lookahead <= 214) ||
          (216 <= lookahead && lookahead <= 246) ||
          (248 <= lookahead && lookahead <= 705) ||
          (710 <= lookahead && lookahead <= 721) ||
          (736 <= lookahead && lookahead <= 740) ||
          lookahead == 748 ||
          lookahead == 750 ||
          (880 <= lookahead && lookahead <= 884) ||
          lookahead == 886 ||
          lookahead == 887 ||
          (890 <= lookahead && lookahead <= 893) ||
          lookahead == 895 ||
          lookahead == 902 ||
          (904 <= lookahead && lookahead <= 906) ||
          lookahead == 908 ||
          (910 <= lookahead && lookahead <= 929) ||
          (931 <= lookahead && lookahead <= 1013) ||
          (1015 <= lookahead && lookahead <= 1153) ||
          (1162 <= lookahead && lookahead <= 1327) ||
          (1329 <= lookahead && lookahead <= 1366) ||
          lookahead == 1369 ||
          (1376 <= lookahead && lookahead <= 1416) ||
          (1488 <= lookahead && lookahead <= 1514) ||
          (1519 <= lookahead && lookahead <= 1522) ||
          (1568 <= lookahead && lookahead <= 1610) ||
          lookahead == 1646 ||
          lookahead == 1647 ||
          (1649 <= lookahead && lookahead <= 1747) ||
          lookahead == 1749 ||
          lookahead == 1765 ||
          lookahead == 1766 ||
          lookahead == 1774 ||
          lookahead == 1775 ||
          (1786 <= lookahead && lookahead <= 1788) ||
          lookahead == 1791 ||
          lookahead == 1808 ||
          (1810 <= lookahead && lookahead <= 1839) ||
          (1869 <= lookahead && lookahead <= 1957) ||
          lookahead == 1969 ||
          (1994 <= lookahead && lookahead <= 2026) ||
          lookahead == 2036 ||
          lookahead == 2037 ||
          lookahead == 2042 ||
          (2048 <= lookahead && lookahead <= 2069) ||
          lookahead == 2074 ||
          lookahead == 2084 ||
          lookahead == 2088 ||
          (2112 <= lookahead && lookahead <= 2136) ||
          (2144 <= lookahead && lookahead <= 2154) ||
          (2208 <= lookahead && lookahead <= 2228) ||
          (2230 <= lookahead && lookahead <= 2247) ||
          (2308 <= lookahead && lookahead <= 2361) ||
          lookahead == 2365 ||
          lookahead == 2384 ||
          (2392 <= lookahead && lookahead <= 2401) ||
          (2417 <= lookahead && lookahead <= 2432) ||
          (2437 <= lookahead && lookahead <= 2444) ||
          lookahead == 2447 ||
          lookahead == 2448 ||
          (2451 <= lookahead && lookahead <= 2472) ||
          (2474 <= lookahead && lookahead <= 2480) ||
          lookahead == 2482 ||
          (2486 <= lookahead && lookahead <= 2489) ||
          lookahead == 2493 ||
          lookahead == 2510 ||
          lookahead == 2524 ||
          lookahead == 2525 ||
          (2527 <= lookahead && lookahead <= 2529) ||
          lookahead == 2544 ||
          lookahead == 2545 ||
          lookahead == 2556 ||
          (2565 <= lookahead && lookahead <= 2570) ||
          lookahead == 2575 ||
          lookahead == 2576 ||
          (2579 <= lookahead && lookahead <= 2600) ||
          (2602 <= lookahead && lookahead <= 2608) ||
          lookahead == 2610 ||
          lookahead == 2611 ||
          lookahead == 2613 ||
          lookahead == 2614 ||
          lookahead == 2616 ||
          lookahead == 2617 ||
          (2649 <= lookahead && lookahead <= 2652) ||
          lookahead == 2654 ||
          (2674 <= lookahead && lookahead <= 2676) ||
          (2693 <= lookahead && lookahead <= 2701) ||
          (2703 <= lookahead && lookahead <= 2705) ||
          (2707 <= lookahead && lookahead <= 2728) ||
          (2730 <= lookahead && lookahead <= 2736) ||
          lookahead == 2738 ||
          lookahead == 2739 ||
          (2741 <= lookahead && lookahead <= 2745) ||
          lookahead == 2749 ||
          lookahead == 2768 ||
          lookahead == 2784 ||
          lookahead == 2785 ||
          lookahead == 2809 ||
          (2821 <= lookahead && lookahead <= 2828) ||
          lookahead == 2831 ||
          lookahead == 2832 ||
          (2835 <= lookahead && lookahead <= 2856) ||
          (2858 <= lookahead && lookahead <= 2864) ||
          lookahead == 2866 ||
          lookahead == 2867 ||
          (2869 <= lookahead && lookahead <= 2873) ||
          lookahead == 2877 ||
          lookahead == 2908 ||
          lookahead == 2909 ||
          (2911 <= lookahead && lookahead <= 2913) ||
          lookahead == 2929 ||
          lookahead == 2947 ||
          (2949 <= lookahead && lookahead <= 2954) ||
          (2958 <= lookahead && lookahead <= 2960) ||
          (2962 <= lookahead && lookahead <= 2965) ||
          lookahead == 2969 ||
          lookahead == 2970 ||
          lookahead == 2972 ||
          lookahead == 2974 ||
          lookahead == 2975 ||
          lookahead == 2979 ||
          lookahead == 2980 ||
          (2984 <= lookahead && lookahead <= 2986) ||
          (2990 <= lookahead && lookahead <= 3001) ||
          lookahead == 3024 ||
          (3077 <= lookahead && lookahead <= 3084) ||
          (3086 <= lookahead && lookahead <= 3088) ||
          (3090 <= lookahead && lookahead <= 3112) ||
          (3114 <= lookahead && lookahead <= 3129) ||
          lookahead == 3133 ||
          (3160 <= lookahead && lookahead <= 3162) ||
          lookahead == 3168 ||
          lookahead == 3169 ||
          lookahead == 3200 ||
          (3205 <= lookahead && lookahead <= 3212) ||
          (3214 <= lookahead && lookahead <= 3216) ||
          (3218 <= lookahead && lookahead <= 3240) ||
          (3242 <= lookahead && lookahead <= 3251) ||
          (3253 <= lookahead && lookahead <= 3257) ||
          lookahead == 3261 ||
          lookahead == 3294 ||
          lookahead == 3296 ||
          lookahead == 3297 ||
          lookahead == 3313 ||
          lookahead == 3314 ||
          (3332 <= lookahead && lookahead <= 3340) ||
          (3342 <= lookahead && lookahead <= 3344) ||
          (3346 <= lookahead && lookahead <= 3386) ||
          lookahead == 3389 ||
          lookahead == 3406 ||
          (3412 <= lookahead && lookahead <= 3414) ||
          (3423 <= lookahead && lookahead <= 3425) ||
          (3450 <= lookahead && lookahead <= 3455) ||
          (3461 <= lookahead && lookahead <= 3478) ||
          (3482 <= lookahead && lookahead <= 3505) ||
          (3507 <= lookahead && lookahead <= 3515) ||
          lookahead == 3517 ||
          (3520 <= lookahead && lookahead <= 3526) ||
          (3585 <= lookahead && lookahead <= 3632) ||
          lookahead == 3634 ||
          lookahead == 3635 ||
          (3648 <= lookahead && lookahead <= 3654) ||
          lookahead == 3713 ||
          lookahead == 3714 ||
          lookahead == 3716 ||
          (3718 <= lookahead && lookahead <= 3722) ||
          (3724 <= lookahead && lookahead <= 3747) ||
          lookahead == 3749 ||
          (3751 <= lookahead && lookahead <= 3760) ||
          lookahead == 3762 ||
          lookahead == 3763 ||
          lookahead == 3773 ||
          (3776 <= lookahead && lookahead <= 3780) ||
          lookahead == 3782 ||
          (3804 <= lookahead && lookahead <= 3807) ||
          lookahead == 3840 ||
          (3904 <= lookahead && lookahead <= 3911) ||
          (3913 <= lookahead && lookahead <= 3948) ||
          (3976 <= lookahead && lookahead <= 3980) ||
          (4096 <= lookahead && lookahead <= 4138) ||
          lookahead == 4159 ||
          (4176 <= lookahead && lookahead <= 4181) ||
          (4186 <= lookahead && lookahead <= 4189) ||
          lookahead == 4193 ||
          lookahead == 4197 ||
          lookahead == 4198 ||
          (4206 <= lookahead && lookahead <= 4208) ||
          (4213 <= lookahead && lookahead <= 4225) ||
          lookahead == 4238 ||
          (4256 <= lookahead && lookahead <= 4293) ||
          lookahead == 4295 ||
          lookahead == 4301 ||
          (4304 <= lookahead && lookahead <= 4346) ||
          (4348 <= lookahead && lookahead <= 4680) ||
          (4682 <= lookahead && lookahead <= 4685) ||
          (4688 <= lookahead && lookahead <= 4694) ||
          lookahead == 4696 ||
          (4698 <= lookahead && lookahead <= 4701) ||
          (4704 <= lookahead && lookahead <= 4744) ||
          (4746 <= lookahead && lookahead <= 4749) ||
          (4752 <= lookahead && lookahead <= 4784) ||
          (4786 <= lookahead && lookahead <= 4789) ||
          (4792 <= lookahead && lookahead <= 4798) ||
          lookahead == 4800 ||
          (4802 <= lookahead && lookahead <= 4805) ||
          (4808 <= lookahead && lookahead <= 4822) ||
          (4824 <= lookahead && lookahead <= 4880) ||
          (4882 <= lookahead && lookahead <= 4885) ||
          (4888 <= lookahead && lookahead <= 4954) ||
          (4992 <= lookahead && lookahead <= 5007) ||
          (5024 <= lookahead && lookahead <= 5109) ||
          (5112 <= lookahead && lookahead <= 5117) ||
          (5121 <= lookahead && lookahead <= 5740) ||
          (5743 <= lookahead && lookahead <= 5759) ||
          (5761 <= lookahead && lookahead <= 5786) ||
          (5792 <= lookahead && lookahead <= 5866) ||
          (5873 <= lookahead && lookahead <= 5880) ||
          (5888 <= lookahead && lookahead <= 5900) ||
          (5902 <= lookahead && lookahead <= 5905) ||
          (5920 <= lookahead && lookahead <= 5937) ||
          (5952 <= lookahead && lookahead <= 5969) ||
          (5984 <= lookahead && lookahead <= 5996) ||
          (5998 <= lookahead && lookahead <= 6000) ||
          (6016 <= lookahead && lookahead <= 6067) ||
          lookahead == 6103 ||
          lookahead == 6108 ||
          (6176 <= lookahead && lookahead <= 6264) ||
          (6272 <= lookahead && lookahead <= 6276) ||
          (6279 <= lookahead && lookahead <= 6312) ||
          lookahead == 6314 ||
          (6320 <= lookahead && lookahead <= 6389) ||
          (6400 <= lookahead && lookahead <= 6430) ||
          (6480 <= lookahead && lookahead <= 6509) ||
          (6512 <= lookahead && lookahead <= 6516) ||
          (6528 <= lookahead && lookahead <= 6571) ||
          (6576 <= lookahead && lookahead <= 6601) ||
          (6656 <= lookahead && lookahead <= 6678) ||
          (6688 <= lookahead && lookahead <= 6740) ||
          lookahead == 6823 ||
          (6917 <= lookahead && lookahead <= 6963) ||
          (6981 <= lookahead && lookahead <= 6987) ||
          (7043 <= lookahead && lookahead <= 7072) ||
          lookahead == 7086 ||
          lookahead == 7087 ||
          (7098 <= lookahead && lookahead <= 7141) ||
          (7168 <= lookahead && lookahead <= 7203) ||
          (7245 <= lookahead && lookahead <= 7247) ||
          (7258 <= lookahead && lookahead <= 7293) ||
          (7296 <= lookahead && lookahead <= 7304) ||
          (7312 <= lookahead && lookahead <= 7354) ||
          (7357 <= lookahead && lookahead <= 7359) ||
          (7401 <= lookahead && lookahead <= 7404) ||
          (7406 <= lookahead && lookahead <= 7411) ||
          lookahead == 7413 ||
          lookahead == 7414 ||
          lookahead == 7418 ||
          (7424 <= lookahead && lookahead <= 7615) ||
          (7680 <= lookahead && lookahead <= 7957) ||
          (7960 <= lookahead && lookahead <= 7965) ||
          (7968 <= lookahead && lookahead <= 8005) ||
          (8008 <= lookahead && lookahead <= 8013) ||
          (8016 <= lookahead && lookahead <= 8023) ||
          lookahead == 8025 ||
          lookahead == 8027 ||
          lookahead == 8029 ||
          (8031 <= lookahead && lookahead <= 8061) ||
          (8064 <= lookahead && lookahead <= 8116) ||
          (8118 <= lookahead && lookahead <= 8124) ||
          lookahead == 8126 ||
          (8130 <= lookahead && lookahead <= 8132) ||
          (8134 <= lookahead && lookahead <= 8140) ||
          (8144 <= lookahead && lookahead <= 8147) ||
          (8150 <= lookahead && lookahead <= 8155) ||
          (8160 <= lookahead && lookahead <= 8172) ||
          (8178 <= lookahead && lookahead <= 8180) ||
          (8182 <= lookahead && lookahead <= 8188) ||
          lookahead == 8305 ||
          lookahead == 8319 ||
          (8336 <= lookahead && lookahead <= 8348) ||
          lookahead == 8450 ||
          lookahead == 8455 ||
          (8458 <= lookahead && lookahead <= 8467) ||
          lookahead == 8469 ||
          (8473 <= lookahead && lookahead <= 8477) ||
          lookahead == 8484 ||
          lookahead == 8486 ||
          lookahead == 8488 ||
          (8490 <= lookahead && lookahead <= 8493) ||
          (8495 <= lookahead && lookahead <= 8505) ||
          (8508 <= lookahead && lookahead <= 8511) ||
          (8517 <= lookahead && lookahead <= 8521) ||
          lookahead == 8526 ||
          lookahead == 8579 ||
          lookahead == 8580 ||
          (11264 <= lookahead && lookahead <= 11310) ||
          (11312 <= lookahead && lookahead <= 11358) ||
          (11360 <= lookahead && lookahead <= 11492) ||
          (11499 <= lookahead && lookahead <= 11502) ||
          lookahead == 11506 ||
          lookahead == 11507 ||
          (11520 <= lookahead && lookahead <= 11557) ||
          lookahead == 11559 ||
          lookahead == 11565 ||
          (11568 <= lookahead && lookahead <= 11623) ||
          lookahead == 11631 ||
          (11648 <= lookahead && lookahead <= 11670) ||
          (11680 <= lookahead && lookahead <= 11686) ||
          (11688 <= lookahead && lookahead <= 11694) ||
          (11696 <= lookahead && lookahead <= 11702) ||
          (11704 <= lookahead && lookahead <= 11710) ||
          (11712 <= lookahead && lookahead <= 11718) ||
          (11720 <= lookahead && lookahead <= 11726) ||
          (11728 <= lookahead && lookahead <= 11734) ||
          (11736 <= lookahead && lookahead <= 11742) ||
          lookahead == 11823 ||
          lookahead == 12293 ||
          lookahead == 12294 ||
          (12337 <= lookahead && lookahead <= 12341) ||
          lookahead == 12347 ||
          lookahead == 12348 ||
          (12353 <= lookahead && lookahead <= 12438) ||
          (12445 <= lookahead && lookahead <= 12447) ||
          (12449 <= lookahead && lookahead <= 12538) ||
          (12540 <= lookahead && lookahead <= 12543) ||
          (12549 <= lookahead && lookahead <= 12591) ||
          (12593 <= lookahead && lookahead <= 12686) ||
          (12704 <= lookahead && lookahead <= 12735) ||
          (12784 <= lookahead && lookahead <= 12799) ||
          lookahead == 13312 ||
          lookahead == 19903 ||
          lookahead == 19968 ||
          lookahead == 40956 ||
          (40960 <= lookahead && lookahead <= 42124) ||
          (42192 <= lookahead && lookahead <= 42237) ||
          (42240 <= lookahead && lookahead <= 42508) ||
          (42512 <= lookahead && lookahead <= 42527) ||
          lookahead == 42538 ||
          lookahead == 42539 ||
          (42560 <= lookahead && lookahead <= 42606) ||
          (42623 <= lookahead && lookahead <= 42653) ||
          (42656 <= lookahead && lookahead <= 42725) ||
          (42775 <= lookahead && lookahead <= 42783) ||
          (42786 <= lookahead && lookahead <= 42888) ||
          (42891 <= lookahead && lookahead <= 42943) ||
          (42946 <= lookahead && lookahead <= 42954) ||
          (42997 <= lookahead && lookahead <= 43009) ||
          (43011 <= lookahead && lookahead <= 43013) ||
          (43015 <= lookahead && lookahead <= 43018) ||
          (43020 <= lookahead && lookahead <= 43042) ||
          (43072 <= lookahead && lookahead <= 43123) ||
          (43138 <= lookahead && lookahead <= 43187) ||
          (43250 <= lookahead && lookahead <= 43255) ||
          lookahead == 43259 ||
          lookahead == 43261 ||
          lookahead == 43262 ||
          (43274 <= lookahead && lookahead <= 43301) ||
          (43312 <= lookahead && lookahead <= 43334) ||
          (43360 <= lookahead && lookahead <= 43388) ||
          (43396 <= lookahead && lookahead <= 43442) ||
          lookahead == 43471 ||
          (43488 <= lookahead && lookahead <= 43492) ||
          (43494 <= lookahead && lookahead <= 43503) ||
          (43514 <= lookahead && lookahead <= 43518) ||
          (43520 <= lookahead && lookahead <= 43560) ||
          (43584 <= lookahead && lookahead <= 43586) ||
          (43588 <= lookahead && lookahead <= 43595) ||
          (43616 <= lookahead && lookahead <= 43638) ||
          lookahead == 43642 ||
          (43646 <= lookahead && lookahead <= 43695) ||
          lookahead == 43697 ||
          lookahead == 43701 ||
          lookahead == 43702 ||
          (43705 <= lookahead && lookahead <= 43709) ||
          lookahead == 43712 ||
          lookahead == 43714 ||
          (43739 <= lookahead && lookahead <= 43741) ||
          (43744 <= lookahead && lookahead <= 43754) ||
          (43762 <= lookahead && lookahead <= 43764) ||
          (43777 <= lookahead && lookahead <= 43782) ||
          (43785 <= lookahead && lookahead <= 43790) ||
          (43793 <= lookahead && lookahead <= 43798) ||
          (43808 <= lookahead && lookahead <= 43814) ||
          (43816 <= lookahead && lookahead <= 43822) ||
          (43824 <= lookahead && lookahead <= 43866) ||
          (43868 <= lookahead && lookahead <= 43881) ||
          (43888 <= lookahead && lookahead <= 44002) ||
          lookahead == 44032 ||
          lookahead == 55203 ||
          (55216 <= lookahead && lookahead <= 55238) ||
          (55243 <= lookahead && lookahead <= 55291) ||
          (63744 <= lookahead && lookahead <= 64109) ||
          (64112 <= lookahead && lookahead <= 64217) ||
          (64256 <= lookahead && lookahead <= 64262) ||
          (64275 <= lookahead && lookahead <= 64279) ||
          lookahead == 64285 ||
          (64287 <= lookahead && lookahead <= 64296) ||
          (64298 <= lookahead && lookahead <= 64310) ||
          (64312 <= lookahead && lookahead <= 64316) ||
          lookahead == 64318 ||
          lookahead == 64320 ||
          lookahead == 64321 ||
          lookahead == 64323 ||
          lookahead == 64324 ||
          (64326 <= lookahead && lookahead <= 64433) ||
          (64467 <= lookahead && lookahead <= 64829) ||
          (64848 <= lookahead && lookahead <= 64911) ||
          (64914 <= lookahead && lookahead <= 64967) ||
          (65008 <= lookahead && lookahead <= 65019) ||
          (65136 <= lookahead && lookahead <= 65140) ||
          (65142 <= lookahead && lookahead <= 65276) ||
          (65313 <= lookahead && lookahead <= 65338) ||
          (65345 <= lookahead && lookahead <= 65370) ||
          (65382 <= lookahead && lookahead <= 65470) ||
          (65474 <= lookahead && lookahead <= 65479) ||
          (65482 <= lookahead && lookahead <= 65487) ||
          (65490 <= lookahead && lookahead <= 65495) ||
          (65498 <= lookahead && lookahead <= 65500) ||
          (65536 <= lookahead && lookahead <= 65547) ||
          (65549 <= lookahead && lookahead <= 65574) ||
          (65576 <= lookahead && lookahead <= 65594) ||
          lookahead == 65596 ||
          lookahead == 65597 ||
          (65599 <= lookahead && lookahead <= 65613) ||
          (65616 <= lookahead && lookahead <= 65629) ||
          (65664 <= lookahead && lookahead <= 65786) ||
          (66176 <= lookahead && lookahead <= 66204) ||
          (66208 <= lookahead && lookahead <= 66256) ||
          (66304 <= lookahead && lookahead <= 66335) ||
          (66349 <= lookahead && lookahead <= 66368) ||
          (66370 <= lookahead && lookahead <= 66377) ||
          (66384 <= lookahead && lookahead <= 66421) ||
          (66432 <= lookahead && lookahead <= 66461) ||
          (66464 <= lookahead && lookahead <= 66499) ||
          (66504 <= lookahead && lookahead <= 66511) ||
          (66560 <= lookahead && lookahead <= 66717) ||
          (66736 <= lookahead && lookahead <= 66771) ||
          (66776 <= lookahead && lookahead <= 66811) ||
          (66816 <= lookahead && lookahead <= 66855) ||
          (66864 <= lookahead && lookahead <= 66915) ||
          (67072 <= lookahead && lookahead <= 67382) ||
          (67392 <= lookahead && lookahead <= 67413) ||
          (67424 <= lookahead && lookahead <= 67431) ||
          (67584 <= lookahead && lookahead <= 67589) ||
          lookahead == 67592 ||
          (67594 <= lookahead && lookahead <= 67637) ||
          lookahead == 67639 ||
          lookahead == 67640 ||
          lookahead == 67644 ||
          (67647 <= lookahead && lookahead <= 67669) ||
          (67680 <= lookahead && lookahead <= 67702) ||
          (67712 <= lookahead && lookahead <= 67742) ||
          (67808 <= lookahead && lookahead <= 67826) ||
          lookahead == 67828 ||
          lookahead == 67829 ||
          (67840 <= lookahead && lookahead <= 67861) ||
          (67872 <= lookahead && lookahead <= 67897) ||
          (67968 <= lookahead && lookahead <= 68023) ||
          lookahead == 68030 ||
          lookahead == 68031 ||
          lookahead == 68096 ||
          (68112 <= lookahead && lookahead <= 68115) ||
          (68117 <= lookahead && lookahead <= 68119) ||
          (68121 <= lookahead && lookahead <= 68149) ||
          (68192 <= lookahead && lookahead <= 68220) ||
          (68224 <= lookahead && lookahead <= 68252) ||
          (68288 <= lookahead && lookahead <= 68295) ||
          (68297 <= lookahead && lookahead <= 68309)) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(138);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(137);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '*') ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead == '/') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_interpreted_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(24);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(17);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'i') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_imaginary_literal);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(156);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(17);
      if (lookahead == 'h') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(29);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(31);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(32);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 't') ADVANCE(36);
      if (lookahead == 'w') ADVANCE(37);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'y') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(40);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(42);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(43);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(44);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(45);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(51);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 29:
      if (lookahead == 'k') ADVANCE(53);
      if (lookahead == 'p') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'w') ADVANCE(55);
      END_STATE();
    case 31:
      if (lookahead == 'l') ADVANCE(56);
      END_STATE();
    case 32:
      if (lookahead == 'c') ADVANCE(57);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 37:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(64);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 44:
      if (lookahead == 's') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(71);
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(76);
      END_STATE();
    case 50:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 57:
      if (lookahead == 'k') ADVANCE(81);
      END_STATE();
    case 58:
      if (lookahead == 'g') ADVANCE(82);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 66:
      if (lookahead == 'k') ADVANCE(89);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(92);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(97);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_make);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(98);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(102);
      END_STATE();
    case 86:
      if (lookahead == 'c') ADVANCE(103);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 92:
      if (lookahead == 'l') ADVANCE(105);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 94:
      if (lookahead == 'h') ADVANCE(106);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 96:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 97:
      if (lookahead == 'f') ADVANCE(108);
      END_STATE();
    case 98:
      if (lookahead == 'g') ADVANCE(109);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 100:
      if (lookahead == 'n') ADVANCE(110);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 103:
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == 'u') ADVANCE(114);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 106:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(117);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(120);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(121);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 120:
      if (lookahead == 'u') ADVANCE(122);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 122:
      if (lookahead == 'g') ADVANCE(124);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 124:
      if (lookahead == 'h') ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 59},
  [2] = {.lex_state = 59},
  [3] = {.lex_state = 59},
  [4] = {.lex_state = 59},
  [5] = {.lex_state = 59},
  [6] = {.lex_state = 59},
  [7] = {.lex_state = 59},
  [8] = {.lex_state = 59},
  [9] = {.lex_state = 59},
  [10] = {.lex_state = 59},
  [11] = {.lex_state = 59},
  [12] = {.lex_state = 59},
  [13] = {.lex_state = 59},
  [14] = {.lex_state = 59},
  [15] = {.lex_state = 59},
  [16] = {.lex_state = 59},
  [17] = {.lex_state = 59},
  [18] = {.lex_state = 59},
  [19] = {.lex_state = 59},
  [20] = {.lex_state = 59},
  [21] = {.lex_state = 59},
  [22] = {.lex_state = 59},
  [23] = {.lex_state = 59},
  [24] = {.lex_state = 59},
  [25] = {.lex_state = 59},
  [26] = {.lex_state = 59},
  [27] = {.lex_state = 57},
  [28] = {.lex_state = 59},
  [29] = {.lex_state = 57},
  [30] = {.lex_state = 57},
  [31] = {.lex_state = 57},
  [32] = {.lex_state = 59},
  [33] = {.lex_state = 59},
  [34] = {.lex_state = 59},
  [35] = {.lex_state = 59},
  [36] = {.lex_state = 59},
  [37] = {.lex_state = 59},
  [38] = {.lex_state = 59},
  [39] = {.lex_state = 59},
  [40] = {.lex_state = 59},
  [41] = {.lex_state = 59},
  [42] = {.lex_state = 59},
  [43] = {.lex_state = 59},
  [44] = {.lex_state = 59},
  [45] = {.lex_state = 59},
  [46] = {.lex_state = 59},
  [47] = {.lex_state = 59},
  [48] = {.lex_state = 59},
  [49] = {.lex_state = 59},
  [50] = {.lex_state = 59},
  [51] = {.lex_state = 59},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 59},
  [54] = {.lex_state = 59},
  [55] = {.lex_state = 59},
  [56] = {.lex_state = 59},
  [57] = {.lex_state = 59},
  [58] = {.lex_state = 59},
  [59] = {.lex_state = 59},
  [60] = {.lex_state = 59},
  [61] = {.lex_state = 59},
  [62] = {.lex_state = 59},
  [63] = {.lex_state = 59},
  [64] = {.lex_state = 59},
  [65] = {.lex_state = 59},
  [66] = {.lex_state = 59},
  [67] = {.lex_state = 59},
  [68] = {.lex_state = 59},
  [69] = {.lex_state = 59},
  [70] = {.lex_state = 59},
  [71] = {.lex_state = 59},
  [72] = {.lex_state = 59},
  [73] = {.lex_state = 59},
  [74] = {.lex_state = 59},
  [75] = {.lex_state = 59},
  [76] = {.lex_state = 59},
  [77] = {.lex_state = 59},
  [78] = {.lex_state = 59},
  [79] = {.lex_state = 59},
  [80] = {.lex_state = 59},
  [81] = {.lex_state = 59},
  [82] = {.lex_state = 59},
  [83] = {.lex_state = 59},
  [84] = {.lex_state = 59},
  [85] = {.lex_state = 59},
  [86] = {.lex_state = 59},
  [87] = {.lex_state = 59},
  [88] = {.lex_state = 59},
  [89] = {.lex_state = 59},
  [90] = {.lex_state = 59},
  [91] = {.lex_state = 59},
  [92] = {.lex_state = 59},
  [93] = {.lex_state = 59},
  [94] = {.lex_state = 59},
  [95] = {.lex_state = 59},
  [96] = {.lex_state = 59},
  [97] = {.lex_state = 59},
  [98] = {.lex_state = 59},
  [99] = {.lex_state = 59},
  [100] = {.lex_state = 59},
  [101] = {.lex_state = 59},
  [102] = {.lex_state = 59},
  [103] = {.lex_state = 59},
  [104] = {.lex_state = 59},
  [105] = {.lex_state = 59},
  [106] = {.lex_state = 59},
  [107] = {.lex_state = 59},
  [108] = {.lex_state = 59},
  [109] = {.lex_state = 59},
  [110] = {.lex_state = 59},
  [111] = {.lex_state = 59},
  [112] = {.lex_state = 59},
  [113] = {.lex_state = 59},
  [114] = {.lex_state = 59},
  [115] = {.lex_state = 59},
  [116] = {.lex_state = 59},
  [117] = {.lex_state = 59},
  [118] = {.lex_state = 59},
  [119] = {.lex_state = 59},
  [120] = {.lex_state = 59},
  [121] = {.lex_state = 59},
  [122] = {.lex_state = 59},
  [123] = {.lex_state = 59},
  [124] = {.lex_state = 59},
  [125] = {.lex_state = 59},
  [126] = {.lex_state = 59},
  [127] = {.lex_state = 59},
  [128] = {.lex_state = 59},
  [129] = {.lex_state = 59},
  [130] = {.lex_state = 59},
  [131] = {.lex_state = 59},
  [132] = {.lex_state = 59},
  [133] = {.lex_state = 59},
  [134] = {.lex_state = 59},
  [135] = {.lex_state = 59},
  [136] = {.lex_state = 59},
  [137] = {.lex_state = 59},
  [138] = {.lex_state = 59},
  [139] = {.lex_state = 59},
  [140] = {.lex_state = 59},
  [141] = {.lex_state = 59},
  [142] = {.lex_state = 59},
  [143] = {.lex_state = 59},
  [144] = {.lex_state = 59},
  [145] = {.lex_state = 59},
  [146] = {.lex_state = 59},
  [147] = {.lex_state = 59},
  [148] = {.lex_state = 59},
  [149] = {.lex_state = 59},
  [150] = {.lex_state = 59},
  [151] = {.lex_state = 59},
  [152] = {.lex_state = 59},
  [153] = {.lex_state = 59},
  [154] = {.lex_state = 59},
  [155] = {.lex_state = 59},
  [156] = {.lex_state = 59},
  [157] = {.lex_state = 59},
  [158] = {.lex_state = 59},
  [159] = {.lex_state = 59},
  [160] = {.lex_state = 59},
  [161] = {.lex_state = 59},
  [162] = {.lex_state = 59},
  [163] = {.lex_state = 59},
  [164] = {.lex_state = 59},
  [165] = {.lex_state = 59},
  [166] = {.lex_state = 59},
  [167] = {.lex_state = 59},
  [168] = {.lex_state = 59},
  [169] = {.lex_state = 59},
  [170] = {.lex_state = 59},
  [171] = {.lex_state = 59},
  [172] = {.lex_state = 59},
  [173] = {.lex_state = 59},
  [174] = {.lex_state = 59},
  [175] = {.lex_state = 59},
  [176] = {.lex_state = 59},
  [177] = {.lex_state = 59},
  [178] = {.lex_state = 59},
  [179] = {.lex_state = 59},
  [180] = {.lex_state = 59},
  [181] = {.lex_state = 59},
  [182] = {.lex_state = 59},
  [183] = {.lex_state = 59},
  [184] = {.lex_state = 59},
  [185] = {.lex_state = 59},
  [186] = {.lex_state = 59},
  [187] = {.lex_state = 59},
  [188] = {.lex_state = 59},
  [189] = {.lex_state = 59},
  [190] = {.lex_state = 59},
  [191] = {.lex_state = 59},
  [192] = {.lex_state = 59},
  [193] = {.lex_state = 59},
  [194] = {.lex_state = 59},
  [195] = {.lex_state = 59},
  [196] = {.lex_state = 59},
  [197] = {.lex_state = 59},
  [198] = {.lex_state = 59},
  [199] = {.lex_state = 59},
  [200] = {.lex_state = 59},
  [201] = {.lex_state = 59},
  [202] = {.lex_state = 59},
  [203] = {.lex_state = 59},
  [204] = {.lex_state = 59},
  [205] = {.lex_state = 59},
  [206] = {.lex_state = 59},
  [207] = {.lex_state = 59},
  [208] = {.lex_state = 59},
  [209] = {.lex_state = 59},
  [210] = {.lex_state = 59},
  [211] = {.lex_state = 59},
  [212] = {.lex_state = 59},
  [213] = {.lex_state = 59},
  [214] = {.lex_state = 59},
  [215] = {.lex_state = 59},
  [216] = {.lex_state = 59},
  [217] = {.lex_state = 59},
  [218] = {.lex_state = 59},
  [219] = {.lex_state = 59},
  [220] = {.lex_state = 59},
  [221] = {.lex_state = 59},
  [222] = {.lex_state = 59},
  [223] = {.lex_state = 59},
  [224] = {.lex_state = 59},
  [225] = {.lex_state = 59},
  [226] = {.lex_state = 59},
  [227] = {.lex_state = 59},
  [228] = {.lex_state = 59},
  [229] = {.lex_state = 59},
  [230] = {.lex_state = 59},
  [231] = {.lex_state = 59},
  [232] = {.lex_state = 59},
  [233] = {.lex_state = 1},
  [234] = {.lex_state = 1},
  [235] = {.lex_state = 57},
  [236] = {.lex_state = 57},
  [237] = {.lex_state = 57},
  [238] = {.lex_state = 57},
  [239] = {.lex_state = 57},
  [240] = {.lex_state = 57},
  [241] = {.lex_state = 57},
  [242] = {.lex_state = 57},
  [243] = {.lex_state = 57},
  [244] = {.lex_state = 57},
  [245] = {.lex_state = 57},
  [246] = {.lex_state = 57},
  [247] = {.lex_state = 57},
  [248] = {.lex_state = 57},
  [249] = {.lex_state = 57},
  [250] = {.lex_state = 57},
  [251] = {.lex_state = 57},
  [252] = {.lex_state = 57},
  [253] = {.lex_state = 57},
  [254] = {.lex_state = 57},
  [255] = {.lex_state = 57},
  [256] = {.lex_state = 57},
  [257] = {.lex_state = 1},
  [258] = {.lex_state = 57},
  [259] = {.lex_state = 57},
  [260] = {.lex_state = 57},
  [261] = {.lex_state = 57},
  [262] = {.lex_state = 57},
  [263] = {.lex_state = 57},
  [264] = {.lex_state = 57},
  [265] = {.lex_state = 1},
  [266] = {.lex_state = 57},
  [267] = {.lex_state = 57},
  [268] = {.lex_state = 57},
  [269] = {.lex_state = 57},
  [270] = {.lex_state = 57},
  [271] = {.lex_state = 57},
  [272] = {.lex_state = 57},
  [273] = {.lex_state = 57},
  [274] = {.lex_state = 57},
  [275] = {.lex_state = 57},
  [276] = {.lex_state = 57},
  [277] = {.lex_state = 57},
  [278] = {.lex_state = 57},
  [279] = {.lex_state = 57},
  [280] = {.lex_state = 57},
  [281] = {.lex_state = 57},
  [282] = {.lex_state = 57},
  [283] = {.lex_state = 57},
  [284] = {.lex_state = 57},
  [285] = {.lex_state = 1},
  [286] = {.lex_state = 1},
  [287] = {.lex_state = 1},
  [288] = {.lex_state = 1},
  [289] = {.lex_state = 1},
  [290] = {.lex_state = 1},
  [291] = {.lex_state = 59},
  [292] = {.lex_state = 1},
  [293] = {.lex_state = 1},
  [294] = {.lex_state = 1},
  [295] = {.lex_state = 1},
  [296] = {.lex_state = 1},
  [297] = {.lex_state = 1},
  [298] = {.lex_state = 1},
  [299] = {.lex_state = 1},
  [300] = {.lex_state = 1},
  [301] = {.lex_state = 1},
  [302] = {.lex_state = 1},
  [303] = {.lex_state = 1},
  [304] = {.lex_state = 1},
  [305] = {.lex_state = 1},
  [306] = {.lex_state = 1},
  [307] = {.lex_state = 1},
  [308] = {.lex_state = 1},
  [309] = {.lex_state = 1},
  [310] = {.lex_state = 1},
  [311] = {.lex_state = 1},
  [312] = {.lex_state = 4},
  [313] = {.lex_state = 1},
  [314] = {.lex_state = 1},
  [315] = {.lex_state = 1},
  [316] = {.lex_state = 1},
  [317] = {.lex_state = 1},
  [318] = {.lex_state = 1},
  [319] = {.lex_state = 1},
  [320] = {.lex_state = 1},
  [321] = {.lex_state = 1},
  [322] = {.lex_state = 1},
  [323] = {.lex_state = 1},
  [324] = {.lex_state = 1},
  [325] = {.lex_state = 1},
  [326] = {.lex_state = 1},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 4},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 4},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 4},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 4},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4},
  [345] = {.lex_state = 4},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 4},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 4},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 5},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 5},
  [375] = {.lex_state = 5},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 5},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 5},
  [387] = {.lex_state = 5},
  [388] = {.lex_state = 5},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 5},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 5},
  [396] = {.lex_state = 5},
  [397] = {.lex_state = 5},
  [398] = {.lex_state = 5},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 5},
  [401] = {.lex_state = 5},
  [402] = {.lex_state = 5},
  [403] = {.lex_state = 5},
  [404] = {.lex_state = 5},
  [405] = {.lex_state = 5},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 5},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 5},
  [410] = {.lex_state = 5},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 5},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 6},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 6},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 57},
  [451] = {.lex_state = 2},
  [452] = {.lex_state = 2},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 2},
  [458] = {.lex_state = 57},
  [459] = {.lex_state = 2},
  [460] = {.lex_state = 2},
  [461] = {.lex_state = 7},
  [462] = {.lex_state = 2},
  [463] = {.lex_state = 2},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 2},
  [466] = {.lex_state = 2},
  [467] = {.lex_state = 7},
  [468] = {.lex_state = 57},
  [469] = {.lex_state = 57},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 2},
  [473] = {.lex_state = 2},
  [474] = {.lex_state = 2},
  [475] = {.lex_state = 2},
  [476] = {.lex_state = 2},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 2},
  [479] = {.lex_state = 2},
  [480] = {.lex_state = 2},
  [481] = {.lex_state = 2},
  [482] = {.lex_state = 2},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 7},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 7},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 2},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 7},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 7},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 7},
  [498] = {.lex_state = 7},
  [499] = {.lex_state = 6},
  [500] = {.lex_state = 2},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 2},
  [503] = {.lex_state = 2},
  [504] = {.lex_state = 7},
  [505] = {.lex_state = 2},
  [506] = {.lex_state = 2},
  [507] = {.lex_state = 2},
  [508] = {.lex_state = 2},
  [509] = {.lex_state = 2},
  [510] = {.lex_state = 2},
  [511] = {.lex_state = 2},
  [512] = {.lex_state = 2},
  [513] = {.lex_state = 2},
  [514] = {.lex_state = 7},
  [515] = {.lex_state = 7},
  [516] = {.lex_state = 6},
  [517] = {.lex_state = 6},
  [518] = {.lex_state = 7},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 7},
  [521] = {.lex_state = 7},
  [522] = {.lex_state = 7},
  [523] = {.lex_state = 7},
  [524] = {.lex_state = 7},
  [525] = {.lex_state = 7},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 7},
  [529] = {.lex_state = 6},
  [530] = {.lex_state = 7},
  [531] = {.lex_state = 7},
  [532] = {.lex_state = 7},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 7},
  [535] = {.lex_state = 6},
  [536] = {.lex_state = 7},
  [537] = {.lex_state = 7},
  [538] = {.lex_state = 7},
  [539] = {.lex_state = 7},
  [540] = {.lex_state = 6},
  [541] = {.lex_state = 7},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 7},
  [544] = {.lex_state = 7},
  [545] = {.lex_state = 7},
  [546] = {.lex_state = 7},
  [547] = {.lex_state = 7},
  [548] = {.lex_state = 7},
  [549] = {.lex_state = 7},
  [550] = {.lex_state = 7},
  [551] = {.lex_state = 7},
  [552] = {.lex_state = 7},
  [553] = {.lex_state = 6},
  [554] = {.lex_state = 7},
  [555] = {.lex_state = 7},
  [556] = {.lex_state = 7},
  [557] = {.lex_state = 7},
  [558] = {.lex_state = 6},
  [559] = {.lex_state = 6},
  [560] = {.lex_state = 6},
  [561] = {.lex_state = 6},
  [562] = {.lex_state = 6},
  [563] = {.lex_state = 6},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 6},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 6},
  [568] = {.lex_state = 6},
  [569] = {.lex_state = 6},
  [570] = {.lex_state = 6},
  [571] = {.lex_state = 6},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 6},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 6},
  [576] = {.lex_state = 6},
  [577] = {.lex_state = 6},
  [578] = {.lex_state = 6},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 6},
  [582] = {.lex_state = 6},
  [583] = {.lex_state = 6},
  [584] = {.lex_state = 6},
  [585] = {.lex_state = 6},
  [586] = {.lex_state = 6},
  [587] = {.lex_state = 6},
  [588] = {.lex_state = 6},
  [589] = {.lex_state = 6},
  [590] = {.lex_state = 6},
  [591] = {.lex_state = 6},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 6},
  [594] = {.lex_state = 6},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 6},
  [597] = {.lex_state = 6},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 6},
  [600] = {.lex_state = 6},
  [601] = {.lex_state = 6},
  [602] = {.lex_state = 6},
  [603] = {.lex_state = 6},
  [604] = {.lex_state = 6},
  [605] = {.lex_state = 6},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 6},
  [608] = {.lex_state = 6},
  [609] = {.lex_state = 6},
  [610] = {.lex_state = 6},
  [611] = {.lex_state = 6},
  [612] = {.lex_state = 6},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 6},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 6},
  [617] = {.lex_state = 6},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 6},
  [620] = {.lex_state = 6},
  [621] = {.lex_state = 6},
  [622] = {.lex_state = 6},
  [623] = {.lex_state = 6},
  [624] = {.lex_state = 6},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 6},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 6},
  [629] = {.lex_state = 6},
  [630] = {.lex_state = 6},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 57},
  [633] = {.lex_state = 6},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 6},
  [636] = {.lex_state = 6},
  [637] = {.lex_state = 6},
  [638] = {.lex_state = 6},
  [639] = {.lex_state = 6},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 6},
  [643] = {.lex_state = 6},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 6},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 57},
  [717] = {.lex_state = 57},
  [718] = {.lex_state = 57},
  [719] = {.lex_state = 57},
  [720] = {.lex_state = 57},
  [721] = {.lex_state = 57},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 57},
  [742] = {.lex_state = 57},
  [743] = {.lex_state = 57},
  [744] = {.lex_state = 57},
  [745] = {.lex_state = 57},
  [746] = {.lex_state = 57},
  [747] = {.lex_state = 57},
  [748] = {.lex_state = 57},
  [749] = {.lex_state = 57},
  [750] = {.lex_state = 57},
  [751] = {.lex_state = 57},
  [752] = {.lex_state = 57},
  [753] = {.lex_state = 57},
  [754] = {.lex_state = 57},
  [755] = {.lex_state = 57},
  [756] = {.lex_state = 57},
  [757] = {.lex_state = 57},
  [758] = {.lex_state = 57},
  [759] = {.lex_state = 57},
  [760] = {.lex_state = 57},
  [761] = {.lex_state = 57},
  [762] = {.lex_state = 57},
  [763] = {.lex_state = 57},
  [764] = {.lex_state = 57},
  [765] = {.lex_state = 57},
  [766] = {.lex_state = 57},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 57},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 57},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 57},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 57},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 57},
  [798] = {.lex_state = 57},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 57},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 57},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 57},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 57},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 57},
  [810] = {.lex_state = 57},
  [811] = {.lex_state = 57},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 57},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 57},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 57},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 57},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 57},
  [829] = {.lex_state = 57},
  [830] = {.lex_state = 57},
  [831] = {.lex_state = 57},
  [832] = {.lex_state = 57},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 57},
  [835] = {.lex_state = 57},
  [836] = {.lex_state = 57},
  [837] = {.lex_state = 57},
  [838] = {.lex_state = 57},
  [839] = {.lex_state = 57},
  [840] = {.lex_state = 57},
  [841] = {.lex_state = 57},
  [842] = {.lex_state = 57},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 57},
  [845] = {.lex_state = 57},
  [846] = {.lex_state = 57},
  [847] = {.lex_state = 57},
  [848] = {.lex_state = 57},
  [849] = {.lex_state = 57},
  [850] = {.lex_state = 57},
  [851] = {.lex_state = 57},
  [852] = {.lex_state = 57},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 57},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 57},
  [857] = {.lex_state = 57},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 57},
  [860] = {.lex_state = 57},
  [861] = {.lex_state = 57},
  [862] = {.lex_state = 57},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 57},
  [865] = {.lex_state = 57},
  [866] = {.lex_state = 57},
  [867] = {.lex_state = 57},
  [868] = {.lex_state = 57},
  [869] = {.lex_state = 57},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 57},
  [872] = {.lex_state = 57},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 57},
  [875] = {.lex_state = 57},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 57},
  [878] = {.lex_state = 57},
  [879] = {.lex_state = 57},
  [880] = {.lex_state = 57},
  [881] = {.lex_state = 57},
  [882] = {.lex_state = 57},
  [883] = {.lex_state = 57},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 57},
  [886] = {.lex_state = 57},
  [887] = {.lex_state = 57},
  [888] = {.lex_state = 57},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 57},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 57},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 57},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 3},
  [901] = {.lex_state = 3},
  [902] = {.lex_state = 3},
  [903] = {.lex_state = 3},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 57},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 57},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 57},
  [914] = {.lex_state = 57},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 57},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 57},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 57},
  [922] = {.lex_state = 57},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 57},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 3},
  [929] = {.lex_state = 3},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 3},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 57},
  [935] = {.lex_state = 57},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 57},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 57},
  [943] = {.lex_state = 3},
  [944] = {.lex_state = 57},
  [945] = {.lex_state = 3},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 3},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 3},
  [951] = {.lex_state = 57},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 57},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 57},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 57},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 57},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 57},
  [1006] = {.lex_state = 57},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 57},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 57},
  [1036] = {.lex_state = 57},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 57},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 57},
  [1043] = {.lex_state = 57},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 57},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 57},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 57},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 57},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 57},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_make] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_imaginary_literal] = ACTIONS(1),
    [sym_rune_literal] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1147),
    [sym_package_clause] = STATE(248),
    [sym_import_declaration] = STATE(248),
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_function_declaration] = STATE(248),
    [sym_method_declaration] = STATE(248),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(1071),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_package_clause] = STATE(248),
    [sym_import_declaration] = STATE(248),
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_function_declaration] = STATE(248),
    [sym_method_declaration] = STATE(248),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(1071),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(73),
    [sym_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(78),
    [anon_sym_package] = ACTIONS(81),
    [anon_sym_import] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(87),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_var] = ACTIONS(93),
    [anon_sym_func] = ACTIONS(96),
    [anon_sym_type] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_LBRACK] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(108),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(114),
    [anon_sym_map] = ACTIONS(117),
    [anon_sym_chan] = ACTIONS(120),
    [anon_sym_LT_DASH] = ACTIONS(123),
    [anon_sym_fallthrough] = ACTIONS(126),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(138),
    [anon_sym_go] = ACTIONS(141),
    [anon_sym_defer] = ACTIONS(144),
    [anon_sym_if] = ACTIONS(147),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_switch] = ACTIONS(153),
    [anon_sym_select] = ACTIONS(156),
    [anon_sym_new] = ACTIONS(159),
    [anon_sym_make] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_BANG] = ACTIONS(162),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
    [sym_raw_string_literal] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_int_literal] = ACTIONS(171),
    [sym_float_literal] = ACTIONS(171),
    [sym_imaginary_literal] = ACTIONS(165),
    [sym_rune_literal] = ACTIONS(165),
    [sym_nil] = ACTIONS(171),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_package_clause] = STATE(248),
    [sym_import_declaration] = STATE(248),
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_function_declaration] = STATE(248),
    [sym_method_declaration] = STATE(248),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(1071),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(174),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(966),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(966),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(180),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(182),
    [anon_sym_default] = ACTIONS(182),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(983),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(983),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(184),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_default] = ACTIONS(186),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(961),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(961),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(188),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(190),
    [anon_sym_default] = ACTIONS(190),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(970),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(970),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(192),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(194),
    [anon_sym_default] = ACTIONS(194),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(957),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(957),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_default] = ACTIONS(198),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(868),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1022),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(200),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(202),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(868),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(995),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(204),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(206),
    [anon_sym_default] = ACTIONS(206),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1151),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1151),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(208),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1118),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1118),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1105),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1105),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(212),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1132),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1132),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1120),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1120),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1159),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1159),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(218),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement_list] = STATE(1122),
    [sym__statement] = STATE(829),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_empty_labeled_statement] = STATE(1122),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(834),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(224),
    [anon_sym_default] = ACTIONS(224),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(834),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__declaration] = STATE(856),
    [sym_const_declaration] = STATE(856),
    [sym_var_declaration] = STATE(856),
    [sym_type_declaration] = STATE(856),
    [sym_expression_list] = STATE(732),
    [sym_parenthesized_type] = STATE(1140),
    [sym__simple_type] = STATE(1140),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(963),
    [sym_implicit_length_array_type] = STATE(1070),
    [sym_slice_type] = STATE(963),
    [sym_struct_type] = STATE(963),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(963),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(856),
    [sym__statement] = STATE(868),
    [sym_empty_statement] = STATE(856),
    [sym__simple_statement] = STATE(856),
    [sym_send_statement] = STATE(860),
    [sym_inc_statement] = STATE(860),
    [sym_dec_statement] = STATE(860),
    [sym_assignment_statement] = STATE(860),
    [sym_short_var_declaration] = STATE(860),
    [sym_labeled_statement] = STATE(856),
    [sym_fallthrough_statement] = STATE(856),
    [sym_break_statement] = STATE(856),
    [sym_continue_statement] = STATE(856),
    [sym_goto_statement] = STATE(856),
    [sym_return_statement] = STATE(856),
    [sym_go_statement] = STATE(856),
    [sym_defer_statement] = STATE(856),
    [sym_if_statement] = STATE(856),
    [sym_for_statement] = STATE(856),
    [sym_expression_switch_statement] = STATE(856),
    [sym_type_switch_statement] = STATE(856),
    [sym_select_statement] = STATE(856),
    [sym__expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_selector_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_slice_expression] = STATE(310),
    [sym_type_assertion_expression] = STATE(310),
    [sym_type_conversion_expression] = STATE(310),
    [sym_composite_literal] = STATE(310),
    [sym_func_literal] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_qualified_type] = STATE(963),
    [sym_interpreted_string_literal] = STATE(310),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression_list] = STATE(731),
    [sym_parenthesized_type] = STATE(1178),
    [sym__simple_type] = STATE(1178),
    [sym_pointer_type] = STATE(782),
    [sym_array_type] = STATE(1003),
    [sym_implicit_length_array_type] = STATE(1091),
    [sym_slice_type] = STATE(1003),
    [sym_struct_type] = STATE(1003),
    [sym_interface_type] = STATE(782),
    [sym_map_type] = STATE(1003),
    [sym_channel_type] = STATE(782),
    [sym_function_type] = STATE(782),
    [sym_block] = STATE(848),
    [sym__simple_statement] = STATE(1175),
    [sym_send_statement] = STATE(1061),
    [sym_inc_statement] = STATE(1061),
    [sym_dec_statement] = STATE(1061),
    [sym_assignment_statement] = STATE(1061),
    [sym_short_var_declaration] = STATE(1061),
    [sym_for_clause] = STATE(1040),
    [sym_range_clause] = STATE(1040),
    [sym__expression] = STATE(327),
    [sym_parenthesized_expression] = STATE(342),
    [sym_call_expression] = STATE(342),
    [sym_selector_expression] = STATE(342),
    [sym_index_expression] = STATE(342),
    [sym_slice_expression] = STATE(342),
    [sym_type_assertion_expression] = STATE(342),
    [sym_type_conversion_expression] = STATE(342),
    [sym_composite_literal] = STATE(342),
    [sym_func_literal] = STATE(342),
    [sym_unary_expression] = STATE(342),
    [sym_binary_expression] = STATE(342),
    [sym_qualified_type] = STATE(1003),
    [sym_interpreted_string_literal] = STATE(342),
    [sym_identifier] = ACTIONS(226),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_func] = ACTIONS(232),
    [anon_sym_STAR] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(236),
    [anon_sym_range] = ACTIONS(238),
    [anon_sym_new] = ACTIONS(240),
    [anon_sym_make] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(242),
    [anon_sym_AMP] = ACTIONS(242),
    [sym_raw_string_literal] = ACTIONS(244),
    [anon_sym_DQUOTE] = ACTIONS(246),
    [sym_int_literal] = ACTIONS(248),
    [sym_float_literal] = ACTIONS(248),
    [sym_imaginary_literal] = ACTIONS(244),
    [sym_rune_literal] = ACTIONS(244),
    [sym_nil] = ACTIONS(248),
    [sym_true] = ACTIONS(248),
    [sym_false] = ACTIONS(248),
    [sym_comment] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym__expression,
    STATE(728), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1116), 1,
      sym__type_switch_header,
    STATE(1123), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [116] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(252), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym__expression,
    STATE(733), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1155), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(254), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym__expression,
    STATE(733), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1107), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [342] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(256), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym__expression,
    STATE(733), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1144), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(258), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym__expression,
    STATE(733), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1164), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [568] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_STAR,
    ACTIONS(272), 1,
      anon_sym_LBRACK,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(275), 1,
      sym_block,
    ACTIONS(260), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(235), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(264), 33,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [662] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(312), 1,
      sym__expression,
    STATE(730), 1,
      sym_expression_list,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    STATE(1166), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(1061), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [772] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_STAR,
    ACTIONS(272), 1,
      anon_sym_LBRACK,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(238), 1,
      sym_block,
    ACTIONS(288), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(236), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(290), 33,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [866] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(294), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_LPAREN,
    ACTIONS(302), 1,
      anon_sym_func,
    ACTIONS(305), 1,
      anon_sym_STAR,
    ACTIONS(308), 1,
      anon_sym_LBRACK,
    ACTIONS(311), 1,
      anon_sym_struct,
    ACTIONS(314), 1,
      anon_sym_interface,
    ACTIONS(317), 1,
      anon_sym_map,
    ACTIONS(320), 1,
      anon_sym_chan,
    ACTIONS(323), 1,
      anon_sym_LT_DASH,
    ACTIONS(292), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(252), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(297), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_LBRACE,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [955] = 24,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_LF,
    ACTIONS(332), 1,
      anon_sym_LPAREN,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(336), 1,
      anon_sym_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACK,
    ACTIONS(340), 1,
      anon_sym_LT_DASH,
    ACTIONS(348), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(842), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(330), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(344), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    ACTIONS(346), 8,
      sym_raw_string_literal,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1062] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(360), 1,
      anon_sym_RBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1172] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1282] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(376), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1392] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1018), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(380), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1612] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1722] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(384), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1001), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1832] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(386), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1034), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1942] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2052] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(965), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2162] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2272] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(394), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2382] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(396), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2492] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(398), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2602] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(400), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2712] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(998), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(404), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2932] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1019), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3042] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    STATE(573), 1,
      sym__expression,
    STATE(953), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1092), 2,
      sym_keyed_element,
      sym_element,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3149] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(461), 1,
      sym__expression,
    STATE(1069), 1,
      sym_expression_list,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1133), 2,
      sym_send_statement,
      sym_receive_statement,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3253] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(430), 1,
      anon_sym_RPAREN,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(517), 1,
      sym__expression,
    STATE(968), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3356] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(438), 1,
      anon_sym_RPAREN,
    STATE(529), 1,
      sym__expression,
    STATE(1028), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3459] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_range,
    STATE(542), 1,
      sym__expression,
    STATE(1041), 1,
      sym_expression_list,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3562] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(444), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(446), 1,
      anon_sym_RBRACK,
    STATE(628), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3665] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(448), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3768] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(450), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3871] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(452), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3974] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(454), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4077] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(456), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4180] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(458), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4283] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(460), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4386] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_range,
    STATE(542), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1094), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4489] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(466), 1,
      anon_sym_LBRACE,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(516), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1137), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4592] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4695] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(589), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1097), 1,
      sym_literal_value,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4798] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    STATE(519), 1,
      sym__expression,
    STATE(997), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(476), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5004] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(478), 1,
      anon_sym_RPAREN,
    STATE(535), 1,
      sym__expression,
    STATE(996), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5107] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(590), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1099), 1,
      sym_literal_value,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5210] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(480), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5313] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5416] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(484), 1,
      anon_sym_RPAREN,
    STATE(540), 1,
      sym__expression,
    STATE(1020), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5519] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5622] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      sym__expression,
    STATE(1021), 1,
      sym_variadic_argument,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(567), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1094), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_RBRACK,
    STATE(597), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6025] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(542), 1,
      sym__expression,
    STATE(1041), 1,
      sym_expression_list,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(494), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(498), 1,
      anon_sym_RBRACK,
    STATE(593), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6425] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(502), 1,
      anon_sym_RBRACK,
    STATE(581), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(504), 1,
      anon_sym_COLON,
    STATE(610), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(446), 1,
      anon_sym_RBRACK,
    STATE(628), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(506), 1,
      anon_sym_RBRACK,
    STATE(609), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(508), 1,
      anon_sym_COLON,
    STATE(588), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7025] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(510), 1,
      anon_sym_RBRACK,
    STATE(594), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(512), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(567), 1,
      sym__expression,
    STATE(1041), 1,
      sym_expression_list,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7425] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(516), 1,
      anon_sym_RBRACK,
    STATE(591), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(518), 1,
      anon_sym_RBRACK,
    STATE(614), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(520), 1,
      anon_sym_RBRACK,
    STATE(578), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(522), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(542), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1094), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(524), 1,
      anon_sym_SEMI,
    STATE(639), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8025] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(542), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1150), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(526), 1,
      anon_sym_SEMI,
    STATE(611), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(569), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1094), 1,
      sym_expression_list,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8425] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(530), 1,
      anon_sym_RBRACK,
    STATE(602), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_RBRACK,
    STATE(626), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(879), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(546), 1,
      anon_sym_COLON,
    STATE(575), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(571), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    STATE(1086), 1,
      sym_variadic_argument,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(548), 1,
      anon_sym_RBRACK,
    STATE(601), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9025] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(871), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(550), 1,
      anon_sym_COLON,
    STATE(608), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(552), 1,
      anon_sym_RBRACK,
    STATE(641), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(554), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9425] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(844), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(846), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(841), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_COLON,
    STATE(603), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(849), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(875), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10025] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(558), 1,
      anon_sym_RBRACK,
    STATE(587), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10125] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(831), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(867), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10425] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(452), 1,
      sym__expression,
    STATE(862), 1,
      sym_expression_list,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(562), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_RBRACK,
    STATE(586), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(566), 1,
      anon_sym_RBRACK,
    STATE(596), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10825] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(568), 1,
      anon_sym_COLON,
    STATE(584), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10925] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11025] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(600), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11122] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11219] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(513), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11316] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(294), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(379), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11510] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(288), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11607] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(293), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11704] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(292), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11801] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(290), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11898] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(621), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11995] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(582), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12092] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(638), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12189] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(642), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12286] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(576), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12383] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(558), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(337), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12577] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(453), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12674] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(375), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12771] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(559), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12868] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(454), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12965] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(459), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13062] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(562), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13159] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13256] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(455), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(459), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13450] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13547] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(563), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13644] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(336), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13741] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(624), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13838] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(585), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13935] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(456), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14032] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(413), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14129] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(561), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14226] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(570), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14323] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(568), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14420] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(565), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14517] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(499), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14614] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(413), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14711] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14808] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(640), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14905] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(413), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15002] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(636), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15099] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(334), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15196] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(629), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15293] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(631), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15390] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(286), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(332), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(332), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15778] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(333), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15875] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(330), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15972] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(630), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16069] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(466), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16166] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(378), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16263] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16360] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(373), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16457] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16554] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(374), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16651] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(604), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16748] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(634), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16845] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(376), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16942] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17039] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(377), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17136] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17233] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(643), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17330] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17427] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(286), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17524] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(332), 1,
      sym__expression,
    STATE(1091), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1178), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1003), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(342), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17621] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(622), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17718] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(583), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17815] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(605), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17912] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(619), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18009] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(491), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18106] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(492), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18203] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(620), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18300] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(375), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1179), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18397] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_func,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(582), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_DQUOTE,
    STATE(375), 1,
      sym__expression,
    STATE(1053), 1,
      sym_implicit_length_array_type,
    ACTIONS(584), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(588), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(586), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(592), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1030), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(387), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18494] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(415), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18591] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(498), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18688] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      anon_sym_chan,
    STATE(487), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18785] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(497), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18882] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(495), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18979] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(487), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19076] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(652), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19173] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(493), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19270] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(504), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19367] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(572), 1,
      sym_identifier,
    STATE(286), 1,
      sym__expression,
    STATE(1070), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1140), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(963), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(310), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19464] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(462), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19561] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(623), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19658] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(463), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19755] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(408), 1,
      sym_identifier,
    ACTIONS(410), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_func,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(416), 1,
      anon_sym_LT_DASH,
    ACTIONS(424), 1,
      anon_sym_DQUOTE,
    STATE(487), 1,
      sym__expression,
    STATE(1082), 1,
      sym_implicit_length_array_type,
    ACTIONS(418), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1180), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(422), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(420), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(426), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(1008), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(538), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19852] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(462), 1,
      sym_identifier,
    ACTIONS(464), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_LT_DASH,
    STATE(577), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(470), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19949] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(465), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20046] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(457), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20143] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(612), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20240] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(599), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20337] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(616), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20434] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(617), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20531] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(633), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20628] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(627), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20725] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_func,
    ACTIONS(534), 1,
      anon_sym_LPAREN,
    ACTIONS(536), 1,
      anon_sym_STAR,
    ACTIONS(538), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_DQUOTE,
    STATE(459), 1,
      sym__expression,
    STATE(1072), 1,
      sym_implicit_length_array_type,
    ACTIONS(342), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(542), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(346), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(540), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(967), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(476), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20822] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(428), 1,
      sym_identifier,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    STATE(607), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20919] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(434), 1,
      anon_sym_LT_DASH,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_STAR,
    STATE(637), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    ACTIONS(436), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21016] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_func,
    ACTIONS(356), 1,
      anon_sym_STAR,
    ACTIONS(362), 1,
      anon_sym_LT_DASH,
    ACTIONS(370), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    STATE(635), 1,
      sym__expression,
    STATE(1084), 1,
      sym_implicit_length_array_type,
    ACTIONS(364), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1174), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(368), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(782), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(366), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(372), 5,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
    STATE(946), 5,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(437), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21113] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(602), 1,
      anon_sym_DOT,
    ACTIONS(605), 1,
      anon_sym_LPAREN,
    ACTIONS(608), 1,
      anon_sym_LBRACE,
    ACTIONS(610), 1,
      anon_sym_COLON,
    STATE(325), 1,
      sym_literal_value,
    ACTIONS(600), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21178] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(602), 1,
      anon_sym_DOT,
    ACTIONS(605), 1,
      anon_sym_LPAREN,
    ACTIONS(608), 1,
      anon_sym_LBRACE,
    ACTIONS(612), 1,
      anon_sym_COLON,
    STATE(325), 1,
      sym_literal_value,
    ACTIONS(600), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21243] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(267), 1,
      sym_block,
    ACTIONS(614), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(616), 43,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21302] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(282), 1,
      sym_block,
    ACTIONS(618), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(620), 43,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21361] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(622), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(624), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21418] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(628), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(630), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21472] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(632), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(634), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21526] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(636), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(638), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21580] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(640), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(642), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21634] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(644), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(646), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21688] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(648), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(650), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21742] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(652), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(654), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21796] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(656), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(658), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21850] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(660), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(662), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21904] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(666), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [21958] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(668), 1,
      ts_builtin_sym_end,
    ACTIONS(672), 1,
      anon_sym_LF,
    ACTIONS(674), 1,
      anon_sym_SEMI,
    ACTIONS(670), 43,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22016] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(677), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(679), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22070] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(681), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(683), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22124] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(687), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22178] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(689), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(691), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22232] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(693), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(695), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22286] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(697), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(699), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22340] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(701), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(703), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22394] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(687), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22448] = 18,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_LF,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(713), 1,
      anon_sym_COMMA,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_LT_DASH,
    ACTIONS(723), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(725), 1,
      anon_sym_DASH_DASH,
    ACTIONS(731), 1,
      anon_sym_AMP_AMP,
    ACTIONS(733), 1,
      anon_sym_PIPE_PIPE,
    STATE(326), 1,
      sym_argument_list,
    STATE(726), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(707), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(727), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(729), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(717), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(715), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [22532] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(735), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(737), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22586] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(739), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(741), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22640] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(745), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22694] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(749), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22748] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(687), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22802] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(753), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22856] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(755), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(757), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [22910] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(602), 1,
      anon_sym_DOT,
    ACTIONS(605), 1,
      anon_sym_LPAREN,
    ACTIONS(608), 1,
      anon_sym_LBRACE,
    STATE(325), 1,
      sym_literal_value,
    ACTIONS(600), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22972] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(759), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(761), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23026] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(763), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(765), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23080] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(767), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(769), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23134] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(771), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(773), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23188] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(775), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(777), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23242] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(779), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(781), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23296] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(783), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(785), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23350] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(787), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(789), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23404] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(791), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(793), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23458] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(795), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(797), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23512] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(799), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(801), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23566] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(803), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(805), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23620] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(807), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(809), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23674] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(811), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(813), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23728] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(815), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(817), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23782] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(819), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(821), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23836] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(823), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(825), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23890] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(827), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(829), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23944] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(831), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(833), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
  [23998] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(787), 1,
      anon_sym_LF,
    ACTIONS(789), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24051] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(835), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(837), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24112] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_LF,
    ACTIONS(785), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24165] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(839), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(717), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24228] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(843), 1,
      anon_sym_LPAREN,
    STATE(326), 1,
      sym_special_argument_list,
    ACTIONS(600), 42,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24285] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(731), 1,
      anon_sym_AMP_AMP,
    ACTIONS(839), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(727), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(729), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(717), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
  [24354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_imaginary_literal,
      sym_rune_literal,
    ACTIONS(845), 29,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      sym_identifier,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
  [24407] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(839), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(727), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(729), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(717), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24474] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(839), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(727), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(717), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24539] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_DOT,
    ACTIONS(711), 1,
      anon_sym_LPAREN,
    ACTIONS(719), 1,
      anon_sym_LBRACK,
    ACTIONS(839), 1,
      anon_sym_LF,
    STATE(326), 1,
      sym_argument_list,
    ACTIONS(841), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24600] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LF,
    ACTIONS(849), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24652] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_LF,
    ACTIONS(853), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24704] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_LF,
    ACTIONS(857), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24756] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(859), 1,
      anon_sym_LF,
    ACTIONS(861), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24808] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(811), 1,
      anon_sym_LF,
    ACTIONS(813), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24860] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_LF,
    ACTIONS(865), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24912] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(867), 1,
      anon_sym_LF,
    ACTIONS(869), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24964] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(871), 1,
      anon_sym_LF,
    ACTIONS(873), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25016] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_LF,
    ACTIONS(877), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25068] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_LF,
    ACTIONS(881), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25120] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(883), 1,
      anon_sym_LF,
    ACTIONS(885), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25172] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(887), 1,
      anon_sym_LF,
    ACTIONS(889), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25224] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LF,
    ACTIONS(893), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25276] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_LF,
    ACTIONS(897), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25328] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_LF,
    ACTIONS(901), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25380] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(600), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25432] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(903), 1,
      anon_sym_LF,
    ACTIONS(905), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25484] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(705), 1,
      anon_sym_SEMI,
    ACTIONS(715), 1,
      anon_sym_EQ,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_COMMA,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LT_DASH,
    ACTIONS(921), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(933), 1,
      anon_sym_PIPE_PIPE,
    STATE(345), 1,
      sym_argument_list,
    STATE(726), 1,
      aux_sym_expression_list_repeat1,
    STATE(830), 1,
      sym_block,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(919), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25572] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_LF,
    ACTIONS(937), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25624] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_LF,
    ACTIONS(941), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25676] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_LF,
    ACTIONS(945), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25728] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(947), 1,
      anon_sym_LF,
    ACTIONS(949), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25780] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_LF,
    ACTIONS(953), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25832] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_LF,
    ACTIONS(957), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25884] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(959), 1,
      anon_sym_LF,
    ACTIONS(961), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25936] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_LF,
    ACTIONS(965), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25988] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(967), 1,
      anon_sym_LF,
    ACTIONS(969), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26040] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_LF,
    ACTIONS(973), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26092] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(815), 1,
      anon_sym_LF,
    ACTIONS(817), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26144] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(975), 1,
      anon_sym_LF,
    ACTIONS(977), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26196] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(979), 1,
      anon_sym_LF,
    ACTIONS(981), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26248] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(983), 1,
      anon_sym_LF,
    ACTIONS(985), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26300] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(705), 1,
      anon_sym_SEMI,
    ACTIONS(715), 1,
      anon_sym_EQ,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_COMMA,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LT_DASH,
    ACTIONS(921), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(933), 1,
      anon_sym_PIPE_PIPE,
    STATE(345), 1,
      sym_argument_list,
    STATE(726), 1,
      aux_sym_expression_list_repeat1,
    STATE(840), 1,
      sym_block,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(919), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26388] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_SEMI,
    ACTIONS(715), 1,
      anon_sym_EQ,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_COMMA,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LT_DASH,
    ACTIONS(921), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(987), 1,
      anon_sym_DOT,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(345), 1,
      sym_argument_list,
    STATE(726), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(919), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26473] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_LBRACE,
    ACTIONS(715), 1,
      anon_sym_EQ,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(911), 1,
      anon_sym_COMMA,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    ACTIONS(921), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(923), 1,
      anon_sym_DASH_DASH,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    STATE(345), 1,
      sym_argument_list,
    STATE(726), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(919), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(841), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(839), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      anon_sym_LPAREN,
    STATE(345), 1,
      sym_special_argument_list,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(837), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(835), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(841), 7,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(841), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_literal_value,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26903] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      anon_sym_EQ,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      anon_sym_EQ,
    ACTIONS(907), 1,
      anon_sym_DOT,
    ACTIONS(909), 1,
      anon_sym_LPAREN,
    ACTIONS(915), 1,
      anon_sym_LBRACK,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(913), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [27037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(939), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(859), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(879), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(899), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(947), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(789), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(787), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(983), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(979), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(811), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(851), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(963), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(815), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(975), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(903), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(891), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(967), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(783), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(943), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(935), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(867), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(971), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(895), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(875), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(871), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(863), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(887), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(855), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(959), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(951), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(883), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(955), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(849), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(847), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_LBRACE,
    STATE(401), 1,
      sym_literal_value,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 20,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_LPAREN,
    STATE(400), 1,
      sym_special_argument_list,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 21,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(841), 7,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1009), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28812] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(841), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1013), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1009), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(837), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(835), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28922] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      anon_sym_EQ,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(1017), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1013), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1015), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1009), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 15,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28983] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      anon_sym_EQ,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    ACTIONS(1019), 1,
      anon_sym_AMP_AMP,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(1017), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1013), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1015), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1009), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 14,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [29046] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(841), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(839), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_DOT,
    ACTIONS(1007), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_LBRACK,
    ACTIONS(1019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1023), 1,
      anon_sym_EQ,
    ACTIONS(1025), 1,
      anon_sym_PIPE_PIPE,
    STATE(400), 1,
      sym_argument_list,
    ACTIONS(1017), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1013), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1015), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1009), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(1021), 13,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(951), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(899), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(863), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(811), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(887), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(855), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(859), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(871), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(959), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(895), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(935), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(883), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(939), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(943), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(967), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(849), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(847), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(955), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(947), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(789), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(787), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(983), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(979), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(975), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(903), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(963), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(891), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(875), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(783), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(867), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(971), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(851), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(879), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(815), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30616] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(841), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(839), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      anon_sym_LPAREN,
    STATE(433), 1,
      sym_special_argument_list,
    ACTIONS(600), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 23,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30710] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(837), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(835), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(935), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(875), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(903), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(849), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(847), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30919] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(995), 1,
      anon_sym_DOT,
    STATE(432), 1,
      sym_literal_value,
    ACTIONS(998), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(600), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(863), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(895), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(899), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(947), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(939), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(891), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(943), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(783), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(859), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(851), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(815), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(979), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(983), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(789), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(787), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(967), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(975), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(963), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(867), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(887), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(811), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(879), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(883), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(855), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(871), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(951), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(959), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(971), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(955), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32127] = 21,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1037), 1,
      anon_sym_LF,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1043), 1,
      anon_sym_LPAREN,
    ACTIONS(1045), 1,
      anon_sym_COMMA,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1051), 1,
      anon_sym_LBRACK,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1061), 1,
      anon_sym_LT_DASH,
    ACTIONS(1063), 1,
      sym_raw_string_literal,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    STATE(645), 1,
      aux_sym_field_name_list_repeat1,
    STATE(1036), 1,
      sym_interpreted_string_literal,
    ACTIONS(1039), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(809), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [32201] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(602), 1,
      anon_sym_DOT,
    ACTIONS(605), 1,
      anon_sym_LPAREN,
    ACTIONS(1067), 1,
      anon_sym_LBRACE,
    STATE(508), 1,
      sym_literal_value,
    ACTIONS(600), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32247] = 14,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_COMMA,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1085), 1,
      anon_sym_PIPE_PIPE,
    STATE(507), 1,
      sym_argument_list,
    STATE(773), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(715), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [32307] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
  [32367] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32425] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(841), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(841), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32529] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(841), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32574] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1105), 1,
      anon_sym_LF,
    ACTIONS(1109), 1,
      anon_sym_LPAREN,
    ACTIONS(1111), 1,
      anon_sym_COMMA,
    ACTIONS(1113), 1,
      anon_sym_EQ,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1117), 1,
      anon_sym_STAR,
    ACTIONS(1119), 1,
      anon_sym_LBRACK,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1125), 1,
      anon_sym_LT_DASH,
    STATE(469), 1,
      aux_sym_const_spec_repeat1,
    STATE(1126), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1107), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [32641] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(835), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(837), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32686] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_LPAREN,
    STATE(507), 1,
      sym_special_argument_list,
    ACTIONS(600), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32727] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 1,
      anon_sym_EQ,
    ACTIONS(917), 1,
      anon_sym_LT_DASH,
    ACTIONS(919), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_COMMA,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1139), 1,
      anon_sym_COLON,
    ACTIONS(1145), 1,
      anon_sym_PIPE,
    ACTIONS(1151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE_PIPE,
    STATE(556), 1,
      sym_argument_list,
    STATE(802), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1143), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1149), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1141), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1147), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1135), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [32796] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(841), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [32849] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(841), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [32900] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32949] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(841), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32996] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_LF,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1085), 1,
      anon_sym_PIPE_PIPE,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1023), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_literal_value,
    ACTIONS(600), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 18,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33096] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(292), 1,
      anon_sym_LF,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1051), 1,
      anon_sym_LBRACK,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1061), 1,
      anon_sym_LT_DASH,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    STATE(756), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(297), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [33157] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1109), 1,
      anon_sym_LPAREN,
    ACTIONS(1111), 1,
      anon_sym_COMMA,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1117), 1,
      anon_sym_STAR,
    ACTIONS(1119), 1,
      anon_sym_LBRACK,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1125), 1,
      anon_sym_LT_DASH,
    ACTIONS(1159), 1,
      anon_sym_LF,
    ACTIONS(1163), 1,
      anon_sym_EQ,
    STATE(720), 1,
      aux_sym_const_spec_repeat1,
    STATE(1161), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1161), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [33224] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_LF,
    ACTIONS(937), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33260] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LF,
    ACTIONS(893), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33296] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_LF,
    ACTIONS(965), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33332] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(959), 1,
      anon_sym_LF,
    ACTIONS(961), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33368] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(947), 1,
      anon_sym_LF,
    ACTIONS(949), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33404] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_LF,
    ACTIONS(901), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33440] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_LF,
    ACTIONS(600), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33476] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_LF,
    ACTIONS(957), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33512] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(967), 1,
      anon_sym_LF,
    ACTIONS(969), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33548] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_LF,
    ACTIONS(953), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33584] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(787), 1,
      anon_sym_LF,
    ACTIONS(789), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33620] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_LF,
    ACTIONS(945), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33656] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(883), 1,
      anon_sym_LF,
    ACTIONS(885), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33692] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_LF,
    ACTIONS(941), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33728] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_LF,
    ACTIONS(881), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    STATE(556), 1,
      sym_special_argument_list,
    ACTIONS(600), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 19,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33804] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_LF,
    ACTIONS(897), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(837), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(835), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33884] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LF,
    ACTIONS(849), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33920] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(867), 1,
      anon_sym_LF,
    ACTIONS(869), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33956] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_LF,
    ACTIONS(785), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33992] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1167), 1,
      anon_sym_LF,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1169), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34046] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1171), 1,
      anon_sym_LF,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1173), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34100] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(1143), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(841), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1135), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 12,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34148] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(859), 1,
      anon_sym_LF,
    ACTIONS(861), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34184] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_PIPE,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(1143), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1141), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(841), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1135), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 9,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34236] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_LF,
    ACTIONS(973), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34272] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_PIPE,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1143), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1149), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1141), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1147), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(839), 5,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1135), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34328] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_PIPE,
    ACTIONS(1151), 1,
      anon_sym_AMP_AMP,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1143), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1149), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1141), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(839), 4,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1135), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34386] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1023), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1021), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34446] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_LF,
    ACTIONS(857), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34482] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(887), 1,
      anon_sym_LF,
    ACTIONS(889), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34518] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(811), 1,
      anon_sym_LF,
    ACTIONS(813), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34554] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_LF,
    ACTIONS(865), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_DOT,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    STATE(556), 1,
      sym_argument_list,
    ACTIONS(841), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(839), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34634] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(871), 1,
      anon_sym_LF,
    ACTIONS(873), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34670] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_LF,
    ACTIONS(877), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34706] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(983), 1,
      anon_sym_LF,
    ACTIONS(985), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34742] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(979), 1,
      anon_sym_LF,
    ACTIONS(981), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34778] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_LF,
    ACTIONS(853), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34814] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(815), 1,
      anon_sym_LF,
    ACTIONS(817), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34850] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(903), 1,
      anon_sym_LF,
    ACTIONS(905), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34886] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(975), 1,
      anon_sym_LF,
    ACTIONS(977), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34922] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_DOT,
    ACTIONS(1071), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1177), 1,
      anon_sym_LF,
    STATE(507), 1,
      sym_argument_list,
    ACTIONS(1079), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1179), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1081), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1075), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(899), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(935), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35046] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1133), 1,
      anon_sym_COMMA,
    ACTIONS(1181), 1,
      anon_sym_DOT,
    ACTIONS(1185), 1,
      anon_sym_LBRACE,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(802), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35109] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(986), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(967), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35207] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1223), 1,
      anon_sym_RPAREN,
    ACTIONS(1225), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(984), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(975), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(963), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(947), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(871), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(955), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(971), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35480] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(995), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_COLON,
    STATE(432), 1,
      sym_literal_value,
    ACTIONS(600), 5,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35525] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    STATE(781), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(292), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [35582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(959), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35617] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
    ACTIONS(1239), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1013), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(943), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(875), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(951), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35785] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
    ACTIONS(1243), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1031), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(855), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35883] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
    ACTIONS(1247), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(987), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(895), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(849), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(847), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(815), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36086] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    ACTIONS(1251), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1010), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(813), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(811), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36184] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1133), 1,
      anon_sym_COMMA,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(802), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(919), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(863), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(859), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(887), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(885), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(883), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(879), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(867), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(783), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(939), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(891), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(905), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(903), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    ACTIONS(602), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    STATE(432), 1,
      sym_literal_value,
    ACTIONS(600), 5,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(851), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(979), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(983), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(789), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(787), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36778] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(839), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36832] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(839), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DOT,
    ACTIONS(998), 1,
      anon_sym_LPAREN,
    STATE(432), 1,
      sym_literal_value,
    ACTIONS(600), 5,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 18,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36924] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(839), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36978] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37028] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(841), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37074] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
    ACTIONS(1259), 1,
      anon_sym_COMMA,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1000), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37136] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(841), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 12,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37182] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1263), 1,
      anon_sym_DOT,
    ACTIONS(1265), 1,
      anon_sym_COMMA,
    ACTIONS(1268), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(651), 1,
      aux_sym_const_spec_repeat1,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37246] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1270), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    STATE(1009), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37306] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(841), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(839), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37356] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_SEMI,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1133), 1,
      anon_sym_COMMA,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    STATE(802), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37416] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(839), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37468] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_DOT,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1274), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37526] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1276), 1,
      anon_sym_RPAREN,
    ACTIONS(1278), 1,
      anon_sym_COMMA,
    STATE(977), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37588] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1282), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1280), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37646] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    ACTIONS(1286), 1,
      anon_sym_COMMA,
    STATE(958), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37708] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1288), 1,
      anon_sym_RBRACK,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37765] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1292), 1,
      anon_sym_RPAREN,
    ACTIONS(1294), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37822] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1021), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37877] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1296), 1,
      anon_sym_RBRACK,
    ACTIONS(1298), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37934] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1300), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37993] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1302), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [38052] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1304), 1,
      anon_sym_RBRACK,
    ACTIONS(1306), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38109] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1308), 1,
      anon_sym_RPAREN,
    ACTIONS(1310), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38166] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    STATE(805), 1,
      sym_block,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38223] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1312), 1,
      anon_sym_RBRACK,
    ACTIONS(1314), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38280] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1177), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38335] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1316), 1,
      anon_sym_RBRACK,
    ACTIONS(1318), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38392] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1320), 1,
      anon_sym_RBRACK,
    ACTIONS(1322), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38449] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1324), 1,
      anon_sym_RBRACK,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38561] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38616] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1332), 1,
      anon_sym_RBRACK,
    ACTIONS(1334), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [38732] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1338), 1,
      anon_sym_RBRACK,
    ACTIONS(1340), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38789] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1342), 1,
      anon_sym_RBRACK,
    ACTIONS(1344), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38846] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [38905] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1348), 1,
      anon_sym_RBRACK,
    ACTIONS(1350), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38962] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1352), 1,
      anon_sym_RBRACK,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39019] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39078] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    ACTIONS(1360), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39135] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1021), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39190] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1362), 1,
      anon_sym_RBRACK,
    ACTIONS(1364), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39247] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1366), 1,
      anon_sym_RBRACK,
    ACTIONS(1368), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39304] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1370), 1,
      anon_sym_RBRACK,
    ACTIONS(1372), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39361] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1374), 1,
      anon_sym_RPAREN,
    ACTIONS(1376), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39418] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1378), 1,
      anon_sym_RPAREN,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39475] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1382), 1,
      anon_sym_RPAREN,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39534] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    ACTIONS(1386), 1,
      anon_sym_COMMA,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39591] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1388), 1,
      anon_sym_RBRACK,
    ACTIONS(1390), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39648] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_RBRACK,
    ACTIONS(1394), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39705] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1396), 1,
      anon_sym_RBRACK,
    ACTIONS(1398), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39762] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1400), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39816] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1402), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39870] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1253), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1261), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1083), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39926] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39980] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1408), 1,
      anon_sym_COMMA,
    ACTIONS(1410), 1,
      anon_sym_EQ,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(729), 1,
      aux_sym_const_spec_repeat1,
    STATE(803), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40038] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1418), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40092] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1420), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40146] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      anon_sym_RPAREN,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1431), 1,
      anon_sym_LBRACE,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(426), 1,
      sym_block,
    STATE(908), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40204] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40258] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1437), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40312] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1439), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1441), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40420] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40474] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40528] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1408), 1,
      anon_sym_COMMA,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    ACTIONS(1447), 1,
      anon_sym_EQ,
    STATE(615), 1,
      aux_sym_const_spec_repeat1,
    STATE(800), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40586] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1449), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40640] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1451), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1453), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40748] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1455), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40802] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1177), 1,
      anon_sym_LBRACE,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40856] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1457), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40910] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1051), 1,
      anon_sym_LBRACK,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1061), 1,
      anon_sym_LT_DASH,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    ACTIONS(1459), 1,
      anon_sym_LF,
    ACTIONS(1461), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(989), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40966] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_COLON,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41020] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41074] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1467), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41128] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1469), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1189), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1195), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1187), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1193), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1183), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41182] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41236] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41290] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1475), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41344] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1477), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41398] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1479), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41452] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1213), 1,
      anon_sym_PIPE,
    ACTIONS(1219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1211), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1209), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1215), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1207), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1483), 1,
      anon_sym_RBRACK,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41560] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(1485), 1,
      anon_sym_LBRACE,
    STATE(405), 1,
      sym_block,
    STATE(1032), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41615] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    ACTIONS(1487), 1,
      anon_sym_COMMA,
    STATE(734), 1,
      aux_sym_field_name_list_repeat1,
    STATE(816), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41670] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    STATE(353), 1,
      sym_block,
    STATE(1016), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41725] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(292), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(781), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41778] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_block,
    STATE(959), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41833] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(307), 1,
      sym_block,
    STATE(981), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41888] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(1493), 1,
      sym_identifier,
    STATE(307), 1,
      sym_block,
    STATE(981), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41943] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1408), 1,
      anon_sym_COMMA,
    STATE(729), 1,
      aux_sym_const_spec_repeat1,
    STATE(1080), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41998] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_PIPE,
    ACTIONS(1101), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1495), 1,
      anon_sym_DOT,
    STATE(433), 1,
      sym_argument_list,
    ACTIONS(1093), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1099), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1091), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1097), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1089), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42049] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    ACTIONS(1497), 1,
      anon_sym_LBRACE,
    STATE(551), 1,
      sym_block,
    STATE(1004), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42104] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1499), 1,
      anon_sym_type,
    STATE(1167), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42156] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1501), 1,
      anon_sym_type,
    STATE(1110), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42208] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1503), 1,
      anon_sym_type,
    STATE(1110), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42260] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    ACTIONS(1505), 1,
      anon_sym_EQ,
    STATE(886), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42312] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1507), 1,
      anon_sym_type,
    STATE(1110), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42364] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1167), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42413] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(796), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42462] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1115), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42511] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(778), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42560] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1064), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42609] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(979), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42658] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(769), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42707] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1104), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42756] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(748), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42805] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1509), 1,
      anon_sym_LT_DASH,
    STATE(784), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42854] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1517), 1,
      anon_sym_LT_DASH,
    STATE(262), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1519), 1,
      anon_sym_LT_DASH,
    STATE(793), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42952] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1170), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43001] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1163), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43050] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(877), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(952), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43148] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1078), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43197] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1110), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43246] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(596), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(780), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43295] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    STATE(241), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43344] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    STATE(266), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43393] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1139), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43442] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(964), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43491] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1523), 1,
      anon_sym_LT_DASH,
    STATE(758), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43540] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(769), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43589] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    STATE(251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43638] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1158), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43687] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(794), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43736] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1157), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43785] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(772), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43834] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(796), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43883] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(745), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43932] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1108), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43981] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    ACTIONS(1525), 1,
      anon_sym_chan,
    STATE(746), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44030] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1017), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44079] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(743), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44128] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(744), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44177] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1135), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44226] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1169), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44275] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1037), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44324] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1002), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44373] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1433), 1,
      anon_sym_LT_DASH,
    STATE(794), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44422] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1523), 1,
      anon_sym_LT_DASH,
    STATE(747), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44471] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    STATE(269), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44520] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    ACTIONS(1527), 1,
      anon_sym_chan,
    STATE(256), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44569] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1425), 1,
      anon_sym_func,
    ACTIONS(1427), 1,
      anon_sym_STAR,
    ACTIONS(1429), 1,
      anon_sym_LBRACK,
    ACTIONS(1509), 1,
      anon_sym_LT_DASH,
    STATE(793), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44618] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1519), 1,
      anon_sym_LT_DASH,
    STATE(784), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44667] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    ACTIONS(1529), 1,
      anon_sym_chan,
    STATE(780), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44716] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(778), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44765] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1033), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44814] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(772), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44863] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1171), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44912] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 1,
      anon_sym_LT_DASH,
    STATE(239), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44961] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1138), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45010] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LBRACK,
    ACTIONS(1517), 1,
      anon_sym_LT_DASH,
    STATE(274), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(277), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45059] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_func,
    ACTIONS(1053), 1,
      anon_sym_struct,
    ACTIONS(1055), 1,
      anon_sym_interface,
    ACTIONS(1057), 1,
      anon_sym_map,
    ACTIONS(1059), 1,
      anon_sym_chan,
    ACTIONS(1406), 1,
      anon_sym_LPAREN,
    ACTIONS(1412), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_LBRACK,
    ACTIONS(1416), 1,
      anon_sym_LT_DASH,
    STATE(751), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(765), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45108] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1231), 1,
      anon_sym_STAR,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_LT_DASH,
    ACTIONS(1255), 1,
      anon_sym_LPAREN,
    STATE(1127), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(782), 9,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45157] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_LF,
    ACTIONS(741), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45183] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(819), 1,
      anon_sym_LF,
    ACTIONS(821), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45209] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(827), 1,
      anon_sym_LF,
    ACTIONS(829), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45235] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_LF,
    ACTIONS(833), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45261] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1533), 1,
      anon_sym_LF,
    ACTIONS(1535), 1,
      anon_sym_COMMA,
    STATE(720), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1531), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [45291] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1533), 1,
      anon_sym_LF,
    ACTIONS(1531), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [45316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(833), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(831), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [45340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(829), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(827), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [45364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(821), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(819), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [45388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(739), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [45412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_COMMA,
    STATE(727), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1538), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 1,
      anon_sym_COMMA,
    STATE(727), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1021), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1543), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_COMMA,
    STATE(729), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1533), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
    ACTIONS(1531), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [45508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1543), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_EQ,
    ACTIONS(1554), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1543), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1556), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1560), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [45594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      anon_sym_COMMA,
    STATE(734), 1,
      aux_sym_field_name_list_repeat1,
    ACTIONS(1566), 4,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
    ACTIONS(1564), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [45618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1531), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1533), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
  [45638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_LT_DASH,
    ACTIONS(1571), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [45657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 1,
      sym_identifier,
    ACTIONS(1577), 1,
      anon_sym_DOT,
    ACTIONS(1579), 1,
      sym_blank_identifier,
    ACTIONS(1581), 1,
      anon_sym_LPAREN,
    ACTIONS(1583), 1,
      sym_raw_string_literal,
    ACTIONS(1585), 1,
      anon_sym_DQUOTE,
    STATE(260), 1,
      sym_interpreted_string_literal,
    STATE(975), 1,
      sym_dot,
    STATE(264), 2,
      sym_import_spec,
      sym_import_spec_list,
  [45689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1577), 1,
      anon_sym_DOT,
    ACTIONS(1587), 1,
      sym_identifier,
    ACTIONS(1589), 1,
      sym_blank_identifier,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
    ACTIONS(1593), 1,
      sym_raw_string_literal,
    STATE(739), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1024), 1,
      sym_dot,
    STATE(1059), 1,
      sym_interpreted_string_literal,
    STATE(1090), 1,
      sym_import_spec,
  [45723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1577), 1,
      anon_sym_DOT,
    ACTIONS(1587), 1,
      sym_identifier,
    ACTIONS(1589), 1,
      sym_blank_identifier,
    ACTIONS(1593), 1,
      sym_raw_string_literal,
    ACTIONS(1595), 1,
      anon_sym_RPAREN,
    STATE(740), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1024), 1,
      sym_dot,
    STATE(1059), 1,
      sym_interpreted_string_literal,
    STATE(1090), 1,
      sym_import_spec,
  [45757] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      sym_identifier,
    ACTIONS(1600), 1,
      anon_sym_DOT,
    ACTIONS(1603), 1,
      sym_blank_identifier,
    ACTIONS(1606), 1,
      anon_sym_RPAREN,
    ACTIONS(1608), 1,
      sym_raw_string_literal,
    ACTIONS(1611), 1,
      anon_sym_DQUOTE,
    STATE(740), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1024), 1,
      sym_dot,
    STATE(1059), 1,
      sym_interpreted_string_literal,
    STATE(1090), 1,
      sym_import_spec,
  [45791] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(622), 1,
      anon_sym_LF,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(624), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45810] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(701), 1,
      anon_sym_LF,
    ACTIONS(703), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45826] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_LF,
    ACTIONS(687), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45842] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(632), 1,
      anon_sym_LF,
    ACTIONS(634), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45858] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_LF,
    ACTIONS(773), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45874] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_LF,
    ACTIONS(687), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45890] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_LF,
    ACTIONS(687), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45906] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(640), 1,
      anon_sym_LF,
    ACTIONS(642), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45922] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 1,
      anon_sym_LF,
    ACTIONS(749), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45938] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LF,
    ACTIONS(646), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45954] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(759), 1,
      anon_sym_LF,
    ACTIONS(761), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45970] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(648), 1,
      anon_sym_LF,
    ACTIONS(650), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [45986] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(677), 1,
      anon_sym_LF,
    ACTIONS(679), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46002] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_LF,
    ACTIONS(769), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46018] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_LF,
    ACTIONS(699), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46034] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LF,
    ACTIONS(691), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46050] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_LF,
    ACTIONS(695), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46066] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(791), 1,
      anon_sym_LF,
    ACTIONS(793), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46082] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(775), 1,
      anon_sym_LF,
    ACTIONS(777), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46098] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_LF,
    ACTIONS(781), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46114] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_LF,
    ACTIONS(801), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46130] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(807), 1,
      anon_sym_LF,
    ACTIONS(809), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46146] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(652), 1,
      anon_sym_LF,
    ACTIONS(654), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46162] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LF,
    ACTIONS(753), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46178] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LF,
    ACTIONS(805), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46194] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_LF,
    ACTIONS(638), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 1,
      anon_sym_DOT,
    ACTIONS(622), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46226] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_LF,
    ACTIONS(1618), 1,
      anon_sym_SEMI,
    ACTIONS(1620), 1,
      anon_sym_RBRACE,
    STATE(632), 1,
      sym_parameter_list,
    STATE(922), 1,
      aux_sym_method_spec_list_repeat1,
  [46251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(759), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(648), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46303] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_COMMA,
    ACTIONS(1538), 1,
      anon_sym_LF,
    STATE(798), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1622), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46335] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LF,
    ACTIONS(1626), 1,
      anon_sym_SEMI,
    ACTIONS(1628), 1,
      anon_sym_RBRACE,
    STATE(632), 1,
      sym_parameter_list,
    STATE(919), 1,
      aux_sym_method_spec_list_repeat1,
  [46360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(771), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(775), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(652), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(791), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(640), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46607] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1630), 1,
      anon_sym_LF,
    ACTIONS(1634), 1,
      sym_raw_string_literal,
    STATE(1006), 1,
      sym_interpreted_string_literal,
    ACTIONS(1632), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [46630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [46643] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    ACTIONS(1636), 1,
      anon_sym_LF,
    ACTIONS(1638), 1,
      anon_sym_SEMI,
    ACTIONS(1640), 1,
      anon_sym_RBRACE,
    STATE(632), 1,
      sym_parameter_list,
    STATE(921), 1,
      aux_sym_method_spec_list_repeat1,
  [46668] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_LF,
    ACTIONS(1642), 1,
      anon_sym_COMMA,
    STATE(798), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1023), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_RBRACE,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    STATE(817), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [46705] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1651), 1,
      anon_sym_LF,
    ACTIONS(1655), 1,
      anon_sym_EQ,
    ACTIONS(1653), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1657), 1,
      anon_sym_RBRACE,
    STATE(817), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [46739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 1,
      anon_sym_COMMA,
    ACTIONS(1622), 1,
      anon_sym_COLON,
    STATE(815), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1538), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [46757] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_LF,
    ACTIONS(1663), 1,
      anon_sym_EQ,
    ACTIONS(1661), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 1,
      anon_sym_RBRACE,
    ACTIONS(1667), 1,
      anon_sym_case,
    ACTIONS(1670), 1,
      anon_sym_default,
    STATE(804), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [46791] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_LF,
    ACTIONS(1677), 1,
      anon_sym_else,
    ACTIONS(1675), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_RBRACE,
    ACTIONS(1681), 1,
      anon_sym_case,
    ACTIONS(1684), 1,
      anon_sym_default,
    STATE(806), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [46825] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1687), 1,
      anon_sym_LF,
    ACTIONS(1691), 1,
      sym_raw_string_literal,
    STATE(1005), 1,
      sym_interpreted_string_literal,
    ACTIONS(1689), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [46845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1693), 1,
      anon_sym_RBRACE,
    ACTIONS(1695), 1,
      anon_sym_case,
    STATE(819), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [46863] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1697), 1,
      anon_sym_LF,
    ACTIONS(1701), 1,
      sym_raw_string_literal,
    STATE(999), 1,
      sym_interpreted_string_literal,
    ACTIONS(1699), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [46883] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1703), 1,
      anon_sym_LF,
    ACTIONS(1707), 1,
      sym_raw_string_literal,
    STATE(1029), 1,
      sym_interpreted_string_literal,
    ACTIONS(1705), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [46903] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1709), 1,
      anon_sym_LF,
    ACTIONS(1711), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(202), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(1606), 4,
      anon_sym_DOT,
      anon_sym_RPAREN,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [46935] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1715), 1,
      anon_sym_LF,
    ACTIONS(1718), 1,
      anon_sym_SEMI,
    STATE(813), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1721), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [46953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1723), 1,
      anon_sym_RBRACE,
    STATE(799), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [46971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_COLON,
    ACTIONS(1725), 1,
      anon_sym_COMMA,
    STATE(815), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1021), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [46989] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1728), 1,
      anon_sym_LF,
    ACTIONS(1732), 1,
      sym_raw_string_literal,
    STATE(973), 1,
      sym_interpreted_string_literal,
    ACTIONS(1730), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [47009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(1736), 1,
      anon_sym_case,
    ACTIONS(1739), 1,
      anon_sym_default,
    STATE(817), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1742), 1,
      anon_sym_RBRACE,
    STATE(801), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1695), 1,
      anon_sym_case,
    ACTIONS(1744), 1,
      anon_sym_RBRACE,
    STATE(806), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [47063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1746), 1,
      anon_sym_RBRACE,
    ACTIONS(1748), 1,
      anon_sym_case,
    STATE(804), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [47081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1750), 1,
      anon_sym_RBRACE,
    STATE(827), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47099] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1752), 1,
      sym_identifier,
    ACTIONS(1754), 1,
      anon_sym_LF,
    ACTIONS(1756), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1748), 1,
      anon_sym_case,
    ACTIONS(1758), 1,
      anon_sym_RBRACE,
    STATE(820), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [47133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1760), 1,
      anon_sym_RBRACE,
    STATE(817), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47151] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_DOT,
    ACTIONS(1157), 1,
      anon_sym_LPAREN,
    ACTIONS(1762), 1,
      anon_sym_LF,
    STATE(632), 1,
      sym_parameter_list,
    ACTIONS(1764), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [47171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1766), 1,
      anon_sym_RBRACE,
    STATE(824), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_case,
    ACTIONS(1649), 1,
      anon_sym_default,
    ACTIONS(1768), 1,
      anon_sym_RBRACE,
    STATE(817), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [47207] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1770), 1,
      sym_identifier,
    ACTIONS(1772), 1,
      anon_sym_LF,
    ACTIONS(1774), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47223] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1776), 1,
      anon_sym_LF,
    ACTIONS(1778), 1,
      anon_sym_SEMI,
    STATE(811), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1780), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47241] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_LF,
    ACTIONS(1786), 1,
      anon_sym_else,
    ACTIONS(1784), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47257] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_LF,
    ACTIONS(1790), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47270] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1792), 1,
      anon_sym_LF,
    ACTIONS(1794), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [47302] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1802), 1,
      anon_sym_LF,
    ACTIONS(1804), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47315] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_LF,
    ACTIONS(1808), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47328] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1810), 1,
      anon_sym_LF,
    ACTIONS(1812), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47341] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LF,
    ACTIONS(1816), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47354] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_LF,
    ACTIONS(1820), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47367] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1822), 1,
      anon_sym_LF,
    ACTIONS(1824), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47380] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LF,
    ACTIONS(1828), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47393] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_LF,
    ACTIONS(1832), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47406] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LF,
    ACTIONS(1836), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1838), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(926), 1,
      sym_field_declaration,
  [47438] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1840), 1,
      anon_sym_LF,
    ACTIONS(1842), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47451] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_LF,
    ACTIONS(1846), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47464] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_LF,
    ACTIONS(1850), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47477] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LF,
    ACTIONS(1854), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47490] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_LF,
    ACTIONS(1858), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47503] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_LF,
    ACTIONS(1862), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47516] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1864), 1,
      anon_sym_LF,
    ACTIONS(1866), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47529] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1868), 1,
      anon_sym_LF,
    ACTIONS(1870), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47542] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LF,
    ACTIONS(1874), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1876), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_field_declaration,
  [47574] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1878), 1,
      anon_sym_LF,
    ACTIONS(1880), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1882), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [47606] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1884), 1,
      anon_sym_LF,
    ACTIONS(1886), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47619] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1888), 1,
      anon_sym_LF,
    ACTIONS(1890), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1892), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(942), 1,
      sym_field_declaration,
  [47651] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1894), 1,
      anon_sym_LF,
    ACTIONS(1896), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47664] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_LF,
    ACTIONS(707), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47677] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1898), 1,
      anon_sym_LF,
    ACTIONS(1900), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47690] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LF,
    ACTIONS(1904), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47703] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      sym_identifier,
    ACTIONS(1908), 1,
      anon_sym_RPAREN,
    STATE(876), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1103), 2,
      sym_type_alias,
      sym_type_spec,
  [47720] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_LF,
    ACTIONS(1912), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47733] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_LF,
    ACTIONS(1916), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47746] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_LF,
    ACTIONS(1920), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47759] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_LF,
    ACTIONS(1924), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47772] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_LF,
    ACTIONS(1721), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47785] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1928), 1,
      anon_sym_LF,
    ACTIONS(1930), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47798] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1932), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [47817] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1934), 1,
      anon_sym_LF,
    ACTIONS(1936), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47830] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_LF,
    ACTIONS(1940), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(1942), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [47862] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_LF,
    ACTIONS(1946), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47875] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1948), 1,
      anon_sym_LF,
    ACTIONS(1950), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      sym_identifier,
    ACTIONS(1952), 1,
      anon_sym_RPAREN,
    STATE(884), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1103), 2,
      sym_type_alias,
      sym_type_spec,
  [47905] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1954), 1,
      anon_sym_LF,
    ACTIONS(1956), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47918] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1958), 1,
      anon_sym_LF,
    ACTIONS(1960), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47931] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1962), 1,
      anon_sym_LF,
    ACTIONS(1964), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47944] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1966), 1,
      anon_sym_LF,
    ACTIONS(1968), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47957] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1970), 1,
      anon_sym_LF,
    ACTIONS(1972), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47970] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1974), 1,
      anon_sym_LF,
    ACTIONS(1976), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47983] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_LF,
    ACTIONS(1980), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [47996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 1,
      sym_identifier,
    ACTIONS(1985), 1,
      anon_sym_RPAREN,
    STATE(884), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1103), 2,
      sym_type_alias,
      sym_type_spec,
  [48013] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LF,
    ACTIONS(1989), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [48026] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_LF,
    ACTIONS(1993), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [48039] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LF,
    ACTIONS(1997), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [48052] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LF,
    ACTIONS(2001), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [48065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(2003), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [48084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    ACTIONS(2005), 1,
      anon_sym_RBRACE,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [48103] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2007), 1,
      anon_sym_LF,
    ACTIONS(2009), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [48116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2013), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_STAR,
    STATE(810), 1,
      sym_qualified_type,
    STATE(1035), 1,
      sym_field_declaration,
  [48146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48160] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LF,
    ACTIONS(2019), 1,
      anon_sym_SEMI,
    ACTIONS(2021), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_if,
    STATE(859), 2,
      sym_block,
      sym_if_statement,
  [48190] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym_LF,
    ACTIONS(2027), 1,
      anon_sym_SEMI,
    ACTIONS(2029), 1,
      anon_sym_RBRACE,
    STATE(937), 1,
      aux_sym_field_declaration_list_repeat1,
  [48206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2031), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2033), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48234] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_DQUOTE,
    STATE(911), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2037), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48248] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2039), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48262] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2043), 1,
      anon_sym_DQUOTE,
    STATE(903), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2045), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48276] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2047), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 1,
      sym_identifier,
    ACTIONS(2051), 1,
      anon_sym_RPAREN,
    STATE(924), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1039), 1,
      sym_var_spec,
  [48306] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2053), 1,
      anon_sym_LF,
    ACTIONS(2055), 1,
      anon_sym_SEMI,
    ACTIONS(2057), 1,
      anon_sym_RBRACE,
    STATE(895), 1,
      aux_sym_method_spec_list_repeat1,
  [48322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    STATE(906), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1039), 1,
      sym_var_spec,
  [48338] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LF,
    ACTIONS(2066), 1,
      anon_sym_SEMI,
    ACTIONS(2068), 1,
      anon_sym_RBRACE,
    STATE(897), 1,
      aux_sym_field_declaration_list_repeat1,
  [48354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_block,
    ACTIONS(689), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [48368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2070), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48396] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2074), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      anon_sym_LBRACE,
    ACTIONS(1614), 1,
      anon_sym_DOT,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parameter_list,
  [48426] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LF,
    ACTIONS(2080), 1,
      anon_sym_SEMI,
    ACTIONS(2082), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48442] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2084), 1,
      anon_sym_LF,
    ACTIONS(2087), 1,
      anon_sym_SEMI,
    ACTIONS(2090), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48458] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2092), 1,
      anon_sym_DQUOTE,
    STATE(932), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2094), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48472] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_LF,
    ACTIONS(2098), 1,
      anon_sym_SEMI,
    ACTIONS(2100), 1,
      anon_sym_RBRACE,
    STATE(937), 1,
      aux_sym_field_declaration_list_repeat1,
  [48488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2102), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2104), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48516] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_LF,
    ACTIONS(2108), 1,
      anon_sym_SEMI,
    ACTIONS(2110), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_RPAREN,
    STATE(936), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1075), 1,
      sym_const_spec,
  [48548] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LF,
    ACTIONS(2118), 1,
      anon_sym_SEMI,
    ACTIONS(2120), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48564] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2122), 1,
      anon_sym_LF,
    ACTIONS(2124), 1,
      anon_sym_SEMI,
    ACTIONS(2126), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2128), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_RPAREN,
    STATE(906), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1039), 1,
      sym_var_spec,
  [48610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym_identifier,
    ACTIONS(2135), 1,
      anon_sym_RPAREN,
    STATE(925), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1075), 1,
      sym_const_spec,
  [48626] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_LF,
    ACTIONS(2139), 1,
      anon_sym_SEMI,
    ACTIONS(2141), 1,
      anon_sym_RBRACE,
    STATE(916), 1,
      aux_sym_field_declaration_list_repeat1,
  [48642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48656] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_DQUOTE,
    STATE(938), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2147), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48670] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2149), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2151), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    ACTIONS(2153), 1,
      anon_sym_RBRACE,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [48712] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2155), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      sym_identifier,
    ACTIONS(2159), 1,
      anon_sym_RBRACE,
    STATE(944), 2,
      sym_method_spec,
      sym_qualified_type,
  [48740] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2161), 1,
      anon_sym_LF,
    ACTIONS(2163), 1,
      anon_sym_SEMI,
    ACTIONS(2165), 1,
      anon_sym_RBRACE,
    STATE(935), 1,
      aux_sym_method_spec_list_repeat1,
  [48756] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2167), 1,
      anon_sym_LF,
    ACTIONS(2169), 1,
      anon_sym_SEMI,
    ACTIONS(2171), 1,
      anon_sym_RBRACE,
    STATE(914), 1,
      aux_sym_method_spec_list_repeat1,
  [48772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      sym_identifier,
    ACTIONS(2173), 1,
      anon_sym_RPAREN,
    STATE(925), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1075), 1,
      sym_const_spec,
  [48788] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_LF,
    ACTIONS(2178), 1,
      anon_sym_SEMI,
    ACTIONS(2181), 1,
      anon_sym_RBRACE,
    STATE(937), 1,
      aux_sym_field_declaration_list_repeat1,
  [48804] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      sym_identifier,
    ACTIONS(2187), 1,
      anon_sym_RBRACE,
    STATE(905), 2,
      sym_method_spec,
      sym_qualified_type,
  [48832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2023), 1,
      anon_sym_if,
    STATE(878), 2,
      sym_block,
      sym_if_statement,
  [48846] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2189), 1,
      anon_sym_DQUOTE,
    STATE(901), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2191), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48860] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2193), 1,
      anon_sym_LF,
    ACTIONS(2195), 1,
      anon_sym_SEMI,
    ACTIONS(2197), 1,
      anon_sym_RBRACE,
    STATE(951), 1,
      aux_sym_field_declaration_list_repeat1,
  [48876] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2041), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48890] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LF,
    ACTIONS(2203), 1,
      anon_sym_SEMI,
    ACTIONS(2205), 1,
      anon_sym_RBRACE,
    STATE(913), 1,
      aux_sym_method_spec_list_repeat1,
  [48906] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2207), 1,
      anon_sym_DQUOTE,
    STATE(943), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2209), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_literal_value,
    ACTIONS(803), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [48934] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_DQUOTE,
    STATE(929), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2213), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      sym_identifier,
    ACTIONS(2215), 1,
      anon_sym_LPAREN,
    STATE(852), 2,
      sym_type_alias,
      sym_type_spec,
  [48962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      sym_identifier,
    ACTIONS(2219), 1,
      anon_sym_RBRACE,
    STATE(934), 2,
      sym_method_spec,
      sym_qualified_type,
  [48976] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DQUOTE,
    STATE(950), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2223), 2,
      aux_sym_interpreted_string_literal_token1,
      sym_escape_sequence,
  [48990] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LF,
    ACTIONS(2228), 1,
      anon_sym_SEMI,
    ACTIONS(2230), 1,
      anon_sym_RBRACE,
    STATE(937), 1,
      aux_sym_field_declaration_list_repeat1,
  [49006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_RPAREN,
    ACTIONS(2234), 1,
      anon_sym_COMMA,
    STATE(991), 1,
      aux_sym_expression_list_repeat1,
  [49019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 1,
      anon_sym_COLON,
    ACTIONS(1280), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      sym_identifier,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
    STATE(887), 1,
      sym_const_spec,
  [49043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_var_spec,
  [49056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      sym_identifier,
    STATE(650), 1,
      sym_parameter_list,
  [49069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      anon_sym_RPAREN,
    ACTIONS(2246), 1,
      anon_sym_COMMA,
    STATE(972), 1,
      aux_sym_parameter_list_repeat1,
  [49091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_block,
  [49104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 1,
      anon_sym_COMMA,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    STATE(960), 1,
      aux_sym_type_case_repeat1,
  [49117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2253), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_LBRACE,
    ACTIONS(2255), 1,
      anon_sym_COMMA,
    STATE(962), 1,
      aux_sym_expression_list_repeat1,
  [49139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LPAREN,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    STATE(296), 1,
      sym_literal_value,
  [49152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_RPAREN,
    ACTIONS(2262), 1,
      anon_sym_COMMA,
    STATE(980), 1,
      aux_sym_expression_list_repeat1,
  [49165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_COMMA,
    ACTIONS(2266), 1,
      anon_sym_RBRACE,
    STATE(982), 1,
      aux_sym_literal_value_repeat1,
  [49178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LPAREN,
    ACTIONS(2270), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_literal_value,
  [49200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_argument_list_repeat1,
  [49213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      anon_sym_COMMA,
    ACTIONS(2274), 1,
      anon_sym_COLON,
    STATE(960), 1,
      aux_sym_type_case_repeat1,
  [49226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      sym_identifier,
    STATE(993), 2,
      sym_method_spec,
      sym_qualified_type,
  [49246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
    ACTIONS(2278), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym_parameter_list_repeat1,
  [49259] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2280), 1,
      anon_sym_LF,
    ACTIONS(2282), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_RPAREN,
    ACTIONS(2284), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 1,
      anon_sym_DQUOTE,
    ACTIONS(2287), 1,
      sym_raw_string_literal,
    STATE(245), 1,
      sym_interpreted_string_literal,
  [49296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 1,
      anon_sym_DQUOTE,
    ACTIONS(2289), 1,
      sym_raw_string_literal,
    STATE(247), 1,
      sym_interpreted_string_literal,
  [49309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 1,
      anon_sym_RPAREN,
    ACTIONS(2293), 1,
      anon_sym_COMMA,
    STATE(1026), 1,
      aux_sym_parameter_list_repeat1,
  [49322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_COMMA,
    ACTIONS(2298), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      anon_sym_COMMA,
    ACTIONS(2300), 1,
      anon_sym_COLON,
    STATE(969), 1,
      aux_sym_type_case_repeat1,
  [49348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 1,
      anon_sym_RPAREN,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    STATE(317), 1,
      sym_block,
  [49374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    ACTIONS(2304), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(458), 1,
      anon_sym_RPAREN,
    ACTIONS(2308), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_RBRACE,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    ACTIONS(2312), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_RPAREN,
    ACTIONS(2314), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    ACTIONS(2316), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49461] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_LF,
    ACTIONS(2320), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    ACTIONS(2322), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    ACTIONS(2324), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    ACTIONS(2326), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym_parameter_list_repeat1,
  [49511] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_LF,
    ACTIONS(2090), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2333), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
    ACTIONS(1247), 1,
      anon_sym_COMMA,
    STATE(987), 1,
      aux_sym_argument_list_repeat1,
  [49557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_RPAREN,
    ACTIONS(1225), 1,
      anon_sym_COMMA,
    STATE(984), 1,
      aux_sym_argument_list_repeat1,
  [49570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_COMMA,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    STATE(990), 1,
      aux_sym_literal_value_repeat1,
  [49583] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_LF,
    ACTIONS(2341), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_RPAREN,
    ACTIONS(2345), 1,
      anon_sym_COMMA,
    STATE(992), 1,
      aux_sym_parameter_list_repeat1,
  [49607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    ACTIONS(2349), 1,
      anon_sym_RBRACE,
    STATE(985), 1,
      aux_sym_literal_value_repeat1,
  [49620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_RPAREN,
    ACTIONS(2353), 1,
      anon_sym_COMMA,
    STATE(988), 1,
      aux_sym_expression_list_repeat1,
  [49633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LPAREN,
    ACTIONS(2355), 1,
      anon_sym_LBRACE,
    STATE(348), 1,
      sym_literal_value,
  [49646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_LBRACE,
    STATE(532), 1,
      sym_block,
  [49659] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2357), 1,
      anon_sym_LF,
    ACTIONS(2359), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49670] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_LF,
    ACTIONS(2363), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_RPAREN,
    ACTIONS(2367), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym_parameter_list_repeat1,
  [49694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_literal_value,
  [49707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1270), 1,
      anon_sym_COMMA,
    ACTIONS(1538), 1,
      anon_sym_LBRACE,
    STATE(962), 1,
      aux_sym_expression_list_repeat1,
  [49720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 1,
      anon_sym_RPAREN,
    ACTIONS(2370), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 1,
      anon_sym_RBRACE,
    ACTIONS(2372), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    ACTIONS(2374), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    ACTIONS(2376), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [49772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_RBRACE,
    ACTIONS(2378), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
    ACTIONS(2380), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    STATE(367), 1,
      sym_block,
  [49811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
    ACTIONS(2384), 1,
      anon_sym_COMMA,
    STATE(1025), 1,
      aux_sym_expression_list_repeat1,
  [49824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      anon_sym_COMMA,
    ACTIONS(2388), 1,
      anon_sym_RBRACE,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [49837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_COMMA,
    ACTIONS(2392), 1,
      anon_sym_RBRACE,
    STATE(1011), 1,
      aux_sym_literal_value_repeat1,
  [49850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    ACTIONS(1251), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_argument_list_repeat1,
  [49863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
    ACTIONS(1243), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      aux_sym_argument_list_repeat1,
  [49876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(204), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2394), 1,
      sym_raw_string_literal,
    STATE(1042), 1,
      sym_interpreted_string_literal,
  [49898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2396), 1,
      sym_raw_string_literal,
    STATE(1043), 1,
      sym_interpreted_string_literal,
  [49911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 1,
      anon_sym_RPAREN,
    ACTIONS(2398), 1,
      anon_sym_COMMA,
    STATE(994), 1,
      aux_sym_expression_list_repeat1,
  [49924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 1,
      anon_sym_RPAREN,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    STATE(1007), 1,
      aux_sym_parameter_list_repeat1,
  [49937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_RBRACE,
    ACTIONS(2402), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_literal_value_repeat1,
  [49950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
    ACTIONS(1239), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_argument_list_repeat1,
  [49963] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_LF,
    ACTIONS(2406), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_LBRACE,
    STATE(410), 1,
      sym_literal_value,
  [49987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 1,
      anon_sym_RPAREN,
    ACTIONS(2408), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_argument_list_repeat1,
  [50000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(1485), 1,
      anon_sym_LBRACE,
    STATE(380), 1,
      sym_block,
  [50013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_RPAREN,
    ACTIONS(2412), 1,
      anon_sym_COMMA,
    STATE(1015), 1,
      aux_sym_expression_list_repeat1,
  [50026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    ACTIONS(2416), 1,
      anon_sym_RBRACE,
    STATE(1014), 1,
      aux_sym_literal_value_repeat1,
  [50039] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_LF,
    ACTIONS(2181), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50050] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_LF,
    ACTIONS(2422), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_RPAREN,
    ACTIONS(2426), 1,
      anon_sym_COMMA,
    STATE(1012), 1,
      aux_sym_expression_list_repeat1,
  [50074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
  [50084] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_LF,
    ACTIONS(2434), 1,
      anon_sym_SEMI,
  [50094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    STATE(840), 1,
      sym_block,
  [50104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [50112] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_LF,
    ACTIONS(666), 1,
      anon_sym_SEMI,
  [50122] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(656), 1,
      anon_sym_LF,
    ACTIONS(658), 1,
      anon_sym_SEMI,
  [50132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(653), 1,
      sym_parameter_list,
  [50142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LBRACE,
    STATE(774), 1,
      sym_field_declaration_list,
  [50152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_method_spec_list,
  [50162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(761), 1,
      sym_field_declaration_list,
  [50172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1970), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [50180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      sym_identifier,
    ACTIONS(2444), 1,
      anon_sym_LPAREN,
  [50190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [50198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [50206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LBRACE,
    STATE(776), 1,
      sym_method_spec_list,
  [50216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_LBRACE,
    STATE(410), 1,
      sym_literal_value,
  [50226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [50242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [50250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      sym_identifier,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
  [50260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(644), 1,
      sym_parameter_list,
  [50270] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_LF,
    ACTIONS(745), 1,
      anon_sym_SEMI,
  [50280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(647), 1,
      sym_parameter_list,
  [50290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [50298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_LBRACE,
    STATE(271), 1,
      sym_method_spec_list,
  [50308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(646), 1,
      sym_parameter_list,
  [50318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [50326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(648), 1,
      sym_parameter_list,
  [50336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
  [50346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_LPAREN,
    STATE(468), 1,
      sym_parameter_list,
  [50356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(527), 1,
      sym_parameter_list,
  [50366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [50374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 1,
      anon_sym_LBRACE,
    STATE(296), 1,
      sym_literal_value,
  [50384] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(672), 1,
      anon_sym_LF,
    ACTIONS(2462), 1,
      anon_sym_SEMI,
  [50394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_literal_value,
  [50404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN,
  [50414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_LBRACE,
    STATE(276), 1,
      sym_field_declaration_list,
  [50424] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_LF,
    ACTIONS(2470), 1,
      anon_sym_SEMI,
  [50434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(649), 1,
      sym_parameter_list,
  [50452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      sym_identifier,
    ACTIONS(2478), 1,
      anon_sym_LPAREN,
  [50470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 2,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [50486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_literal_value,
  [50496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_literal_value,
  [50514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(771), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [50522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 1,
      sym_identifier,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
  [50540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parameter_list,
  [50550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50558] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_LF,
    ACTIONS(2492), 1,
      anon_sym_SEMI,
  [50568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_LBRACE,
    STATE(348), 1,
      sym_literal_value,
  [50578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      anon_sym_LPAREN,
    STATE(618), 1,
      sym_parameter_list,
  [50596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [50604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_LPAREN,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
  [50614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      sym_identifier,
    STATE(807), 1,
      sym_qualified_type,
  [50624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN,
  [50642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym_parameter_list,
  [50660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(2504), 1,
      anon_sym_LPAREN,
  [50670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN,
  [50680] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_LF,
    ACTIONS(2510), 1,
      anon_sym_SEMI,
  [50690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [50698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      anon_sym_RBRACE,
  [50705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 1,
      anon_sym_RPAREN,
  [50712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      anon_sym_LBRACE,
  [50719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_RPAREN,
  [50726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
  [50733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
  [50740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_RPAREN,
  [50747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_RPAREN,
  [50754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 1,
      anon_sym_RPAREN,
  [50761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      sym_identifier,
  [50768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      anon_sym_RBRACK,
  [50775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_LBRACE,
  [50782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_RPAREN,
  [50789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 1,
      anon_sym_RBRACE,
  [50796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_chan,
  [50803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      anon_sym_RBRACE,
  [50810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      sym_identifier,
  [50817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_RBRACE,
  [50824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_SEMI,
  [50831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_RBRACK,
  [50838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      sym_identifier,
  [50845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_EQ,
  [50852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_RPAREN,
  [50859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      sym_identifier,
  [50866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      anon_sym_RPAREN,
  [50873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_LBRACE,
  [50880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      sym_identifier,
  [50887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_RBRACE,
  [50894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_COLON,
  [50901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      anon_sym_chan,
  [50908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_RBRACK,
  [50915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_RPAREN,
  [50922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_COLON_EQ,
  [50929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
  [50936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_RBRACK,
  [50943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_LPAREN,
  [50950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_RPAREN,
  [50957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_RPAREN,
  [50964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_RPAREN,
  [50971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_LBRACE,
  [50978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_RPAREN,
  [50985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_LBRACE,
  [50992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      ts_builtin_sym_end,
  [50999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
  [51006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      anon_sym_LBRACE,
  [51013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_COLON,
  [51020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_RBRACE,
  [51027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      sym_identifier,
  [51034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_chan,
  [51041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      anon_sym_LBRACE,
  [51048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_LBRACE,
  [51055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      sym_identifier,
  [51062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_RPAREN,
  [51069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_LBRACE,
  [51076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 1,
      anon_sym_RBRACE,
  [51083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_LBRACK,
  [51090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_EQ,
  [51097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_COLON,
  [51104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
  [51111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      anon_sym_LBRACE,
  [51118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      anon_sym_RPAREN,
  [51125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_SEMI,
  [51132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
  [51139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_chan,
  [51146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      anon_sym_RBRACK,
  [51153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_RPAREN,
  [51160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      anon_sym_RPAREN,
  [51167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      sym_identifier,
  [51174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      anon_sym_LBRACK,
  [51181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_LPAREN,
  [51188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_SEMI,
  [51195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_LBRACK,
  [51202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_LPAREN,
  [51209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_LPAREN,
  [51216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_LPAREN,
  [51223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 1,
      anon_sym_LPAREN,
  [51230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACK,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(22)] = 0,
  [SMALL_STATE(23)] = 116,
  [SMALL_STATE(24)] = 229,
  [SMALL_STATE(25)] = 342,
  [SMALL_STATE(26)] = 455,
  [SMALL_STATE(27)] = 568,
  [SMALL_STATE(28)] = 662,
  [SMALL_STATE(29)] = 772,
  [SMALL_STATE(30)] = 866,
  [SMALL_STATE(31)] = 955,
  [SMALL_STATE(32)] = 1062,
  [SMALL_STATE(33)] = 1172,
  [SMALL_STATE(34)] = 1282,
  [SMALL_STATE(35)] = 1392,
  [SMALL_STATE(36)] = 1502,
  [SMALL_STATE(37)] = 1612,
  [SMALL_STATE(38)] = 1722,
  [SMALL_STATE(39)] = 1832,
  [SMALL_STATE(40)] = 1942,
  [SMALL_STATE(41)] = 2052,
  [SMALL_STATE(42)] = 2162,
  [SMALL_STATE(43)] = 2272,
  [SMALL_STATE(44)] = 2382,
  [SMALL_STATE(45)] = 2492,
  [SMALL_STATE(46)] = 2602,
  [SMALL_STATE(47)] = 2712,
  [SMALL_STATE(48)] = 2822,
  [SMALL_STATE(49)] = 2932,
  [SMALL_STATE(50)] = 3042,
  [SMALL_STATE(51)] = 3149,
  [SMALL_STATE(52)] = 3253,
  [SMALL_STATE(53)] = 3356,
  [SMALL_STATE(54)] = 3459,
  [SMALL_STATE(55)] = 3562,
  [SMALL_STATE(56)] = 3665,
  [SMALL_STATE(57)] = 3768,
  [SMALL_STATE(58)] = 3871,
  [SMALL_STATE(59)] = 3974,
  [SMALL_STATE(60)] = 4077,
  [SMALL_STATE(61)] = 4180,
  [SMALL_STATE(62)] = 4283,
  [SMALL_STATE(63)] = 4386,
  [SMALL_STATE(64)] = 4489,
  [SMALL_STATE(65)] = 4592,
  [SMALL_STATE(66)] = 4695,
  [SMALL_STATE(67)] = 4798,
  [SMALL_STATE(68)] = 4901,
  [SMALL_STATE(69)] = 5004,
  [SMALL_STATE(70)] = 5107,
  [SMALL_STATE(71)] = 5210,
  [SMALL_STATE(72)] = 5313,
  [SMALL_STATE(73)] = 5416,
  [SMALL_STATE(74)] = 5519,
  [SMALL_STATE(75)] = 5622,
  [SMALL_STATE(76)] = 5725,
  [SMALL_STATE(77)] = 5825,
  [SMALL_STATE(78)] = 5925,
  [SMALL_STATE(79)] = 6025,
  [SMALL_STATE(80)] = 6125,
  [SMALL_STATE(81)] = 6225,
  [SMALL_STATE(82)] = 6325,
  [SMALL_STATE(83)] = 6425,
  [SMALL_STATE(84)] = 6525,
  [SMALL_STATE(85)] = 6625,
  [SMALL_STATE(86)] = 6725,
  [SMALL_STATE(87)] = 6825,
  [SMALL_STATE(88)] = 6925,
  [SMALL_STATE(89)] = 7025,
  [SMALL_STATE(90)] = 7125,
  [SMALL_STATE(91)] = 7225,
  [SMALL_STATE(92)] = 7325,
  [SMALL_STATE(93)] = 7425,
  [SMALL_STATE(94)] = 7525,
  [SMALL_STATE(95)] = 7625,
  [SMALL_STATE(96)] = 7725,
  [SMALL_STATE(97)] = 7825,
  [SMALL_STATE(98)] = 7925,
  [SMALL_STATE(99)] = 8025,
  [SMALL_STATE(100)] = 8125,
  [SMALL_STATE(101)] = 8225,
  [SMALL_STATE(102)] = 8325,
  [SMALL_STATE(103)] = 8425,
  [SMALL_STATE(104)] = 8525,
  [SMALL_STATE(105)] = 8625,
  [SMALL_STATE(106)] = 8725,
  [SMALL_STATE(107)] = 8825,
  [SMALL_STATE(108)] = 8925,
  [SMALL_STATE(109)] = 9025,
  [SMALL_STATE(110)] = 9125,
  [SMALL_STATE(111)] = 9225,
  [SMALL_STATE(112)] = 9325,
  [SMALL_STATE(113)] = 9425,
  [SMALL_STATE(114)] = 9525,
  [SMALL_STATE(115)] = 9625,
  [SMALL_STATE(116)] = 9725,
  [SMALL_STATE(117)] = 9825,
  [SMALL_STATE(118)] = 9925,
  [SMALL_STATE(119)] = 10025,
  [SMALL_STATE(120)] = 10125,
  [SMALL_STATE(121)] = 10225,
  [SMALL_STATE(122)] = 10325,
  [SMALL_STATE(123)] = 10425,
  [SMALL_STATE(124)] = 10525,
  [SMALL_STATE(125)] = 10625,
  [SMALL_STATE(126)] = 10725,
  [SMALL_STATE(127)] = 10825,
  [SMALL_STATE(128)] = 10925,
  [SMALL_STATE(129)] = 11025,
  [SMALL_STATE(130)] = 11122,
  [SMALL_STATE(131)] = 11219,
  [SMALL_STATE(132)] = 11316,
  [SMALL_STATE(133)] = 11413,
  [SMALL_STATE(134)] = 11510,
  [SMALL_STATE(135)] = 11607,
  [SMALL_STATE(136)] = 11704,
  [SMALL_STATE(137)] = 11801,
  [SMALL_STATE(138)] = 11898,
  [SMALL_STATE(139)] = 11995,
  [SMALL_STATE(140)] = 12092,
  [SMALL_STATE(141)] = 12189,
  [SMALL_STATE(142)] = 12286,
  [SMALL_STATE(143)] = 12383,
  [SMALL_STATE(144)] = 12480,
  [SMALL_STATE(145)] = 12577,
  [SMALL_STATE(146)] = 12674,
  [SMALL_STATE(147)] = 12771,
  [SMALL_STATE(148)] = 12868,
  [SMALL_STATE(149)] = 12965,
  [SMALL_STATE(150)] = 13062,
  [SMALL_STATE(151)] = 13159,
  [SMALL_STATE(152)] = 13256,
  [SMALL_STATE(153)] = 13353,
  [SMALL_STATE(154)] = 13450,
  [SMALL_STATE(155)] = 13547,
  [SMALL_STATE(156)] = 13644,
  [SMALL_STATE(157)] = 13741,
  [SMALL_STATE(158)] = 13838,
  [SMALL_STATE(159)] = 13935,
  [SMALL_STATE(160)] = 14032,
  [SMALL_STATE(161)] = 14129,
  [SMALL_STATE(162)] = 14226,
  [SMALL_STATE(163)] = 14323,
  [SMALL_STATE(164)] = 14420,
  [SMALL_STATE(165)] = 14517,
  [SMALL_STATE(166)] = 14614,
  [SMALL_STATE(167)] = 14711,
  [SMALL_STATE(168)] = 14808,
  [SMALL_STATE(169)] = 14905,
  [SMALL_STATE(170)] = 15002,
  [SMALL_STATE(171)] = 15099,
  [SMALL_STATE(172)] = 15196,
  [SMALL_STATE(173)] = 15293,
  [SMALL_STATE(174)] = 15390,
  [SMALL_STATE(175)] = 15487,
  [SMALL_STATE(176)] = 15584,
  [SMALL_STATE(177)] = 15681,
  [SMALL_STATE(178)] = 15778,
  [SMALL_STATE(179)] = 15875,
  [SMALL_STATE(180)] = 15972,
  [SMALL_STATE(181)] = 16069,
  [SMALL_STATE(182)] = 16166,
  [SMALL_STATE(183)] = 16263,
  [SMALL_STATE(184)] = 16360,
  [SMALL_STATE(185)] = 16457,
  [SMALL_STATE(186)] = 16554,
  [SMALL_STATE(187)] = 16651,
  [SMALL_STATE(188)] = 16748,
  [SMALL_STATE(189)] = 16845,
  [SMALL_STATE(190)] = 16942,
  [SMALL_STATE(191)] = 17039,
  [SMALL_STATE(192)] = 17136,
  [SMALL_STATE(193)] = 17233,
  [SMALL_STATE(194)] = 17330,
  [SMALL_STATE(195)] = 17427,
  [SMALL_STATE(196)] = 17524,
  [SMALL_STATE(197)] = 17621,
  [SMALL_STATE(198)] = 17718,
  [SMALL_STATE(199)] = 17815,
  [SMALL_STATE(200)] = 17912,
  [SMALL_STATE(201)] = 18009,
  [SMALL_STATE(202)] = 18106,
  [SMALL_STATE(203)] = 18203,
  [SMALL_STATE(204)] = 18300,
  [SMALL_STATE(205)] = 18397,
  [SMALL_STATE(206)] = 18494,
  [SMALL_STATE(207)] = 18591,
  [SMALL_STATE(208)] = 18688,
  [SMALL_STATE(209)] = 18785,
  [SMALL_STATE(210)] = 18882,
  [SMALL_STATE(211)] = 18979,
  [SMALL_STATE(212)] = 19076,
  [SMALL_STATE(213)] = 19173,
  [SMALL_STATE(214)] = 19270,
  [SMALL_STATE(215)] = 19367,
  [SMALL_STATE(216)] = 19464,
  [SMALL_STATE(217)] = 19561,
  [SMALL_STATE(218)] = 19658,
  [SMALL_STATE(219)] = 19755,
  [SMALL_STATE(220)] = 19852,
  [SMALL_STATE(221)] = 19949,
  [SMALL_STATE(222)] = 20046,
  [SMALL_STATE(223)] = 20143,
  [SMALL_STATE(224)] = 20240,
  [SMALL_STATE(225)] = 20337,
  [SMALL_STATE(226)] = 20434,
  [SMALL_STATE(227)] = 20531,
  [SMALL_STATE(228)] = 20628,
  [SMALL_STATE(229)] = 20725,
  [SMALL_STATE(230)] = 20822,
  [SMALL_STATE(231)] = 20919,
  [SMALL_STATE(232)] = 21016,
  [SMALL_STATE(233)] = 21113,
  [SMALL_STATE(234)] = 21178,
  [SMALL_STATE(235)] = 21243,
  [SMALL_STATE(236)] = 21302,
  [SMALL_STATE(237)] = 21361,
  [SMALL_STATE(238)] = 21418,
  [SMALL_STATE(239)] = 21472,
  [SMALL_STATE(240)] = 21526,
  [SMALL_STATE(241)] = 21580,
  [SMALL_STATE(242)] = 21634,
  [SMALL_STATE(243)] = 21688,
  [SMALL_STATE(244)] = 21742,
  [SMALL_STATE(245)] = 21796,
  [SMALL_STATE(246)] = 21850,
  [SMALL_STATE(247)] = 21904,
  [SMALL_STATE(248)] = 21958,
  [SMALL_STATE(249)] = 22016,
  [SMALL_STATE(250)] = 22070,
  [SMALL_STATE(251)] = 22124,
  [SMALL_STATE(252)] = 22178,
  [SMALL_STATE(253)] = 22232,
  [SMALL_STATE(254)] = 22286,
  [SMALL_STATE(255)] = 22340,
  [SMALL_STATE(256)] = 22394,
  [SMALL_STATE(257)] = 22448,
  [SMALL_STATE(258)] = 22532,
  [SMALL_STATE(259)] = 22586,
  [SMALL_STATE(260)] = 22640,
  [SMALL_STATE(261)] = 22694,
  [SMALL_STATE(262)] = 22748,
  [SMALL_STATE(263)] = 22802,
  [SMALL_STATE(264)] = 22856,
  [SMALL_STATE(265)] = 22910,
  [SMALL_STATE(266)] = 22972,
  [SMALL_STATE(267)] = 23026,
  [SMALL_STATE(268)] = 23080,
  [SMALL_STATE(269)] = 23134,
  [SMALL_STATE(270)] = 23188,
  [SMALL_STATE(271)] = 23242,
  [SMALL_STATE(272)] = 23296,
  [SMALL_STATE(273)] = 23350,
  [SMALL_STATE(274)] = 23404,
  [SMALL_STATE(275)] = 23458,
  [SMALL_STATE(276)] = 23512,
  [SMALL_STATE(277)] = 23566,
  [SMALL_STATE(278)] = 23620,
  [SMALL_STATE(279)] = 23674,
  [SMALL_STATE(280)] = 23728,
  [SMALL_STATE(281)] = 23782,
  [SMALL_STATE(282)] = 23836,
  [SMALL_STATE(283)] = 23890,
  [SMALL_STATE(284)] = 23944,
  [SMALL_STATE(285)] = 23998,
  [SMALL_STATE(286)] = 24051,
  [SMALL_STATE(287)] = 24112,
  [SMALL_STATE(288)] = 24165,
  [SMALL_STATE(289)] = 24228,
  [SMALL_STATE(290)] = 24285,
  [SMALL_STATE(291)] = 24354,
  [SMALL_STATE(292)] = 24407,
  [SMALL_STATE(293)] = 24474,
  [SMALL_STATE(294)] = 24539,
  [SMALL_STATE(295)] = 24600,
  [SMALL_STATE(296)] = 24652,
  [SMALL_STATE(297)] = 24704,
  [SMALL_STATE(298)] = 24756,
  [SMALL_STATE(299)] = 24808,
  [SMALL_STATE(300)] = 24860,
  [SMALL_STATE(301)] = 24912,
  [SMALL_STATE(302)] = 24964,
  [SMALL_STATE(303)] = 25016,
  [SMALL_STATE(304)] = 25068,
  [SMALL_STATE(305)] = 25120,
  [SMALL_STATE(306)] = 25172,
  [SMALL_STATE(307)] = 25224,
  [SMALL_STATE(308)] = 25276,
  [SMALL_STATE(309)] = 25328,
  [SMALL_STATE(310)] = 25380,
  [SMALL_STATE(311)] = 25432,
  [SMALL_STATE(312)] = 25484,
  [SMALL_STATE(313)] = 25572,
  [SMALL_STATE(314)] = 25624,
  [SMALL_STATE(315)] = 25676,
  [SMALL_STATE(316)] = 25728,
  [SMALL_STATE(317)] = 25780,
  [SMALL_STATE(318)] = 25832,
  [SMALL_STATE(319)] = 25884,
  [SMALL_STATE(320)] = 25936,
  [SMALL_STATE(321)] = 25988,
  [SMALL_STATE(322)] = 26040,
  [SMALL_STATE(323)] = 26092,
  [SMALL_STATE(324)] = 26144,
  [SMALL_STATE(325)] = 26196,
  [SMALL_STATE(326)] = 26248,
  [SMALL_STATE(327)] = 26300,
  [SMALL_STATE(328)] = 26388,
  [SMALL_STATE(329)] = 26473,
  [SMALL_STATE(330)] = 26555,
  [SMALL_STATE(331)] = 26613,
  [SMALL_STATE(332)] = 26667,
  [SMALL_STATE(333)] = 26725,
  [SMALL_STATE(334)] = 26785,
  [SMALL_STATE(335)] = 26847,
  [SMALL_STATE(336)] = 26903,
  [SMALL_STATE(337)] = 26969,
  [SMALL_STATE(338)] = 27037,
  [SMALL_STATE(339)] = 27086,
  [SMALL_STATE(340)] = 27135,
  [SMALL_STATE(341)] = 27184,
  [SMALL_STATE(342)] = 27233,
  [SMALL_STATE(343)] = 27282,
  [SMALL_STATE(344)] = 27331,
  [SMALL_STATE(345)] = 27380,
  [SMALL_STATE(346)] = 27429,
  [SMALL_STATE(347)] = 27478,
  [SMALL_STATE(348)] = 27527,
  [SMALL_STATE(349)] = 27576,
  [SMALL_STATE(350)] = 27625,
  [SMALL_STATE(351)] = 27674,
  [SMALL_STATE(352)] = 27723,
  [SMALL_STATE(353)] = 27772,
  [SMALL_STATE(354)] = 27821,
  [SMALL_STATE(355)] = 27870,
  [SMALL_STATE(356)] = 27919,
  [SMALL_STATE(357)] = 27968,
  [SMALL_STATE(358)] = 28017,
  [SMALL_STATE(359)] = 28066,
  [SMALL_STATE(360)] = 28115,
  [SMALL_STATE(361)] = 28164,
  [SMALL_STATE(362)] = 28213,
  [SMALL_STATE(363)] = 28262,
  [SMALL_STATE(364)] = 28311,
  [SMALL_STATE(365)] = 28360,
  [SMALL_STATE(366)] = 28409,
  [SMALL_STATE(367)] = 28458,
  [SMALL_STATE(368)] = 28507,
  [SMALL_STATE(369)] = 28556,
  [SMALL_STATE(370)] = 28605,
  [SMALL_STATE(371)] = 28654,
  [SMALL_STATE(372)] = 28708,
  [SMALL_STATE(373)] = 28757,
  [SMALL_STATE(374)] = 28812,
  [SMALL_STATE(375)] = 28869,
  [SMALL_STATE(376)] = 28922,
  [SMALL_STATE(377)] = 28983,
  [SMALL_STATE(378)] = 29046,
  [SMALL_STATE(379)] = 29099,
  [SMALL_STATE(380)] = 29164,
  [SMALL_STATE(381)] = 29208,
  [SMALL_STATE(382)] = 29252,
  [SMALL_STATE(383)] = 29296,
  [SMALL_STATE(384)] = 29340,
  [SMALL_STATE(385)] = 29384,
  [SMALL_STATE(386)] = 29428,
  [SMALL_STATE(387)] = 29472,
  [SMALL_STATE(388)] = 29516,
  [SMALL_STATE(389)] = 29560,
  [SMALL_STATE(390)] = 29604,
  [SMALL_STATE(391)] = 29648,
  [SMALL_STATE(392)] = 29692,
  [SMALL_STATE(393)] = 29736,
  [SMALL_STATE(394)] = 29780,
  [SMALL_STATE(395)] = 29824,
  [SMALL_STATE(396)] = 29868,
  [SMALL_STATE(397)] = 29912,
  [SMALL_STATE(398)] = 29956,
  [SMALL_STATE(399)] = 30000,
  [SMALL_STATE(400)] = 30044,
  [SMALL_STATE(401)] = 30088,
  [SMALL_STATE(402)] = 30132,
  [SMALL_STATE(403)] = 30176,
  [SMALL_STATE(404)] = 30220,
  [SMALL_STATE(405)] = 30264,
  [SMALL_STATE(406)] = 30308,
  [SMALL_STATE(407)] = 30352,
  [SMALL_STATE(408)] = 30396,
  [SMALL_STATE(409)] = 30440,
  [SMALL_STATE(410)] = 30484,
  [SMALL_STATE(411)] = 30528,
  [SMALL_STATE(412)] = 30572,
  [SMALL_STATE(413)] = 30616,
  [SMALL_STATE(414)] = 30665,
  [SMALL_STATE(415)] = 30710,
  [SMALL_STATE(416)] = 30759,
  [SMALL_STATE(417)] = 30799,
  [SMALL_STATE(418)] = 30839,
  [SMALL_STATE(419)] = 30879,
  [SMALL_STATE(420)] = 30919,
  [SMALL_STATE(421)] = 30967,
  [SMALL_STATE(422)] = 31007,
  [SMALL_STATE(423)] = 31047,
  [SMALL_STATE(424)] = 31087,
  [SMALL_STATE(425)] = 31127,
  [SMALL_STATE(426)] = 31167,
  [SMALL_STATE(427)] = 31207,
  [SMALL_STATE(428)] = 31247,
  [SMALL_STATE(429)] = 31287,
  [SMALL_STATE(430)] = 31327,
  [SMALL_STATE(431)] = 31367,
  [SMALL_STATE(432)] = 31407,
  [SMALL_STATE(433)] = 31447,
  [SMALL_STATE(434)] = 31487,
  [SMALL_STATE(435)] = 31527,
  [SMALL_STATE(436)] = 31567,
  [SMALL_STATE(437)] = 31607,
  [SMALL_STATE(438)] = 31647,
  [SMALL_STATE(439)] = 31687,
  [SMALL_STATE(440)] = 31727,
  [SMALL_STATE(441)] = 31767,
  [SMALL_STATE(442)] = 31807,
  [SMALL_STATE(443)] = 31847,
  [SMALL_STATE(444)] = 31887,
  [SMALL_STATE(445)] = 31927,
  [SMALL_STATE(446)] = 31967,
  [SMALL_STATE(447)] = 32007,
  [SMALL_STATE(448)] = 32047,
  [SMALL_STATE(449)] = 32087,
  [SMALL_STATE(450)] = 32127,
  [SMALL_STATE(451)] = 32201,
  [SMALL_STATE(452)] = 32247,
  [SMALL_STATE(453)] = 32307,
  [SMALL_STATE(454)] = 32367,
  [SMALL_STATE(455)] = 32425,
  [SMALL_STATE(456)] = 32479,
  [SMALL_STATE(457)] = 32529,
  [SMALL_STATE(458)] = 32574,
  [SMALL_STATE(459)] = 32641,
  [SMALL_STATE(460)] = 32686,
  [SMALL_STATE(461)] = 32727,
  [SMALL_STATE(462)] = 32796,
  [SMALL_STATE(463)] = 32849,
  [SMALL_STATE(464)] = 32900,
  [SMALL_STATE(465)] = 32949,
  [SMALL_STATE(466)] = 32996,
  [SMALL_STATE(467)] = 33051,
  [SMALL_STATE(468)] = 33096,
  [SMALL_STATE(469)] = 33157,
  [SMALL_STATE(470)] = 33224,
  [SMALL_STATE(471)] = 33260,
  [SMALL_STATE(472)] = 33296,
  [SMALL_STATE(473)] = 33332,
  [SMALL_STATE(474)] = 33368,
  [SMALL_STATE(475)] = 33404,
  [SMALL_STATE(476)] = 33440,
  [SMALL_STATE(477)] = 33476,
  [SMALL_STATE(478)] = 33512,
  [SMALL_STATE(479)] = 33548,
  [SMALL_STATE(480)] = 33584,
  [SMALL_STATE(481)] = 33620,
  [SMALL_STATE(482)] = 33656,
  [SMALL_STATE(483)] = 33692,
  [SMALL_STATE(484)] = 33728,
  [SMALL_STATE(485)] = 33764,
  [SMALL_STATE(486)] = 33804,
  [SMALL_STATE(487)] = 33840,
  [SMALL_STATE(488)] = 33884,
  [SMALL_STATE(489)] = 33920,
  [SMALL_STATE(490)] = 33956,
  [SMALL_STATE(491)] = 33992,
  [SMALL_STATE(492)] = 34046,
  [SMALL_STATE(493)] = 34100,
  [SMALL_STATE(494)] = 34148,
  [SMALL_STATE(495)] = 34184,
  [SMALL_STATE(496)] = 34236,
  [SMALL_STATE(497)] = 34272,
  [SMALL_STATE(498)] = 34328,
  [SMALL_STATE(499)] = 34386,
  [SMALL_STATE(500)] = 34446,
  [SMALL_STATE(501)] = 34482,
  [SMALL_STATE(502)] = 34518,
  [SMALL_STATE(503)] = 34554,
  [SMALL_STATE(504)] = 34590,
  [SMALL_STATE(505)] = 34634,
  [SMALL_STATE(506)] = 34670,
  [SMALL_STATE(507)] = 34706,
  [SMALL_STATE(508)] = 34742,
  [SMALL_STATE(509)] = 34778,
  [SMALL_STATE(510)] = 34814,
  [SMALL_STATE(511)] = 34850,
  [SMALL_STATE(512)] = 34886,
  [SMALL_STATE(513)] = 34922,
  [SMALL_STATE(514)] = 34976,
  [SMALL_STATE(515)] = 35011,
  [SMALL_STATE(516)] = 35046,
  [SMALL_STATE(517)] = 35109,
  [SMALL_STATE(518)] = 35172,
  [SMALL_STATE(519)] = 35207,
  [SMALL_STATE(520)] = 35270,
  [SMALL_STATE(521)] = 35305,
  [SMALL_STATE(522)] = 35340,
  [SMALL_STATE(523)] = 35375,
  [SMALL_STATE(524)] = 35410,
  [SMALL_STATE(525)] = 35445,
  [SMALL_STATE(526)] = 35480,
  [SMALL_STATE(527)] = 35525,
  [SMALL_STATE(528)] = 35582,
  [SMALL_STATE(529)] = 35617,
  [SMALL_STATE(530)] = 35680,
  [SMALL_STATE(531)] = 35715,
  [SMALL_STATE(532)] = 35750,
  [SMALL_STATE(533)] = 35785,
  [SMALL_STATE(534)] = 35848,
  [SMALL_STATE(535)] = 35883,
  [SMALL_STATE(536)] = 35946,
  [SMALL_STATE(537)] = 35981,
  [SMALL_STATE(538)] = 36016,
  [SMALL_STATE(539)] = 36051,
  [SMALL_STATE(540)] = 36086,
  [SMALL_STATE(541)] = 36149,
  [SMALL_STATE(542)] = 36184,
  [SMALL_STATE(543)] = 36245,
  [SMALL_STATE(544)] = 36280,
  [SMALL_STATE(545)] = 36315,
  [SMALL_STATE(546)] = 36350,
  [SMALL_STATE(547)] = 36385,
  [SMALL_STATE(548)] = 36420,
  [SMALL_STATE(549)] = 36455,
  [SMALL_STATE(550)] = 36490,
  [SMALL_STATE(551)] = 36525,
  [SMALL_STATE(552)] = 36560,
  [SMALL_STATE(553)] = 36595,
  [SMALL_STATE(554)] = 36638,
  [SMALL_STATE(555)] = 36673,
  [SMALL_STATE(556)] = 36708,
  [SMALL_STATE(557)] = 36743,
  [SMALL_STATE(558)] = 36778,
  [SMALL_STATE(559)] = 36832,
  [SMALL_STATE(560)] = 36884,
  [SMALL_STATE(561)] = 36924,
  [SMALL_STATE(562)] = 36978,
  [SMALL_STATE(563)] = 37028,
  [SMALL_STATE(564)] = 37074,
  [SMALL_STATE(565)] = 37136,
  [SMALL_STATE(566)] = 37182,
  [SMALL_STATE(567)] = 37246,
  [SMALL_STATE(568)] = 37306,
  [SMALL_STATE(569)] = 37356,
  [SMALL_STATE(570)] = 37416,
  [SMALL_STATE(571)] = 37468,
  [SMALL_STATE(572)] = 37526,
  [SMALL_STATE(573)] = 37588,
  [SMALL_STATE(574)] = 37646,
  [SMALL_STATE(575)] = 37708,
  [SMALL_STATE(576)] = 37765,
  [SMALL_STATE(577)] = 37822,
  [SMALL_STATE(578)] = 37877,
  [SMALL_STATE(579)] = 37934,
  [SMALL_STATE(580)] = 37993,
  [SMALL_STATE(581)] = 38052,
  [SMALL_STATE(582)] = 38109,
  [SMALL_STATE(583)] = 38166,
  [SMALL_STATE(584)] = 38223,
  [SMALL_STATE(585)] = 38280,
  [SMALL_STATE(586)] = 38335,
  [SMALL_STATE(587)] = 38392,
  [SMALL_STATE(588)] = 38449,
  [SMALL_STATE(589)] = 38506,
  [SMALL_STATE(590)] = 38561,
  [SMALL_STATE(591)] = 38616,
  [SMALL_STATE(592)] = 38673,
  [SMALL_STATE(593)] = 38732,
  [SMALL_STATE(594)] = 38789,
  [SMALL_STATE(595)] = 38846,
  [SMALL_STATE(596)] = 38905,
  [SMALL_STATE(597)] = 38962,
  [SMALL_STATE(598)] = 39019,
  [SMALL_STATE(599)] = 39078,
  [SMALL_STATE(600)] = 39135,
  [SMALL_STATE(601)] = 39190,
  [SMALL_STATE(602)] = 39247,
  [SMALL_STATE(603)] = 39304,
  [SMALL_STATE(604)] = 39361,
  [SMALL_STATE(605)] = 39418,
  [SMALL_STATE(606)] = 39475,
  [SMALL_STATE(607)] = 39534,
  [SMALL_STATE(608)] = 39591,
  [SMALL_STATE(609)] = 39648,
  [SMALL_STATE(610)] = 39705,
  [SMALL_STATE(611)] = 39762,
  [SMALL_STATE(612)] = 39816,
  [SMALL_STATE(613)] = 39870,
  [SMALL_STATE(614)] = 39926,
  [SMALL_STATE(615)] = 39980,
  [SMALL_STATE(616)] = 40038,
  [SMALL_STATE(617)] = 40092,
  [SMALL_STATE(618)] = 40146,
  [SMALL_STATE(619)] = 40204,
  [SMALL_STATE(620)] = 40258,
  [SMALL_STATE(621)] = 40312,
  [SMALL_STATE(622)] = 40366,
  [SMALL_STATE(623)] = 40420,
  [SMALL_STATE(624)] = 40474,
  [SMALL_STATE(625)] = 40528,
  [SMALL_STATE(626)] = 40586,
  [SMALL_STATE(627)] = 40640,
  [SMALL_STATE(628)] = 40694,
  [SMALL_STATE(629)] = 40748,
  [SMALL_STATE(630)] = 40802,
  [SMALL_STATE(631)] = 40856,
  [SMALL_STATE(632)] = 40910,
  [SMALL_STATE(633)] = 40966,
  [SMALL_STATE(634)] = 41020,
  [SMALL_STATE(635)] = 41074,
  [SMALL_STATE(636)] = 41128,
  [SMALL_STATE(637)] = 41182,
  [SMALL_STATE(638)] = 41236,
  [SMALL_STATE(639)] = 41290,
  [SMALL_STATE(640)] = 41344,
  [SMALL_STATE(641)] = 41398,
  [SMALL_STATE(642)] = 41452,
  [SMALL_STATE(643)] = 41506,
  [SMALL_STATE(644)] = 41560,
  [SMALL_STATE(645)] = 41615,
  [SMALL_STATE(646)] = 41670,
  [SMALL_STATE(647)] = 41725,
  [SMALL_STATE(648)] = 41778,
  [SMALL_STATE(649)] = 41833,
  [SMALL_STATE(650)] = 41888,
  [SMALL_STATE(651)] = 41943,
  [SMALL_STATE(652)] = 41998,
  [SMALL_STATE(653)] = 42049,
  [SMALL_STATE(654)] = 42104,
  [SMALL_STATE(655)] = 42156,
  [SMALL_STATE(656)] = 42208,
  [SMALL_STATE(657)] = 42260,
  [SMALL_STATE(658)] = 42312,
  [SMALL_STATE(659)] = 42364,
  [SMALL_STATE(660)] = 42413,
  [SMALL_STATE(661)] = 42462,
  [SMALL_STATE(662)] = 42511,
  [SMALL_STATE(663)] = 42560,
  [SMALL_STATE(664)] = 42609,
  [SMALL_STATE(665)] = 42658,
  [SMALL_STATE(666)] = 42707,
  [SMALL_STATE(667)] = 42756,
  [SMALL_STATE(668)] = 42805,
  [SMALL_STATE(669)] = 42854,
  [SMALL_STATE(670)] = 42903,
  [SMALL_STATE(671)] = 42952,
  [SMALL_STATE(672)] = 43001,
  [SMALL_STATE(673)] = 43050,
  [SMALL_STATE(674)] = 43099,
  [SMALL_STATE(675)] = 43148,
  [SMALL_STATE(676)] = 43197,
  [SMALL_STATE(677)] = 43246,
  [SMALL_STATE(678)] = 43295,
  [SMALL_STATE(679)] = 43344,
  [SMALL_STATE(680)] = 43393,
  [SMALL_STATE(681)] = 43442,
  [SMALL_STATE(682)] = 43491,
  [SMALL_STATE(683)] = 43540,
  [SMALL_STATE(684)] = 43589,
  [SMALL_STATE(685)] = 43638,
  [SMALL_STATE(686)] = 43687,
  [SMALL_STATE(687)] = 43736,
  [SMALL_STATE(688)] = 43785,
  [SMALL_STATE(689)] = 43834,
  [SMALL_STATE(690)] = 43883,
  [SMALL_STATE(691)] = 43932,
  [SMALL_STATE(692)] = 43981,
  [SMALL_STATE(693)] = 44030,
  [SMALL_STATE(694)] = 44079,
  [SMALL_STATE(695)] = 44128,
  [SMALL_STATE(696)] = 44177,
  [SMALL_STATE(697)] = 44226,
  [SMALL_STATE(698)] = 44275,
  [SMALL_STATE(699)] = 44324,
  [SMALL_STATE(700)] = 44373,
  [SMALL_STATE(701)] = 44422,
  [SMALL_STATE(702)] = 44471,
  [SMALL_STATE(703)] = 44520,
  [SMALL_STATE(704)] = 44569,
  [SMALL_STATE(705)] = 44618,
  [SMALL_STATE(706)] = 44667,
  [SMALL_STATE(707)] = 44716,
  [SMALL_STATE(708)] = 44765,
  [SMALL_STATE(709)] = 44814,
  [SMALL_STATE(710)] = 44863,
  [SMALL_STATE(711)] = 44912,
  [SMALL_STATE(712)] = 44961,
  [SMALL_STATE(713)] = 45010,
  [SMALL_STATE(714)] = 45059,
  [SMALL_STATE(715)] = 45108,
  [SMALL_STATE(716)] = 45157,
  [SMALL_STATE(717)] = 45183,
  [SMALL_STATE(718)] = 45209,
  [SMALL_STATE(719)] = 45235,
  [SMALL_STATE(720)] = 45261,
  [SMALL_STATE(721)] = 45291,
  [SMALL_STATE(722)] = 45316,
  [SMALL_STATE(723)] = 45340,
  [SMALL_STATE(724)] = 45364,
  [SMALL_STATE(725)] = 45388,
  [SMALL_STATE(726)] = 45412,
  [SMALL_STATE(727)] = 45437,
  [SMALL_STATE(728)] = 45462,
  [SMALL_STATE(729)] = 45483,
  [SMALL_STATE(730)] = 45508,
  [SMALL_STATE(731)] = 45529,
  [SMALL_STATE(732)] = 45552,
  [SMALL_STATE(733)] = 45573,
  [SMALL_STATE(734)] = 45594,
  [SMALL_STATE(735)] = 45618,
  [SMALL_STATE(736)] = 45638,
  [SMALL_STATE(737)] = 45657,
  [SMALL_STATE(738)] = 45689,
  [SMALL_STATE(739)] = 45723,
  [SMALL_STATE(740)] = 45757,
  [SMALL_STATE(741)] = 45791,
  [SMALL_STATE(742)] = 45810,
  [SMALL_STATE(743)] = 45826,
  [SMALL_STATE(744)] = 45842,
  [SMALL_STATE(745)] = 45858,
  [SMALL_STATE(746)] = 45874,
  [SMALL_STATE(747)] = 45890,
  [SMALL_STATE(748)] = 45906,
  [SMALL_STATE(749)] = 45922,
  [SMALL_STATE(750)] = 45938,
  [SMALL_STATE(751)] = 45954,
  [SMALL_STATE(752)] = 45970,
  [SMALL_STATE(753)] = 45986,
  [SMALL_STATE(754)] = 46002,
  [SMALL_STATE(755)] = 46018,
  [SMALL_STATE(756)] = 46034,
  [SMALL_STATE(757)] = 46050,
  [SMALL_STATE(758)] = 46066,
  [SMALL_STATE(759)] = 46082,
  [SMALL_STATE(760)] = 46098,
  [SMALL_STATE(761)] = 46114,
  [SMALL_STATE(762)] = 46130,
  [SMALL_STATE(763)] = 46146,
  [SMALL_STATE(764)] = 46162,
  [SMALL_STATE(765)] = 46178,
  [SMALL_STATE(766)] = 46194,
  [SMALL_STATE(767)] = 46210,
  [SMALL_STATE(768)] = 46226,
  [SMALL_STATE(769)] = 46251,
  [SMALL_STATE(770)] = 46264,
  [SMALL_STATE(771)] = 46277,
  [SMALL_STATE(772)] = 46290,
  [SMALL_STATE(773)] = 46303,
  [SMALL_STATE(774)] = 46322,
  [SMALL_STATE(775)] = 46335,
  [SMALL_STATE(776)] = 46360,
  [SMALL_STATE(777)] = 46373,
  [SMALL_STATE(778)] = 46386,
  [SMALL_STATE(779)] = 46399,
  [SMALL_STATE(780)] = 46412,
  [SMALL_STATE(781)] = 46425,
  [SMALL_STATE(782)] = 46438,
  [SMALL_STATE(783)] = 46451,
  [SMALL_STATE(784)] = 46464,
  [SMALL_STATE(785)] = 46477,
  [SMALL_STATE(786)] = 46490,
  [SMALL_STATE(787)] = 46503,
  [SMALL_STATE(788)] = 46516,
  [SMALL_STATE(789)] = 46529,
  [SMALL_STATE(790)] = 46542,
  [SMALL_STATE(791)] = 46555,
  [SMALL_STATE(792)] = 46568,
  [SMALL_STATE(793)] = 46581,
  [SMALL_STATE(794)] = 46594,
  [SMALL_STATE(795)] = 46607,
  [SMALL_STATE(796)] = 46630,
  [SMALL_STATE(797)] = 46643,
  [SMALL_STATE(798)] = 46668,
  [SMALL_STATE(799)] = 46687,
  [SMALL_STATE(800)] = 46705,
  [SMALL_STATE(801)] = 46721,
  [SMALL_STATE(802)] = 46739,
  [SMALL_STATE(803)] = 46757,
  [SMALL_STATE(804)] = 46773,
  [SMALL_STATE(805)] = 46791,
  [SMALL_STATE(806)] = 46807,
  [SMALL_STATE(807)] = 46825,
  [SMALL_STATE(808)] = 46845,
  [SMALL_STATE(809)] = 46863,
  [SMALL_STATE(810)] = 46883,
  [SMALL_STATE(811)] = 46903,
  [SMALL_STATE(812)] = 46921,
  [SMALL_STATE(813)] = 46935,
  [SMALL_STATE(814)] = 46953,
  [SMALL_STATE(815)] = 46971,
  [SMALL_STATE(816)] = 46989,
  [SMALL_STATE(817)] = 47009,
  [SMALL_STATE(818)] = 47027,
  [SMALL_STATE(819)] = 47045,
  [SMALL_STATE(820)] = 47063,
  [SMALL_STATE(821)] = 47081,
  [SMALL_STATE(822)] = 47099,
  [SMALL_STATE(823)] = 47115,
  [SMALL_STATE(824)] = 47133,
  [SMALL_STATE(825)] = 47151,
  [SMALL_STATE(826)] = 47171,
  [SMALL_STATE(827)] = 47189,
  [SMALL_STATE(828)] = 47207,
  [SMALL_STATE(829)] = 47223,
  [SMALL_STATE(830)] = 47241,
  [SMALL_STATE(831)] = 47257,
  [SMALL_STATE(832)] = 47270,
  [SMALL_STATE(833)] = 47283,
  [SMALL_STATE(834)] = 47302,
  [SMALL_STATE(835)] = 47315,
  [SMALL_STATE(836)] = 47328,
  [SMALL_STATE(837)] = 47341,
  [SMALL_STATE(838)] = 47354,
  [SMALL_STATE(839)] = 47367,
  [SMALL_STATE(840)] = 47380,
  [SMALL_STATE(841)] = 47393,
  [SMALL_STATE(842)] = 47406,
  [SMALL_STATE(843)] = 47419,
  [SMALL_STATE(844)] = 47438,
  [SMALL_STATE(845)] = 47451,
  [SMALL_STATE(846)] = 47464,
  [SMALL_STATE(847)] = 47477,
  [SMALL_STATE(848)] = 47490,
  [SMALL_STATE(849)] = 47503,
  [SMALL_STATE(850)] = 47516,
  [SMALL_STATE(851)] = 47529,
  [SMALL_STATE(852)] = 47542,
  [SMALL_STATE(853)] = 47555,
  [SMALL_STATE(854)] = 47574,
  [SMALL_STATE(855)] = 47587,
  [SMALL_STATE(856)] = 47606,
  [SMALL_STATE(857)] = 47619,
  [SMALL_STATE(858)] = 47632,
  [SMALL_STATE(859)] = 47651,
  [SMALL_STATE(860)] = 47664,
  [SMALL_STATE(861)] = 47677,
  [SMALL_STATE(862)] = 47690,
  [SMALL_STATE(863)] = 47703,
  [SMALL_STATE(864)] = 47720,
  [SMALL_STATE(865)] = 47733,
  [SMALL_STATE(866)] = 47746,
  [SMALL_STATE(867)] = 47759,
  [SMALL_STATE(868)] = 47772,
  [SMALL_STATE(869)] = 47785,
  [SMALL_STATE(870)] = 47798,
  [SMALL_STATE(871)] = 47817,
  [SMALL_STATE(872)] = 47830,
  [SMALL_STATE(873)] = 47843,
  [SMALL_STATE(874)] = 47862,
  [SMALL_STATE(875)] = 47875,
  [SMALL_STATE(876)] = 47888,
  [SMALL_STATE(877)] = 47905,
  [SMALL_STATE(878)] = 47918,
  [SMALL_STATE(879)] = 47931,
  [SMALL_STATE(880)] = 47944,
  [SMALL_STATE(881)] = 47957,
  [SMALL_STATE(882)] = 47970,
  [SMALL_STATE(883)] = 47983,
  [SMALL_STATE(884)] = 47996,
  [SMALL_STATE(885)] = 48013,
  [SMALL_STATE(886)] = 48026,
  [SMALL_STATE(887)] = 48039,
  [SMALL_STATE(888)] = 48052,
  [SMALL_STATE(889)] = 48065,
  [SMALL_STATE(890)] = 48084,
  [SMALL_STATE(891)] = 48103,
  [SMALL_STATE(892)] = 48116,
  [SMALL_STATE(893)] = 48130,
  [SMALL_STATE(894)] = 48146,
  [SMALL_STATE(895)] = 48160,
  [SMALL_STATE(896)] = 48176,
  [SMALL_STATE(897)] = 48190,
  [SMALL_STATE(898)] = 48206,
  [SMALL_STATE(899)] = 48220,
  [SMALL_STATE(900)] = 48234,
  [SMALL_STATE(901)] = 48248,
  [SMALL_STATE(902)] = 48262,
  [SMALL_STATE(903)] = 48276,
  [SMALL_STATE(904)] = 48290,
  [SMALL_STATE(905)] = 48306,
  [SMALL_STATE(906)] = 48322,
  [SMALL_STATE(907)] = 48338,
  [SMALL_STATE(908)] = 48354,
  [SMALL_STATE(909)] = 48368,
  [SMALL_STATE(910)] = 48382,
  [SMALL_STATE(911)] = 48396,
  [SMALL_STATE(912)] = 48410,
  [SMALL_STATE(913)] = 48426,
  [SMALL_STATE(914)] = 48442,
  [SMALL_STATE(915)] = 48458,
  [SMALL_STATE(916)] = 48472,
  [SMALL_STATE(917)] = 48488,
  [SMALL_STATE(918)] = 48502,
  [SMALL_STATE(919)] = 48516,
  [SMALL_STATE(920)] = 48532,
  [SMALL_STATE(921)] = 48548,
  [SMALL_STATE(922)] = 48564,
  [SMALL_STATE(923)] = 48580,
  [SMALL_STATE(924)] = 48594,
  [SMALL_STATE(925)] = 48610,
  [SMALL_STATE(926)] = 48626,
  [SMALL_STATE(927)] = 48642,
  [SMALL_STATE(928)] = 48656,
  [SMALL_STATE(929)] = 48670,
  [SMALL_STATE(930)] = 48684,
  [SMALL_STATE(931)] = 48698,
  [SMALL_STATE(932)] = 48712,
  [SMALL_STATE(933)] = 48726,
  [SMALL_STATE(934)] = 48740,
  [SMALL_STATE(935)] = 48756,
  [SMALL_STATE(936)] = 48772,
  [SMALL_STATE(937)] = 48788,
  [SMALL_STATE(938)] = 48804,
  [SMALL_STATE(939)] = 48818,
  [SMALL_STATE(940)] = 48832,
  [SMALL_STATE(941)] = 48846,
  [SMALL_STATE(942)] = 48860,
  [SMALL_STATE(943)] = 48876,
  [SMALL_STATE(944)] = 48890,
  [SMALL_STATE(945)] = 48906,
  [SMALL_STATE(946)] = 48920,
  [SMALL_STATE(947)] = 48934,
  [SMALL_STATE(948)] = 48948,
  [SMALL_STATE(949)] = 48962,
  [SMALL_STATE(950)] = 48976,
  [SMALL_STATE(951)] = 48990,
  [SMALL_STATE(952)] = 49006,
  [SMALL_STATE(953)] = 49019,
  [SMALL_STATE(954)] = 49030,
  [SMALL_STATE(955)] = 49043,
  [SMALL_STATE(956)] = 49056,
  [SMALL_STATE(957)] = 49069,
  [SMALL_STATE(958)] = 49078,
  [SMALL_STATE(959)] = 49091,
  [SMALL_STATE(960)] = 49104,
  [SMALL_STATE(961)] = 49117,
  [SMALL_STATE(962)] = 49126,
  [SMALL_STATE(963)] = 49139,
  [SMALL_STATE(964)] = 49152,
  [SMALL_STATE(965)] = 49165,
  [SMALL_STATE(966)] = 49178,
  [SMALL_STATE(967)] = 49187,
  [SMALL_STATE(968)] = 49200,
  [SMALL_STATE(969)] = 49213,
  [SMALL_STATE(970)] = 49226,
  [SMALL_STATE(971)] = 49235,
  [SMALL_STATE(972)] = 49246,
  [SMALL_STATE(973)] = 49259,
  [SMALL_STATE(974)] = 49270,
  [SMALL_STATE(975)] = 49283,
  [SMALL_STATE(976)] = 49296,
  [SMALL_STATE(977)] = 49309,
  [SMALL_STATE(978)] = 49322,
  [SMALL_STATE(979)] = 49335,
  [SMALL_STATE(980)] = 49348,
  [SMALL_STATE(981)] = 49361,
  [SMALL_STATE(982)] = 49374,
  [SMALL_STATE(983)] = 49387,
  [SMALL_STATE(984)] = 49396,
  [SMALL_STATE(985)] = 49409,
  [SMALL_STATE(986)] = 49422,
  [SMALL_STATE(987)] = 49435,
  [SMALL_STATE(988)] = 49448,
  [SMALL_STATE(989)] = 49461,
  [SMALL_STATE(990)] = 49472,
  [SMALL_STATE(991)] = 49485,
  [SMALL_STATE(992)] = 49498,
  [SMALL_STATE(993)] = 49511,
  [SMALL_STATE(994)] = 49522,
  [SMALL_STATE(995)] = 49535,
  [SMALL_STATE(996)] = 49544,
  [SMALL_STATE(997)] = 49557,
  [SMALL_STATE(998)] = 49570,
  [SMALL_STATE(999)] = 49583,
  [SMALL_STATE(1000)] = 49594,
  [SMALL_STATE(1001)] = 49607,
  [SMALL_STATE(1002)] = 49620,
  [SMALL_STATE(1003)] = 49633,
  [SMALL_STATE(1004)] = 49646,
  [SMALL_STATE(1005)] = 49659,
  [SMALL_STATE(1006)] = 49670,
  [SMALL_STATE(1007)] = 49681,
  [SMALL_STATE(1008)] = 49694,
  [SMALL_STATE(1009)] = 49707,
  [SMALL_STATE(1010)] = 49720,
  [SMALL_STATE(1011)] = 49733,
  [SMALL_STATE(1012)] = 49746,
  [SMALL_STATE(1013)] = 49759,
  [SMALL_STATE(1014)] = 49772,
  [SMALL_STATE(1015)] = 49785,
  [SMALL_STATE(1016)] = 49798,
  [SMALL_STATE(1017)] = 49811,
  [SMALL_STATE(1018)] = 49824,
  [SMALL_STATE(1019)] = 49837,
  [SMALL_STATE(1020)] = 49850,
  [SMALL_STATE(1021)] = 49863,
  [SMALL_STATE(1022)] = 49876,
  [SMALL_STATE(1023)] = 49885,
  [SMALL_STATE(1024)] = 49898,
  [SMALL_STATE(1025)] = 49911,
  [SMALL_STATE(1026)] = 49924,
  [SMALL_STATE(1027)] = 49937,
  [SMALL_STATE(1028)] = 49950,
  [SMALL_STATE(1029)] = 49963,
  [SMALL_STATE(1030)] = 49974,
  [SMALL_STATE(1031)] = 49987,
  [SMALL_STATE(1032)] = 50000,
  [SMALL_STATE(1033)] = 50013,
  [SMALL_STATE(1034)] = 50026,
  [SMALL_STATE(1035)] = 50039,
  [SMALL_STATE(1036)] = 50050,
  [SMALL_STATE(1037)] = 50061,
  [SMALL_STATE(1038)] = 50074,
  [SMALL_STATE(1039)] = 50084,
  [SMALL_STATE(1040)] = 50094,
  [SMALL_STATE(1041)] = 50104,
  [SMALL_STATE(1042)] = 50112,
  [SMALL_STATE(1043)] = 50122,
  [SMALL_STATE(1044)] = 50132,
  [SMALL_STATE(1045)] = 50142,
  [SMALL_STATE(1046)] = 50152,
  [SMALL_STATE(1047)] = 50162,
  [SMALL_STATE(1048)] = 50172,
  [SMALL_STATE(1049)] = 50180,
  [SMALL_STATE(1050)] = 50190,
  [SMALL_STATE(1051)] = 50198,
  [SMALL_STATE(1052)] = 50206,
  [SMALL_STATE(1053)] = 50216,
  [SMALL_STATE(1054)] = 50226,
  [SMALL_STATE(1055)] = 50234,
  [SMALL_STATE(1056)] = 50242,
  [SMALL_STATE(1057)] = 50250,
  [SMALL_STATE(1058)] = 50260,
  [SMALL_STATE(1059)] = 50270,
  [SMALL_STATE(1060)] = 50280,
  [SMALL_STATE(1061)] = 50290,
  [SMALL_STATE(1062)] = 50298,
  [SMALL_STATE(1063)] = 50308,
  [SMALL_STATE(1064)] = 50318,
  [SMALL_STATE(1065)] = 50326,
  [SMALL_STATE(1066)] = 50336,
  [SMALL_STATE(1067)] = 50346,
  [SMALL_STATE(1068)] = 50356,
  [SMALL_STATE(1069)] = 50366,
  [SMALL_STATE(1070)] = 50374,
  [SMALL_STATE(1071)] = 50384,
  [SMALL_STATE(1072)] = 50394,
  [SMALL_STATE(1073)] = 50404,
  [SMALL_STATE(1074)] = 50414,
  [SMALL_STATE(1075)] = 50424,
  [SMALL_STATE(1076)] = 50434,
  [SMALL_STATE(1077)] = 50442,
  [SMALL_STATE(1078)] = 50452,
  [SMALL_STATE(1079)] = 50460,
  [SMALL_STATE(1080)] = 50470,
  [SMALL_STATE(1081)] = 50478,
  [SMALL_STATE(1082)] = 50486,
  [SMALL_STATE(1083)] = 50496,
  [SMALL_STATE(1084)] = 50504,
  [SMALL_STATE(1085)] = 50514,
  [SMALL_STATE(1086)] = 50522,
  [SMALL_STATE(1087)] = 50530,
  [SMALL_STATE(1088)] = 50540,
  [SMALL_STATE(1089)] = 50550,
  [SMALL_STATE(1090)] = 50558,
  [SMALL_STATE(1091)] = 50568,
  [SMALL_STATE(1092)] = 50578,
  [SMALL_STATE(1093)] = 50586,
  [SMALL_STATE(1094)] = 50596,
  [SMALL_STATE(1095)] = 50604,
  [SMALL_STATE(1096)] = 50614,
  [SMALL_STATE(1097)] = 50624,
  [SMALL_STATE(1098)] = 50632,
  [SMALL_STATE(1099)] = 50642,
  [SMALL_STATE(1100)] = 50650,
  [SMALL_STATE(1101)] = 50660,
  [SMALL_STATE(1102)] = 50670,
  [SMALL_STATE(1103)] = 50680,
  [SMALL_STATE(1104)] = 50690,
  [SMALL_STATE(1105)] = 50698,
  [SMALL_STATE(1106)] = 50705,
  [SMALL_STATE(1107)] = 50712,
  [SMALL_STATE(1108)] = 50719,
  [SMALL_STATE(1109)] = 50726,
  [SMALL_STATE(1110)] = 50733,
  [SMALL_STATE(1111)] = 50740,
  [SMALL_STATE(1112)] = 50747,
  [SMALL_STATE(1113)] = 50754,
  [SMALL_STATE(1114)] = 50761,
  [SMALL_STATE(1115)] = 50768,
  [SMALL_STATE(1116)] = 50775,
  [SMALL_STATE(1117)] = 50782,
  [SMALL_STATE(1118)] = 50789,
  [SMALL_STATE(1119)] = 50796,
  [SMALL_STATE(1120)] = 50803,
  [SMALL_STATE(1121)] = 50810,
  [SMALL_STATE(1122)] = 50817,
  [SMALL_STATE(1123)] = 50824,
  [SMALL_STATE(1124)] = 50831,
  [SMALL_STATE(1125)] = 50838,
  [SMALL_STATE(1126)] = 50845,
  [SMALL_STATE(1127)] = 50852,
  [SMALL_STATE(1128)] = 50859,
  [SMALL_STATE(1129)] = 50866,
  [SMALL_STATE(1130)] = 50873,
  [SMALL_STATE(1131)] = 50880,
  [SMALL_STATE(1132)] = 50887,
  [SMALL_STATE(1133)] = 50894,
  [SMALL_STATE(1134)] = 50901,
  [SMALL_STATE(1135)] = 50908,
  [SMALL_STATE(1136)] = 50915,
  [SMALL_STATE(1137)] = 50922,
  [SMALL_STATE(1138)] = 50929,
  [SMALL_STATE(1139)] = 50936,
  [SMALL_STATE(1140)] = 50943,
  [SMALL_STATE(1141)] = 50950,
  [SMALL_STATE(1142)] = 50957,
  [SMALL_STATE(1143)] = 50964,
  [SMALL_STATE(1144)] = 50971,
  [SMALL_STATE(1145)] = 50978,
  [SMALL_STATE(1146)] = 50985,
  [SMALL_STATE(1147)] = 50992,
  [SMALL_STATE(1148)] = 50999,
  [SMALL_STATE(1149)] = 51006,
  [SMALL_STATE(1150)] = 51013,
  [SMALL_STATE(1151)] = 51020,
  [SMALL_STATE(1152)] = 51027,
  [SMALL_STATE(1153)] = 51034,
  [SMALL_STATE(1154)] = 51041,
  [SMALL_STATE(1155)] = 51048,
  [SMALL_STATE(1156)] = 51055,
  [SMALL_STATE(1157)] = 51062,
  [SMALL_STATE(1158)] = 51069,
  [SMALL_STATE(1159)] = 51076,
  [SMALL_STATE(1160)] = 51083,
  [SMALL_STATE(1161)] = 51090,
  [SMALL_STATE(1162)] = 51097,
  [SMALL_STATE(1163)] = 51104,
  [SMALL_STATE(1164)] = 51111,
  [SMALL_STATE(1165)] = 51118,
  [SMALL_STATE(1166)] = 51125,
  [SMALL_STATE(1167)] = 51132,
  [SMALL_STATE(1168)] = 51139,
  [SMALL_STATE(1169)] = 51146,
  [SMALL_STATE(1170)] = 51153,
  [SMALL_STATE(1171)] = 51160,
  [SMALL_STATE(1172)] = 51167,
  [SMALL_STATE(1173)] = 51174,
  [SMALL_STATE(1174)] = 51181,
  [SMALL_STATE(1175)] = 51188,
  [SMALL_STATE(1176)] = 51195,
  [SMALL_STATE(1177)] = 51202,
  [SMALL_STATE(1178)] = 51209,
  [SMALL_STATE(1179)] = 51216,
  [SMALL_STATE(1180)] = 51223,
  [SMALL_STATE(1181)] = 51230,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(233),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(885),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1172),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(737),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(141),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(954),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(955),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(956),
  [99] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(948),
  [102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(174),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(55),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1045),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(14),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1052),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1160),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(704),
  [123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(195),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(845),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(828),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(822),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1152),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(31),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(201),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(202),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(28),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(21),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(22),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1149),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(289),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(215),
  [165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(310),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(941),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(310),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 3, .production_id = 78),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_communication_case, 3, .production_id = 78),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 2),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_case, 2),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 3, .production_id = 36),
  [190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 3, .production_id = 36),
  [192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 91),
  [198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 4, .production_id = 91),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 2),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 2),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 3),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 3),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 24),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 24),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 52),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 51),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 76),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 39),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, .production_id = 39),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(237),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(564),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1088),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(702),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(111),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1074),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1062),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1176),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(713),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1168),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(1114),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 37),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 37),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 62),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 62),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 63),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 63),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, .production_id = 43),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, .production_id = 43),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, .production_id = 70),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, .production_id = 70),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 4),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 4),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 4, .production_id = 48),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 4, .production_id = 48),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 5),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 5),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 13),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 13),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT_REPEAT(291),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 3, .production_id = 25),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 3, .production_id = 25),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 19),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 19),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 3),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 3),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 3, .production_id = 48),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 3, .production_id = 48),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 29),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, .production_id = 29),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 5, .production_id = 48),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 5, .production_id = 48),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 61),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 61),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec_list, 2),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec_list, 2),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 2),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 2),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 38),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 38),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 84),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 84),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 30),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 30),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 82),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 82),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 5),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 5),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, .production_id = 89),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, .production_id = 89),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 2),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 2),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 7, .production_id = 92),
  [873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 7, .production_id = 92),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 8, .production_id = 95),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 8, .production_id = 95),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, .production_id = 32),
  [881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, .production_id = 32),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 3, .production_id = 20),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 3, .production_id = 20),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 81),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 81),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 80),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 80),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 55),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 55),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, .production_id = 56),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, .production_id = 56),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 4, .production_id = 40),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 4, .production_id = 40),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 55),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 55),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 57),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 57),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 4),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 4),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 3),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 3),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 4),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 4),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 11),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 11),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1114),
  [998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 23),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 23),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_statement, 1, .production_id = 54),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 2, .production_id = 15),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 2, .production_id = 15),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_statement, 2),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_statement, 2),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, .production_id = 33),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, .production_id = 33),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(1121),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3, .production_id = 79),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(572),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 4, .production_id = 74),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 2, .production_id = 49),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 2, .production_id = 49),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_statement, 3, .production_id = 31),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 2, .production_id = 27),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1125),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(133),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1121),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_name_list_repeat1, 2),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2),
  [1568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2), SHIFT_REPEAT(1156),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_name_list_repeat1, 2, .production_id = 66),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_name_list_repeat1, 2, .production_id = 66),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1023),
  [1600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1081),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1024),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1059),
  [1611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(941),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 44),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 44),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(181),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [1651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 2, .production_id = 16),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 2, .production_id = 16),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 35),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 35),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(664),
  [1670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(1162),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 71),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 71),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2),
  [1681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(51),
  [1684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(1162),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 36),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 36),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 46),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 46),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 17),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 17),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(165),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 68),
  [1730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 68),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(99),
  [1739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(1162),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_method_spec_list_repeat1, 2, .production_id = 48),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_method_spec_list_repeat1, 2, .production_id = 48),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 1),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 26),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 5, .production_id = 83),
  [1790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 5, .production_id = 83),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 77),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 77),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 24),
  [1804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 24),
  [1806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [1808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 3),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 3),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 3),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 3),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, .production_id = 28),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, .production_id = 28),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 58),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 58),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 58),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 58),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 1),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallthrough_statement, 1),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 59),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 59),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 59),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 59),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 4, .production_id = 53),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 4, .production_id = 53),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2),
  [1874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3),
  [1880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 87),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 87),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 4),
  [1900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 4),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_var_declaration, 3, .production_id = 31),
  [1904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_var_declaration, 3, .production_id = 31),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 87),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 87),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 30),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 30),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_statement, 2),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_statement, 2),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 3, .production_id = 34),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 3, .production_id = 34),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 4),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 5, .production_id = 83),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 5, .production_id = 83),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 3, .production_id = 41),
  [1956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 3, .production_id = 41),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 72),
  [1960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 72),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 34),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 34),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 2),
  [1968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 2),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_statement, 2),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_statement, 2),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 77),
  [1976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 77),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2), SHIFT_REPEAT(657),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, .production_id = 21),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 2, .production_id = 21),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 5, .production_id = 53),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 5, .production_id = 53),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2), SHIFT_REPEAT(625),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [2084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_method_spec_list_repeat1, 2), SHIFT_REPEAT(971),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_method_spec_list_repeat1, 2), SHIFT_REPEAT(971),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_method_spec_list_repeat1, 2),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(458),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(893),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(893),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2),
  [2223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2), SHIFT_REPEAT(950),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 5, .production_id = 91),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_case_repeat1, 2), SHIFT_REPEAT(663),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_case_repeat1, 2),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 36),
  [2255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(220),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 4, .production_id = 78),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 4, .production_id = 7),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 85),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 85),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(107),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2), SHIFT_REPEAT(50),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 3, .production_id = 69),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 3, .production_id = 69),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_method_spec_list_repeat1, 2),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(129),
  [2333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 4),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 67),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 67),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 65),
  [2359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 65),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 64),
  [2363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 64),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(613),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 47),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 47),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 45),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 45),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 16),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_argument, 2),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 3, .production_id = 60),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, .production_id = 35),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot, 1),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 17),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, .production_id = 36),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 75),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 5, .production_id = 88),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 73),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 93),
  [2594] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 94),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 9, .production_id = 96),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 50),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_length_array_type, 4, .production_id = 42),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, .production_id = 86),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_go(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
